/*
 * Copyright (C) 2017, David PHAM-VAN <dev.nfet.net@gmail.com>
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

// Generated file

import 'package:pdf/widgets.dart';

import 'font.dart';

/// Google Fonts
class PdfGoogleFonts extends DownloadbleFont {
  /// Create a Google Font
  const PdfGoogleFonts._(String url, String name) : super(url, name);

  /// ABeeZee regular
  static Future<Font> aBeeZeeRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/abeezee/v14/esDR31xSG-6AGleN6tKukbcHCpE.ttf',
      'ABeeZee-Regular',
    );
    return font.getFont();
  }

  /// ABeeZee italic
  static Future<Font> aBeeZeeItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/abeezee/v14/esDT31xSG-6AGleN2tCklZUCGpG-GQ.ttf',
      'ABeeZee-Italic',
    );
    return font.getFont();
  }

  /// Abel regular
  static Future<Font> abelRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/abel/v12/MwQ5bhbm2POE6VhLPJp6qGI.ttf',
      'Abel-Regular',
    );
    return font.getFont();
  }

  /// Abhaya Libre regular
  static Future<Font> abhayaLibreRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/abhayalibre/v6/e3tmeuGtX-Co5MNzeAOqinEge0PWovdU4w.ttf',
      'AbhayaLibre-Regular',
    );
    return font.getFont();
  }

  /// Abhaya Libre 500
  static Future<Font> abhayaLibreMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/abhayalibre/v6/e3t5euGtX-Co5MNzeAOqinEYj2ryqtxI6oYtBA.ttf',
      'AbhayaLibre-Medium',
    );
    return font.getFont();
  }

  /// Abhaya Libre 600
  static Future<Font> abhayaLibreSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/abhayalibre/v6/e3t5euGtX-Co5MNzeAOqinEYo23yqtxI6oYtBA.ttf',
      'AbhayaLibre-SemiBold',
    );
    return font.getFont();
  }

  /// Abhaya Libre 700
  static Future<Font> abhayaLibreBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/abhayalibre/v6/e3t5euGtX-Co5MNzeAOqinEYx2zyqtxI6oYtBA.ttf',
      'AbhayaLibre-Bold',
    );
    return font.getFont();
  }

  /// Abhaya Libre 800
  static Future<Font> abhayaLibreExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/abhayalibre/v6/e3t5euGtX-Co5MNzeAOqinEY22_yqtxI6oYtBA.ttf',
      'AbhayaLibre-ExtraBold',
    );
    return font.getFont();
  }

  /// Abril Fatface regular
  static Future<Font> abrilFatfaceRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/abrilfatface/v12/zOL64pLDlL1D99S8g8PtiKchm-BsjOLhZBY.ttf',
      'AbrilFatface-Regular',
    );
    return font.getFont();
  }

  /// Aclonica regular
  static Future<Font> aclonicaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/aclonica/v11/K2FyfZJVlfNNSEBXGb7TCI6oBjLz.ttf',
      'Aclonica-Regular',
    );
    return font.getFont();
  }

  /// Acme regular
  static Future<Font> acmeRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/acme/v11/RrQfboBx-C5_bx3Lb23lzLk.ttf',
      'Acme-Regular',
    );
    return font.getFont();
  }

  /// Actor regular
  static Future<Font> actorRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/actor/v10/wEOzEBbCkc5cO3ekXygtUMIO.ttf',
      'Actor-Regular',
    );
    return font.getFont();
  }

  /// Adamina regular
  static Future<Font> adaminaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/adamina/v14/j8_r6-DH1bjoc-dwu-reETl4Bno.ttf',
      'Adamina-Regular',
    );
    return font.getFont();
  }

  /// Advent Pro 100
  static Future<Font> adventProThin() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/adventpro/v11/V8mCoQfxVT4Dvddr_yOwjVmtLZxcBtItFw.ttf',
      'AdventPro-Thin',
    );
    return font.getFont();
  }

  /// Advent Pro 200
  static Future<Font> adventProExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/adventpro/v11/V8mDoQfxVT4Dvddr_yOwjfWMDbZyCts0DqQ.ttf',
      'AdventPro-ExtraLight',
    );
    return font.getFont();
  }

  /// Advent Pro 300
  static Future<Font> adventProLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/adventpro/v11/V8mDoQfxVT4Dvddr_yOwjZGPDbZyCts0DqQ.ttf',
      'AdventPro-Light',
    );
    return font.getFont();
  }

  /// Advent Pro regular
  static Future<Font> adventProRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/adventpro/v11/V8mAoQfxVT4Dvddr_yOwtT2nKb5ZFtI.ttf',
      'AdventPro-Regular',
    );
    return font.getFont();
  }

  /// Advent Pro 500
  static Future<Font> adventProMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/adventpro/v11/V8mDoQfxVT4Dvddr_yOwjcmODbZyCts0DqQ.ttf',
      'AdventPro-Medium',
    );
    return font.getFont();
  }

  /// Advent Pro 600
  static Future<Font> adventProSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/adventpro/v11/V8mDoQfxVT4Dvddr_yOwjeWJDbZyCts0DqQ.ttf',
      'AdventPro-SemiBold',
    );
    return font.getFont();
  }

  /// Advent Pro 700
  static Future<Font> adventProBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/adventpro/v11/V8mDoQfxVT4Dvddr_yOwjYGIDbZyCts0DqQ.ttf',
      'AdventPro-Bold',
    );
    return font.getFont();
  }

  /// Aguafina Script regular
  static Future<Font> aguafinaScriptRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/aguafinascript/v9/If2QXTv_ZzSxGIO30LemWEOmt1bHqs4pgicOrg.ttf',
      'AguafinaScript-Regular',
    );
    return font.getFont();
  }

  /// Akaya Kanadaka regular
  static Future<Font> akayaKanadakaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/akayakanadaka/v4/N0bM2S5CPO5oOQqvazoRRb-8-PfRS5VBBSSF.ttf',
      'AkayaKanadaka-Regular',
    );
    return font.getFont();
  }

  /// Akaya Telivigala regular
  static Future<Font> akayaTelivigalaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/akayatelivigala/v9/lJwc-oo_iG9wXqU3rCTD395tp0uifdLdsIH0YH8.ttf',
      'AkayaTelivigala-Regular',
    );
    return font.getFont();
  }

  /// Akronim regular
  static Future<Font> akronimRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/akronim/v12/fdN-9sqWtWZZlHRp-gBxkFYN-a8.ttf',
      'Akronim-Regular',
    );
    return font.getFont();
  }

  /// Aladin regular
  static Future<Font> aladinRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/aladin/v9/ZgNSjPJFPrvJV5f16Sf4pGT2Ng.ttf',
      'Aladin-Regular',
    );
    return font.getFont();
  }

  /// Alata regular
  static Future<Font> alataRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/alata/v2/PbytFmztEwbIofe6xKcRQEOX.ttf',
      'Alata-Regular',
    );
    return font.getFont();
  }

  /// Alatsi regular
  static Future<Font> alatsiRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/alatsi/v2/TK3iWkUJAxQ2nLNGHjUHte5fKg.ttf',
      'Alatsi-Regular',
    );
    return font.getFont();
  }

  /// Aldrich regular
  static Future<Font> aldrichRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/aldrich/v11/MCoTzAn-1s3IGyJMZaAS3pP5H_E.ttf',
      'Aldrich-Regular',
    );
    return font.getFont();
  }

  /// Alef regular
  static Future<Font> alefRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/alef/v12/FeVfS0NQpLYgrjJbC5FxxbU.ttf',
      'Alef-Regular',
    );
    return font.getFont();
  }

  /// Alef 700
  static Future<Font> alefBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/alef/v12/FeVQS0NQpLYglo50L5la2bxii28.ttf',
      'Alef-Bold',
    );
    return font.getFont();
  }

  /// Alegreya regular
  static Future<Font> alegreyaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/alegreya/v19/4UacrEBBsBhlBjvfkQjt71kZfyBzPgNG9hUI_KCisSGVrw.ttf',
      'Alegreya-Regular',
    );
    return font.getFont();
  }

  /// Alegreya 500
  static Future<Font> alegreyaMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/alegreya/v19/4UacrEBBsBhlBjvfkQjt71kZfyBzPgNGxBUI_KCisSGVrw.ttf',
      'Alegreya-Medium',
    );
    return font.getFont();
  }

  /// Alegreya 600
  static Future<Font> alegreyaSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/alegreya/v19/4UacrEBBsBhlBjvfkQjt71kZfyBzPgNGKBII_KCisSGVrw.ttf',
      'Alegreya-SemiBold',
    );
    return font.getFont();
  }

  /// Alegreya 700
  static Future<Font> alegreyaBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/alegreya/v19/4UacrEBBsBhlBjvfkQjt71kZfyBzPgNGERII_KCisSGVrw.ttf',
      'Alegreya-Bold',
    );
    return font.getFont();
  }

  /// Alegreya 800
  static Future<Font> alegreyaExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/alegreya/v19/4UacrEBBsBhlBjvfkQjt71kZfyBzPgNGdhII_KCisSGVrw.ttf',
      'Alegreya-ExtraBold',
    );
    return font.getFont();
  }

  /// Alegreya 900
  static Future<Font> alegreyaBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/alegreya/v19/4UacrEBBsBhlBjvfkQjt71kZfyBzPgNGXxII_KCisSGVrw.ttf',
      'Alegreya-Black',
    );
    return font.getFont();
  }

  /// Alegreya italic
  static Future<Font> alegreyaItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/alegreya/v19/4UaSrEBBsBhlBjvfkSLk3abBFkvpkARTPlbgv6qmkySFr9V9.ttf',
      'Alegreya-Italic',
    );
    return font.getFont();
  }

  /// Alegreya 500italic
  static Future<Font> alegreyaMediumItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/alegreya/v19/4UaSrEBBsBhlBjvfkSLk3abBFkvpkARTPlbSv6qmkySFr9V9.ttf',
      'Alegreya-MediumItalic',
    );
    return font.getFont();
  }

  /// Alegreya 600italic
  static Future<Font> alegreyaSemiBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/alegreya/v19/4UaSrEBBsBhlBjvfkSLk3abBFkvpkARTPlY-uKqmkySFr9V9.ttf',
      'Alegreya-SemiBoldItalic',
    );
    return font.getFont();
  }

  /// Alegreya 700italic
  static Future<Font> alegreyaBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/alegreya/v19/4UaSrEBBsBhlBjvfkSLk3abBFkvpkARTPlYHuKqmkySFr9V9.ttf',
      'Alegreya-BoldItalic',
    );
    return font.getFont();
  }

  /// Alegreya 800italic
  static Future<Font> alegreyaExtraBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/alegreya/v19/4UaSrEBBsBhlBjvfkSLk3abBFkvpkARTPlZguKqmkySFr9V9.ttf',
      'Alegreya-ExtraBoldItalic',
    );
    return font.getFont();
  }

  /// Alegreya 900italic
  static Future<Font> alegreyaBlackItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/alegreya/v19/4UaSrEBBsBhlBjvfkSLk3abBFkvpkARTPlZJuKqmkySFr9V9.ttf',
      'Alegreya-BlackItalic',
    );
    return font.getFont();
  }

  /// Alegreya SC regular
  static Future<Font> alegreyaSCRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/alegreyasc/v15/taiOGmRtCJ62-O0HhNEa-a6o05E5abe_.ttf',
      'AlegreyaSC-Regular',
    );
    return font.getFont();
  }

  /// Alegreya SC italic
  static Future<Font> alegreyaSCItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/alegreyasc/v15/taiMGmRtCJ62-O0HhNEa-Z6q2ZUbbKe_DGs.ttf',
      'AlegreyaSC-Italic',
    );
    return font.getFont();
  }

  /// Alegreya SC 500
  static Future<Font> alegreyaSCMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/alegreyasc/v15/taiTGmRtCJ62-O0HhNEa-ZZc-rUxQqu2FXKD.ttf',
      'AlegreyaSC-Medium',
    );
    return font.getFont();
  }

  /// Alegreya SC 500italic
  static Future<Font> alegreyaSCMediumItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/alegreyasc/v15/taiRGmRtCJ62-O0HhNEa-Z6q4WEySK-UEGKDBz4.ttf',
      'AlegreyaSC-MediumItalic',
    );
    return font.getFont();
  }

  /// Alegreya SC 700
  static Future<Font> alegreyaSCBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/alegreyasc/v15/taiTGmRtCJ62-O0HhNEa-ZYU_LUxQqu2FXKD.ttf',
      'AlegreyaSC-Bold',
    );
    return font.getFont();
  }

  /// Alegreya SC 700italic
  static Future<Font> alegreyaSCBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/alegreyasc/v15/taiRGmRtCJ62-O0HhNEa-Z6q4Sk0SK-UEGKDBz4.ttf',
      'AlegreyaSC-BoldItalic',
    );
    return font.getFont();
  }

  /// Alegreya SC 800
  static Future<Font> alegreyaSCExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/alegreyasc/v15/taiTGmRtCJ62-O0HhNEa-ZYI_7UxQqu2FXKD.ttf',
      'AlegreyaSC-ExtraBold',
    );
    return font.getFont();
  }

  /// Alegreya SC 800italic
  static Future<Font> alegreyaSCExtraBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/alegreyasc/v15/taiRGmRtCJ62-O0HhNEa-Z6q4TU3SK-UEGKDBz4.ttf',
      'AlegreyaSC-ExtraBoldItalic',
    );
    return font.getFont();
  }

  /// Alegreya SC 900
  static Future<Font> alegreyaSCBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/alegreyasc/v15/taiTGmRtCJ62-O0HhNEa-ZYs_rUxQqu2FXKD.ttf',
      'AlegreyaSC-Black',
    );
    return font.getFont();
  }

  /// Alegreya SC 900italic
  static Future<Font> alegreyaSCBlackItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/alegreyasc/v15/taiRGmRtCJ62-O0HhNEa-Z6q4RE2SK-UEGKDBz4.ttf',
      'AlegreyaSC-BlackItalic',
    );
    return font.getFont();
  }

  /// Alegreya Sans 100
  static Future<Font> alegreyaSansThin() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/alegreyasans/v14/5aUt9_-1phKLFgshYDvh6Vwt5TltuGdShm5bsg.ttf',
      'AlegreyaSans-Thin',
    );
    return font.getFont();
  }

  /// Alegreya Sans 100italic
  static Future<Font> alegreyaSansThinItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/alegreyasans/v14/5aUv9_-1phKLFgshYDvh6Vwt7V9V3G1WpGtLsgu7.ttf',
      'AlegreyaSans-ThinItalic',
    );
    return font.getFont();
  }

  /// Alegreya Sans 300
  static Future<Font> alegreyaSansLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/alegreyasans/v14/5aUu9_-1phKLFgshYDvh6Vwt5fFPmE18imdCqxI.ttf',
      'AlegreyaSans-Light',
    );
    return font.getFont();
  }

  /// Alegreya Sans 300italic
  static Future<Font> alegreyaSansLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/alegreyasans/v14/5aUo9_-1phKLFgshYDvh6Vwt7V9VFE92jkVHuxKiBA.ttf',
      'AlegreyaSans-LightItalic',
    );
    return font.getFont();
  }

  /// Alegreya Sans regular
  static Future<Font> alegreyaSansRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/alegreyasans/v14/5aUz9_-1phKLFgshYDvh6Vwt3V1nvEVXlm4.ttf',
      'AlegreyaSans-Regular',
    );
    return font.getFont();
  }

  /// Alegreya Sans italic
  static Future<Font> alegreyaSansItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/alegreyasans/v14/5aUt9_-1phKLFgshYDvh6Vwt7V9tuGdShm5bsg.ttf',
      'AlegreyaSans-Italic',
    );
    return font.getFont();
  }

  /// Alegreya Sans 500
  static Future<Font> alegreyaSansMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/alegreyasans/v14/5aUu9_-1phKLFgshYDvh6Vwt5alOmE18imdCqxI.ttf',
      'AlegreyaSans-Medium',
    );
    return font.getFont();
  }

  /// Alegreya Sans 500italic
  static Future<Font> alegreyaSansMediumItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/alegreyasans/v14/5aUo9_-1phKLFgshYDvh6Vwt7V9VTE52jkVHuxKiBA.ttf',
      'AlegreyaSans-MediumItalic',
    );
    return font.getFont();
  }

  /// Alegreya Sans 700
  static Future<Font> alegreyaSansBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/alegreyasans/v14/5aUu9_-1phKLFgshYDvh6Vwt5eFImE18imdCqxI.ttf',
      'AlegreyaSans-Bold',
    );
    return font.getFont();
  }

  /// Alegreya Sans 700italic
  static Future<Font> alegreyaSansBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/alegreyasans/v14/5aUo9_-1phKLFgshYDvh6Vwt7V9VBEh2jkVHuxKiBA.ttf',
      'AlegreyaSans-BoldItalic',
    );
    return font.getFont();
  }

  /// Alegreya Sans 800
  static Future<Font> alegreyaSansExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/alegreyasans/v14/5aUu9_-1phKLFgshYDvh6Vwt5f1LmE18imdCqxI.ttf',
      'AlegreyaSans-ExtraBold',
    );
    return font.getFont();
  }

  /// Alegreya Sans 800italic
  static Future<Font> alegreyaSansExtraBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/alegreyasans/v14/5aUo9_-1phKLFgshYDvh6Vwt7V9VGEt2jkVHuxKiBA.ttf',
      'AlegreyaSans-ExtraBoldItalic',
    );
    return font.getFont();
  }

  /// Alegreya Sans 900
  static Future<Font> alegreyaSansBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/alegreyasans/v14/5aUu9_-1phKLFgshYDvh6Vwt5dlKmE18imdCqxI.ttf',
      'AlegreyaSans-Black',
    );
    return font.getFont();
  }

  /// Alegreya Sans 900italic
  static Future<Font> alegreyaSansBlackItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/alegreyasans/v14/5aUo9_-1phKLFgshYDvh6Vwt7V9VPEp2jkVHuxKiBA.ttf',
      'AlegreyaSans-BlackItalic',
    );
    return font.getFont();
  }

  /// Alegreya Sans SC 100
  static Future<Font> alegreyaSansSCThin() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/alegreyasanssc/v13/mtGn4-RGJqfMvt7P8FUr0Q1j-Hf1Dipl8g5FPYtmMg.ttf',
      'AlegreyaSansSC-Thin',
    );
    return font.getFont();
  }

  /// Alegreya Sans SC 100italic
  static Future<Font> alegreyaSansSCThinItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/alegreyasanssc/v13/mtGl4-RGJqfMvt7P8FUr0Q1j-Hf1BkxdlgRBH452Mvds.ttf',
      'AlegreyaSansSC-ThinItalic',
    );
    return font.getFont();
  }

  /// Alegreya Sans SC 300
  static Future<Font> alegreyaSansSCLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/alegreyasanssc/v13/mtGm4-RGJqfMvt7P8FUr0Q1j-Hf1DuJH0iRrMYJ_K-4.ttf',
      'AlegreyaSansSC-Light',
    );
    return font.getFont();
  }

  /// Alegreya Sans SC 300italic
  static Future<Font> alegreyaSansSCLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/alegreyasanssc/v13/mtGk4-RGJqfMvt7P8FUr0Q1j-Hf1BkxdXiZhNaB6O-51OA.ttf',
      'AlegreyaSansSC-LightItalic',
    );
    return font.getFont();
  }

  /// Alegreya Sans SC regular
  static Future<Font> alegreyaSansSCRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/alegreyasanssc/v13/mtGh4-RGJqfMvt7P8FUr0Q1j-Hf1Nk5v9ixALYs.ttf',
      'AlegreyaSansSC-Regular',
    );
    return font.getFont();
  }

  /// Alegreya Sans SC italic
  static Future<Font> alegreyaSansSCItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/alegreyasanssc/v13/mtGn4-RGJqfMvt7P8FUr0Q1j-Hf1Bkxl8g5FPYtmMg.ttf',
      'AlegreyaSansSC-Italic',
    );
    return font.getFont();
  }

  /// Alegreya Sans SC 500
  static Future<Font> alegreyaSansSCMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/alegreyasanssc/v13/mtGm4-RGJqfMvt7P8FUr0Q1j-Hf1DrpG0iRrMYJ_K-4.ttf',
      'AlegreyaSansSC-Medium',
    );
    return font.getFont();
  }

  /// Alegreya Sans SC 500italic
  static Future<Font> alegreyaSansSCMediumItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/alegreyasanssc/v13/mtGk4-RGJqfMvt7P8FUr0Q1j-Hf1BkxdBidhNaB6O-51OA.ttf',
      'AlegreyaSansSC-MediumItalic',
    );
    return font.getFont();
  }

  /// Alegreya Sans SC 700
  static Future<Font> alegreyaSansSCBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/alegreyasanssc/v13/mtGm4-RGJqfMvt7P8FUr0Q1j-Hf1DvJA0iRrMYJ_K-4.ttf',
      'AlegreyaSansSC-Bold',
    );
    return font.getFont();
  }

  /// Alegreya Sans SC 700italic
  static Future<Font> alegreyaSansSCBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/alegreyasanssc/v13/mtGk4-RGJqfMvt7P8FUr0Q1j-Hf1BkxdTiFhNaB6O-51OA.ttf',
      'AlegreyaSansSC-BoldItalic',
    );
    return font.getFont();
  }

  /// Alegreya Sans SC 800
  static Future<Font> alegreyaSansSCExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/alegreyasanssc/v13/mtGm4-RGJqfMvt7P8FUr0Q1j-Hf1Du5D0iRrMYJ_K-4.ttf',
      'AlegreyaSansSC-ExtraBold',
    );
    return font.getFont();
  }

  /// Alegreya Sans SC 800italic
  static Future<Font> alegreyaSansSCExtraBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/alegreyasanssc/v13/mtGk4-RGJqfMvt7P8FUr0Q1j-Hf1BkxdUiJhNaB6O-51OA.ttf',
      'AlegreyaSansSC-ExtraBoldItalic',
    );
    return font.getFont();
  }

  /// Alegreya Sans SC 900
  static Future<Font> alegreyaSansSCBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/alegreyasanssc/v13/mtGm4-RGJqfMvt7P8FUr0Q1j-Hf1DspC0iRrMYJ_K-4.ttf',
      'AlegreyaSansSC-Black',
    );
    return font.getFont();
  }

  /// Alegreya Sans SC 900italic
  static Future<Font> alegreyaSansSCBlackItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/alegreyasanssc/v13/mtGk4-RGJqfMvt7P8FUr0Q1j-Hf1BkxddiNhNaB6O-51OA.ttf',
      'AlegreyaSansSC-BlackItalic',
    );
    return font.getFont();
  }

  /// Aleo 300
  static Future<Font> aleoLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/aleo/v4/c4mg1nF8G8_syKbr9DVDno985KM.ttf',
      'Aleo-Light',
    );
    return font.getFont();
  }

  /// Aleo 300italic
  static Future<Font> aleoLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/aleo/v4/c4mi1nF8G8_swAjxeDdJmq159KOnWA.ttf',
      'Aleo-LightItalic',
    );
    return font.getFont();
  }

  /// Aleo regular
  static Future<Font> aleoRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/aleo/v4/c4mv1nF8G8_s8ArD0D1ogoY.ttf',
      'Aleo-Regular',
    );
    return font.getFont();
  }

  /// Aleo italic
  static Future<Font> aleoItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/aleo/v4/c4mh1nF8G8_swAjJ1B9tkoZl_Q.ttf',
      'Aleo-Italic',
    );
    return font.getFont();
  }

  /// Aleo 700
  static Future<Font> aleoBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/aleo/v4/c4mg1nF8G8_syLbs9DVDno985KM.ttf',
      'Aleo-Bold',
    );
    return font.getFont();
  }

  /// Aleo 700italic
  static Future<Font> aleoBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/aleo/v4/c4mi1nF8G8_swAjxaDBJmq159KOnWA.ttf',
      'Aleo-BoldItalic',
    );
    return font.getFont();
  }

  /// Alex Brush regular
  static Future<Font> alexBrushRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/alexbrush/v12/SZc83FzrJKuqFbwMKk6EtUL57DtOmCc.ttf',
      'AlexBrush-Regular',
    );
    return font.getFont();
  }

  /// Alfa Slab One regular
  static Future<Font> alfaSlabOneRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/alfaslabone/v10/6NUQ8FmMKwSEKjnm5-4v-4Jh6dVretWvYmE.ttf',
      'AlfaSlabOne-Regular',
    );
    return font.getFont();
  }

  /// Alice regular
  static Future<Font> aliceRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/alice/v12/OpNCnoEEmtHa6FcJpA_chzJ0.ttf',
      'Alice-Regular',
    );
    return font.getFont();
  }

  /// Alike regular
  static Future<Font> alikeRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/alike/v13/HI_EiYEYI6BIoEjBSZXAQ4-d.ttf',
      'Alike-Regular',
    );
    return font.getFont();
  }

  /// Alike Angular regular
  static Future<Font> alikeAngularRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/alikeangular/v13/3qTrojWunjGQtEBlIcwMbSoI3kM6bB7FKjE.ttf',
      'AlikeAngular-Regular',
    );
    return font.getFont();
  }

  /// Allan regular
  static Future<Font> allanRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/allan/v13/ea8XadU7WuTxEtb2P9SF8nZE.ttf',
      'Allan-Regular',
    );
    return font.getFont();
  }

  /// Allan 700
  static Future<Font> allanBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/allan/v13/ea8aadU7WuTxEu5KEPCN2WpNgEKU.ttf',
      'Allan-Bold',
    );
    return font.getFont();
  }

  /// Allerta regular
  static Future<Font> allertaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/allerta/v11/TwMO-IAHRlkbx940UnEdSQqO5uY.ttf',
      'Allerta-Regular',
    );
    return font.getFont();
  }

  /// Allerta Stencil regular
  static Future<Font> allertaStencilRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/allertastencil/v11/HTx0L209KT-LmIE9N7OR6eiycOeF-zz313DuvQ.ttf',
      'AllertaStencil-Regular',
    );
    return font.getFont();
  }

  /// Allura regular
  static Future<Font> alluraRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/allura/v9/9oRPNYsQpS4zjuAPjAIXPtrrGA.ttf',
      'Allura-Regular',
    );
    return font.getFont();
  }

  /// Almarai 300
  static Future<Font> almaraiLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/almarai/v5/tssoApxBaigK_hnnS_anhnicoq72sXg.ttf',
      'Almarai-Light',
    );
    return font.getFont();
  }

  /// Almarai regular
  static Future<Font> almaraiRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/almarai/v5/tsstApxBaigK_hnnc1qPonC3vqc.ttf',
      'Almarai-Regular',
    );
    return font.getFont();
  }

  /// Almarai 700
  static Future<Font> almaraiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/almarai/v5/tssoApxBaigK_hnnS-aghnicoq72sXg.ttf',
      'Almarai-Bold',
    );
    return font.getFont();
  }

  /// Almarai 800
  static Future<Font> almaraiExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/almarai/v5/tssoApxBaigK_hnnS_qjhnicoq72sXg.ttf',
      'Almarai-ExtraBold',
    );
    return font.getFont();
  }

  /// Almendra regular
  static Future<Font> almendraRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/almendra/v15/H4ckBXKAlMnTn0CskyY6wr-wg763.ttf',
      'Almendra-Regular',
    );
    return font.getFont();
  }

  /// Almendra italic
  static Future<Font> almendraItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/almendra/v15/H4ciBXKAlMnTn0CskxY4yLuShq63czE.ttf',
      'Almendra-Italic',
    );
    return font.getFont();
  }

  /// Almendra 700
  static Future<Font> almendraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/almendra/v15/H4cjBXKAlMnTn0Cskx6G7Zu4qKK-aihq.ttf',
      'Almendra-Bold',
    );
    return font.getFont();
  }

  /// Almendra 700italic
  static Future<Font> almendraBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/almendra/v15/H4chBXKAlMnTn0CskxY48Ae9oqacbzhqDtg.ttf',
      'Almendra-BoldItalic',
    );
    return font.getFont();
  }

  /// Almendra Display regular
  static Future<Font> almendraDisplayRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/almendradisplay/v13/0FlPVOGWl1Sb4O3tETtADHRRlZhzXS_eTyer338.ttf',
      'AlmendraDisplay-Regular',
    );
    return font.getFont();
  }

  /// Almendra SC regular
  static Future<Font> almendraSCRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/almendrasc/v13/Iure6Yx284eebowr7hbyTZZJprVA4XQ0.ttf',
      'AlmendraSC-Regular',
    );
    return font.getFont();
  }

  /// Amarante regular
  static Future<Font> amaranteRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/amarante/v10/xMQXuF1KTa6EvGx9bq-3C3rAmD-b.ttf',
      'Amarante-Regular',
    );
    return font.getFont();
  }

  /// Amaranth regular
  static Future<Font> amaranthRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/amaranth/v11/KtkuALODe433f0j1zPnCF9GqwnzW.ttf',
      'Amaranth-Regular',
    );
    return font.getFont();
  }

  /// Amaranth italic
  static Future<Font> amaranthItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/amaranth/v11/KtkoALODe433f0j1zMnAHdWIx2zWD4I.ttf',
      'Amaranth-Italic',
    );
    return font.getFont();
  }

  /// Amaranth 700
  static Future<Font> amaranthBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/amaranth/v11/KtkpALODe433f0j1zMF-OPWi6WDfFpuc.ttf',
      'Amaranth-Bold',
    );
    return font.getFont();
  }

  /// Amaranth 700italic
  static Future<Font> amaranthBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/amaranth/v11/KtkrALODe433f0j1zMnAJWmn42T9E4ucRY8.ttf',
      'Amaranth-BoldItalic',
    );
    return font.getFont();
  }

  /// Amatic SC regular
  static Future<Font> amaticSCRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/amaticsc/v16/TUZyzwprpvBS1izr_vO0De6ecZQf1A.ttf',
      'AmaticSC-Regular',
    );
    return font.getFont();
  }

  /// Amatic SC 700
  static Future<Font> amaticSCBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/amaticsc/v16/TUZ3zwprpvBS1izr_vOMscG6eb8D3WTy-A.ttf',
      'AmaticSC-Bold',
    );
    return font.getFont();
  }

  /// Amethysta regular
  static Future<Font> amethystaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/amethysta/v9/rP2Fp2K15kgb_F3ibfWIGDWCBl0O8Q.ttf',
      'Amethysta-Regular',
    );
    return font.getFont();
  }

  /// Amiko regular
  static Future<Font> amikoRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/amiko/v5/WwkQxPq1DFK04tqlc17MMZgJ.ttf',
      'Amiko-Regular',
    );
    return font.getFont();
  }

  /// Amiko 600
  static Future<Font> amikoSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/amiko/v5/WwkdxPq1DFK04uJ9XXrEGoQAUco5.ttf',
      'Amiko-SemiBold',
    );
    return font.getFont();
  }

  /// Amiko 700
  static Future<Font> amikoBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/amiko/v5/WwkdxPq1DFK04uIZXHrEGoQAUco5.ttf',
      'Amiko-Bold',
    );
    return font.getFont();
  }

  /// Amiri regular
  static Future<Font> amiriRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/amiri/v17/J7aRnpd8CGxBHqUpvrIw74NL.ttf',
      'Amiri-Regular',
    );
    return font.getFont();
  }

  /// Amiri italic
  static Future<Font> amiriItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/amiri/v17/J7afnpd8CGxBHpUrtLYS6pNLAjk.ttf',
      'Amiri-Italic',
    );
    return font.getFont();
  }

  /// Amiri 700
  static Future<Font> amiriBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/amiri/v17/J7acnpd8CGxBHp2VkZY4xJ9CGyAa.ttf',
      'Amiri-Bold',
    );
    return font.getFont();
  }

  /// Amiri 700italic
  static Future<Font> amiriBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/amiri/v17/J7aanpd8CGxBHpUrjAo9zptgHjAavCA.ttf',
      'Amiri-BoldItalic',
    );
    return font.getFont();
  }

  /// Amita regular
  static Future<Font> amitaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/amita/v9/HhyaU5si9Om7PQlvAfSKEZZL.ttf',
      'Amita-Regular',
    );
    return font.getFont();
  }

  /// Amita 700
  static Future<Font> amitaBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/amita/v9/HhyXU5si9Om7PTHTLtCCOopCTKkI.ttf',
      'Amita-Bold',
    );
    return font.getFont();
  }

  /// Anaheim regular
  static Future<Font> anaheimRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/anaheim/v8/8vII7w042Wp87g4G0UTUEE5eK_w.ttf',
      'Anaheim-Regular',
    );
    return font.getFont();
  }

  /// Andada regular
  static Future<Font> andadaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/andada/v12/uK_y4riWaego3w9RCh0TMv6EXw.ttf',
      'Andada-Regular',
    );
    return font.getFont();
  }

  /// Andika regular
  static Future<Font> andikaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/andika/v12/mem_Ya6iyW-LwqgAbbwRWrwGVA.ttf',
      'Andika-Regular',
    );
    return font.getFont();
  }

  /// Andika New Basic regular
  static Future<Font> andikaNewBasicRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/andikanewbasic/v5/taiRGn9tCp-44eleq5Q-mszJivxSSK-UEGKDBz4.ttf',
      'AndikaNewBasic-Regular',
    );
    return font.getFont();
  }

  /// Andika New Basic italic
  static Future<Font> andikaNewBasicItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/andikanewbasic/v5/taiXGn9tCp-44eleq5Q-mszJivxSeK2eFECGFz5VCg.ttf',
      'AndikaNewBasic-Italic',
    );
    return font.getFont();
  }

  /// Andika New Basic 700
  static Future<Font> andikaNewBasicBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/andikanewbasic/v5/taiWGn9tCp-44eleq5Q-mszJivxScBO7NGqoGzdME84.ttf',
      'AndikaNewBasic-Bold',
    );
    return font.getFont();
  }

  /// Andika New Basic 700italic
  static Future<Font> andikaNewBasicBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/andikanewbasic/v5/taiUGn9tCp-44eleq5Q-mszJivxSeK2mqG-iHxVJA85Okw.ttf',
      'AndikaNewBasic-BoldItalic',
    );
    return font.getFont();
  }

  /// Angkor regular
  static Future<Font> angkorRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/angkor/v15/H4cmBXyAlsPdnlb-8iw-4Lqggw.ttf',
      'Angkor-Regular',
    );
    return font.getFont();
  }

  /// Annie Use Your Telescope regular
  static Future<Font> annieUseYourTelescopeRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/annieuseyourtelescope/v11/daaLSS4tI2qYYl3Jq9s_Hu74xwktnlKxH6osGVGjlDfB3UUVZA.ttf',
      'AnnieUseYourTelescope-Regular',
    );
    return font.getFont();
  }

  /// Anonymous Pro regular
  static Future<Font> anonymousProRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/anonymouspro/v14/rP2Bp2a15UIB7Un-bOeISG3pLlw89CH98Ko.ttf',
      'AnonymousPro-Regular',
    );
    return font.getFont();
  }

  /// Anonymous Pro italic
  static Future<Font> anonymousProItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/anonymouspro/v14/rP2fp2a15UIB7Un-bOeISG3pHl428AP44Kqr2Q.ttf',
      'AnonymousPro-Italic',
    );
    return font.getFont();
  }

  /// Anonymous Pro 700
  static Future<Font> anonymousProBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/anonymouspro/v14/rP2cp2a15UIB7Un-bOeISG3pFuAT0CnW7KOywKo.ttf',
      'AnonymousPro-Bold',
    );
    return font.getFont();
  }

  /// Anonymous Pro 700italic
  static Future<Font> anonymousProBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/anonymouspro/v14/rP2ap2a15UIB7Un-bOeISG3pHl4OTCzc6IG30KqB9Q.ttf',
      'AnonymousPro-BoldItalic',
    );
    return font.getFont();
  }

  /// Antic regular
  static Future<Font> anticRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/antic/v12/TuGfUVB8XY5DRaZLodgzydtk.ttf',
      'Antic-Regular',
    );
    return font.getFont();
  }

  /// Antic Didone regular
  static Future<Font> anticDidoneRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/anticdidone/v9/RWmPoKKX6u8sp8fIWdnDKqDiqYsGBGBzCw.ttf',
      'AnticDidone-Regular',
    );
    return font.getFont();
  }

  /// Antic Slab regular
  static Future<Font> anticSlabRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/anticslab/v9/bWt97fPFfRzkCa9Jlp6IWcJWXW5p5Qo.ttf',
      'AnticSlab-Regular',
    );
    return font.getFont();
  }

  /// Anton regular
  static Future<Font> antonRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/anton/v15/1Ptgg87LROyAm0K08i4gS7lu.ttf',
      'Anton-Regular',
    );
    return font.getFont();
  }

  /// Antonio 100
  static Future<Font> antonioThin() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/antonio/v1/gNMbW3NwSYq_9WD34ngK5F8vR8T0PVxx8BtIY2DwSXlM.ttf',
      'Antonio-Thin',
    );
    return font.getFont();
  }

  /// Antonio 200
  static Future<Font> antonioExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/antonio/v1/gNMbW3NwSYq_9WD34ngK5F8vR8T0PVzx8RtIY2DwSXlM.ttf',
      'Antonio-ExtraLight',
    );
    return font.getFont();
  }

  /// Antonio 300
  static Future<Font> antonioLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/antonio/v1/gNMbW3NwSYq_9WD34ngK5F8vR8T0PVwv8RtIY2DwSXlM.ttf',
      'Antonio-Light',
    );
    return font.getFont();
  }

  /// Antonio regular
  static Future<Font> antonioRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/antonio/v1/gNMbW3NwSYq_9WD34ngK5F8vR8T0PVxx8RtIY2DwSXlM.ttf',
      'Antonio-Regular',
    );
    return font.getFont();
  }

  /// Antonio 500
  static Future<Font> antonioMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/antonio/v1/gNMbW3NwSYq_9WD34ngK5F8vR8T0PVxD8RtIY2DwSXlM.ttf',
      'Antonio-Medium',
    );
    return font.getFont();
  }

  /// Antonio 600
  static Future<Font> antonioSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/antonio/v1/gNMbW3NwSYq_9WD34ngK5F8vR8T0PVyv9htIY2DwSXlM.ttf',
      'Antonio-SemiBold',
    );
    return font.getFont();
  }

  /// Antonio 700
  static Future<Font> antonioBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/antonio/v1/gNMbW3NwSYq_9WD34ngK5F8vR8T0PVyW9htIY2DwSXlM.ttf',
      'Antonio-Bold',
    );
    return font.getFont();
  }

  /// Arapey regular
  static Future<Font> arapeyRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/arapey/v9/-W__XJn-UDDA2RC6Z9AcZkIzeg.ttf',
      'Arapey-Regular',
    );
    return font.getFont();
  }

  /// Arapey italic
  static Future<Font> arapeyItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/arapey/v9/-W_9XJn-UDDA2RCKZdoYREcjeo0k.ttf',
      'Arapey-Italic',
    );
    return font.getFont();
  }

  /// Arbutus regular
  static Future<Font> arbutusRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/arbutus/v12/NaPYcZ7dG_5J3poob9JtryO8fMU.ttf',
      'Arbutus-Regular',
    );
    return font.getFont();
  }

  /// Arbutus Slab regular
  static Future<Font> arbutusSlabRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/arbutusslab/v9/oY1Z8e7OuLXkJGbXtr5ba7ZVa68dJlaFAQ.ttf',
      'ArbutusSlab-Regular',
    );
    return font.getFont();
  }

  /// Architects Daughter regular
  static Future<Font> architectsDaughterRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/architectsdaughter/v11/KtkxAKiDZI_td1Lkx62xHZHDtgO_Y-bvfY5q4szgE-Q.ttf',
      'ArchitectsDaughter-Regular',
    );
    return font.getFont();
  }

  /// Archivo 100
  static Future<Font> archivoThin() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/archivo/v8/k3k6o8UDI-1M0wlSV9XAw6lQkqWY8Q82sJaRE-NWIDdgffTTNDJp8B1oJ0vyVQ.ttf',
      'Archivo-Thin',
    );
    return font.getFont();
  }

  /// Archivo 200
  static Future<Font> archivoExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/archivo/v8/k3k6o8UDI-1M0wlSV9XAw6lQkqWY8Q82sJaRE-NWIDdgffTTtDNp8B1oJ0vyVQ.ttf',
      'Archivo-ExtraLight',
    );
    return font.getFont();
  }

  /// Archivo 300
  static Future<Font> archivoLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/archivo/v8/k3k6o8UDI-1M0wlSV9XAw6lQkqWY8Q82sJaRE-NWIDdgffTTajNp8B1oJ0vyVQ.ttf',
      'Archivo-Light',
    );
    return font.getFont();
  }

  /// Archivo regular
  static Future<Font> archivoRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/archivo/v8/k3k6o8UDI-1M0wlSV9XAw6lQkqWY8Q82sJaRE-NWIDdgffTTNDNp8B1oJ0vyVQ.ttf',
      'Archivo-Regular',
    );
    return font.getFont();
  }

  /// Archivo 500
  static Future<Font> archivoMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/archivo/v8/k3k6o8UDI-1M0wlSV9XAw6lQkqWY8Q82sJaRE-NWIDdgffTTBjNp8B1oJ0vyVQ.ttf',
      'Archivo-Medium',
    );
    return font.getFont();
  }

  /// Archivo 600
  static Future<Font> archivoSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/archivo/v8/k3k6o8UDI-1M0wlSV9XAw6lQkqWY8Q82sJaRE-NWIDdgffTT6jRp8B1oJ0vyVQ.ttf',
      'Archivo-SemiBold',
    );
    return font.getFont();
  }

  /// Archivo 700
  static Future<Font> archivoBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/archivo/v8/k3k6o8UDI-1M0wlSV9XAw6lQkqWY8Q82sJaRE-NWIDdgffTT0zRp8B1oJ0vyVQ.ttf',
      'Archivo-Bold',
    );
    return font.getFont();
  }

  /// Archivo 800
  static Future<Font> archivoExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/archivo/v8/k3k6o8UDI-1M0wlSV9XAw6lQkqWY8Q82sJaRE-NWIDdgffTTtDRp8B1oJ0vyVQ.ttf',
      'Archivo-ExtraBold',
    );
    return font.getFont();
  }

  /// Archivo 900
  static Future<Font> archivoBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/archivo/v8/k3k6o8UDI-1M0wlSV9XAw6lQkqWY8Q82sJaRE-NWIDdgffTTnTRp8B1oJ0vyVQ.ttf',
      'Archivo-Black',
    );
    return font.getFont();
  }

  /// Archivo 100italic
  static Future<Font> archivoThinItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/archivo/v8/k3k8o8UDI-1M0wlSfdzyIEkpwTM29hr-8mTYIRyOSVz60_PG_HCBshdsBU7iVdxQ.ttf',
      'Archivo-ThinItalic',
    );
    return font.getFont();
  }

  /// Archivo 200italic
  static Future<Font> archivoExtraLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/archivo/v8/k3k8o8UDI-1M0wlSfdzyIEkpwTM29hr-8mTYIRyOSVz60_PG_HABsxdsBU7iVdxQ.ttf',
      'Archivo-ExtraLightItalic',
    );
    return font.getFont();
  }

  /// Archivo 300italic
  static Future<Font> archivoLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/archivo/v8/k3k8o8UDI-1M0wlSfdzyIEkpwTM29hr-8mTYIRyOSVz60_PG_HDfsxdsBU7iVdxQ.ttf',
      'Archivo-LightItalic',
    );
    return font.getFont();
  }

  /// Archivo italic
  static Future<Font> archivoItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/archivo/v8/k3k8o8UDI-1M0wlSfdzyIEkpwTM29hr-8mTYIRyOSVz60_PG_HCBsxdsBU7iVdxQ.ttf',
      'Archivo-Italic',
    );
    return font.getFont();
  }

  /// Archivo 500italic
  static Future<Font> archivoMediumItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/archivo/v8/k3k8o8UDI-1M0wlSfdzyIEkpwTM29hr-8mTYIRyOSVz60_PG_HCzsxdsBU7iVdxQ.ttf',
      'Archivo-MediumItalic',
    );
    return font.getFont();
  }

  /// Archivo 600italic
  static Future<Font> archivoSemiBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/archivo/v8/k3k8o8UDI-1M0wlSfdzyIEkpwTM29hr-8mTYIRyOSVz60_PG_HBftBdsBU7iVdxQ.ttf',
      'Archivo-SemiBoldItalic',
    );
    return font.getFont();
  }

  /// Archivo 700italic
  static Future<Font> archivoBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/archivo/v8/k3k8o8UDI-1M0wlSfdzyIEkpwTM29hr-8mTYIRyOSVz60_PG_HBmtBdsBU7iVdxQ.ttf',
      'Archivo-BoldItalic',
    );
    return font.getFont();
  }

  /// Archivo 800italic
  static Future<Font> archivoExtraBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/archivo/v8/k3k8o8UDI-1M0wlSfdzyIEkpwTM29hr-8mTYIRyOSVz60_PG_HABtBdsBU7iVdxQ.ttf',
      'Archivo-ExtraBoldItalic',
    );
    return font.getFont();
  }

  /// Archivo 900italic
  static Future<Font> archivoBlackItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/archivo/v8/k3k8o8UDI-1M0wlSfdzyIEkpwTM29hr-8mTYIRyOSVz60_PG_HAotBdsBU7iVdxQ.ttf',
      'Archivo-BlackItalic',
    );
    return font.getFont();
  }

  /// Archivo Black regular
  static Future<Font> archivoBlackRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/archivoblack/v10/HTxqL289NzCGg4MzN6KJ7eW6OYuP_x7yx3A.ttf',
      'ArchivoBlack-Regular',
    );
    return font.getFont();
  }

  /// Archivo Narrow regular
  static Future<Font> archivoNarrowRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/archivonarrow/v12/tss0ApVBdCYD5Q7hcxTE1ArZ0Yb3g31S2s8p.ttf',
      'ArchivoNarrow-Regular',
    );
    return font.getFont();
  }

  /// Archivo Narrow italic
  static Future<Font> archivoNarrowItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/archivonarrow/v12/tss2ApVBdCYD5Q7hcxTE1ArZ0bb1iXlw398pJxk.ttf',
      'ArchivoNarrow-Italic',
    );
    return font.getFont();
  }

  /// Archivo Narrow 500
  static Future<Font> archivoNarrowMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/archivonarrow/v12/tss3ApVBdCYD5Q7hcxTE1ArZ0b4Dqlla8dMgPgBu.ttf',
      'ArchivoNarrow-Medium',
    );
    return font.getFont();
  }

  /// Archivo Narrow 500italic
  static Future<Font> archivoNarrowMediumItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/archivonarrow/v12/tssxApVBdCYD5Q7hcxTE1ArZ0bb1sY1Z-9cCOxBu_BM.ttf',
      'ArchivoNarrow-MediumItalic',
    );
    return font.getFont();
  }

  /// Archivo Narrow 600
  static Future<Font> archivoNarrowSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/archivonarrow/v12/tss3ApVBdCYD5Q7hcxTE1ArZ0b4vrVla8dMgPgBu.ttf',
      'ArchivoNarrow-SemiBold',
    );
    return font.getFont();
  }

  /// Archivo Narrow 600italic
  static Future<Font> archivoNarrowSemiBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/archivonarrow/v12/tssxApVBdCYD5Q7hcxTE1ArZ0bb1saFe-9cCOxBu_BM.ttf',
      'ArchivoNarrow-SemiBoldItalic',
    );
    return font.getFont();
  }

  /// Archivo Narrow 700
  static Future<Font> archivoNarrowBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/archivonarrow/v12/tss3ApVBdCYD5Q7hcxTE1ArZ0b5LrFla8dMgPgBu.ttf',
      'ArchivoNarrow-Bold',
    );
    return font.getFont();
  }

  /// Archivo Narrow 700italic
  static Future<Font> archivoNarrowBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/archivonarrow/v12/tssxApVBdCYD5Q7hcxTE1ArZ0bb1scVf-9cCOxBu_BM.ttf',
      'ArchivoNarrow-BoldItalic',
    );
    return font.getFont();
  }

  /// Aref Ruqaa regular
  static Future<Font> arefRuqaaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/arefruqaa/v15/WwkbxPW1E165rajQKDulEIAiVNo5xNY.ttf',
      'ArefRuqaa-Regular',
    );
    return font.getFont();
  }

  /// Aref Ruqaa 700
  static Future<Font> arefRuqaaBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/arefruqaa/v15/WwkYxPW1E165rajQKDulKDwNcNIS2N_7Bdk.ttf',
      'ArefRuqaa-Bold',
    );
    return font.getFont();
  }

  /// Arima Madurai 100
  static Future<Font> arimaMaduraiThin() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/arimamadurai/v7/t5t4IRoeKYORG0WNMgnC3seB1V3PqrGCch4Drg.ttf',
      'ArimaMadurai-Thin',
    );
    return font.getFont();
  }

  /// Arima Madurai 200
  static Future<Font> arimaMaduraiExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/arimamadurai/v7/t5t7IRoeKYORG0WNMgnC3seB1fHuipusfhcat2c.ttf',
      'ArimaMadurai-ExtraLight',
    );
    return font.getFont();
  }

  /// Arima Madurai 300
  static Future<Font> arimaMaduraiLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/arimamadurai/v7/t5t7IRoeKYORG0WNMgnC3seB1ZXtipusfhcat2c.ttf',
      'ArimaMadurai-Light',
    );
    return font.getFont();
  }

  /// Arima Madurai regular
  static Future<Font> arimaMaduraiRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/arimamadurai/v7/t5tmIRoeKYORG0WNMgnC3seB7TnFrpOHYh4.ttf',
      'ArimaMadurai-Regular',
    );
    return font.getFont();
  }

  /// Arima Madurai 500
  static Future<Font> arimaMaduraiMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/arimamadurai/v7/t5t7IRoeKYORG0WNMgnC3seB1c3sipusfhcat2c.ttf',
      'ArimaMadurai-Medium',
    );
    return font.getFont();
  }

  /// Arima Madurai 700
  static Future<Font> arimaMaduraiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/arimamadurai/v7/t5t7IRoeKYORG0WNMgnC3seB1YXqipusfhcat2c.ttf',
      'ArimaMadurai-Bold',
    );
    return font.getFont();
  }

  /// Arima Madurai 800
  static Future<Font> arimaMaduraiExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/arimamadurai/v7/t5t7IRoeKYORG0WNMgnC3seB1Znpipusfhcat2c.ttf',
      'ArimaMadurai-ExtraBold',
    );
    return font.getFont();
  }

  /// Arima Madurai 900
  static Future<Font> arimaMaduraiBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/arimamadurai/v7/t5t7IRoeKYORG0WNMgnC3seB1b3oipusfhcat2c.ttf',
      'ArimaMadurai-Black',
    );
    return font.getFont();
  }

  /// Arimo regular
  static Future<Font> arimoRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/arimo/v17/P5sfzZCDf9_T_3cV7NCUECyoxNk37cxsBxDAVQI4aA.ttf',
      'Arimo-Regular',
    );
    return font.getFont();
  }

  /// Arimo 500
  static Future<Font> arimoMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/arimo/v17/P5sfzZCDf9_T_3cV7NCUECyoxNk338xsBxDAVQI4aA.ttf',
      'Arimo-Medium',
    );
    return font.getFont();
  }

  /// Arimo 600
  static Future<Font> arimoSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/arimo/v17/P5sfzZCDf9_T_3cV7NCUECyoxNk3M8tsBxDAVQI4aA.ttf',
      'Arimo-SemiBold',
    );
    return font.getFont();
  }

  /// Arimo 700
  static Future<Font> arimoBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/arimo/v17/P5sfzZCDf9_T_3cV7NCUECyoxNk3CstsBxDAVQI4aA.ttf',
      'Arimo-Bold',
    );
    return font.getFont();
  }

  /// Arimo italic
  static Future<Font> arimoItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/arimo/v17/P5sdzZCDf9_T_10c3i9MeUcyat4iJY-ERBrEdwcoaKww.ttf',
      'Arimo-Italic',
    );
    return font.getFont();
  }

  /// Arimo 500italic
  static Future<Font> arimoMediumItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/arimo/v17/P5sdzZCDf9_T_10c3i9MeUcyat4iJY-2RBrEdwcoaKww.ttf',
      'Arimo-MediumItalic',
    );
    return font.getFont();
  }

  /// Arimo 600italic
  static Future<Font> arimoSemiBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/arimo/v17/P5sdzZCDf9_T_10c3i9MeUcyat4iJY9aQxrEdwcoaKww.ttf',
      'Arimo-SemiBoldItalic',
    );
    return font.getFont();
  }

  /// Arimo 700italic
  static Future<Font> arimoBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/arimo/v17/P5sdzZCDf9_T_10c3i9MeUcyat4iJY9jQxrEdwcoaKww.ttf',
      'Arimo-BoldItalic',
    );
    return font.getFont();
  }

  /// Arizonia regular
  static Future<Font> arizoniaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/arizonia/v11/neIIzCemt4A5qa7mv6WGHK06UY30.ttf',
      'Arizonia-Regular',
    );
    return font.getFont();
  }

  /// Armata regular
  static Future<Font> armataRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/armata/v12/gokvH63_HV5jQ-E9lD53Q2u_mQ.ttf',
      'Armata-Regular',
    );
    return font.getFont();
  }

  /// Arsenal regular
  static Future<Font> arsenalRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/arsenal/v5/wXKrE3kQtZQ4pF3D11_WAewrhXY.ttf',
      'Arsenal-Regular',
    );
    return font.getFont();
  }

  /// Arsenal italic
  static Future<Font> arsenalItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/arsenal/v5/wXKpE3kQtZQ4pF3D513cBc4ulXYrtA.ttf',
      'Arsenal-Italic',
    );
    return font.getFont();
  }

  /// Arsenal 700
  static Future<Font> arsenalBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/arsenal/v5/wXKuE3kQtZQ4pF3D7-P5JeQAmX8yrdk.ttf',
      'Arsenal-Bold',
    );
    return font.getFont();
  }

  /// Arsenal 700italic
  static Future<Font> arsenalBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/arsenal/v5/wXKsE3kQtZQ4pF3D513kueEKnV03vdnKjw.ttf',
      'Arsenal-BoldItalic',
    );
    return font.getFont();
  }

  /// Artifika regular
  static Future<Font> artifikaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/artifika/v13/VEMyRoxzronptCuxu6Wt5jDtreOL.ttf',
      'Artifika-Regular',
    );
    return font.getFont();
  }

  /// Arvo regular
  static Future<Font> arvoRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/arvo/v14/tDbD2oWUg0MKmSAa7Lzr7vs.ttf',
      'Arvo-Regular',
    );
    return font.getFont();
  }

  /// Arvo italic
  static Future<Font> arvoItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/arvo/v14/tDbN2oWUg0MKqSIQ6J7u_vvijQ.ttf',
      'Arvo-Italic',
    );
    return font.getFont();
  }

  /// Arvo 700
  static Future<Font> arvoBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/arvo/v14/tDbM2oWUg0MKoZw1yLTA8vL7lAE.ttf',
      'Arvo-Bold',
    );
    return font.getFont();
  }

  /// Arvo 700italic
  static Future<Font> arvoBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/arvo/v14/tDbO2oWUg0MKqSIoVLHK9tD-hAHkGg.ttf',
      'Arvo-BoldItalic',
    );
    return font.getFont();
  }

  /// Arya regular
  static Future<Font> aryaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/arya/v9/ga6CawNG-HJd9Ub1-beqdFE.ttf',
      'Arya-Regular',
    );
    return font.getFont();
  }

  /// Arya 700
  static Future<Font> aryaBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/arya/v9/ga6NawNG-HJdzfra3b-BaFg3dRE.ttf',
      'Arya-Bold',
    );
    return font.getFont();
  }

  /// Asap regular
  static Future<Font> asapRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/asap/v15/KFO9CniXp96a4Tc2EZzSuDAoKsE61qhOUX-8AEEe.ttf',
      'Asap-Regular',
    );
    return font.getFont();
  }

  /// Asap 500
  static Future<Font> asapMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/asap/v15/KFO9CniXp96a4Tc2EZzSuDAoKsEI1qhOUX-8AEEe.ttf',
      'Asap-Medium',
    );
    return font.getFont();
  }

  /// Asap 600
  static Future<Font> asapSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/asap/v15/KFO9CniXp96a4Tc2EZzSuDAoKsHk0ahOUX-8AEEe.ttf',
      'Asap-SemiBold',
    );
    return font.getFont();
  }

  /// Asap 700
  static Future<Font> asapBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/asap/v15/KFO9CniXp96a4Tc2EZzSuDAoKsHd0ahOUX-8AEEe.ttf',
      'Asap-Bold',
    );
    return font.getFont();
  }

  /// Asap italic
  static Future<Font> asapItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/asap/v15/KFO7CniXp96ayz4E7kS706qGLdTylUANW3ueBVEeezU.ttf',
      'Asap-Italic',
    );
    return font.getFont();
  }

  /// Asap 500italic
  static Future<Font> asapMediumItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/asap/v15/KFO7CniXp96ayz4E7kS706qGLdTylXINW3ueBVEeezU.ttf',
      'Asap-MediumItalic',
    );
    return font.getFont();
  }

  /// Asap 600italic
  static Future<Font> asapSemiBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/asap/v15/KFO7CniXp96ayz4E7kS706qGLdTylZ4KW3ueBVEeezU.ttf',
      'Asap-SemiBoldItalic',
    );
    return font.getFont();
  }

  /// Asap 700italic
  static Future<Font> asapBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/asap/v15/KFO7CniXp96ayz4E7kS706qGLdTylacKW3ueBVEeezU.ttf',
      'Asap-BoldItalic',
    );
    return font.getFont();
  }

  /// Asap Condensed regular
  static Future<Font> asapCondensedRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/asapcondensed/v8/pxidypY1o9NHyXh3WvSbGSggdNeLYk1Mq3ap.ttf',
      'AsapCondensed-Regular',
    );
    return font.getFont();
  }

  /// Asap Condensed italic
  static Future<Font> asapCondensedItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/asapcondensed/v8/pxifypY1o9NHyXh3WvSbGSggdOeJaElurmapvvM.ttf',
      'AsapCondensed-Italic',
    );
    return font.getFont();
  }

  /// Asap Condensed 500
  static Future<Font> asapCondensedMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/asapcondensed/v8/pxieypY1o9NHyXh3WvSbGSggdO9_S2lEgGqgp-pO.ttf',
      'AsapCondensed-Medium',
    );
    return font.getFont();
  }

  /// Asap Condensed 500italic
  static Future<Font> asapCondensedMediumItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/asapcondensed/v8/pxiYypY1o9NHyXh3WvSbGSggdOeJUL1Him6CovpOkXA.ttf',
      'AsapCondensed-MediumItalic',
    );
    return font.getFont();
  }

  /// Asap Condensed 600
  static Future<Font> asapCondensedSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/asapcondensed/v8/pxieypY1o9NHyXh3WvSbGSggdO9TTGlEgGqgp-pO.ttf',
      'AsapCondensed-SemiBold',
    );
    return font.getFont();
  }

  /// Asap Condensed 600italic
  static Future<Font> asapCondensedSemiBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/asapcondensed/v8/pxiYypY1o9NHyXh3WvSbGSggdOeJUJFAim6CovpOkXA.ttf',
      'AsapCondensed-SemiBoldItalic',
    );
    return font.getFont();
  }

  /// Asap Condensed 700
  static Future<Font> asapCondensedBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/asapcondensed/v8/pxieypY1o9NHyXh3WvSbGSggdO83TWlEgGqgp-pO.ttf',
      'AsapCondensed-Bold',
    );
    return font.getFont();
  }

  /// Asap Condensed 700italic
  static Future<Font> asapCondensedBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/asapcondensed/v8/pxiYypY1o9NHyXh3WvSbGSggdOeJUPVBim6CovpOkXA.ttf',
      'AsapCondensed-BoldItalic',
    );
    return font.getFont();
  }

  /// Asar regular
  static Future<Font> asarRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/asar/v10/sZlLdRyI6TBIXkYQDLlTW6E.ttf',
      'Asar-Regular',
    );
    return font.getFont();
  }

  /// Asset regular
  static Future<Font> assetRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/asset/v12/SLXGc1na-mM4cWImRJqExst1.ttf',
      'Asset-Regular',
    );
    return font.getFont();
  }

  /// Assistant 200
  static Future<Font> assistantExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/assistant/v7/2sDPZGJYnIjSi6H75xkZZE1I0yCmYzzQtmZnEGGf3qGuvM4.ttf',
      'Assistant-ExtraLight',
    );
    return font.getFont();
  }

  /// Assistant 300
  static Future<Font> assistantLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/assistant/v7/2sDPZGJYnIjSi6H75xkZZE1I0yCmYzzQtrhnEGGf3qGuvM4.ttf',
      'Assistant-Light',
    );
    return font.getFont();
  }

  /// Assistant regular
  static Future<Font> assistantRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/assistant/v7/2sDPZGJYnIjSi6H75xkZZE1I0yCmYzzQtuZnEGGf3qGuvM4.ttf',
      'Assistant-Regular',
    );
    return font.getFont();
  }

  /// Assistant 500
  static Future<Font> assistantMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/assistant/v7/2sDPZGJYnIjSi6H75xkZZE1I0yCmYzzQttRnEGGf3qGuvM4.ttf',
      'Assistant-Medium',
    );
    return font.getFont();
  }

  /// Assistant 600
  static Future<Font> assistantSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/assistant/v7/2sDPZGJYnIjSi6H75xkZZE1I0yCmYzzQtjhgEGGf3qGuvM4.ttf',
      'Assistant-SemiBold',
    );
    return font.getFont();
  }

  /// Assistant 700
  static Future<Font> assistantBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/assistant/v7/2sDPZGJYnIjSi6H75xkZZE1I0yCmYzzQtgFgEGGf3qGuvM4.ttf',
      'Assistant-Bold',
    );
    return font.getFont();
  }

  /// Assistant 800
  static Future<Font> assistantExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/assistant/v7/2sDPZGJYnIjSi6H75xkZZE1I0yCmYzzQtmZgEGGf3qGuvM4.ttf',
      'Assistant-ExtraBold',
    );
    return font.getFont();
  }

  /// Astloch regular
  static Future<Font> astlochRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/astloch/v14/TuGRUVJ8QI5GSeUjq9wRzMtkH1Q.ttf',
      'Astloch-Regular',
    );
    return font.getFont();
  }

  /// Astloch 700
  static Future<Font> astlochBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/astloch/v14/TuGUUVJ8QI5GSeUjk2A-6MNPA10xLMQ.ttf',
      'Astloch-Bold',
    );
    return font.getFont();
  }

  /// Asul regular
  static Future<Font> asulRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/asul/v12/VuJ-dNjKxYr46fMFXK78JIg.ttf',
      'Asul-Regular',
    );
    return font.getFont();
  }

  /// Asul 700
  static Future<Font> asulBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/asul/v12/VuJxdNjKxYr40U8qeKbXOIFneRo.ttf',
      'Asul-Bold',
    );
    return font.getFont();
  }

  /// Athiti 200
  static Future<Font> athitiExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/athiti/v5/pe0sMISdLIZIv1wAxDNyAv2-C99ycg.ttf',
      'Athiti-ExtraLight',
    );
    return font.getFont();
  }

  /// Athiti 300
  static Future<Font> athitiLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/athiti/v5/pe0sMISdLIZIv1wAoDByAv2-C99ycg.ttf',
      'Athiti-Light',
    );
    return font.getFont();
  }

  /// Athiti regular
  static Future<Font> athitiRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/athiti/v5/pe0vMISdLIZIv1w4DBhWCtaiAg.ttf',
      'Athiti-Regular',
    );
    return font.getFont();
  }

  /// Athiti 500
  static Future<Font> athitiMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/athiti/v5/pe0sMISdLIZIv1wA-DFyAv2-C99ycg.ttf',
      'Athiti-Medium',
    );
    return font.getFont();
  }

  /// Athiti 600
  static Future<Font> athitiSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/athiti/v5/pe0sMISdLIZIv1wA1DZyAv2-C99ycg.ttf',
      'Athiti-SemiBold',
    );
    return font.getFont();
  }

  /// Athiti 700
  static Future<Font> athitiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/athiti/v5/pe0sMISdLIZIv1wAsDdyAv2-C99ycg.ttf',
      'Athiti-Bold',
    );
    return font.getFont();
  }

  /// Atma 300
  static Future<Font> atmaLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/atma/v8/uK_z4rqWc-Eoo8JzKjc9PvedRkM.ttf',
      'Atma-Light',
    );
    return font.getFont();
  }

  /// Atma regular
  static Future<Font> atmaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/atma/v8/uK_84rqWc-Eom25bDj8WIv4.ttf',
      'Atma-Regular',
    );
    return font.getFont();
  }

  /// Atma 500
  static Future<Font> atmaMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/atma/v8/uK_z4rqWc-Eoo5pyKjc9PvedRkM.ttf',
      'Atma-Medium',
    );
    return font.getFont();
  }

  /// Atma 600
  static Future<Font> atmaSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/atma/v8/uK_z4rqWc-Eoo7Z1Kjc9PvedRkM.ttf',
      'Atma-SemiBold',
    );
    return font.getFont();
  }

  /// Atma 700
  static Future<Font> atmaBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/atma/v8/uK_z4rqWc-Eoo9J0Kjc9PvedRkM.ttf',
      'Atma-Bold',
    );
    return font.getFont();
  }

  /// Atomic Age regular
  static Future<Font> atomicAgeRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/atomicage/v15/f0Xz0eug6sdmRFkYZZGL58Ht9a8GYeA.ttf',
      'AtomicAge-Regular',
    );
    return font.getFont();
  }

  /// Aubrey regular
  static Future<Font> aubreyRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/aubrey/v15/q5uGsou7NPBw-p7vugNsCxVEgA.ttf',
      'Aubrey-Regular',
    );
    return font.getFont();
  }

  /// Audiowide regular
  static Future<Font> audiowideRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/audiowide/v9/l7gdbjpo0cum0ckerWCtkQXPExpQBw.ttf',
      'Audiowide-Regular',
    );
    return font.getFont();
  }

  /// Autour One regular
  static Future<Font> autourOneRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/autourone/v12/UqyVK80cP25l3fJgbdfbk5lWVscxdKE.ttf',
      'AutourOne-Regular',
    );
    return font.getFont();
  }

  /// Average regular
  static Future<Font> averageRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/average/v9/fC1hPYBHe23MxA7rIeJwVWytTyk.ttf',
      'Average-Regular',
    );
    return font.getFont();
  }

  /// Average Sans regular
  static Future<Font> averageSansRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/averagesans/v9/1Ptpg8fLXP2dlAXR-HlJJNJPBdqazVoK4A.ttf',
      'AverageSans-Regular',
    );
    return font.getFont();
  }

  /// Averia Gruesa Libre regular
  static Future<Font> averiaGruesaLibreRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/averiagruesalibre/v11/NGSov4nEGEktOaDRKsY-1dhh8eEtIx3ZUmmJw0SLRA8.ttf',
      'AveriaGruesaLibre-Regular',
    );
    return font.getFont();
  }

  /// Averia Libre 300
  static Future<Font> averiaLibreLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/averialibre/v9/2V0FKIcMGZEnV6xygz7eNjEarovtb07t-pQgTw.ttf',
      'AveriaLibre-Light',
    );
    return font.getFont();
  }

  /// Averia Libre 300italic
  static Future<Font> averiaLibreLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/averialibre/v9/2V0HKIcMGZEnV6xygz7eNjESAJFhbUTp2JEwT4Sk.ttf',
      'AveriaLibre-LightItalic',
    );
    return font.getFont();
  }

  /// Averia Libre regular
  static Future<Font> averiaLibreRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/averialibre/v9/2V0aKIcMGZEnV6xygz7eNjEiAqPJZ2Xx8w.ttf',
      'AveriaLibre-Regular',
    );
    return font.getFont();
  }

  /// Averia Libre italic
  static Future<Font> averiaLibreItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/averialibre/v9/2V0EKIcMGZEnV6xygz7eNjESAKnNRWDh8405.ttf',
      'AveriaLibre-Italic',
    );
    return font.getFont();
  }

  /// Averia Libre 700
  static Future<Font> averiaLibreBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/averialibre/v9/2V0FKIcMGZEnV6xygz7eNjEavoztb07t-pQgTw.ttf',
      'AveriaLibre-Bold',
    );
    return font.getFont();
  }

  /// Averia Libre 700italic
  static Future<Font> averiaLibreBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/averialibre/v9/2V0HKIcMGZEnV6xygz7eNjESAJFxakTp2JEwT4Sk.ttf',
      'AveriaLibre-BoldItalic',
    );
    return font.getFont();
  }

  /// Averia Sans Libre 300
  static Future<Font> averiaSansLibreLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/averiasanslibre/v11/ga6SaxZG_G5OvCf_rt7FH3B6BHLMEd3lMKcQJZP1LmD9.ttf',
      'AveriaSansLibre-Light',
    );
    return font.getFont();
  }

  /// Averia Sans Libre 300italic
  static Future<Font> averiaSansLibreLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/averiasanslibre/v11/ga6caxZG_G5OvCf_rt7FH3B6BHLMEdVLKisSL5fXK3D9qtg.ttf',
      'AveriaSansLibre-LightItalic',
    );
    return font.getFont();
  }

  /// Averia Sans Libre regular
  static Future<Font> averiaSansLibreRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/averiasanslibre/v11/ga6XaxZG_G5OvCf_rt7FH3B6BHLMEeVJGIMYDo_8.ttf',
      'AveriaSansLibre-Regular',
    );
    return font.getFont();
  }

  /// Averia Sans Libre italic
  static Future<Font> averiaSansLibreItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/averiasanslibre/v11/ga6RaxZG_G5OvCf_rt7FH3B6BHLMEdVLEoc6C5_8N3k.ttf',
      'AveriaSansLibre-Italic',
    );
    return font.getFont();
  }

  /// Averia Sans Libre 700
  static Future<Font> averiaSansLibreBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/averiasanslibre/v11/ga6SaxZG_G5OvCf_rt7FH3B6BHLMEd31N6cQJZP1LmD9.ttf',
      'AveriaSansLibre-Bold',
    );
    return font.getFont();
  }

  /// Averia Sans Libre 700italic
  static Future<Font> averiaSansLibreBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/averiasanslibre/v11/ga6caxZG_G5OvCf_rt7FH3B6BHLMEdVLKjsVL5fXK3D9qtg.ttf',
      'AveriaSansLibre-BoldItalic',
    );
    return font.getFont();
  }

  /// Averia Serif Libre 300
  static Future<Font> averiaSerifLibreLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/averiaseriflibre/v10/neIVzD2ms4wxr6GvjeD0X88SHPyX2xYGCSmqwacqdrKvbQ.ttf',
      'AveriaSerifLibre-Light',
    );
    return font.getFont();
  }

  /// Averia Serif Libre 300italic
  static Future<Font> averiaSerifLibreLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/averiaseriflibre/v10/neIbzD2ms4wxr6GvjeD0X88SHPyX2xYOpzMmw60uVLe_bXHq.ttf',
      'AveriaSerifLibre-LightItalic',
    );
    return font.getFont();
  }

  /// Averia Serif Libre regular
  static Future<Font> averiaSerifLibreRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/averiaseriflibre/v10/neIWzD2ms4wxr6GvjeD0X88SHPyX2xY-pQGOyYw2fw.ttf',
      'AveriaSerifLibre-Regular',
    );
    return font.getFont();
  }

  /// Averia Serif Libre italic
  static Future<Font> averiaSerifLibreItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/averiaseriflibre/v10/neIUzD2ms4wxr6GvjeD0X88SHPyX2xYOpwuK64kmf6u2.ttf',
      'AveriaSerifLibre-Italic',
    );
    return font.getFont();
  }

  /// Averia Serif Libre 700
  static Future<Font> averiaSerifLibreBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/averiaseriflibre/v10/neIVzD2ms4wxr6GvjeD0X88SHPyX2xYGGS6qwacqdrKvbQ.ttf',
      'AveriaSerifLibre-Bold',
    );
    return font.getFont();
  }

  /// Averia Serif Libre 700italic
  static Future<Font> averiaSerifLibreBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/averiaseriflibre/v10/neIbzD2ms4wxr6GvjeD0X88SHPyX2xYOpzM2xK0uVLe_bXHq.ttf',
      'AveriaSerifLibre-BoldItalic',
    );
    return font.getFont();
  }

  /// B612 regular
  static Future<Font> b612Regular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/b612/v5/3JnySDDxiSz32jm4GDigUXw.ttf',
      'B612-Regular',
    );
    return font.getFont();
  }

  /// B612 italic
  static Future<Font> b612Italic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/b612/v5/3Jn8SDDxiSz36juyHBqlQXwdVw.ttf',
      'B612-Italic',
    );
    return font.getFont();
  }

  /// B612 700
  static Future<Font> b612Bold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/b612/v5/3Jn9SDDxiSz34oWXPDCLTXUETuE.ttf',
      'B612-Bold',
    );
    return font.getFont();
  }

  /// B612 700italic
  static Future<Font> b612BoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/b612/v5/3Jn_SDDxiSz36juKoDWBSVcBXuFb0Q.ttf',
      'B612-BoldItalic',
    );
    return font.getFont();
  }

  /// B612 Mono regular
  static Future<Font> b612MonoRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/b612mono/v5/kmK_Zq85QVWbN1eW6lJl1wTcquRTtg.ttf',
      'B612Mono-Regular',
    );
    return font.getFont();
  }

  /// B612 Mono italic
  static Future<Font> b612MonoItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/b612mono/v5/kmK5Zq85QVWbN1eW6lJV1Q7YiOFDtqtf.ttf',
      'B612Mono-Italic',
    );
    return font.getFont();
  }

  /// B612 Mono 700
  static Future<Font> b612MonoBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/b612mono/v5/kmK6Zq85QVWbN1eW6lJdayv4os9Pv7JGSg.ttf',
      'B612Mono-Bold',
    );
    return font.getFont();
  }

  /// B612 Mono 700italic
  static Future<Font> b612MonoBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/b612mono/v5/kmKkZq85QVWbN1eW6lJV1TZkp8VLnbdWSg4x.ttf',
      'B612Mono-BoldItalic',
    );
    return font.getFont();
  }

  /// Bad Script regular
  static Future<Font> badScriptRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/badscript/v9/6NUT8F6PJgbFWQn47_x7lOwuzd1AZtw.ttf',
      'BadScript-Regular',
    );
    return font.getFont();
  }

  /// Bahiana regular
  static Future<Font> bahianaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bahiana/v7/uU9PCBUV4YenPWJU7xPb3vyHmlI.ttf',
      'Bahiana-Regular',
    );
    return font.getFont();
  }

  /// Bahianita regular
  static Future<Font> bahianitaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bahianita/v5/yYLr0hTb3vuqqsBUgxWtxTvV2NJPcA.ttf',
      'Bahianita-Regular',
    );
    return font.getFont();
  }

  /// Bai Jamjuree 200
  static Future<Font> baiJamjureeExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/baijamjuree/v4/LDIqapSCOBt_aeQQ7ftydoa0kePuk5A1-yiSgA.ttf',
      'BaiJamjuree-ExtraLight',
    );
    return font.getFont();
  }

  /// Bai Jamjuree 200italic
  static Future<Font> baiJamjureeExtraLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/baijamjuree/v4/LDIoapSCOBt_aeQQ7ftydoa8W_oGkpox2S2CgOva.ttf',
      'BaiJamjuree-ExtraLightItalic',
    );
    return font.getFont();
  }

  /// Bai Jamjuree 300
  static Future<Font> baiJamjureeLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/baijamjuree/v4/LDIqapSCOBt_aeQQ7ftydoa09eDuk5A1-yiSgA.ttf',
      'BaiJamjuree-Light',
    );
    return font.getFont();
  }

  /// Bai Jamjuree 300italic
  static Future<Font> baiJamjureeLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/baijamjuree/v4/LDIoapSCOBt_aeQQ7ftydoa8W_pikZox2S2CgOva.ttf',
      'BaiJamjuree-LightItalic',
    );
    return font.getFont();
  }

  /// Bai Jamjuree regular
  static Future<Font> baiJamjureeRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/baijamjuree/v4/LDI1apSCOBt_aeQQ7ftydoaMWcjKm7sp8g.ttf',
      'BaiJamjuree-Regular',
    );
    return font.getFont();
  }

  /// Bai Jamjuree italic
  static Future<Font> baiJamjureeItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/baijamjuree/v4/LDIrapSCOBt_aeQQ7ftydoa8W8LOub458jGL.ttf',
      'BaiJamjuree-Italic',
    );
    return font.getFont();
  }

  /// Bai Jamjuree 500
  static Future<Font> baiJamjureeMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/baijamjuree/v4/LDIqapSCOBt_aeQQ7ftydoa0reHuk5A1-yiSgA.ttf',
      'BaiJamjuree-Medium',
    );
    return font.getFont();
  }

  /// Bai Jamjuree 500italic
  static Future<Font> baiJamjureeMediumItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/baijamjuree/v4/LDIoapSCOBt_aeQQ7ftydoa8W_o6kJox2S2CgOva.ttf',
      'BaiJamjuree-MediumItalic',
    );
    return font.getFont();
  }

  /// Bai Jamjuree 600
  static Future<Font> baiJamjureeSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/baijamjuree/v4/LDIqapSCOBt_aeQQ7ftydoa0gebuk5A1-yiSgA.ttf',
      'BaiJamjuree-SemiBold',
    );
    return font.getFont();
  }

  /// Bai Jamjuree 600italic
  static Future<Font> baiJamjureeSemiBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/baijamjuree/v4/LDIoapSCOBt_aeQQ7ftydoa8W_oWl5ox2S2CgOva.ttf',
      'BaiJamjuree-SemiBoldItalic',
    );
    return font.getFont();
  }

  /// Bai Jamjuree 700
  static Future<Font> baiJamjureeBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/baijamjuree/v4/LDIqapSCOBt_aeQQ7ftydoa05efuk5A1-yiSgA.ttf',
      'BaiJamjuree-Bold',
    );
    return font.getFont();
  }

  /// Bai Jamjuree 700italic
  static Future<Font> baiJamjureeBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/baijamjuree/v4/LDIoapSCOBt_aeQQ7ftydoa8W_pylpox2S2CgOva.ttf',
      'BaiJamjuree-BoldItalic',
    );
    return font.getFont();
  }

  /// Ballet regular
  static Future<Font> balletRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ballet/v6/QGYyz_MYZA-HM4NjuGOVnUEXme1I4Xi3C4G-EiAou6Y.ttf',
      'Ballet-Regular',
    );
    return font.getFont();
  }

  /// Baloo 2 regular
  static Future<Font> baloo2Regular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/baloo2/v2/wXKrE3kTposypRyd11_WAewrhXY.ttf',
      'Baloo2-Regular',
    );
    return font.getFont();
  }

  /// Baloo 2 500
  static Future<Font> baloo2Medium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/baloo2/v2/wXKuE3kTposypRyd76v_JeQAmX8yrdk.ttf',
      'Baloo2-Medium',
    );
    return font.getFont();
  }

  /// Baloo 2 600
  static Future<Font> baloo2SemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/baloo2/v2/wXKuE3kTposypRyd74f4JeQAmX8yrdk.ttf',
      'Baloo2-SemiBold',
    );
    return font.getFont();
  }

  /// Baloo 2 700
  static Future<Font> baloo2Bold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/baloo2/v2/wXKuE3kTposypRyd7-P5JeQAmX8yrdk.ttf',
      'Baloo2-Bold',
    );
    return font.getFont();
  }

  /// Baloo 2 800
  static Future<Font> baloo2ExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/baloo2/v2/wXKuE3kTposypRyd7__6JeQAmX8yrdk.ttf',
      'Baloo2-ExtraBold',
    );
    return font.getFont();
  }

  /// Baloo Bhai 2 regular
  static Future<Font> balooBhai2Regular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/baloobhai2/v4/sZlDdRSL-z1VEWZ4YNA7Y5I3cdTmiH1gFQ.ttf',
      'BalooBhai2-Regular',
    );
    return font.getFont();
  }

  /// Baloo Bhai 2 500
  static Future<Font> balooBhai2Medium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/baloobhai2/v4/sZlcdRSL-z1VEWZ4YNA7Y5IPhf3CgFZ8HNV3Nw.ttf',
      'BalooBhai2-Medium',
    );
    return font.getFont();
  }

  /// Baloo Bhai 2 600
  static Future<Font> balooBhai2SemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/baloobhai2/v4/sZlcdRSL-z1VEWZ4YNA7Y5IPqfrCgFZ8HNV3Nw.ttf',
      'BalooBhai2-SemiBold',
    );
    return font.getFont();
  }

  /// Baloo Bhai 2 700
  static Future<Font> balooBhai2Bold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/baloobhai2/v4/sZlcdRSL-z1VEWZ4YNA7Y5IPzfvCgFZ8HNV3Nw.ttf',
      'BalooBhai2-Bold',
    );
    return font.getFont();
  }

  /// Baloo Bhai 2 800
  static Future<Font> balooBhai2ExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/baloobhai2/v4/sZlcdRSL-z1VEWZ4YNA7Y5IP0fjCgFZ8HNV3Nw.ttf',
      'BalooBhai2-ExtraBold',
    );
    return font.getFont();
  }

  /// Baloo Bhaina 2 regular
  static Future<Font> balooBhaina2Regular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/baloobhaina2/v4/qWczB6yyq4P9Adr3RtoX1q6yShz7mDUoupoI.ttf',
      'BalooBhaina2-Regular',
    );
    return font.getFont();
  }

  /// Baloo Bhaina 2 500
  static Future<Font> balooBhaina2Medium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/baloobhaina2/v4/qWcwB6yyq4P9Adr3RtoX1q6ySiQPsREgkYYBX_3F.ttf',
      'BalooBhaina2-Medium',
    );
    return font.getFont();
  }

  /// Baloo Bhaina 2 600
  static Future<Font> balooBhaina2SemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/baloobhaina2/v4/qWcwB6yyq4P9Adr3RtoX1q6ySiQjthEgkYYBX_3F.ttf',
      'BalooBhaina2-SemiBold',
    );
    return font.getFont();
  }

  /// Baloo Bhaina 2 700
  static Future<Font> balooBhaina2Bold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/baloobhaina2/v4/qWcwB6yyq4P9Adr3RtoX1q6ySiRHtxEgkYYBX_3F.ttf',
      'BalooBhaina2-Bold',
    );
    return font.getFont();
  }

  /// Baloo Bhaina 2 800
  static Future<Font> balooBhaina2ExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/baloobhaina2/v4/qWcwB6yyq4P9Adr3RtoX1q6ySiRbtBEgkYYBX_3F.ttf',
      'BalooBhaina2-ExtraBold',
    );
    return font.getFont();
  }

  /// Baloo Chettan 2 regular
  static Future<Font> balooChettan2Regular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/baloochettan2/v2/vm8udRbmXEva26PK-NtuX4ynWEzf4P17OpYDlg.ttf',
      'BalooChettan2-Regular',
    );
    return font.getFont();
  }

  /// Baloo Chettan 2 500
  static Future<Font> balooChettan2Medium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/baloochettan2/v2/vm8rdRbmXEva26PK-NtuX4ynWEznFNRfMr0fn5bhCA.ttf',
      'BalooChettan2-Medium',
    );
    return font.getFont();
  }

  /// Baloo Chettan 2 600
  static Future<Font> balooChettan2SemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/baloochettan2/v2/vm8rdRbmXEva26PK-NtuX4ynWEznONNfMr0fn5bhCA.ttf',
      'BalooChettan2-SemiBold',
    );
    return font.getFont();
  }

  /// Baloo Chettan 2 700
  static Future<Font> balooChettan2Bold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/baloochettan2/v2/vm8rdRbmXEva26PK-NtuX4ynWEznXNJfMr0fn5bhCA.ttf',
      'BalooChettan2-Bold',
    );
    return font.getFont();
  }

  /// Baloo Chettan 2 800
  static Future<Font> balooChettan2ExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/baloochettan2/v2/vm8rdRbmXEva26PK-NtuX4ynWEznQNFfMr0fn5bhCA.ttf',
      'BalooChettan2-ExtraBold',
    );
    return font.getFont();
  }

  /// Baloo Da 2 regular
  static Future<Font> balooDa2Regular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/balooda2/v2/2-ci9J9j0IaUMQZwAJyJcu7XoZFDf2Q.ttf',
      'BalooDa2-Regular',
    );
    return font.getFont();
  }

  /// Baloo Da 2 500
  static Future<Font> balooDa2Medium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/balooda2/v2/2-ch9J9j0IaUMQZwAJyJShr-hZloY23zejE.ttf',
      'BalooDa2-Medium',
    );
    return font.getFont();
  }

  /// Baloo Da 2 600
  static Future<Font> balooDa2SemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/balooda2/v2/2-ch9J9j0IaUMQZwAJyJSjb5hZloY23zejE.ttf',
      'BalooDa2-SemiBold',
    );
    return font.getFont();
  }

  /// Baloo Da 2 700
  static Future<Font> balooDa2Bold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/balooda2/v2/2-ch9J9j0IaUMQZwAJyJSlL4hZloY23zejE.ttf',
      'BalooDa2-Bold',
    );
    return font.getFont();
  }

  /// Baloo Da 2 800
  static Future<Font> balooDa2ExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/balooda2/v2/2-ch9J9j0IaUMQZwAJyJSk77hZloY23zejE.ttf',
      'BalooDa2-ExtraBold',
    );
    return font.getFont();
  }

  /// Baloo Paaji 2 regular
  static Future<Font> balooPaaji2Regular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/baloopaaji2/v4/i7dMIFFzbz-QHZUdV9_UGWZuYFKQHwyVd3U.ttf',
      'BalooPaaji2-Regular',
    );
    return font.getFont();
  }

  /// Baloo Paaji 2 500
  static Future<Font> balooPaaji2Medium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/baloopaaji2/v4/i7dRIFFzbz-QHZUdV9_UGWZuWKa5OwS-a3yGe9E.ttf',
      'BalooPaaji2-Medium',
    );
    return font.getFont();
  }

  /// Baloo Paaji 2 600
  static Future<Font> balooPaaji2SemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/baloopaaji2/v4/i7dRIFFzbz-QHZUdV9_UGWZuWIq-OwS-a3yGe9E.ttf',
      'BalooPaaji2-SemiBold',
    );
    return font.getFont();
  }

  /// Baloo Paaji 2 700
  static Future<Font> balooPaaji2Bold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/baloopaaji2/v4/i7dRIFFzbz-QHZUdV9_UGWZuWO6_OwS-a3yGe9E.ttf',
      'BalooPaaji2-Bold',
    );
    return font.getFont();
  }

  /// Baloo Paaji 2 800
  static Future<Font> balooPaaji2ExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/baloopaaji2/v4/i7dRIFFzbz-QHZUdV9_UGWZuWPK8OwS-a3yGe9E.ttf',
      'BalooPaaji2-ExtraBold',
    );
    return font.getFont();
  }

  /// Baloo Tamma 2 regular
  static Future<Font> balooTamma2Regular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/balootamma2/v2/vEFX2_hCAgcR46PaajtrYlBbT0g21tqeR7c.ttf',
      'BalooTamma2-Regular',
    );
    return font.getFont();
  }

  /// Baloo Tamma 2 500
  static Future<Font> balooTamma2Medium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/balootamma2/v2/vEFK2_hCAgcR46PaajtrYlBbd7wf8tK1W77HtMo.ttf',
      'BalooTamma2-Medium',
    );
    return font.getFont();
  }

  /// Baloo Tamma 2 600
  static Future<Font> balooTamma2SemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/balootamma2/v2/vEFK2_hCAgcR46PaajtrYlBbd5AY8tK1W77HtMo.ttf',
      'BalooTamma2-SemiBold',
    );
    return font.getFont();
  }

  /// Baloo Tamma 2 700
  static Future<Font> balooTamma2Bold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/balootamma2/v2/vEFK2_hCAgcR46PaajtrYlBbd_QZ8tK1W77HtMo.ttf',
      'BalooTamma2-Bold',
    );
    return font.getFont();
  }

  /// Baloo Tamma 2 800
  static Future<Font> balooTamma2ExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/balootamma2/v2/vEFK2_hCAgcR46PaajtrYlBbd-ga8tK1W77HtMo.ttf',
      'BalooTamma2-ExtraBold',
    );
    return font.getFont();
  }

  /// Baloo Tammudu 2 regular
  static Future<Font> balooTammudu2Regular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/balootammudu2/v4/1Pt2g8TIS_SAmkLguUdFP8UaJcK-xXEW6aGXHw.ttf',
      'BalooTammudu2-Regular',
    );
    return font.getFont();
  }

  /// Baloo Tammudu 2 500
  static Future<Font> balooTammudu2Medium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/balootammudu2/v4/1Ptzg8TIS_SAmkLguUdFP8UaJcKGMVgy4YqLFrUnJA.ttf',
      'BalooTammudu2-Medium',
    );
    return font.getFont();
  }

  /// Baloo Tammudu 2 600
  static Future<Font> balooTammudu2SemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/balootammudu2/v4/1Ptzg8TIS_SAmkLguUdFP8UaJcKGHV8y4YqLFrUnJA.ttf',
      'BalooTammudu2-SemiBold',
    );
    return font.getFont();
  }

  /// Baloo Tammudu 2 700
  static Future<Font> balooTammudu2Bold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/balootammudu2/v4/1Ptzg8TIS_SAmkLguUdFP8UaJcKGeV4y4YqLFrUnJA.ttf',
      'BalooTammudu2-Bold',
    );
    return font.getFont();
  }

  /// Baloo Tammudu 2 800
  static Future<Font> balooTammudu2ExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/balootammudu2/v4/1Ptzg8TIS_SAmkLguUdFP8UaJcKGZV0y4YqLFrUnJA.ttf',
      'BalooTammudu2-ExtraBold',
    );
    return font.getFont();
  }

  /// Baloo Thambi 2 regular
  static Future<Font> balooThambi2Regular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/baloothambi2/v2/cY9cfjeOW0NHpmOQXranrbDyu4hHBJOxZQPp.ttf',
      'BalooThambi2-Regular',
    );
    return font.getFont();
  }

  /// Baloo Thambi 2 500
  static Future<Font> balooThambi2Medium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/baloothambi2/v2/cY9ffjeOW0NHpmOQXranrbDyu7CzLbe5Th_gRA7L.ttf',
      'BalooThambi2-Medium',
    );
    return font.getFont();
  }

  /// Baloo Thambi 2 600
  static Future<Font> balooThambi2SemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/baloothambi2/v2/cY9ffjeOW0NHpmOQXranrbDyu7CfKre5Th_gRA7L.ttf',
      'BalooThambi2-SemiBold',
    );
    return font.getFont();
  }

  /// Baloo Thambi 2 700
  static Future<Font> balooThambi2Bold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/baloothambi2/v2/cY9ffjeOW0NHpmOQXranrbDyu7D7K7e5Th_gRA7L.ttf',
      'BalooThambi2-Bold',
    );
    return font.getFont();
  }

  /// Baloo Thambi 2 800
  static Future<Font> balooThambi2ExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/baloothambi2/v2/cY9ffjeOW0NHpmOQXranrbDyu7DnKLe5Th_gRA7L.ttf',
      'BalooThambi2-ExtraBold',
    );
    return font.getFont();
  }

  /// Balsamiq Sans regular
  static Future<Font> balsamiqSansRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/balsamiqsans/v3/P5sEzZiAbNrN8SB3lQQX7Pnc8dkdIYdNHzs.ttf',
      'BalsamiqSans-Regular',
    );
    return font.getFont();
  }

  /// Balsamiq Sans italic
  static Future<Font> balsamiqSansItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/balsamiqsans/v3/P5sazZiAbNrN8SB3lQQX7PncwdsXJaVIDzvcXA.ttf',
      'BalsamiqSans-Italic',
    );
    return font.getFont();
  }

  /// Balsamiq Sans 700
  static Future<Font> balsamiqSansBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/balsamiqsans/v3/P5sZzZiAbNrN8SB3lQQX7PncyWUyBY9mAzLFRQI.ttf',
      'BalsamiqSans-Bold',
    );
    return font.getFont();
  }

  /// Balsamiq Sans 700italic
  static Future<Font> balsamiqSansBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/balsamiqsans/v3/P5sfzZiAbNrN8SB3lQQX7PncwdsvmYpsBxDAVQI4aA.ttf',
      'BalsamiqSans-BoldItalic',
    );
    return font.getFont();
  }

  /// Balthazar regular
  static Future<Font> balthazarRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/balthazar/v10/d6lKkaajS8Gm4CVQjFEvyRTo39l8hw.ttf',
      'Balthazar-Regular',
    );
    return font.getFont();
  }

  /// Bangers regular
  static Future<Font> bangersRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bangers/v13/FeVQS0BTqb0h60ACL5la2bxii28.ttf',
      'Bangers-Regular',
    );
    return font.getFont();
  }

  /// Barlow 100
  static Future<Font> barlowThin() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/barlow/v5/7cHrv4kjgoGqM7E3b8s8yn4hnCci.ttf',
      'Barlow-Thin',
    );
    return font.getFont();
  }

  /// Barlow 100italic
  static Future<Font> barlowThinItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/barlow/v5/7cHtv4kjgoGqM7E_CfNYwHoDmTcibrA.ttf',
      'Barlow-ThinItalic',
    );
    return font.getFont();
  }

  /// Barlow 200
  static Future<Font> barlowExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/barlow/v5/7cHqv4kjgoGqM7E3w-oc4FAtlT47dw.ttf',
      'Barlow-ExtraLight',
    );
    return font.getFont();
  }

  /// Barlow 200italic
  static Future<Font> barlowExtraLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/barlow/v5/7cHsv4kjgoGqM7E_CfP04Voptzsrd6m9.ttf',
      'Barlow-ExtraLightItalic',
    );
    return font.getFont();
  }

  /// Barlow 300
  static Future<Font> barlowLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/barlow/v5/7cHqv4kjgoGqM7E3p-kc4FAtlT47dw.ttf',
      'Barlow-Light',
    );
    return font.getFont();
  }

  /// Barlow 300italic
  static Future<Font> barlowLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/barlow/v5/7cHsv4kjgoGqM7E_CfOQ4loptzsrd6m9.ttf',
      'Barlow-LightItalic',
    );
    return font.getFont();
  }

  /// Barlow regular
  static Future<Font> barlowRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/barlow/v5/7cHpv4kjgoGqM7EPC8E46HsxnA.ttf',
      'Barlow-Regular',
    );
    return font.getFont();
  }

  /// Barlow italic
  static Future<Font> barlowItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/barlow/v5/7cHrv4kjgoGqM7E_Ccs8yn4hnCci.ttf',
      'Barlow-Italic',
    );
    return font.getFont();
  }

  /// Barlow 500
  static Future<Font> barlowMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/barlow/v5/7cHqv4kjgoGqM7E3_-gc4FAtlT47dw.ttf',
      'Barlow-Medium',
    );
    return font.getFont();
  }

  /// Barlow 500italic
  static Future<Font> barlowMediumItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/barlow/v5/7cHsv4kjgoGqM7E_CfPI41optzsrd6m9.ttf',
      'Barlow-MediumItalic',
    );
    return font.getFont();
  }

  /// Barlow 600
  static Future<Font> barlowSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/barlow/v5/7cHqv4kjgoGqM7E30-8c4FAtlT47dw.ttf',
      'Barlow-SemiBold',
    );
    return font.getFont();
  }

  /// Barlow 600italic
  static Future<Font> barlowSemiBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/barlow/v5/7cHsv4kjgoGqM7E_CfPk5Foptzsrd6m9.ttf',
      'Barlow-SemiBoldItalic',
    );
    return font.getFont();
  }

  /// Barlow 700
  static Future<Font> barlowBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/barlow/v5/7cHqv4kjgoGqM7E3t-4c4FAtlT47dw.ttf',
      'Barlow-Bold',
    );
    return font.getFont();
  }

  /// Barlow 700italic
  static Future<Font> barlowBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/barlow/v5/7cHsv4kjgoGqM7E_CfOA5Voptzsrd6m9.ttf',
      'Barlow-BoldItalic',
    );
    return font.getFont();
  }

  /// Barlow 800
  static Future<Font> barlowExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/barlow/v5/7cHqv4kjgoGqM7E3q-0c4FAtlT47dw.ttf',
      'Barlow-ExtraBold',
    );
    return font.getFont();
  }

  /// Barlow 800italic
  static Future<Font> barlowExtraBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/barlow/v5/7cHsv4kjgoGqM7E_CfOc5loptzsrd6m9.ttf',
      'Barlow-ExtraBoldItalic',
    );
    return font.getFont();
  }

  /// Barlow 900
  static Future<Font> barlowBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/barlow/v5/7cHqv4kjgoGqM7E3j-wc4FAtlT47dw.ttf',
      'Barlow-Black',
    );
    return font.getFont();
  }

  /// Barlow 900italic
  static Future<Font> barlowBlackItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/barlow/v5/7cHsv4kjgoGqM7E_CfO451optzsrd6m9.ttf',
      'Barlow-BlackItalic',
    );
    return font.getFont();
  }

  /// Barlow Condensed 100
  static Future<Font> barlowCondensedThin() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/barlowcondensed/v5/HTxxL3I-JCGChYJ8VI-L6OO_au7B43LT31vytKgbaw.ttf',
      'BarlowCondensed-Thin',
    );
    return font.getFont();
  }

  /// Barlow Condensed 100italic
  static Future<Font> barlowCondensedThinItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/barlowcondensed/v5/HTxzL3I-JCGChYJ8VI-L6OO_au7B6xTru1H2lq0La6JN.ttf',
      'BarlowCondensed-ThinItalic',
    );
    return font.getFont();
  }

  /// Barlow Condensed 200
  static Future<Font> barlowCondensedExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/barlowcondensed/v5/HTxwL3I-JCGChYJ8VI-L6OO_au7B497y_3HcuKECcrs.ttf',
      'BarlowCondensed-ExtraLight',
    );
    return font.getFont();
  }

  /// Barlow Condensed 200italic
  static Future<Font> barlowCondensedExtraLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/barlowcondensed/v5/HTxyL3I-JCGChYJ8VI-L6OO_au7B6xTrF3DWvIMHYrtUxg.ttf',
      'BarlowCondensed-ExtraLightItalic',
    );
    return font.getFont();
  }

  /// Barlow Condensed 300
  static Future<Font> barlowCondensedLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/barlowcondensed/v5/HTxwL3I-JCGChYJ8VI-L6OO_au7B47rx_3HcuKECcrs.ttf',
      'BarlowCondensed-Light',
    );
    return font.getFont();
  }

  /// Barlow Condensed 300italic
  static Future<Font> barlowCondensedLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/barlowcondensed/v5/HTxyL3I-JCGChYJ8VI-L6OO_au7B6xTrc3PWvIMHYrtUxg.ttf',
      'BarlowCondensed-LightItalic',
    );
    return font.getFont();
  }

  /// Barlow Condensed regular
  static Future<Font> barlowCondensedRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/barlowcondensed/v5/HTx3L3I-JCGChYJ8VI-L6OO_au7B2xbZ23n3pKg.ttf',
      'BarlowCondensed-Regular',
    );
    return font.getFont();
  }

  /// Barlow Condensed italic
  static Future<Font> barlowCondensedItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/barlowcondensed/v5/HTxxL3I-JCGChYJ8VI-L6OO_au7B6xTT31vytKgbaw.ttf',
      'BarlowCondensed-Italic',
    );
    return font.getFont();
  }

  /// Barlow Condensed 500
  static Future<Font> barlowCondensedMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/barlowcondensed/v5/HTxwL3I-JCGChYJ8VI-L6OO_au7B4-Lw_3HcuKECcrs.ttf',
      'BarlowCondensed-Medium',
    );
    return font.getFont();
  }

  /// Barlow Condensed 500italic
  static Future<Font> barlowCondensedMediumItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/barlowcondensed/v5/HTxyL3I-JCGChYJ8VI-L6OO_au7B6xTrK3LWvIMHYrtUxg.ttf',
      'BarlowCondensed-MediumItalic',
    );
    return font.getFont();
  }

  /// Barlow Condensed 600
  static Future<Font> barlowCondensedSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/barlowcondensed/v5/HTxwL3I-JCGChYJ8VI-L6OO_au7B4873_3HcuKECcrs.ttf',
      'BarlowCondensed-SemiBold',
    );
    return font.getFont();
  }

  /// Barlow Condensed 600italic
  static Future<Font> barlowCondensedSemiBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/barlowcondensed/v5/HTxyL3I-JCGChYJ8VI-L6OO_au7B6xTrB3XWvIMHYrtUxg.ttf',
      'BarlowCondensed-SemiBoldItalic',
    );
    return font.getFont();
  }

  /// Barlow Condensed 700
  static Future<Font> barlowCondensedBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/barlowcondensed/v5/HTxwL3I-JCGChYJ8VI-L6OO_au7B46r2_3HcuKECcrs.ttf',
      'BarlowCondensed-Bold',
    );
    return font.getFont();
  }

  /// Barlow Condensed 700italic
  static Future<Font> barlowCondensedBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/barlowcondensed/v5/HTxyL3I-JCGChYJ8VI-L6OO_au7B6xTrY3TWvIMHYrtUxg.ttf',
      'BarlowCondensed-BoldItalic',
    );
    return font.getFont();
  }

  /// Barlow Condensed 800
  static Future<Font> barlowCondensedExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/barlowcondensed/v5/HTxwL3I-JCGChYJ8VI-L6OO_au7B47b1_3HcuKECcrs.ttf',
      'BarlowCondensed-ExtraBold',
    );
    return font.getFont();
  }

  /// Barlow Condensed 800italic
  static Future<Font> barlowCondensedExtraBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/barlowcondensed/v5/HTxyL3I-JCGChYJ8VI-L6OO_au7B6xTrf3fWvIMHYrtUxg.ttf',
      'BarlowCondensed-ExtraBoldItalic',
    );
    return font.getFont();
  }

  /// Barlow Condensed 900
  static Future<Font> barlowCondensedBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/barlowcondensed/v5/HTxwL3I-JCGChYJ8VI-L6OO_au7B45L0_3HcuKECcrs.ttf',
      'BarlowCondensed-Black',
    );
    return font.getFont();
  }

  /// Barlow Condensed 900italic
  static Future<Font> barlowCondensedBlackItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/barlowcondensed/v5/HTxyL3I-JCGChYJ8VI-L6OO_au7B6xTrW3bWvIMHYrtUxg.ttf',
      'BarlowCondensed-BlackItalic',
    );
    return font.getFont();
  }

  /// Barlow Semi Condensed 100
  static Future<Font> barlowSemiCondensedThin() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/barlowsemicondensed/v6/wlphgxjLBV1hqnzfr-F8sEYMB0Yybp0mudRfG4qvKk8ogoSP.ttf',
      'BarlowSemiCondensed-Thin',
    );
    return font.getFont();
  }

  /// Barlow Semi Condensed 100italic
  static Future<Font> barlowSemiCondensedThinItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/barlowsemicondensed/v6/wlpjgxjLBV1hqnzfr-F8sEYMB0Yybp0mudRXfbLLIEsKh5SPZWs.ttf',
      'BarlowSemiCondensed-ThinItalic',
    );
    return font.getFont();
  }

  /// Barlow Semi Condensed 200
  static Future<Font> barlowSemiCondensedExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/barlowsemicondensed/v6/wlpigxjLBV1hqnzfr-F8sEYMB0Yybp0mudRft6uPAGEki52WfA.ttf',
      'BarlowSemiCondensed-ExtraLight',
    );
    return font.getFont();
  }

  /// Barlow Semi Condensed 200italic
  static Future<Font> barlowSemiCondensedExtraLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/barlowsemicondensed/v6/wlpkgxjLBV1hqnzfr-F8sEYMB0Yybp0mudRXfbJnAWsgqZiGfHK5.ttf',
      'BarlowSemiCondensed-ExtraLightItalic',
    );
    return font.getFont();
  }

  /// Barlow Semi Condensed 300
  static Future<Font> barlowSemiCondensedLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/barlowsemicondensed/v6/wlpigxjLBV1hqnzfr-F8sEYMB0Yybp0mudRf06iPAGEki52WfA.ttf',
      'BarlowSemiCondensed-Light',
    );
    return font.getFont();
  }

  /// Barlow Semi Condensed 300italic
  static Future<Font> barlowSemiCondensedLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/barlowsemicondensed/v6/wlpkgxjLBV1hqnzfr-F8sEYMB0Yybp0mudRXfbIDAmsgqZiGfHK5.ttf',
      'BarlowSemiCondensed-LightItalic',
    );
    return font.getFont();
  }

  /// Barlow Semi Condensed regular
  static Future<Font> barlowSemiCondensedRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/barlowsemicondensed/v6/wlpvgxjLBV1hqnzfr-F8sEYMB0Yybp0mudRnf4CrCEo4gg.ttf',
      'BarlowSemiCondensed-Regular',
    );
    return font.getFont();
  }

  /// Barlow Semi Condensed italic
  static Future<Font> barlowSemiCondensedItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/barlowsemicondensed/v6/wlphgxjLBV1hqnzfr-F8sEYMB0Yybp0mudRXfYqvKk8ogoSP.ttf',
      'BarlowSemiCondensed-Italic',
    );
    return font.getFont();
  }

  /// Barlow Semi Condensed 500
  static Future<Font> barlowSemiCondensedMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/barlowsemicondensed/v6/wlpigxjLBV1hqnzfr-F8sEYMB0Yybp0mudRfi6mPAGEki52WfA.ttf',
      'BarlowSemiCondensed-Medium',
    );
    return font.getFont();
  }

  /// Barlow Semi Condensed 500italic
  static Future<Font> barlowSemiCondensedMediumItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/barlowsemicondensed/v6/wlpkgxjLBV1hqnzfr-F8sEYMB0Yybp0mudRXfbJbA2sgqZiGfHK5.ttf',
      'BarlowSemiCondensed-MediumItalic',
    );
    return font.getFont();
  }

  /// Barlow Semi Condensed 600
  static Future<Font> barlowSemiCondensedSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/barlowsemicondensed/v6/wlpigxjLBV1hqnzfr-F8sEYMB0Yybp0mudRfp66PAGEki52WfA.ttf',
      'BarlowSemiCondensed-SemiBold',
    );
    return font.getFont();
  }

  /// Barlow Semi Condensed 600italic
  static Future<Font> barlowSemiCondensedSemiBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/barlowsemicondensed/v6/wlpkgxjLBV1hqnzfr-F8sEYMB0Yybp0mudRXfbJ3BGsgqZiGfHK5.ttf',
      'BarlowSemiCondensed-SemiBoldItalic',
    );
    return font.getFont();
  }

  /// Barlow Semi Condensed 700
  static Future<Font> barlowSemiCondensedBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/barlowsemicondensed/v6/wlpigxjLBV1hqnzfr-F8sEYMB0Yybp0mudRfw6-PAGEki52WfA.ttf',
      'BarlowSemiCondensed-Bold',
    );
    return font.getFont();
  }

  /// Barlow Semi Condensed 700italic
  static Future<Font> barlowSemiCondensedBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/barlowsemicondensed/v6/wlpkgxjLBV1hqnzfr-F8sEYMB0Yybp0mudRXfbITBWsgqZiGfHK5.ttf',
      'BarlowSemiCondensed-BoldItalic',
    );
    return font.getFont();
  }

  /// Barlow Semi Condensed 800
  static Future<Font> barlowSemiCondensedExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/barlowsemicondensed/v6/wlpigxjLBV1hqnzfr-F8sEYMB0Yybp0mudRf36yPAGEki52WfA.ttf',
      'BarlowSemiCondensed-ExtraBold',
    );
    return font.getFont();
  }

  /// Barlow Semi Condensed 800italic
  static Future<Font> barlowSemiCondensedExtraBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/barlowsemicondensed/v6/wlpkgxjLBV1hqnzfr-F8sEYMB0Yybp0mudRXfbIPBmsgqZiGfHK5.ttf',
      'BarlowSemiCondensed-ExtraBoldItalic',
    );
    return font.getFont();
  }

  /// Barlow Semi Condensed 900
  static Future<Font> barlowSemiCondensedBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/barlowsemicondensed/v6/wlpigxjLBV1hqnzfr-F8sEYMB0Yybp0mudRf-62PAGEki52WfA.ttf',
      'BarlowSemiCondensed-Black',
    );
    return font.getFont();
  }

  /// Barlow Semi Condensed 900italic
  static Future<Font> barlowSemiCondensedBlackItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/barlowsemicondensed/v6/wlpkgxjLBV1hqnzfr-F8sEYMB0Yybp0mudRXfbIrB2sgqZiGfHK5.ttf',
      'BarlowSemiCondensed-BlackItalic',
    );
    return font.getFont();
  }

  /// Barriecito regular
  static Future<Font> barriecitoRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/barriecito/v5/WWXXlj-CbBOSLY2QTuY_KdUiYwTO0MU.ttf',
      'Barriecito-Regular',
    );
    return font.getFont();
  }

  /// Barrio regular
  static Future<Font> barrioRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/barrio/v7/wEO8EBXBk8hBIDiEdQYhWdsX1Q.ttf',
      'Barrio-Regular',
    );
    return font.getFont();
  }

  /// Basic regular
  static Future<Font> basicRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/basic/v10/xfu_0WLxV2_XKQN34lDVyR7D.ttf',
      'Basic-Regular',
    );
    return font.getFont();
  }

  /// Baskervville regular
  static Future<Font> baskervvilleRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/baskervville/v5/YA9Ur0yU4l_XOrogbkun3kQgt5OohvbJ9A.ttf',
      'Baskervville-Regular',
    );
    return font.getFont();
  }

  /// Baskervville italic
  static Future<Font> baskervvilleItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/baskervville/v5/YA9Kr0yU4l_XOrogbkun3kQQtZmspPPZ9Mlt.ttf',
      'Baskervville-Italic',
    );
    return font.getFont();
  }

  /// Battambang regular
  static Future<Font> battambangRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/battambang/v14/uk-mEGe7raEw-HjkzZabDnWj4yxx7o8.ttf',
      'Battambang-Regular',
    );
    return font.getFont();
  }

  /// Battambang 700
  static Future<Font> battambangBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/battambang/v14/uk-lEGe7raEw-HjkzZabNsmMxyRa8oZK9I0.ttf',
      'Battambang-Bold',
    );
    return font.getFont();
  }

  /// Baumans regular
  static Future<Font> baumansRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/baumans/v10/-W_-XJj9QyTd3QfpR_oyaksqY5Q.ttf',
      'Baumans-Regular',
    );
    return font.getFont();
  }

  /// Bayon regular
  static Future<Font> bayonRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bayon/v16/9XUrlJNmn0LPFl-pOhYEd2NJ.ttf',
      'Bayon-Regular',
    );
    return font.getFont();
  }

  /// Be Vietnam 100
  static Future<Font> beVietnamThin() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bevietnam/v2/FBVxdDflz-iPfoPuIC2iKsUn7W1hK2czPg.ttf',
      'BeVietnam-Thin',
    );
    return font.getFont();
  }

  /// Be Vietnam 100italic
  static Future<Font> beVietnamThinItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bevietnam/v2/FBVvdDflz-iPfoPuIC2iIqMfiWdlCWIjPi5p.ttf',
      'BeVietnam-ThinItalic',
    );
    return font.getFont();
  }

  /// Be Vietnam 300
  static Future<Font> beVietnamLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bevietnam/v2/FBVwdDflz-iPfoPuIC2iKg0FzUdPJ24qJzc.ttf',
      'BeVietnam-Light',
    );
    return font.getFont();
  }

  /// Be Vietnam 300italic
  static Future<Font> beVietnamLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bevietnam/v2/FBVudDflz-iPfoPuIC2iIqMfQUVFI0wvNzdwXQ.ttf',
      'BeVietnam-LightItalic',
    );
    return font.getFont();
  }

  /// Be Vietnam regular
  static Future<Font> beVietnamRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bevietnam/v2/FBVzdDflz-iPfoPuIC2iEqEt6U9kO2c.ttf',
      'BeVietnam-Regular',
    );
    return font.getFont();
  }

  /// Be Vietnam italic
  static Future<Font> beVietnamItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bevietnam/v2/FBVxdDflz-iPfoPuIC2iIqMn7W1hK2czPg.ttf',
      'BeVietnam-Italic',
    );
    return font.getFont();
  }

  /// Be Vietnam 500
  static Future<Font> beVietnamMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bevietnam/v2/FBVwdDflz-iPfoPuIC2iKlUEzUdPJ24qJzc.ttf',
      'BeVietnam-Medium',
    );
    return font.getFont();
  }

  /// Be Vietnam 500italic
  static Future<Font> beVietnamMediumItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bevietnam/v2/FBVudDflz-iPfoPuIC2iIqMfGURFI0wvNzdwXQ.ttf',
      'BeVietnam-MediumItalic',
    );
    return font.getFont();
  }

  /// Be Vietnam 600
  static Future<Font> beVietnamSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bevietnam/v2/FBVwdDflz-iPfoPuIC2iKnkDzUdPJ24qJzc.ttf',
      'BeVietnam-SemiBold',
    );
    return font.getFont();
  }

  /// Be Vietnam 600italic
  static Future<Font> beVietnamSemiBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bevietnam/v2/FBVudDflz-iPfoPuIC2iIqMfNUNFI0wvNzdwXQ.ttf',
      'BeVietnam-SemiBoldItalic',
    );
    return font.getFont();
  }

  /// Be Vietnam 700
  static Future<Font> beVietnamBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bevietnam/v2/FBVwdDflz-iPfoPuIC2iKh0CzUdPJ24qJzc.ttf',
      'BeVietnam-Bold',
    );
    return font.getFont();
  }

  /// Be Vietnam 700italic
  static Future<Font> beVietnamBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bevietnam/v2/FBVudDflz-iPfoPuIC2iIqMfUUJFI0wvNzdwXQ.ttf',
      'BeVietnam-BoldItalic',
    );
    return font.getFont();
  }

  /// Be Vietnam 800
  static Future<Font> beVietnamExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bevietnam/v2/FBVwdDflz-iPfoPuIC2iKgEBzUdPJ24qJzc.ttf',
      'BeVietnam-ExtraBold',
    );
    return font.getFont();
  }

  /// Be Vietnam 800italic
  static Future<Font> beVietnamExtraBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bevietnam/v2/FBVudDflz-iPfoPuIC2iIqMfTUFFI0wvNzdwXQ.ttf',
      'BeVietnam-ExtraBoldItalic',
    );
    return font.getFont();
  }

  /// Bebas Neue regular
  static Future<Font> bebasNeueRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bebasneue/v2/JTUSjIg69CK48gW7PXooxW5rygbi49c.ttf',
      'BebasNeue-Regular',
    );
    return font.getFont();
  }

  /// Belgrano regular
  static Future<Font> belgranoRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/belgrano/v11/55xvey5tM9rwKWrJZcMFirl08KDJ.ttf',
      'Belgrano-Regular',
    );
    return font.getFont();
  }

  /// Bellefair regular
  static Future<Font> bellefairRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bellefair/v6/kJExBuYY6AAuhiXUxG19__A2pOdvDA.ttf',
      'Bellefair-Regular',
    );
    return font.getFont();
  }

  /// Belleza regular
  static Future<Font> bellezaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/belleza/v9/0nkoC9_pNeMfhX4BtcbyawzruP8.ttf',
      'Belleza-Regular',
    );
    return font.getFont();
  }

  /// Bellota 300
  static Future<Font> bellotaLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bellota/v4/MwQzbhXl3_qEpiwAID55kGMViblPtXs.ttf',
      'Bellota-Light',
    );
    return font.getFont();
  }

  /// Bellota 300italic
  static Future<Font> bellotaLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bellota/v4/MwQxbhXl3_qEpiwAKJBjHGEfjZtKpXulTQ.ttf',
      'Bellota-LightItalic',
    );
    return font.getFont();
  }

  /// Bellota regular
  static Future<Font> bellotaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bellota/v4/MwQ2bhXl3_qEpiwAGJJRtGs-lbA.ttf',
      'Bellota-Regular',
    );
    return font.getFont();
  }

  /// Bellota italic
  static Future<Font> bellotaItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bellota/v4/MwQ0bhXl3_qEpiwAKJBbsEk7hbBWrA.ttf',
      'Bellota-Italic',
    );
    return font.getFont();
  }

  /// Bellota 700
  static Future<Font> bellotaBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bellota/v4/MwQzbhXl3_qEpiwAIC5-kGMViblPtXs.ttf',
      'Bellota-Bold',
    );
    return font.getFont();
  }

  /// Bellota 700italic
  static Future<Font> bellotaBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bellota/v4/MwQxbhXl3_qEpiwAKJBjDGYfjZtKpXulTQ.ttf',
      'Bellota-BoldItalic',
    );
    return font.getFont();
  }

  /// Bellota Text 300
  static Future<Font> bellotaTextLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bellotatext/v4/0FlMVP2VnlWS4f3-UE9hHXM5VfsqfQXwQy6yxg.ttf',
      'BellotaText-Light',
    );
    return font.getFont();
  }

  /// Bellota Text 300italic
  static Future<Font> bellotaTextLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bellotatext/v4/0FlOVP2VnlWS4f3-UE9hHXMx--Gmfw_0YSuixmYK.ttf',
      'BellotaText-LightItalic',
    );
    return font.getFont();
  }

  /// Bellota Text regular
  static Future<Font> bellotaTextRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bellotatext/v4/0FlTVP2VnlWS4f3-UE9hHXMB-dMOdS7sSg.ttf',
      'BellotaText-Regular',
    );
    return font.getFont();
  }

  /// Bellota Text italic
  static Future<Font> bellotaTextItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bellotatext/v4/0FlNVP2VnlWS4f3-UE9hHXMx-9kKVyv8Sjer.ttf',
      'BellotaText-Italic',
    );
    return font.getFont();
  }

  /// Bellota Text 700
  static Future<Font> bellotaTextBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bellotatext/v4/0FlMVP2VnlWS4f3-UE9hHXM5RfwqfQXwQy6yxg.ttf',
      'BellotaText-Bold',
    );
    return font.getFont();
  }

  /// Bellota Text 700italic
  static Future<Font> bellotaTextBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bellotatext/v4/0FlOVP2VnlWS4f3-UE9hHXMx--G2eA_0YSuixmYK.ttf',
      'BellotaText-BoldItalic',
    );
    return font.getFont();
  }

  /// BenchNine 300
  static Future<Font> benchNineLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/benchnine/v9/ahcev8612zF4jxrwMosT--tRhWa8q0v8ag.ttf',
      'BenchNine-Light',
    );
    return font.getFont();
  }

  /// BenchNine regular
  static Future<Font> benchNineRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/benchnine/v9/ahcbv8612zF4jxrwMosrV8N1jU2gog.ttf',
      'BenchNine-Regular',
    );
    return font.getFont();
  }

  /// BenchNine 700
  static Future<Font> benchNineBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/benchnine/v9/ahcev8612zF4jxrwMosT6-xRhWa8q0v8ag.ttf',
      'BenchNine-Bold',
    );
    return font.getFont();
  }

  /// Benne regular
  static Future<Font> benneRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/benne/v10/L0xzDFAhn18E6Vjxlt6qTDBN.ttf',
      'Benne-Regular',
    );
    return font.getFont();
  }

  /// Bentham regular
  static Future<Font> benthamRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bentham/v11/VdGeAZQPEpYfmHglKWw7CJaK_y4.ttf',
      'Bentham-Regular',
    );
    return font.getFont();
  }

  /// Berkshire Swash regular
  static Future<Font> berkshireSwashRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/berkshireswash/v9/ptRRTi-cavZOGqCvnNJDl5m5XmNPrcQybX4pQA.ttf',
      'BerkshireSwash-Regular',
    );
    return font.getFont();
  }

  /// Beth Ellen regular
  static Future<Font> bethEllenRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bethellen/v5/WwkbxPW2BE-3rb_JNT-qEIAiVNo5xNY.ttf',
      'BethEllen-Regular',
    );
    return font.getFont();
  }

  /// Bevan regular
  static Future<Font> bevanRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bevan/v12/4iCj6KZ0a9NXjF8aUir7tlSJ.ttf',
      'Bevan-Regular',
    );
    return font.getFont();
  }

  /// Big Shoulders Display 100
  static Future<Font> bigShouldersDisplayThin() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bigshouldersdisplay/v4/fC1xPZJEZG-e9gHhdI4-NBbfd2ys3SjJCx1Ur9DrDJYM2lAZ.ttf',
      'BigShouldersDisplay-Thin',
    );
    return font.getFont();
  }

  /// Big Shoulders Display 300
  static Future<Font> bigShouldersDisplayLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bigshouldersdisplay/v4/fC1yPZJEZG-e9gHhdI4-NBbfd2ys3SjJCx1UZ_LLJrgA00kAdA.ttf',
      'BigShouldersDisplay-Light',
    );
    return font.getFont();
  }

  /// Big Shoulders Display regular
  static Future<Font> bigShouldersDisplayRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bigshouldersdisplay/v4/fC1_PZJEZG-e9gHhdI4-NBbfd2ys3SjJCx1sy9rvLpMc2g.ttf',
      'BigShouldersDisplay-Regular',
    );
    return font.getFont();
  }

  /// Big Shoulders Display 500
  static Future<Font> bigShouldersDisplayMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bigshouldersdisplay/v4/fC1yPZJEZG-e9gHhdI4-NBbfd2ys3SjJCx1UP_PLJrgA00kAdA.ttf',
      'BigShouldersDisplay-Medium',
    );
    return font.getFont();
  }

  /// Big Shoulders Display 600
  static Future<Font> bigShouldersDisplaySemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bigshouldersdisplay/v4/fC1yPZJEZG-e9gHhdI4-NBbfd2ys3SjJCx1UE_TLJrgA00kAdA.ttf',
      'BigShouldersDisplay-SemiBold',
    );
    return font.getFont();
  }

  /// Big Shoulders Display 700
  static Future<Font> bigShouldersDisplayBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bigshouldersdisplay/v4/fC1yPZJEZG-e9gHhdI4-NBbfd2ys3SjJCx1Ud_XLJrgA00kAdA.ttf',
      'BigShouldersDisplay-Bold',
    );
    return font.getFont();
  }

  /// Big Shoulders Display 800
  static Future<Font> bigShouldersDisplayExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bigshouldersdisplay/v4/fC1yPZJEZG-e9gHhdI4-NBbfd2ys3SjJCx1Ua_bLJrgA00kAdA.ttf',
      'BigShouldersDisplay-ExtraBold',
    );
    return font.getFont();
  }

  /// Big Shoulders Display 900
  static Future<Font> bigShouldersDisplayBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bigshouldersdisplay/v4/fC1yPZJEZG-e9gHhdI4-NBbfd2ys3SjJCx1UT_fLJrgA00kAdA.ttf',
      'BigShouldersDisplay-Black',
    );
    return font.getFont();
  }

  /// Big Shoulders Inline Display 100
  static Future<Font> bigShouldersInlineDisplayThin() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bigshouldersinlinedisplay/v5/_LOlmyfF4eSU_SCrJc9OI24U7siGvBGcZqmqV9-ZZ85COrytjChoEoUCJg.ttf',
      'BigShouldersInlineDisplay-Thin',
    );
    return font.getFont();
  }

  /// Big Shoulders Inline Display 300
  static Future<Font> bigShouldersInlineDisplayLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bigshouldersinlinedisplay/v5/_LOkmyfF4eSU_SCrJc9OI24U7siGvBGcZqmqV9-ZZ85COnSPrAJGHowbP0g.ttf',
      'BigShouldersInlineDisplay-Light',
    );
    return font.getFont();
  }

  /// Big Shoulders Inline Display regular
  static Future<Font> bigShouldersInlineDisplayRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bigshouldersinlinedisplay/v5/_LObmyfF4eSU_SCrJc9OI24U7siGvBGcZqmqV9-ZZ85CAtiniAptAoU.ttf',
      'BigShouldersInlineDisplay-Regular',
    );
    return font.getFont();
  }

  /// Big Shoulders Inline Display 500
  static Future<Font> bigShouldersInlineDisplayMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bigshouldersinlinedisplay/v5/_LOkmyfF4eSU_SCrJc9OI24U7siGvBGcZqmqV9-ZZ85COiyOrAJGHowbP0g.ttf',
      'BigShouldersInlineDisplay-Medium',
    );
    return font.getFont();
  }

  /// Big Shoulders Inline Display 600
  static Future<Font> bigShouldersInlineDisplaySemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bigshouldersinlinedisplay/v5/_LOkmyfF4eSU_SCrJc9OI24U7siGvBGcZqmqV9-ZZ85COgCJrAJGHowbP0g.ttf',
      'BigShouldersInlineDisplay-SemiBold',
    );
    return font.getFont();
  }

  /// Big Shoulders Inline Display 700
  static Future<Font> bigShouldersInlineDisplayBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bigshouldersinlinedisplay/v5/_LOkmyfF4eSU_SCrJc9OI24U7siGvBGcZqmqV9-ZZ85COmSIrAJGHowbP0g.ttf',
      'BigShouldersInlineDisplay-Bold',
    );
    return font.getFont();
  }

  /// Big Shoulders Inline Display 800
  static Future<Font> bigShouldersInlineDisplayExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bigshouldersinlinedisplay/v5/_LOkmyfF4eSU_SCrJc9OI24U7siGvBGcZqmqV9-ZZ85COniLrAJGHowbP0g.ttf',
      'BigShouldersInlineDisplay-ExtraBold',
    );
    return font.getFont();
  }

  /// Big Shoulders Inline Display 900
  static Future<Font> bigShouldersInlineDisplayBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bigshouldersinlinedisplay/v5/_LOkmyfF4eSU_SCrJc9OI24U7siGvBGcZqmqV9-ZZ85COlyKrAJGHowbP0g.ttf',
      'BigShouldersInlineDisplay-Black',
    );
    return font.getFont();
  }

  /// Big Shoulders Inline Text 100
  static Future<Font> bigShouldersInlineTextThin() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bigshouldersinlinetext/v5/vm8idQDmVECV5-vm5dJ-Tp-6WDeRjL4RV7dP8u-NEU7wG3AwE9VRww.ttf',
      'BigShouldersInlineText-Thin',
    );
    return font.getFont();
  }

  /// Big Shoulders Inline Text 300
  static Future<Font> bigShouldersInlineTextLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bigshouldersinlinetext/v5/vm8hdQDmVECV5-vm5dJ-Tp-6WDeRjL4RV7dP8u-NEYbSO1oeH9xI2gc.ttf',
      'BigShouldersInlineText-Light',
    );
    return font.getFont();
  }

  /// Big Shoulders Inline Text regular
  static Future<Font> bigShouldersInlineTextRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bigshouldersinlinetext/v5/vm8kdQDmVECV5-vm5dJ-Tp-6WDeRjL4RV7dP8u-NKSr6H1I1A9U.ttf',
      'BigShouldersInlineText-Regular',
    );
    return font.getFont();
  }

  /// Big Shoulders Inline Text 500
  static Future<Font> bigShouldersInlineTextMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bigshouldersinlinetext/v5/vm8hdQDmVECV5-vm5dJ-Tp-6WDeRjL4RV7dP8u-NEd7TO1oeH9xI2gc.ttf',
      'BigShouldersInlineText-Medium',
    );
    return font.getFont();
  }

  /// Big Shoulders Inline Text 600
  static Future<Font> bigShouldersInlineTextSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bigshouldersinlinetext/v5/vm8hdQDmVECV5-vm5dJ-Tp-6WDeRjL4RV7dP8u-NEfLUO1oeH9xI2gc.ttf',
      'BigShouldersInlineText-SemiBold',
    );
    return font.getFont();
  }

  /// Big Shoulders Inline Text 700
  static Future<Font> bigShouldersInlineTextBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bigshouldersinlinetext/v5/vm8hdQDmVECV5-vm5dJ-Tp-6WDeRjL4RV7dP8u-NEZbVO1oeH9xI2gc.ttf',
      'BigShouldersInlineText-Bold',
    );
    return font.getFont();
  }

  /// Big Shoulders Inline Text 800
  static Future<Font> bigShouldersInlineTextExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bigshouldersinlinetext/v5/vm8hdQDmVECV5-vm5dJ-Tp-6WDeRjL4RV7dP8u-NEYrWO1oeH9xI2gc.ttf',
      'BigShouldersInlineText-ExtraBold',
    );
    return font.getFont();
  }

  /// Big Shoulders Inline Text 900
  static Future<Font> bigShouldersInlineTextBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bigshouldersinlinetext/v5/vm8hdQDmVECV5-vm5dJ-Tp-6WDeRjL4RV7dP8u-NEa7XO1oeH9xI2gc.ttf',
      'BigShouldersInlineText-Black',
    );
    return font.getFont();
  }

  /// Big Shoulders Stencil Display 100
  static Future<Font> bigShouldersStencilDisplayThin() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bigshouldersstencildisplay/v5/6aeU4LS6U6pR_bp5b_t2ugOhHWFcxSGP9ttD96KCb8xPyvD00ncryljitbg.ttf',
      'BigShouldersStencilDisplay-Thin',
    );
    return font.getFont();
  }

  /// Big Shoulders Stencil Display 300
  static Future<Font> bigShouldersStencilDisplayLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bigshouldersstencildisplay/v5/6aeX4LS6U6pR_bp5b_t2ugOhHWFcxSGP9ttD96KCb8xPyvA88FcB5FTrrKG-.ttf',
      'BigShouldersStencilDisplay-Light',
    );
    return font.getFont();
  }

  /// Big Shoulders Stencil Display regular
  static Future<Font> bigShouldersStencilDisplayRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bigshouldersstencildisplay/v5/6aeq4LS6U6pR_bp5b_t2ugOhHWFcxSGP9ttD96KCb8xPysiQ2HMJz0ji.ttf',
      'BigShouldersStencilDisplay-Regular',
    );
    return font.getFont();
  }

  /// Big Shoulders Stencil Display 500
  static Future<Font> bigShouldersStencilDisplayMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bigshouldersstencildisplay/v5/6aeX4LS6U6pR_bp5b_t2ugOhHWFcxSGP9ttD96KCb8xPyvBk8VcB5FTrrKG-.ttf',
      'BigShouldersStencilDisplay-Medium',
    );
    return font.getFont();
  }

  /// Big Shoulders Stencil Display 600
  static Future<Font> bigShouldersStencilDisplaySemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bigshouldersstencildisplay/v5/6aeX4LS6U6pR_bp5b_t2ugOhHWFcxSGP9ttD96KCb8xPyvBI9lcB5FTrrKG-.ttf',
      'BigShouldersStencilDisplay-SemiBold',
    );
    return font.getFont();
  }

  /// Big Shoulders Stencil Display 700
  static Future<Font> bigShouldersStencilDisplayBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bigshouldersstencildisplay/v5/6aeX4LS6U6pR_bp5b_t2ugOhHWFcxSGP9ttD96KCb8xPyvAs91cB5FTrrKG-.ttf',
      'BigShouldersStencilDisplay-Bold',
    );
    return font.getFont();
  }

  /// Big Shoulders Stencil Display 800
  static Future<Font> bigShouldersStencilDisplayExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bigshouldersstencildisplay/v5/6aeX4LS6U6pR_bp5b_t2ugOhHWFcxSGP9ttD96KCb8xPyvAw9FcB5FTrrKG-.ttf',
      'BigShouldersStencilDisplay-ExtraBold',
    );
    return font.getFont();
  }

  /// Big Shoulders Stencil Display 900
  static Future<Font> bigShouldersStencilDisplayBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bigshouldersstencildisplay/v5/6aeX4LS6U6pR_bp5b_t2ugOhHWFcxSGP9ttD96KCb8xPyvAU9VcB5FTrrKG-.ttf',
      'BigShouldersStencilDisplay-Black',
    );
    return font.getFont();
  }

  /// Big Shoulders Stencil Text 100
  static Future<Font> bigShouldersStencilTextThin() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bigshouldersstenciltext/v5/5aUi9-i2oxDMNwY3dHfW7UAt3Q453SM15wNj53bCcYSZYGLxtPhi2eA.ttf',
      'BigShouldersStencilText-Thin',
    );
    return font.getFont();
  }

  /// Big Shoulders Stencil Text 300
  static Future<Font> bigShouldersStencilTextLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bigshouldersstenciltext/v5/5aUj9-i2oxDMNwY3dHfW7UAt3Q453SM15wNj53bCcYRRQkLbmvRrwPmQ.ttf',
      'BigShouldersStencilText-Light',
    );
    return font.getFont();
  }

  /// Big Shoulders Stencil Text regular
  static Future<Font> bigShouldersStencilTextRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bigshouldersstenciltext/v5/5aUg9-i2oxDMNwY3dHfW7UAt3Q453SM15wNj53bCcbz9ambTsehi.ttf',
      'BigShouldersStencilText-Regular',
    );
    return font.getFont();
  }

  /// Big Shoulders Stencil Text 500
  static Future<Font> bigShouldersStencilTextMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bigshouldersstenciltext/v5/5aUj9-i2oxDMNwY3dHfW7UAt3Q453SM15wNj53bCcYQJQ0LbmvRrwPmQ.ttf',
      'BigShouldersStencilText-Medium',
    );
    return font.getFont();
  }

  /// Big Shoulders Stencil Text 600
  static Future<Font> bigShouldersStencilTextSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bigshouldersstenciltext/v5/5aUj9-i2oxDMNwY3dHfW7UAt3Q453SM15wNj53bCcYQlRELbmvRrwPmQ.ttf',
      'BigShouldersStencilText-SemiBold',
    );
    return font.getFont();
  }

  /// Big Shoulders Stencil Text 700
  static Future<Font> bigShouldersStencilTextBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bigshouldersstenciltext/v5/5aUj9-i2oxDMNwY3dHfW7UAt3Q453SM15wNj53bCcYRBRULbmvRrwPmQ.ttf',
      'BigShouldersStencilText-Bold',
    );
    return font.getFont();
  }

  /// Big Shoulders Stencil Text 800
  static Future<Font> bigShouldersStencilTextExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bigshouldersstenciltext/v5/5aUj9-i2oxDMNwY3dHfW7UAt3Q453SM15wNj53bCcYRdRkLbmvRrwPmQ.ttf',
      'BigShouldersStencilText-ExtraBold',
    );
    return font.getFont();
  }

  /// Big Shoulders Stencil Text 900
  static Future<Font> bigShouldersStencilTextBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bigshouldersstenciltext/v5/5aUj9-i2oxDMNwY3dHfW7UAt3Q453SM15wNj53bCcYR5R0LbmvRrwPmQ.ttf',
      'BigShouldersStencilText-Black',
    );
    return font.getFont();
  }

  /// Big Shoulders Text 100
  static Future<Font> bigShouldersTextThin() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bigshoulderstext/v6/55xzezRtP9G3CGPIf49hxc8P0eytUxBU-IZ_YscCdXQB.ttf',
      'BigShouldersText-Thin',
    );
    return font.getFont();
  }

  /// Big Shoulders Text 300
  static Future<Font> bigShouldersTextLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bigshoulderstext/v6/55xyezRtP9G3CGPIf49hxc8P0eytUxBUMKRfSOkOfG0Y3A.ttf',
      'BigShouldersText-Light',
    );
    return font.getFont();
  }

  /// Big Shoulders Text regular
  static Future<Font> bigShouldersTextRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bigshoulderstext/v6/55xxezRtP9G3CGPIf49hxc8P0eytUxBsnIx7QMISdQ.ttf',
      'BigShouldersText-Regular',
    );
    return font.getFont();
  }

  /// Big Shoulders Text 500
  static Future<Font> bigShouldersTextMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bigshoulderstext/v6/55xyezRtP9G3CGPIf49hxc8P0eytUxBUaKVfSOkOfG0Y3A.ttf',
      'BigShouldersText-Medium',
    );
    return font.getFont();
  }

  /// Big Shoulders Text 600
  static Future<Font> bigShouldersTextSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bigshoulderstext/v6/55xyezRtP9G3CGPIf49hxc8P0eytUxBURKJfSOkOfG0Y3A.ttf',
      'BigShouldersText-SemiBold',
    );
    return font.getFont();
  }

  /// Big Shoulders Text 700
  static Future<Font> bigShouldersTextBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bigshoulderstext/v6/55xyezRtP9G3CGPIf49hxc8P0eytUxBUIKNfSOkOfG0Y3A.ttf',
      'BigShouldersText-Bold',
    );
    return font.getFont();
  }

  /// Big Shoulders Text 800
  static Future<Font> bigShouldersTextExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bigshoulderstext/v6/55xyezRtP9G3CGPIf49hxc8P0eytUxBUPKBfSOkOfG0Y3A.ttf',
      'BigShouldersText-ExtraBold',
    );
    return font.getFont();
  }

  /// Big Shoulders Text 900
  static Future<Font> bigShouldersTextBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bigshoulderstext/v6/55xyezRtP9G3CGPIf49hxc8P0eytUxBUGKFfSOkOfG0Y3A.ttf',
      'BigShouldersText-Black',
    );
    return font.getFont();
  }

  /// Bigelow Rules regular
  static Future<Font> bigelowRulesRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bigelowrules/v11/RrQWboly8iR_I3KWSzeRuN0zT4cCH8WAJVk.ttf',
      'BigelowRules-Regular',
    );
    return font.getFont();
  }

  /// Bigshot One regular
  static Future<Font> bigshotOneRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bigshotone/v13/u-470qukhRkkO6BD_7cM_gxuUQJBXv_-.ttf',
      'BigshotOne-Regular',
    );
    return font.getFont();
  }

  /// Bilbo regular
  static Future<Font> bilboRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bilbo/v12/o-0EIpgpwWwZ210hpIRz4wxE.ttf',
      'Bilbo-Regular',
    );
    return font.getFont();
  }

  /// Bilbo Swash Caps regular
  static Future<Font> bilboSwashCapsRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bilboswashcaps/v15/zrf-0GXbz-H3Wb4XBsGrTgq2PVmdqAPopiRfKp8.ttf',
      'BilboSwashCaps-Regular',
    );
    return font.getFont();
  }

  /// BioRhyme 200
  static Future<Font> bioRhymeExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/biorhyme/v5/1cX3aULHBpDMsHYW_ESOjnGAq8Sk1PoH.ttf',
      'BioRhyme-ExtraLight',
    );
    return font.getFont();
  }

  /// BioRhyme 300
  static Future<Font> bioRhymeLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/biorhyme/v5/1cX3aULHBpDMsHYW_ETqjXGAq8Sk1PoH.ttf',
      'BioRhyme-Light',
    );
    return font.getFont();
  }

  /// BioRhyme regular
  static Future<Font> bioRhymeRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/biorhyme/v5/1cXwaULHBpDMsHYW_HxGpVWIgNit.ttf',
      'BioRhyme-Regular',
    );
    return font.getFont();
  }

  /// BioRhyme 700
  static Future<Font> bioRhymeBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/biorhyme/v5/1cX3aULHBpDMsHYW_ET6inGAq8Sk1PoH.ttf',
      'BioRhyme-Bold',
    );
    return font.getFont();
  }

  /// BioRhyme 800
  static Future<Font> bioRhymeExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/biorhyme/v5/1cX3aULHBpDMsHYW_ETmiXGAq8Sk1PoH.ttf',
      'BioRhyme-ExtraBold',
    );
    return font.getFont();
  }

  /// BioRhyme Expanded 200
  static Future<Font> bioRhymeExpandedExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/biorhymeexpanded/v8/i7dVIE1zZzytGswgU577CDY9LjbffxxcblSHSdTXrb_z.ttf',
      'BioRhymeExpanded-ExtraLight',
    );
    return font.getFont();
  }

  /// BioRhyme Expanded 300
  static Future<Font> bioRhymeExpandedLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/biorhymeexpanded/v8/i7dVIE1zZzytGswgU577CDY9Ljbffxw4bVSHSdTXrb_z.ttf',
      'BioRhymeExpanded-Light',
    );
    return font.getFont();
  }

  /// BioRhyme Expanded regular
  static Future<Font> bioRhymeExpandedRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/biorhymeexpanded/v8/i7dQIE1zZzytGswgU577CDY9LjbffySURXCPYsje.ttf',
      'BioRhymeExpanded-Regular',
    );
    return font.getFont();
  }

  /// BioRhyme Expanded 700
  static Future<Font> bioRhymeExpandedBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/biorhymeexpanded/v8/i7dVIE1zZzytGswgU577CDY9LjbffxwoalSHSdTXrb_z.ttf',
      'BioRhymeExpanded-Bold',
    );
    return font.getFont();
  }

  /// BioRhyme Expanded 800
  static Future<Font> bioRhymeExpandedExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/biorhymeexpanded/v8/i7dVIE1zZzytGswgU577CDY9Ljbffxw0aVSHSdTXrb_z.ttf',
      'BioRhymeExpanded-ExtraBold',
    );
    return font.getFont();
  }

  /// Biryani 200
  static Future<Font> biryaniExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/biryani/v6/hv-TlzNxIFoO84YddYQyGTBSU-J-RxQ.ttf',
      'Biryani-ExtraLight',
    );
    return font.getFont();
  }

  /// Biryani 300
  static Future<Font> biryaniLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/biryani/v6/hv-TlzNxIFoO84YddeAxGTBSU-J-RxQ.ttf',
      'Biryani-Light',
    );
    return font.getFont();
  }

  /// Biryani regular
  static Future<Font> biryaniRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/biryani/v6/hv-WlzNxIFoO84YdTUwZPTh5T-s.ttf',
      'Biryani-Regular',
    );
    return font.getFont();
  }

  /// Biryani 600
  static Future<Font> biryaniSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/biryani/v6/hv-TlzNxIFoO84YddZQ3GTBSU-J-RxQ.ttf',
      'Biryani-SemiBold',
    );
    return font.getFont();
  }

  /// Biryani 700
  static Future<Font> biryaniBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/biryani/v6/hv-TlzNxIFoO84YddfA2GTBSU-J-RxQ.ttf',
      'Biryani-Bold',
    );
    return font.getFont();
  }

  /// Biryani 800
  static Future<Font> biryaniExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/biryani/v6/hv-TlzNxIFoO84Yddew1GTBSU-J-RxQ.ttf',
      'Biryani-ExtraBold',
    );
    return font.getFont();
  }

  /// Biryani 900
  static Future<Font> biryaniBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/biryani/v6/hv-TlzNxIFoO84Yddcg0GTBSU-J-RxQ.ttf',
      'Biryani-Black',
    );
    return font.getFont();
  }

  /// Bitter 100
  static Future<Font> bitterThin() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bitter/v17/raxhHiqOu8IVPmnRc6SY1KXhnF_Y8fbeCL_EXFh2reU.ttf',
      'Bitter-Thin',
    );
    return font.getFont();
  }

  /// Bitter 200
  static Future<Font> bitterExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bitter/v17/raxhHiqOu8IVPmnRc6SY1KXhnF_Y8XbfCL_EXFh2reU.ttf',
      'Bitter-ExtraLight',
    );
    return font.getFont();
  }

  /// Bitter 300
  static Future<Font> bitterLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bitter/v17/raxhHiqOu8IVPmnRc6SY1KXhnF_Y8ajfCL_EXFh2reU.ttf',
      'Bitter-Light',
    );
    return font.getFont();
  }

  /// Bitter regular
  static Future<Font> bitterRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bitter/v17/raxhHiqOu8IVPmnRc6SY1KXhnF_Y8fbfCL_EXFh2reU.ttf',
      'Bitter-Regular',
    );
    return font.getFont();
  }

  /// Bitter 500
  static Future<Font> bitterMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bitter/v17/raxhHiqOu8IVPmnRc6SY1KXhnF_Y8cTfCL_EXFh2reU.ttf',
      'Bitter-Medium',
    );
    return font.getFont();
  }

  /// Bitter 600
  static Future<Font> bitterSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bitter/v17/raxhHiqOu8IVPmnRc6SY1KXhnF_Y8SjYCL_EXFh2reU.ttf',
      'Bitter-SemiBold',
    );
    return font.getFont();
  }

  /// Bitter 700
  static Future<Font> bitterBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bitter/v17/raxhHiqOu8IVPmnRc6SY1KXhnF_Y8RHYCL_EXFh2reU.ttf',
      'Bitter-Bold',
    );
    return font.getFont();
  }

  /// Bitter 800
  static Future<Font> bitterExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bitter/v17/raxhHiqOu8IVPmnRc6SY1KXhnF_Y8XbYCL_EXFh2reU.ttf',
      'Bitter-ExtraBold',
    );
    return font.getFont();
  }

  /// Bitter 900
  static Future<Font> bitterBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bitter/v17/raxhHiqOu8IVPmnRc6SY1KXhnF_Y8V_YCL_EXFh2reU.ttf',
      'Bitter-Black',
    );
    return font.getFont();
  }

  /// Bitter 100italic
  static Future<Font> bitterThinItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bitter/v17/raxjHiqOu8IVPmn7epZnDMyKBvHf5D6c4P3OWHpzveWxBw.ttf',
      'Bitter-ThinItalic',
    );
    return font.getFont();
  }

  /// Bitter 200italic
  static Future<Font> bitterExtraLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bitter/v17/raxjHiqOu8IVPmn7epZnDMyKBvHf5D6cYPzOWHpzveWxBw.ttf',
      'Bitter-ExtraLightItalic',
    );
    return font.getFont();
  }

  /// Bitter 300italic
  static Future<Font> bitterLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bitter/v17/raxjHiqOu8IVPmn7epZnDMyKBvHf5D6cvvzOWHpzveWxBw.ttf',
      'Bitter-LightItalic',
    );
    return font.getFont();
  }

  /// Bitter italic
  static Future<Font> bitterItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bitter/v17/raxjHiqOu8IVPmn7epZnDMyKBvHf5D6c4PzOWHpzveWxBw.ttf',
      'Bitter-Italic',
    );
    return font.getFont();
  }

  /// Bitter 500italic
  static Future<Font> bitterMediumItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bitter/v17/raxjHiqOu8IVPmn7epZnDMyKBvHf5D6c0vzOWHpzveWxBw.ttf',
      'Bitter-MediumItalic',
    );
    return font.getFont();
  }

  /// Bitter 600italic
  static Future<Font> bitterSemiBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bitter/v17/raxjHiqOu8IVPmn7epZnDMyKBvHf5D6cPvvOWHpzveWxBw.ttf',
      'Bitter-SemiBoldItalic',
    );
    return font.getFont();
  }

  /// Bitter 700italic
  static Future<Font> bitterBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bitter/v17/raxjHiqOu8IVPmn7epZnDMyKBvHf5D6cB_vOWHpzveWxBw.ttf',
      'Bitter-BoldItalic',
    );
    return font.getFont();
  }

  /// Bitter 800italic
  static Future<Font> bitterExtraBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bitter/v17/raxjHiqOu8IVPmn7epZnDMyKBvHf5D6cYPvOWHpzveWxBw.ttf',
      'Bitter-ExtraBoldItalic',
    );
    return font.getFont();
  }

  /// Bitter 900italic
  static Future<Font> bitterBlackItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bitter/v17/raxjHiqOu8IVPmn7epZnDMyKBvHf5D6cSfvOWHpzveWxBw.ttf',
      'Bitter-BlackItalic',
    );
    return font.getFont();
  }

  /// Black And White Picture regular
  static Future<Font> blackAndWhitePictureRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/blackandwhitepicture/v10/TwMe-JAERlQd3ooUHBUXGmrmioKjjnRSFO-NqI5HbcMi-yWY.ttf',
      'BlackAndWhitePicture-Regular',
    );
    return font.getFont();
  }

  /// Black Han Sans regular
  static Future<Font> blackHanSansRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/blackhansans/v8/ea8Aad44WunzF9a-dL6toA8r8nqVIXSkH-Hc.ttf',
      'BlackHanSans-Regular',
    );
    return font.getFont();
  }

  /// Black Ops One regular
  static Future<Font> blackOpsOneRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/blackopsone/v12/qWcsB6-ypo7xBdr6Xshe96H3WDzRtjkho4M.ttf',
      'BlackOpsOne-Regular',
    );
    return font.getFont();
  }

  /// Blinker 100
  static Future<Font> blinkerThin() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/blinker/v4/cIf_MaFatEE-VTaP_E2hZEsCkIt9QQ.ttf',
      'Blinker-Thin',
    );
    return font.getFont();
  }

  /// Blinker 200
  static Future<Font> blinkerExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/blinker/v4/cIf4MaFatEE-VTaP_OGARGEsnIJkWL4.ttf',
      'Blinker-ExtraLight',
    );
    return font.getFont();
  }

  /// Blinker 300
  static Future<Font> blinkerLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/blinker/v4/cIf4MaFatEE-VTaP_IWDRGEsnIJkWL4.ttf',
      'Blinker-Light',
    );
    return font.getFont();
  }

  /// Blinker regular
  static Future<Font> blinkerRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/blinker/v4/cIf9MaFatEE-VTaPxCmrYGkHgIs.ttf',
      'Blinker-Regular',
    );
    return font.getFont();
  }

  /// Blinker 600
  static Future<Font> blinkerSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/blinker/v4/cIf4MaFatEE-VTaP_PGFRGEsnIJkWL4.ttf',
      'Blinker-SemiBold',
    );
    return font.getFont();
  }

  /// Blinker 700
  static Future<Font> blinkerBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/blinker/v4/cIf4MaFatEE-VTaP_JWERGEsnIJkWL4.ttf',
      'Blinker-Bold',
    );
    return font.getFont();
  }

  /// Blinker 800
  static Future<Font> blinkerExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/blinker/v4/cIf4MaFatEE-VTaP_ImHRGEsnIJkWL4.ttf',
      'Blinker-ExtraBold',
    );
    return font.getFont();
  }

  /// Blinker 900
  static Future<Font> blinkerBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/blinker/v4/cIf4MaFatEE-VTaP_K2GRGEsnIJkWL4.ttf',
      'Blinker-Black',
    );
    return font.getFont();
  }

  /// Bodoni Moda regular
  static Future<Font> bodoniModaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bodonimoda/v7/aFT67PxzY382XsXX63LUYL6GYFcan6NJrKp-VPjfJMShrpsGFUt8oU7awIBytVjMYwE.ttf',
      'BodoniModa-Regular',
    );
    return font.getFont();
  }

  /// Bodoni Moda 500
  static Future<Font> bodoniModaMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bodonimoda/v7/aFT67PxzY382XsXX63LUYL6GYFcan6NJrKp-VPjfJMShrpsGFUt8oXzawIBytVjMYwE.ttf',
      'BodoniModa-Medium',
    );
    return font.getFont();
  }

  /// Bodoni Moda 600
  static Future<Font> bodoniModaSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bodonimoda/v7/aFT67PxzY382XsXX63LUYL6GYFcan6NJrKp-VPjfJMShrpsGFUt8oZDdwIBytVjMYwE.ttf',
      'BodoniModa-SemiBold',
    );
    return font.getFont();
  }

  /// Bodoni Moda 700
  static Future<Font> bodoniModaBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bodonimoda/v7/aFT67PxzY382XsXX63LUYL6GYFcan6NJrKp-VPjfJMShrpsGFUt8oandwIBytVjMYwE.ttf',
      'BodoniModa-Bold',
    );
    return font.getFont();
  }

  /// Bodoni Moda 800
  static Future<Font> bodoniModaExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bodonimoda/v7/aFT67PxzY382XsXX63LUYL6GYFcan6NJrKp-VPjfJMShrpsGFUt8oc7dwIBytVjMYwE.ttf',
      'BodoniModa-ExtraBold',
    );
    return font.getFont();
  }

  /// Bodoni Moda 900
  static Future<Font> bodoniModaBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bodonimoda/v7/aFT67PxzY382XsXX63LUYL6GYFcan6NJrKp-VPjfJMShrpsGFUt8oefdwIBytVjMYwE.ttf',
      'BodoniModa-Black',
    );
    return font.getFont();
  }

  /// Bodoni Moda italic
  static Future<Font> bodoniModaItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bodonimoda/v7/aFT07PxzY382XsXX63LUYJSPUqb0pL6OQqxrZLnVbvZedvJtj-V7tIaZKMN4sXrJcwHqoQ.ttf',
      'BodoniModa-Italic',
    );
    return font.getFont();
  }

  /// Bodoni Moda 500italic
  static Future<Font> bodoniModaMediumItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bodonimoda/v7/aFT07PxzY382XsXX63LUYJSPUqb0pL6OQqxrZLnVbvZedvJtj-V7tIaZGsN4sXrJcwHqoQ.ttf',
      'BodoniModa-MediumItalic',
    );
    return font.getFont();
  }

  /// Bodoni Moda 600italic
  static Future<Font> bodoniModaSemiBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bodonimoda/v7/aFT07PxzY382XsXX63LUYJSPUqb0pL6OQqxrZLnVbvZedvJtj-V7tIaZ9sR4sXrJcwHqoQ.ttf',
      'BodoniModa-SemiBoldItalic',
    );
    return font.getFont();
  }

  /// Bodoni Moda 700italic
  static Future<Font> bodoniModaBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bodonimoda/v7/aFT07PxzY382XsXX63LUYJSPUqb0pL6OQqxrZLnVbvZedvJtj-V7tIaZz8R4sXrJcwHqoQ.ttf',
      'BodoniModa-BoldItalic',
    );
    return font.getFont();
  }

  /// Bodoni Moda 800italic
  static Future<Font> bodoniModaExtraBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bodonimoda/v7/aFT07PxzY382XsXX63LUYJSPUqb0pL6OQqxrZLnVbvZedvJtj-V7tIaZqMR4sXrJcwHqoQ.ttf',
      'BodoniModa-ExtraBoldItalic',
    );
    return font.getFont();
  }

  /// Bodoni Moda 900italic
  static Future<Font> bodoniModaBlackItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bodonimoda/v7/aFT07PxzY382XsXX63LUYJSPUqb0pL6OQqxrZLnVbvZedvJtj-V7tIaZgcR4sXrJcwHqoQ.ttf',
      'BodoniModa-BlackItalic',
    );
    return font.getFont();
  }

  /// Bokor regular
  static Future<Font> bokorRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bokor/v15/m8JcjfpeeaqTiR2WdInbcaxE.ttf',
      'Bokor-Regular',
    );
    return font.getFont();
  }

  /// Bonbon regular
  static Future<Font> bonbonRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bonbon/v14/0FlVVPeVlFec4ee_cDEAbQY5-A.ttf',
      'Bonbon-Regular',
    );
    return font.getFont();
  }

  /// Boogaloo regular
  static Future<Font> boogalooRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/boogaloo/v12/kmK-Zq45GAvOdnaW6x1F_SrQo_1K.ttf',
      'Boogaloo-Regular',
    );
    return font.getFont();
  }

  /// Bowlby One regular
  static Future<Font> bowlbyOneRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bowlbyone/v12/taiPGmVuC4y96PFeqp8smo6C_Z0wcK4.ttf',
      'BowlbyOne-Regular',
    );
    return font.getFont();
  }

  /// Bowlby One SC regular
  static Future<Font> bowlbyOneSCRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bowlbyonesc/v12/DtVlJxerQqQm37tzN3wMug9Pzgj8owhNjuE.ttf',
      'BowlbyOneSC-Regular',
    );
    return font.getFont();
  }

  /// Brawler regular
  static Future<Font> brawlerRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/brawler/v11/xn7gYHE3xXewAscGsgC7S9XdZN8.ttf',
      'Brawler-Regular',
    );
    return font.getFont();
  }

  /// Bree Serif regular
  static Future<Font> breeSerifRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/breeserif/v10/4UaHrEJCrhhnVA3DgluAx63j5pN1MwI.ttf',
      'BreeSerif-Regular',
    );
    return font.getFont();
  }

  /// Brygada 1918 regular
  static Future<Font> brygada1918Regular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/brygada1918/v3/pe08MI6eKpdGqlF5LANrM--ACNaeo8mTUIR_y2-f-V8Wu5O3gbo.ttf',
      'Brygada1918-Regular',
    );
    return font.getFont();
  }

  /// Brygada 1918 500
  static Future<Font> brygada1918Medium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/brygada1918/v3/pe08MI6eKpdGqlF5LANrM--ACNaeo8mTUIR_y12f-V8Wu5O3gbo.ttf',
      'Brygada1918-Medium',
    );
    return font.getFont();
  }

  /// Brygada 1918 600
  static Future<Font> brygada1918SemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/brygada1918/v3/pe08MI6eKpdGqlF5LANrM--ACNaeo8mTUIR_y7GY-V8Wu5O3gbo.ttf',
      'Brygada1918-SemiBold',
    );
    return font.getFont();
  }

  /// Brygada 1918 700
  static Future<Font> brygada1918Bold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/brygada1918/v3/pe08MI6eKpdGqlF5LANrM--ACNaeo8mTUIR_y4iY-V8Wu5O3gbo.ttf',
      'Brygada1918-Bold',
    );
    return font.getFont();
  }

  /// Brygada 1918 italic
  static Future<Font> brygada1918Italic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/brygada1918/v3/pe06MI6eKpdGqlF5LANrM--qAeRhe6D4yip43qfcERwcv7GykboaLg.ttf',
      'Brygada1918-Italic',
    );
    return font.getFont();
  }

  /// Brygada 1918 500italic
  static Future<Font> brygada1918MediumItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/brygada1918/v3/pe06MI6eKpdGqlF5LANrM--qAeRhe6D4yip43qfcIxwcv7GykboaLg.ttf',
      'Brygada1918-MediumItalic',
    );
    return font.getFont();
  }

  /// Brygada 1918 600italic
  static Future<Font> brygada1918SemiBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/brygada1918/v3/pe06MI6eKpdGqlF5LANrM--qAeRhe6D4yip43qfczxscv7GykboaLg.ttf',
      'Brygada1918-SemiBoldItalic',
    );
    return font.getFont();
  }

  /// Brygada 1918 700italic
  static Future<Font> brygada1918BoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/brygada1918/v3/pe06MI6eKpdGqlF5LANrM--qAeRhe6D4yip43qfc9hscv7GykboaLg.ttf',
      'Brygada1918-BoldItalic',
    );
    return font.getFont();
  }

  /// Bubblegum Sans regular
  static Future<Font> bubblegumSansRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bubblegumsans/v9/AYCSpXb_Z9EORv1M5QTjEzMEtdaHzoPPb7R4.ttf',
      'BubblegumSans-Regular',
    );
    return font.getFont();
  }

  /// Bubbler One regular
  static Future<Font> bubblerOneRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bubblerone/v11/f0Xy0eqj68ppQV9KBLmAouHH26MPePkt.ttf',
      'BubblerOne-Regular',
    );
    return font.getFont();
  }

  /// Buda 300
  static Future<Font> budaLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/buda/v13/GFDqWAN8mnyIJSSrG7UBr7pZKA0.ttf',
      'Buda-Light',
    );
    return font.getFont();
  }

  /// Buenard regular
  static Future<Font> buenardRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/buenard/v12/OD5DuM6Cyma8FnnsPzf9qGi9HL4.ttf',
      'Buenard-Regular',
    );
    return font.getFont();
  }

  /// Buenard 700
  static Future<Font> buenardBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/buenard/v12/OD5GuM6Cyma8FnnsB4vSjGCWALepwss.ttf',
      'Buenard-Bold',
    );
    return font.getFont();
  }

  /// Bungee regular
  static Future<Font> bungeeRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bungee/v6/N0bU2SZBIuF2PU_ECn50Kd_PmA.ttf',
      'Bungee-Regular',
    );
    return font.getFont();
  }

  /// Bungee Hairline regular
  static Future<Font> bungeeHairlineRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bungeehairline/v8/snfys0G548t04270a_ljTLUVrv-7YB2dQ5ZPqQ.ttf',
      'BungeeHairline-Regular',
    );
    return font.getFont();
  }

  /// Bungee Inline regular
  static Future<Font> bungeeInlineRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bungeeinline/v6/Gg8zN58UcgnlCweMrih332VuDGJ1-FEglsc.ttf',
      'BungeeInline-Regular',
    );
    return font.getFont();
  }

  /// Bungee Outline regular
  static Future<Font> bungeeOutlineRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bungeeoutline/v8/_6_mEDvmVP24UvU2MyiGDslL3Qg3YhJqPXxo.ttf',
      'BungeeOutline-Regular',
    );
    return font.getFont();
  }

  /// Bungee Shade regular
  static Future<Font> bungeeShadeRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/bungeeshade/v6/DtVkJxarWL0t2KdzK3oI_jks7iLSrwFUlw.ttf',
      'BungeeShade-Regular',
    );
    return font.getFont();
  }

  /// Butcherman regular
  static Future<Font> butchermanRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/butcherman/v14/2EbiL-thF0loflXUBOdb1zWzq_5uT84.ttf',
      'Butcherman-Regular',
    );
    return font.getFont();
  }

  /// Butterfly Kids regular
  static Future<Font> butterflyKidsRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/butterflykids/v11/ll8lK2CWTjuqAsXDqlnIbMNs5S4arxFrAX1D.ttf',
      'ButterflyKids-Regular',
    );
    return font.getFont();
  }

  /// Cabin regular
  static Future<Font> cabinRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cabin/v18/u-4X0qWljRw-PfU81xCKCpdpbgZJl6XFpfEd7eA9BIxxkV2EL7Gvxm7rE_s.ttf',
      'Cabin-Regular',
    );
    return font.getFont();
  }

  /// Cabin 500
  static Future<Font> cabinMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cabin/v18/u-4X0qWljRw-PfU81xCKCpdpbgZJl6XFpfEd7eA9BIxxkW-EL7Gvxm7rE_s.ttf',
      'Cabin-Medium',
    );
    return font.getFont();
  }

  /// Cabin 600
  static Future<Font> cabinSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cabin/v18/u-4X0qWljRw-PfU81xCKCpdpbgZJl6XFpfEd7eA9BIxxkYODL7Gvxm7rE_s.ttf',
      'Cabin-SemiBold',
    );
    return font.getFont();
  }

  /// Cabin 700
  static Future<Font> cabinBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cabin/v18/u-4X0qWljRw-PfU81xCKCpdpbgZJl6XFpfEd7eA9BIxxkbqDL7Gvxm7rE_s.ttf',
      'Cabin-Bold',
    );
    return font.getFont();
  }

  /// Cabin italic
  static Future<Font> cabinItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cabin/v18/u-4V0qWljRw-Pd815fNqc8T_wAFcX-c37MPiNYlWniJ2hJXHx_KlwkzuA_u1Bg.ttf',
      'Cabin-Italic',
    );
    return font.getFont();
  }

  /// Cabin 500italic
  static Future<Font> cabinMediumItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cabin/v18/u-4V0qWljRw-Pd815fNqc8T_wAFcX-c37MPiNYlWniJ2hJXH9fKlwkzuA_u1Bg.ttf',
      'Cabin-MediumItalic',
    );
    return font.getFont();
  }

  /// Cabin 600italic
  static Future<Font> cabinSemiBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cabin/v18/u-4V0qWljRw-Pd815fNqc8T_wAFcX-c37MPiNYlWniJ2hJXHGfWlwkzuA_u1Bg.ttf',
      'Cabin-SemiBoldItalic',
    );
    return font.getFont();
  }

  /// Cabin 700italic
  static Future<Font> cabinBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cabin/v18/u-4V0qWljRw-Pd815fNqc8T_wAFcX-c37MPiNYlWniJ2hJXHIPWlwkzuA_u1Bg.ttf',
      'Cabin-BoldItalic',
    );
    return font.getFont();
  }

  /// Cabin Condensed regular
  static Future<Font> cabinCondensedRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cabincondensed/v14/nwpMtK6mNhBK2err_hqkYhHRqmwaYOjZ5HZl8Q.ttf',
      'CabinCondensed-Regular',
    );
    return font.getFont();
  }

  /// Cabin Condensed 500
  static Future<Font> cabinCondensedMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cabincondensed/v14/nwpJtK6mNhBK2err_hqkYhHRqmwilMH97F15-K1oqQ.ttf',
      'CabinCondensed-Medium',
    );
    return font.getFont();
  }

  /// Cabin Condensed 600
  static Future<Font> cabinCondensedSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cabincondensed/v14/nwpJtK6mNhBK2err_hqkYhHRqmwiuMb97F15-K1oqQ.ttf',
      'CabinCondensed-SemiBold',
    );
    return font.getFont();
  }

  /// Cabin Condensed 700
  static Future<Font> cabinCondensedBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cabincondensed/v14/nwpJtK6mNhBK2err_hqkYhHRqmwi3Mf97F15-K1oqQ.ttf',
      'CabinCondensed-Bold',
    );
    return font.getFont();
  }

  /// Cabin Sketch regular
  static Future<Font> cabinSketchRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cabinsketch/v14/QGYpz_kZZAGCONcK2A4bGOjMn9JM6fnuKg.ttf',
      'CabinSketch-Regular',
    );
    return font.getFont();
  }

  /// Cabin Sketch 700
  static Future<Font> cabinSketchBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cabinsketch/v14/QGY2z_kZZAGCONcK2A4bGOj0I_1o4dLyI4CMFw.ttf',
      'CabinSketch-Bold',
    );
    return font.getFont();
  }

  /// Caesar Dressing regular
  static Future<Font> caesarDressingRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/caesardressing/v11/yYLx0hLa3vawqtwdswbotmK4vrR3cbb6LZttyg.ttf',
      'CaesarDressing-Regular',
    );
    return font.getFont();
  }

  /// Cagliostro regular
  static Future<Font> cagliostroRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cagliostro/v11/ZgNWjP5HM73BV5amnX-TjGXEM4COoE4.ttf',
      'Cagliostro-Regular',
    );
    return font.getFont();
  }

  /// Cairo 200
  static Future<Font> cairoExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cairo/v10/SLXLc1nY6Hkvalrub76M7dd8aGZk.ttf',
      'Cairo-ExtraLight',
    );
    return font.getFont();
  }

  /// Cairo 300
  static Future<Font> cairoLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cairo/v10/SLXLc1nY6HkvalqKbL6M7dd8aGZk.ttf',
      'Cairo-Light',
    );
    return font.getFont();
  }

  /// Cairo regular
  static Future<Font> cairoRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cairo/v10/SLXGc1nY6HkvamImRJqExst1.ttf',
      'Cairo-Regular',
    );
    return font.getFont();
  }

  /// Cairo 600
  static Future<Font> cairoSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cairo/v10/SLXLc1nY6Hkvalr-ar6M7dd8aGZk.ttf',
      'Cairo-SemiBold',
    );
    return font.getFont();
  }

  /// Cairo 700
  static Future<Font> cairoBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cairo/v10/SLXLc1nY6Hkvalqaa76M7dd8aGZk.ttf',
      'Cairo-Bold',
    );
    return font.getFont();
  }

  /// Cairo 900
  static Future<Font> cairoBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cairo/v10/SLXLc1nY6Hkvalqiab6M7dd8aGZk.ttf',
      'Cairo-Black',
    );
    return font.getFont();
  }

  /// Caladea regular
  static Future<Font> caladeaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/caladea/v2/kJEzBugZ7AAjhybUjR93-9IztOc.ttf',
      'Caladea-Regular',
    );
    return font.getFont();
  }

  /// Caladea italic
  static Future<Font> caladeaItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/caladea/v2/kJExBugZ7AAjhybUvR19__A2pOdvDA.ttf',
      'Caladea-Italic',
    );
    return font.getFont();
  }

  /// Caladea 700
  static Future<Font> caladeaBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/caladea/v2/kJE2BugZ7AAjhybUtaNY39oYqO52FZ0.ttf',
      'Caladea-Bold',
    );
    return font.getFont();
  }

  /// Caladea 700italic
  static Future<Font> caladeaBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/caladea/v2/kJE0BugZ7AAjhybUvR1FQ98SrMxzBZ2lDA.ttf',
      'Caladea-BoldItalic',
    );
    return font.getFont();
  }

  /// Calistoga regular
  static Future<Font> calistogaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/calistoga/v5/6NUU8F2OJg6MeR7l4e0vtMYAwdRZfw.ttf',
      'Calistoga-Regular',
    );
    return font.getFont();
  }

  /// Calligraffitti regular
  static Future<Font> calligraffittiRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/calligraffitti/v12/46k2lbT3XjDVqJw3DCmCFjE0vnFZM5ZBpYN-.ttf',
      'Calligraffitti-Regular',
    );
    return font.getFont();
  }

  /// Cambay regular
  static Future<Font> cambayRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cambay/v7/SLXJc1rY6H0_ZDsGbrSIz9JsaA.ttf',
      'Cambay-Regular',
    );
    return font.getFont();
  }

  /// Cambay italic
  static Future<Font> cambayItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cambay/v7/SLXLc1rY6H0_ZDs2bL6M7dd8aGZk.ttf',
      'Cambay-Italic',
    );
    return font.getFont();
  }

  /// Cambay 700
  static Future<Font> cambayBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cambay/v7/SLXKc1rY6H0_ZDs-0pusx_lwYX99kA.ttf',
      'Cambay-Bold',
    );
    return font.getFont();
  }

  /// Cambay 700italic
  static Future<Font> cambayBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cambay/v7/SLXMc1rY6H0_ZDs2bIYwwvN0Q3ptkDMN.ttf',
      'Cambay-BoldItalic',
    );
    return font.getFont();
  }

  /// Cambo regular
  static Future<Font> camboRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cambo/v9/IFSqHeNEk8FJk416ok7xkPm8.ttf',
      'Cambo-Regular',
    );
    return font.getFont();
  }

  /// Candal regular
  static Future<Font> candalRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/candal/v10/XoHn2YH6T7-t_8cNAR4Jt9Yxlw.ttf',
      'Candal-Regular',
    );
    return font.getFont();
  }

  /// Cantarell regular
  static Future<Font> cantarellRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cantarell/v10/B50NF7ZDq37KMUvlO01Ji6hqHK-CLA.ttf',
      'Cantarell-Regular',
    );
    return font.getFont();
  }

  /// Cantarell italic
  static Future<Font> cantarellItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cantarell/v10/B50LF7ZDq37KMUvlO015iaJuPqqSLJYf.ttf',
      'Cantarell-Italic',
    );
    return font.getFont();
  }

  /// Cantarell 700
  static Future<Font> cantarellBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cantarell/v10/B50IF7ZDq37KMUvlO01xN4dOFISeJY8GgQ.ttf',
      'Cantarell-Bold',
    );
    return font.getFont();
  }

  /// Cantarell 700italic
  static Future<Font> cantarellBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cantarell/v10/B50WF7ZDq37KMUvlO015iZrSEY6aB4oWgWHB.ttf',
      'Cantarell-BoldItalic',
    );
    return font.getFont();
  }

  /// Cantata One regular
  static Future<Font> cantataOneRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cantataone/v10/PlI5Fl60Nb5obNzNe2jslVxEt8CwfGaD.ttf',
      'CantataOne-Regular',
    );
    return font.getFont();
  }

  /// Cantora One regular
  static Future<Font> cantoraOneRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cantoraone/v12/gyB4hws1JdgnKy56GB_JX6zdZ4vZVbgZ.ttf',
      'CantoraOne-Regular',
    );
    return font.getFont();
  }

  /// Capriola regular
  static Future<Font> capriolaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/capriola/v8/wXKoE3YSppcvo1PDln_8L-AinG8y.ttf',
      'Capriola-Regular',
    );
    return font.getFont();
  }

  /// Cardo regular
  static Future<Font> cardoRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cardo/v14/wlp_gwjKBV1pqiv_1oAZ2H5O.ttf',
      'Cardo-Regular',
    );
    return font.getFont();
  }

  /// Cardo italic
  static Future<Font> cardoItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cardo/v14/wlpxgwjKBV1pqhv93IQ73W5OcCk.ttf',
      'Cardo-Italic',
    );
    return font.getFont();
  }

  /// Cardo 700
  static Future<Font> cardoBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cardo/v14/wlpygwjKBV1pqhND-aQR82JHaTBX.ttf',
      'Cardo-Bold',
    );
    return font.getFont();
  }

  /// Carme regular
  static Future<Font> carmeRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/carme/v11/ptRHTiWdbvZIDOjGxLNrxfbZ.ttf',
      'Carme-Regular',
    );
    return font.getFont();
  }

  /// Carrois Gothic regular
  static Future<Font> carroisGothicRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/carroisgothic/v11/Z9XPDmFATg-N1PLtLOOxvIHl9ZmD3i7ajcJ-.ttf',
      'CarroisGothic-Regular',
    );
    return font.getFont();
  }

  /// Carrois Gothic SC regular
  static Future<Font> carroisGothicSCRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/carroisgothicsc/v10/ZgNJjOVHM6jfUZCmyUqT2A2HVKjc-28nNHabY4dN.ttf',
      'CarroisGothicSC-Regular',
    );
    return font.getFont();
  }

  /// Carter One regular
  static Future<Font> carterOneRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/carterone/v12/q5uCsoe5IOB2-pXv9UcNIxR2hYxREMs.ttf',
      'CarterOne-Regular',
    );
    return font.getFont();
  }

  /// Castoro regular
  static Future<Font> castoroRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/castoro/v8/1q2GY5yMCld3-O4cHYhEzOYenEU.ttf',
      'Castoro-Regular',
    );
    return font.getFont();
  }

  /// Castoro italic
  static Future<Font> castoroItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/castoro/v8/1q2EY5yMCld3-O4cLYpOyMQbjEX5fw.ttf',
      'Castoro-Italic',
    );
    return font.getFont();
  }

  /// Catamaran 100
  static Future<Font> catamaranThin() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/catamaran/v8/o-0bIpQoyXQa2RxT7-5B6Ryxs2E_6n1iPHjc1anXuluiLyw.ttf',
      'Catamaran-Thin',
    );
    return font.getFont();
  }

  /// Catamaran 200
  static Future<Font> catamaranExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/catamaran/v8/o-0bIpQoyXQa2RxT7-5B6Ryxs2E_6n1iPPjd1anXuluiLyw.ttf',
      'Catamaran-ExtraLight',
    );
    return font.getFont();
  }

  /// Catamaran 300
  static Future<Font> catamaranLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/catamaran/v8/o-0bIpQoyXQa2RxT7-5B6Ryxs2E_6n1iPCbd1anXuluiLyw.ttf',
      'Catamaran-Light',
    );
    return font.getFont();
  }

  /// Catamaran regular
  static Future<Font> catamaranRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/catamaran/v8/o-0bIpQoyXQa2RxT7-5B6Ryxs2E_6n1iPHjd1anXuluiLyw.ttf',
      'Catamaran-Regular',
    );
    return font.getFont();
  }

  /// Catamaran 500
  static Future<Font> catamaranMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/catamaran/v8/o-0bIpQoyXQa2RxT7-5B6Ryxs2E_6n1iPErd1anXuluiLyw.ttf',
      'Catamaran-Medium',
    );
    return font.getFont();
  }

  /// Catamaran 600
  static Future<Font> catamaranSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/catamaran/v8/o-0bIpQoyXQa2RxT7-5B6Ryxs2E_6n1iPKba1anXuluiLyw.ttf',
      'Catamaran-SemiBold',
    );
    return font.getFont();
  }

  /// Catamaran 700
  static Future<Font> catamaranBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/catamaran/v8/o-0bIpQoyXQa2RxT7-5B6Ryxs2E_6n1iPJ_a1anXuluiLyw.ttf',
      'Catamaran-Bold',
    );
    return font.getFont();
  }

  /// Catamaran 800
  static Future<Font> catamaranExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/catamaran/v8/o-0bIpQoyXQa2RxT7-5B6Ryxs2E_6n1iPPja1anXuluiLyw.ttf',
      'Catamaran-ExtraBold',
    );
    return font.getFont();
  }

  /// Catamaran 900
  static Future<Font> catamaranBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/catamaran/v8/o-0bIpQoyXQa2RxT7-5B6Ryxs2E_6n1iPNHa1anXuluiLyw.ttf',
      'Catamaran-Black',
    );
    return font.getFont();
  }

  /// Caudex regular
  static Future<Font> caudexRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/caudex/v10/esDQ311QOP6BJUrIyviAnb4eEw.ttf',
      'Caudex-Regular',
    );
    return font.getFont();
  }

  /// Caudex italic
  static Future<Font> caudexItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/caudex/v10/esDS311QOP6BJUr4yPKEv7sOE4in.ttf',
      'Caudex-Italic',
    );
    return font.getFont();
  }

  /// Caudex 700
  static Future<Font> caudexBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/caudex/v10/esDT311QOP6BJUrwdteklZUCGpG-GQ.ttf',
      'Caudex-Bold',
    );
    return font.getFont();
  }

  /// Caudex 700italic
  static Future<Font> caudexBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/caudex/v10/esDV311QOP6BJUr4yMo4kJ8GOJSuGdLB.ttf',
      'Caudex-BoldItalic',
    );
    return font.getFont();
  }

  /// Caveat regular
  static Future<Font> caveatRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/caveat/v10/WnznHAc5bAfYB2QRah7pcpNvOx-pjfJ9SIKjYBxPigs.ttf',
      'Caveat-Regular',
    );
    return font.getFont();
  }

  /// Caveat 500
  static Future<Font> caveatMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/caveat/v10/WnznHAc5bAfYB2QRah7pcpNvOx-pjcB9SIKjYBxPigs.ttf',
      'Caveat-Medium',
    );
    return font.getFont();
  }

  /// Caveat 600
  static Future<Font> caveatSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/caveat/v10/WnznHAc5bAfYB2QRah7pcpNvOx-pjSx6SIKjYBxPigs.ttf',
      'Caveat-SemiBold',
    );
    return font.getFont();
  }

  /// Caveat 700
  static Future<Font> caveatBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/caveat/v10/WnznHAc5bAfYB2QRah7pcpNvOx-pjRV6SIKjYBxPigs.ttf',
      'Caveat-Bold',
    );
    return font.getFont();
  }

  /// Caveat Brush regular
  static Future<Font> caveatBrushRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/caveatbrush/v6/EYq0maZfwr9S9-ETZc3fKXtMW7mT03pdQw.ttf',
      'CaveatBrush-Regular',
    );
    return font.getFont();
  }

  /// Cedarville Cursive regular
  static Future<Font> cedarvilleCursiveRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cedarvillecursive/v12/yYL00g_a2veiudhUmxjo5VKkoqA-B_neJbBxw8BeTg.ttf',
      'CedarvilleCursive-Regular',
    );
    return font.getFont();
  }

  /// Ceviche One regular
  static Future<Font> cevicheOneRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cevicheone/v11/gyB4hws1IcA6JzR-GB_JX6zdZ4vZVbgZ.ttf',
      'CevicheOne-Regular',
    );
    return font.getFont();
  }

  /// Chakra Petch 300
  static Future<Font> chakraPetchLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/chakrapetch/v4/cIflMapbsEk7TDLdtEz1BwkeNIhFQJXE3AY00g.ttf',
      'ChakraPetch-Light',
    );
    return font.getFont();
  }

  /// Chakra Petch 300italic
  static Future<Font> chakraPetchLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/chakrapetch/v4/cIfnMapbsEk7TDLdtEz1BwkWmpLJQp_A_gMk0izH.ttf',
      'ChakraPetch-LightItalic',
    );
    return font.getFont();
  }

  /// Chakra Petch regular
  static Future<Font> chakraPetchRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/chakrapetch/v4/cIf6MapbsEk7TDLdtEz1BwkmmKBhSL7Y1Q.ttf',
      'ChakraPetch-Regular',
    );
    return font.getFont();
  }

  /// Chakra Petch italic
  static Future<Font> chakraPetchItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/chakrapetch/v4/cIfkMapbsEk7TDLdtEz1BwkWmqplarvI1R8t.ttf',
      'ChakraPetch-Italic',
    );
    return font.getFont();
  }

  /// Chakra Petch 500
  static Future<Font> chakraPetchMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/chakrapetch/v4/cIflMapbsEk7TDLdtEz1BwkebIlFQJXE3AY00g.ttf',
      'ChakraPetch-Medium',
    );
    return font.getFont();
  }

  /// Chakra Petch 500italic
  static Future<Font> chakraPetchMediumItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/chakrapetch/v4/cIfnMapbsEk7TDLdtEz1BwkWmpKRQ5_A_gMk0izH.ttf',
      'ChakraPetch-MediumItalic',
    );
    return font.getFont();
  }

  /// Chakra Petch 600
  static Future<Font> chakraPetchSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/chakrapetch/v4/cIflMapbsEk7TDLdtEz1BwkeQI5FQJXE3AY00g.ttf',
      'ChakraPetch-SemiBold',
    );
    return font.getFont();
  }

  /// Chakra Petch 600italic
  static Future<Font> chakraPetchSemiBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/chakrapetch/v4/cIfnMapbsEk7TDLdtEz1BwkWmpK9RJ_A_gMk0izH.ttf',
      'ChakraPetch-SemiBoldItalic',
    );
    return font.getFont();
  }

  /// Chakra Petch 700
  static Future<Font> chakraPetchBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/chakrapetch/v4/cIflMapbsEk7TDLdtEz1BwkeJI9FQJXE3AY00g.ttf',
      'ChakraPetch-Bold',
    );
    return font.getFont();
  }

  /// Chakra Petch 700italic
  static Future<Font> chakraPetchBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/chakrapetch/v4/cIfnMapbsEk7TDLdtEz1BwkWmpLZRZ_A_gMk0izH.ttf',
      'ChakraPetch-BoldItalic',
    );
    return font.getFont();
  }

  /// Changa 200
  static Future<Font> changaExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/changa/v11/2-c79JNi2YuVOUcOarRPgnNGooxCZy2xQjDp9htf1ZM.ttf',
      'Changa-ExtraLight',
    );
    return font.getFont();
  }

  /// Changa 300
  static Future<Font> changaLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/changa/v11/2-c79JNi2YuVOUcOarRPgnNGooxCZ_OxQjDp9htf1ZM.ttf',
      'Changa-Light',
    );
    return font.getFont();
  }

  /// Changa regular
  static Future<Font> changaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/changa/v11/2-c79JNi2YuVOUcOarRPgnNGooxCZ62xQjDp9htf1ZM.ttf',
      'Changa-Regular',
    );
    return font.getFont();
  }

  /// Changa 500
  static Future<Font> changaMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/changa/v11/2-c79JNi2YuVOUcOarRPgnNGooxCZ5-xQjDp9htf1ZM.ttf',
      'Changa-Medium',
    );
    return font.getFont();
  }

  /// Changa 600
  static Future<Font> changaSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/changa/v11/2-c79JNi2YuVOUcOarRPgnNGooxCZ3O2QjDp9htf1ZM.ttf',
      'Changa-SemiBold',
    );
    return font.getFont();
  }

  /// Changa 700
  static Future<Font> changaBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/changa/v11/2-c79JNi2YuVOUcOarRPgnNGooxCZ0q2QjDp9htf1ZM.ttf',
      'Changa-Bold',
    );
    return font.getFont();
  }

  /// Changa 800
  static Future<Font> changaExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/changa/v11/2-c79JNi2YuVOUcOarRPgnNGooxCZy22QjDp9htf1ZM.ttf',
      'Changa-ExtraBold',
    );
    return font.getFont();
  }

  /// Changa One regular
  static Future<Font> changaOneRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/changaone/v13/xfu00W3wXn3QLUJXhzq46AbouLfbK64.ttf',
      'ChangaOne-Regular',
    );
    return font.getFont();
  }

  /// Changa One italic
  static Future<Font> changaOneItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/changaone/v13/xfu20W3wXn3QLUJXhzq42ATivJXeO67ISw.ttf',
      'ChangaOne-Italic',
    );
    return font.getFont();
  }

  /// Chango regular
  static Future<Font> changoRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/chango/v11/2V0cKI0OB5U7WaJyz324TFUaAw.ttf',
      'Chango-Regular',
    );
    return font.getFont();
  }

  /// Charm regular
  static Future<Font> charmRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/charm/v5/7cHmv4oii5K0MeYvIe804WIo.ttf',
      'Charm-Regular',
    );
    return font.getFont();
  }

  /// Charm 700
  static Future<Font> charmBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/charm/v5/7cHrv4oii5K0Md6TDss8yn4hnCci.ttf',
      'Charm-Bold',
    );
    return font.getFont();
  }

  /// Charmonman regular
  static Future<Font> charmonmanRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/charmonman/v8/MjQDmiR3vP_nuxDv47jiWJGovLdh6OE.ttf',
      'Charmonman-Regular',
    );
    return font.getFont();
  }

  /// Charmonman 700
  static Future<Font> charmonmanBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/charmonman/v8/MjQAmiR3vP_nuxDv47jiYC2HmL9K9OhmGnY.ttf',
      'Charmonman-Bold',
    );
    return font.getFont();
  }

  /// Chathura 100
  static Future<Font> chathuraThin() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/chathura/v10/_gP91R7-rzUuVjim42dEq0SbTvZyuDo.ttf',
      'Chathura-Thin',
    );
    return font.getFont();
  }

  /// Chathura 300
  static Future<Font> chathuraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/chathura/v10/_gP81R7-rzUuVjim42eMiWSxYPp7oSNy.ttf',
      'Chathura-Light',
    );
    return font.getFont();
  }

  /// Chathura regular
  static Future<Font> chathuraRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/chathura/v10/_gP71R7-rzUuVjim418goUC5S-Zy.ttf',
      'Chathura-Regular',
    );
    return font.getFont();
  }

  /// Chathura 700
  static Future<Font> chathuraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/chathura/v10/_gP81R7-rzUuVjim42ecjmSxYPp7oSNy.ttf',
      'Chathura-Bold',
    );
    return font.getFont();
  }

  /// Chathura 800
  static Future<Font> chathuraExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/chathura/v10/_gP81R7-rzUuVjim42eAjWSxYPp7oSNy.ttf',
      'Chathura-ExtraBold',
    );
    return font.getFont();
  }

  /// Chau Philomene One regular
  static Future<Font> chauPhilomeneOneRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/chauphilomeneone/v10/55xxezRsPtfie1vPY49qzdgSlJiHRQFsnIx7QMISdQ.ttf',
      'ChauPhilomeneOne-Regular',
    );
    return font.getFont();
  }

  /// Chau Philomene One italic
  static Future<Font> chauPhilomeneOneItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/chauphilomeneone/v10/55xzezRsPtfie1vPY49qzdgSlJiHRQFcnoZ_YscCdXQB.ttf',
      'ChauPhilomeneOne-Italic',
    );
    return font.getFont();
  }

  /// Chela One regular
  static Future<Font> chelaOneRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/chelaone/v11/6ae-4KC7Uqgdz_JZdPIy31vWNTMwoQ.ttf',
      'ChelaOne-Regular',
    );
    return font.getFont();
  }

  /// Chelsea Market regular
  static Future<Font> chelseaMarketRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/chelseamarket/v8/BCawqZsHqfr89WNP_IApC8tzKBhlLA4uKkWk.ttf',
      'ChelseaMarket-Regular',
    );
    return font.getFont();
  }

  /// Chenla regular
  static Future<Font> chenlaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/chenla/v15/SZc43FDpIKu8WZ9eXxfonUPL6Q.ttf',
      'Chenla-Regular',
    );
    return font.getFont();
  }

  /// Cherry Cream Soda regular
  static Future<Font> cherryCreamSodaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cherrycreamsoda/v13/UMBIrOxBrW6w2FFyi9paG0fdVdRciTd6Cd47DJ7G.ttf',
      'CherryCreamSoda-Regular',
    );
    return font.getFont();
  }

  /// Cherry Swash regular
  static Future<Font> cherrySwashRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cherryswash/v11/i7dNIFByZjaNAMxtZcnfAy58QHi-EwWMbg.ttf',
      'CherrySwash-Regular',
    );
    return font.getFont();
  }

  /// Cherry Swash 700
  static Future<Font> cherrySwashBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cherryswash/v11/i7dSIFByZjaNAMxtZcnfAy5E_FeaGy6QZ3WfYg.ttf',
      'CherrySwash-Bold',
    );
    return font.getFont();
  }

  /// Chewy regular
  static Future<Font> chewyRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/chewy/v12/uK_94ruUb-k-wk5xIDMfO-ed.ttf',
      'Chewy-Regular',
    );
    return font.getFont();
  }

  /// Chicle regular
  static Future<Font> chicleRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/chicle/v11/lJwG-pw9i2dqU-BDyWKuobYSxw.ttf',
      'Chicle-Regular',
    );
    return font.getFont();
  }

  /// Chilanka regular
  static Future<Font> chilankaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/chilanka/v8/WWXRlj2DZQiMJYaYRrJQI9EAZhTO.ttf',
      'Chilanka-Regular',
    );
    return font.getFont();
  }

  /// Chivo 300
  static Future<Font> chivoLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/chivo/v12/va9F4kzIxd1KFrjDY8Z_uqzGQC_-.ttf',
      'Chivo-Light',
    );
    return font.getFont();
  }

  /// Chivo 300italic
  static Future<Font> chivoLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/chivo/v12/va9D4kzIxd1KFrBteUp9sKjkRT_-bF0.ttf',
      'Chivo-LightItalic',
    );
    return font.getFont();
  }

  /// Chivo regular
  static Future<Font> chivoRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/chivo/v12/va9I4kzIxd1KFoBvS-J3kbDP.ttf',
      'Chivo-Regular',
    );
    return font.getFont();
  }

  /// Chivo italic
  static Future<Font> chivoItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/chivo/v12/va9G4kzIxd1KFrBtQeZVlKDPWTY.ttf',
      'Chivo-Italic',
    );
    return font.getFont();
  }

  /// Chivo 700
  static Future<Font> chivoBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/chivo/v12/va9F4kzIxd1KFrjTZMZ_uqzGQC_-.ttf',
      'Chivo-Bold',
    );
    return font.getFont();
  }

  /// Chivo 700italic
  static Future<Font> chivoBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/chivo/v12/va9D4kzIxd1KFrBteVp6sKjkRT_-bF0.ttf',
      'Chivo-BoldItalic',
    );
    return font.getFont();
  }

  /// Chivo 900
  static Future<Font> chivoBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/chivo/v12/va9F4kzIxd1KFrjrZsZ_uqzGQC_-.ttf',
      'Chivo-Black',
    );
    return font.getFont();
  }

  /// Chivo 900italic
  static Future<Font> chivoBlackItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/chivo/v12/va9D4kzIxd1KFrBteWJ4sKjkRT_-bF0.ttf',
      'Chivo-BlackItalic',
    );
    return font.getFont();
  }

  /// Chonburi regular
  static Future<Font> chonburiRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/chonburi/v5/8AtqGs-wOpGRTBq66IWaFr3biAfZ.ttf',
      'Chonburi-Regular',
    );
    return font.getFont();
  }

  /// Cinzel regular
  static Future<Font> cinzelRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cinzel/v11/8vIU7ww63mVu7gtR-kwKxNvkNOjw-tbnTYrvDE5ZdqU.ttf',
      'Cinzel-Regular',
    );
    return font.getFont();
  }

  /// Cinzel 500
  static Future<Font> cinzelMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cinzel/v11/8vIU7ww63mVu7gtR-kwKxNvkNOjw-uTnTYrvDE5ZdqU.ttf',
      'Cinzel-Medium',
    );
    return font.getFont();
  }

  /// Cinzel 600
  static Future<Font> cinzelSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cinzel/v11/8vIU7ww63mVu7gtR-kwKxNvkNOjw-gjgTYrvDE5ZdqU.ttf',
      'Cinzel-SemiBold',
    );
    return font.getFont();
  }

  /// Cinzel 700
  static Future<Font> cinzelBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cinzel/v11/8vIU7ww63mVu7gtR-kwKxNvkNOjw-jHgTYrvDE5ZdqU.ttf',
      'Cinzel-Bold',
    );
    return font.getFont();
  }

  /// Cinzel 800
  static Future<Font> cinzelExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cinzel/v11/8vIU7ww63mVu7gtR-kwKxNvkNOjw-lbgTYrvDE5ZdqU.ttf',
      'Cinzel-ExtraBold',
    );
    return font.getFont();
  }

  /// Cinzel 900
  static Future<Font> cinzelBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cinzel/v11/8vIU7ww63mVu7gtR-kwKxNvkNOjw-n_gTYrvDE5ZdqU.ttf',
      'Cinzel-Black',
    );
    return font.getFont();
  }

  /// Cinzel Decorative regular
  static Future<Font> cinzelDecorativeRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cinzeldecorative/v9/daaCSScvJGqLYhG8nNt8KPPswUAPnh7URs1LaCyC.ttf',
      'CinzelDecorative-Regular',
    );
    return font.getFont();
  }

  /// Cinzel Decorative 700
  static Future<Font> cinzelDecorativeBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cinzeldecorative/v9/daaHSScvJGqLYhG8nNt8KPPswUAPniZoaelDQzCLlQXE.ttf',
      'CinzelDecorative-Bold',
    );
    return font.getFont();
  }

  /// Cinzel Decorative 900
  static Future<Font> cinzelDecorativeBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cinzeldecorative/v9/daaHSScvJGqLYhG8nNt8KPPswUAPniZQa-lDQzCLlQXE.ttf',
      'CinzelDecorative-Black',
    );
    return font.getFont();
  }

  /// Clicker Script regular
  static Future<Font> clickerScriptRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/clickerscript/v8/raxkHiKPvt8CMH6ZWP8PdlEq72rY2zqUKafv.ttf',
      'ClickerScript-Regular',
    );
    return font.getFont();
  }

  /// Coda regular
  static Future<Font> codaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/coda/v16/SLXHc1jY5nQ8JUIMapaN39I.ttf',
      'Coda-Regular',
    );
    return font.getFont();
  }

  /// Coda 800
  static Future<Font> codaExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/coda/v16/SLXIc1jY5nQ8HeIgTp6mw9t1cX8.ttf',
      'Coda-ExtraBold',
    );
    return font.getFont();
  }

  /// Coda Caption 800
  static Future<Font> codaCaptionExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/codacaption/v14/ieVm2YRII2GMY7SyXSoDRiQGqcx6x_-fACIgaw.ttf',
      'CodaCaption-ExtraBold',
    );
    return font.getFont();
  }

  /// Codystar 300
  static Future<Font> codystarLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/codystar/v10/FwZf7-Q1xVk-40qxOuYsyuyrj0e29bfC.ttf',
      'Codystar-Light',
    );
    return font.getFont();
  }

  /// Codystar regular
  static Future<Font> codystarRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/codystar/v10/FwZY7-Q1xVk-40qxOt6A4sijpFu_.ttf',
      'Codystar-Regular',
    );
    return font.getFont();
  }

  /// Coiny regular
  static Future<Font> coinyRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/coiny/v8/gyByhwU1K989PXwbElSvO5Tc.ttf',
      'Coiny-Regular',
    );
    return font.getFont();
  }

  /// Combo regular
  static Future<Font> comboRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/combo/v11/BXRlvF3Jh_fIhg0iBu9y8Hf0.ttf',
      'Combo-Regular',
    );
    return font.getFont();
  }

  /// Comfortaa 300
  static Future<Font> comfortaaLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/comfortaa/v30/1Pt_g8LJRfWJmhDAuUsSQamb1W0lwk4S4TbMPrQVIT9c2c8.ttf',
      'Comfortaa-Light',
    );
    return font.getFont();
  }

  /// Comfortaa regular
  static Future<Font> comfortaaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/comfortaa/v30/1Pt_g8LJRfWJmhDAuUsSQamb1W0lwk4S4WjMPrQVIT9c2c8.ttf',
      'Comfortaa-Regular',
    );
    return font.getFont();
  }

  /// Comfortaa 500
  static Future<Font> comfortaaMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/comfortaa/v30/1Pt_g8LJRfWJmhDAuUsSQamb1W0lwk4S4VrMPrQVIT9c2c8.ttf',
      'Comfortaa-Medium',
    );
    return font.getFont();
  }

  /// Comfortaa 600
  static Future<Font> comfortaaSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/comfortaa/v30/1Pt_g8LJRfWJmhDAuUsSQamb1W0lwk4S4bbLPrQVIT9c2c8.ttf',
      'Comfortaa-SemiBold',
    );
    return font.getFont();
  }

  /// Comfortaa 700
  static Future<Font> comfortaaBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/comfortaa/v30/1Pt_g8LJRfWJmhDAuUsSQamb1W0lwk4S4Y_LPrQVIT9c2c8.ttf',
      'Comfortaa-Bold',
    );
    return font.getFont();
  }

  /// Comic Neue 300
  static Future<Font> comicNeueLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/comicneue/v2/4UaErEJDsxBrF37olUeD_wHLwpteLwtHJlc.ttf',
      'ComicNeue-Light',
    );
    return font.getFont();
  }

  /// Comic Neue 300italic
  static Future<Font> comicNeueLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/comicneue/v2/4UaarEJDsxBrF37olUeD96_RTplUKylCNlcw_Q.ttf',
      'ComicNeue-LightItalic',
    );
    return font.getFont();
  }

  /// Comic Neue regular
  static Future<Font> comicNeueRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/comicneue/v2/4UaHrEJDsxBrF37olUeDx63j5pN1MwI.ttf',
      'ComicNeue-Regular',
    );
    return font.getFont();
  }

  /// Comic Neue italic
  static Future<Font> comicNeueItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/comicneue/v2/4UaFrEJDsxBrF37olUeD96_p4rFwIwJePw.ttf',
      'ComicNeue-Italic',
    );
    return font.getFont();
  }

  /// Comic Neue 700
  static Future<Font> comicNeueBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/comicneue/v2/4UaErEJDsxBrF37olUeD_xHMwpteLwtHJlc.ttf',
      'ComicNeue-Bold',
    );
    return font.getFont();
  }

  /// Comic Neue 700italic
  static Future<Font> comicNeueBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/comicneue/v2/4UaarEJDsxBrF37olUeD96_RXp5UKylCNlcw_Q.ttf',
      'ComicNeue-BoldItalic',
    );
    return font.getFont();
  }

  /// Coming Soon regular
  static Future<Font> comingSoonRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/comingsoon/v12/qWcuB6mzpYL7AJ2VfdQR1u-SUjjzsykh.ttf',
      'ComingSoon-Regular',
    );
    return font.getFont();
  }

  /// Commissioner 100
  static Future<Font> commissionerThin() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/commissioner/v5/tDbe2o2WnlgI0FNDgduEk4jAhwgIy5k8SlfU5Ni-IO9pOXuRoaY.ttf',
      'Commissioner-Thin',
    );
    return font.getFont();
  }

  /// Commissioner 200
  static Future<Font> commissionerExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/commissioner/v5/tDbe2o2WnlgI0FNDgduEk4jAhwgIy5k8SlfU5Fi_IO9pOXuRoaY.ttf',
      'Commissioner-ExtraLight',
    );
    return font.getFont();
  }

  /// Commissioner 300
  static Future<Font> commissionerLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/commissioner/v5/tDbe2o2WnlgI0FNDgduEk4jAhwgIy5k8SlfU5Ia_IO9pOXuRoaY.ttf',
      'Commissioner-Light',
    );
    return font.getFont();
  }

  /// Commissioner regular
  static Future<Font> commissionerRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/commissioner/v5/tDbe2o2WnlgI0FNDgduEk4jAhwgIy5k8SlfU5Ni_IO9pOXuRoaY.ttf',
      'Commissioner-Regular',
    );
    return font.getFont();
  }

  /// Commissioner 500
  static Future<Font> commissionerMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/commissioner/v5/tDbe2o2WnlgI0FNDgduEk4jAhwgIy5k8SlfU5Oq_IO9pOXuRoaY.ttf',
      'Commissioner-Medium',
    );
    return font.getFont();
  }

  /// Commissioner 600
  static Future<Font> commissionerSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/commissioner/v5/tDbe2o2WnlgI0FNDgduEk4jAhwgIy5k8SlfU5Aa4IO9pOXuRoaY.ttf',
      'Commissioner-SemiBold',
    );
    return font.getFont();
  }

  /// Commissioner 700
  static Future<Font> commissionerBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/commissioner/v5/tDbe2o2WnlgI0FNDgduEk4jAhwgIy5k8SlfU5D-4IO9pOXuRoaY.ttf',
      'Commissioner-Bold',
    );
    return font.getFont();
  }

  /// Commissioner 800
  static Future<Font> commissionerExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/commissioner/v5/tDbe2o2WnlgI0FNDgduEk4jAhwgIy5k8SlfU5Fi4IO9pOXuRoaY.ttf',
      'Commissioner-ExtraBold',
    );
    return font.getFont();
  }

  /// Commissioner 900
  static Future<Font> commissionerBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/commissioner/v5/tDbe2o2WnlgI0FNDgduEk4jAhwgIy5k8SlfU5HG4IO9pOXuRoaY.ttf',
      'Commissioner-Black',
    );
    return font.getFont();
  }

  /// Concert One regular
  static Future<Font> concertOneRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/concertone/v11/VEM1Ro9xs5PjtzCu-srDqRTlhv-CuVAQ.ttf',
      'ConcertOne-Regular',
    );
    return font.getFont();
  }

  /// Condiment regular
  static Future<Font> condimentRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/condiment/v10/pONk1hggFNmwvXALyH6Sq4n4o1vyCQ.ttf',
      'Condiment-Regular',
    );
    return font.getFont();
  }

  /// Content regular
  static Future<Font> contentRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/content/v15/zrfl0HLayePhU_AwUaDyIiL0RCg.ttf',
      'Content-Regular',
    );
    return font.getFont();
  }

  /// Content 700
  static Future<Font> contentBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/content/v15/zrfg0HLayePhU_AwaRzdBirfWCHvkAI.ttf',
      'Content-Bold',
    );
    return font.getFont();
  }

  /// Contrail One regular
  static Future<Font> contrailOneRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/contrailone/v10/eLGbP-j_JA-kG0_Zo51noafdZUvt_c092w.ttf',
      'ContrailOne-Regular',
    );
    return font.getFont();
  }

  /// Convergence regular
  static Future<Font> convergenceRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/convergence/v9/rax5HiePvdgXPmmMHcIPYRhasU7Q8Cad.ttf',
      'Convergence-Regular',
    );
    return font.getFont();
  }

  /// Cookie regular
  static Future<Font> cookieRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cookie/v12/syky-y18lb0tSbfNlQCT9tPdpw.ttf',
      'Cookie-Regular',
    );
    return font.getFont();
  }

  /// Copse regular
  static Future<Font> copseRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/copse/v10/11hPGpDKz1rGb0djHkihUb-A.ttf',
      'Copse-Regular',
    );
    return font.getFont();
  }

  /// Corben regular
  static Future<Font> corbenRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/corben/v14/LYjDdGzzklQtCMp9oAlEpVs3VQ.ttf',
      'Corben-Regular',
    );
    return font.getFont();
  }

  /// Corben 700
  static Future<Font> corbenBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/corben/v14/LYjAdGzzklQtCMpFHCZgrXArXN7HWQ.ttf',
      'Corben-Bold',
    );
    return font.getFont();
  }

  /// Cormorant 300
  static Future<Font> cormorantLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cormorant/v11/H4cgBXOCl9bbnla_nHIiRLmYgoyyYzFzFw.ttf',
      'Cormorant-Light',
    );
    return font.getFont();
  }

  /// Cormorant 300italic
  static Future<Font> cormorantLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cormorant/v11/H4c-BXOCl9bbnla_nHIq6qMUgIa2QTRjF8ER.ttf',
      'Cormorant-LightItalic',
    );
    return font.getFont();
  }

  /// Cormorant regular
  static Future<Font> cormorantRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cormorant/v11/H4clBXOCl9bbnla_nHIa6JG8iqeuag.ttf',
      'Cormorant-Regular',
    );
    return font.getFont();
  }

  /// Cormorant italic
  static Future<Font> cormorantItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cormorant/v11/H4cjBXOCl9bbnla_nHIq6pu4qKK-aihq.ttf',
      'Cormorant-Italic',
    );
    return font.getFont();
  }

  /// Cormorant 500
  static Future<Font> cormorantMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cormorant/v11/H4cgBXOCl9bbnla_nHIiHLiYgoyyYzFzFw.ttf',
      'Cormorant-Medium',
    );
    return font.getFont();
  }

  /// Cormorant 500italic
  static Future<Font> cormorantMediumItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cormorant/v11/H4c-BXOCl9bbnla_nHIq6qNMgYa2QTRjF8ER.ttf',
      'Cormorant-MediumItalic',
    );
    return font.getFont();
  }

  /// Cormorant 600
  static Future<Font> cormorantSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cormorant/v11/H4cgBXOCl9bbnla_nHIiML-YgoyyYzFzFw.ttf',
      'Cormorant-SemiBold',
    );
    return font.getFont();
  }

  /// Cormorant 600italic
  static Future<Font> cormorantSemiBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cormorant/v11/H4c-BXOCl9bbnla_nHIq6qNghoa2QTRjF8ER.ttf',
      'Cormorant-SemiBoldItalic',
    );
    return font.getFont();
  }

  /// Cormorant 700
  static Future<Font> cormorantBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cormorant/v11/H4cgBXOCl9bbnla_nHIiVL6YgoyyYzFzFw.ttf',
      'Cormorant-Bold',
    );
    return font.getFont();
  }

  /// Cormorant 700italic
  static Future<Font> cormorantBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cormorant/v11/H4c-BXOCl9bbnla_nHIq6qMEh4a2QTRjF8ER.ttf',
      'Cormorant-BoldItalic',
    );
    return font.getFont();
  }

  /// Cormorant Garamond 300
  static Future<Font> cormorantGaramondLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cormorantgaramond/v10/co3YmX5slCNuHLi8bLeY9MK7whWMhyjQAllvuQWJ5heb_w.ttf',
      'CormorantGaramond-Light',
    );
    return font.getFont();
  }

  /// Cormorant Garamond 300italic
  static Future<Font> cormorantGaramondLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cormorantgaramond/v10/co3WmX5slCNuHLi8bLeY9MK7whWMhyjYrEPjuw-NxBKL_y94.ttf',
      'CormorantGaramond-LightItalic',
    );
    return font.getFont();
  }

  /// Cormorant Garamond regular
  static Future<Font> cormorantGaramondRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cormorantgaramond/v10/co3bmX5slCNuHLi8bLeY9MK7whWMhyjornFLsS6V7w.ttf',
      'CormorantGaramond-Regular',
    );
    return font.getFont();
  }

  /// Cormorant Garamond italic
  static Future<Font> cormorantGaramondItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cormorantgaramond/v10/co3ZmX5slCNuHLi8bLeY9MK7whWMhyjYrHtPkyuF7w6C.ttf',
      'CormorantGaramond-Italic',
    );
    return font.getFont();
  }

  /// Cormorant Garamond 500
  static Future<Font> cormorantGaramondMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cormorantgaramond/v10/co3YmX5slCNuHLi8bLeY9MK7whWMhyjQWlhvuQWJ5heb_w.ttf',
      'CormorantGaramond-Medium',
    );
    return font.getFont();
  }

  /// Cormorant Garamond 500italic
  static Future<Font> cormorantGaramondMediumItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cormorantgaramond/v10/co3WmX5slCNuHLi8bLeY9MK7whWMhyjYrEO7ug-NxBKL_y94.ttf',
      'CormorantGaramond-MediumItalic',
    );
    return font.getFont();
  }

  /// Cormorant Garamond 600
  static Future<Font> cormorantGaramondSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cormorantgaramond/v10/co3YmX5slCNuHLi8bLeY9MK7whWMhyjQdl9vuQWJ5heb_w.ttf',
      'CormorantGaramond-SemiBold',
    );
    return font.getFont();
  }

  /// Cormorant Garamond 600italic
  static Future<Font> cormorantGaramondSemiBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cormorantgaramond/v10/co3WmX5slCNuHLi8bLeY9MK7whWMhyjYrEOXvQ-NxBKL_y94.ttf',
      'CormorantGaramond-SemiBoldItalic',
    );
    return font.getFont();
  }

  /// Cormorant Garamond 700
  static Future<Font> cormorantGaramondBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cormorantgaramond/v10/co3YmX5slCNuHLi8bLeY9MK7whWMhyjQEl5vuQWJ5heb_w.ttf',
      'CormorantGaramond-Bold',
    );
    return font.getFont();
  }

  /// Cormorant Garamond 700italic
  static Future<Font> cormorantGaramondBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cormorantgaramond/v10/co3WmX5slCNuHLi8bLeY9MK7whWMhyjYrEPzvA-NxBKL_y94.ttf',
      'CormorantGaramond-BoldItalic',
    );
    return font.getFont();
  }

  /// Cormorant Infant 300
  static Future<Font> cormorantInfantLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cormorantinfant/v11/HhyIU44g9vKiM1sORYSiWeAsLN9951w3_DMrQqcdJrk.ttf',
      'CormorantInfant-Light',
    );
    return font.getFont();
  }

  /// Cormorant Infant 300italic
  static Future<Font> cormorantInfantLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cormorantinfant/v11/HhyKU44g9vKiM1sORYSiWeAsLN997_ItcDEhRoUYNrn_Ig.ttf',
      'CormorantInfant-LightItalic',
    );
    return font.getFont();
  }

  /// Cormorant Infant regular
  static Future<Font> cormorantInfantRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cormorantinfant/v11/HhyPU44g9vKiM1sORYSiWeAsLN993_Af2DsAXq4.ttf',
      'CormorantInfant-Regular',
    );
    return font.getFont();
  }

  /// Cormorant Infant italic
  static Future<Font> cormorantInfantItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cormorantinfant/v11/HhyJU44g9vKiM1sORYSiWeAsLN997_IV3BkFTq4EPw.ttf',
      'CormorantInfant-Italic',
    );
    return font.getFont();
  }

  /// Cormorant Infant 500
  static Future<Font> cormorantInfantMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cormorantinfant/v11/HhyIU44g9vKiM1sORYSiWeAsLN995wQ2_DMrQqcdJrk.ttf',
      'CormorantInfant-Medium',
    );
    return font.getFont();
  }

  /// Cormorant Infant 500italic
  static Future<Font> cormorantInfantMediumItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cormorantinfant/v11/HhyKU44g9vKiM1sORYSiWeAsLN997_ItKDAhRoUYNrn_Ig.ttf',
      'CormorantInfant-MediumItalic',
    );
    return font.getFont();
  }

  /// Cormorant Infant 600
  static Future<Font> cormorantInfantSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cormorantinfant/v11/HhyIU44g9vKiM1sORYSiWeAsLN995ygx_DMrQqcdJrk.ttf',
      'CormorantInfant-SemiBold',
    );
    return font.getFont();
  }

  /// Cormorant Infant 600italic
  static Future<Font> cormorantInfantSemiBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cormorantinfant/v11/HhyKU44g9vKiM1sORYSiWeAsLN997_ItBDchRoUYNrn_Ig.ttf',
      'CormorantInfant-SemiBoldItalic',
    );
    return font.getFont();
  }

  /// Cormorant Infant 700
  static Future<Font> cormorantInfantBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cormorantinfant/v11/HhyIU44g9vKiM1sORYSiWeAsLN9950ww_DMrQqcdJrk.ttf',
      'CormorantInfant-Bold',
    );
    return font.getFont();
  }

  /// Cormorant Infant 700italic
  static Future<Font> cormorantInfantBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cormorantinfant/v11/HhyKU44g9vKiM1sORYSiWeAsLN997_ItYDYhRoUYNrn_Ig.ttf',
      'CormorantInfant-BoldItalic',
    );
    return font.getFont();
  }

  /// Cormorant SC 300
  static Future<Font> cormorantSCLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cormorantsc/v11/0ybmGD4kxqXBmOVLG30OGwsmABIU_R3y8DOWGA.ttf',
      'CormorantSC-Light',
    );
    return font.getFont();
  }

  /// Cormorant SC regular
  static Future<Font> cormorantSCRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cormorantsc/v11/0yb5GD4kxqXBmOVLG30OGwserDow9Tbu-Q.ttf',
      'CormorantSC-Regular',
    );
    return font.getFont();
  }

  /// Cormorant SC 500
  static Future<Font> cormorantSCMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cormorantsc/v11/0ybmGD4kxqXBmOVLG30OGwsmWBMU_R3y8DOWGA.ttf',
      'CormorantSC-Medium',
    );
    return font.getFont();
  }

  /// Cormorant SC 600
  static Future<Font> cormorantSCSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cormorantsc/v11/0ybmGD4kxqXBmOVLG30OGwsmdBQU_R3y8DOWGA.ttf',
      'CormorantSC-SemiBold',
    );
    return font.getFont();
  }

  /// Cormorant SC 700
  static Future<Font> cormorantSCBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cormorantsc/v11/0ybmGD4kxqXBmOVLG30OGwsmEBUU_R3y8DOWGA.ttf',
      'CormorantSC-Bold',
    );
    return font.getFont();
  }

  /// Cormorant Unicase 300
  static Future<Font> cormorantUnicaseLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cormorantunicase/v13/HI_ViZUaILtOqhqgDeXoF_n1_fTGX9N_tucv7Gy0DRzS.ttf',
      'CormorantUnicase-Light',
    );
    return font.getFont();
  }

  /// Cormorant Unicase regular
  static Future<Font> cormorantUnicaseRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cormorantunicase/v13/HI_QiZUaILtOqhqgDeXoF_n1_fTGX-vTnsMnx3C9.ttf',
      'CormorantUnicase-Regular',
    );
    return font.getFont();
  }

  /// Cormorant Unicase 500
  static Future<Font> cormorantUnicaseMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cormorantunicase/v13/HI_ViZUaILtOqhqgDeXoF_n1_fTGX9Mnt-cv7Gy0DRzS.ttf',
      'CormorantUnicase-Medium',
    );
    return font.getFont();
  }

  /// Cormorant Unicase 600
  static Future<Font> cormorantUnicaseSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cormorantunicase/v13/HI_ViZUaILtOqhqgDeXoF_n1_fTGX9MLsOcv7Gy0DRzS.ttf',
      'CormorantUnicase-SemiBold',
    );
    return font.getFont();
  }

  /// Cormorant Unicase 700
  static Future<Font> cormorantUnicaseBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cormorantunicase/v13/HI_ViZUaILtOqhqgDeXoF_n1_fTGX9Nvsecv7Gy0DRzS.ttf',
      'CormorantUnicase-Bold',
    );
    return font.getFont();
  }

  /// Cormorant Upright 300
  static Future<Font> cormorantUprightLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cormorantupright/v11/VuJudM3I2Y35poFONtLdafkUCHw1y1N5phDsU9X6RPzQ.ttf',
      'CormorantUpright-Light',
    );
    return font.getFont();
  }

  /// Cormorant Upright regular
  static Future<Font> cormorantUprightRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cormorantupright/v11/VuJrdM3I2Y35poFONtLdafkUCHw1y2vVjjTkeMnz.ttf',
      'CormorantUpright-Regular',
    );
    return font.getFont();
  }

  /// Cormorant Upright 500
  static Future<Font> cormorantUprightMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cormorantupright/v11/VuJudM3I2Y35poFONtLdafkUCHw1y1MhpxDsU9X6RPzQ.ttf',
      'CormorantUpright-Medium',
    );
    return font.getFont();
  }

  /// Cormorant Upright 600
  static Future<Font> cormorantUprightSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cormorantupright/v11/VuJudM3I2Y35poFONtLdafkUCHw1y1MNoBDsU9X6RPzQ.ttf',
      'CormorantUpright-SemiBold',
    );
    return font.getFont();
  }

  /// Cormorant Upright 700
  static Future<Font> cormorantUprightBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cormorantupright/v11/VuJudM3I2Y35poFONtLdafkUCHw1y1NpoRDsU9X6RPzQ.ttf',
      'CormorantUpright-Bold',
    );
    return font.getFont();
  }

  /// Courgette regular
  static Future<Font> courgetteRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/courgette/v8/wEO_EBrAnc9BLjLQAUkFUfAL3EsHiA.ttf',
      'Courgette-Regular',
    );
    return font.getFont();
  }

  /// Courier Prime regular
  static Future<Font> courierPrimeRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/courierprime/v2/u-450q2lgwslOqpF_6gQ8kELWwZjW-_-tvg.ttf',
      'CourierPrime-Regular',
    );
    return font.getFont();
  }

  /// Courier Prime italic
  static Future<Font> courierPrimeItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/courierprime/v2/u-4n0q2lgwslOqpF_6gQ8kELawRpX837pvjxPA.ttf',
      'CourierPrime-Italic',
    );
    return font.getFont();
  }

  /// Courier Prime 700
  static Future<Font> courierPrimeBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/courierprime/v2/u-4k0q2lgwslOqpF_6gQ8kELY7pMf-fVqvHoJXw.ttf',
      'CourierPrime-Bold',
    );
    return font.getFont();
  }

  /// Courier Prime 700italic
  static Future<Font> courierPrimeBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/courierprime/v2/u-4i0q2lgwslOqpF_6gQ8kELawRR4-LfrtPtNXyeAg.ttf',
      'CourierPrime-BoldItalic',
    );
    return font.getFont();
  }

  /// Cousine regular
  static Future<Font> cousineRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cousine/v17/d6lIkaiiRdih4SpPzSMlzTbtz9k.ttf',
      'Cousine-Regular',
    );
    return font.getFont();
  }

  /// Cousine italic
  static Future<Font> cousineItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cousine/v17/d6lKkaiiRdih4SpP_SEvyRTo39l8hw.ttf',
      'Cousine-Italic',
    );
    return font.getFont();
  }

  /// Cousine 700
  static Future<Font> cousineBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cousine/v17/d6lNkaiiRdih4SpP9Z8K6T7G09BlnmQ.ttf',
      'Cousine-Bold',
    );
    return font.getFont();
  }

  /// Cousine 700italic
  static Future<Font> cousineBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cousine/v17/d6lPkaiiRdih4SpP_SEXdTvM1_JgjmRpOA.ttf',
      'Cousine-BoldItalic',
    );
    return font.getFont();
  }

  /// Coustard regular
  static Future<Font> coustardRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/coustard/v11/3XFpErgg3YsZ5fqUU9UPvWXuROTd.ttf',
      'Coustard-Regular',
    );
    return font.getFont();
  }

  /// Coustard 900
  static Future<Font> coustardBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/coustard/v11/3XFuErgg3YsZ5fqUU-2LkEHmb_jU3eRL.ttf',
      'Coustard-Black',
    );
    return font.getFont();
  }

  /// Covered By Your Grace regular
  static Future<Font> coveredByYourGraceRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/coveredbyyourgrace/v10/QGYwz-AZahWOJJI9kykWW9mD6opopoqXSOS0FgItq6bFIg.ttf',
      'CoveredByYourGrace-Regular',
    );
    return font.getFont();
  }

  /// Crafty Girls regular
  static Future<Font> craftyGirlsRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/craftygirls/v10/va9B4kXI39VaDdlPJo8N_NvuQR37fF3Wlg.ttf',
      'CraftyGirls-Regular',
    );
    return font.getFont();
  }

  /// Creepster regular
  static Future<Font> creepsterRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/creepster/v9/AlZy_zVUqJz4yMrniH4hdXf4XB0Tow.ttf',
      'Creepster-Regular',
    );
    return font.getFont();
  }

  /// Crete Round regular
  static Future<Font> creteRoundRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/creteround/v9/55xoey1sJNPjPiv1ZZZrxJ1827zAKnxN.ttf',
      'CreteRound-Regular',
    );
    return font.getFont();
  }

  /// Crete Round italic
  static Future<Font> creteRoundItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/creteround/v9/55xqey1sJNPjPiv1ZZZrxK1-0bjiL2xNhKc.ttf',
      'CreteRound-Italic',
    );
    return font.getFont();
  }

  /// Crimson Pro 200
  static Future<Font> crimsonProExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/crimsonpro/v14/q5uUsoa5M_tv7IihmnkabC5XiXCAlXGks1WZTm18OJE_VNWoyQ.ttf',
      'CrimsonPro-ExtraLight',
    );
    return font.getFont();
  }

  /// Crimson Pro 300
  static Future<Font> crimsonProLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/crimsonpro/v14/q5uUsoa5M_tv7IihmnkabC5XiXCAlXGks1WZkG18OJE_VNWoyQ.ttf',
      'CrimsonPro-Light',
    );
    return font.getFont();
  }

  /// Crimson Pro regular
  static Future<Font> crimsonProRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/crimsonpro/v14/q5uUsoa5M_tv7IihmnkabC5XiXCAlXGks1WZzm18OJE_VNWoyQ.ttf',
      'CrimsonPro-Regular',
    );
    return font.getFont();
  }

  /// Crimson Pro 500
  static Future<Font> crimsonProMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/crimsonpro/v14/q5uUsoa5M_tv7IihmnkabC5XiXCAlXGks1WZ_G18OJE_VNWoyQ.ttf',
      'CrimsonPro-Medium',
    );
    return font.getFont();
  }

  /// Crimson Pro 600
  static Future<Font> crimsonProSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/crimsonpro/v14/q5uUsoa5M_tv7IihmnkabC5XiXCAlXGks1WZEGp8OJE_VNWoyQ.ttf',
      'CrimsonPro-SemiBold',
    );
    return font.getFont();
  }

  /// Crimson Pro 700
  static Future<Font> crimsonProBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/crimsonpro/v14/q5uUsoa5M_tv7IihmnkabC5XiXCAlXGks1WZKWp8OJE_VNWoyQ.ttf',
      'CrimsonPro-Bold',
    );
    return font.getFont();
  }

  /// Crimson Pro 800
  static Future<Font> crimsonProExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/crimsonpro/v14/q5uUsoa5M_tv7IihmnkabC5XiXCAlXGks1WZTmp8OJE_VNWoyQ.ttf',
      'CrimsonPro-ExtraBold',
    );
    return font.getFont();
  }

  /// Crimson Pro 900
  static Future<Font> crimsonProBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/crimsonpro/v14/q5uUsoa5M_tv7IihmnkabC5XiXCAlXGks1WZZ2p8OJE_VNWoyQ.ttf',
      'CrimsonPro-Black',
    );
    return font.getFont();
  }

  /// Crimson Pro 200italic
  static Future<Font> crimsonProExtraLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/crimsonpro/v14/q5uSsoa5M_tv7IihmnkabAReu49Y_Bo-HVKMBi4Ue5s7dtC4yZNE.ttf',
      'CrimsonPro-ExtraLightItalic',
    );
    return font.getFont();
  }

  /// Crimson Pro 300italic
  static Future<Font> crimsonProLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/crimsonpro/v14/q5uSsoa5M_tv7IihmnkabAReu49Y_Bo-HVKMBi7Ke5s7dtC4yZNE.ttf',
      'CrimsonPro-LightItalic',
    );
    return font.getFont();
  }

  /// Crimson Pro italic
  static Future<Font> crimsonProItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/crimsonpro/v14/q5uSsoa5M_tv7IihmnkabAReu49Y_Bo-HVKMBi6Ue5s7dtC4yZNE.ttf',
      'CrimsonPro-Italic',
    );
    return font.getFont();
  }

  /// Crimson Pro 500italic
  static Future<Font> crimsonProMediumItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/crimsonpro/v14/q5uSsoa5M_tv7IihmnkabAReu49Y_Bo-HVKMBi6me5s7dtC4yZNE.ttf',
      'CrimsonPro-MediumItalic',
    );
    return font.getFont();
  }

  /// Crimson Pro 600italic
  static Future<Font> crimsonProSemiBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/crimsonpro/v14/q5uSsoa5M_tv7IihmnkabAReu49Y_Bo-HVKMBi5KfJs7dtC4yZNE.ttf',
      'CrimsonPro-SemiBoldItalic',
    );
    return font.getFont();
  }

  /// Crimson Pro 700italic
  static Future<Font> crimsonProBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/crimsonpro/v14/q5uSsoa5M_tv7IihmnkabAReu49Y_Bo-HVKMBi5zfJs7dtC4yZNE.ttf',
      'CrimsonPro-BoldItalic',
    );
    return font.getFont();
  }

  /// Crimson Pro 800italic
  static Future<Font> crimsonProExtraBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/crimsonpro/v14/q5uSsoa5M_tv7IihmnkabAReu49Y_Bo-HVKMBi4UfJs7dtC4yZNE.ttf',
      'CrimsonPro-ExtraBoldItalic',
    );
    return font.getFont();
  }

  /// Crimson Pro 900italic
  static Future<Font> crimsonProBlackItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/crimsonpro/v14/q5uSsoa5M_tv7IihmnkabAReu49Y_Bo-HVKMBi49fJs7dtC4yZNE.ttf',
      'CrimsonPro-BlackItalic',
    );
    return font.getFont();
  }

  /// Crimson Text regular
  static Future<Font> crimsonTextRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/crimsontext/v11/wlp2gwHKFkZgtmSR3NB0oRJvaAJSA_JN3Q.ttf',
      'CrimsonText-Regular',
    );
    return font.getFont();
  }

  /// Crimson Text italic
  static Future<Font> crimsonTextItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/crimsontext/v11/wlpogwHKFkZgtmSR3NB0oRJfaghWIfdd3ahG.ttf',
      'CrimsonText-Italic',
    );
    return font.getFont();
  }

  /// Crimson Text 600
  static Future<Font> crimsonTextSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/crimsontext/v11/wlppgwHKFkZgtmSR3NB0oRJXsCx2C9lR1LFffg.ttf',
      'CrimsonText-SemiBold',
    );
    return font.getFont();
  }

  /// Crimson Text 600italic
  static Future<Font> crimsonTextSemiBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/crimsontext/v11/wlprgwHKFkZgtmSR3NB0oRJfajCOD9NV9rRPfrKu.ttf',
      'CrimsonText-SemiBoldItalic',
    );
    return font.getFont();
  }

  /// Crimson Text 700
  static Future<Font> crimsonTextBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/crimsontext/v11/wlppgwHKFkZgtmSR3NB0oRJX1C12C9lR1LFffg.ttf',
      'CrimsonText-Bold',
    );
    return font.getFont();
  }

  /// Crimson Text 700italic
  static Future<Font> crimsonTextBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/crimsontext/v11/wlprgwHKFkZgtmSR3NB0oRJfajDqDtNV9rRPfrKu.ttf',
      'CrimsonText-BoldItalic',
    );
    return font.getFont();
  }

  /// Croissant One regular
  static Future<Font> croissantOneRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/croissantone/v10/3y9n6bU9bTPg4m8NDy3Kq24UM3pqn5cdJ-4.ttf',
      'CroissantOne-Regular',
    );
    return font.getFont();
  }

  /// Crushed regular
  static Future<Font> crushedRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/crushed/v13/U9Mc6dym6WXImTlFT1kfuIqyLzA.ttf',
      'Crushed-Regular',
    );
    return font.getFont();
  }

  /// Cuprum regular
  static Future<Font> cuprumRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cuprum/v14/dg45_pLmvrkcOkBnKsOzXyGWTBcmg-X6ZjzSJjQjgnU.ttf',
      'Cuprum-Regular',
    );
    return font.getFont();
  }

  /// Cuprum 500
  static Future<Font> cuprumMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cuprum/v14/dg45_pLmvrkcOkBnKsOzXyGWTBcmg9f6ZjzSJjQjgnU.ttf',
      'Cuprum-Medium',
    );
    return font.getFont();
  }

  /// Cuprum 600
  static Future<Font> cuprumSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cuprum/v14/dg45_pLmvrkcOkBnKsOzXyGWTBcmgzv9ZjzSJjQjgnU.ttf',
      'Cuprum-SemiBold',
    );
    return font.getFont();
  }

  /// Cuprum 700
  static Future<Font> cuprumBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cuprum/v14/dg45_pLmvrkcOkBnKsOzXyGWTBcmgwL9ZjzSJjQjgnU.ttf',
      'Cuprum-Bold',
    );
    return font.getFont();
  }

  /// Cuprum italic
  static Future<Font> cuprumItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cuprum/v14/dg47_pLmvrkcOkBNI_FMh0j91rkhli25jn_YIhYmknUPEA.ttf',
      'Cuprum-Italic',
    );
    return font.getFont();
  }

  /// Cuprum 500italic
  static Future<Font> cuprumMediumItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cuprum/v14/dg47_pLmvrkcOkBNI_FMh0j91rkhli25vH_YIhYmknUPEA.ttf',
      'Cuprum-MediumItalic',
    );
    return font.getFont();
  }

  /// Cuprum 600italic
  static Future<Font> cuprumSemiBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cuprum/v14/dg47_pLmvrkcOkBNI_FMh0j91rkhli25UHjYIhYmknUPEA.ttf',
      'Cuprum-SemiBoldItalic',
    );
    return font.getFont();
  }

  /// Cuprum 700italic
  static Future<Font> cuprumBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cuprum/v14/dg47_pLmvrkcOkBNI_FMh0j91rkhli25aXjYIhYmknUPEA.ttf',
      'Cuprum-BoldItalic',
    );
    return font.getFont();
  }

  /// Cute Font regular
  static Future<Font> cuteFontRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cutefont/v10/Noaw6Uny2oWPbSHMrY6vmJNVNC9hkw.ttf',
      'CuteFont-Regular',
    );
    return font.getFont();
  }

  /// Cutive regular
  static Future<Font> cutiveRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cutive/v12/NaPZcZ_fHOhV3Ip7T_hDoyqlZQ.ttf',
      'Cutive-Regular',
    );
    return font.getFont();
  }

  /// Cutive Mono regular
  static Future<Font> cutiveMonoRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/cutivemono/v9/m8JWjfRfY7WVjVi2E-K9H5RFRG-K3Mud.ttf',
      'CutiveMono-Regular',
    );
    return font.getFont();
  }

  /// DM Mono 300
  static Future<Font> dMMonoLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/dmmono/v5/aFTR7PB1QTsUX8KYvrGyIYSnbKX9Rlk.ttf',
      'DMMono-Light',
    );
    return font.getFont();
  }

  /// DM Mono 300italic
  static Future<Font> dMMonoLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/dmmono/v5/aFTT7PB1QTsUX8KYth-orYataIf4VllXuA.ttf',
      'DMMono-LightItalic',
    );
    return font.getFont();
  }

  /// DM Mono regular
  static Future<Font> dMMonoRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/dmmono/v5/aFTU7PB1QTsUX8KYhh2aBYyMcKw.ttf',
      'DMMono-Regular',
    );
    return font.getFont();
  }

  /// DM Mono italic
  static Future<Font> dMMonoItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/dmmono/v5/aFTW7PB1QTsUX8KYth-QAa6JYKzkXw.ttf',
      'DMMono-Italic',
    );
    return font.getFont();
  }

  /// DM Mono 500
  static Future<Font> dMMonoMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/dmmono/v5/aFTR7PB1QTsUX8KYvumzIYSnbKX9Rlk.ttf',
      'DMMono-Medium',
    );
    return font.getFont();
  }

  /// DM Mono 500italic
  static Future<Font> dMMonoMediumItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/dmmono/v5/aFTT7PB1QTsUX8KYth-o9YetaIf4VllXuA.ttf',
      'DMMono-MediumItalic',
    );
    return font.getFont();
  }

  /// DM Sans regular
  static Future<Font> dMSansRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/dmsans/v6/rP2Hp2ywxg089UriOZSCHBeHFl0.ttf',
      'DMSans-Regular',
    );
    return font.getFont();
  }

  /// DM Sans italic
  static Future<Font> dMSansItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/dmsans/v6/rP2Fp2ywxg089UriCZaIGDWCBl0O8Q.ttf',
      'DMSans-Italic',
    );
    return font.getFont();
  }

  /// DM Sans 500
  static Future<Font> dMSansMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/dmsans/v6/rP2Cp2ywxg089UriAWCrOB-sClQX6Cg.ttf',
      'DMSans-Medium',
    );
    return font.getFont();
  }

  /// DM Sans 500italic
  static Future<Font> dMSansMediumItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/dmsans/v6/rP2Ap2ywxg089UriCZaw7BymDnYS-Cjk6Q.ttf',
      'DMSans-MediumItalic',
    );
    return font.getFont();
  }

  /// DM Sans 700
  static Future<Font> dMSansBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/dmsans/v6/rP2Cp2ywxg089UriASitOB-sClQX6Cg.ttf',
      'DMSans-Bold',
    );
    return font.getFont();
  }

  /// DM Sans 700italic
  static Future<Font> dMSansBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/dmsans/v6/rP2Ap2ywxg089UriCZawpBqmDnYS-Cjk6Q.ttf',
      'DMSans-BoldItalic',
    );
    return font.getFont();
  }

  /// DM Serif Display regular
  static Future<Font> dMSerifDisplayRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/dmserifdisplay/v5/-nFnOHM81r4j6k0gjAW3mujVU2B2K_d709jy92k.ttf',
      'DMSerifDisplay-Regular',
    );
    return font.getFont();
  }

  /// DM Serif Display italic
  static Future<Font> dMSerifDisplayItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/dmserifdisplay/v5/-nFhOHM81r4j6k0gjAW3mujVU2B2G_Vx1_r352np3Q.ttf',
      'DMSerifDisplay-Italic',
    );
    return font.getFont();
  }

  /// DM Serif Text regular
  static Future<Font> dMSerifTextRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/dmseriftext/v5/rnCu-xZa_krGokauCeNq1wWyafOPXHIJErY.ttf',
      'DMSerifText-Regular',
    );
    return font.getFont();
  }

  /// DM Serif Text italic
  static Future<Font> dMSerifTextItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/dmseriftext/v5/rnCw-xZa_krGokauCeNq1wWyWfGFWFAMArZKqQ.ttf',
      'DMSerifText-Italic',
    );
    return font.getFont();
  }

  /// Damion regular
  static Future<Font> damionRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/damion/v10/hv-XlzJ3KEUe_YZUbWY3MTFgVg.ttf',
      'Damion-Regular',
    );
    return font.getFont();
  }

  /// Dancing Script regular
  static Future<Font> dancingScriptRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/dancingscript/v16/If2cXTr6YS-zF4S-kcSWSVi_sxjsohD9F50Ruu7BMSoHTeB9ptDqpw.ttf',
      'DancingScript-Regular',
    );
    return font.getFont();
  }

  /// Dancing Script 500
  static Future<Font> dancingScriptMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/dancingscript/v16/If2cXTr6YS-zF4S-kcSWSVi_sxjsohD9F50Ruu7BAyoHTeB9ptDqpw.ttf',
      'DancingScript-Medium',
    );
    return font.getFont();
  }

  /// Dancing Script 600
  static Future<Font> dancingScriptSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/dancingscript/v16/If2cXTr6YS-zF4S-kcSWSVi_sxjsohD9F50Ruu7B7y0HTeB9ptDqpw.ttf',
      'DancingScript-SemiBold',
    );
    return font.getFont();
  }

  /// Dancing Script 700
  static Future<Font> dancingScriptBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/dancingscript/v16/If2cXTr6YS-zF4S-kcSWSVi_sxjsohD9F50Ruu7B1i0HTeB9ptDqpw.ttf',
      'DancingScript-Bold',
    );
    return font.getFont();
  }

  /// Dangrek regular
  static Future<Font> dangrekRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/dangrek/v14/LYjCdG30nEgoH8E2gCNqqVIuTN4.ttf',
      'Dangrek-Regular',
    );
    return font.getFont();
  }

  /// Darker Grotesque 300
  static Future<Font> darkerGrotesqueLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/darkergrotesque/v2/U9MA6cuh-mLQlC4BKCtayOfARkSVoxr2AW8hTOsXsX0.ttf',
      'DarkerGrotesque-Light',
    );
    return font.getFont();
  }

  /// Darker Grotesque regular
  static Future<Font> darkerGrotesqueRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/darkergrotesque/v2/U9MH6cuh-mLQlC4BKCtayOfARkSVm7beJWcKUOI.ttf',
      'DarkerGrotesque-Regular',
    );
    return font.getFont();
  }

  /// Darker Grotesque 500
  static Future<Font> darkerGrotesqueMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/darkergrotesque/v2/U9MA6cuh-mLQlC4BKCtayOfARkSVo0L3AW8hTOsXsX0.ttf',
      'DarkerGrotesque-Medium',
    );
    return font.getFont();
  }

  /// Darker Grotesque 600
  static Future<Font> darkerGrotesqueSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/darkergrotesque/v2/U9MA6cuh-mLQlC4BKCtayOfARkSVo27wAW8hTOsXsX0.ttf',
      'DarkerGrotesque-SemiBold',
    );
    return font.getFont();
  }

  /// Darker Grotesque 700
  static Future<Font> darkerGrotesqueBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/darkergrotesque/v2/U9MA6cuh-mLQlC4BKCtayOfARkSVowrxAW8hTOsXsX0.ttf',
      'DarkerGrotesque-Bold',
    );
    return font.getFont();
  }

  /// Darker Grotesque 800
  static Future<Font> darkerGrotesqueExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/darkergrotesque/v2/U9MA6cuh-mLQlC4BKCtayOfARkSVoxbyAW8hTOsXsX0.ttf',
      'DarkerGrotesque-ExtraBold',
    );
    return font.getFont();
  }

  /// Darker Grotesque 900
  static Future<Font> darkerGrotesqueBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/darkergrotesque/v2/U9MA6cuh-mLQlC4BKCtayOfARkSVozLzAW8hTOsXsX0.ttf',
      'DarkerGrotesque-Black',
    );
    return font.getFont();
  }

  /// David Libre regular
  static Future<Font> davidLibreRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/davidlibre/v5/snfus0W_99N64iuYSvp4W_l86p6TYS-Y.ttf',
      'DavidLibre-Regular',
    );
    return font.getFont();
  }

  /// David Libre 500
  static Future<Font> davidLibreMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/davidlibre/v5/snfzs0W_99N64iuYSvp4W8GIw7qbSjORSo9W.ttf',
      'DavidLibre-Medium',
    );
    return font.getFont();
  }

  /// David Libre 700
  static Future<Font> davidLibreBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/davidlibre/v5/snfzs0W_99N64iuYSvp4W8HAxbqbSjORSo9W.ttf',
      'DavidLibre-Bold',
    );
    return font.getFont();
  }

  /// Dawning of a New Day regular
  static Future<Font> dawningofaNewDayRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/dawningofanewday/v11/t5t_IQMbOp2SEwuncwLRjMfIg1yYit_nAz8bhWJGNoBE.ttf',
      'DawningofaNewDay-Regular',
    );
    return font.getFont();
  }

  /// Days One regular
  static Future<Font> daysOneRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/daysone/v10/mem9YaCnxnKRiYZOCLYVeLkWVNBt.ttf',
      'DaysOne-Regular',
    );
    return font.getFont();
  }

  /// Dekko regular
  static Future<Font> dekkoRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/dekko/v9/46khlb_wWjfSrttFR0vsfl1B.ttf',
      'Dekko-Regular',
    );
    return font.getFont();
  }

  /// Dela Gothic One regular
  static Future<Font> delaGothicOneRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/delagothicone/v4/hESp6XxvMDRA-2eD0lXpDa6QkBAGRUsJQAlbUA.ttf',
      'DelaGothicOne-Regular',
    );
    return font.getFont();
  }

  /// Delius regular
  static Future<Font> deliusRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/delius/v10/PN_xRfK0pW_9e1rtYcI-jT3L_w.ttf',
      'Delius-Regular',
    );
    return font.getFont();
  }

  /// Delius Swash Caps regular
  static Future<Font> deliusSwashCapsRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/deliusswashcaps/v14/oY1E8fPLr7v4JWCExZpWebxVKORpXXedKmeBvEYs.ttf',
      'DeliusSwashCaps-Regular',
    );
    return font.getFont();
  }

  /// Delius Unicase regular
  static Future<Font> deliusUnicaseRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/deliusunicase/v16/845BNMEwEIOVT8BmgfSzIr_6mmLHd-73LXWs.ttf',
      'DeliusUnicase-Regular',
    );
    return font.getFont();
  }

  /// Delius Unicase 700
  static Future<Font> deliusUnicaseBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/deliusunicase/v16/845CNMEwEIOVT8BmgfSzIr_6mlp7WMr_BmmlS5aw.ttf',
      'DeliusUnicase-Bold',
    );
    return font.getFont();
  }

  /// Della Respira regular
  static Future<Font> dellaRespiraRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/dellarespira/v10/RLp5K5v44KaueWI6iEJQBiGPRfkSu6EuTHo.ttf',
      'DellaRespira-Regular',
    );
    return font.getFont();
  }

  /// Denk One regular
  static Future<Font> denkOneRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/denkone/v10/dg4m_pzhrqcFb2IzROtHpbglShon.ttf',
      'DenkOne-Regular',
    );
    return font.getFont();
  }

  /// Devonshire regular
  static Future<Font> devonshireRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/devonshire/v11/46kqlbDwWirWr4gtBD2BX0Vq01lYAZM.ttf',
      'Devonshire-Regular',
    );
    return font.getFont();
  }

  /// Dhurjati regular
  static Future<Font> dhurjatiRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/dhurjati/v10/_6_8ED3gSeatXfFiFX3ySKQtuTA2.ttf',
      'Dhurjati-Regular',
    );
    return font.getFont();
  }

  /// Didact Gothic regular
  static Future<Font> didactGothicRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/didactgothic/v14/ahcfv8qz1zt6hCC5G4F_P4ASpUySp0LlcyQ.ttf',
      'DidactGothic-Regular',
    );
    return font.getFont();
  }

  /// Diplomata regular
  static Future<Font> diplomataRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/diplomata/v14/Cn-0JtiMXwhNwp-wKxyfYGxYrdM9Sg.ttf',
      'Diplomata-Regular',
    );
    return font.getFont();
  }

  /// Diplomata SC regular
  static Future<Font> diplomataSCRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/diplomatasc/v11/buExpoi3ecvs3kidKgBJo2kf-P5Oaiw4cw.ttf',
      'DiplomataSC-Regular',
    );
    return font.getFont();
  }

  /// Do Hyeon regular
  static Future<Font> doHyeonRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/dohyeon/v11/TwMN-I8CRRU2zM86HFE3ZwaH__-C.ttf',
      'DoHyeon-Regular',
    );
    return font.getFont();
  }

  /// Dokdo regular
  static Future<Font> dokdoRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/dokdo/v10/esDf315XNuCBLxLo4NaMlKcH.ttf',
      'Dokdo-Regular',
    );
    return font.getFont();
  }

  /// Domine regular
  static Future<Font> domineRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/domine/v11/L0xhDFMnlVwD4h3Lt9JWnbX3jG-2X3LAI10VErGuW8Q.ttf',
      'Domine-Regular',
    );
    return font.getFont();
  }

  /// Domine 500
  static Future<Font> domineMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/domine/v11/L0xhDFMnlVwD4h3Lt9JWnbX3jG-2X0DAI10VErGuW8Q.ttf',
      'Domine-Medium',
    );
    return font.getFont();
  }

  /// Domine 600
  static Future<Font> domineSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/domine/v11/L0xhDFMnlVwD4h3Lt9JWnbX3jG-2X6zHI10VErGuW8Q.ttf',
      'Domine-SemiBold',
    );
    return font.getFont();
  }

  /// Domine 700
  static Future<Font> domineBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/domine/v11/L0xhDFMnlVwD4h3Lt9JWnbX3jG-2X5XHI10VErGuW8Q.ttf',
      'Domine-Bold',
    );
    return font.getFont();
  }

  /// Donegal One regular
  static Future<Font> donegalOneRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/donegalone/v10/m8JWjfRYea-ZnFz6fsK9FZRFRG-K3Mud.ttf',
      'DonegalOne-Regular',
    );
    return font.getFont();
  }

  /// Doppio One regular
  static Future<Font> doppioOneRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/doppioone/v8/Gg8wN5gSaBfyBw2MqCh-lgshKGpe5Fg.ttf',
      'DoppioOne-Regular',
    );
    return font.getFont();
  }

  /// Dorsa regular
  static Future<Font> dorsaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/dorsa/v13/yYLn0hjd0OGwqo493XCFxAnQ.ttf',
      'Dorsa-Regular',
    );
    return font.getFont();
  }

  /// Dosis 200
  static Future<Font> dosisExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/dosis/v19/HhyJU5sn9vOmLxNkIwRSjTVNWLEJt7MV3BkFTq4EPw.ttf',
      'Dosis-ExtraLight',
    );
    return font.getFont();
  }

  /// Dosis 300
  static Future<Font> dosisLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/dosis/v19/HhyJU5sn9vOmLxNkIwRSjTVNWLEJabMV3BkFTq4EPw.ttf',
      'Dosis-Light',
    );
    return font.getFont();
  }

  /// Dosis regular
  static Future<Font> dosisRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/dosis/v19/HhyJU5sn9vOmLxNkIwRSjTVNWLEJN7MV3BkFTq4EPw.ttf',
      'Dosis-Regular',
    );
    return font.getFont();
  }

  /// Dosis 500
  static Future<Font> dosisMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/dosis/v19/HhyJU5sn9vOmLxNkIwRSjTVNWLEJBbMV3BkFTq4EPw.ttf',
      'Dosis-Medium',
    );
    return font.getFont();
  }

  /// Dosis 600
  static Future<Font> dosisSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/dosis/v19/HhyJU5sn9vOmLxNkIwRSjTVNWLEJ6bQV3BkFTq4EPw.ttf',
      'Dosis-SemiBold',
    );
    return font.getFont();
  }

  /// Dosis 700
  static Future<Font> dosisBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/dosis/v19/HhyJU5sn9vOmLxNkIwRSjTVNWLEJ0LQV3BkFTq4EPw.ttf',
      'Dosis-Bold',
    );
    return font.getFont();
  }

  /// Dosis 800
  static Future<Font> dosisExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/dosis/v19/HhyJU5sn9vOmLxNkIwRSjTVNWLEJt7QV3BkFTq4EPw.ttf',
      'Dosis-ExtraBold',
    );
    return font.getFont();
  }

  /// DotGothic16 regular
  static Future<Font> dotGothic16Regular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/dotgothic16/v4/v6-QGYjBJFKgyw5nSoDAGE7L435YPFrT.ttf',
      'DotGothic16-Regular',
    );
    return font.getFont();
  }

  /// Dr Sugiyama regular
  static Future<Font> drSugiyamaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/drsugiyama/v12/HTxoL2k4N3O9n5I1boGI7abRM4-t-g7y.ttf',
      'DrSugiyama-Regular',
    );
    return font.getFont();
  }

  /// Duru Sans regular
  static Future<Font> duruSansRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/durusans/v14/xn7iYH8xwmSyTvEV_HOxT_fYdN-WZw.ttf',
      'DuruSans-Regular',
    );
    return font.getFont();
  }

  /// Dynalight regular
  static Future<Font> dynalightRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/dynalight/v11/1Ptsg8LOU_aOmQvTsF4ISotrDfGGxA.ttf',
      'Dynalight-Regular',
    );
    return font.getFont();
  }

  /// EB Garamond regular
  static Future<Font> eBGaramondRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ebgaramond/v15/SlGDmQSNjdsmc35JDF1K5E55YMjF_7DPuGi-6_RUA4V-e6yHgQ.ttf',
      'EBGaramond-Regular',
    );
    return font.getFont();
  }

  /// EB Garamond 500
  static Future<Font> eBGaramondMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ebgaramond/v15/SlGDmQSNjdsmc35JDF1K5E55YMjF_7DPuGi-2fRUA4V-e6yHgQ.ttf',
      'EBGaramond-Medium',
    );
    return font.getFont();
  }

  /// EB Garamond 600
  static Future<Font> eBGaramondSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ebgaramond/v15/SlGDmQSNjdsmc35JDF1K5E55YMjF_7DPuGi-NfNUA4V-e6yHgQ.ttf',
      'EBGaramond-SemiBold',
    );
    return font.getFont();
  }

  /// EB Garamond 700
  static Future<Font> eBGaramondBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ebgaramond/v15/SlGDmQSNjdsmc35JDF1K5E55YMjF_7DPuGi-DPNUA4V-e6yHgQ.ttf',
      'EBGaramond-Bold',
    );
    return font.getFont();
  }

  /// EB Garamond 800
  static Future<Font> eBGaramondExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ebgaramond/v15/SlGDmQSNjdsmc35JDF1K5E55YMjF_7DPuGi-a_NUA4V-e6yHgQ.ttf',
      'EBGaramond-ExtraBold',
    );
    return font.getFont();
  }

  /// EB Garamond italic
  static Future<Font> eBGaramondItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ebgaramond/v15/SlGFmQSNjdsmc35JDF1K5GRwUjcdlttVFm-rI7e8QI96WamXgXFI.ttf',
      'EBGaramond-Italic',
    );
    return font.getFont();
  }

  /// EB Garamond 500italic
  static Future<Font> eBGaramondMediumItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ebgaramond/v15/SlGFmQSNjdsmc35JDF1K5GRwUjcdlttVFm-rI7eOQI96WamXgXFI.ttf',
      'EBGaramond-MediumItalic',
    );
    return font.getFont();
  }

  /// EB Garamond 600italic
  static Future<Font> eBGaramondSemiBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ebgaramond/v15/SlGFmQSNjdsmc35JDF1K5GRwUjcdlttVFm-rI7diR496WamXgXFI.ttf',
      'EBGaramond-SemiBoldItalic',
    );
    return font.getFont();
  }

  /// EB Garamond 700italic
  static Future<Font> eBGaramondBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ebgaramond/v15/SlGFmQSNjdsmc35JDF1K5GRwUjcdlttVFm-rI7dbR496WamXgXFI.ttf',
      'EBGaramond-BoldItalic',
    );
    return font.getFont();
  }

  /// EB Garamond 800italic
  static Future<Font> eBGaramondExtraBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ebgaramond/v15/SlGFmQSNjdsmc35JDF1K5GRwUjcdlttVFm-rI7c8R496WamXgXFI.ttf',
      'EBGaramond-ExtraBoldItalic',
    );
    return font.getFont();
  }

  /// Eagle Lake regular
  static Future<Font> eagleLakeRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/eaglelake/v10/ptRMTiqbbuNJDOiKj9wG5O7yKQNute8.ttf',
      'EagleLake-Regular',
    );
    return font.getFont();
  }

  /// East Sea Dokdo regular
  static Future<Font> eastSeaDokdoRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/eastseadokdo/v10/xfuo0Wn2V2_KanASqXSZp22m05_aGavYS18y.ttf',
      'EastSeaDokdo-Regular',
    );
    return font.getFont();
  }

  /// Eater regular
  static Future<Font> eaterRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/eater/v11/mtG04_FCK7bOvpu2u3FwsXsR.ttf',
      'Eater-Regular',
    );
    return font.getFont();
  }

  /// Economica regular
  static Future<Font> economicaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/economica/v8/Qw3fZQZaHCLgIWa29ZBrMcgAAl1lfQ.ttf',
      'Economica-Regular',
    );
    return font.getFont();
  }

  /// Economica italic
  static Future<Font> economicaItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/economica/v8/Qw3ZZQZaHCLgIWa29ZBbM8IEIFh1fWUl.ttf',
      'Economica-Italic',
    );
    return font.getFont();
  }

  /// Economica 700
  static Future<Font> economicaBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/economica/v8/Qw3aZQZaHCLgIWa29ZBTjeckCnZ5dHw8iw.ttf',
      'Economica-Bold',
    );
    return font.getFont();
  }

  /// Economica 700italic
  static Future<Font> economicaBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/economica/v8/Qw3EZQZaHCLgIWa29ZBbM_q4D3x9Vnksi4M7.ttf',
      'Economica-BoldItalic',
    );
    return font.getFont();
  }

  /// Eczar regular
  static Future<Font> eczarRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/eczar/v9/BXRlvF3Pi-DLmw0iBu9y8Hf0.ttf',
      'Eczar-Regular',
    );
    return font.getFont();
  }

  /// Eczar 500
  static Future<Font> eczarMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/eczar/v9/BXRovF3Pi-DLmzXWL8t622v9WNjW.ttf',
      'Eczar-Medium',
    );
    return font.getFont();
  }

  /// Eczar 600
  static Future<Font> eczarSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/eczar/v9/BXRovF3Pi-DLmzX6KMt622v9WNjW.ttf',
      'Eczar-SemiBold',
    );
    return font.getFont();
  }

  /// Eczar 700
  static Future<Font> eczarBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/eczar/v9/BXRovF3Pi-DLmzWeKct622v9WNjW.ttf',
      'Eczar-Bold',
    );
    return font.getFont();
  }

  /// Eczar 800
  static Future<Font> eczarExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/eczar/v9/BXRovF3Pi-DLmzWCKst622v9WNjW.ttf',
      'Eczar-ExtraBold',
    );
    return font.getFont();
  }

  /// El Messiri regular
  static Future<Font> elMessiriRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/elmessiri/v9/K2F0fZBRmr9vQ1pHEey6AoqKAyLzfWo.ttf',
      'ElMessiri-Regular',
    );
    return font.getFont();
  }

  /// El Messiri 500
  static Future<Font> elMessiriMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/elmessiri/v9/K2F3fZBRmr9vQ1pHEey6On6jJyrYYWOMluQ.ttf',
      'ElMessiri-Medium',
    );
    return font.getFont();
  }

  /// El Messiri 600
  static Future<Font> elMessiriSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/elmessiri/v9/K2F3fZBRmr9vQ1pHEey6OlKkJyrYYWOMluQ.ttf',
      'ElMessiri-SemiBold',
    );
    return font.getFont();
  }

  /// El Messiri 700
  static Future<Font> elMessiriBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/elmessiri/v9/K2F3fZBRmr9vQ1pHEey6OjalJyrYYWOMluQ.ttf',
      'ElMessiri-Bold',
    );
    return font.getFont();
  }

  /// Electrolize regular
  static Future<Font> electrolizeRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/electrolize/v9/cIf5Ma1dtE0zSiGSiED7AUEGso5tQafB.ttf',
      'Electrolize-Regular',
    );
    return font.getFont();
  }

  /// Elsie regular
  static Future<Font> elsieRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/elsie/v11/BCanqZABrez54yYu9slAeLgX.ttf',
      'Elsie-Regular',
    );
    return font.getFont();
  }

  /// Elsie 900
  static Future<Font> elsieBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/elsie/v11/BCaqqZABrez54x6q2-1IU6QeXSBk.ttf',
      'Elsie-Black',
    );
    return font.getFont();
  }

  /// Elsie Swash Caps regular
  static Future<Font> elsieSwashCapsRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/elsieswashcaps/v11/845DNN8xGZyVX5MVo_upKf7KnjK0ferVKGWsUo8.ttf',
      'ElsieSwashCaps-Regular',
    );
    return font.getFont();
  }

  /// Elsie Swash Caps 900
  static Future<Font> elsieSwashCapsBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/elsieswashcaps/v11/845ENN8xGZyVX5MVo_upKf7KnjK0RW74DG2HToawrdU.ttf',
      'ElsieSwashCaps-Black',
    );
    return font.getFont();
  }

  /// Emblema One regular
  static Future<Font> emblemaOneRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/emblemaone/v11/nKKT-GQ0F5dSY8vzG0rOEIRBHl57G_f_.ttf',
      'EmblemaOne-Regular',
    );
    return font.getFont();
  }

  /// Emilys Candy regular
  static Future<Font> emilysCandyRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/emilyscandy/v8/2EbgL-1mD1Rnb0OGKudbk0y5r9xrX84JjA.ttf',
      'EmilysCandy-Regular',
    );
    return font.getFont();
  }

  /// Encode Sans 100
  static Future<Font> encodeSansThin() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/encodesans/v8/LDIcapOFNxEwR-Bd1O9uYNmnUQomAgE25imKSbHhROjLsZBWTSrQGGHiZtWP7FJCt2c.ttf',
      'EncodeSans-Thin',
    );
    return font.getFont();
  }

  /// Encode Sans 200
  static Future<Font> encodeSansExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/encodesans/v8/LDIcapOFNxEwR-Bd1O9uYNmnUQomAgE25imKSbHhROjLsZBWTSrQGOHjZtWP7FJCt2c.ttf',
      'EncodeSans-ExtraLight',
    );
    return font.getFont();
  }

  /// Encode Sans 300
  static Future<Font> encodeSansLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/encodesans/v8/LDIcapOFNxEwR-Bd1O9uYNmnUQomAgE25imKSbHhROjLsZBWTSrQGD_jZtWP7FJCt2c.ttf',
      'EncodeSans-Light',
    );
    return font.getFont();
  }

  /// Encode Sans regular
  static Future<Font> encodeSansRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/encodesans/v8/LDIcapOFNxEwR-Bd1O9uYNmnUQomAgE25imKSbHhROjLsZBWTSrQGGHjZtWP7FJCt2c.ttf',
      'EncodeSans-Regular',
    );
    return font.getFont();
  }

  /// Encode Sans 500
  static Future<Font> encodeSansMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/encodesans/v8/LDIcapOFNxEwR-Bd1O9uYNmnUQomAgE25imKSbHhROjLsZBWTSrQGFPjZtWP7FJCt2c.ttf',
      'EncodeSans-Medium',
    );
    return font.getFont();
  }

  /// Encode Sans 600
  static Future<Font> encodeSansSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/encodesans/v8/LDIcapOFNxEwR-Bd1O9uYNmnUQomAgE25imKSbHhROjLsZBWTSrQGL_kZtWP7FJCt2c.ttf',
      'EncodeSans-SemiBold',
    );
    return font.getFont();
  }

  /// Encode Sans 700
  static Future<Font> encodeSansBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/encodesans/v8/LDIcapOFNxEwR-Bd1O9uYNmnUQomAgE25imKSbHhROjLsZBWTSrQGIbkZtWP7FJCt2c.ttf',
      'EncodeSans-Bold',
    );
    return font.getFont();
  }

  /// Encode Sans 800
  static Future<Font> encodeSansExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/encodesans/v8/LDIcapOFNxEwR-Bd1O9uYNmnUQomAgE25imKSbHhROjLsZBWTSrQGOHkZtWP7FJCt2c.ttf',
      'EncodeSans-ExtraBold',
    );
    return font.getFont();
  }

  /// Encode Sans 900
  static Future<Font> encodeSansBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/encodesans/v8/LDIcapOFNxEwR-Bd1O9uYNmnUQomAgE25imKSbHhROjLsZBWTSrQGMjkZtWP7FJCt2c.ttf',
      'EncodeSans-Black',
    );
    return font.getFont();
  }

  /// Encode Sans Condensed 100
  static Future<Font> encodeSansCondensedThin() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/encodesanscondensed/v5/j8_76_LD37rqfuwxyIuaZhE6cRXOLtm2gfT-5a-JLQoFI2KR.ttf',
      'EncodeSansCondensed-Thin',
    );
    return font.getFont();
  }

  /// Encode Sans Condensed 200
  static Future<Font> encodeSansCondensedExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/encodesanscondensed/v5/j8_46_LD37rqfuwxyIuaZhE6cRXOLtm2gfT-SY6pByQJKnuIFA.ttf',
      'EncodeSansCondensed-ExtraLight',
    );
    return font.getFont();
  }

  /// Encode Sans Condensed 300
  static Future<Font> encodeSansCondensedLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/encodesanscondensed/v5/j8_46_LD37rqfuwxyIuaZhE6cRXOLtm2gfT-LY2pByQJKnuIFA.ttf',
      'EncodeSansCondensed-Light',
    );
    return font.getFont();
  }

  /// Encode Sans Condensed regular
  static Future<Font> encodeSansCondensedRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/encodesanscondensed/v5/j8_16_LD37rqfuwxyIuaZhE6cRXOLtm2gfTGgaWNDw8VIw.ttf',
      'EncodeSansCondensed-Regular',
    );
    return font.getFont();
  }

  /// Encode Sans Condensed 500
  static Future<Font> encodeSansCondensedMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/encodesanscondensed/v5/j8_46_LD37rqfuwxyIuaZhE6cRXOLtm2gfT-dYypByQJKnuIFA.ttf',
      'EncodeSansCondensed-Medium',
    );
    return font.getFont();
  }

  /// Encode Sans Condensed 600
  static Future<Font> encodeSansCondensedSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/encodesanscondensed/v5/j8_46_LD37rqfuwxyIuaZhE6cRXOLtm2gfT-WYupByQJKnuIFA.ttf',
      'EncodeSansCondensed-SemiBold',
    );
    return font.getFont();
  }

  /// Encode Sans Condensed 700
  static Future<Font> encodeSansCondensedBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/encodesanscondensed/v5/j8_46_LD37rqfuwxyIuaZhE6cRXOLtm2gfT-PYqpByQJKnuIFA.ttf',
      'EncodeSansCondensed-Bold',
    );
    return font.getFont();
  }

  /// Encode Sans Condensed 800
  static Future<Font> encodeSansCondensedExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/encodesanscondensed/v5/j8_46_LD37rqfuwxyIuaZhE6cRXOLtm2gfT-IYmpByQJKnuIFA.ttf',
      'EncodeSansCondensed-ExtraBold',
    );
    return font.getFont();
  }

  /// Encode Sans Condensed 900
  static Future<Font> encodeSansCondensedBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/encodesanscondensed/v5/j8_46_LD37rqfuwxyIuaZhE6cRXOLtm2gfT-BYipByQJKnuIFA.ttf',
      'EncodeSansCondensed-Black',
    );
    return font.getFont();
  }

  /// Encode Sans Expanded 100
  static Future<Font> encodeSansExpandedThin() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/encodesansexpanded/v5/c4mx1mF4GcnstG_Jh1QH6ac4hNLeNyeYUpJGKQNicoAbJlw.ttf',
      'EncodeSansExpanded-Thin',
    );
    return font.getFont();
  }

  /// Encode Sans Expanded 200
  static Future<Font> encodeSansExpandedExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/encodesansexpanded/v5/c4mw1mF4GcnstG_Jh1QH6ac4hNLeNyeYUpLqCCNIXIwSP0XD.ttf',
      'EncodeSansExpanded-ExtraLight',
    );
    return font.getFont();
  }

  /// Encode Sans Expanded 300
  static Future<Font> encodeSansExpandedLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/encodesansexpanded/v5/c4mw1mF4GcnstG_Jh1QH6ac4hNLeNyeYUpKOCyNIXIwSP0XD.ttf',
      'EncodeSansExpanded-Light',
    );
    return font.getFont();
  }

  /// Encode Sans Expanded regular
  static Future<Font> encodeSansExpandedRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/encodesansexpanded/v5/c4m_1mF4GcnstG_Jh1QH6ac4hNLeNyeYUqoiIwdAd5Ab.ttf',
      'EncodeSansExpanded-Regular',
    );
    return font.getFont();
  }

  /// Encode Sans Expanded 500
  static Future<Font> encodeSansExpandedMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/encodesansexpanded/v5/c4mw1mF4GcnstG_Jh1QH6ac4hNLeNyeYUpLWCiNIXIwSP0XD.ttf',
      'EncodeSansExpanded-Medium',
    );
    return font.getFont();
  }

  /// Encode Sans Expanded 600
  static Future<Font> encodeSansExpandedSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/encodesansexpanded/v5/c4mw1mF4GcnstG_Jh1QH6ac4hNLeNyeYUpL6DSNIXIwSP0XD.ttf',
      'EncodeSansExpanded-SemiBold',
    );
    return font.getFont();
  }

  /// Encode Sans Expanded 700
  static Future<Font> encodeSansExpandedBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/encodesansexpanded/v5/c4mw1mF4GcnstG_Jh1QH6ac4hNLeNyeYUpKeDCNIXIwSP0XD.ttf',
      'EncodeSansExpanded-Bold',
    );
    return font.getFont();
  }

  /// Encode Sans Expanded 800
  static Future<Font> encodeSansExpandedExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/encodesansexpanded/v5/c4mw1mF4GcnstG_Jh1QH6ac4hNLeNyeYUpKCDyNIXIwSP0XD.ttf',
      'EncodeSansExpanded-ExtraBold',
    );
    return font.getFont();
  }

  /// Encode Sans Expanded 900
  static Future<Font> encodeSansExpandedBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/encodesansexpanded/v5/c4mw1mF4GcnstG_Jh1QH6ac4hNLeNyeYUpKmDiNIXIwSP0XD.ttf',
      'EncodeSansExpanded-Black',
    );
    return font.getFont();
  }

  /// Encode Sans Semi Condensed 100
  static Future<Font> encodeSansSemiCondensedThin() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/encodesanssemicondensed/v5/3qT6oiKqnDuUtQUEHMoXcmspmy55SFWrXFRp9FTOG1T19MFtQ9jpVUA.ttf',
      'EncodeSansSemiCondensed-Thin',
    );
    return font.getFont();
  }

  /// Encode Sans Semi Condensed 200
  static Future<Font> encodeSansSemiCondensedExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/encodesanssemicondensed/v5/3qT7oiKqnDuUtQUEHMoXcmspmy55SFWrXFRp9FTOG1RZ1eFHbdTgTFmr.ttf',
      'EncodeSansSemiCondensed-ExtraLight',
    );
    return font.getFont();
  }

  /// Encode Sans Semi Condensed 300
  static Future<Font> encodeSansSemiCondensedLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/encodesanssemicondensed/v5/3qT7oiKqnDuUtQUEHMoXcmspmy55SFWrXFRp9FTOG1Q91uFHbdTgTFmr.ttf',
      'EncodeSansSemiCondensed-Light',
    );
    return font.getFont();
  }

  /// Encode Sans Semi Condensed regular
  static Future<Font> encodeSansSemiCondensedRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/encodesanssemicondensed/v5/3qT4oiKqnDuUtQUEHMoXcmspmy55SFWrXFRp9FTOG2yR_sVPRsjp.ttf',
      'EncodeSansSemiCondensed-Regular',
    );
    return font.getFont();
  }

  /// Encode Sans Semi Condensed 500
  static Future<Font> encodeSansSemiCondensedMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/encodesanssemicondensed/v5/3qT7oiKqnDuUtQUEHMoXcmspmy55SFWrXFRp9FTOG1Rl1-FHbdTgTFmr.ttf',
      'EncodeSansSemiCondensed-Medium',
    );
    return font.getFont();
  }

  /// Encode Sans Semi Condensed 600
  static Future<Font> encodeSansSemiCondensedSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/encodesanssemicondensed/v5/3qT7oiKqnDuUtQUEHMoXcmspmy55SFWrXFRp9FTOG1RJ0OFHbdTgTFmr.ttf',
      'EncodeSansSemiCondensed-SemiBold',
    );
    return font.getFont();
  }

  /// Encode Sans Semi Condensed 700
  static Future<Font> encodeSansSemiCondensedBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/encodesanssemicondensed/v5/3qT7oiKqnDuUtQUEHMoXcmspmy55SFWrXFRp9FTOG1Qt0eFHbdTgTFmr.ttf',
      'EncodeSansSemiCondensed-Bold',
    );
    return font.getFont();
  }

  /// Encode Sans Semi Condensed 800
  static Future<Font> encodeSansSemiCondensedExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/encodesanssemicondensed/v5/3qT7oiKqnDuUtQUEHMoXcmspmy55SFWrXFRp9FTOG1Qx0uFHbdTgTFmr.ttf',
      'EncodeSansSemiCondensed-ExtraBold',
    );
    return font.getFont();
  }

  /// Encode Sans Semi Condensed 900
  static Future<Font> encodeSansSemiCondensedBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/encodesanssemicondensed/v5/3qT7oiKqnDuUtQUEHMoXcmspmy55SFWrXFRp9FTOG1QV0-FHbdTgTFmr.ttf',
      'EncodeSansSemiCondensed-Black',
    );
    return font.getFont();
  }

  /// Encode Sans Semi Expanded 100
  static Future<Font> encodeSansSemiExpandedThin() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/encodesanssemiexpanded/v8/ke8xOhAPMEZs-BDuzwftTNJ85JvwMOzE9d9Cca5TM-41KwrlKXeOEA.ttf',
      'EncodeSansSemiExpanded-Thin',
    );
    return font.getFont();
  }

  /// Encode Sans Semi Expanded 200
  static Future<Font> encodeSansSemiExpandedExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/encodesanssemiexpanded/v8/ke8yOhAPMEZs-BDuzwftTNJ85JvwMOzE9d9Cca5TM0IUCyDLJX6XCWU.ttf',
      'EncodeSansSemiExpanded-ExtraLight',
    );
    return font.getFont();
  }

  /// Encode Sans Semi Expanded 300
  static Future<Font> encodeSansSemiExpandedLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/encodesanssemiexpanded/v8/ke8yOhAPMEZs-BDuzwftTNJ85JvwMOzE9d9Cca5TMyYXCyDLJX6XCWU.ttf',
      'EncodeSansSemiExpanded-Light',
    );
    return font.getFont();
  }

  /// Encode Sans Semi Expanded regular
  static Future<Font> encodeSansSemiExpandedRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/encodesanssemiexpanded/v8/ke83OhAPMEZs-BDuzwftTNJ85JvwMOzE9d9Cca5TC4o_LyjgOXc.ttf',
      'EncodeSansSemiExpanded-Regular',
    );
    return font.getFont();
  }

  /// Encode Sans Semi Expanded 500
  static Future<Font> encodeSansSemiExpandedMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/encodesanssemiexpanded/v8/ke8yOhAPMEZs-BDuzwftTNJ85JvwMOzE9d9Cca5TM34WCyDLJX6XCWU.ttf',
      'EncodeSansSemiExpanded-Medium',
    );
    return font.getFont();
  }

  /// Encode Sans Semi Expanded 600
  static Future<Font> encodeSansSemiExpandedSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/encodesanssemiexpanded/v8/ke8yOhAPMEZs-BDuzwftTNJ85JvwMOzE9d9Cca5TM1IRCyDLJX6XCWU.ttf',
      'EncodeSansSemiExpanded-SemiBold',
    );
    return font.getFont();
  }

  /// Encode Sans Semi Expanded 700
  static Future<Font> encodeSansSemiExpandedBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/encodesanssemiexpanded/v8/ke8yOhAPMEZs-BDuzwftTNJ85JvwMOzE9d9Cca5TMzYQCyDLJX6XCWU.ttf',
      'EncodeSansSemiExpanded-Bold',
    );
    return font.getFont();
  }

  /// Encode Sans Semi Expanded 800
  static Future<Font> encodeSansSemiExpandedExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/encodesanssemiexpanded/v8/ke8yOhAPMEZs-BDuzwftTNJ85JvwMOzE9d9Cca5TMyoTCyDLJX6XCWU.ttf',
      'EncodeSansSemiExpanded-ExtraBold',
    );
    return font.getFont();
  }

  /// Encode Sans Semi Expanded 900
  static Future<Font> encodeSansSemiExpandedBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/encodesanssemiexpanded/v8/ke8yOhAPMEZs-BDuzwftTNJ85JvwMOzE9d9Cca5TMw4SCyDLJX6XCWU.ttf',
      'EncodeSansSemiExpanded-Black',
    );
    return font.getFont();
  }

  /// Engagement regular
  static Future<Font> engagementRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/engagement/v12/x3dlckLDZbqa7RUs9MFVXNossybsHQI.ttf',
      'Engagement-Regular',
    );
    return font.getFont();
  }

  /// Englebert regular
  static Future<Font> englebertRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/englebert/v10/xn7iYH8w2XGrC8AR4HSxT_fYdN-WZw.ttf',
      'Englebert-Regular',
    );
    return font.getFont();
  }

  /// Enriqueta regular
  static Future<Font> enriquetaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/enriqueta/v10/goksH6L7AUFrRvV44HVTS0CjkP1Yog.ttf',
      'Enriqueta-Regular',
    );
    return font.getFont();
  }

  /// Enriqueta 500
  static Future<Font> enriquetaMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/enriqueta/v10/gokpH6L7AUFrRvV44HVrv2mHmNZEq6TTFw.ttf',
      'Enriqueta-Medium',
    );
    return font.getFont();
  }

  /// Enriqueta 600
  static Future<Font> enriquetaSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/enriqueta/v10/gokpH6L7AUFrRvV44HVrk26HmNZEq6TTFw.ttf',
      'Enriqueta-SemiBold',
    );
    return font.getFont();
  }

  /// Enriqueta 700
  static Future<Font> enriquetaBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/enriqueta/v10/gokpH6L7AUFrRvV44HVr92-HmNZEq6TTFw.ttf',
      'Enriqueta-Bold',
    );
    return font.getFont();
  }

  /// Epilogue 100
  static Future<Font> epilogueThin() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/epilogue/v4/O4ZMFGj5hxF0EhjimngomvnCCtqb30OXMDLiDJXVigHPVA.ttf',
      'Epilogue-Thin',
    );
    return font.getFont();
  }

  /// Epilogue 200
  static Future<Font> epilogueExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/epilogue/v4/O4ZMFGj5hxF0EhjimngomvnCCtqb30OXsDPiDJXVigHPVA.ttf',
      'Epilogue-ExtraLight',
    );
    return font.getFont();
  }

  /// Epilogue 300
  static Future<Font> epilogueLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/epilogue/v4/O4ZMFGj5hxF0EhjimngomvnCCtqb30OXbjPiDJXVigHPVA.ttf',
      'Epilogue-Light',
    );
    return font.getFont();
  }

  /// Epilogue regular
  static Future<Font> epilogueRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/epilogue/v4/O4ZMFGj5hxF0EhjimngomvnCCtqb30OXMDPiDJXVigHPVA.ttf',
      'Epilogue-Regular',
    );
    return font.getFont();
  }

  /// Epilogue 500
  static Future<Font> epilogueMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/epilogue/v4/O4ZMFGj5hxF0EhjimngomvnCCtqb30OXAjPiDJXVigHPVA.ttf',
      'Epilogue-Medium',
    );
    return font.getFont();
  }

  /// Epilogue 600
  static Future<Font> epilogueSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/epilogue/v4/O4ZMFGj5hxF0EhjimngomvnCCtqb30OX7jTiDJXVigHPVA.ttf',
      'Epilogue-SemiBold',
    );
    return font.getFont();
  }

  /// Epilogue 700
  static Future<Font> epilogueBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/epilogue/v4/O4ZMFGj5hxF0EhjimngomvnCCtqb30OX1zTiDJXVigHPVA.ttf',
      'Epilogue-Bold',
    );
    return font.getFont();
  }

  /// Epilogue 800
  static Future<Font> epilogueExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/epilogue/v4/O4ZMFGj5hxF0EhjimngomvnCCtqb30OXsDTiDJXVigHPVA.ttf',
      'Epilogue-ExtraBold',
    );
    return font.getFont();
  }

  /// Epilogue 900
  static Future<Font> epilogueBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/epilogue/v4/O4ZMFGj5hxF0EhjimngomvnCCtqb30OXmTTiDJXVigHPVA.ttf',
      'Epilogue-Black',
    );
    return font.getFont();
  }

  /// Epilogue 100italic
  static Future<Font> epilogueThinItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/epilogue/v4/O4ZCFGj5hxF0EhjimlIhqAYaY7EBcUSC-HAKTp_RqATfVHNU.ttf',
      'Epilogue-ThinItalic',
    );
    return font.getFont();
  }

  /// Epilogue 200italic
  static Future<Font> epilogueExtraLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/epilogue/v4/O4ZCFGj5hxF0EhjimlIhqAYaY7EBcUSC-HCKT5_RqATfVHNU.ttf',
      'Epilogue-ExtraLightItalic',
    );
    return font.getFont();
  }

  /// Epilogue 300italic
  static Future<Font> epilogueLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/epilogue/v4/O4ZCFGj5hxF0EhjimlIhqAYaY7EBcUSC-HBUT5_RqATfVHNU.ttf',
      'Epilogue-LightItalic',
    );
    return font.getFont();
  }

  /// Epilogue italic
  static Future<Font> epilogueItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/epilogue/v4/O4ZCFGj5hxF0EhjimlIhqAYaY7EBcUSC-HAKT5_RqATfVHNU.ttf',
      'Epilogue-Italic',
    );
    return font.getFont();
  }

  /// Epilogue 500italic
  static Future<Font> epilogueMediumItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/epilogue/v4/O4ZCFGj5hxF0EhjimlIhqAYaY7EBcUSC-HA4T5_RqATfVHNU.ttf',
      'Epilogue-MediumItalic',
    );
    return font.getFont();
  }

  /// Epilogue 600italic
  static Future<Font> epilogueSemiBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/epilogue/v4/O4ZCFGj5hxF0EhjimlIhqAYaY7EBcUSC-HDUSJ_RqATfVHNU.ttf',
      'Epilogue-SemiBoldItalic',
    );
    return font.getFont();
  }

  /// Epilogue 700italic
  static Future<Font> epilogueBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/epilogue/v4/O4ZCFGj5hxF0EhjimlIhqAYaY7EBcUSC-HDtSJ_RqATfVHNU.ttf',
      'Epilogue-BoldItalic',
    );
    return font.getFont();
  }

  /// Epilogue 800italic
  static Future<Font> epilogueExtraBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/epilogue/v4/O4ZCFGj5hxF0EhjimlIhqAYaY7EBcUSC-HCKSJ_RqATfVHNU.ttf',
      'Epilogue-ExtraBoldItalic',
    );
    return font.getFont();
  }

  /// Epilogue 900italic
  static Future<Font> epilogueBlackItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/epilogue/v4/O4ZCFGj5hxF0EhjimlIhqAYaY7EBcUSC-HCjSJ_RqATfVHNU.ttf',
      'Epilogue-BlackItalic',
    );
    return font.getFont();
  }

  /// Erica One regular
  static Future<Font> ericaOneRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ericaone/v13/WBLnrEXccV9VGrOKmGD1W0_MJMGxiQ.ttf',
      'EricaOne-Regular',
    );
    return font.getFont();
  }

  /// Esteban regular
  static Future<Font> estebanRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/esteban/v9/r05bGLZE-bdGdN-GdOuD5jokU8E.ttf',
      'Esteban-Regular',
    );
    return font.getFont();
  }

  /// Euphoria Script regular
  static Future<Font> euphoriaScriptRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/euphoriascript/v11/mFTpWb0X2bLb_cx6To2B8GpKoD5ak_ZT1D8x7Q.ttf',
      'EuphoriaScript-Regular',
    );
    return font.getFont();
  }

  /// Ewert regular
  static Future<Font> ewertRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ewert/v10/va9I4kzO2tFODYBvS-J3kbDP.ttf',
      'Ewert-Regular',
    );
    return font.getFont();
  }

  /// Exo 100
  static Future<Font> exoThin() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/exo/v12/4UaZrEtFpBI4f1ZSIK9d4LjJ4lM2CwNsOl4p5Is.ttf',
      'Exo-Thin',
    );
    return font.getFont();
  }

  /// Exo 200
  static Future<Font> exoExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/exo/v12/4UaZrEtFpBI4f1ZSIK9d4LjJ4tM3CwNsOl4p5Is.ttf',
      'Exo-ExtraLight',
    );
    return font.getFont();
  }

  /// Exo 300
  static Future<Font> exoLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/exo/v12/4UaZrEtFpBI4f1ZSIK9d4LjJ4g03CwNsOl4p5Is.ttf',
      'Exo-Light',
    );
    return font.getFont();
  }

  /// Exo regular
  static Future<Font> exoRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/exo/v12/4UaZrEtFpBI4f1ZSIK9d4LjJ4lM3CwNsOl4p5Is.ttf',
      'Exo-Regular',
    );
    return font.getFont();
  }

  /// Exo 500
  static Future<Font> exoMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/exo/v12/4UaZrEtFpBI4f1ZSIK9d4LjJ4mE3CwNsOl4p5Is.ttf',
      'Exo-Medium',
    );
    return font.getFont();
  }

  /// Exo 600
  static Future<Font> exoSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/exo/v12/4UaZrEtFpBI4f1ZSIK9d4LjJ4o0wCwNsOl4p5Is.ttf',
      'Exo-SemiBold',
    );
    return font.getFont();
  }

  /// Exo 700
  static Future<Font> exoBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/exo/v12/4UaZrEtFpBI4f1ZSIK9d4LjJ4rQwCwNsOl4p5Is.ttf',
      'Exo-Bold',
    );
    return font.getFont();
  }

  /// Exo 800
  static Future<Font> exoExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/exo/v12/4UaZrEtFpBI4f1ZSIK9d4LjJ4tMwCwNsOl4p5Is.ttf',
      'Exo-ExtraBold',
    );
    return font.getFont();
  }

  /// Exo 900
  static Future<Font> exoBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/exo/v12/4UaZrEtFpBI4f1ZSIK9d4LjJ4vowCwNsOl4p5Is.ttf',
      'Exo-Black',
    );
    return font.getFont();
  }

  /// Exo 100italic
  static Future<Font> exoThinItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/exo/v12/4UafrEtFpBISdmSt-MY2ehbO95t040FmPnws9Iu-uA.ttf',
      'Exo-ThinItalic',
    );
    return font.getFont();
  }

  /// Exo 200italic
  static Future<Font> exoExtraLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/exo/v12/4UafrEtFpBISdmSt-MY2ehbO95t0Y0BmPnws9Iu-uA.ttf',
      'Exo-ExtraLightItalic',
    );
    return font.getFont();
  }

  /// Exo 300italic
  static Future<Font> exoLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/exo/v12/4UafrEtFpBISdmSt-MY2ehbO95t0vUBmPnws9Iu-uA.ttf',
      'Exo-LightItalic',
    );
    return font.getFont();
  }

  /// Exo italic
  static Future<Font> exoItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/exo/v12/4UafrEtFpBISdmSt-MY2ehbO95t040BmPnws9Iu-uA.ttf',
      'Exo-Italic',
    );
    return font.getFont();
  }

  /// Exo 500italic
  static Future<Font> exoMediumItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/exo/v12/4UafrEtFpBISdmSt-MY2ehbO95t00UBmPnws9Iu-uA.ttf',
      'Exo-MediumItalic',
    );
    return font.getFont();
  }

  /// Exo 600italic
  static Future<Font> exoSemiBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/exo/v12/4UafrEtFpBISdmSt-MY2ehbO95t0PUdmPnws9Iu-uA.ttf',
      'Exo-SemiBoldItalic',
    );
    return font.getFont();
  }

  /// Exo 700italic
  static Future<Font> exoBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/exo/v12/4UafrEtFpBISdmSt-MY2ehbO95t0BEdmPnws9Iu-uA.ttf',
      'Exo-BoldItalic',
    );
    return font.getFont();
  }

  /// Exo 800italic
  static Future<Font> exoExtraBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/exo/v12/4UafrEtFpBISdmSt-MY2ehbO95t0Y0dmPnws9Iu-uA.ttf',
      'Exo-ExtraBoldItalic',
    );
    return font.getFont();
  }

  /// Exo 900italic
  static Future<Font> exoBlackItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/exo/v12/4UafrEtFpBISdmSt-MY2ehbO95t0SkdmPnws9Iu-uA.ttf',
      'Exo-BlackItalic',
    );
    return font.getFont();
  }

  /// Exo 2 100
  static Future<Font> exo2Thin() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/exo2/v10/7cH1v4okm5zmbvwkAx_sfcEuiD8jvvOcPtq-rpvLpQ.ttf',
      'Exo2-Thin',
    );
    return font.getFont();
  }

  /// Exo 2 200
  static Future<Font> exo2ExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/exo2/v10/7cH1v4okm5zmbvwkAx_sfcEuiD8jPvKcPtq-rpvLpQ.ttf',
      'Exo2-ExtraLight',
    );
    return font.getFont();
  }

  /// Exo 2 300
  static Future<Font> exo2Light() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/exo2/v10/7cH1v4okm5zmbvwkAx_sfcEuiD8j4PKcPtq-rpvLpQ.ttf',
      'Exo2-Light',
    );
    return font.getFont();
  }

  /// Exo 2 regular
  static Future<Font> exo2Regular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/exo2/v10/7cH1v4okm5zmbvwkAx_sfcEuiD8jvvKcPtq-rpvLpQ.ttf',
      'Exo2-Regular',
    );
    return font.getFont();
  }

  /// Exo 2 500
  static Future<Font> exo2Medium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/exo2/v10/7cH1v4okm5zmbvwkAx_sfcEuiD8jjPKcPtq-rpvLpQ.ttf',
      'Exo2-Medium',
    );
    return font.getFont();
  }

  /// Exo 2 600
  static Future<Font> exo2SemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/exo2/v10/7cH1v4okm5zmbvwkAx_sfcEuiD8jYPWcPtq-rpvLpQ.ttf',
      'Exo2-SemiBold',
    );
    return font.getFont();
  }

  /// Exo 2 700
  static Future<Font> exo2Bold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/exo2/v10/7cH1v4okm5zmbvwkAx_sfcEuiD8jWfWcPtq-rpvLpQ.ttf',
      'Exo2-Bold',
    );
    return font.getFont();
  }

  /// Exo 2 800
  static Future<Font> exo2ExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/exo2/v10/7cH1v4okm5zmbvwkAx_sfcEuiD8jPvWcPtq-rpvLpQ.ttf',
      'Exo2-ExtraBold',
    );
    return font.getFont();
  }

  /// Exo 2 900
  static Future<Font> exo2Black() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/exo2/v10/7cH1v4okm5zmbvwkAx_sfcEuiD8jF_WcPtq-rpvLpQ.ttf',
      'Exo2-Black',
    );
    return font.getFont();
  }

  /// Exo 2 100italic
  static Future<Font> exo2ThinItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/exo2/v10/7cH3v4okm5zmbtYtMeA0FKq0Jjg2drF0fNC6jJ7bpQBL.ttf',
      'Exo2-ThinItalic',
    );
    return font.getFont();
  }

  /// Exo 2 200italic
  static Future<Font> exo2ExtraLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/exo2/v10/7cH3v4okm5zmbtYtMeA0FKq0Jjg2drH0fdC6jJ7bpQBL.ttf',
      'Exo2-ExtraLightItalic',
    );
    return font.getFont();
  }

  /// Exo 2 300italic
  static Future<Font> exo2LightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/exo2/v10/7cH3v4okm5zmbtYtMeA0FKq0Jjg2drEqfdC6jJ7bpQBL.ttf',
      'Exo2-LightItalic',
    );
    return font.getFont();
  }

  /// Exo 2 italic
  static Future<Font> exo2Italic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/exo2/v10/7cH3v4okm5zmbtYtMeA0FKq0Jjg2drF0fdC6jJ7bpQBL.ttf',
      'Exo2-Italic',
    );
    return font.getFont();
  }

  /// Exo 2 500italic
  static Future<Font> exo2MediumItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/exo2/v10/7cH3v4okm5zmbtYtMeA0FKq0Jjg2drFGfdC6jJ7bpQBL.ttf',
      'Exo2-MediumItalic',
    );
    return font.getFont();
  }

  /// Exo 2 600italic
  static Future<Font> exo2SemiBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/exo2/v10/7cH3v4okm5zmbtYtMeA0FKq0Jjg2drGqetC6jJ7bpQBL.ttf',
      'Exo2-SemiBoldItalic',
    );
    return font.getFont();
  }

  /// Exo 2 700italic
  static Future<Font> exo2BoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/exo2/v10/7cH3v4okm5zmbtYtMeA0FKq0Jjg2drGTetC6jJ7bpQBL.ttf',
      'Exo2-BoldItalic',
    );
    return font.getFont();
  }

  /// Exo 2 800italic
  static Future<Font> exo2ExtraBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/exo2/v10/7cH3v4okm5zmbtYtMeA0FKq0Jjg2drH0etC6jJ7bpQBL.ttf',
      'Exo2-ExtraBoldItalic',
    );
    return font.getFont();
  }

  /// Exo 2 900italic
  static Future<Font> exo2BlackItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/exo2/v10/7cH3v4okm5zmbtYtMeA0FKq0Jjg2drHdetC6jJ7bpQBL.ttf',
      'Exo2-BlackItalic',
    );
    return font.getFont();
  }

  /// Expletus Sans regular
  static Future<Font> expletusSansRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/expletussans/v14/RLp5K5v5_bqufTYdnhFzDj2dRfkSu6EuTHo.ttf',
      'ExpletusSans-Regular',
    );
    return font.getFont();
  }

  /// Expletus Sans italic
  static Future<Font> expletusSansItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/expletussans/v14/RLpnK5v5_bqufTYdnhFzDj2ddfsYv4MrXHrRDA.ttf',
      'ExpletusSans-Italic',
    );
    return font.getFont();
  }

  /// Expletus Sans 500
  static Future<Font> expletusSansMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/expletussans/v14/RLpkK5v5_bqufTYdnhFzDj2dfQ07n6kFUHPIFaU.ttf',
      'ExpletusSans-Medium',
    );
    return font.getFont();
  }

  /// Expletus Sans 500italic
  static Future<Font> expletusSansMediumItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/expletussans/v14/RLpiK5v5_bqufTYdnhFzDj2ddfsgS6oPVFHNBaVImA.ttf',
      'ExpletusSans-MediumItalic',
    );
    return font.getFont();
  }

  /// Expletus Sans 600
  static Future<Font> expletusSansSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/expletussans/v14/RLpkK5v5_bqufTYdnhFzDj2dfSE8n6kFUHPIFaU.ttf',
      'ExpletusSans-SemiBold',
    );
    return font.getFont();
  }

  /// Expletus Sans 600italic
  static Future<Font> expletusSansSemiBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/expletussans/v14/RLpiK5v5_bqufTYdnhFzDj2ddfsgZ60PVFHNBaVImA.ttf',
      'ExpletusSans-SemiBoldItalic',
    );
    return font.getFont();
  }

  /// Expletus Sans 700
  static Future<Font> expletusSansBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/expletussans/v14/RLpkK5v5_bqufTYdnhFzDj2dfUU9n6kFUHPIFaU.ttf',
      'ExpletusSans-Bold',
    );
    return font.getFont();
  }

  /// Expletus Sans 700italic
  static Future<Font> expletusSansBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/expletussans/v14/RLpiK5v5_bqufTYdnhFzDj2ddfsgA6wPVFHNBaVImA.ttf',
      'ExpletusSans-BoldItalic',
    );
    return font.getFont();
  }

  /// Fahkwang 200
  static Future<Font> fahkwangExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/fahkwang/v6/Noa26Uj3zpmBOgbNpOJHmZlRFipxkwjx.ttf',
      'Fahkwang-ExtraLight',
    );
    return font.getFont();
  }

  /// Fahkwang 200italic
  static Future<Font> fahkwangExtraLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/fahkwang/v6/Noa06Uj3zpmBOgbNpOqNgHFQHC5Tlhjxdw4.ttf',
      'Fahkwang-ExtraLightItalic',
    );
    return font.getFont();
  }

  /// Fahkwang 300
  static Future<Font> fahkwangLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/fahkwang/v6/Noa26Uj3zpmBOgbNpOIjmplRFipxkwjx.ttf',
      'Fahkwang-Light',
    );
    return font.getFont();
  }

  /// Fahkwang 300italic
  static Future<Font> fahkwangLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/fahkwang/v6/Noa06Uj3zpmBOgbNpOqNgBVTHC5Tlhjxdw4.ttf',
      'Fahkwang-LightItalic',
    );
    return font.getFont();
  }

  /// Fahkwang regular
  static Future<Font> fahkwangRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/fahkwang/v6/Noax6Uj3zpmBOgbNpNqPsr1ZPTZ4.ttf',
      'Fahkwang-Regular',
    );
    return font.getFont();
  }

  /// Fahkwang italic
  static Future<Font> fahkwangItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/fahkwang/v6/Noa36Uj3zpmBOgbNpOqNuLl7OCZ4ihE.ttf',
      'Fahkwang-Italic',
    );
    return font.getFont();
  }

  /// Fahkwang 500
  static Future<Font> fahkwangMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/fahkwang/v6/Noa26Uj3zpmBOgbNpOJ7m5lRFipxkwjx.ttf',
      'Fahkwang-Medium',
    );
    return font.getFont();
  }

  /// Fahkwang 500italic
  static Future<Font> fahkwangMediumItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/fahkwang/v6/Noa06Uj3zpmBOgbNpOqNgE1SHC5Tlhjxdw4.ttf',
      'Fahkwang-MediumItalic',
    );
    return font.getFont();
  }

  /// Fahkwang 600
  static Future<Font> fahkwangSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/fahkwang/v6/Noa26Uj3zpmBOgbNpOJXnJlRFipxkwjx.ttf',
      'Fahkwang-SemiBold',
    );
    return font.getFont();
  }

  /// Fahkwang 600italic
  static Future<Font> fahkwangSemiBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/fahkwang/v6/Noa06Uj3zpmBOgbNpOqNgGFVHC5Tlhjxdw4.ttf',
      'Fahkwang-SemiBoldItalic',
    );
    return font.getFont();
  }

  /// Fahkwang 700
  static Future<Font> fahkwangBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/fahkwang/v6/Noa26Uj3zpmBOgbNpOIznZlRFipxkwjx.ttf',
      'Fahkwang-Bold',
    );
    return font.getFont();
  }

  /// Fahkwang 700italic
  static Future<Font> fahkwangBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/fahkwang/v6/Noa06Uj3zpmBOgbNpOqNgAVUHC5Tlhjxdw4.ttf',
      'Fahkwang-BoldItalic',
    );
    return font.getFont();
  }

  /// Fanwood Text regular
  static Future<Font> fanwoodTextRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/fanwoodtext/v10/3XFtErwl05Ad_vSCF6Fq7xXGRdbY1P1Sbg.ttf',
      'FanwoodText-Regular',
    );
    return font.getFont();
  }

  /// Fanwood Text italic
  static Future<Font> fanwoodTextItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/fanwoodtext/v10/3XFzErwl05Ad_vSCF6Fq7xX2R9zc9vhCblye.ttf',
      'FanwoodText-Italic',
    );
    return font.getFont();
  }

  /// Farro 300
  static Future<Font> farroLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/farro/v4/i7dJIFl3byGNHa3hNJ6-WkJUQUq7.ttf',
      'Farro-Light',
    );
    return font.getFont();
  }

  /// Farro regular
  static Future<Font> farroRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/farro/v4/i7dEIFl3byGNHZVNHLq2cV5d.ttf',
      'Farro-Regular',
    );
    return font.getFont();
  }

  /// Farro 500
  static Future<Font> farroMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/farro/v4/i7dJIFl3byGNHa25NZ6-WkJUQUq7.ttf',
      'Farro-Medium',
    );
    return font.getFont();
  }

  /// Farro 700
  static Future<Font> farroBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/farro/v4/i7dJIFl3byGNHa3xM56-WkJUQUq7.ttf',
      'Farro-Bold',
    );
    return font.getFont();
  }

  /// Farsan regular
  static Future<Font> farsanRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/farsan/v8/VEMwRoJ0vY_zsyz62q-pxDX9rQ.ttf',
      'Farsan-Regular',
    );
    return font.getFont();
  }

  /// Fascinate regular
  static Future<Font> fascinateRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/fascinate/v11/z7NWdRrufC8XJK0IIEli1LbQRPyNrw.ttf',
      'Fascinate-Regular',
    );
    return font.getFont();
  }

  /// Fascinate Inline regular
  static Future<Font> fascinateInlineRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/fascinateinline/v12/jVyR7mzzB3zc-jp6QCAu60poNqIy1g3CfRXxWZQ.ttf',
      'FascinateInline-Regular',
    );
    return font.getFont();
  }

  /// Faster One regular
  static Future<Font> fasterOneRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/fasterone/v12/H4ciBXCHmdfClFb-vWhfyLuShq63czE.ttf',
      'FasterOne-Regular',
    );
    return font.getFont();
  }

  /// Fasthand regular
  static Future<Font> fasthandRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/fasthand/v13/0yb9GDohyKTYn_ZEESkuYkw2rQg1.ttf',
      'Fasthand-Regular',
    );
    return font.getFont();
  }

  /// Fauna One regular
  static Future<Font> faunaOneRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/faunaone/v8/wlpzgwTPBVpjpCuwkuEx2UxLYClOCg.ttf',
      'FaunaOne-Regular',
    );
    return font.getFont();
  }

  /// Faustina regular
  static Future<Font> faustinaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/faustina/v8/XLY4IZPxYpJfTbZAFXWzNT2SO8wpWHlsgoEvGVWWe8tbEg.ttf',
      'Faustina-Regular',
    );
    return font.getFont();
  }

  /// Faustina 500
  static Future<Font> faustinaMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/faustina/v8/XLY4IZPxYpJfTbZAFXWzNT2SO8wpWHlssIEvGVWWe8tbEg.ttf',
      'Faustina-Medium',
    );
    return font.getFont();
  }

  /// Faustina 600
  static Future<Font> faustinaSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/faustina/v8/XLY4IZPxYpJfTbZAFXWzNT2SO8wpWHlsXIYvGVWWe8tbEg.ttf',
      'Faustina-SemiBold',
    );
    return font.getFont();
  }

  /// Faustina 700
  static Future<Font> faustinaBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/faustina/v8/XLY4IZPxYpJfTbZAFXWzNT2SO8wpWHlsZYYvGVWWe8tbEg.ttf',
      'Faustina-Bold',
    );
    return font.getFont();
  }

  /// Faustina italic
  static Future<Font> faustinaItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/faustina/v8/XLY2IZPxYpJfTbZAFV-6B8JKUqez9n55SsLHWl-SWc5LEnoF.ttf',
      'Faustina-Italic',
    );
    return font.getFont();
  }

  /// Faustina 500italic
  static Future<Font> faustinaMediumItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/faustina/v8/XLY2IZPxYpJfTbZAFV-6B8JKUqez9n55SsL1Wl-SWc5LEnoF.ttf',
      'Faustina-MediumItalic',
    );
    return font.getFont();
  }

  /// Faustina 600italic
  static Future<Font> faustinaSemiBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/faustina/v8/XLY2IZPxYpJfTbZAFV-6B8JKUqez9n55SsIZXV-SWc5LEnoF.ttf',
      'Faustina-SemiBoldItalic',
    );
    return font.getFont();
  }

  /// Faustina 700italic
  static Future<Font> faustinaBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/faustina/v8/XLY2IZPxYpJfTbZAFV-6B8JKUqez9n55SsIgXV-SWc5LEnoF.ttf',
      'Faustina-BoldItalic',
    );
    return font.getFont();
  }

  /// Federant regular
  static Future<Font> federantRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/federant/v15/2sDdZGNfip_eirT0_U0jRUG0AqUc.ttf',
      'Federant-Regular',
    );
    return font.getFont();
  }

  /// Federo regular
  static Future<Font> federoRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/federo/v14/iJWFBX-cbD_ETsbmjVOe2WTG7Q.ttf',
      'Federo-Regular',
    );
    return font.getFont();
  }

  /// Felipa regular
  static Future<Font> felipaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/felipa/v9/FwZa7-owz1Eu4F_wSNSEwM2zpA.ttf',
      'Felipa-Regular',
    );
    return font.getFont();
  }

  /// Fenix regular
  static Future<Font> fenixRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/fenix/v10/XoHo2YL_S7-g5ostKzAFvs8o.ttf',
      'Fenix-Regular',
    );
    return font.getFont();
  }

  /// Finger Paint regular
  static Future<Font> fingerPaintRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/fingerpaint/v10/0QInMXVJ-o-oRn_7dron8YWO85bS8ANesw.ttf',
      'FingerPaint-Regular',
    );
    return font.getFont();
  }

  /// Fira Code 300
  static Future<Font> firaCodeLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/firacode/v10/uU9eCBsR6Z2vfE9aq3bL0fxyUs4tcw4W_GNsFVfxN87gsj0.ttf',
      'FiraCode-Light',
    );
    return font.getFont();
  }

  /// Fira Code regular
  static Future<Font> firaCodeRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/firacode/v10/uU9eCBsR6Z2vfE9aq3bL0fxyUs4tcw4W_D1sFVfxN87gsj0.ttf',
      'FiraCode-Regular',
    );
    return font.getFont();
  }

  /// Fira Code 500
  static Future<Font> firaCodeMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/firacode/v10/uU9eCBsR6Z2vfE9aq3bL0fxyUs4tcw4W_A9sFVfxN87gsj0.ttf',
      'FiraCode-Medium',
    );
    return font.getFont();
  }

  /// Fira Code 600
  static Future<Font> firaCodeSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/firacode/v10/uU9eCBsR6Z2vfE9aq3bL0fxyUs4tcw4W_ONrFVfxN87gsj0.ttf',
      'FiraCode-SemiBold',
    );
    return font.getFont();
  }

  /// Fira Code 700
  static Future<Font> firaCodeBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/firacode/v10/uU9eCBsR6Z2vfE9aq3bL0fxyUs4tcw4W_NprFVfxN87gsj0.ttf',
      'FiraCode-Bold',
    );
    return font.getFont();
  }

  /// Fira Mono regular
  static Future<Font> firaMonoRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/firamono/v9/N0bX2SlFPv1weGeLZDtQIfTTkdbJYA.ttf',
      'FiraMono-Regular',
    );
    return font.getFont();
  }

  /// Fira Mono 500
  static Future<Font> firaMonoMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/firamono/v9/N0bS2SlFPv1weGeLZDto1d33mf3VaZBRBQ.ttf',
      'FiraMono-Medium',
    );
    return font.getFont();
  }

  /// Fira Mono 700
  static Future<Font> firaMonoBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/firamono/v9/N0bS2SlFPv1weGeLZDtondv3mf3VaZBRBQ.ttf',
      'FiraMono-Bold',
    );
    return font.getFont();
  }

  /// Fira Sans 100
  static Future<Font> firaSansThin() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/firasans/v11/va9C4kDNxMZdWfMOD5Vn9IjOazP3dUTP.ttf',
      'FiraSans-Thin',
    );
    return font.getFont();
  }

  /// Fira Sans 100italic
  static Future<Font> firaSansThinItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/firasans/v11/va9A4kDNxMZdWfMOD5VvkrCqYTfVcFTPj0s.ttf',
      'FiraSans-ThinItalic',
    );
    return font.getFont();
  }

  /// Fira Sans 200
  static Future<Font> firaSansExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/firasans/v11/va9B4kDNxMZdWfMOD5VnWKnuQR37fF3Wlg.ttf',
      'FiraSans-ExtraLight',
    );
    return font.getFont();
  }

  /// Fira Sans 200italic
  static Future<Font> firaSansExtraLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/firasans/v11/va9f4kDNxMZdWfMOD5VvkrAGQBf_XljGllLX.ttf',
      'FiraSans-ExtraLightItalic',
    );
    return font.getFont();
  }

  /// Fira Sans 300
  static Future<Font> firaSansLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/firasans/v11/va9B4kDNxMZdWfMOD5VnPKruQR37fF3Wlg.ttf',
      'FiraSans-Light',
    );
    return font.getFont();
  }

  /// Fira Sans 300italic
  static Future<Font> firaSansLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/firasans/v11/va9f4kDNxMZdWfMOD5VvkrBiQxf_XljGllLX.ttf',
      'FiraSans-LightItalic',
    );
    return font.getFont();
  }

  /// Fira Sans regular
  static Future<Font> firaSansRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/firasans/v11/va9E4kDNxMZdWfMOD5VfkILKSTbndQ.ttf',
      'FiraSans-Regular',
    );
    return font.getFont();
  }

  /// Fira Sans italic
  static Future<Font> firaSansItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/firasans/v11/va9C4kDNxMZdWfMOD5VvkojOazP3dUTP.ttf',
      'FiraSans-Italic',
    );
    return font.getFont();
  }

  /// Fira Sans 500
  static Future<Font> firaSansMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/firasans/v11/va9B4kDNxMZdWfMOD5VnZKvuQR37fF3Wlg.ttf',
      'FiraSans-Medium',
    );
    return font.getFont();
  }

  /// Fira Sans 500italic
  static Future<Font> firaSansMediumItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/firasans/v11/va9f4kDNxMZdWfMOD5VvkrA6Qhf_XljGllLX.ttf',
      'FiraSans-MediumItalic',
    );
    return font.getFont();
  }

  /// Fira Sans 600
  static Future<Font> firaSansSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/firasans/v11/va9B4kDNxMZdWfMOD5VnSKzuQR37fF3Wlg.ttf',
      'FiraSans-SemiBold',
    );
    return font.getFont();
  }

  /// Fira Sans 600italic
  static Future<Font> firaSansSemiBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/firasans/v11/va9f4kDNxMZdWfMOD5VvkrAWRRf_XljGllLX.ttf',
      'FiraSans-SemiBoldItalic',
    );
    return font.getFont();
  }

  /// Fira Sans 700
  static Future<Font> firaSansBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/firasans/v11/va9B4kDNxMZdWfMOD5VnLK3uQR37fF3Wlg.ttf',
      'FiraSans-Bold',
    );
    return font.getFont();
  }

  /// Fira Sans 700italic
  static Future<Font> firaSansBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/firasans/v11/va9f4kDNxMZdWfMOD5VvkrByRBf_XljGllLX.ttf',
      'FiraSans-BoldItalic',
    );
    return font.getFont();
  }

  /// Fira Sans 800
  static Future<Font> firaSansExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/firasans/v11/va9B4kDNxMZdWfMOD5VnMK7uQR37fF3Wlg.ttf',
      'FiraSans-ExtraBold',
    );
    return font.getFont();
  }

  /// Fira Sans 800italic
  static Future<Font> firaSansExtraBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/firasans/v11/va9f4kDNxMZdWfMOD5VvkrBuRxf_XljGllLX.ttf',
      'FiraSans-ExtraBoldItalic',
    );
    return font.getFont();
  }

  /// Fira Sans 900
  static Future<Font> firaSansBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/firasans/v11/va9B4kDNxMZdWfMOD5VnFK_uQR37fF3Wlg.ttf',
      'FiraSans-Black',
    );
    return font.getFont();
  }

  /// Fira Sans 900italic
  static Future<Font> firaSansBlackItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/firasans/v11/va9f4kDNxMZdWfMOD5VvkrBKRhf_XljGllLX.ttf',
      'FiraSans-BlackItalic',
    );
    return font.getFont();
  }

  /// Fira Sans Condensed 100
  static Future<Font> firaSansCondensedThin() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/firasanscondensed/v5/wEOjEADFm8hSaQTFG18FErVhsC9x-tarWZXtqOlQfx9CjA.ttf',
      'FiraSansCondensed-Thin',
    );
    return font.getFont();
  }

  /// Fira Sans Condensed 100italic
  static Future<Font> firaSansCondensedThinItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/firasanscondensed/v5/wEOtEADFm8hSaQTFG18FErVhsC9x-tarUfPVzONUXRpSjJcu.ttf',
      'FiraSansCondensed-ThinItalic',
    );
    return font.getFont();
  }

  /// Fira Sans Condensed 200
  static Future<Font> firaSansCondensedExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/firasanscondensed/v5/wEOsEADFm8hSaQTFG18FErVhsC9x-tarWTnMiMN-cxZblY4.ttf',
      'FiraSansCondensed-ExtraLight',
    );
    return font.getFont();
  }

  /// Fira Sans Condensed 200italic
  static Future<Font> firaSansCondensedExtraLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/firasanscondensed/v5/wEOuEADFm8hSaQTFG18FErVhsC9x-tarUfPVYMJ0dzRehY43EA.ttf',
      'FiraSansCondensed-ExtraLightItalic',
    );
    return font.getFont();
  }

  /// Fira Sans Condensed 300
  static Future<Font> firaSansCondensedLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/firasanscondensed/v5/wEOsEADFm8hSaQTFG18FErVhsC9x-tarWV3PiMN-cxZblY4.ttf',
      'FiraSansCondensed-Light',
    );
    return font.getFont();
  }

  /// Fira Sans Condensed 300italic
  static Future<Font> firaSansCondensedLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/firasanscondensed/v5/wEOuEADFm8hSaQTFG18FErVhsC9x-tarUfPVBMF0dzRehY43EA.ttf',
      'FiraSansCondensed-LightItalic',
    );
    return font.getFont();
  }

  /// Fira Sans Condensed regular
  static Future<Font> firaSansCondensedRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/firasanscondensed/v5/wEOhEADFm8hSaQTFG18FErVhsC9x-tarYfHnrMtVbx8.ttf',
      'FiraSansCondensed-Regular',
    );
    return font.getFont();
  }

  /// Fira Sans Condensed italic
  static Future<Font> firaSansCondensedItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/firasanscondensed/v5/wEOjEADFm8hSaQTFG18FErVhsC9x-tarUfPtqOlQfx9CjA.ttf',
      'FiraSansCondensed-Italic',
    );
    return font.getFont();
  }

  /// Fira Sans Condensed 500
  static Future<Font> firaSansCondensedMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/firasanscondensed/v5/wEOsEADFm8hSaQTFG18FErVhsC9x-tarWQXOiMN-cxZblY4.ttf',
      'FiraSansCondensed-Medium',
    );
    return font.getFont();
  }

  /// Fira Sans Condensed 500italic
  static Future<Font> firaSansCondensedMediumItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/firasanscondensed/v5/wEOuEADFm8hSaQTFG18FErVhsC9x-tarUfPVXMB0dzRehY43EA.ttf',
      'FiraSansCondensed-MediumItalic',
    );
    return font.getFont();
  }

  /// Fira Sans Condensed 600
  static Future<Font> firaSansCondensedSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/firasanscondensed/v5/wEOsEADFm8hSaQTFG18FErVhsC9x-tarWSnJiMN-cxZblY4.ttf',
      'FiraSansCondensed-SemiBold',
    );
    return font.getFont();
  }

  /// Fira Sans Condensed 600italic
  static Future<Font> firaSansCondensedSemiBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/firasanscondensed/v5/wEOuEADFm8hSaQTFG18FErVhsC9x-tarUfPVcMd0dzRehY43EA.ttf',
      'FiraSansCondensed-SemiBoldItalic',
    );
    return font.getFont();
  }

  /// Fira Sans Condensed 700
  static Future<Font> firaSansCondensedBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/firasanscondensed/v5/wEOsEADFm8hSaQTFG18FErVhsC9x-tarWU3IiMN-cxZblY4.ttf',
      'FiraSansCondensed-Bold',
    );
    return font.getFont();
  }

  /// Fira Sans Condensed 700italic
  static Future<Font> firaSansCondensedBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/firasanscondensed/v5/wEOuEADFm8hSaQTFG18FErVhsC9x-tarUfPVFMZ0dzRehY43EA.ttf',
      'FiraSansCondensed-BoldItalic',
    );
    return font.getFont();
  }

  /// Fira Sans Condensed 800
  static Future<Font> firaSansCondensedExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/firasanscondensed/v5/wEOsEADFm8hSaQTFG18FErVhsC9x-tarWVHLiMN-cxZblY4.ttf',
      'FiraSansCondensed-ExtraBold',
    );
    return font.getFont();
  }

  /// Fira Sans Condensed 800italic
  static Future<Font> firaSansCondensedExtraBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/firasanscondensed/v5/wEOuEADFm8hSaQTFG18FErVhsC9x-tarUfPVCMV0dzRehY43EA.ttf',
      'FiraSansCondensed-ExtraBoldItalic',
    );
    return font.getFont();
  }

  /// Fira Sans Condensed 900
  static Future<Font> firaSansCondensedBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/firasanscondensed/v5/wEOsEADFm8hSaQTFG18FErVhsC9x-tarWXXKiMN-cxZblY4.ttf',
      'FiraSansCondensed-Black',
    );
    return font.getFont();
  }

  /// Fira Sans Condensed 900italic
  static Future<Font> firaSansCondensedBlackItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/firasanscondensed/v5/wEOuEADFm8hSaQTFG18FErVhsC9x-tarUfPVLMR0dzRehY43EA.ttf',
      'FiraSansCondensed-BlackItalic',
    );
    return font.getFont();
  }

  /// Fira Sans Extra Condensed 100
  static Future<Font> firaSansExtraCondensedThin() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/firasansextracondensed/v5/NaPMcYDaAO5dirw6IaFn7lPJFqXmS-M9Atn3wgda3Zyuv1WarE9ncg.ttf',
      'FiraSansExtraCondensed-Thin',
    );
    return font.getFont();
  }

  /// Fira Sans Extra Condensed 100italic
  static Future<Font> firaSansExtraCondensedThinItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/firasansextracondensed/v5/NaPOcYDaAO5dirw6IaFn7lPJFqXmS-M9Atn3wgda1fqW21-ejkp3cn22.ttf',
      'FiraSansExtraCondensed-ThinItalic',
    );
    return font.getFont();
  }

  /// Fira Sans Extra Condensed 200
  static Future<Font> firaSansExtraCondensedExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/firasansextracondensed/v5/NaPPcYDaAO5dirw6IaFn7lPJFqXmS-M9Atn3wgda3TCPn3-0oEZ-a2Q.ttf',
      'FiraSansExtraCondensed-ExtraLight',
    );
    return font.getFont();
  }

  /// Fira Sans Extra Condensed 200italic
  static Future<Font> firaSansExtraCondensedExtraLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/firasansextracondensed/v5/NaPxcYDaAO5dirw6IaFn7lPJFqXmS-M9Atn3wgda1fqWd36-pGR7e2SvJQ.ttf',
      'FiraSansExtraCondensed-ExtraLightItalic',
    );
    return font.getFont();
  }

  /// Fira Sans Extra Condensed 300
  static Future<Font> firaSansExtraCondensedLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/firasansextracondensed/v5/NaPPcYDaAO5dirw6IaFn7lPJFqXmS-M9Atn3wgda3VSMn3-0oEZ-a2Q.ttf',
      'FiraSansExtraCondensed-Light',
    );
    return font.getFont();
  }

  /// Fira Sans Extra Condensed 300italic
  static Future<Font> firaSansExtraCondensedLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/firasansextracondensed/v5/NaPxcYDaAO5dirw6IaFn7lPJFqXmS-M9Atn3wgda1fqWE32-pGR7e2SvJQ.ttf',
      'FiraSansExtraCondensed-LightItalic',
    );
    return font.getFont();
  }

  /// Fira Sans Extra Condensed regular
  static Future<Font> firaSansExtraCondensedRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/firasansextracondensed/v5/NaPKcYDaAO5dirw6IaFn7lPJFqXmS-M9Atn3wgda5fiku3efvE8.ttf',
      'FiraSansExtraCondensed-Regular',
    );
    return font.getFont();
  }

  /// Fira Sans Extra Condensed italic
  static Future<Font> firaSansExtraCondensedItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/firasansextracondensed/v5/NaPMcYDaAO5dirw6IaFn7lPJFqXmS-M9Atn3wgda1fquv1WarE9ncg.ttf',
      'FiraSansExtraCondensed-Italic',
    );
    return font.getFont();
  }

  /// Fira Sans Extra Condensed 500
  static Future<Font> firaSansExtraCondensedMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/firasansextracondensed/v5/NaPPcYDaAO5dirw6IaFn7lPJFqXmS-M9Atn3wgda3QyNn3-0oEZ-a2Q.ttf',
      'FiraSansExtraCondensed-Medium',
    );
    return font.getFont();
  }

  /// Fira Sans Extra Condensed 500italic
  static Future<Font> firaSansExtraCondensedMediumItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/firasansextracondensed/v5/NaPxcYDaAO5dirw6IaFn7lPJFqXmS-M9Atn3wgda1fqWS3y-pGR7e2SvJQ.ttf',
      'FiraSansExtraCondensed-MediumItalic',
    );
    return font.getFont();
  }

  /// Fira Sans Extra Condensed 600
  static Future<Font> firaSansExtraCondensedSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/firasansextracondensed/v5/NaPPcYDaAO5dirw6IaFn7lPJFqXmS-M9Atn3wgda3SCKn3-0oEZ-a2Q.ttf',
      'FiraSansExtraCondensed-SemiBold',
    );
    return font.getFont();
  }

  /// Fira Sans Extra Condensed 600italic
  static Future<Font> firaSansExtraCondensedSemiBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/firasansextracondensed/v5/NaPxcYDaAO5dirw6IaFn7lPJFqXmS-M9Atn3wgda1fqWZ3u-pGR7e2SvJQ.ttf',
      'FiraSansExtraCondensed-SemiBoldItalic',
    );
    return font.getFont();
  }

  /// Fira Sans Extra Condensed 700
  static Future<Font> firaSansExtraCondensedBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/firasansextracondensed/v5/NaPPcYDaAO5dirw6IaFn7lPJFqXmS-M9Atn3wgda3USLn3-0oEZ-a2Q.ttf',
      'FiraSansExtraCondensed-Bold',
    );
    return font.getFont();
  }

  /// Fira Sans Extra Condensed 700italic
  static Future<Font> firaSansExtraCondensedBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/firasansextracondensed/v5/NaPxcYDaAO5dirw6IaFn7lPJFqXmS-M9Atn3wgda1fqWA3q-pGR7e2SvJQ.ttf',
      'FiraSansExtraCondensed-BoldItalic',
    );
    return font.getFont();
  }

  /// Fira Sans Extra Condensed 800
  static Future<Font> firaSansExtraCondensedExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/firasansextracondensed/v5/NaPPcYDaAO5dirw6IaFn7lPJFqXmS-M9Atn3wgda3ViIn3-0oEZ-a2Q.ttf',
      'FiraSansExtraCondensed-ExtraBold',
    );
    return font.getFont();
  }

  /// Fira Sans Extra Condensed 800italic
  static Future<Font> firaSansExtraCondensedExtraBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/firasansextracondensed/v5/NaPxcYDaAO5dirw6IaFn7lPJFqXmS-M9Atn3wgda1fqWH3m-pGR7e2SvJQ.ttf',
      'FiraSansExtraCondensed-ExtraBoldItalic',
    );
    return font.getFont();
  }

  /// Fira Sans Extra Condensed 900
  static Future<Font> firaSansExtraCondensedBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/firasansextracondensed/v5/NaPPcYDaAO5dirw6IaFn7lPJFqXmS-M9Atn3wgda3XyJn3-0oEZ-a2Q.ttf',
      'FiraSansExtraCondensed-Black',
    );
    return font.getFont();
  }

  /// Fira Sans Extra Condensed 900italic
  static Future<Font> firaSansExtraCondensedBlackItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/firasansextracondensed/v5/NaPxcYDaAO5dirw6IaFn7lPJFqXmS-M9Atn3wgda1fqWO3i-pGR7e2SvJQ.ttf',
      'FiraSansExtraCondensed-BlackItalic',
    );
    return font.getFont();
  }

  /// Fjalla One regular
  static Future<Font> fjallaOneRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/fjallaone/v8/Yq6R-LCAWCX3-6Ky7FAFnOZwkxgtUb8.ttf',
      'FjallaOne-Regular',
    );
    return font.getFont();
  }

  /// Fjord One regular
  static Future<Font> fjordOneRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/fjordone/v11/zOL-4pbEnKBY_9S1jNKr6e5As-FeiQ.ttf',
      'FjordOne-Regular',
    );
    return font.getFont();
  }

  /// Flamenco 300
  static Future<Font> flamencoLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/flamenco/v13/neIPzCehqYguo67ssZ0qNIkyepH9qGsf.ttf',
      'Flamenco-Light',
    );
    return font.getFont();
  }

  /// Flamenco regular
  static Future<Font> flamencoRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/flamenco/v13/neIIzCehqYguo67ssaWGHK06UY30.ttf',
      'Flamenco-Regular',
    );
    return font.getFont();
  }

  /// Flavors regular
  static Future<Font> flavorsRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/flavors/v12/FBV2dDrhxqmveJTpbkzlNqkG9UY.ttf',
      'Flavors-Regular',
    );
    return font.getFont();
  }

  /// Fondamento regular
  static Future<Font> fondamentoRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/fondamento/v11/4UaHrEJGsxNmFTPDnkaJx63j5pN1MwI.ttf',
      'Fondamento-Regular',
    );
    return font.getFont();
  }

  /// Fondamento italic
  static Future<Font> fondamentoItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/fondamento/v11/4UaFrEJGsxNmFTPDnkaJ96_p4rFwIwJePw.ttf',
      'Fondamento-Italic',
    );
    return font.getFont();
  }

  /// Fontdiner Swanky regular
  static Future<Font> fontdinerSwankyRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/fontdinerswanky/v11/ijwOs4XgRNsiaI5-hcVb4hQgMvCD4uEfKiGvxts.ttf',
      'FontdinerSwanky-Regular',
    );
    return font.getFont();
  }

  /// Forum regular
  static Future<Font> forumRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/forum/v11/6aey4Ky-Vb8Ew_IWMJMa3mnT.ttf',
      'Forum-Regular',
    );
    return font.getFont();
  }

  /// Francois One regular
  static Future<Font> francoisOneRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/francoisone/v15/_Xmr-H4zszafZw3A-KPSZutNxgKQu_avAg.ttf',
      'FrancoisOne-Regular',
    );
    return font.getFont();
  }

  /// Frank Ruhl Libre 300
  static Future<Font> frankRuhlLibreLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/frankruhllibre/v6/j8_36_fAw7jrcalD7oKYNX0QfAnPUxvHxJDMhYeIHw8.ttf',
      'FrankRuhlLibre-Light',
    );
    return font.getFont();
  }

  /// Frank Ruhl Libre regular
  static Future<Font> frankRuhlLibreRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/frankruhllibre/v6/j8_w6_fAw7jrcalD7oKYNX0QfAnPa7fv4JjnmY4.ttf',
      'FrankRuhlLibre-Regular',
    );
    return font.getFont();
  }

  /// Frank Ruhl Libre 500
  static Future<Font> frankRuhlLibreMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/frankruhllibre/v6/j8_36_fAw7jrcalD7oKYNX0QfAnPU0PGxJDMhYeIHw8.ttf',
      'FrankRuhlLibre-Medium',
    );
    return font.getFont();
  }

  /// Frank Ruhl Libre 700
  static Future<Font> frankRuhlLibreBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/frankruhllibre/v6/j8_36_fAw7jrcalD7oKYNX0QfAnPUwvAxJDMhYeIHw8.ttf',
      'FrankRuhlLibre-Bold',
    );
    return font.getFont();
  }

  /// Frank Ruhl Libre 900
  static Future<Font> frankRuhlLibreBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/frankruhllibre/v6/j8_36_fAw7jrcalD7oKYNX0QfAnPUzPCxJDMhYeIHw8.ttf',
      'FrankRuhlLibre-Black',
    );
    return font.getFont();
  }

  /// Fraunces 100
  static Future<Font> frauncesThin() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/fraunces/v10/6NUh8FyLNQOQZAnv9bYEvDiIdE9Ea92uemAk_WBq8U_9v0c2Wa0K7iN7hzFUPJH58nib1603gg7S2nfgRYIctxqjDvTShUtWNg.ttf',
      'Fraunces-Thin',
    );
    return font.getFont();
  }

  /// Fraunces 200
  static Future<Font> frauncesExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/fraunces/v10/6NUh8FyLNQOQZAnv9bYEvDiIdE9Ea92uemAk_WBq8U_9v0c2Wa0K7iN7hzFUPJH58nib1603gg7S2nfgRYIcNxujDvTShUtWNg.ttf',
      'Fraunces-ExtraLight',
    );
    return font.getFont();
  }

  /// Fraunces 300
  static Future<Font> frauncesLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/fraunces/v10/6NUh8FyLNQOQZAnv9bYEvDiIdE9Ea92uemAk_WBq8U_9v0c2Wa0K7iN7hzFUPJH58nib1603gg7S2nfgRYIc6RujDvTShUtWNg.ttf',
      'Fraunces-Light',
    );
    return font.getFont();
  }

  /// Fraunces regular
  static Future<Font> frauncesRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/fraunces/v10/6NUh8FyLNQOQZAnv9bYEvDiIdE9Ea92uemAk_WBq8U_9v0c2Wa0K7iN7hzFUPJH58nib1603gg7S2nfgRYIctxujDvTShUtWNg.ttf',
      'Fraunces-Regular',
    );
    return font.getFont();
  }

  /// Fraunces 500
  static Future<Font> frauncesMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/fraunces/v10/6NUh8FyLNQOQZAnv9bYEvDiIdE9Ea92uemAk_WBq8U_9v0c2Wa0K7iN7hzFUPJH58nib1603gg7S2nfgRYIchRujDvTShUtWNg.ttf',
      'Fraunces-Medium',
    );
    return font.getFont();
  }

  /// Fraunces 600
  static Future<Font> frauncesSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/fraunces/v10/6NUh8FyLNQOQZAnv9bYEvDiIdE9Ea92uemAk_WBq8U_9v0c2Wa0K7iN7hzFUPJH58nib1603gg7S2nfgRYIcaRyjDvTShUtWNg.ttf',
      'Fraunces-SemiBold',
    );
    return font.getFont();
  }

  /// Fraunces 700
  static Future<Font> frauncesBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/fraunces/v10/6NUh8FyLNQOQZAnv9bYEvDiIdE9Ea92uemAk_WBq8U_9v0c2Wa0K7iN7hzFUPJH58nib1603gg7S2nfgRYIcUByjDvTShUtWNg.ttf',
      'Fraunces-Bold',
    );
    return font.getFont();
  }

  /// Fraunces 800
  static Future<Font> frauncesExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/fraunces/v10/6NUh8FyLNQOQZAnv9bYEvDiIdE9Ea92uemAk_WBq8U_9v0c2Wa0K7iN7hzFUPJH58nib1603gg7S2nfgRYIcNxyjDvTShUtWNg.ttf',
      'Fraunces-ExtraBold',
    );
    return font.getFont();
  }

  /// Fraunces 900
  static Future<Font> frauncesBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/fraunces/v10/6NUh8FyLNQOQZAnv9bYEvDiIdE9Ea92uemAk_WBq8U_9v0c2Wa0K7iN7hzFUPJH58nib1603gg7S2nfgRYIcHhyjDvTShUtWNg.ttf',
      'Fraunces-Black',
    );
    return font.getFont();
  }

  /// Fraunces 100italic
  static Future<Font> frauncesThinItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/fraunces/v10/6NVf8FyLNQOQZAnv9ZwNjucMHVn85Ni7emAe9lKqZTnbB-gzTK0K1ChJdt9vIVYX9G37lvd9sPEKsxx664UJf1hLTP7Wp05GNi3k.ttf',
      'Fraunces-ThinItalic',
    );
    return font.getFont();
  }

  /// Fraunces 200italic
  static Future<Font> frauncesExtraLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/fraunces/v10/6NVf8FyLNQOQZAnv9ZwNjucMHVn85Ni7emAe9lKqZTnbB-gzTK0K1ChJdt9vIVYX9G37lvd9sPEKsxx664UJf1jLTf7Wp05GNi3k.ttf',
      'Fraunces-ExtraLightItalic',
    );
    return font.getFont();
  }

  /// Fraunces 300italic
  static Future<Font> frauncesLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/fraunces/v10/6NVf8FyLNQOQZAnv9ZwNjucMHVn85Ni7emAe9lKqZTnbB-gzTK0K1ChJdt9vIVYX9G37lvd9sPEKsxx664UJf1gVTf7Wp05GNi3k.ttf',
      'Fraunces-LightItalic',
    );
    return font.getFont();
  }

  /// Fraunces italic
  static Future<Font> frauncesItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/fraunces/v10/6NVf8FyLNQOQZAnv9ZwNjucMHVn85Ni7emAe9lKqZTnbB-gzTK0K1ChJdt9vIVYX9G37lvd9sPEKsxx664UJf1hLTf7Wp05GNi3k.ttf',
      'Fraunces-Italic',
    );
    return font.getFont();
  }

  /// Fraunces 500italic
  static Future<Font> frauncesMediumItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/fraunces/v10/6NVf8FyLNQOQZAnv9ZwNjucMHVn85Ni7emAe9lKqZTnbB-gzTK0K1ChJdt9vIVYX9G37lvd9sPEKsxx664UJf1h5Tf7Wp05GNi3k.ttf',
      'Fraunces-MediumItalic',
    );
    return font.getFont();
  }

  /// Fraunces 600italic
  static Future<Font> frauncesSemiBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/fraunces/v10/6NVf8FyLNQOQZAnv9ZwNjucMHVn85Ni7emAe9lKqZTnbB-gzTK0K1ChJdt9vIVYX9G37lvd9sPEKsxx664UJf1iVSv7Wp05GNi3k.ttf',
      'Fraunces-SemiBoldItalic',
    );
    return font.getFont();
  }

  /// Fraunces 700italic
  static Future<Font> frauncesBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/fraunces/v10/6NVf8FyLNQOQZAnv9ZwNjucMHVn85Ni7emAe9lKqZTnbB-gzTK0K1ChJdt9vIVYX9G37lvd9sPEKsxx664UJf1isSv7Wp05GNi3k.ttf',
      'Fraunces-BoldItalic',
    );
    return font.getFont();
  }

  /// Fraunces 800italic
  static Future<Font> frauncesExtraBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/fraunces/v10/6NVf8FyLNQOQZAnv9ZwNjucMHVn85Ni7emAe9lKqZTnbB-gzTK0K1ChJdt9vIVYX9G37lvd9sPEKsxx664UJf1jLSv7Wp05GNi3k.ttf',
      'Fraunces-ExtraBoldItalic',
    );
    return font.getFont();
  }

  /// Fraunces 900italic
  static Future<Font> frauncesBlackItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/fraunces/v10/6NVf8FyLNQOQZAnv9ZwNjucMHVn85Ni7emAe9lKqZTnbB-gzTK0K1ChJdt9vIVYX9G37lvd9sPEKsxx664UJf1jiSv7Wp05GNi3k.ttf',
      'Fraunces-BlackItalic',
    );
    return font.getFont();
  }

  /// Freckle Face regular
  static Future<Font> freckleFaceRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/freckleface/v9/AMOWz4SXrmKHCvXTohxY-YI0U1K2w9lb4g.ttf',
      'FreckleFace-Regular',
    );
    return font.getFont();
  }

  /// Fredericka the Great regular
  static Future<Font> frederickatheGreatRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/frederickathegreat/v10/9Bt33CxNwt7aOctW2xjbCstzwVKsIBVV-9Skz7Ylch2L.ttf',
      'FrederickatheGreat-Regular',
    );
    return font.getFont();
  }

  /// Fredoka One regular
  static Future<Font> fredokaOneRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/fredokaone/v8/k3kUo8kEI-tA1RRcTZGmTmHBA6aF8Bf_.ttf',
      'FredokaOne-Regular',
    );
    return font.getFont();
  }

  /// Freehand regular
  static Future<Font> freehandRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/freehand/v14/cIf-Ma5eqk01VjKTgAmBTmUOmZJk.ttf',
      'Freehand-Regular',
    );
    return font.getFont();
  }

  /// Fresca regular
  static Future<Font> frescaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/fresca/v11/6ae94K--SKgCzbM2Gr0W13DKPA.ttf',
      'Fresca-Regular',
    );
    return font.getFont();
  }

  /// Frijole regular
  static Future<Font> frijoleRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/frijole/v9/uU9PCBUR8oakM2BQ7xPb3vyHmlI.ttf',
      'Frijole-Regular',
    );
    return font.getFont();
  }

  /// Fruktur regular
  static Future<Font> frukturRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/fruktur/v15/SZc53FHsOru5QYsMfz3GkUrS8DI.ttf',
      'Fruktur-Regular',
    );
    return font.getFont();
  }

  /// Fugaz One regular
  static Future<Font> fugazOneRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/fugazone/v10/rax_HiWKp9EAITukFslMBBJek0vA8A.ttf',
      'FugazOne-Regular',
    );
    return font.getFont();
  }

  /// GFS Didot regular
  static Future<Font> gFSDidotRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/gfsdidot/v10/Jqzh5TybZ9vZMWFssvwiF-fGFSCGAA.ttf',
      'GFSDidot-Regular',
    );
    return font.getFont();
  }

  /// GFS Neohellenic regular
  static Future<Font> gFSNeohellenicRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/gfsneohellenic/v15/8QIRdiDOrfiq0b7R8O1Iw9WLcY5TLahP46UDUw.ttf',
      'GFSNeohellenic-Regular',
    );
    return font.getFont();
  }

  /// GFS Neohellenic italic
  static Future<Font> gFSNeohellenicItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/gfsneohellenic/v15/8QITdiDOrfiq0b7R8O1Iw9WLcY5jL6JLwaATU91X.ttf',
      'GFSNeohellenic-Italic',
    );
    return font.getFont();
  }

  /// GFS Neohellenic 700
  static Future<Font> gFSNeohellenicBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/gfsneohellenic/v15/8QIUdiDOrfiq0b7R8O1Iw9WLcY5rkYdr644fWsRO9w.ttf',
      'GFSNeohellenic-Bold',
    );
    return font.getFont();
  }

  /// GFS Neohellenic 700italic
  static Future<Font> gFSNeohellenicBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/gfsneohellenic/v15/8QIWdiDOrfiq0b7R8O1Iw9WLcY5jL5r37oQbeMFe985V.ttf',
      'GFSNeohellenic-BoldItalic',
    );
    return font.getFont();
  }

  /// Gabriela regular
  static Future<Font> gabrielaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/gabriela/v9/qkBWXvsO6sreR8E-b_m-zrpHmRzC.ttf',
      'Gabriela-Regular',
    );
    return font.getFont();
  }

  /// Gaegu 300
  static Future<Font> gaeguLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/gaegu/v10/TuGSUVB6Up9NU57nifw74sdtBk0x.ttf',
      'Gaegu-Light',
    );
    return font.getFont();
  }

  /// Gaegu regular
  static Future<Font> gaeguRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/gaegu/v10/TuGfUVB6Up9NU6ZLodgzydtk.ttf',
      'Gaegu-Regular',
    );
    return font.getFont();
  }

  /// Gaegu 700
  static Future<Font> gaeguBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/gaegu/v10/TuGSUVB6Up9NU573jvw74sdtBk0x.ttf',
      'Gaegu-Bold',
    );
    return font.getFont();
  }

  /// Gafata regular
  static Future<Font> gafataRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/gafata/v11/XRXV3I6Cn0VJKon4MuyAbsrVcA.ttf',
      'Gafata-Regular',
    );
    return font.getFont();
  }

  /// Galada regular
  static Future<Font> galadaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/galada/v8/H4cmBXyGmcjXlUX-8iw-4Lqggw.ttf',
      'Galada-Regular',
    );
    return font.getFont();
  }

  /// Galdeano regular
  static Future<Font> galdeanoRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/galdeano/v12/uU9MCBoQ4YOqOW1boDPx8PCOg0uX.ttf',
      'Galdeano-Regular',
    );
    return font.getFont();
  }

  /// Galindo regular
  static Future<Font> galindoRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/galindo/v10/HI_KiYMeLqVKqwyuQ5HiRp-dhpQ.ttf',
      'Galindo-Regular',
    );
    return font.getFont();
  }

  /// Gamja Flower regular
  static Future<Font> gamjaFlowerRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/gamjaflower/v10/6NUR8FiKJg-Pa0rM6uN40Z4kyf9Fdty2ew.ttf',
      'GamjaFlower-Regular',
    );
    return font.getFont();
  }

  /// Gayathri 100
  static Future<Font> gayathriThin() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/gayathri/v6/MCoWzAb429DbBilWLLhc-pvSA_gA2W8.ttf',
      'Gayathri-Thin',
    );
    return font.getFont();
  }

  /// Gayathri regular
  static Future<Font> gayathriRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/gayathri/v6/MCoQzAb429DbBilWLIA48J_wBugA.ttf',
      'Gayathri-Regular',
    );
    return font.getFont();
  }

  /// Gayathri 700
  static Future<Font> gayathriBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/gayathri/v6/MCoXzAb429DbBilWLLiE37v4LfQJwHbn.ttf',
      'Gayathri-Bold',
    );
    return font.getFont();
  }

  /// Gelasio regular
  static Future<Font> gelasioRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/gelasio/v4/cIf9MaFfvUQxTTqSxCmrYGkHgIs.ttf',
      'Gelasio-Regular',
    );
    return font.getFont();
  }

  /// Gelasio italic
  static Future<Font> gelasioItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/gelasio/v4/cIf_MaFfvUQxTTqS9CuhZEsCkIt9QQ.ttf',
      'Gelasio-Italic',
    );
    return font.getFont();
  }

  /// Gelasio 500
  static Future<Font> gelasioMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/gelasio/v4/cIf4MaFfvUQxTTqS_N2CRGEsnIJkWL4.ttf',
      'Gelasio-Medium',
    );
    return font.getFont();
  }

  /// Gelasio 500italic
  static Future<Font> gelasioMediumItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/gelasio/v4/cIf6MaFfvUQxTTqS9CuZkGImmKBhSL7Y1Q.ttf',
      'Gelasio-MediumItalic',
    );
    return font.getFont();
  }

  /// Gelasio 600
  static Future<Font> gelasioSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/gelasio/v4/cIf4MaFfvUQxTTqS_PGFRGEsnIJkWL4.ttf',
      'Gelasio-SemiBold',
    );
    return font.getFont();
  }

  /// Gelasio 600italic
  static Future<Font> gelasioSemiBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/gelasio/v4/cIf6MaFfvUQxTTqS9CuZvGUmmKBhSL7Y1Q.ttf',
      'Gelasio-SemiBoldItalic',
    );
    return font.getFont();
  }

  /// Gelasio 700
  static Future<Font> gelasioBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/gelasio/v4/cIf4MaFfvUQxTTqS_JWERGEsnIJkWL4.ttf',
      'Gelasio-Bold',
    );
    return font.getFont();
  }

  /// Gelasio 700italic
  static Future<Font> gelasioBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/gelasio/v4/cIf6MaFfvUQxTTqS9CuZ2GQmmKBhSL7Y1Q.ttf',
      'Gelasio-BoldItalic',
    );
    return font.getFont();
  }

  /// Gentium Basic regular
  static Future<Font> gentiumBasicRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/gentiumbasic/v12/Wnz9HAw9aB_JD2VGQVR80We3HAqDiTI_cIM.ttf',
      'GentiumBasic-Regular',
    );
    return font.getFont();
  }

  /// Gentium Basic italic
  static Future<Font> gentiumBasicItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/gentiumbasic/v12/WnzjHAw9aB_JD2VGQVR80We3LAiJjRA6YIORZQ.ttf',
      'GentiumBasic-Italic',
    );
    return font.getFont();
  }

  /// Gentium Basic 700
  static Future<Font> gentiumBasicBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/gentiumbasic/v12/WnzgHAw9aB_JD2VGQVR80We3JLasrToUbIqIfBU.ttf',
      'GentiumBasic-Bold',
    );
    return font.getFont();
  }

  /// Gentium Basic 700italic
  static Future<Font> gentiumBasicBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/gentiumbasic/v12/WnzmHAw9aB_JD2VGQVR80We3LAixMT8eaKiNbBVWkw.ttf',
      'GentiumBasic-BoldItalic',
    );
    return font.getFont();
  }

  /// Gentium Book Basic regular
  static Future<Font> gentiumBookBasicRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/gentiumbookbasic/v11/pe0zMJCbPYBVokB1LHA9bbyaQb8ZGjcIV7t7w6bE2A.ttf',
      'GentiumBookBasic-Regular',
    );
    return font.getFont();
  }

  /// Gentium Book Basic italic
  static Future<Font> gentiumBookBasicItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/gentiumbookbasic/v11/pe0xMJCbPYBVokB1LHA9bbyaQb8ZGjc4VbF_4aPU2Ec9.ttf',
      'GentiumBookBasic-Italic',
    );
    return font.getFont();
  }

  /// Gentium Book Basic 700
  static Future<Font> gentiumBookBasicBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/gentiumbookbasic/v11/pe0wMJCbPYBVokB1LHA9bbyaQb8ZGjcw65Rfy43Y0V4kvg.ttf',
      'GentiumBookBasic-Bold',
    );
    return font.getFont();
  }

  /// Gentium Book Basic 700italic
  static Future<Font> gentiumBookBasicBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/gentiumbookbasic/v11/pe0-MJCbPYBVokB1LHA9bbyaQb8ZGjc4VYnDzofc81s0voO3.ttf',
      'GentiumBookBasic-BoldItalic',
    );
    return font.getFont();
  }

  /// Geo regular
  static Future<Font> geoRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/geo/v14/CSRz4zRZlufVL3BmQjlCbQ.ttf',
      'Geo-Regular',
    );
    return font.getFont();
  }

  /// Geo italic
  static Future<Font> geoItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/geo/v14/CSRx4zRZluflLXpiYDxSbf8r.ttf',
      'Geo-Italic',
    );
    return font.getFont();
  }

  /// Geostar regular
  static Future<Font> geostarRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/geostar/v13/sykz-yx4n701VLOftSq9-trEvlQ.ttf',
      'Geostar-Regular',
    );
    return font.getFont();
  }

  /// Geostar Fill regular
  static Future<Font> geostarFillRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/geostarfill/v13/AMOWz4SWuWiXFfjEohxQ9os0U1K2w9lb4g.ttf',
      'GeostarFill-Regular',
    );
    return font.getFont();
  }

  /// Germania One regular
  static Future<Font> germaniaOneRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/germaniaone/v10/Fh4yPjrqIyv2ucM2qzBjeS3ezAJONau6ew.ttf',
      'GermaniaOne-Regular',
    );
    return font.getFont();
  }

  /// Gidugu regular
  static Future<Font> giduguRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/gidugu/v11/L0x8DFMkk1Uf6w3RvPCmRSlUig.ttf',
      'Gidugu-Regular',
    );
    return font.getFont();
  }

  /// Gilda Display regular
  static Future<Font> gildaDisplayRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/gildadisplay/v8/t5tmIRoYMoaYG0WEOh7HwMeR7TnFrpOHYh4.ttf',
      'GildaDisplay-Regular',
    );
    return font.getFont();
  }

  /// Girassol regular
  static Future<Font> girassolRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/girassol/v6/JTUUjIo_-DK48laaNC9Nz2pJzxbi.ttf',
      'Girassol-Regular',
    );
    return font.getFont();
  }

  /// Give You Glory regular
  static Future<Font> giveYouGloryRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/giveyouglory/v10/8QIQdiHOgt3vv4LR7ahjw9-XYc1zB4ZD6rwa.ttf',
      'GiveYouGlory-Regular',
    );
    return font.getFont();
  }

  /// Glass Antiqua regular
  static Future<Font> glassAntiquaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/glassantiqua/v10/xfu30Wr0Wn3NOQM2piC0uXOjnL_wN6fRUkY.ttf',
      'GlassAntiqua-Regular',
    );
    return font.getFont();
  }

  /// Glegoo regular
  static Future<Font> glegooRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/glegoo/v10/_Xmt-HQyrTKWaw2Ji6mZAI91xw.ttf',
      'Glegoo-Regular',
    );
    return font.getFont();
  }

  /// Glegoo 700
  static Future<Font> glegooBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/glegoo/v10/_Xmu-HQyrTKWaw2xN4a9CKRpzimMsg.ttf',
      'Glegoo-Bold',
    );
    return font.getFont();
  }

  /// Gloria Hallelujah regular
  static Future<Font> gloriaHallelujahRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/gloriahallelujah/v12/LYjYdHv3kUk9BMV96EIswT9DIbW-MLSy3TKEvkCF.ttf',
      'GloriaHallelujah-Regular',
    );
    return font.getFont();
  }

  /// Goblin One regular
  static Future<Font> goblinOneRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/goblinone/v12/CSR64z1ZnOqZRjRCBVY_TOcATNt_pOU.ttf',
      'GoblinOne-Regular',
    );
    return font.getFont();
  }

  /// Gochi Hand regular
  static Future<Font> gochiHandRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/gochihand/v11/hES06XlsOjtJsgCkx1PkTo71-n0nXWA.ttf',
      'GochiHand-Regular',
    );
    return font.getFont();
  }

  /// Goldman regular
  static Future<Font> goldmanRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/goldman/v5/pe0uMIWbN4JFplR2LDJ4Bt-7G98.ttf',
      'Goldman-Regular',
    );
    return font.getFont();
  }

  /// Goldman 700
  static Future<Font> goldmanBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/goldman/v5/pe0rMIWbN4JFplR2FI5XIteQB9Zra1U.ttf',
      'Goldman-Bold',
    );
    return font.getFont();
  }

  /// Gorditas regular
  static Future<Font> gorditasRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/gorditas/v10/ll8_K2aTVD26DsPEtQDoDa4AlxYb.ttf',
      'Gorditas-Regular',
    );
    return font.getFont();
  }

  /// Gorditas 700
  static Future<Font> gorditasBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/gorditas/v10/ll84K2aTVD26DsPEtThUIooIvAoShA1i.ttf',
      'Gorditas-Bold',
    );
    return font.getFont();
  }

  /// Gothic A1 100
  static Future<Font> gothicA1Thin() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/gothica1/v8/CSR74z5ZnPydRjlCCwlCCMcqYtd2vfwk.ttf',
      'GothicA1-Thin',
    );
    return font.getFont();
  }

  /// Gothic A1 200
  static Future<Font> gothicA1ExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/gothica1/v8/CSR44z5ZnPydRjlCCwlCpOYKSPl6tOU9Eg.ttf',
      'GothicA1-ExtraLight',
    );
    return font.getFont();
  }

  /// Gothic A1 300
  static Future<Font> gothicA1Light() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/gothica1/v8/CSR44z5ZnPydRjlCCwlCwOUKSPl6tOU9Eg.ttf',
      'GothicA1-Light',
    );
    return font.getFont();
  }

  /// Gothic A1 regular
  static Future<Font> gothicA1Regular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/gothica1/v8/CSR94z5ZnPydRjlCCwl6bM0uQNJmvQ.ttf',
      'GothicA1-Regular',
    );
    return font.getFont();
  }

  /// Gothic A1 500
  static Future<Font> gothicA1Medium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/gothica1/v8/CSR44z5ZnPydRjlCCwlCmOQKSPl6tOU9Eg.ttf',
      'GothicA1-Medium',
    );
    return font.getFont();
  }

  /// Gothic A1 600
  static Future<Font> gothicA1SemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/gothica1/v8/CSR44z5ZnPydRjlCCwlCtOMKSPl6tOU9Eg.ttf',
      'GothicA1-SemiBold',
    );
    return font.getFont();
  }

  /// Gothic A1 700
  static Future<Font> gothicA1Bold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/gothica1/v8/CSR44z5ZnPydRjlCCwlC0OIKSPl6tOU9Eg.ttf',
      'GothicA1-Bold',
    );
    return font.getFont();
  }

  /// Gothic A1 800
  static Future<Font> gothicA1ExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/gothica1/v8/CSR44z5ZnPydRjlCCwlCzOEKSPl6tOU9Eg.ttf',
      'GothicA1-ExtraBold',
    );
    return font.getFont();
  }

  /// Gothic A1 900
  static Future<Font> gothicA1Black() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/gothica1/v8/CSR44z5ZnPydRjlCCwlC6OAKSPl6tOU9Eg.ttf',
      'GothicA1-Black',
    );
    return font.getFont();
  }

  /// Gotu regular
  static Future<Font> gotuRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/gotu/v4/o-0FIpksx3QOlH0Lioh6-hU.ttf',
      'Gotu-Regular',
    );
    return font.getFont();
  }

  /// Goudy Bookletter 1911 regular
  static Future<Font> goudyBookletter1911Regular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/goudybookletter1911/v10/sykt-z54laciWfKv-kX8krex0jDiD2HbY6I5tRbXZ4IXAA.ttf',
      'GoudyBookletter1911-Regular',
    );
    return font.getFont();
  }

  /// Graduate regular
  static Future<Font> graduateRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/graduate/v8/C8cg4cs3o2n15t_2YxgR6X2NZAn2.ttf',
      'Graduate-Regular',
    );
    return font.getFont();
  }

  /// Grand Hotel regular
  static Future<Font> grandHotelRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/grandhotel/v8/7Au7p_IgjDKdCRWuR1azpmQNEl0O0kEx.ttf',
      'GrandHotel-Regular',
    );
    return font.getFont();
  }

  /// Grandstander 100
  static Future<Font> grandstanderThin() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/grandstander/v4/ga6fawtA-GpSsTWrnNHPCSIMZhhKpFjyNZIQD1-_D3jWttFGmQk.ttf',
      'Grandstander-Thin',
    );
    return font.getFont();
  }

  /// Grandstander 200
  static Future<Font> grandstanderExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/grandstander/v4/ga6fawtA-GpSsTWrnNHPCSIMZhhKpFjyNZIQD9--D3jWttFGmQk.ttf',
      'Grandstander-ExtraLight',
    );
    return font.getFont();
  }

  /// Grandstander 300
  static Future<Font> grandstanderLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/grandstander/v4/ga6fawtA-GpSsTWrnNHPCSIMZhhKpFjyNZIQDwG-D3jWttFGmQk.ttf',
      'Grandstander-Light',
    );
    return font.getFont();
  }

  /// Grandstander regular
  static Future<Font> grandstanderRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/grandstander/v4/ga6fawtA-GpSsTWrnNHPCSIMZhhKpFjyNZIQD1--D3jWttFGmQk.ttf',
      'Grandstander-Regular',
    );
    return font.getFont();
  }

  /// Grandstander 500
  static Future<Font> grandstanderMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/grandstander/v4/ga6fawtA-GpSsTWrnNHPCSIMZhhKpFjyNZIQD22-D3jWttFGmQk.ttf',
      'Grandstander-Medium',
    );
    return font.getFont();
  }

  /// Grandstander 600
  static Future<Font> grandstanderSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/grandstander/v4/ga6fawtA-GpSsTWrnNHPCSIMZhhKpFjyNZIQD4G5D3jWttFGmQk.ttf',
      'Grandstander-SemiBold',
    );
    return font.getFont();
  }

  /// Grandstander 700
  static Future<Font> grandstanderBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/grandstander/v4/ga6fawtA-GpSsTWrnNHPCSIMZhhKpFjyNZIQD7i5D3jWttFGmQk.ttf',
      'Grandstander-Bold',
    );
    return font.getFont();
  }

  /// Grandstander 800
  static Future<Font> grandstanderExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/grandstander/v4/ga6fawtA-GpSsTWrnNHPCSIMZhhKpFjyNZIQD9-5D3jWttFGmQk.ttf',
      'Grandstander-ExtraBold',
    );
    return font.getFont();
  }

  /// Grandstander 900
  static Future<Font> grandstanderBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/grandstander/v4/ga6fawtA-GpSsTWrnNHPCSIMZhhKpFjyNZIQD_a5D3jWttFGmQk.ttf',
      'Grandstander-Black',
    );
    return font.getFont();
  }

  /// Grandstander 100italic
  static Future<Font> grandstanderThinItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/grandstander/v4/ga6ZawtA-GpSsTWrnNHPCSImbyq1fDGZrzwXGpf95zrcsvNDiQlBYQ.ttf',
      'Grandstander-ThinItalic',
    );
    return font.getFont();
  }

  /// Grandstander 200italic
  static Future<Font> grandstanderExtraLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/grandstander/v4/ga6ZawtA-GpSsTWrnNHPCSImbyq1fDGZrzwXGpf9ZzvcsvNDiQlBYQ.ttf',
      'Grandstander-ExtraLightItalic',
    );
    return font.getFont();
  }

  /// Grandstander 300italic
  static Future<Font> grandstanderLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/grandstander/v4/ga6ZawtA-GpSsTWrnNHPCSImbyq1fDGZrzwXGpf9uTvcsvNDiQlBYQ.ttf',
      'Grandstander-LightItalic',
    );
    return font.getFont();
  }

  /// Grandstander italic
  static Future<Font> grandstanderItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/grandstander/v4/ga6ZawtA-GpSsTWrnNHPCSImbyq1fDGZrzwXGpf95zvcsvNDiQlBYQ.ttf',
      'Grandstander-Italic',
    );
    return font.getFont();
  }

  /// Grandstander 500italic
  static Future<Font> grandstanderMediumItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/grandstander/v4/ga6ZawtA-GpSsTWrnNHPCSImbyq1fDGZrzwXGpf91TvcsvNDiQlBYQ.ttf',
      'Grandstander-MediumItalic',
    );
    return font.getFont();
  }

  /// Grandstander 600italic
  static Future<Font> grandstanderSemiBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/grandstander/v4/ga6ZawtA-GpSsTWrnNHPCSImbyq1fDGZrzwXGpf9OTzcsvNDiQlBYQ.ttf',
      'Grandstander-SemiBoldItalic',
    );
    return font.getFont();
  }

  /// Grandstander 700italic
  static Future<Font> grandstanderBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/grandstander/v4/ga6ZawtA-GpSsTWrnNHPCSImbyq1fDGZrzwXGpf9ADzcsvNDiQlBYQ.ttf',
      'Grandstander-BoldItalic',
    );
    return font.getFont();
  }

  /// Grandstander 800italic
  static Future<Font> grandstanderExtraBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/grandstander/v4/ga6ZawtA-GpSsTWrnNHPCSImbyq1fDGZrzwXGpf9ZzzcsvNDiQlBYQ.ttf',
      'Grandstander-ExtraBoldItalic',
    );
    return font.getFont();
  }

  /// Grandstander 900italic
  static Future<Font> grandstanderBlackItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/grandstander/v4/ga6ZawtA-GpSsTWrnNHPCSImbyq1fDGZrzwXGpf9TjzcsvNDiQlBYQ.ttf',
      'Grandstander-BlackItalic',
    );
    return font.getFont();
  }

  /// Gravitas One regular
  static Future<Font> gravitasOneRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/gravitasone/v10/5h1diZ4hJ3cblKy3LWakKQmaDWRNr3DzbQ.ttf',
      'GravitasOne-Regular',
    );
    return font.getFont();
  }

  /// Great Vibes regular
  static Future<Font> greatVibesRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/greatvibes/v8/RWmMoKWR9v4ksMfaWd_JN-XCg6UKDXlq.ttf',
      'GreatVibes-Regular',
    );
    return font.getFont();
  }

  /// Grenze 100
  static Future<Font> grenzeThin() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/grenze/v4/O4ZRFGb7hR12BxqPm2IjuAkalnmd.ttf',
      'Grenze-Thin',
    );
    return font.getFont();
  }

  /// Grenze 100italic
  static Future<Font> grenzeThinItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/grenze/v4/O4ZXFGb7hR12BxqH_VpHsg04k2md0kI.ttf',
      'Grenze-ThinItalic',
    );
    return font.getFont();
  }

  /// Grenze 200
  static Future<Font> grenzeExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/grenze/v4/O4ZQFGb7hR12BxqPN0MDkicWn2CEyw.ttf',
      'Grenze-ExtraLight',
    );
    return font.getFont();
  }

  /// Grenze 200italic
  static Future<Font> grenzeExtraLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/grenze/v4/O4ZWFGb7hR12BxqH_Vrrky0SvWWUy1uW.ttf',
      'Grenze-ExtraLightItalic',
    );
    return font.getFont();
  }

  /// Grenze 300
  static Future<Font> grenzeLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/grenze/v4/O4ZQFGb7hR12BxqPU0ADkicWn2CEyw.ttf',
      'Grenze-Light',
    );
    return font.getFont();
  }

  /// Grenze 300italic
  static Future<Font> grenzeLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/grenze/v4/O4ZWFGb7hR12BxqH_VqPkC0SvWWUy1uW.ttf',
      'Grenze-LightItalic',
    );
    return font.getFont();
  }

  /// Grenze regular
  static Future<Font> grenzeRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/grenze/v4/O4ZTFGb7hR12Bxq3_2gnmgwKlg.ttf',
      'Grenze-Regular',
    );
    return font.getFont();
  }

  /// Grenze italic
  static Future<Font> grenzeItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/grenze/v4/O4ZRFGb7hR12BxqH_WIjuAkalnmd.ttf',
      'Grenze-Italic',
    );
    return font.getFont();
  }

  /// Grenze 500
  static Future<Font> grenzeMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/grenze/v4/O4ZQFGb7hR12BxqPC0EDkicWn2CEyw.ttf',
      'Grenze-Medium',
    );
    return font.getFont();
  }

  /// Grenze 500italic
  static Future<Font> grenzeMediumItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/grenze/v4/O4ZWFGb7hR12BxqH_VrXkS0SvWWUy1uW.ttf',
      'Grenze-MediumItalic',
    );
    return font.getFont();
  }

  /// Grenze 600
  static Future<Font> grenzeSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/grenze/v4/O4ZQFGb7hR12BxqPJ0YDkicWn2CEyw.ttf',
      'Grenze-SemiBold',
    );
    return font.getFont();
  }

  /// Grenze 600italic
  static Future<Font> grenzeSemiBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/grenze/v4/O4ZWFGb7hR12BxqH_Vr7li0SvWWUy1uW.ttf',
      'Grenze-SemiBoldItalic',
    );
    return font.getFont();
  }

  /// Grenze 700
  static Future<Font> grenzeBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/grenze/v4/O4ZQFGb7hR12BxqPQ0cDkicWn2CEyw.ttf',
      'Grenze-Bold',
    );
    return font.getFont();
  }

  /// Grenze 700italic
  static Future<Font> grenzeBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/grenze/v4/O4ZWFGb7hR12BxqH_Vqfly0SvWWUy1uW.ttf',
      'Grenze-BoldItalic',
    );
    return font.getFont();
  }

  /// Grenze 800
  static Future<Font> grenzeExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/grenze/v4/O4ZQFGb7hR12BxqPX0QDkicWn2CEyw.ttf',
      'Grenze-ExtraBold',
    );
    return font.getFont();
  }

  /// Grenze 800italic
  static Future<Font> grenzeExtraBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/grenze/v4/O4ZWFGb7hR12BxqH_VqDlC0SvWWUy1uW.ttf',
      'Grenze-ExtraBoldItalic',
    );
    return font.getFont();
  }

  /// Grenze 900
  static Future<Font> grenzeBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/grenze/v4/O4ZQFGb7hR12BxqPe0UDkicWn2CEyw.ttf',
      'Grenze-Black',
    );
    return font.getFont();
  }

  /// Grenze 900italic
  static Future<Font> grenzeBlackItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/grenze/v4/O4ZWFGb7hR12BxqH_VqnlS0SvWWUy1uW.ttf',
      'Grenze-BlackItalic',
    );
    return font.getFont();
  }

  /// Grenze Gotisch 100
  static Future<Font> grenzeGotischThin() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/grenzegotisch/v3/Fh4hPjjqNDz1osh_jX9YfjudpBJBNV5y5wf_k1i5Lz5UcICdYPSd_w.ttf',
      'GrenzeGotisch-Thin',
    );
    return font.getFont();
  }

  /// Grenze Gotisch 200
  static Future<Font> grenzeGotischExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/grenzegotisch/v3/Fh4hPjjqNDz1osh_jX9YfjudpBJBNV5y5wf_k1i5rz9UcICdYPSd_w.ttf',
      'GrenzeGotisch-ExtraLight',
    );
    return font.getFont();
  }

  /// Grenze Gotisch 300
  static Future<Font> grenzeGotischLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/grenzegotisch/v3/Fh4hPjjqNDz1osh_jX9YfjudpBJBNV5y5wf_k1i5cT9UcICdYPSd_w.ttf',
      'GrenzeGotisch-Light',
    );
    return font.getFont();
  }

  /// Grenze Gotisch regular
  static Future<Font> grenzeGotischRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/grenzegotisch/v3/Fh4hPjjqNDz1osh_jX9YfjudpBJBNV5y5wf_k1i5Lz9UcICdYPSd_w.ttf',
      'GrenzeGotisch-Regular',
    );
    return font.getFont();
  }

  /// Grenze Gotisch 500
  static Future<Font> grenzeGotischMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/grenzegotisch/v3/Fh4hPjjqNDz1osh_jX9YfjudpBJBNV5y5wf_k1i5HT9UcICdYPSd_w.ttf',
      'GrenzeGotisch-Medium',
    );
    return font.getFont();
  }

  /// Grenze Gotisch 600
  static Future<Font> grenzeGotischSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/grenzegotisch/v3/Fh4hPjjqNDz1osh_jX9YfjudpBJBNV5y5wf_k1i58ThUcICdYPSd_w.ttf',
      'GrenzeGotisch-SemiBold',
    );
    return font.getFont();
  }

  /// Grenze Gotisch 700
  static Future<Font> grenzeGotischBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/grenzegotisch/v3/Fh4hPjjqNDz1osh_jX9YfjudpBJBNV5y5wf_k1i5yDhUcICdYPSd_w.ttf',
      'GrenzeGotisch-Bold',
    );
    return font.getFont();
  }

  /// Grenze Gotisch 800
  static Future<Font> grenzeGotischExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/grenzegotisch/v3/Fh4hPjjqNDz1osh_jX9YfjudpBJBNV5y5wf_k1i5rzhUcICdYPSd_w.ttf',
      'GrenzeGotisch-ExtraBold',
    );
    return font.getFont();
  }

  /// Grenze Gotisch 900
  static Future<Font> grenzeGotischBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/grenzegotisch/v3/Fh4hPjjqNDz1osh_jX9YfjudpBJBNV5y5wf_k1i5hjhUcICdYPSd_w.ttf',
      'GrenzeGotisch-Black',
    );
    return font.getFont();
  }

  /// Griffy regular
  static Future<Font> griffyRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/griffy/v11/FwZa7-ox2FQh9kfwSNSEwM2zpA.ttf',
      'Griffy-Regular',
    );
    return font.getFont();
  }

  /// Gruppo regular
  static Future<Font> gruppoRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/gruppo/v11/WwkfxPmzE06v_ZWFWXDAOIEQUQ.ttf',
      'Gruppo-Regular',
    );
    return font.getFont();
  }

  /// Gudea regular
  static Future<Font> gudeaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/gudea/v10/neIFzCqgsI0mp-CP9IGON7Ez.ttf',
      'Gudea-Regular',
    );
    return font.getFont();
  }

  /// Gudea italic
  static Future<Font> gudeaItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/gudea/v10/neILzCqgsI0mp9CN_oWsMqEzSJQ.ttf',
      'Gudea-Italic',
    );
    return font.getFont();
  }

  /// Gudea 700
  static Future<Font> gudeaBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/gudea/v10/neIIzCqgsI0mp9gz26WGHK06UY30.ttf',
      'Gudea-Bold',
    );
    return font.getFont();
  }

  /// Gugi regular
  static Future<Font> gugiRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/gugi/v8/A2BVn5dXywshVA6A9DEfgqM.ttf',
      'Gugi-Regular',
    );
    return font.getFont();
  }

  /// Gupter regular
  static Future<Font> gupterRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/gupter/v4/2-cm9JNmxJqPO1QUYZa_Wu_lpA.ttf',
      'Gupter-Regular',
    );
    return font.getFont();
  }

  /// Gupter 500
  static Future<Font> gupterMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/gupter/v4/2-cl9JNmxJqPO1Qslb-bUsT5rZhaZg.ttf',
      'Gupter-Medium',
    );
    return font.getFont();
  }

  /// Gupter 700
  static Future<Font> gupterBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/gupter/v4/2-cl9JNmxJqPO1Qs3bmbUsT5rZhaZg.ttf',
      'Gupter-Bold',
    );
    return font.getFont();
  }

  /// Gurajada regular
  static Future<Font> gurajadaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/gurajada/v10/FwZY7-Qx308m-l-0Kd6A4sijpFu_.ttf',
      'Gurajada-Regular',
    );
    return font.getFont();
  }

  /// Habibi regular
  static Future<Font> habibiRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/habibi/v11/CSR-4zFWkuqcTTNCShJeZOYySQ.ttf',
      'Habibi-Regular',
    );
    return font.getFont();
  }

  /// Hachi Maru Pop regular
  static Future<Font> hachiMaruPopRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/hachimarupop/v6/HI_TiYoRLqpLrEiMAuO9Ysfz7rW1EM_btd8u.ttf',
      'HachiMaruPop-Regular',
    );
    return font.getFont();
  }

  /// Halant 300
  static Future<Font> halantLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/halant/v8/u-490qaujRI2Pbsvc_pCmwZqcwdRXg.ttf',
      'Halant-Light',
    );
    return font.getFont();
  }

  /// Halant regular
  static Future<Font> halantRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/halant/v8/u-4-0qaujRI2PbsX39Jmky12eg.ttf',
      'Halant-Regular',
    );
    return font.getFont();
  }

  /// Halant 500
  static Future<Font> halantMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/halant/v8/u-490qaujRI2PbsvK_tCmwZqcwdRXg.ttf',
      'Halant-Medium',
    );
    return font.getFont();
  }

  /// Halant 600
  static Future<Font> halantSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/halant/v8/u-490qaujRI2PbsvB_xCmwZqcwdRXg.ttf',
      'Halant-SemiBold',
    );
    return font.getFont();
  }

  /// Halant 700
  static Future<Font> halantBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/halant/v8/u-490qaujRI2PbsvY_1CmwZqcwdRXg.ttf',
      'Halant-Bold',
    );
    return font.getFont();
  }

  /// Hammersmith One regular
  static Future<Font> hammersmithOneRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/hammersmithone/v12/qWcyB624q4L_C4jGQ9IK0O_dFlnbshsks4MRXw.ttf',
      'HammersmithOne-Regular',
    );
    return font.getFont();
  }

  /// Hanalei regular
  static Future<Font> hanaleiRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/hanalei/v13/E21n_dD8iufIjBRHXzgmVydREus.ttf',
      'Hanalei-Regular',
    );
    return font.getFont();
  }

  /// Hanalei Fill regular
  static Future<Font> hanaleiFillRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/hanaleifill/v11/fC1mPYtObGbfyQznIaQzPQiMVwLBplm9aw.ttf',
      'HanaleiFill-Regular',
    );
    return font.getFont();
  }

  /// Handlee regular
  static Future<Font> handleeRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/handlee/v9/-F6xfjBsISg9aMakDmr6oilJ3ik.ttf',
      'Handlee-Regular',
    );
    return font.getFont();
  }

  /// Hanuman regular
  static Future<Font> hanumanRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/hanuman/v14/VuJxdNvD15HhpJJBeKbXOIFneRo.ttf',
      'Hanuman-Regular',
    );
    return font.getFont();
  }

  /// Hanuman 700
  static Future<Font> hanumanBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/hanuman/v14/VuJ0dNvD15HhpJJBQBr4HIlMZRNcp0o.ttf',
      'Hanuman-Bold',
    );
    return font.getFont();
  }

  /// Happy Monkey regular
  static Future<Font> happyMonkeyRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/happymonkey/v9/K2F2fZZcl-9SXwl5F_C4R_OABwD2bWqVjw.ttf',
      'HappyMonkey-Regular',
    );
    return font.getFont();
  }

  /// Harmattan regular
  static Future<Font> harmattanRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/harmattan/v11/goksH6L2DkFvVvRp9XpTS0CjkP1Yog.ttf',
      'Harmattan-Regular',
    );
    return font.getFont();
  }

  /// Harmattan 700
  static Future<Font> harmattanBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/harmattan/v11/gokpH6L2DkFvVvRp9Xpr92-HmNZEq6TTFw.ttf',
      'Harmattan-Bold',
    );
    return font.getFont();
  }

  /// Headland One regular
  static Future<Font> headlandOneRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/headlandone/v10/yYLu0hHR2vKnp89Tk1TCq3Tx0PlTeZ3mJA.ttf',
      'HeadlandOne-Regular',
    );
    return font.getFont();
  }

  /// Heebo 100
  static Future<Font> heeboThin() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/heebo/v10/NGSpv5_NC0k9P_v6ZUCbLRAHxK1EiS2cckOnz02SXQ.ttf',
      'Heebo-Thin',
    );
    return font.getFont();
  }

  /// Heebo 200
  static Future<Font> heeboExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/heebo/v10/NGSpv5_NC0k9P_v6ZUCbLRAHxK1ECSycckOnz02SXQ.ttf',
      'Heebo-ExtraLight',
    );
    return font.getFont();
  }

  /// Heebo 300
  static Future<Font> heeboLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/heebo/v10/NGSpv5_NC0k9P_v6ZUCbLRAHxK1E1yycckOnz02SXQ.ttf',
      'Heebo-Light',
    );
    return font.getFont();
  }

  /// Heebo regular
  static Future<Font> heeboRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/heebo/v10/NGSpv5_NC0k9P_v6ZUCbLRAHxK1EiSycckOnz02SXQ.ttf',
      'Heebo-Regular',
    );
    return font.getFont();
  }

  /// Heebo 500
  static Future<Font> heeboMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/heebo/v10/NGSpv5_NC0k9P_v6ZUCbLRAHxK1EuyycckOnz02SXQ.ttf',
      'Heebo-Medium',
    );
    return font.getFont();
  }

  /// Heebo 600
  static Future<Font> heeboSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/heebo/v10/NGSpv5_NC0k9P_v6ZUCbLRAHxK1EVyucckOnz02SXQ.ttf',
      'Heebo-SemiBold',
    );
    return font.getFont();
  }

  /// Heebo 700
  static Future<Font> heeboBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/heebo/v10/NGSpv5_NC0k9P_v6ZUCbLRAHxK1EbiucckOnz02SXQ.ttf',
      'Heebo-Bold',
    );
    return font.getFont();
  }

  /// Heebo 800
  static Future<Font> heeboExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/heebo/v10/NGSpv5_NC0k9P_v6ZUCbLRAHxK1ECSucckOnz02SXQ.ttf',
      'Heebo-ExtraBold',
    );
    return font.getFont();
  }

  /// Heebo 900
  static Future<Font> heeboBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/heebo/v10/NGSpv5_NC0k9P_v6ZUCbLRAHxK1EICucckOnz02SXQ.ttf',
      'Heebo-Black',
    );
    return font.getFont();
  }

  /// Henny Penny regular
  static Future<Font> hennyPennyRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/hennypenny/v10/wXKvE3UZookzsxz_kjGSfMQqt3M7tMDT.ttf',
      'HennyPenny-Regular',
    );
    return font.getFont();
  }

  /// Hepta Slab 100
  static Future<Font> heptaSlabThin() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/heptaslab/v9/ea8JadoyU_jkHdalebHvyWVNdYoIsHe5HvkV5jfbY5B0NBkz.ttf',
      'HeptaSlab-Thin',
    );
    return font.getFont();
  }

  /// Hepta Slab 200
  static Future<Font> heptaSlabExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/heptaslab/v9/ea8JadoyU_jkHdalebHvyWVNdYoIsHe5HvmV5zfbY5B0NBkz.ttf',
      'HeptaSlab-ExtraLight',
    );
    return font.getFont();
  }

  /// Hepta Slab 300
  static Future<Font> heptaSlabLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/heptaslab/v9/ea8JadoyU_jkHdalebHvyWVNdYoIsHe5HvlL5zfbY5B0NBkz.ttf',
      'HeptaSlab-Light',
    );
    return font.getFont();
  }

  /// Hepta Slab regular
  static Future<Font> heptaSlabRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/heptaslab/v9/ea8JadoyU_jkHdalebHvyWVNdYoIsHe5HvkV5zfbY5B0NBkz.ttf',
      'HeptaSlab-Regular',
    );
    return font.getFont();
  }

  /// Hepta Slab 500
  static Future<Font> heptaSlabMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/heptaslab/v9/ea8JadoyU_jkHdalebHvyWVNdYoIsHe5Hvkn5zfbY5B0NBkz.ttf',
      'HeptaSlab-Medium',
    );
    return font.getFont();
  }

  /// Hepta Slab 600
  static Future<Font> heptaSlabSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/heptaslab/v9/ea8JadoyU_jkHdalebHvyWVNdYoIsHe5HvnL4DfbY5B0NBkz.ttf',
      'HeptaSlab-SemiBold',
    );
    return font.getFont();
  }

  /// Hepta Slab 700
  static Future<Font> heptaSlabBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/heptaslab/v9/ea8JadoyU_jkHdalebHvyWVNdYoIsHe5Hvny4DfbY5B0NBkz.ttf',
      'HeptaSlab-Bold',
    );
    return font.getFont();
  }

  /// Hepta Slab 800
  static Future<Font> heptaSlabExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/heptaslab/v9/ea8JadoyU_jkHdalebHvyWVNdYoIsHe5HvmV4DfbY5B0NBkz.ttf',
      'HeptaSlab-ExtraBold',
    );
    return font.getFont();
  }

  /// Hepta Slab 900
  static Future<Font> heptaSlabBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/heptaslab/v9/ea8JadoyU_jkHdalebHvyWVNdYoIsHe5Hvm84DfbY5B0NBkz.ttf',
      'HeptaSlab-Black',
    );
    return font.getFont();
  }

  /// Herr Von Muellerhoff regular
  static Future<Font> herrVonMuellerhoffRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/herrvonmuellerhoff/v10/WBL6rFjRZkREW8WqmCWYLgCkQKXb4CAft3c6_qJY3QPQ.ttf',
      'HerrVonMuellerhoff-Regular',
    );
    return font.getFont();
  }

  /// Hi Melody regular
  static Future<Font> hiMelodyRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/himelody/v8/46ktlbP8Vnz0pJcqCTbEf29E31BBGA.ttf',
      'HiMelody-Regular',
    );
    return font.getFont();
  }

  /// Hind 300
  static Future<Font> hindLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/hind/v11/5aU19_a8oxmIfMJaIRuYjDpf5Vw.ttf',
      'Hind-Light',
    );
    return font.getFont();
  }

  /// Hind regular
  static Future<Font> hindRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/hind/v11/5aU69_a8oxmIRG5yBROzkDM.ttf',
      'Hind-Regular',
    );
    return font.getFont();
  }

  /// Hind 500
  static Future<Font> hindMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/hind/v11/5aU19_a8oxmIfJpbIRuYjDpf5Vw.ttf',
      'Hind-Medium',
    );
    return font.getFont();
  }

  /// Hind 600
  static Future<Font> hindSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/hind/v11/5aU19_a8oxmIfLZcIRuYjDpf5Vw.ttf',
      'Hind-SemiBold',
    );
    return font.getFont();
  }

  /// Hind 700
  static Future<Font> hindBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/hind/v11/5aU19_a8oxmIfNJdIRuYjDpf5Vw.ttf',
      'Hind-Bold',
    );
    return font.getFont();
  }

  /// Hind Guntur 300
  static Future<Font> hindGunturLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/hindguntur/v7/wXKyE3UZrok56nvamSuJd_yGn1czn9zaj5Ju.ttf',
      'HindGuntur-Light',
    );
    return font.getFont();
  }

  /// Hind Guntur regular
  static Future<Font> hindGunturRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/hindguntur/v7/wXKvE3UZrok56nvamSuJd8Qqt3M7tMDT.ttf',
      'HindGuntur-Regular',
    );
    return font.getFont();
  }

  /// Hind Guntur 500
  static Future<Font> hindGunturMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/hindguntur/v7/wXKyE3UZrok56nvamSuJd_zenlczn9zaj5Ju.ttf',
      'HindGuntur-Medium',
    );
    return font.getFont();
  }

  /// Hind Guntur 600
  static Future<Font> hindGunturSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/hindguntur/v7/wXKyE3UZrok56nvamSuJd_zymVczn9zaj5Ju.ttf',
      'HindGuntur-SemiBold',
    );
    return font.getFont();
  }

  /// Hind Guntur 700
  static Future<Font> hindGunturBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/hindguntur/v7/wXKyE3UZrok56nvamSuJd_yWmFczn9zaj5Ju.ttf',
      'HindGuntur-Bold',
    );
    return font.getFont();
  }

  /// Hind Madurai 300
  static Future<Font> hindMaduraiLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/hindmadurai/v6/f0Xu0e2p98ZvDXdZQIOcpqjfXaUnecsoMJ0b_g.ttf',
      'HindMadurai-Light',
    );
    return font.getFont();
  }

  /// Hind Madurai regular
  static Future<Font> hindMaduraiRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/hindmadurai/v6/f0Xx0e2p98ZvDXdZQIOcpqjn8Y0DceA0OQ.ttf',
      'HindMadurai-Regular',
    );
    return font.getFont();
  }

  /// Hind Madurai 500
  static Future<Font> hindMaduraiMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/hindmadurai/v6/f0Xu0e2p98ZvDXdZQIOcpqjfBaQnecsoMJ0b_g.ttf',
      'HindMadurai-Medium',
    );
    return font.getFont();
  }

  /// Hind Madurai 600
  static Future<Font> hindMaduraiSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/hindmadurai/v6/f0Xu0e2p98ZvDXdZQIOcpqjfKaMnecsoMJ0b_g.ttf',
      'HindMadurai-SemiBold',
    );
    return font.getFont();
  }

  /// Hind Madurai 700
  static Future<Font> hindMaduraiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/hindmadurai/v6/f0Xu0e2p98ZvDXdZQIOcpqjfTaInecsoMJ0b_g.ttf',
      'HindMadurai-Bold',
    );
    return font.getFont();
  }

  /// Hind Siliguri 300
  static Future<Font> hindSiliguriLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/hindsiliguri/v7/ijwOs5juQtsyLLR5jN4cxBEoRDf44uEfKiGvxts.ttf',
      'HindSiliguri-Light',
    );
    return font.getFont();
  }

  /// Hind Siliguri regular
  static Future<Font> hindSiliguriRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/hindsiliguri/v7/ijwTs5juQtsyLLR5jN4cxBEofJvQxuk0Nig.ttf',
      'HindSiliguri-Regular',
    );
    return font.getFont();
  }

  /// Hind Siliguri 500
  static Future<Font> hindSiliguriMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/hindsiliguri/v7/ijwOs5juQtsyLLR5jN4cxBEoRG_54uEfKiGvxts.ttf',
      'HindSiliguri-Medium',
    );
    return font.getFont();
  }

  /// Hind Siliguri 600
  static Future<Font> hindSiliguriSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/hindsiliguri/v7/ijwOs5juQtsyLLR5jN4cxBEoREP-4uEfKiGvxts.ttf',
      'HindSiliguri-SemiBold',
    );
    return font.getFont();
  }

  /// Hind Siliguri 700
  static Future<Font> hindSiliguriBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/hindsiliguri/v7/ijwOs5juQtsyLLR5jN4cxBEoRCf_4uEfKiGvxts.ttf',
      'HindSiliguri-Bold',
    );
    return font.getFont();
  }

  /// Hind Vadodara 300
  static Future<Font> hindVadodaraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/hindvadodara/v7/neIQzCKvrIcn5pbuuuriV9tTSDn3iXM0oSOL2Yw.ttf',
      'HindVadodara-Light',
    );
    return font.getFont();
  }

  /// Hind Vadodara regular
  static Future<Font> hindVadodaraRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/hindvadodara/v7/neINzCKvrIcn5pbuuuriV9tTcJXfrXsfvSo.ttf',
      'HindVadodara-Regular',
    );
    return font.getFont();
  }

  /// Hind Vadodara 500
  static Future<Font> hindVadodaraMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/hindvadodara/v7/neIQzCKvrIcn5pbuuuriV9tTSGH2iXM0oSOL2Yw.ttf',
      'HindVadodara-Medium',
    );
    return font.getFont();
  }

  /// Hind Vadodara 600
  static Future<Font> hindVadodaraSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/hindvadodara/v7/neIQzCKvrIcn5pbuuuriV9tTSE3xiXM0oSOL2Yw.ttf',
      'HindVadodara-SemiBold',
    );
    return font.getFont();
  }

  /// Hind Vadodara 700
  static Future<Font> hindVadodaraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/hindvadodara/v7/neIQzCKvrIcn5pbuuuriV9tTSCnwiXM0oSOL2Yw.ttf',
      'HindVadodara-Bold',
    );
    return font.getFont();
  }

  /// Holtwood One SC regular
  static Future<Font> holtwoodOneSCRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/holtwoodonesc/v11/yYLx0hLR0P-3vMFSk1TCq3Txg5B3cbb6LZttyg.ttf',
      'HoltwoodOneSC-Regular',
    );
    return font.getFont();
  }

  /// Homemade Apple regular
  static Future<Font> homemadeAppleRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/homemadeapple/v11/Qw3EZQFXECDrI2q789EKQZJob3x9Vnksi4M7.ttf',
      'HomemadeApple-Regular',
    );
    return font.getFont();
  }

  /// Homenaje regular
  static Future<Font> homenajeRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/homenaje/v10/FwZY7-Q-xVAi_l-6Ld6A4sijpFu_.ttf',
      'Homenaje-Regular',
    );
    return font.getFont();
  }

  /// IBM Plex Mono 100
  static Future<Font> iBMPlexMonoThin() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ibmplexmono/v6/-F6pfjptAgt5VM-kVkqdyU8n3kwq0n1hj-sNFQ.ttf',
      'IBMPlexMono-Thin',
    );
    return font.getFont();
  }

  /// IBM Plex Mono 100italic
  static Future<Font> iBMPlexMonoThinItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ibmplexmono/v6/-F6rfjptAgt5VM-kVkqdyU8n1ioStndlre4dFcFh.ttf',
      'IBMPlexMono-ThinItalic',
    );
    return font.getFont();
  }

  /// IBM Plex Mono 200
  static Future<Font> iBMPlexMonoExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ibmplexmono/v6/-F6qfjptAgt5VM-kVkqdyU8n3uAL8ldPg-IUDNg.ttf',
      'IBMPlexMono-ExtraLight',
    );
    return font.getFont();
  }

  /// IBM Plex Mono 200italic
  static Future<Font> iBMPlexMonoExtraLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ibmplexmono/v6/-F6sfjptAgt5VM-kVkqdyU8n1ioSGlZFh8ARHNh4zg.ttf',
      'IBMPlexMono-ExtraLightItalic',
    );
    return font.getFont();
  }

  /// IBM Plex Mono 300
  static Future<Font> iBMPlexMonoLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ibmplexmono/v6/-F6qfjptAgt5VM-kVkqdyU8n3oQI8ldPg-IUDNg.ttf',
      'IBMPlexMono-Light',
    );
    return font.getFont();
  }

  /// IBM Plex Mono 300italic
  static Future<Font> iBMPlexMonoLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ibmplexmono/v6/-F6sfjptAgt5VM-kVkqdyU8n1ioSflVFh8ARHNh4zg.ttf',
      'IBMPlexMono-LightItalic',
    );
    return font.getFont();
  }

  /// IBM Plex Mono regular
  static Future<Font> iBMPlexMonoRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ibmplexmono/v6/-F63fjptAgt5VM-kVkqdyU8n5igg1l9kn-s.ttf',
      'IBMPlexMono-Regular',
    );
    return font.getFont();
  }

  /// IBM Plex Mono italic
  static Future<Font> iBMPlexMonoItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ibmplexmono/v6/-F6pfjptAgt5VM-kVkqdyU8n1ioq0n1hj-sNFQ.ttf',
      'IBMPlexMono-Italic',
    );
    return font.getFont();
  }

  /// IBM Plex Mono 500
  static Future<Font> iBMPlexMonoMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ibmplexmono/v6/-F6qfjptAgt5VM-kVkqdyU8n3twJ8ldPg-IUDNg.ttf',
      'IBMPlexMono-Medium',
    );
    return font.getFont();
  }

  /// IBM Plex Mono 500italic
  static Future<Font> iBMPlexMonoMediumItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ibmplexmono/v6/-F6sfjptAgt5VM-kVkqdyU8n1ioSJlRFh8ARHNh4zg.ttf',
      'IBMPlexMono-MediumItalic',
    );
    return font.getFont();
  }

  /// IBM Plex Mono 600
  static Future<Font> iBMPlexMonoSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ibmplexmono/v6/-F6qfjptAgt5VM-kVkqdyU8n3vAO8ldPg-IUDNg.ttf',
      'IBMPlexMono-SemiBold',
    );
    return font.getFont();
  }

  /// IBM Plex Mono 600italic
  static Future<Font> iBMPlexMonoSemiBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ibmplexmono/v6/-F6sfjptAgt5VM-kVkqdyU8n1ioSClNFh8ARHNh4zg.ttf',
      'IBMPlexMono-SemiBoldItalic',
    );
    return font.getFont();
  }

  /// IBM Plex Mono 700
  static Future<Font> iBMPlexMonoBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ibmplexmono/v6/-F6qfjptAgt5VM-kVkqdyU8n3pQP8ldPg-IUDNg.ttf',
      'IBMPlexMono-Bold',
    );
    return font.getFont();
  }

  /// IBM Plex Mono 700italic
  static Future<Font> iBMPlexMonoBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ibmplexmono/v6/-F6sfjptAgt5VM-kVkqdyU8n1ioSblJFh8ARHNh4zg.ttf',
      'IBMPlexMono-BoldItalic',
    );
    return font.getFont();
  }

  /// IBM Plex Sans 100
  static Future<Font> iBMPlexSansThin() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ibmplexsans/v8/zYX-KVElMYYaJe8bpLHnCwDKjbLeEKxIedbzDw.ttf',
      'IBMPlexSans-Thin',
    );
    return font.getFont();
  }

  /// IBM Plex Sans 100italic
  static Future<Font> iBMPlexSansThinItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ibmplexsans/v8/zYX8KVElMYYaJe8bpLHnCwDKhdTmdKZMW9PjD3N8.ttf',
      'IBMPlexSans-ThinItalic',
    );
    return font.getFont();
  }

  /// IBM Plex Sans 200
  static Future<Font> iBMPlexSansExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ibmplexsans/v8/zYX9KVElMYYaJe8bpLHnCwDKjR7_MIZmdd_qFmo.ttf',
      'IBMPlexSans-ExtraLight',
    );
    return font.getFont();
  }

  /// IBM Plex Sans 200italic
  static Future<Font> iBMPlexSansExtraLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ibmplexsans/v8/zYX7KVElMYYaJe8bpLHnCwDKhdTm2Idscf3vBmpl8A.ttf',
      'IBMPlexSans-ExtraLightItalic',
    );
    return font.getFont();
  }

  /// IBM Plex Sans 300
  static Future<Font> iBMPlexSansLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ibmplexsans/v8/zYX9KVElMYYaJe8bpLHnCwDKjXr8MIZmdd_qFmo.ttf',
      'IBMPlexSans-Light',
    );
    return font.getFont();
  }

  /// IBM Plex Sans 300italic
  static Future<Font> iBMPlexSansLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ibmplexsans/v8/zYX7KVElMYYaJe8bpLHnCwDKhdTmvIRscf3vBmpl8A.ttf',
      'IBMPlexSans-LightItalic',
    );
    return font.getFont();
  }

  /// IBM Plex Sans regular
  static Future<Font> iBMPlexSansRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ibmplexsans/v8/zYXgKVElMYYaJe8bpLHnCwDKtdbUFI5NadY.ttf',
      'IBMPlexSans-Regular',
    );
    return font.getFont();
  }

  /// IBM Plex Sans italic
  static Future<Font> iBMPlexSansItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ibmplexsans/v8/zYX-KVElMYYaJe8bpLHnCwDKhdTeEKxIedbzDw.ttf',
      'IBMPlexSans-Italic',
    );
    return font.getFont();
  }

  /// IBM Plex Sans 500
  static Future<Font> iBMPlexSansMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ibmplexsans/v8/zYX9KVElMYYaJe8bpLHnCwDKjSL9MIZmdd_qFmo.ttf',
      'IBMPlexSans-Medium',
    );
    return font.getFont();
  }

  /// IBM Plex Sans 500italic
  static Future<Font> iBMPlexSansMediumItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ibmplexsans/v8/zYX7KVElMYYaJe8bpLHnCwDKhdTm5IVscf3vBmpl8A.ttf',
      'IBMPlexSans-MediumItalic',
    );
    return font.getFont();
  }

  /// IBM Plex Sans 600
  static Future<Font> iBMPlexSansSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ibmplexsans/v8/zYX9KVElMYYaJe8bpLHnCwDKjQ76MIZmdd_qFmo.ttf',
      'IBMPlexSans-SemiBold',
    );
    return font.getFont();
  }

  /// IBM Plex Sans 600italic
  static Future<Font> iBMPlexSansSemiBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ibmplexsans/v8/zYX7KVElMYYaJe8bpLHnCwDKhdTmyIJscf3vBmpl8A.ttf',
      'IBMPlexSans-SemiBoldItalic',
    );
    return font.getFont();
  }

  /// IBM Plex Sans 700
  static Future<Font> iBMPlexSansBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ibmplexsans/v8/zYX9KVElMYYaJe8bpLHnCwDKjWr7MIZmdd_qFmo.ttf',
      'IBMPlexSans-Bold',
    );
    return font.getFont();
  }

  /// IBM Plex Sans 700italic
  static Future<Font> iBMPlexSansBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ibmplexsans/v8/zYX7KVElMYYaJe8bpLHnCwDKhdTmrINscf3vBmpl8A.ttf',
      'IBMPlexSans-BoldItalic',
    );
    return font.getFont();
  }

  /// IBM Plex Sans Condensed 100
  static Future<Font> iBMPlexSansCondensedThin() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ibmplexsanscondensed/v7/Gg8nN4UfRSqiPg7Jn2ZI12V4DCEwkj1E4LVeHY7KyKvBgYsMDhM.ttf',
      'IBMPlexSansCondensed-Thin',
    );
    return font.getFont();
  }

  /// IBM Plex Sans Condensed 100italic
  static Future<Font> iBMPlexSansCondensedThinItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ibmplexsanscondensed/v7/Gg8hN4UfRSqiPg7Jn2ZI12V4DCEwkj1E4LVeHYas8M_LhakJHhOgBg.ttf',
      'IBMPlexSansCondensed-ThinItalic',
    );
    return font.getFont();
  }

  /// IBM Plex Sans Condensed 200
  static Future<Font> iBMPlexSansCondensedExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ibmplexsanscondensed/v7/Gg8gN4UfRSqiPg7Jn2ZI12V4DCEwkj1E4LVeHY5m6Yvrr4cFFwq5.ttf',
      'IBMPlexSansCondensed-ExtraLight',
    );
    return font.getFont();
  }

  /// IBM Plex Sans Condensed 200italic
  static Future<Font> iBMPlexSansCondensedExtraLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ibmplexsanscondensed/v7/Gg8iN4UfRSqiPg7Jn2ZI12V4DCEwkj1E4LVeHYas8GPqpYMnEhq5H1w.ttf',
      'IBMPlexSansCondensed-ExtraLightItalic',
    );
    return font.getFont();
  }

  /// IBM Plex Sans Condensed 300
  static Future<Font> iBMPlexSansCondensedLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ibmplexsanscondensed/v7/Gg8gN4UfRSqiPg7Jn2ZI12V4DCEwkj1E4LVeHY4C6ovrr4cFFwq5.ttf',
      'IBMPlexSansCondensed-Light',
    );
    return font.getFont();
  }

  /// IBM Plex Sans Condensed 300italic
  static Future<Font> iBMPlexSansCondensedLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ibmplexsanscondensed/v7/Gg8iN4UfRSqiPg7Jn2ZI12V4DCEwkj1E4LVeHYas8AfppYMnEhq5H1w.ttf',
      'IBMPlexSansCondensed-LightItalic',
    );
    return font.getFont();
  }

  /// IBM Plex Sans Condensed regular
  static Future<Font> iBMPlexSansCondensedRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ibmplexsanscondensed/v7/Gg8lN4UfRSqiPg7Jn2ZI12V4DCEwkj1E4LVeHbauwq_jhJsM.ttf',
      'IBMPlexSansCondensed-Regular',
    );
    return font.getFont();
  }

  /// IBM Plex Sans Condensed italic
  static Future<Font> iBMPlexSansCondensedItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ibmplexsanscondensed/v7/Gg8nN4UfRSqiPg7Jn2ZI12V4DCEwkj1E4LVeHYasyKvBgYsMDhM.ttf',
      'IBMPlexSansCondensed-Italic',
    );
    return font.getFont();
  }

  /// IBM Plex Sans Condensed 500
  static Future<Font> iBMPlexSansCondensedMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ibmplexsanscondensed/v7/Gg8gN4UfRSqiPg7Jn2ZI12V4DCEwkj1E4LVeHY5a64vrr4cFFwq5.ttf',
      'IBMPlexSansCondensed-Medium',
    );
    return font.getFont();
  }

  /// IBM Plex Sans Condensed 500italic
  static Future<Font> iBMPlexSansCondensedMediumItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ibmplexsanscondensed/v7/Gg8iN4UfRSqiPg7Jn2ZI12V4DCEwkj1E4LVeHYas8F_opYMnEhq5H1w.ttf',
      'IBMPlexSansCondensed-MediumItalic',
    );
    return font.getFont();
  }

  /// IBM Plex Sans Condensed 600
  static Future<Font> iBMPlexSansCondensedSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ibmplexsanscondensed/v7/Gg8gN4UfRSqiPg7Jn2ZI12V4DCEwkj1E4LVeHY527Ivrr4cFFwq5.ttf',
      'IBMPlexSansCondensed-SemiBold',
    );
    return font.getFont();
  }

  /// IBM Plex Sans Condensed 600italic
  static Future<Font> iBMPlexSansCondensedSemiBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ibmplexsanscondensed/v7/Gg8iN4UfRSqiPg7Jn2ZI12V4DCEwkj1E4LVeHYas8HPvpYMnEhq5H1w.ttf',
      'IBMPlexSansCondensed-SemiBoldItalic',
    );
    return font.getFont();
  }

  /// IBM Plex Sans Condensed 700
  static Future<Font> iBMPlexSansCondensedBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ibmplexsanscondensed/v7/Gg8gN4UfRSqiPg7Jn2ZI12V4DCEwkj1E4LVeHY4S7Yvrr4cFFwq5.ttf',
      'IBMPlexSansCondensed-Bold',
    );
    return font.getFont();
  }

  /// IBM Plex Sans Condensed 700italic
  static Future<Font> iBMPlexSansCondensedBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ibmplexsanscondensed/v7/Gg8iN4UfRSqiPg7Jn2ZI12V4DCEwkj1E4LVeHYas8BfupYMnEhq5H1w.ttf',
      'IBMPlexSansCondensed-BoldItalic',
    );
    return font.getFont();
  }

  /// IBM Plex Serif 100
  static Future<Font> iBMPlexSerifThin() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ibmplexserif/v9/jizBREVNn1dOx-zrZ2X3pZvkTi182zIZj1bIkNo.ttf',
      'IBMPlexSerif-Thin',
    );
    return font.getFont();
  }

  /// IBM Plex Serif 100italic
  static Future<Font> iBMPlexSerifThinItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ibmplexserif/v9/jizHREVNn1dOx-zrZ2X3pZvkTiUa41YTi3TNgNq55w.ttf',
      'IBMPlexSerif-ThinItalic',
    );
    return font.getFont();
  }

  /// IBM Plex Serif 200
  static Future<Font> iBMPlexSerifExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ibmplexserif/v9/jizAREVNn1dOx-zrZ2X3pZvkTi3Q-hIzoVrBicOg.ttf',
      'IBMPlexSerif-ExtraLight',
    );
    return font.getFont();
  }

  /// IBM Plex Serif 200italic
  static Future<Font> iBMPlexSerifExtraLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ibmplexserif/v9/jizGREVNn1dOx-zrZ2X3pZvkTiUa4_oyq17jjNOg_oc.ttf',
      'IBMPlexSerif-ExtraLightItalic',
    );
    return font.getFont();
  }

  /// IBM Plex Serif 300
  static Future<Font> iBMPlexSerifLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ibmplexserif/v9/jizAREVNn1dOx-zrZ2X3pZvkTi20-RIzoVrBicOg.ttf',
      'IBMPlexSerif-Light',
    );
    return font.getFont();
  }

  /// IBM Plex Serif 300italic
  static Future<Font> iBMPlexSerifLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ibmplexserif/v9/jizGREVNn1dOx-zrZ2X3pZvkTiUa454xq17jjNOg_oc.ttf',
      'IBMPlexSerif-LightItalic',
    );
    return font.getFont();
  }

  /// IBM Plex Serif regular
  static Future<Font> iBMPlexSerifRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ibmplexserif/v9/jizDREVNn1dOx-zrZ2X3pZvkThUY0TY7ikbI.ttf',
      'IBMPlexSerif-Regular',
    );
    return font.getFont();
  }

  /// IBM Plex Serif italic
  static Future<Font> iBMPlexSerifItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ibmplexserif/v9/jizBREVNn1dOx-zrZ2X3pZvkTiUa2zIZj1bIkNo.ttf',
      'IBMPlexSerif-Italic',
    );
    return font.getFont();
  }

  /// IBM Plex Serif 500
  static Future<Font> iBMPlexSerifMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ibmplexserif/v9/jizAREVNn1dOx-zrZ2X3pZvkTi3s-BIzoVrBicOg.ttf',
      'IBMPlexSerif-Medium',
    );
    return font.getFont();
  }

  /// IBM Plex Serif 500italic
  static Future<Font> iBMPlexSerifMediumItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ibmplexserif/v9/jizGREVNn1dOx-zrZ2X3pZvkTiUa48Ywq17jjNOg_oc.ttf',
      'IBMPlexSerif-MediumItalic',
    );
    return font.getFont();
  }

  /// IBM Plex Serif 600
  static Future<Font> iBMPlexSerifSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ibmplexserif/v9/jizAREVNn1dOx-zrZ2X3pZvkTi3A_xIzoVrBicOg.ttf',
      'IBMPlexSerif-SemiBold',
    );
    return font.getFont();
  }

  /// IBM Plex Serif 600italic
  static Future<Font> iBMPlexSerifSemiBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ibmplexserif/v9/jizGREVNn1dOx-zrZ2X3pZvkTiUa4-o3q17jjNOg_oc.ttf',
      'IBMPlexSerif-SemiBoldItalic',
    );
    return font.getFont();
  }

  /// IBM Plex Serif 700
  static Future<Font> iBMPlexSerifBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ibmplexserif/v9/jizAREVNn1dOx-zrZ2X3pZvkTi2k_hIzoVrBicOg.ttf',
      'IBMPlexSerif-Bold',
    );
    return font.getFont();
  }

  /// IBM Plex Serif 700italic
  static Future<Font> iBMPlexSerifBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ibmplexserif/v9/jizGREVNn1dOx-zrZ2X3pZvkTiUa4442q17jjNOg_oc.ttf',
      'IBMPlexSerif-BoldItalic',
    );
    return font.getFont();
  }

  /// IM Fell DW Pica regular
  static Future<Font> iMFellDWPicaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/imfelldwpica/v12/2sDGZGRQotv9nbn2qSl0TxXVYNw9ZAPUvi88MQ.ttf',
      'IMFellDWPica-Regular',
    );
    return font.getFont();
  }

  /// IM Fell DW Pica italic
  static Future<Font> iMFellDWPicaItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/imfelldwpica/v12/2sDEZGRQotv9nbn2qSl0TxXVYNwNZgnQnCosMXm0.ttf',
      'IMFellDWPica-Italic',
    );
    return font.getFont();
  }

  /// IM Fell DW Pica SC regular
  static Future<Font> iMFellDWPicaSCRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/imfelldwpicasc/v12/0ybjGCAu5PfqkvtGVU15aBhXz3EUrnTW-BiKEUiBGA.ttf',
      'IMFellDWPicaSC-Regular',
    );
    return font.getFont();
  }

  /// IM Fell Double Pica regular
  static Future<Font> iMFellDoublePicaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/imfelldoublepica/v10/3XF2EqMq_94s9PeKF7Fg4gOKINyMtZ8rT0S1UL5Ayp0.ttf',
      'IMFellDoublePica-Regular',
    );
    return font.getFont();
  }

  /// IM Fell Double Pica italic
  static Future<Font> iMFellDoublePicaItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/imfelldoublepica/v10/3XF0EqMq_94s9PeKF7Fg4gOKINyMtZ8rf0a_VJxF2p2G8g.ttf',
      'IMFellDoublePica-Italic',
    );
    return font.getFont();
  }

  /// IM Fell Double Pica SC regular
  static Future<Font> iMFellDoublePicaSCRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/imfelldoublepicasc/v12/neIazDmuiMkFo6zj_sHpQ8teNbWlwBB_hXjJ4Y0Eeru2dGg.ttf',
      'IMFellDoublePicaSC-Regular',
    );
    return font.getFont();
  }

  /// IM Fell English regular
  static Future<Font> iMFellEnglishRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/imfellenglish/v10/Ktk1ALSLW8zDe0rthJysWrnLsAz3F6mZVY9Y5w.ttf',
      'IMFellEnglish-Regular',
    );
    return font.getFont();
  }

  /// IM Fell English italic
  static Future<Font> iMFellEnglishItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/imfellenglish/v10/Ktk3ALSLW8zDe0rthJysWrnLsAzHFaOdd4pI59zg.ttf',
      'IMFellEnglish-Italic',
    );
    return font.getFont();
  }

  /// IM Fell English SC regular
  static Future<Font> iMFellEnglishSCRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/imfellenglishsc/v12/a8IENpD3CDX-4zrWfr1VY879qFF05pZLO4gOg0shzA.ttf',
      'IMFellEnglishSC-Regular',
    );
    return font.getFont();
  }

  /// IM Fell French Canon regular
  static Future<Font> iMFellFrenchCanonRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/imfellfrenchcanon/v12/-F6ufiNtDWYfYc-tDiyiw08rrghJszkK6coVPt1ozoPz.ttf',
      'IMFellFrenchCanon-Regular',
    );
    return font.getFont();
  }

  /// IM Fell French Canon italic
  static Future<Font> iMFellFrenchCanonItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/imfellfrenchcanon/v12/-F6gfiNtDWYfYc-tDiyiw08rrghJszkK6foXNNlKy5PzzrU.ttf',
      'IMFellFrenchCanon-Italic',
    );
    return font.getFont();
  }

  /// IM Fell French Canon SC regular
  static Future<Font> iMFellFrenchCanonSCRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/imfellfrenchcanonsc/v12/FBVmdCru5-ifcor2bgq9V89khWcmQghEURY7H3c0UBCVIVqH.ttf',
      'IMFellFrenchCanonSC-Regular',
    );
    return font.getFont();
  }

  /// IM Fell Great Primer regular
  static Future<Font> iMFellGreatPrimerRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/imfellgreatprimer/v12/bx6aNwSJtayYxOkbYFsT6hMsLzX7u85rJorXvDo3SQY1.ttf',
      'IMFellGreatPrimer-Regular',
    );
    return font.getFont();
  }

  /// IM Fell Great Primer italic
  static Future<Font> iMFellGreatPrimerItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/imfellgreatprimer/v12/bx6UNwSJtayYxOkbYFsT6hMsLzX7u85rJrrVtj4VTBY1N6U.ttf',
      'IMFellGreatPrimer-Italic',
    );
    return font.getFont();
  }

  /// IM Fell Great Primer SC regular
  static Future<Font> iMFellGreatPrimerSCRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/imfellgreatprimersc/v12/ga6daxBOxyt6sCqz3fjZCTFCTUDMHagsQKdDTLf9BXz0s8FG.ttf',
      'IMFellGreatPrimerSC-Regular',
    );
    return font.getFont();
  }

  /// Ibarra Real Nova regular
  static Future<Font> ibarraRealNovaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ibarrarealnova/v8/sZlSdQiA-DBIDCcaWtQzL4BZHoiDundw4ATyjed3EXdg5MDtVT9TWIvS.ttf',
      'IbarraRealNova-Regular',
    );
    return font.getFont();
  }

  /// Ibarra Real Nova 500
  static Future<Font> ibarraRealNovaMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ibarrarealnova/v8/sZlSdQiA-DBIDCcaWtQzL4BZHoiDundw4ATyjed3EXdS5MDtVT9TWIvS.ttf',
      'IbarraRealNova-Medium',
    );
    return font.getFont();
  }

  /// Ibarra Real Nova 600
  static Future<Font> ibarraRealNovaSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ibarrarealnova/v8/sZlSdQiA-DBIDCcaWtQzL4BZHoiDundw4ATyjed3EXe-48DtVT9TWIvS.ttf',
      'IbarraRealNova-SemiBold',
    );
    return font.getFont();
  }

  /// Ibarra Real Nova 700
  static Future<Font> ibarraRealNovaBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ibarrarealnova/v8/sZlSdQiA-DBIDCcaWtQzL4BZHoiDundw4ATyjed3EXeH48DtVT9TWIvS.ttf',
      'IbarraRealNova-Bold',
    );
    return font.getFont();
  }

  /// Ibarra Real Nova italic
  static Future<Font> ibarraRealNovaItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ibarrarealnova/v8/sZlsdQiA-DBIDCcaWtQzL4BZHoiDkH5CH9yb5n3ZFmKopyiuXztxXZvSkTo.ttf',
      'IbarraRealNova-Italic',
    );
    return font.getFont();
  }

  /// Ibarra Real Nova 500italic
  static Future<Font> ibarraRealNovaMediumItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ibarrarealnova/v8/sZlsdQiA-DBIDCcaWtQzL4BZHoiDkH5CH9yb5n3ZFmKopxquXztxXZvSkTo.ttf',
      'IbarraRealNova-MediumItalic',
    );
    return font.getFont();
  }

  /// Ibarra Real Nova 600italic
  static Future<Font> ibarraRealNovaSemiBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ibarrarealnova/v8/sZlsdQiA-DBIDCcaWtQzL4BZHoiDkH5CH9yb5n3ZFmKop_apXztxXZvSkTo.ttf',
      'IbarraRealNova-SemiBoldItalic',
    );
    return font.getFont();
  }

  /// Ibarra Real Nova 700italic
  static Future<Font> ibarraRealNovaBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ibarrarealnova/v8/sZlsdQiA-DBIDCcaWtQzL4BZHoiDkH5CH9yb5n3ZFmKop8-pXztxXZvSkTo.ttf',
      'IbarraRealNova-BoldItalic',
    );
    return font.getFont();
  }

  /// Iceberg regular
  static Future<Font> icebergRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/iceberg/v10/8QIJdijAiM7o-qnZuIgOq7jkAOw.ttf',
      'Iceberg-Regular',
    );
    return font.getFont();
  }

  /// Iceland regular
  static Future<Font> icelandRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/iceland/v11/rax9HiuFsdMNOnWPWKxGADBbg0s.ttf',
      'Iceland-Regular',
    );
    return font.getFont();
  }

  /// Imbue 100
  static Future<Font> imbueThin() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/imbue/v9/RLpXK5P16Ki3fXhj5cvGrqjocPk4n-gVX3M93TnrnvhoP8iWfOsNNK-Q4xY.ttf',
      'Imbue-Thin',
    );
    return font.getFont();
  }

  /// Imbue 200
  static Future<Font> imbueExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/imbue/v9/RLpXK5P16Ki3fXhj5cvGrqjocPk4n-gVX3M93TnrnvhoP0iXfOsNNK-Q4xY.ttf',
      'Imbue-ExtraLight',
    );
    return font.getFont();
  }

  /// Imbue 300
  static Future<Font> imbueLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/imbue/v9/RLpXK5P16Ki3fXhj5cvGrqjocPk4n-gVX3M93TnrnvhoP5aXfOsNNK-Q4xY.ttf',
      'Imbue-Light',
    );
    return font.getFont();
  }

  /// Imbue regular
  static Future<Font> imbueRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/imbue/v9/RLpXK5P16Ki3fXhj5cvGrqjocPk4n-gVX3M93TnrnvhoP8iXfOsNNK-Q4xY.ttf',
      'Imbue-Regular',
    );
    return font.getFont();
  }

  /// Imbue 500
  static Future<Font> imbueMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/imbue/v9/RLpXK5P16Ki3fXhj5cvGrqjocPk4n-gVX3M93TnrnvhoP_qXfOsNNK-Q4xY.ttf',
      'Imbue-Medium',
    );
    return font.getFont();
  }

  /// Imbue 600
  static Future<Font> imbueSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/imbue/v9/RLpXK5P16Ki3fXhj5cvGrqjocPk4n-gVX3M93TnrnvhoPxaQfOsNNK-Q4xY.ttf',
      'Imbue-SemiBold',
    );
    return font.getFont();
  }

  /// Imbue 700
  static Future<Font> imbueBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/imbue/v9/RLpXK5P16Ki3fXhj5cvGrqjocPk4n-gVX3M93TnrnvhoPy-QfOsNNK-Q4xY.ttf',
      'Imbue-Bold',
    );
    return font.getFont();
  }

  /// Imbue 800
  static Future<Font> imbueExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/imbue/v9/RLpXK5P16Ki3fXhj5cvGrqjocPk4n-gVX3M93TnrnvhoP0iQfOsNNK-Q4xY.ttf',
      'Imbue-ExtraBold',
    );
    return font.getFont();
  }

  /// Imbue 900
  static Future<Font> imbueBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/imbue/v9/RLpXK5P16Ki3fXhj5cvGrqjocPk4n-gVX3M93TnrnvhoP2GQfOsNNK-Q4xY.ttf',
      'Imbue-Black',
    );
    return font.getFont();
  }

  /// Imprima regular
  static Future<Font> imprimaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/imprima/v11/VEMxRoN7sY3yuy-7-oWHyDzktPo.ttf',
      'Imprima-Regular',
    );
    return font.getFont();
  }

  /// Inconsolata 200
  static Future<Font> inconsolataExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/inconsolata/v21/QldgNThLqRwH-OJ1UHjlKENVzkWGVkL3GZQmAwLYxYWI2qfdm7LppwU8aRr8lleY2co.ttf',
      'Inconsolata-ExtraLight',
    );
    return font.getFont();
  }

  /// Inconsolata 300
  static Future<Font> inconsolataLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/inconsolata/v21/QldgNThLqRwH-OJ1UHjlKENVzkWGVkL3GZQmAwLYxYWI2qfdm7Lpp9s8aRr8lleY2co.ttf',
      'Inconsolata-Light',
    );
    return font.getFont();
  }

  /// Inconsolata regular
  static Future<Font> inconsolataRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/inconsolata/v21/QldgNThLqRwH-OJ1UHjlKENVzkWGVkL3GZQmAwLYxYWI2qfdm7Lpp4U8aRr8lleY2co.ttf',
      'Inconsolata-Regular',
    );
    return font.getFont();
  }

  /// Inconsolata 500
  static Future<Font> inconsolataMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/inconsolata/v21/QldgNThLqRwH-OJ1UHjlKENVzkWGVkL3GZQmAwLYxYWI2qfdm7Lpp7c8aRr8lleY2co.ttf',
      'Inconsolata-Medium',
    );
    return font.getFont();
  }

  /// Inconsolata 600
  static Future<Font> inconsolataSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/inconsolata/v21/QldgNThLqRwH-OJ1UHjlKENVzkWGVkL3GZQmAwLYxYWI2qfdm7Lpp1s7aRr8lleY2co.ttf',
      'Inconsolata-SemiBold',
    );
    return font.getFont();
  }

  /// Inconsolata 700
  static Future<Font> inconsolataBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/inconsolata/v21/QldgNThLqRwH-OJ1UHjlKENVzkWGVkL3GZQmAwLYxYWI2qfdm7Lpp2I7aRr8lleY2co.ttf',
      'Inconsolata-Bold',
    );
    return font.getFont();
  }

  /// Inconsolata 800
  static Future<Font> inconsolataExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/inconsolata/v21/QldgNThLqRwH-OJ1UHjlKENVzkWGVkL3GZQmAwLYxYWI2qfdm7LppwU7aRr8lleY2co.ttf',
      'Inconsolata-ExtraBold',
    );
    return font.getFont();
  }

  /// Inconsolata 900
  static Future<Font> inconsolataBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/inconsolata/v21/QldgNThLqRwH-OJ1UHjlKENVzkWGVkL3GZQmAwLYxYWI2qfdm7Lppyw7aRr8lleY2co.ttf',
      'Inconsolata-Black',
    );
    return font.getFont();
  }

  /// Inder regular
  static Future<Font> inderRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/inder/v9/w8gUH2YoQe8_4vq6pw-P3U4O.ttf',
      'Inder-Regular',
    );
    return font.getFont();
  }

  /// Indie Flower regular
  static Future<Font> indieFlowerRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/indieflower/v12/m8JVjfNVeKWVnh3QMuKkFcZlbkGG1dKEDw.ttf',
      'IndieFlower-Regular',
    );
    return font.getFont();
  }

  /// Inika regular
  static Future<Font> inikaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/inika/v11/rnCm-x5X3QP-phTHRcc2s2XH.ttf',
      'Inika-Regular',
    );
    return font.getFont();
  }

  /// Inika 700
  static Future<Font> inikaBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/inika/v11/rnCr-x5X3QP-pix7auM-mHnOSOuk.ttf',
      'Inika-Bold',
    );
    return font.getFont();
  }

  /// Inknut Antiqua 300
  static Future<Font> inknutAntiquaLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/inknutantiqua/v9/Y4GRYax7VC4ot_qNB4nYpBdaKU2vwrj5bBoIYJNf.ttf',
      'InknutAntiqua-Light',
    );
    return font.getFont();
  }

  /// Inknut Antiqua regular
  static Future<Font> inknutAntiquaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/inknutantiqua/v9/Y4GSYax7VC4ot_qNB4nYpBdaKXUD6pzxRwYB.ttf',
      'InknutAntiqua-Regular',
    );
    return font.getFont();
  }

  /// Inknut Antiqua 500
  static Future<Font> inknutAntiquaMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/inknutantiqua/v9/Y4GRYax7VC4ot_qNB4nYpBdaKU33w7j5bBoIYJNf.ttf',
      'InknutAntiqua-Medium',
    );
    return font.getFont();
  }

  /// Inknut Antiqua 600
  static Future<Font> inknutAntiquaSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/inknutantiqua/v9/Y4GRYax7VC4ot_qNB4nYpBdaKU3bxLj5bBoIYJNf.ttf',
      'InknutAntiqua-SemiBold',
    );
    return font.getFont();
  }

  /// Inknut Antiqua 700
  static Future<Font> inknutAntiquaBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/inknutantiqua/v9/Y4GRYax7VC4ot_qNB4nYpBdaKU2_xbj5bBoIYJNf.ttf',
      'InknutAntiqua-Bold',
    );
    return font.getFont();
  }

  /// Inknut Antiqua 800
  static Future<Font> inknutAntiquaExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/inknutantiqua/v9/Y4GRYax7VC4ot_qNB4nYpBdaKU2jxrj5bBoIYJNf.ttf',
      'InknutAntiqua-ExtraBold',
    );
    return font.getFont();
  }

  /// Inknut Antiqua 900
  static Future<Font> inknutAntiquaBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/inknutantiqua/v9/Y4GRYax7VC4ot_qNB4nYpBdaKU2Hx7j5bBoIYJNf.ttf',
      'InknutAntiqua-Black',
    );
    return font.getFont();
  }

  /// Inria Sans 300
  static Future<Font> inriaSansLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/inriasans/v4/ptRPTiqXYfZMCOiVj9kQ3ELaDQtFqeY3fX4.ttf',
      'InriaSans-Light',
    );
    return font.getFont();
  }

  /// Inria Sans 300italic
  static Future<Font> inriaSansLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/inriasans/v4/ptRRTiqXYfZMCOiVj9kQ1OzAgQlPrcQybX4pQA.ttf',
      'InriaSans-LightItalic',
    );
    return font.getFont();
  }

  /// Inria Sans regular
  static Future<Font> inriaSansRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/inriasans/v4/ptRMTiqXYfZMCOiVj9kQ5O7yKQNute8.ttf',
      'InriaSans-Regular',
    );
    return font.getFont();
  }

  /// Inria Sans italic
  static Future<Font> inriaSansItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/inriasans/v4/ptROTiqXYfZMCOiVj9kQ1Oz4LSFrpe8uZA.ttf',
      'InriaSans-Italic',
    );
    return font.getFont();
  }

  /// Inria Sans 700
  static Future<Font> inriaSansBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/inriasans/v4/ptRPTiqXYfZMCOiVj9kQ3FLdDQtFqeY3fX4.ttf',
      'InriaSans-Bold',
    );
    return font.getFont();
  }

  /// Inria Sans 700italic
  static Future<Font> inriaSansBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/inriasans/v4/ptRRTiqXYfZMCOiVj9kQ1OzAkQ5PrcQybX4pQA.ttf',
      'InriaSans-BoldItalic',
    );
    return font.getFont();
  }

  /// Inria Serif 300
  static Future<Font> inriaSerifLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/inriaserif/v4/fC14PYxPY3rXxEndZJAzN3wAVQjFhFyta3xN.ttf',
      'InriaSerif-Light',
    );
    return font.getFont();
  }

  /// Inria Serif 300italic
  static Future<Font> inriaSerifLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/inriaserif/v4/fC16PYxPY3rXxEndZJAzN3SuT4THjliPbmxN0_E.ttf',
      'InriaSerif-LightItalic',
    );
    return font.getFont();
  }

  /// Inria Serif regular
  static Future<Font> inriaSerifRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/inriaserif/v4/fC1lPYxPY3rXxEndZJAzN0SsfSzNr0Ck.ttf',
      'InriaSerif-Regular',
    );
    return font.getFont();
  }

  /// Inria Serif italic
  static Future<Font> inriaSerifItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/inriaserif/v4/fC1nPYxPY3rXxEndZJAzN3SudyjvqlCkcmU.ttf',
      'InriaSerif-Italic',
    );
    return font.getFont();
  }

  /// Inria Serif 700
  static Future<Font> inriaSerifBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/inriaserif/v4/fC14PYxPY3rXxEndZJAzN3wQUgjFhFyta3xN.ttf',
      'InriaSerif-Bold',
    );
    return font.getFont();
  }

  /// Inria Serif 700italic
  static Future<Font> inriaSerifBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/inriaserif/v4/fC16PYxPY3rXxEndZJAzN3SuT5TAjliPbmxN0_E.ttf',
      'InriaSerif-BoldItalic',
    );
    return font.getFont();
  }

  /// Inter 100
  static Future<Font> interThin() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/inter/v3/UcCO3FwrK3iLTeHuS_fvQtMwCp50KnMw2boKoduKmMEVuLyeMZhrib2Bg-4.ttf',
      'Inter-Thin',
    );
    return font.getFont();
  }

  /// Inter 200
  static Future<Font> interExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/inter/v3/UcCO3FwrK3iLTeHuS_fvQtMwCp50KnMw2boKoduKmMEVuDyfMZhrib2Bg-4.ttf',
      'Inter-ExtraLight',
    );
    return font.getFont();
  }

  /// Inter 300
  static Future<Font> interLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/inter/v3/UcCO3FwrK3iLTeHuS_fvQtMwCp50KnMw2boKoduKmMEVuOKfMZhrib2Bg-4.ttf',
      'Inter-Light',
    );
    return font.getFont();
  }

  /// Inter regular
  static Future<Font> interRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/inter/v3/UcCO3FwrK3iLTeHuS_fvQtMwCp50KnMw2boKoduKmMEVuLyfMZhrib2Bg-4.ttf',
      'Inter-Regular',
    );
    return font.getFont();
  }

  /// Inter 500
  static Future<Font> interMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/inter/v3/UcCO3FwrK3iLTeHuS_fvQtMwCp50KnMw2boKoduKmMEVuI6fMZhrib2Bg-4.ttf',
      'Inter-Medium',
    );
    return font.getFont();
  }

  /// Inter 600
  static Future<Font> interSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/inter/v3/UcCO3FwrK3iLTeHuS_fvQtMwCp50KnMw2boKoduKmMEVuGKYMZhrib2Bg-4.ttf',
      'Inter-SemiBold',
    );
    return font.getFont();
  }

  /// Inter 700
  static Future<Font> interBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/inter/v3/UcCO3FwrK3iLTeHuS_fvQtMwCp50KnMw2boKoduKmMEVuFuYMZhrib2Bg-4.ttf',
      'Inter-Bold',
    );
    return font.getFont();
  }

  /// Inter 800
  static Future<Font> interExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/inter/v3/UcCO3FwrK3iLTeHuS_fvQtMwCp50KnMw2boKoduKmMEVuDyYMZhrib2Bg-4.ttf',
      'Inter-ExtraBold',
    );
    return font.getFont();
  }

  /// Inter 900
  static Future<Font> interBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/inter/v3/UcCO3FwrK3iLTeHuS_fvQtMwCp50KnMw2boKoduKmMEVuBWYMZhrib2Bg-4.ttf',
      'Inter-Black',
    );
    return font.getFont();
  }

  /// Irish Grover regular
  static Future<Font> irishGroverRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/irishgrover/v12/buExpoi6YtLz2QW7LA4flVgf-P5Oaiw4cw.ttf',
      'IrishGrover-Regular',
    );
    return font.getFont();
  }

  /// Istok Web regular
  static Future<Font> istokWebRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/istokweb/v15/3qTvojGmgSyUukBzKslZAWF-9kIIaQ.ttf',
      'IstokWeb-Regular',
    );
    return font.getFont();
  }

  /// Istok Web italic
  static Future<Font> istokWebItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/istokweb/v15/3qTpojGmgSyUukBzKslpA2t61EcYaQ7F.ttf',
      'IstokWeb-Italic',
    );
    return font.getFont();
  }

  /// Istok Web 700
  static Future<Font> istokWebBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/istokweb/v15/3qTqojGmgSyUukBzKslhvU5a_mkUYBfcMw.ttf',
      'IstokWeb-Bold',
    );
    return font.getFont();
  }

  /// Istok Web 700italic
  static Future<Font> istokWebBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/istokweb/v15/3qT0ojGmgSyUukBzKslpA1PG-2MQQhLMMygN.ttf',
      'IstokWeb-BoldItalic',
    );
    return font.getFont();
  }

  /// Italiana regular
  static Future<Font> italianaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/italiana/v11/QldNNTtLsx4E__B0XTmRY31Wx7Vv.ttf',
      'Italiana-Regular',
    );
    return font.getFont();
  }

  /// Italianno regular
  static Future<Font> italiannoRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/italianno/v10/dg4n_p3sv6gCJkwzT6Rnj5YpQwM-gg.ttf',
      'Italianno-Regular',
    );
    return font.getFont();
  }

  /// Itim regular
  static Future<Font> itimRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/itim/v5/0nknC9ziJOYewARKkc7ZdwU.ttf',
      'Itim-Regular',
    );
    return font.getFont();
  }

  /// Jacques Francois regular
  static Future<Font> jacquesFrancoisRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/jacquesfrancois/v10/ZXu9e04ZvKeOOHIe1TMahbcIU2cgmcPqoeRWfbs.ttf',
      'JacquesFrancois-Regular',
    );
    return font.getFont();
  }

  /// Jacques Francois Shadow regular
  static Future<Font> jacquesFrancoisShadowRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/jacquesfrancoisshadow/v11/KR1FBtOz8PKTMk-kqdkLVrvR0ECFrB6Pin-2_q8VsHuV5ULS.ttf',
      'JacquesFrancoisShadow-Regular',
    );
    return font.getFont();
  }

  /// Jaldi regular
  static Future<Font> jaldiRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/jaldi/v7/or3sQ67z0_CI30NUZpD_B6g8.ttf',
      'Jaldi-Regular',
    );
    return font.getFont();
  }

  /// Jaldi 700
  static Future<Font> jaldiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/jaldi/v7/or3hQ67z0_CI33voSbT3LLQ1niPn.ttf',
      'Jaldi-Bold',
    );
    return font.getFont();
  }

  /// JetBrains Mono 100
  static Future<Font> jetBrainsMonoThin() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/jetbrainsmono/v6/tDbY2o-flEEny0FZhsfKu5WU4zr3E_BX0PnT8RD8yK1jPVmUsaaDhw.ttf',
      'JetBrainsMono-Thin',
    );
    return font.getFont();
  }

  /// JetBrains Mono 200
  static Future<Font> jetBrainsMonoExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/jetbrainsmono/v6/tDbY2o-flEEny0FZhsfKu5WU4zr3E_BX0PnT8RD8SKxjPVmUsaaDhw.ttf',
      'JetBrainsMono-ExtraLight',
    );
    return font.getFont();
  }

  /// JetBrains Mono 300
  static Future<Font> jetBrainsMonoLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/jetbrainsmono/v6/tDbY2o-flEEny0FZhsfKu5WU4zr3E_BX0PnT8RD8lqxjPVmUsaaDhw.ttf',
      'JetBrainsMono-Light',
    );
    return font.getFont();
  }

  /// JetBrains Mono regular
  static Future<Font> jetBrainsMonoRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/jetbrainsmono/v6/tDbY2o-flEEny0FZhsfKu5WU4zr3E_BX0PnT8RD8yKxjPVmUsaaDhw.ttf',
      'JetBrainsMono-Regular',
    );
    return font.getFont();
  }

  /// JetBrains Mono 500
  static Future<Font> jetBrainsMonoMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/jetbrainsmono/v6/tDbY2o-flEEny0FZhsfKu5WU4zr3E_BX0PnT8RD8-qxjPVmUsaaDhw.ttf',
      'JetBrainsMono-Medium',
    );
    return font.getFont();
  }

  /// JetBrains Mono 600
  static Future<Font> jetBrainsMonoSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/jetbrainsmono/v6/tDbY2o-flEEny0FZhsfKu5WU4zr3E_BX0PnT8RD8FqtjPVmUsaaDhw.ttf',
      'JetBrainsMono-SemiBold',
    );
    return font.getFont();
  }

  /// JetBrains Mono 700
  static Future<Font> jetBrainsMonoBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/jetbrainsmono/v6/tDbY2o-flEEny0FZhsfKu5WU4zr3E_BX0PnT8RD8L6tjPVmUsaaDhw.ttf',
      'JetBrainsMono-Bold',
    );
    return font.getFont();
  }

  /// JetBrains Mono 800
  static Future<Font> jetBrainsMonoExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/jetbrainsmono/v6/tDbY2o-flEEny0FZhsfKu5WU4zr3E_BX0PnT8RD8SKtjPVmUsaaDhw.ttf',
      'JetBrainsMono-ExtraBold',
    );
    return font.getFont();
  }

  /// JetBrains Mono 100italic
  static Future<Font> jetBrainsMonoThinItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/jetbrainsmono/v6/tDba2o-flEEny0FZhsfKu5WU4xD-IQ-PuZJJXxfpAO-Lf1OQk6OThxPA.ttf',
      'JetBrainsMono-ThinItalic',
    );
    return font.getFont();
  }

  /// JetBrains Mono 200italic
  static Future<Font> jetBrainsMonoExtraLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/jetbrainsmono/v6/tDba2o-flEEny0FZhsfKu5WU4xD-IQ-PuZJJXxfpAO8LflOQk6OThxPA.ttf',
      'JetBrainsMono-ExtraLightItalic',
    );
    return font.getFont();
  }

  /// JetBrains Mono 300italic
  static Future<Font> jetBrainsMonoLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/jetbrainsmono/v6/tDba2o-flEEny0FZhsfKu5WU4xD-IQ-PuZJJXxfpAO_VflOQk6OThxPA.ttf',
      'JetBrainsMono-LightItalic',
    );
    return font.getFont();
  }

  /// JetBrains Mono italic
  static Future<Font> jetBrainsMonoItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/jetbrainsmono/v6/tDba2o-flEEny0FZhsfKu5WU4xD-IQ-PuZJJXxfpAO-LflOQk6OThxPA.ttf',
      'JetBrainsMono-Italic',
    );
    return font.getFont();
  }

  /// JetBrains Mono 500italic
  static Future<Font> jetBrainsMonoMediumItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/jetbrainsmono/v6/tDba2o-flEEny0FZhsfKu5WU4xD-IQ-PuZJJXxfpAO-5flOQk6OThxPA.ttf',
      'JetBrainsMono-MediumItalic',
    );
    return font.getFont();
  }

  /// JetBrains Mono 600italic
  static Future<Font> jetBrainsMonoSemiBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/jetbrainsmono/v6/tDba2o-flEEny0FZhsfKu5WU4xD-IQ-PuZJJXxfpAO9VeVOQk6OThxPA.ttf',
      'JetBrainsMono-SemiBoldItalic',
    );
    return font.getFont();
  }

  /// JetBrains Mono 700italic
  static Future<Font> jetBrainsMonoBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/jetbrainsmono/v6/tDba2o-flEEny0FZhsfKu5WU4xD-IQ-PuZJJXxfpAO9seVOQk6OThxPA.ttf',
      'JetBrainsMono-BoldItalic',
    );
    return font.getFont();
  }

  /// JetBrains Mono 800italic
  static Future<Font> jetBrainsMonoExtraBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/jetbrainsmono/v6/tDba2o-flEEny0FZhsfKu5WU4xD-IQ-PuZJJXxfpAO8LeVOQk6OThxPA.ttf',
      'JetBrainsMono-ExtraBoldItalic',
    );
    return font.getFont();
  }

  /// Jim Nightshade regular
  static Future<Font> jimNightshadeRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/jimnightshade/v10/PlIkFlu9Pb08Q8HLM1PxmB0g-OS4V3qKaMxD.ttf',
      'JimNightshade-Regular',
    );
    return font.getFont();
  }

  /// Jockey One regular
  static Future<Font> jockeyOneRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/jockeyone/v10/HTxpL2g2KjCFj4x8WI6ArIb7HYOk4xc.ttf',
      'JockeyOne-Regular',
    );
    return font.getFont();
  }

  /// Jolly Lodger regular
  static Future<Font> jollyLodgerRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/jollylodger/v10/BXRsvFTAh_bGkA1uQ48dlB3VWerT3ZyuqA.ttf',
      'JollyLodger-Regular',
    );
    return font.getFont();
  }

  /// Jomhuria regular
  static Future<Font> jomhuriaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/jomhuria/v12/Dxxp8j-TMXf-llKur2b1MOGbC3Dh.ttf',
      'Jomhuria-Regular',
    );
    return font.getFont();
  }

  /// Jomolhari regular
  static Future<Font> jomolhariRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/jomolhari/v4/EvONzA1M1Iw_CBd2hsQCF1IZKq5INg.ttf',
      'Jomolhari-Regular',
    );
    return font.getFont();
  }

  /// Josefin Sans 100
  static Future<Font> josefinSansThin() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/josefinsans/v17/Qw3PZQNVED7rKGKxtqIqX5E-AVSJrOCfjY46_DjRXMFrLgTsQV0.ttf',
      'JosefinSans-Thin',
    );
    return font.getFont();
  }

  /// Josefin Sans 200
  static Future<Font> josefinSansExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/josefinsans/v17/Qw3PZQNVED7rKGKxtqIqX5E-AVSJrOCfjY46_LjQXMFrLgTsQV0.ttf',
      'JosefinSans-ExtraLight',
    );
    return font.getFont();
  }

  /// Josefin Sans 300
  static Future<Font> josefinSansLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/josefinsans/v17/Qw3PZQNVED7rKGKxtqIqX5E-AVSJrOCfjY46_GbQXMFrLgTsQV0.ttf',
      'JosefinSans-Light',
    );
    return font.getFont();
  }

  /// Josefin Sans regular
  static Future<Font> josefinSansRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/josefinsans/v17/Qw3PZQNVED7rKGKxtqIqX5E-AVSJrOCfjY46_DjQXMFrLgTsQV0.ttf',
      'JosefinSans-Regular',
    );
    return font.getFont();
  }

  /// Josefin Sans 500
  static Future<Font> josefinSansMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/josefinsans/v17/Qw3PZQNVED7rKGKxtqIqX5E-AVSJrOCfjY46_ArQXMFrLgTsQV0.ttf',
      'JosefinSans-Medium',
    );
    return font.getFont();
  }

  /// Josefin Sans 600
  static Future<Font> josefinSansSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/josefinsans/v17/Qw3PZQNVED7rKGKxtqIqX5E-AVSJrOCfjY46_ObXXMFrLgTsQV0.ttf',
      'JosefinSans-SemiBold',
    );
    return font.getFont();
  }

  /// Josefin Sans 700
  static Future<Font> josefinSansBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/josefinsans/v17/Qw3PZQNVED7rKGKxtqIqX5E-AVSJrOCfjY46_N_XXMFrLgTsQV0.ttf',
      'JosefinSans-Bold',
    );
    return font.getFont();
  }

  /// Josefin Sans 100italic
  static Future<Font> josefinSansThinItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/josefinsans/v17/Qw3JZQNVED7rKGKxtqIqX5EUCGZ2dIn0FyA96fCTtINhKibpUV3MEQ.ttf',
      'JosefinSans-ThinItalic',
    );
    return font.getFont();
  }

  /// Josefin Sans 200italic
  static Future<Font> josefinSansExtraLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/josefinsans/v17/Qw3JZQNVED7rKGKxtqIqX5EUCGZ2dIn0FyA96fCTNIJhKibpUV3MEQ.ttf',
      'JosefinSans-ExtraLightItalic',
    );
    return font.getFont();
  }

  /// Josefin Sans 300italic
  static Future<Font> josefinSansLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/josefinsans/v17/Qw3JZQNVED7rKGKxtqIqX5EUCGZ2dIn0FyA96fCT6oJhKibpUV3MEQ.ttf',
      'JosefinSans-LightItalic',
    );
    return font.getFont();
  }

  /// Josefin Sans italic
  static Future<Font> josefinSansItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/josefinsans/v17/Qw3JZQNVED7rKGKxtqIqX5EUCGZ2dIn0FyA96fCTtIJhKibpUV3MEQ.ttf',
      'JosefinSans-Italic',
    );
    return font.getFont();
  }

  /// Josefin Sans 500italic
  static Future<Font> josefinSansMediumItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/josefinsans/v17/Qw3JZQNVED7rKGKxtqIqX5EUCGZ2dIn0FyA96fCThoJhKibpUV3MEQ.ttf',
      'JosefinSans-MediumItalic',
    );
    return font.getFont();
  }

  /// Josefin Sans 600italic
  static Future<Font> josefinSansSemiBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/josefinsans/v17/Qw3JZQNVED7rKGKxtqIqX5EUCGZ2dIn0FyA96fCTaoVhKibpUV3MEQ.ttf',
      'JosefinSans-SemiBoldItalic',
    );
    return font.getFont();
  }

  /// Josefin Sans 700italic
  static Future<Font> josefinSansBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/josefinsans/v17/Qw3JZQNVED7rKGKxtqIqX5EUCGZ2dIn0FyA96fCTU4VhKibpUV3MEQ.ttf',
      'JosefinSans-BoldItalic',
    );
    return font.getFont();
  }

  /// Josefin Slab 100
  static Future<Font> josefinSlabThin() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/josefinslab/v13/lW-swjwOK3Ps5GSJlNNkMalNpiZe_ldbOR4W71mtd3k3K6CcEyI.ttf',
      'JosefinSlab-Thin',
    );
    return font.getFont();
  }

  /// Josefin Slab 200
  static Future<Font> josefinSlabExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/josefinslab/v13/lW-swjwOK3Ps5GSJlNNkMalNpiZe_ldbOR4W79msd3k3K6CcEyI.ttf',
      'JosefinSlab-ExtraLight',
    );
    return font.getFont();
  }

  /// Josefin Slab 300
  static Future<Font> josefinSlabLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/josefinslab/v13/lW-swjwOK3Ps5GSJlNNkMalNpiZe_ldbOR4W7wesd3k3K6CcEyI.ttf',
      'JosefinSlab-Light',
    );
    return font.getFont();
  }

  /// Josefin Slab regular
  static Future<Font> josefinSlabRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/josefinslab/v13/lW-swjwOK3Ps5GSJlNNkMalNpiZe_ldbOR4W71msd3k3K6CcEyI.ttf',
      'JosefinSlab-Regular',
    );
    return font.getFont();
  }

  /// Josefin Slab 500
  static Future<Font> josefinSlabMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/josefinslab/v13/lW-swjwOK3Ps5GSJlNNkMalNpiZe_ldbOR4W72usd3k3K6CcEyI.ttf',
      'JosefinSlab-Medium',
    );
    return font.getFont();
  }

  /// Josefin Slab 600
  static Future<Font> josefinSlabSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/josefinslab/v13/lW-swjwOK3Ps5GSJlNNkMalNpiZe_ldbOR4W74erd3k3K6CcEyI.ttf',
      'JosefinSlab-SemiBold',
    );
    return font.getFont();
  }

  /// Josefin Slab 700
  static Future<Font> josefinSlabBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/josefinslab/v13/lW-swjwOK3Ps5GSJlNNkMalNpiZe_ldbOR4W776rd3k3K6CcEyI.ttf',
      'JosefinSlab-Bold',
    );
    return font.getFont();
  }

  /// Josefin Slab 100italic
  static Future<Font> josefinSlabThinItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/josefinslab/v13/lW-qwjwOK3Ps5GSJlNNkMalnrxShJj4wo7AR-pHvnzs9L4KZAyK43w.ttf',
      'JosefinSlab-ThinItalic',
    );
    return font.getFont();
  }

  /// Josefin Slab 200italic
  static Future<Font> josefinSlabExtraLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/josefinslab/v13/lW-qwjwOK3Ps5GSJlNNkMalnrxShJj4wo7AR-pHvHzo9L4KZAyK43w.ttf',
      'JosefinSlab-ExtraLightItalic',
    );
    return font.getFont();
  }

  /// Josefin Slab 300italic
  static Future<Font> josefinSlabLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/josefinslab/v13/lW-qwjwOK3Ps5GSJlNNkMalnrxShJj4wo7AR-pHvwTo9L4KZAyK43w.ttf',
      'JosefinSlab-LightItalic',
    );
    return font.getFont();
  }

  /// Josefin Slab italic
  static Future<Font> josefinSlabItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/josefinslab/v13/lW-qwjwOK3Ps5GSJlNNkMalnrxShJj4wo7AR-pHvnzo9L4KZAyK43w.ttf',
      'JosefinSlab-Italic',
    );
    return font.getFont();
  }

  /// Josefin Slab 500italic
  static Future<Font> josefinSlabMediumItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/josefinslab/v13/lW-qwjwOK3Ps5GSJlNNkMalnrxShJj4wo7AR-pHvrTo9L4KZAyK43w.ttf',
      'JosefinSlab-MediumItalic',
    );
    return font.getFont();
  }

  /// Josefin Slab 600italic
  static Future<Font> josefinSlabSemiBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/josefinslab/v13/lW-qwjwOK3Ps5GSJlNNkMalnrxShJj4wo7AR-pHvQT09L4KZAyK43w.ttf',
      'JosefinSlab-SemiBoldItalic',
    );
    return font.getFont();
  }

  /// Josefin Slab 700italic
  static Future<Font> josefinSlabBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/josefinslab/v13/lW-qwjwOK3Ps5GSJlNNkMalnrxShJj4wo7AR-pHveD09L4KZAyK43w.ttf',
      'JosefinSlab-BoldItalic',
    );
    return font.getFont();
  }

  /// Jost 100
  static Future<Font> jostThin() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/jost/v6/92zPtBhPNqw79Ij1E865zBUv7myjJAVGPokMmuHL.ttf',
      'Jost-Thin',
    );
    return font.getFont();
  }

  /// Jost 200
  static Future<Font> jostExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/jost/v6/92zPtBhPNqw79Ij1E865zBUv7mwjJQVGPokMmuHL.ttf',
      'Jost-ExtraLight',
    );
    return font.getFont();
  }

  /// Jost 300
  static Future<Font> jostLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/jost/v6/92zPtBhPNqw79Ij1E865zBUv7mz9JQVGPokMmuHL.ttf',
      'Jost-Light',
    );
    return font.getFont();
  }

  /// Jost regular
  static Future<Font> jostRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/jost/v6/92zPtBhPNqw79Ij1E865zBUv7myjJQVGPokMmuHL.ttf',
      'Jost-Regular',
    );
    return font.getFont();
  }

  /// Jost 500
  static Future<Font> jostMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/jost/v6/92zPtBhPNqw79Ij1E865zBUv7myRJQVGPokMmuHL.ttf',
      'Jost-Medium',
    );
    return font.getFont();
  }

  /// Jost 600
  static Future<Font> jostSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/jost/v6/92zPtBhPNqw79Ij1E865zBUv7mx9IgVGPokMmuHL.ttf',
      'Jost-SemiBold',
    );
    return font.getFont();
  }

  /// Jost 700
  static Future<Font> jostBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/jost/v6/92zPtBhPNqw79Ij1E865zBUv7mxEIgVGPokMmuHL.ttf',
      'Jost-Bold',
    );
    return font.getFont();
  }

  /// Jost 800
  static Future<Font> jostExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/jost/v6/92zPtBhPNqw79Ij1E865zBUv7mwjIgVGPokMmuHL.ttf',
      'Jost-ExtraBold',
    );
    return font.getFont();
  }

  /// Jost 900
  static Future<Font> jostBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/jost/v6/92zPtBhPNqw79Ij1E865zBUv7mwKIgVGPokMmuHL.ttf',
      'Jost-Black',
    );
    return font.getFont();
  }

  /// Jost 100italic
  static Future<Font> jostThinItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/jost/v6/92zJtBhPNqw73oHH7BbQp4-B6XlrZu0ENI0un_HLMEo.ttf',
      'Jost-ThinItalic',
    );
    return font.getFont();
  }

  /// Jost 200italic
  static Future<Font> jostExtraLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/jost/v6/92zJtBhPNqw73oHH7BbQp4-B6XlrZm0FNI0un_HLMEo.ttf',
      'Jost-ExtraLightItalic',
    );
    return font.getFont();
  }

  /// Jost 300italic
  static Future<Font> jostLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/jost/v6/92zJtBhPNqw73oHH7BbQp4-B6XlrZrMFNI0un_HLMEo.ttf',
      'Jost-LightItalic',
    );
    return font.getFont();
  }

  /// Jost italic
  static Future<Font> jostItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/jost/v6/92zJtBhPNqw73oHH7BbQp4-B6XlrZu0FNI0un_HLMEo.ttf',
      'Jost-Italic',
    );
    return font.getFont();
  }

  /// Jost 500italic
  static Future<Font> jostMediumItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/jost/v6/92zJtBhPNqw73oHH7BbQp4-B6XlrZt8FNI0un_HLMEo.ttf',
      'Jost-MediumItalic',
    );
    return font.getFont();
  }

  /// Jost 600italic
  static Future<Font> jostSemiBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/jost/v6/92zJtBhPNqw73oHH7BbQp4-B6XlrZjMCNI0un_HLMEo.ttf',
      'Jost-SemiBoldItalic',
    );
    return font.getFont();
  }

  /// Jost 700italic
  static Future<Font> jostBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/jost/v6/92zJtBhPNqw73oHH7BbQp4-B6XlrZgoCNI0un_HLMEo.ttf',
      'Jost-BoldItalic',
    );
    return font.getFont();
  }

  /// Jost 800italic
  static Future<Font> jostExtraBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/jost/v6/92zJtBhPNqw73oHH7BbQp4-B6XlrZm0CNI0un_HLMEo.ttf',
      'Jost-ExtraBoldItalic',
    );
    return font.getFont();
  }

  /// Jost 900italic
  static Future<Font> jostBlackItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/jost/v6/92zJtBhPNqw73oHH7BbQp4-B6XlrZkQCNI0un_HLMEo.ttf',
      'Jost-BlackItalic',
    );
    return font.getFont();
  }

  /// Joti One regular
  static Future<Font> jotiOneRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/jotione/v11/Z9XVDmdJQAmWm9TwaYTe4u2El6GC.ttf',
      'JotiOne-Regular',
    );
    return font.getFont();
  }

  /// Jua regular
  static Future<Font> juaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/jua/v8/co3KmW9ljjAjc-DZCsKgsg.ttf',
      'Jua-Regular',
    );
    return font.getFont();
  }

  /// Judson regular
  static Future<Font> judsonRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/judson/v13/FeVRS0Fbvbc14VxRD7N01bV7kg.ttf',
      'Judson-Regular',
    );
    return font.getFont();
  }

  /// Judson italic
  static Future<Font> judsonItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/judson/v13/FeVTS0Fbvbc14VxhDblw97BrknZf.ttf',
      'Judson-Italic',
    );
    return font.getFont();
  }

  /// Judson 700
  static Future<Font> judsonBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/judson/v13/FeVSS0Fbvbc14Vxps5xQ3Z5nm29Gww.ttf',
      'Judson-Bold',
    );
    return font.getFont();
  }

  /// Julee regular
  static Future<Font> juleeRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/julee/v12/TuGfUVB3RpZPQ6ZLodgzydtk.ttf',
      'Julee-Regular',
    );
    return font.getFont();
  }

  /// Julius Sans One regular
  static Future<Font> juliusSansOneRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/juliussansone/v9/1Pt2g8TAX_SGgBGUi0tGOYEga5W-xXEW6aGXHw.ttf',
      'JuliusSansOne-Regular',
    );
    return font.getFont();
  }

  /// Junge regular
  static Future<Font> jungeRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/junge/v10/gokgH670Gl1lUqAdvhB7SnKm.ttf',
      'Junge-Regular',
    );
    return font.getFont();
  }

  /// Jura 300
  static Future<Font> juraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/jura/v16/z7NOdRfiaC4Vd8hhoPzfb5vBTP0D7auhTfmrH_rt.ttf',
      'Jura-Light',
    );
    return font.getFont();
  }

  /// Jura regular
  static Future<Font> juraRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/jura/v16/z7NOdRfiaC4Vd8hhoPzfb5vBTP1d7auhTfmrH_rt.ttf',
      'Jura-Regular',
    );
    return font.getFont();
  }

  /// Jura 500
  static Future<Font> juraMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/jura/v16/z7NOdRfiaC4Vd8hhoPzfb5vBTP1v7auhTfmrH_rt.ttf',
      'Jura-Medium',
    );
    return font.getFont();
  }

  /// Jura 600
  static Future<Font> juraSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/jura/v16/z7NOdRfiaC4Vd8hhoPzfb5vBTP2D6quhTfmrH_rt.ttf',
      'Jura-SemiBold',
    );
    return font.getFont();
  }

  /// Jura 700
  static Future<Font> juraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/jura/v16/z7NOdRfiaC4Vd8hhoPzfb5vBTP266quhTfmrH_rt.ttf',
      'Jura-Bold',
    );
    return font.getFont();
  }

  /// Just Another Hand regular
  static Future<Font> justAnotherHandRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/justanotherhand/v12/845CNN4-AJyIGvIou-6yJKyptyOpOcr_BmmlS5aw.ttf',
      'JustAnotherHand-Regular',
    );
    return font.getFont();
  }

  /// Just Me Again Down Here regular
  static Future<Font> justMeAgainDownHereRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/justmeagaindownhere/v14/MwQmbgXtz-Wc6RUEGNMc0QpRrfUh2hSdBBMoAuwHvqDwc_fg.ttf',
      'JustMeAgainDownHere-Regular',
    );
    return font.getFont();
  }

  /// K2D 100
  static Future<Font> k2DThin() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/k2d/v4/J7aRnpF2V0ErE6UpvrIw74NL.ttf',
      'K2D-Thin',
    );
    return font.getFont();
  }

  /// K2D 100italic
  static Future<Font> k2DThinItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/k2d/v4/J7afnpF2V0EjdZ1NtLYS6pNLAjk.ttf',
      'K2D-ThinItalic',
    );
    return font.getFont();
  }

  /// K2D 200
  static Future<Font> k2DExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/k2d/v4/J7aenpF2V0Erv4QJlJw85ppSGw.ttf',
      'K2D-ExtraLight',
    );
    return font.getFont();
  }

  /// K2D 200italic
  static Future<Font> k2DExtraLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/k2d/v4/J7acnpF2V0EjdZ3hlZY4xJ9CGyAa.ttf',
      'K2D-ExtraLightItalic',
    );
    return font.getFont();
  }

  /// K2D 300
  static Future<Font> k2DLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/k2d/v4/J7aenpF2V0Er24cJlJw85ppSGw.ttf',
      'K2D-Light',
    );
    return font.getFont();
  }

  /// K2D 300italic
  static Future<Font> k2DLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/k2d/v4/J7acnpF2V0EjdZ2FlpY4xJ9CGyAa.ttf',
      'K2D-LightItalic',
    );
    return font.getFont();
  }

  /// K2D regular
  static Future<Font> k2DRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/k2d/v4/J7aTnpF2V0ETd68tnLcg7w.ttf',
      'K2D-Regular',
    );
    return font.getFont();
  }

  /// K2D italic
  static Future<Font> k2DItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/k2d/v4/J7aRnpF2V0EjdaUpvrIw74NL.ttf',
      'K2D-Italic',
    );
    return font.getFont();
  }

  /// K2D 500
  static Future<Font> k2DMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/k2d/v4/J7aenpF2V0Erg4YJlJw85ppSGw.ttf',
      'K2D-Medium',
    );
    return font.getFont();
  }

  /// K2D 500italic
  static Future<Font> k2DMediumItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/k2d/v4/J7acnpF2V0EjdZ3dl5Y4xJ9CGyAa.ttf',
      'K2D-MediumItalic',
    );
    return font.getFont();
  }

  /// K2D 600
  static Future<Font> k2DSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/k2d/v4/J7aenpF2V0Err4EJlJw85ppSGw.ttf',
      'K2D-SemiBold',
    );
    return font.getFont();
  }

  /// K2D 600italic
  static Future<Font> k2DSemiBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/k2d/v4/J7acnpF2V0EjdZ3xkJY4xJ9CGyAa.ttf',
      'K2D-SemiBoldItalic',
    );
    return font.getFont();
  }

  /// K2D 700
  static Future<Font> k2DBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/k2d/v4/J7aenpF2V0Ery4AJlJw85ppSGw.ttf',
      'K2D-Bold',
    );
    return font.getFont();
  }

  /// K2D 700italic
  static Future<Font> k2DBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/k2d/v4/J7acnpF2V0EjdZ2VkZY4xJ9CGyAa.ttf',
      'K2D-BoldItalic',
    );
    return font.getFont();
  }

  /// K2D 800
  static Future<Font> k2DExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/k2d/v4/J7aenpF2V0Er14MJlJw85ppSGw.ttf',
      'K2D-ExtraBold',
    );
    return font.getFont();
  }

  /// K2D 800italic
  static Future<Font> k2DExtraBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/k2d/v4/J7acnpF2V0EjdZ2JkpY4xJ9CGyAa.ttf',
      'K2D-ExtraBoldItalic',
    );
    return font.getFont();
  }

  /// Kadwa regular
  static Future<Font> kadwaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/kadwa/v5/rnCm-x5V0g7iphTHRcc2s2XH.ttf',
      'Kadwa-Regular',
    );
    return font.getFont();
  }

  /// Kadwa 700
  static Future<Font> kadwaBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/kadwa/v5/rnCr-x5V0g7ipix7auM-mHnOSOuk.ttf',
      'Kadwa-Bold',
    );
    return font.getFont();
  }

  /// Kalam 300
  static Future<Font> kalamLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/kalam/v11/YA9Qr0Wd4kDdMtD6GgLLmCUItqGt.ttf',
      'Kalam-Light',
    );
    return font.getFont();
  }

  /// Kalam regular
  static Future<Font> kalamRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/kalam/v11/YA9dr0Wd4kDdMuhWMibDszkB.ttf',
      'Kalam-Regular',
    );
    return font.getFont();
  }

  /// Kalam 700
  static Future<Font> kalamBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/kalam/v11/YA9Qr0Wd4kDdMtDqHQLLmCUItqGt.ttf',
      'Kalam-Bold',
    );
    return font.getFont();
  }

  /// Kameron regular
  static Future<Font> kameronRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/kameron/v11/vm82dR7vXErQxuznsL4wL-XIYH8.ttf',
      'Kameron-Regular',
    );
    return font.getFont();
  }

  /// Kameron 700
  static Future<Font> kameronBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/kameron/v11/vm8zdR7vXErQxuzniAIfC-3jfHb--NY.ttf',
      'Kameron-Bold',
    );
    return font.getFont();
  }

  /// Kanit 100
  static Future<Font> kanitThin() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/kanit/v7/nKKX-Go6G5tXcr72GwWKcaxALFs.ttf',
      'Kanit-Thin',
    );
    return font.getFont();
  }

  /// Kanit 100italic
  static Future<Font> kanitThinItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/kanit/v7/nKKV-Go6G5tXcraQI2GAdY5FPFtrGw.ttf',
      'Kanit-ThinItalic',
    );
    return font.getFont();
  }

  /// Kanit 200
  static Future<Font> kanitExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/kanit/v7/nKKU-Go6G5tXcr5aOiWgX6BJNUJy.ttf',
      'Kanit-ExtraLight',
    );
    return font.getFont();
  }

  /// Kanit 200italic
  static Future<Font> kanitExtraLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/kanit/v7/nKKS-Go6G5tXcraQI82hVaRrMFJyAu4.ttf',
      'Kanit-ExtraLightItalic',
    );
    return font.getFont();
  }

  /// Kanit 300
  static Future<Font> kanitLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/kanit/v7/nKKU-Go6G5tXcr4-OSWgX6BJNUJy.ttf',
      'Kanit-Light',
    );
    return font.getFont();
  }

  /// Kanit 300italic
  static Future<Font> kanitLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/kanit/v7/nKKS-Go6G5tXcraQI6miVaRrMFJyAu4.ttf',
      'Kanit-LightItalic',
    );
    return font.getFont();
  }

  /// Kanit regular
  static Future<Font> kanitRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/kanit/v7/nKKZ-Go6G5tXcoaSEQGodLxA.ttf',
      'Kanit-Regular',
    );
    return font.getFont();
  }

  /// Kanit italic
  static Future<Font> kanitItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/kanit/v7/nKKX-Go6G5tXcraQGwWKcaxALFs.ttf',
      'Kanit-Italic',
    );
    return font.getFont();
  }

  /// Kanit 500
  static Future<Font> kanitMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/kanit/v7/nKKU-Go6G5tXcr5mOCWgX6BJNUJy.ttf',
      'Kanit-Medium',
    );
    return font.getFont();
  }

  /// Kanit 500italic
  static Future<Font> kanitMediumItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/kanit/v7/nKKS-Go6G5tXcraQI_GjVaRrMFJyAu4.ttf',
      'Kanit-MediumItalic',
    );
    return font.getFont();
  }

  /// Kanit 600
  static Future<Font> kanitSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/kanit/v7/nKKU-Go6G5tXcr5KPyWgX6BJNUJy.ttf',
      'Kanit-SemiBold',
    );
    return font.getFont();
  }

  /// Kanit 600italic
  static Future<Font> kanitSemiBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/kanit/v7/nKKS-Go6G5tXcraQI92kVaRrMFJyAu4.ttf',
      'Kanit-SemiBoldItalic',
    );
    return font.getFont();
  }

  /// Kanit 700
  static Future<Font> kanitBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/kanit/v7/nKKU-Go6G5tXcr4uPiWgX6BJNUJy.ttf',
      'Kanit-Bold',
    );
    return font.getFont();
  }

  /// Kanit 700italic
  static Future<Font> kanitBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/kanit/v7/nKKS-Go6G5tXcraQI7mlVaRrMFJyAu4.ttf',
      'Kanit-BoldItalic',
    );
    return font.getFont();
  }

  /// Kanit 800
  static Future<Font> kanitExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/kanit/v7/nKKU-Go6G5tXcr4yPSWgX6BJNUJy.ttf',
      'Kanit-ExtraBold',
    );
    return font.getFont();
  }

  /// Kanit 800italic
  static Future<Font> kanitExtraBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/kanit/v7/nKKS-Go6G5tXcraQI6WmVaRrMFJyAu4.ttf',
      'Kanit-ExtraBoldItalic',
    );
    return font.getFont();
  }

  /// Kanit 900
  static Future<Font> kanitBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/kanit/v7/nKKU-Go6G5tXcr4WPCWgX6BJNUJy.ttf',
      'Kanit-Black',
    );
    return font.getFont();
  }

  /// Kanit 900italic
  static Future<Font> kanitBlackItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/kanit/v7/nKKS-Go6G5tXcraQI4GnVaRrMFJyAu4.ttf',
      'Kanit-BlackItalic',
    );
    return font.getFont();
  }

  /// Kantumruy 300
  static Future<Font> kantumruyLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/kantumruy/v11/syk0-yJ0m7wyVb-f4FOPUtDlpn-UJ1H6Uw.ttf',
      'Kantumruy-Light',
    );
    return font.getFont();
  }

  /// Kantumruy regular
  static Future<Font> kantumruyRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/kantumruy/v11/sykx-yJ0m7wyVb-f4FO3_vjBrlSILg.ttf',
      'Kantumruy-Regular',
    );
    return font.getFont();
  }

  /// Kantumruy 700
  static Future<Font> kantumruyBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/kantumruy/v11/syk0-yJ0m7wyVb-f4FOPQtflpn-UJ1H6Uw.ttf',
      'Kantumruy-Bold',
    );
    return font.getFont();
  }

  /// Karantina 300
  static Future<Font> karantinaLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/karantina/v1/buExpo24ccnh31GVMABxXCgf-P5Oaiw4cw.ttf',
      'Karantina-Light',
    );
    return font.getFont();
  }

  /// Karantina regular
  static Future<Font> karantinaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/karantina/v1/buE0po24ccnh31GVMABJ8AA78NVSYw.ttf',
      'Karantina-Regular',
    );
    return font.getFont();
  }

  /// Karantina 700
  static Future<Font> karantinaBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/karantina/v1/buExpo24ccnh31GVMABxTC8f-P5Oaiw4cw.ttf',
      'Karantina-Bold',
    );
    return font.getFont();
  }

  /// Karla 200
  static Future<Font> karlaExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/karla/v15/qkBIXvYC6trAT55ZBi1ueQVIjQTDeJqqFENLR7fHGw.ttf',
      'Karla-ExtraLight',
    );
    return font.getFont();
  }

  /// Karla 300
  static Future<Font> karlaLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/karla/v15/qkBIXvYC6trAT55ZBi1ueQVIjQTDppqqFENLR7fHGw.ttf',
      'Karla-Light',
    );
    return font.getFont();
  }

  /// Karla regular
  static Future<Font> karlaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/karla/v15/qkBIXvYC6trAT55ZBi1ueQVIjQTD-JqqFENLR7fHGw.ttf',
      'Karla-Regular',
    );
    return font.getFont();
  }

  /// Karla 500
  static Future<Font> karlaMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/karla/v15/qkBIXvYC6trAT55ZBi1ueQVIjQTDypqqFENLR7fHGw.ttf',
      'Karla-Medium',
    );
    return font.getFont();
  }

  /// Karla 600
  static Future<Font> karlaSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/karla/v15/qkBIXvYC6trAT55ZBi1ueQVIjQTDJp2qFENLR7fHGw.ttf',
      'Karla-SemiBold',
    );
    return font.getFont();
  }

  /// Karla 700
  static Future<Font> karlaBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/karla/v15/qkBIXvYC6trAT55ZBi1ueQVIjQTDH52qFENLR7fHGw.ttf',
      'Karla-Bold',
    );
    return font.getFont();
  }

  /// Karla 800
  static Future<Font> karlaExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/karla/v15/qkBIXvYC6trAT55ZBi1ueQVIjQTDeJ2qFENLR7fHGw.ttf',
      'Karla-ExtraBold',
    );
    return font.getFont();
  }

  /// Karla 200italic
  static Future<Font> karlaExtraLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/karla/v15/qkBKXvYC6trAT7RQNNK2EG7SIwPWMNnCV0lPZbLXGxGR.ttf',
      'Karla-ExtraLightItalic',
    );
    return font.getFont();
  }

  /// Karla 300italic
  static Future<Font> karlaLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/karla/v15/qkBKXvYC6trAT7RQNNK2EG7SIwPWMNkcV0lPZbLXGxGR.ttf',
      'Karla-LightItalic',
    );
    return font.getFont();
  }

  /// Karla italic
  static Future<Font> karlaItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/karla/v15/qkBKXvYC6trAT7RQNNK2EG7SIwPWMNlCV0lPZbLXGxGR.ttf',
      'Karla-Italic',
    );
    return font.getFont();
  }

  /// Karla 500italic
  static Future<Font> karlaMediumItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/karla/v15/qkBKXvYC6trAT7RQNNK2EG7SIwPWMNlwV0lPZbLXGxGR.ttf',
      'Karla-MediumItalic',
    );
    return font.getFont();
  }

  /// Karla 600italic
  static Future<Font> karlaSemiBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/karla/v15/qkBKXvYC6trAT7RQNNK2EG7SIwPWMNmcUElPZbLXGxGR.ttf',
      'Karla-SemiBoldItalic',
    );
    return font.getFont();
  }

  /// Karla 700italic
  static Future<Font> karlaBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/karla/v15/qkBKXvYC6trAT7RQNNK2EG7SIwPWMNmlUElPZbLXGxGR.ttf',
      'Karla-BoldItalic',
    );
    return font.getFont();
  }

  /// Karla 800italic
  static Future<Font> karlaExtraBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/karla/v15/qkBKXvYC6trAT7RQNNK2EG7SIwPWMNnCUElPZbLXGxGR.ttf',
      'Karla-ExtraBoldItalic',
    );
    return font.getFont();
  }

  /// Karma 300
  static Future<Font> karmaLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/karma/v11/va9F4kzAzMZRGLjDY8Z_uqzGQC_-.ttf',
      'Karma-Light',
    );
    return font.getFont();
  }

  /// Karma regular
  static Future<Font> karmaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/karma/v11/va9I4kzAzMZRGIBvS-J3kbDP.ttf',
      'Karma-Regular',
    );
    return font.getFont();
  }

  /// Karma 500
  static Future<Font> karmaMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/karma/v11/va9F4kzAzMZRGLibYsZ_uqzGQC_-.ttf',
      'Karma-Medium',
    );
    return font.getFont();
  }

  /// Karma 600
  static Future<Font> karmaSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/karma/v11/va9F4kzAzMZRGLi3ZcZ_uqzGQC_-.ttf',
      'Karma-SemiBold',
    );
    return font.getFont();
  }

  /// Karma 700
  static Future<Font> karmaBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/karma/v11/va9F4kzAzMZRGLjTZMZ_uqzGQC_-.ttf',
      'Karma-Bold',
    );
    return font.getFont();
  }

  /// Katibeh regular
  static Future<Font> katibehRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/katibeh/v12/ZGjXol5MQJog4bxDaC1RVDNdGDs.ttf',
      'Katibeh-Regular',
    );
    return font.getFont();
  }

  /// Kaushan Script regular
  static Future<Font> kaushanScriptRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/kaushanscript/v9/vm8vdRfvXFLG3OLnsO15WYS5DF7_ytN3M48a.ttf',
      'KaushanScript-Regular',
    );
    return font.getFont();
  }

  /// Kavivanar regular
  static Future<Font> kavivanarRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/kavivanar/v8/o-0IIpQgyXYSwhxP7_Jb4j5Ba_2c7A.ttf',
      'Kavivanar-Regular',
    );
    return font.getFont();
  }

  /// Kavoon regular
  static Future<Font> kavoonRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/kavoon/v11/pxiFyp4_scRYhlU4NLr6f1pdEQ.ttf',
      'Kavoon-Regular',
    );
    return font.getFont();
  }

  /// Kdam Thmor regular
  static Future<Font> kdamThmorRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/kdamthmor/v11/MwQzbhjs3veF6QwJVf0JkGMViblPtXs.ttf',
      'KdamThmor-Regular',
    );
    return font.getFont();
  }

  /// Keania One regular
  static Future<Font> keaniaOneRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/keaniaone/v10/zOL54pXJk65E8pXardnuycRuv-hHkOs.ttf',
      'KeaniaOne-Regular',
    );
    return font.getFont();
  }

  /// Kelly Slab regular
  static Future<Font> kellySlabRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/kellyslab/v11/-W_7XJX0Rz3cxUnJC5t6TkMBf50kbiM.ttf',
      'KellySlab-Regular',
    );
    return font.getFont();
  }

  /// Kenia regular
  static Future<Font> keniaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/kenia/v14/jizURE5PuHQH9qCONUGswfGM.ttf',
      'Kenia-Regular',
    );
    return font.getFont();
  }

  /// Khand 300
  static Future<Font> khandLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/khand/v9/TwMN-IINQlQQ0bL5cFE3ZwaH__-C.ttf',
      'Khand-Light',
    );
    return font.getFont();
  }

  /// Khand regular
  static Future<Font> khandRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/khand/v9/TwMA-IINQlQQ0YpVWHU_TBqO.ttf',
      'Khand-Regular',
    );
    return font.getFont();
  }

  /// Khand 500
  static Future<Font> khandMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/khand/v9/TwMN-IINQlQQ0bKhcVE3ZwaH__-C.ttf',
      'Khand-Medium',
    );
    return font.getFont();
  }

  /// Khand 600
  static Future<Font> khandSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/khand/v9/TwMN-IINQlQQ0bKNdlE3ZwaH__-C.ttf',
      'Khand-SemiBold',
    );
    return font.getFont();
  }

  /// Khand 700
  static Future<Font> khandBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/khand/v9/TwMN-IINQlQQ0bLpd1E3ZwaH__-C.ttf',
      'Khand-Bold',
    );
    return font.getFont();
  }

  /// Khmer regular
  static Future<Font> khmerRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/khmer/v15/MjQImit_vPPwpF-BpN2EeYmD.ttf',
      'Khmer-Regular',
    );
    return font.getFont();
  }

  /// Khula 300
  static Future<Font> khulaLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/khula/v7/OpNPnoEOns3V7G-ljCvUrC59XwXD.ttf',
      'Khula-Light',
    );
    return font.getFont();
  }

  /// Khula regular
  static Future<Font> khulaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/khula/v7/OpNCnoEOns3V7FcJpA_chzJ0.ttf',
      'Khula-Regular',
    );
    return font.getFont();
  }

  /// Khula 600
  static Future<Font> khulaSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/khula/v7/OpNPnoEOns3V7G_RiivUrC59XwXD.ttf',
      'Khula-SemiBold',
    );
    return font.getFont();
  }

  /// Khula 700
  static Future<Font> khulaBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/khula/v7/OpNPnoEOns3V7G-1iyvUrC59XwXD.ttf',
      'Khula-Bold',
    );
    return font.getFont();
  }

  /// Khula 800
  static Future<Font> khulaExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/khula/v7/OpNPnoEOns3V7G-piCvUrC59XwXD.ttf',
      'Khula-ExtraBold',
    );
    return font.getFont();
  }

  /// Kirang Haerang regular
  static Future<Font> kirangHaerangRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/kiranghaerang/v10/E21-_dn_gvvIjhYON1lpIU4-bcqvWPaJq4no.ttf',
      'KirangHaerang-Regular',
    );
    return font.getFont();
  }

  /// Kite One regular
  static Future<Font> kiteOneRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/kiteone/v10/70lQu7shLnA_E02vyq1b6HnGO4uA.ttf',
      'KiteOne-Regular',
    );
    return font.getFont();
  }

  /// Kiwi Maru 300
  static Future<Font> kiwiMaruLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/kiwimaru/v4/R70djykGkuuDep-hRg6gNCi0Vxn9R5ShnA.ttf',
      'KiwiMaru-Light',
    );
    return font.getFont();
  }

  /// Kiwi Maru regular
  static Future<Font> kiwiMaruRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/kiwimaru/v4/R70YjykGkuuDep-hRg6YmACQXzLhTg.ttf',
      'KiwiMaru-Regular',
    );
    return font.getFont();
  }

  /// Kiwi Maru 500
  static Future<Font> kiwiMaruMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/kiwimaru/v4/R70djykGkuuDep-hRg6gbCm0Vxn9R5ShnA.ttf',
      'KiwiMaru-Medium',
    );
    return font.getFont();
  }

  /// Knewave regular
  static Future<Font> knewaveRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/knewave/v9/sykz-yx0lLcxQaSItSq9-trEvlQ.ttf',
      'Knewave-Regular',
    );
    return font.getFont();
  }

  /// KoHo 200
  static Future<Font> koHoExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/koho/v6/K2FxfZ5fmddNPuE1WJ75JoKhHys.ttf',
      'KoHo-ExtraLight',
    );
    return font.getFont();
  }

  /// KoHo 200italic
  static Future<Font> koHoExtraLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/koho/v6/K2FzfZ5fmddNNisssJ_zIqCkDyvqZA.ttf',
      'KoHo-ExtraLightItalic',
    );
    return font.getFont();
  }

  /// KoHo 300
  static Future<Font> koHoLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/koho/v6/K2FxfZ5fmddNPoU2WJ75JoKhHys.ttf',
      'KoHo-Light',
    );
    return font.getFont();
  }

  /// KoHo 300italic
  static Future<Font> koHoLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/koho/v6/K2FzfZ5fmddNNiss1JzzIqCkDyvqZA.ttf',
      'KoHo-LightItalic',
    );
    return font.getFont();
  }

  /// KoHo regular
  static Future<Font> koHoRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/koho/v6/K2F-fZ5fmddNBikefJbSOos.ttf',
      'KoHo-Regular',
    );
    return font.getFont();
  }

  /// KoHo italic
  static Future<Font> koHoItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/koho/v6/K2FwfZ5fmddNNisUeLTXKou4Bg.ttf',
      'KoHo-Italic',
    );
    return font.getFont();
  }

  /// KoHo 500
  static Future<Font> koHoMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/koho/v6/K2FxfZ5fmddNPt03WJ75JoKhHys.ttf',
      'KoHo-Medium',
    );
    return font.getFont();
  }

  /// KoHo 500italic
  static Future<Font> koHoMediumItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/koho/v6/K2FzfZ5fmddNNissjJ3zIqCkDyvqZA.ttf',
      'KoHo-MediumItalic',
    );
    return font.getFont();
  }

  /// KoHo 600
  static Future<Font> koHoSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/koho/v6/K2FxfZ5fmddNPvEwWJ75JoKhHys.ttf',
      'KoHo-SemiBold',
    );
    return font.getFont();
  }

  /// KoHo 600italic
  static Future<Font> koHoSemiBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/koho/v6/K2FzfZ5fmddNNissoJrzIqCkDyvqZA.ttf',
      'KoHo-SemiBoldItalic',
    );
    return font.getFont();
  }

  /// KoHo 700
  static Future<Font> koHoBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/koho/v6/K2FxfZ5fmddNPpUxWJ75JoKhHys.ttf',
      'KoHo-Bold',
    );
    return font.getFont();
  }

  /// KoHo 700italic
  static Future<Font> koHoBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/koho/v6/K2FzfZ5fmddNNissxJvzIqCkDyvqZA.ttf',
      'KoHo-BoldItalic',
    );
    return font.getFont();
  }

  /// Kodchasan 200
  static Future<Font> kodchasanExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/kodchasan/v6/1cX0aUPOAJv9sG4I-DJeR1Cggeqo3eMeoA.ttf',
      'Kodchasan-ExtraLight',
    );
    return font.getFont();
  }

  /// Kodchasan 200italic
  static Future<Font> kodchasanExtraLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/kodchasan/v6/1cXqaUPOAJv9sG4I-DJWjUlIgOCs_-YOoIgN.ttf',
      'Kodchasan-ExtraLightItalic',
    );
    return font.getFont();
  }

  /// Kodchasan 300
  static Future<Font> kodchasanLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/kodchasan/v6/1cX0aUPOAJv9sG4I-DJeI1Oggeqo3eMeoA.ttf',
      'Kodchasan-Light',
    );
    return font.getFont();
  }

  /// Kodchasan 300italic
  static Future<Font> kodchasanLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/kodchasan/v6/1cXqaUPOAJv9sG4I-DJWjUksg-Cs_-YOoIgN.ttf',
      'Kodchasan-LightItalic',
    );
    return font.getFont();
  }

  /// Kodchasan regular
  static Future<Font> kodchasanRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/kodchasan/v6/1cXxaUPOAJv9sG4I-DJmj3uEicG01A.ttf',
      'Kodchasan-Regular',
    );
    return font.getFont();
  }

  /// Kodchasan italic
  static Future<Font> kodchasanItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/kodchasan/v6/1cX3aUPOAJv9sG4I-DJWjXGAq8Sk1PoH.ttf',
      'Kodchasan-Italic',
    );
    return font.getFont();
  }

  /// Kodchasan 500
  static Future<Font> kodchasanMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/kodchasan/v6/1cX0aUPOAJv9sG4I-DJee1Kggeqo3eMeoA.ttf',
      'Kodchasan-Medium',
    );
    return font.getFont();
  }

  /// Kodchasan 500italic
  static Future<Font> kodchasanMediumItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/kodchasan/v6/1cXqaUPOAJv9sG4I-DJWjUl0guCs_-YOoIgN.ttf',
      'Kodchasan-MediumItalic',
    );
    return font.getFont();
  }

  /// Kodchasan 600
  static Future<Font> kodchasanSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/kodchasan/v6/1cX0aUPOAJv9sG4I-DJeV1Wggeqo3eMeoA.ttf',
      'Kodchasan-SemiBold',
    );
    return font.getFont();
  }

  /// Kodchasan 600italic
  static Future<Font> kodchasanSemiBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/kodchasan/v6/1cXqaUPOAJv9sG4I-DJWjUlYheCs_-YOoIgN.ttf',
      'Kodchasan-SemiBoldItalic',
    );
    return font.getFont();
  }

  /// Kodchasan 700
  static Future<Font> kodchasanBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/kodchasan/v6/1cX0aUPOAJv9sG4I-DJeM1Sggeqo3eMeoA.ttf',
      'Kodchasan-Bold',
    );
    return font.getFont();
  }

  /// Kodchasan 700italic
  static Future<Font> kodchasanBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/kodchasan/v6/1cXqaUPOAJv9sG4I-DJWjUk8hOCs_-YOoIgN.ttf',
      'Kodchasan-BoldItalic',
    );
    return font.getFont();
  }

  /// Kosugi regular
  static Future<Font> kosugiRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/kosugi/v6/pxiFyp4_v8FCjlI4NLr6f1pdEQ.ttf',
      'Kosugi-Regular',
    );
    return font.getFont();
  }

  /// Kosugi Maru regular
  static Future<Font> kosugiMaruRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/kosugimaru/v6/0nksC9PgP_wGh21A2KeqGiTqivr9iBq_.ttf',
      'KosugiMaru-Regular',
    );
    return font.getFont();
  }

  /// Kotta One regular
  static Future<Font> kottaOneRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/kottaone/v10/S6u_w41LXzPc_jlfNWqPHA3s5dwt7w.ttf',
      'KottaOne-Regular',
    );
    return font.getFont();
  }

  /// Koulen regular
  static Future<Font> koulenRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/koulen/v16/AMOQz46as3KIBPeWgnA9kuYMUg.ttf',
      'Koulen-Regular',
    );
    return font.getFont();
  }

  /// Kranky regular
  static Future<Font> krankyRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/kranky/v13/hESw6XVgJzlPsFnMpheEZo_H_w.ttf',
      'Kranky-Regular',
    );
    return font.getFont();
  }

  /// Kreon 300
  static Future<Font> kreonLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/kreon/v24/t5t9IRIUKY-TFF_LW5lnMR3v2DnvPNimejUfp2dWNg.ttf',
      'Kreon-Light',
    );
    return font.getFont();
  }

  /// Kreon regular
  static Future<Font> kreonRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/kreon/v24/t5t9IRIUKY-TFF_LW5lnMR3v2DnvYtimejUfp2dWNg.ttf',
      'Kreon-Regular',
    );
    return font.getFont();
  }

  /// Kreon 500
  static Future<Font> kreonMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/kreon/v24/t5t9IRIUKY-TFF_LW5lnMR3v2DnvUNimejUfp2dWNg.ttf',
      'Kreon-Medium',
    );
    return font.getFont();
  }

  /// Kreon 600
  static Future<Font> kreonSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/kreon/v24/t5t9IRIUKY-TFF_LW5lnMR3v2DnvvN-mejUfp2dWNg.ttf',
      'Kreon-SemiBold',
    );
    return font.getFont();
  }

  /// Kreon 700
  static Future<Font> kreonBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/kreon/v24/t5t9IRIUKY-TFF_LW5lnMR3v2Dnvhd-mejUfp2dWNg.ttf',
      'Kreon-Bold',
    );
    return font.getFont();
  }

  /// Kristi regular
  static Future<Font> kristiRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/kristi/v12/uK_y4ricdeU6zwdRCh0TMv6EXw.ttf',
      'Kristi-Regular',
    );
    return font.getFont();
  }

  /// Krona One regular
  static Future<Font> kronaOneRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/kronaone/v9/jAnEgHdjHcjgfIb1ZcUCMY-h3cWkWg.ttf',
      'KronaOne-Regular',
    );
    return font.getFont();
  }

  /// Krub 200
  static Future<Font> krubExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/krub/v4/sZlEdRyC6CRYZo47KLF4R6gWaf8.ttf',
      'Krub-ExtraLight',
    );
    return font.getFont();
  }

  /// Krub 200italic
  static Future<Font> krubExtraLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/krub/v4/sZlGdRyC6CRYbkQiwLByQ4oTef_6gQ.ttf',
      'Krub-ExtraLightItalic',
    );
    return font.getFont();
  }

  /// Krub 300
  static Future<Font> krubLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/krub/v4/sZlEdRyC6CRYZuo4KLF4R6gWaf8.ttf',
      'Krub-Light',
    );
    return font.getFont();
  }

  /// Krub 300italic
  static Future<Font> krubLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/krub/v4/sZlGdRyC6CRYbkQipLNyQ4oTef_6gQ.ttf',
      'Krub-LightItalic',
    );
    return font.getFont();
  }

  /// Krub regular
  static Future<Font> krubRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/krub/v4/sZlLdRyC6CRYXkYQDLlTW6E.ttf',
      'Krub-Regular',
    );
    return font.getFont();
  }

  /// Krub italic
  static Future<Font> krubItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/krub/v4/sZlFdRyC6CRYbkQaCJtWS6EPcA.ttf',
      'Krub-Italic',
    );
    return font.getFont();
  }

  /// Krub 500
  static Future<Font> krubMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/krub/v4/sZlEdRyC6CRYZrI5KLF4R6gWaf8.ttf',
      'Krub-Medium',
    );
    return font.getFont();
  }

  /// Krub 500italic
  static Future<Font> krubMediumItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/krub/v4/sZlGdRyC6CRYbkQi_LJyQ4oTef_6gQ.ttf',
      'Krub-MediumItalic',
    );
    return font.getFont();
  }

  /// Krub 600
  static Future<Font> krubSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/krub/v4/sZlEdRyC6CRYZp4-KLF4R6gWaf8.ttf',
      'Krub-SemiBold',
    );
    return font.getFont();
  }

  /// Krub 600italic
  static Future<Font> krubSemiBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/krub/v4/sZlGdRyC6CRYbkQi0LVyQ4oTef_6gQ.ttf',
      'Krub-SemiBoldItalic',
    );
    return font.getFont();
  }

  /// Krub 700
  static Future<Font> krubBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/krub/v4/sZlEdRyC6CRYZvo_KLF4R6gWaf8.ttf',
      'Krub-Bold',
    );
    return font.getFont();
  }

  /// Krub 700italic
  static Future<Font> krubBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/krub/v4/sZlGdRyC6CRYbkQitLRyQ4oTef_6gQ.ttf',
      'Krub-BoldItalic',
    );
    return font.getFont();
  }

  /// Kufam regular
  static Future<Font> kufamRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/kufam/v6/C8c-4cY7pG7w_oSJDszBXsKCcBH3lqk7qQCJHvIwYg.ttf',
      'Kufam-Regular',
    );
    return font.getFont();
  }

  /// Kufam 500
  static Future<Font> kufamMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/kufam/v6/C8c-4cY7pG7w_oSJDszBXsKCcBH3pKk7qQCJHvIwYg.ttf',
      'Kufam-Medium',
    );
    return font.getFont();
  }

  /// Kufam 600
  static Future<Font> kufamSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/kufam/v6/C8c-4cY7pG7w_oSJDszBXsKCcBH3SK47qQCJHvIwYg.ttf',
      'Kufam-SemiBold',
    );
    return font.getFont();
  }

  /// Kufam 700
  static Future<Font> kufamBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/kufam/v6/C8c-4cY7pG7w_oSJDszBXsKCcBH3ca47qQCJHvIwYg.ttf',
      'Kufam-Bold',
    );
    return font.getFont();
  }

  /// Kufam 800
  static Future<Font> kufamExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/kufam/v6/C8c-4cY7pG7w_oSJDszBXsKCcBH3Fq47qQCJHvIwYg.ttf',
      'Kufam-ExtraBold',
    );
    return font.getFont();
  }

  /// Kufam 900
  static Future<Font> kufamBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/kufam/v6/C8c-4cY7pG7w_oSJDszBXsKCcBH3P647qQCJHvIwYg.ttf',
      'Kufam-Black',
    );
    return font.getFont();
  }

  /// Kufam italic
  static Future<Font> kufamItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/kufam/v6/C8c84cY7pG7w_q6APDMZN6kY3hbiXurT6gqNPPcgYp0i.ttf',
      'Kufam-Italic',
    );
    return font.getFont();
  }

  /// Kufam 500italic
  static Future<Font> kufamMediumItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/kufam/v6/C8c84cY7pG7w_q6APDMZN6kY3hbiXurh6gqNPPcgYp0i.ttf',
      'Kufam-MediumItalic',
    );
    return font.getFont();
  }

  /// Kufam 600italic
  static Future<Font> kufamSemiBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/kufam/v6/C8c84cY7pG7w_q6APDMZN6kY3hbiXuoN7QqNPPcgYp0i.ttf',
      'Kufam-SemiBoldItalic',
    );
    return font.getFont();
  }

  /// Kufam 700italic
  static Future<Font> kufamBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/kufam/v6/C8c84cY7pG7w_q6APDMZN6kY3hbiXuo07QqNPPcgYp0i.ttf',
      'Kufam-BoldItalic',
    );
    return font.getFont();
  }

  /// Kufam 800italic
  static Future<Font> kufamExtraBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/kufam/v6/C8c84cY7pG7w_q6APDMZN6kY3hbiXupT7QqNPPcgYp0i.ttf',
      'Kufam-ExtraBoldItalic',
    );
    return font.getFont();
  }

  /// Kufam 900italic
  static Future<Font> kufamBlackItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/kufam/v6/C8c84cY7pG7w_q6APDMZN6kY3hbiXup67QqNPPcgYp0i.ttf',
      'Kufam-BlackItalic',
    );
    return font.getFont();
  }

  /// Kulim Park 200
  static Future<Font> kulimParkExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/kulimpark/v4/fdN49secq3hflz1Uu3IwjJYNwa5aZbUvGjU.ttf',
      'KulimPark-ExtraLight',
    );
    return font.getFont();
  }

  /// Kulim Park 200italic
  static Future<Font> kulimParkExtraLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/kulimpark/v4/fdNm9secq3hflz1Uu3IwhFwUKa9QYZcqCjVVUA.ttf',
      'KulimPark-ExtraLightItalic',
    );
    return font.getFont();
  }

  /// Kulim Park 300
  static Future<Font> kulimParkLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/kulimpark/v4/fdN49secq3hflz1Uu3IwjPIOwa5aZbUvGjU.ttf',
      'KulimPark-Light',
    );
    return font.getFont();
  }

  /// Kulim Park 300italic
  static Future<Font> kulimParkLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/kulimpark/v4/fdNm9secq3hflz1Uu3IwhFwUTaxQYZcqCjVVUA.ttf',
      'KulimPark-LightItalic',
    );
    return font.getFont();
  }

  /// Kulim Park regular
  static Future<Font> kulimParkRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/kulimpark/v4/fdN79secq3hflz1Uu3IwtF4m5aZxebw.ttf',
      'KulimPark-Regular',
    );
    return font.getFont();
  }

  /// Kulim Park italic
  static Future<Font> kulimParkItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/kulimpark/v4/fdN59secq3hflz1Uu3IwhFws4YR0abw2Aw.ttf',
      'KulimPark-Italic',
    );
    return font.getFont();
  }

  /// Kulim Park 600
  static Future<Font> kulimParkSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/kulimpark/v4/fdN49secq3hflz1Uu3IwjIYIwa5aZbUvGjU.ttf',
      'KulimPark-SemiBold',
    );
    return font.getFont();
  }

  /// Kulim Park 600italic
  static Future<Font> kulimParkSemiBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/kulimpark/v4/fdNm9secq3hflz1Uu3IwhFwUOapQYZcqCjVVUA.ttf',
      'KulimPark-SemiBoldItalic',
    );
    return font.getFont();
  }

  /// Kulim Park 700
  static Future<Font> kulimParkBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/kulimpark/v4/fdN49secq3hflz1Uu3IwjOIJwa5aZbUvGjU.ttf',
      'KulimPark-Bold',
    );
    return font.getFont();
  }

  /// Kulim Park 700italic
  static Future<Font> kulimParkBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/kulimpark/v4/fdNm9secq3hflz1Uu3IwhFwUXatQYZcqCjVVUA.ttf',
      'KulimPark-BoldItalic',
    );
    return font.getFont();
  }

  /// Kumar One regular
  static Future<Font> kumarOneRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/kumarone/v7/bMr1mS-P958wYi6YaGeGNO6WU3oT0g.ttf',
      'KumarOne-Regular',
    );
    return font.getFont();
  }

  /// Kumar One Outline regular
  static Future<Font> kumarOneOutlineRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/kumaroneoutline/v8/Noao6VH62pyLP0fsrZ-v18wlUEcX9zDwRQu8EGKF.ttf',
      'KumarOneOutline-Regular',
    );
    return font.getFont();
  }

  /// Kumbh Sans 300
  static Future<Font> kumbhSansLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/kumbhsans/v5/c4mm1n92AsfhuCq6tVsagit_3KKVXUv8Los.ttf',
      'KumbhSans-Light',
    );
    return font.getFont();
  }

  /// Kumbh Sans regular
  static Future<Font> kumbhSansRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/kumbhsans/v5/c4ml1n92AsfhuCq6tVsauodX-Kq-QUI.ttf',
      'KumbhSans-Regular',
    );
    return font.getFont();
  }

  /// Kumbh Sans 700
  static Future<Font> kumbhSansBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/kumbhsans/v5/c4mm1n92AsfhuCq6tVsagjt43KKVXUv8Los.ttf',
      'KumbhSans-Bold',
    );
    return font.getFont();
  }

  /// Kurale regular
  static Future<Font> kuraleRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/kurale/v6/4iCs6KV9e9dXjho6eAT3v02QFg.ttf',
      'Kurale-Regular',
    );
    return font.getFont();
  }

  /// La Belle Aurore regular
  static Future<Font> laBelleAuroreRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/labelleaurore/v11/RrQIbot8-mNYKnGNDkWlocovHeIIG-eFNVmULg.ttf',
      'LaBelleAurore-Regular',
    );
    return font.getFont();
  }

  /// Lacquer regular
  static Future<Font> lacquerRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/lacquer/v5/EYqzma1QwqpG4_BBB7-AXhttQ5I.ttf',
      'Lacquer-Regular',
    );
    return font.getFont();
  }

  /// Laila 300
  static Future<Font> lailaLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/laila/v8/LYjBdG_8nE8jDLzxogNAh14nVcfe.ttf',
      'Laila-Light',
    );
    return font.getFont();
  }

  /// Laila regular
  static Future<Font> lailaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/laila/v8/LYjMdG_8nE8jDIRdiidIrEIu.ttf',
      'Laila-Regular',
    );
    return font.getFont();
  }

  /// Laila 500
  static Future<Font> lailaMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/laila/v8/LYjBdG_8nE8jDLypowNAh14nVcfe.ttf',
      'Laila-Medium',
    );
    return font.getFont();
  }

  /// Laila 600
  static Future<Font> lailaSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/laila/v8/LYjBdG_8nE8jDLyFpANAh14nVcfe.ttf',
      'Laila-SemiBold',
    );
    return font.getFont();
  }

  /// Laila 700
  static Future<Font> lailaBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/laila/v8/LYjBdG_8nE8jDLzhpQNAh14nVcfe.ttf',
      'Laila-Bold',
    );
    return font.getFont();
  }

  /// Lakki Reddy regular
  static Future<Font> lakkiReddyRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/lakkireddy/v9/S6u5w49MUSzD9jlCPmvLZQfox9k97-xZ.ttf',
      'LakkiReddy-Regular',
    );
    return font.getFont();
  }

  /// Lalezar regular
  static Future<Font> lalezarRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/lalezar/v9/zrfl0HLVx-HwTP82UaDyIiL0RCg.ttf',
      'Lalezar-Regular',
    );
    return font.getFont();
  }

  /// Lancelot regular
  static Future<Font> lancelotRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/lancelot/v12/J7acnppxBGtQEulG4JY4xJ9CGyAa.ttf',
      'Lancelot-Regular',
    );
    return font.getFont();
  }

  /// Langar regular
  static Future<Font> langarRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/langar/v15/kJEyBukW7AIlgjGVrTVZ99sqrQ.ttf',
      'Langar-Regular',
    );
    return font.getFont();
  }

  /// Lateef regular
  static Future<Font> lateefRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/lateef/v18/hESw6XVnNCxEvkbMpheEZo_H_w.ttf',
      'Lateef-Regular',
    );
    return font.getFont();
  }

  /// Lato 100
  static Future<Font> latoThin() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/lato/v17/S6u8w4BMUTPHh30wWyWrFCbw7A.ttf',
      'Lato-Thin',
    );
    return font.getFont();
  }

  /// Lato 100italic
  static Future<Font> latoThinItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/lato/v17/S6u-w4BMUTPHjxsIPy-vNiPg7MU0.ttf',
      'Lato-ThinItalic',
    );
    return font.getFont();
  }

  /// Lato 300
  static Future<Font> latoLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/lato/v17/S6u9w4BMUTPHh7USew-FGC_p9dw.ttf',
      'Lato-Light',
    );
    return font.getFont();
  }

  /// Lato 300italic
  static Future<Font> latoLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/lato/v17/S6u_w4BMUTPHjxsI9w2PHA3s5dwt7w.ttf',
      'Lato-LightItalic',
    );
    return font.getFont();
  }

  /// Lato regular
  static Future<Font> latoRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/lato/v17/S6uyw4BMUTPHvxk6XweuBCY.ttf',
      'Lato-Regular',
    );
    return font.getFont();
  }

  /// Lato italic
  static Future<Font> latoItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/lato/v17/S6u8w4BMUTPHjxswWyWrFCbw7A.ttf',
      'Lato-Italic',
    );
    return font.getFont();
  }

  /// Lato 700
  static Future<Font> latoBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/lato/v17/S6u9w4BMUTPHh6UVew-FGC_p9dw.ttf',
      'Lato-Bold',
    );
    return font.getFont();
  }

  /// Lato 700italic
  static Future<Font> latoBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/lato/v17/S6u_w4BMUTPHjxsI5wqPHA3s5dwt7w.ttf',
      'Lato-BoldItalic',
    );
    return font.getFont();
  }

  /// Lato 900
  static Future<Font> latoBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/lato/v17/S6u9w4BMUTPHh50Xew-FGC_p9dw.ttf',
      'Lato-Black',
    );
    return font.getFont();
  }

  /// Lato 900italic
  static Future<Font> latoBlackItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/lato/v17/S6u_w4BMUTPHjxsI3wiPHA3s5dwt7w.ttf',
      'Lato-BlackItalic',
    );
    return font.getFont();
  }

  /// League Script regular
  static Future<Font> leagueScriptRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/leaguescript/v14/CSR54zpSlumSWj9CGVsoBZdeaNNUuOwkC2s.ttf',
      'LeagueScript-Regular',
    );
    return font.getFont();
  }

  /// Leckerli One regular
  static Future<Font> leckerliOneRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/leckerlione/v11/V8mCoQH8VCsNttEnxnGQ-1itLZxcBtItFw.ttf',
      'LeckerliOne-Regular',
    );
    return font.getFont();
  }

  /// Ledger regular
  static Future<Font> ledgerRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ledger/v11/j8_q6-HK1L3if_sxm8DwHTBhHw.ttf',
      'Ledger-Regular',
    );
    return font.getFont();
  }

  /// Lekton regular
  static Future<Font> lektonRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/lekton/v11/SZc43FDmLaWmWpBeXxfonUPL6Q.ttf',
      'Lekton-Regular',
    );
    return font.getFont();
  }

  /// Lekton italic
  static Future<Font> lektonItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/lekton/v11/SZc63FDmLaWmWpBuXR3sv0bb6StO.ttf',
      'Lekton-Italic',
    );
    return font.getFont();
  }

  /// Lekton 700
  static Future<Font> lektonBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/lekton/v11/SZc73FDmLaWmWpBm4zjMlWjX4DJXgQ.ttf',
      'Lekton-Bold',
    );
    return font.getFont();
  }

  /// Lemon regular
  static Future<Font> lemonRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/lemon/v9/HI_EiYEVKqRMq0jBSZXAQ4-d.ttf',
      'Lemon-Regular',
    );
    return font.getFont();
  }

  /// Lemonada 300
  static Future<Font> lemonadaLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/lemonada/v12/0QI-MXFD9oygTWy_R-FFlwV-bgfR7QJGJOt2mfWc3Z2pTg.ttf',
      'Lemonada-Light',
    );
    return font.getFont();
  }

  /// Lemonada regular
  static Future<Font> lemonadaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/lemonada/v12/0QI-MXFD9oygTWy_R-FFlwV-bgfR7QJGeut2mfWc3Z2pTg.ttf',
      'Lemonada-Regular',
    );
    return font.getFont();
  }

  /// Lemonada 500
  static Future<Font> lemonadaMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/lemonada/v12/0QI-MXFD9oygTWy_R-FFlwV-bgfR7QJGSOt2mfWc3Z2pTg.ttf',
      'Lemonada-Medium',
    );
    return font.getFont();
  }

  /// Lemonada 600
  static Future<Font> lemonadaSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/lemonada/v12/0QI-MXFD9oygTWy_R-FFlwV-bgfR7QJGpOx2mfWc3Z2pTg.ttf',
      'Lemonada-SemiBold',
    );
    return font.getFont();
  }

  /// Lemonada 700
  static Future<Font> lemonadaBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/lemonada/v12/0QI-MXFD9oygTWy_R-FFlwV-bgfR7QJGnex2mfWc3Z2pTg.ttf',
      'Lemonada-Bold',
    );
    return font.getFont();
  }

  /// Lexend 100
  static Future<Font> lexendThin() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/lexend/v5/wlpygwvFAVdoq2_nmKQR82JHaTBX.ttf',
      'Lexend-Thin',
    );
    return font.getFont();
  }

  /// Lexend 300
  static Future<Font> lexendLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/lexend/v5/wlpzgwvFAVdoq2_nUIYx2UxLYClOCg.ttf',
      'Lexend-Light',
    );
    return font.getFont();
  }

  /// Lexend regular
  static Future<Font> lexendRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/lexend/v5/wlpwgwvFAVdoq2_f_K4V0WdXaQ.ttf',
      'Lexend-Regular',
    );
    return font.getFont();
  }

  /// Lexend 500
  static Future<Font> lexendMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/lexend/v5/wlpzgwvFAVdoq2_nCIcx2UxLYClOCg.ttf',
      'Lexend-Medium',
    );
    return font.getFont();
  }

  /// Lexend 600
  static Future<Font> lexendSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/lexend/v5/wlpzgwvFAVdoq2_nJIAx2UxLYClOCg.ttf',
      'Lexend-SemiBold',
    );
    return font.getFont();
  }

  /// Lexend 700
  static Future<Font> lexendBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/lexend/v5/wlpzgwvFAVdoq2_nQIEx2UxLYClOCg.ttf',
      'Lexend-Bold',
    );
    return font.getFont();
  }

  /// Lexend 800
  static Future<Font> lexendExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/lexend/v5/wlpzgwvFAVdoq2_nXIIx2UxLYClOCg.ttf',
      'Lexend-ExtraBold',
    );
    return font.getFont();
  }

  /// Lexend Deca regular
  static Future<Font> lexendDecaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/lexenddeca/v7/K2F1fZFYk-dHSE0UPPuwQ6qgLS76ZHOM.ttf',
      'LexendDeca-Regular',
    );
    return font.getFont();
  }

  /// Lexend Exa regular
  static Future<Font> lexendExaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/lexendexa/v10/UMBXrPdOoHOnxExyjdBeWirXArM58BY.ttf',
      'LexendExa-Regular',
    );
    return font.getFont();
  }

  /// Lexend Giga regular
  static Future<Font> lexendGigaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/lexendgiga/v10/PlI5Fl67Mah5Y8yMHE7lkVxEt8CwfGaD.ttf',
      'LexendGiga-Regular',
    );
    return font.getFont();
  }

  /// Lexend Mega regular
  static Future<Font> lexendMegaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/lexendmega/v10/qFdA35aBi5JtHD41zSTFEv7K6BsAikI7.ttf',
      'LexendMega-Regular',
    );
    return font.getFont();
  }

  /// Lexend Peta regular
  static Future<Font> lexendPetaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/lexendpeta/v10/BXRvvFPGjeLPh0kCfI4OkE_1c8Tf1IW3.ttf',
      'LexendPeta-Regular',
    );
    return font.getFont();
  }

  /// Lexend Tera regular
  static Future<Font> lexendTeraRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/lexendtera/v10/RrQUbo98_jt_IXnBPwCWtZhARYMgGtWA.ttf',
      'LexendTera-Regular',
    );
    return font.getFont();
  }

  /// Lexend Zetta regular
  static Future<Font> lexendZettaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/lexendzetta/v10/ll87K2KYXje7CdOFnEWcU8soliQejRR7AQ.ttf',
      'LexendZetta-Regular',
    );
    return font.getFont();
  }

  /// Libre Barcode 128 regular
  static Future<Font> libreBarcode128Regular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/librebarcode128/v16/cIfnMbdUsUoiW3O_hVviCwVjuLtXeJ_A_gMk0izH.ttf',
      'LibreBarcode128-Regular',
    );
    return font.getFont();
  }

  /// Libre Barcode 128 Text regular
  static Future<Font> libreBarcode128TextRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/librebarcode128text/v16/fdNv9tubt3ZEnz1Gu3I4-zppwZ9CWZ16Z0w5cV3Y6M90w4k.ttf',
      'LibreBarcode128Text-Regular',
    );
    return font.getFont();
  }

  /// Libre Barcode 39 regular
  static Future<Font> libreBarcode39Regular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/librebarcode39/v14/-nFnOHM08vwC6h8Li1eQnP_AHzI2K_d709jy92k.ttf',
      'LibreBarcode39-Regular',
    );
    return font.getFont();
  }

  /// Libre Barcode 39 Extended regular
  static Future<Font> libreBarcode39ExtendedRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/librebarcode39extended/v15/8At7Gt6_O5yNS0-K4Nf5U922qSzhJ3dUdfJpwNUgfNRCOZ1GOBw.ttf',
      'LibreBarcode39Extended-Regular',
    );
    return font.getFont();
  }

  /// Libre Barcode 39 Extended Text regular
  static Future<Font> libreBarcode39ExtendedTextRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/librebarcode39extendedtext/v15/eLG1P_rwIgOiDA7yrs9LoKaYRVLQ1YldrrOnnL7xPO4jNP68fLIiPopNNA.ttf',
      'LibreBarcode39ExtendedText-Regular',
    );
    return font.getFont();
  }

  /// Libre Barcode 39 Text regular
  static Future<Font> libreBarcode39TextRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/librebarcode39text/v16/sJoa3KhViNKANw_E3LwoDXvs5Un0HQ1vT-031RRL-9rYaw.ttf',
      'LibreBarcode39Text-Regular',
    );
    return font.getFont();
  }

  /// Libre Barcode EAN13 Text regular
  static Future<Font> libreBarcodeEAN13TextRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/librebarcodeean13text/v9/wlpigxXFDU1_oCu9nfZytgIqSG0XRcJm_OQiB96PAGEki52WfA.ttf',
      'LibreBarcodeEAN13Text-Regular',
    );
    return font.getFont();
  }

  /// Libre Baskerville regular
  static Future<Font> libreBaskervilleRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/librebaskerville/v9/kmKnZrc3Hgbbcjq75U4uslyuy4kn0pNeYRI4CN2V.ttf',
      'LibreBaskerville-Regular',
    );
    return font.getFont();
  }

  /// Libre Baskerville italic
  static Future<Font> libreBaskervilleItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/librebaskerville/v9/kmKhZrc3Hgbbcjq75U4uslyuy4kn0qNcaxYaDc2V2ro.ttf',
      'LibreBaskerville-Italic',
    );
    return font.getFont();
  }

  /// Libre Baskerville 700
  static Future<Font> libreBaskervilleBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/librebaskerville/v9/kmKiZrc3Hgbbcjq75U4uslyuy4kn0qviTjYwI8Gcw6Oi.ttf',
      'LibreBaskerville-Bold',
    );
    return font.getFont();
  }

  /// Libre Caslon Display regular
  static Future<Font> libreCaslonDisplayRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/librecaslondisplay/v4/TuGOUUFxWphYQ6YI6q9Xp61FQzxDRKmzr2lRdRhtCC4d.ttf',
      'LibreCaslonDisplay-Regular',
    );
    return font.getFont();
  }

  /// Libre Caslon Text regular
  static Future<Font> libreCaslonTextRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/librecaslontext/v2/DdT878IGsGw1aF1JU10PUbTvNNaDMcq_3eNrHgO1.ttf',
      'LibreCaslonText-Regular',
    );
    return font.getFont();
  }

  /// Libre Caslon Text italic
  static Future<Font> libreCaslonTextItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/librecaslontext/v2/DdT678IGsGw1aF1JU10PUbTvNNaDMfq91-dJGxO1q9o.ttf',
      'LibreCaslonText-Italic',
    );
    return font.getFont();
  }

  /// Libre Caslon Text 700
  static Future<Font> libreCaslonTextBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/librecaslontext/v2/DdT578IGsGw1aF1JU10PUbTvNNaDMfID8sdjNR-8ssPt.ttf',
      'LibreCaslonText-Bold',
    );
    return font.getFont();
  }

  /// Libre Franklin 100
  static Future<Font> libreFranklinThin() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/librefranklin/v7/jizOREVItHgc8qDIbSTKq4XkRg8T88bjFuXOnduhLsSUB9rIb-JH1g.ttf',
      'LibreFranklin-Thin',
    );
    return font.getFont();
  }

  /// Libre Franklin 200
  static Future<Font> libreFranklinExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/librefranklin/v7/jizOREVItHgc8qDIbSTKq4XkRg8T88bjFuXOnduhrsWUB9rIb-JH1g.ttf',
      'LibreFranklin-ExtraLight',
    );
    return font.getFont();
  }

  /// Libre Franklin 300
  static Future<Font> libreFranklinLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/librefranklin/v7/jizOREVItHgc8qDIbSTKq4XkRg8T88bjFuXOnduhcMWUB9rIb-JH1g.ttf',
      'LibreFranklin-Light',
    );
    return font.getFont();
  }

  /// Libre Franklin regular
  static Future<Font> libreFranklinRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/librefranklin/v7/jizOREVItHgc8qDIbSTKq4XkRg8T88bjFuXOnduhLsWUB9rIb-JH1g.ttf',
      'LibreFranklin-Regular',
    );
    return font.getFont();
  }

  /// Libre Franklin 500
  static Future<Font> libreFranklinMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/librefranklin/v7/jizOREVItHgc8qDIbSTKq4XkRg8T88bjFuXOnduhHMWUB9rIb-JH1g.ttf',
      'LibreFranklin-Medium',
    );
    return font.getFont();
  }

  /// Libre Franklin 600
  static Future<Font> libreFranklinSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/librefranklin/v7/jizOREVItHgc8qDIbSTKq4XkRg8T88bjFuXOnduh8MKUB9rIb-JH1g.ttf',
      'LibreFranklin-SemiBold',
    );
    return font.getFont();
  }

  /// Libre Franklin 700
  static Future<Font> libreFranklinBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/librefranklin/v7/jizOREVItHgc8qDIbSTKq4XkRg8T88bjFuXOnduhycKUB9rIb-JH1g.ttf',
      'LibreFranklin-Bold',
    );
    return font.getFont();
  }

  /// Libre Franklin 800
  static Future<Font> libreFranklinExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/librefranklin/v7/jizOREVItHgc8qDIbSTKq4XkRg8T88bjFuXOnduhrsKUB9rIb-JH1g.ttf',
      'LibreFranklin-ExtraBold',
    );
    return font.getFont();
  }

  /// Libre Franklin 900
  static Future<Font> libreFranklinBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/librefranklin/v7/jizOREVItHgc8qDIbSTKq4XkRg8T88bjFuXOnduhh8KUB9rIb-JH1g.ttf',
      'LibreFranklin-Black',
    );
    return font.getFont();
  }

  /// Libre Franklin 100italic
  static Future<Font> libreFranklinThinItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/librefranklin/v7/jizMREVItHgc8qDIbSTKq4XkRiUawTk7f45UM9y05oZ8RdDMTedX1sGE.ttf',
      'LibreFranklin-ThinItalic',
    );
    return font.getFont();
  }

  /// Libre Franklin 200italic
  static Future<Font> libreFranklinExtraLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/librefranklin/v7/jizMREVItHgc8qDIbSTKq4XkRiUawTk7f45UM9y05ob8RNDMTedX1sGE.ttf',
      'LibreFranklin-ExtraLightItalic',
    );
    return font.getFont();
  }

  /// Libre Franklin 300italic
  static Future<Font> libreFranklinLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/librefranklin/v7/jizMREVItHgc8qDIbSTKq4XkRiUawTk7f45UM9y05oYiRNDMTedX1sGE.ttf',
      'LibreFranklin-LightItalic',
    );
    return font.getFont();
  }

  /// Libre Franklin italic
  static Future<Font> libreFranklinItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/librefranklin/v7/jizMREVItHgc8qDIbSTKq4XkRiUawTk7f45UM9y05oZ8RNDMTedX1sGE.ttf',
      'LibreFranklin-Italic',
    );
    return font.getFont();
  }

  /// Libre Franklin 500italic
  static Future<Font> libreFranklinMediumItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/librefranklin/v7/jizMREVItHgc8qDIbSTKq4XkRiUawTk7f45UM9y05oZORNDMTedX1sGE.ttf',
      'LibreFranklin-MediumItalic',
    );
    return font.getFont();
  }

  /// Libre Franklin 600italic
  static Future<Font> libreFranklinSemiBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/librefranklin/v7/jizMREVItHgc8qDIbSTKq4XkRiUawTk7f45UM9y05oaiQ9DMTedX1sGE.ttf',
      'LibreFranklin-SemiBoldItalic',
    );
    return font.getFont();
  }

  /// Libre Franklin 700italic
  static Future<Font> libreFranklinBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/librefranklin/v7/jizMREVItHgc8qDIbSTKq4XkRiUawTk7f45UM9y05oabQ9DMTedX1sGE.ttf',
      'LibreFranklin-BoldItalic',
    );
    return font.getFont();
  }

  /// Libre Franklin 800italic
  static Future<Font> libreFranklinExtraBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/librefranklin/v7/jizMREVItHgc8qDIbSTKq4XkRiUawTk7f45UM9y05ob8Q9DMTedX1sGE.ttf',
      'LibreFranklin-ExtraBoldItalic',
    );
    return font.getFont();
  }

  /// Libre Franklin 900italic
  static Future<Font> libreFranklinBlackItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/librefranklin/v7/jizMREVItHgc8qDIbSTKq4XkRiUawTk7f45UM9y05obVQ9DMTedX1sGE.ttf',
      'LibreFranklin-BlackItalic',
    );
    return font.getFont();
  }

  /// Life Savers regular
  static Future<Font> lifeSaversRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/lifesavers/v13/ZXuie1UftKKabUQMgxAal_lrFgpbuNvB.ttf',
      'LifeSavers-Regular',
    );
    return font.getFont();
  }

  /// Life Savers 700
  static Future<Font> lifeSaversBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/lifesavers/v13/ZXu_e1UftKKabUQMgxAal8HXOS5Tk8fIpPRW.ttf',
      'LifeSavers-Bold',
    );
    return font.getFont();
  }

  /// Life Savers 800
  static Future<Font> lifeSaversExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/lifesavers/v13/ZXu_e1UftKKabUQMgxAal8HLOi5Tk8fIpPRW.ttf',
      'LifeSavers-ExtraBold',
    );
    return font.getFont();
  }

  /// Lilita One regular
  static Future<Font> lilitaOneRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/lilitaone/v8/i7dPIFZ9Zz-WBtRtedDbUEZ2RFq7AwU.ttf',
      'LilitaOne-Regular',
    );
    return font.getFont();
  }

  /// Lily Script One regular
  static Future<Font> lilyScriptOneRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/lilyscriptone/v10/LhW9MV7ZMfIPdMxeBjBvFN8SXLS4gsSjQNsRMg.ttf',
      'LilyScriptOne-Regular',
    );
    return font.getFont();
  }

  /// Limelight regular
  static Future<Font> limelightRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/limelight/v11/XLYkIZL7aopJVbZJHDuYPeNGrnY2TA.ttf',
      'Limelight-Regular',
    );
    return font.getFont();
  }

  /// Linden Hill regular
  static Future<Font> lindenHillRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/lindenhill/v12/-F61fjxoKSg9Yc3hZgO8ygFI7CwC009k.ttf',
      'LindenHill-Regular',
    );
    return font.getFont();
  }

  /// Linden Hill italic
  static Future<Font> lindenHillItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/lindenhill/v12/-F63fjxoKSg9Yc3hZgO8yjFK5igg1l9kn-s.ttf',
      'LindenHill-Italic',
    );
    return font.getFont();
  }

  /// Literata 200
  static Future<Font> literataExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/literata/v23/or3PQ6P12-iJxAIgLa78DkrbXsDgk0oVDaDPYLanFLHpPf2TbJG_F_bcTWCWp8g.ttf',
      'Literata-ExtraLight',
    );
    return font.getFont();
  }

  /// Literata 300
  static Future<Font> literataLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/literata/v23/or3PQ6P12-iJxAIgLa78DkrbXsDgk0oVDaDPYLanFLHpPf2TbE-_F_bcTWCWp8g.ttf',
      'Literata-Light',
    );
    return font.getFont();
  }

  /// Literata regular
  static Future<Font> literataRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/literata/v23/or3PQ6P12-iJxAIgLa78DkrbXsDgk0oVDaDPYLanFLHpPf2TbBG_F_bcTWCWp8g.ttf',
      'Literata-Regular',
    );
    return font.getFont();
  }

  /// Literata 500
  static Future<Font> literataMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/literata/v23/or3PQ6P12-iJxAIgLa78DkrbXsDgk0oVDaDPYLanFLHpPf2TbCO_F_bcTWCWp8g.ttf',
      'Literata-Medium',
    );
    return font.getFont();
  }

  /// Literata 600
  static Future<Font> literataSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/literata/v23/or3PQ6P12-iJxAIgLa78DkrbXsDgk0oVDaDPYLanFLHpPf2TbM-4F_bcTWCWp8g.ttf',
      'Literata-SemiBold',
    );
    return font.getFont();
  }

  /// Literata 700
  static Future<Font> literataBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/literata/v23/or3PQ6P12-iJxAIgLa78DkrbXsDgk0oVDaDPYLanFLHpPf2TbPa4F_bcTWCWp8g.ttf',
      'Literata-Bold',
    );
    return font.getFont();
  }

  /// Literata 800
  static Future<Font> literataExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/literata/v23/or3PQ6P12-iJxAIgLa78DkrbXsDgk0oVDaDPYLanFLHpPf2TbJG4F_bcTWCWp8g.ttf',
      'Literata-ExtraBold',
    );
    return font.getFont();
  }

  /// Literata 900
  static Future<Font> literataBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/literata/v23/or3PQ6P12-iJxAIgLa78DkrbXsDgk0oVDaDPYLanFLHpPf2TbLi4F_bcTWCWp8g.ttf',
      'Literata-Black',
    );
    return font.getFont();
  }

  /// Literata 200italic
  static Future<Font> literataExtraLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/literata/v23/or3NQ6P12-iJxAIgLYT1PLs1Zd0nfUwAbeGVKoRYzNiCp1OUedn8f7XWSUKTt8iVow.ttf',
      'Literata-ExtraLightItalic',
    );
    return font.getFont();
  }

  /// Literata 300italic
  static Future<Font> literataLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/literata/v23/or3NQ6P12-iJxAIgLYT1PLs1Zd0nfUwAbeGVKoRYzNiCp1OUedn8obXWSUKTt8iVow.ttf',
      'Literata-LightItalic',
    );
    return font.getFont();
  }

  /// Literata italic
  static Future<Font> literataItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/literata/v23/or3NQ6P12-iJxAIgLYT1PLs1Zd0nfUwAbeGVKoRYzNiCp1OUedn8_7XWSUKTt8iVow.ttf',
      'Literata-Italic',
    );
    return font.getFont();
  }

  /// Literata 500italic
  static Future<Font> literataMediumItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/literata/v23/or3NQ6P12-iJxAIgLYT1PLs1Zd0nfUwAbeGVKoRYzNiCp1OUedn8zbXWSUKTt8iVow.ttf',
      'Literata-MediumItalic',
    );
    return font.getFont();
  }

  /// Literata 600italic
  static Future<Font> literataSemiBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/literata/v23/or3NQ6P12-iJxAIgLYT1PLs1Zd0nfUwAbeGVKoRYzNiCp1OUedn8IbLWSUKTt8iVow.ttf',
      'Literata-SemiBoldItalic',
    );
    return font.getFont();
  }

  /// Literata 700italic
  static Future<Font> literataBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/literata/v23/or3NQ6P12-iJxAIgLYT1PLs1Zd0nfUwAbeGVKoRYzNiCp1OUedn8GLLWSUKTt8iVow.ttf',
      'Literata-BoldItalic',
    );
    return font.getFont();
  }

  /// Literata 800italic
  static Future<Font> literataExtraBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/literata/v23/or3NQ6P12-iJxAIgLYT1PLs1Zd0nfUwAbeGVKoRYzNiCp1OUedn8f7LWSUKTt8iVow.ttf',
      'Literata-ExtraBoldItalic',
    );
    return font.getFont();
  }

  /// Literata 900italic
  static Future<Font> literataBlackItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/literata/v23/or3NQ6P12-iJxAIgLYT1PLs1Zd0nfUwAbeGVKoRYzNiCp1OUedn8VrLWSUKTt8iVow.ttf',
      'Literata-BlackItalic',
    );
    return font.getFont();
  }

  /// Liu Jian Mao Cao regular
  static Future<Font> liuJianMaoCaoRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/liujianmaocao/v7/845DNN84HJrccNonurqXILGpvCOoferVKGWsUo8.ttf',
      'LiuJianMaoCao-Regular',
    );
    return font.getFont();
  }

  /// Livvic 100
  static Future<Font> livvicThin() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/livvic/v8/rnCr-x1S2hzjrlffC-M-mHnOSOuk.ttf',
      'Livvic-Thin',
    );
    return font.getFont();
  }

  /// Livvic 100italic
  static Future<Font> livvicThinItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/livvic/v8/rnCt-x1S2hzjrlfXbdtakn3sTfukQHs.ttf',
      'Livvic-ThinItalic',
    );
    return font.getFont();
  }

  /// Livvic 200
  static Future<Font> livvicExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/livvic/v8/rnCq-x1S2hzjrlffp8IeslfCQfK9WQ.ttf',
      'Livvic-ExtraLight',
    );
    return font.getFont();
  }

  /// Livvic 200italic
  static Future<Font> livvicExtraLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/livvic/v8/rnCs-x1S2hzjrlfXbdv2s13GY_etWWIJ.ttf',
      'Livvic-ExtraLightItalic',
    );
    return font.getFont();
  }

  /// Livvic 300
  static Future<Font> livvicLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/livvic/v8/rnCq-x1S2hzjrlffw8EeslfCQfK9WQ.ttf',
      'Livvic-Light',
    );
    return font.getFont();
  }

  /// Livvic 300italic
  static Future<Font> livvicLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/livvic/v8/rnCs-x1S2hzjrlfXbduSsF3GY_etWWIJ.ttf',
      'Livvic-LightItalic',
    );
    return font.getFont();
  }

  /// Livvic regular
  static Future<Font> livvicRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/livvic/v8/rnCp-x1S2hzjrlfnb-k6unzeSA.ttf',
      'Livvic-Regular',
    );
    return font.getFont();
  }

  /// Livvic italic
  static Future<Font> livvicItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/livvic/v8/rnCr-x1S2hzjrlfXbeM-mHnOSOuk.ttf',
      'Livvic-Italic',
    );
    return font.getFont();
  }

  /// Livvic 500
  static Future<Font> livvicMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/livvic/v8/rnCq-x1S2hzjrlffm8AeslfCQfK9WQ.ttf',
      'Livvic-Medium',
    );
    return font.getFont();
  }

  /// Livvic 500italic
  static Future<Font> livvicMediumItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/livvic/v8/rnCs-x1S2hzjrlfXbdvKsV3GY_etWWIJ.ttf',
      'Livvic-MediumItalic',
    );
    return font.getFont();
  }

  /// Livvic 600
  static Future<Font> livvicSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/livvic/v8/rnCq-x1S2hzjrlfft8ceslfCQfK9WQ.ttf',
      'Livvic-SemiBold',
    );
    return font.getFont();
  }

  /// Livvic 600italic
  static Future<Font> livvicSemiBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/livvic/v8/rnCs-x1S2hzjrlfXbdvmtl3GY_etWWIJ.ttf',
      'Livvic-SemiBoldItalic',
    );
    return font.getFont();
  }

  /// Livvic 700
  static Future<Font> livvicBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/livvic/v8/rnCq-x1S2hzjrlff08YeslfCQfK9WQ.ttf',
      'Livvic-Bold',
    );
    return font.getFont();
  }

  /// Livvic 700italic
  static Future<Font> livvicBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/livvic/v8/rnCs-x1S2hzjrlfXbduCt13GY_etWWIJ.ttf',
      'Livvic-BoldItalic',
    );
    return font.getFont();
  }

  /// Livvic 900
  static Future<Font> livvicBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/livvic/v8/rnCq-x1S2hzjrlff68QeslfCQfK9WQ.ttf',
      'Livvic-Black',
    );
    return font.getFont();
  }

  /// Livvic 900italic
  static Future<Font> livvicBlackItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/livvic/v8/rnCs-x1S2hzjrlfXbdu6tV3GY_etWWIJ.ttf',
      'Livvic-BlackItalic',
    );
    return font.getFont();
  }

  /// Lobster regular
  static Future<Font> lobsterRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/lobster/v23/neILzCirqoswsqX9_oWsMqEzSJQ.ttf',
      'Lobster-Regular',
    );
    return font.getFont();
  }

  /// Lobster Two regular
  static Future<Font> lobsterTwoRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/lobstertwo/v13/BngMUXZGTXPUvIoyV6yN59fK7KSJ4ACD.ttf',
      'LobsterTwo-Regular',
    );
    return font.getFont();
  }

  /// Lobster Two italic
  static Future<Font> lobsterTwoItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/lobstertwo/v13/BngOUXZGTXPUvIoyV6yN5-fI5qCr5RCDY_k.ttf',
      'LobsterTwo-Italic',
    );
    return font.getFont();
  }

  /// Lobster Two 700
  static Future<Font> lobsterTwoBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/lobstertwo/v13/BngRUXZGTXPUvIoyV6yN5-92w4CByxyKeuDp.ttf',
      'LobsterTwo-Bold',
    );
    return font.getFont();
  }

  /// Lobster Two 700italic
  static Future<Font> lobsterTwoBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/lobstertwo/v13/BngTUXZGTXPUvIoyV6yN5-fI3hyEwRiof_DpXMY.ttf',
      'LobsterTwo-BoldItalic',
    );
    return font.getFont();
  }

  /// Londrina Outline regular
  static Future<Font> londrinaOutlineRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/londrinaoutline/v13/C8c44dM8vmb14dfsZxhetg3pDH-SfuoxrSKMDvI.ttf',
      'LondrinaOutline-Regular',
    );
    return font.getFont();
  }

  /// Londrina Shadow regular
  static Future<Font> londrinaShadowRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/londrinashadow/v12/oPWX_kB4kOQoWNJmjxLV5JuoCUlXRlaSxkrMCQ.ttf',
      'LondrinaShadow-Regular',
    );
    return font.getFont();
  }

  /// Londrina Sketch regular
  static Future<Font> londrinaSketchRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/londrinasketch/v11/c4m41npxGMTnomOHtRU68eIJn8qfWWn5Pos6CA.ttf',
      'LondrinaSketch-Regular',
    );
    return font.getFont();
  }

  /// Londrina Solid 100
  static Future<Font> londrinaSolidThin() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/londrinasolid/v10/flUjRq6sw40kQEJxWNgkLuudGfs9KBYesZHhV64.ttf',
      'LondrinaSolid-Thin',
    );
    return font.getFont();
  }

  /// Londrina Solid 300
  static Future<Font> londrinaSolidLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/londrinasolid/v10/flUiRq6sw40kQEJxWNgkLuudGfv1CjY0n53oTrcL.ttf',
      'LondrinaSolid-Light',
    );
    return font.getFont();
  }

  /// Londrina Solid regular
  static Future<Font> londrinaSolidRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/londrinasolid/v10/flUhRq6sw40kQEJxWNgkLuudGcNZIhI8tIHh.ttf',
      'LondrinaSolid-Regular',
    );
    return font.getFont();
  }

  /// Londrina Solid 900
  static Future<Font> londrinaSolidBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/londrinasolid/v10/flUiRq6sw40kQEJxWNgkLuudGfvdDzY0n53oTrcL.ttf',
      'LondrinaSolid-Black',
    );
    return font.getFont();
  }

  /// Long Cang regular
  static Future<Font> longCangRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/longcang/v7/LYjAdGP8kkgoTec8zkRgrXArXN7HWQ.ttf',
      'LongCang-Regular',
    );
    return font.getFont();
  }

  /// Lora regular
  static Future<Font> loraRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/lora/v17/0QI6MX1D_JOuGQbT0gvTJPa787weuyJGmKxemMeZ.ttf',
      'Lora-Regular',
    );
    return font.getFont();
  }

  /// Lora 500
  static Future<Font> loraMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/lora/v17/0QI6MX1D_JOuGQbT0gvTJPa787wsuyJGmKxemMeZ.ttf',
      'Lora-Medium',
    );
    return font.getFont();
  }

  /// Lora 600
  static Future<Font> loraSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/lora/v17/0QI6MX1D_JOuGQbT0gvTJPa787zAvCJGmKxemMeZ.ttf',
      'Lora-SemiBold',
    );
    return font.getFont();
  }

  /// Lora 700
  static Future<Font> loraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/lora/v17/0QI6MX1D_JOuGQbT0gvTJPa787z5vCJGmKxemMeZ.ttf',
      'Lora-Bold',
    );
    return font.getFont();
  }

  /// Lora italic
  static Future<Font> loraItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/lora/v17/0QI8MX1D_JOuMw_hLdO6T2wV9KnW-MoFkqh8ndeZzZ0.ttf',
      'Lora-Italic',
    );
    return font.getFont();
  }

  /// Lora 500italic
  static Future<Font> loraMediumItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/lora/v17/0QI8MX1D_JOuMw_hLdO6T2wV9KnW-PgFkqh8ndeZzZ0.ttf',
      'Lora-MediumItalic',
    );
    return font.getFont();
  }

  /// Lora 600italic
  static Future<Font> loraSemiBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/lora/v17/0QI8MX1D_JOuMw_hLdO6T2wV9KnW-BQCkqh8ndeZzZ0.ttf',
      'Lora-SemiBoldItalic',
    );
    return font.getFont();
  }

  /// Lora 700italic
  static Future<Font> loraBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/lora/v17/0QI8MX1D_JOuMw_hLdO6T2wV9KnW-C0Ckqh8ndeZzZ0.ttf',
      'Lora-BoldItalic',
    );
    return font.getFont();
  }

  /// Love Ya Like A Sister regular
  static Future<Font> loveYaLikeASisterRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/loveyalikeasister/v11/R70EjzUBlOqPeouhFDfR80-0FhOqJubN-Be78nZcsGGycA.ttf',
      'LoveYaLikeASister-Regular',
    );
    return font.getFont();
  }

  /// Loved by the King regular
  static Future<Font> lovedbytheKingRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/lovedbytheking/v12/Gw6gwdP76VDVJNXerebZxUMeRXUF2PiNlXFu2R64.ttf',
      'LovedbytheKing-Regular',
    );
    return font.getFont();
  }

  /// Lovers Quarrel regular
  static Future<Font> loversQuarrelRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/loversquarrel/v10/Yq6N-LSKXTL-5bCy8ksBzpQ_-zAsY7pO6siz.ttf',
      'LoversQuarrel-Regular',
    );
    return font.getFont();
  }

  /// Luckiest Guy regular
  static Future<Font> luckiestGuyRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/luckiestguy/v11/_gP_1RrxsjcxVyin9l9n_j2RStR3qDpraA.ttf',
      'LuckiestGuy-Regular',
    );
    return font.getFont();
  }

  /// Lusitana regular
  static Future<Font> lusitanaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/lusitana/v8/CSR84z9ShvucWzsMKxhaRuMiSct_.ttf',
      'Lusitana-Regular',
    );
    return font.getFont();
  }

  /// Lusitana 700
  static Future<Font> lusitanaBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/lusitana/v8/CSR74z9ShvucWzsMKyDmaccqYtd2vfwk.ttf',
      'Lusitana-Bold',
    );
    return font.getFont();
  }

  /// Lustria regular
  static Future<Font> lustriaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/lustria/v8/9oRONYodvDEyjuhOrCg5MtPyAcg.ttf',
      'Lustria-Regular',
    );
    return font.getFont();
  }

  /// M PLUS 1p 100
  static Future<Font> mPLUS1pThin() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/mplus1p/v19/e3tleuShHdiFyPFzBRrQnDQAUW3aq-5N.ttf',
      'MPLUS1p-Thin',
    );
    return font.getFont();
  }

  /// M PLUS 1p 300
  static Future<Font> mPLUS1pLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/mplus1p/v19/e3tmeuShHdiFyPFzBRrQVBYge0PWovdU4w.ttf',
      'MPLUS1p-Light',
    );
    return font.getFont();
  }

  /// M PLUS 1p regular
  static Future<Font> mPLUS1pRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/mplus1p/v19/e3tjeuShHdiFyPFzBRro-D4Ec2jKqw.ttf',
      'MPLUS1p-Regular',
    );
    return font.getFont();
  }

  /// M PLUS 1p 500
  static Future<Font> mPLUS1pMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/mplus1p/v19/e3tmeuShHdiFyPFzBRrQDBcge0PWovdU4w.ttf',
      'MPLUS1p-Medium',
    );
    return font.getFont();
  }

  /// M PLUS 1p 700
  static Future<Font> mPLUS1pBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/mplus1p/v19/e3tmeuShHdiFyPFzBRrQRBEge0PWovdU4w.ttf',
      'MPLUS1p-Bold',
    );
    return font.getFont();
  }

  /// M PLUS 1p 800
  static Future<Font> mPLUS1pExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/mplus1p/v19/e3tmeuShHdiFyPFzBRrQWBIge0PWovdU4w.ttf',
      'MPLUS1p-ExtraBold',
    );
    return font.getFont();
  }

  /// M PLUS 1p 900
  static Future<Font> mPLUS1pBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/mplus1p/v19/e3tmeuShHdiFyPFzBRrQfBMge0PWovdU4w.ttf',
      'MPLUS1p-Black',
    );
    return font.getFont();
  }

  /// M PLUS Rounded 1c 100
  static Future<Font> mPLUSRounded1cThin() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/mplusrounded1c/v10/VdGCAYIAV6gnpUpoWwNkYvrugw9RuM3ixLsg6-av1x0.ttf',
      'MPLUSRounded1c-Thin',
    );
    return font.getFont();
  }

  /// M PLUS Rounded 1c 300
  static Future<Font> mPLUSRounded1cLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/mplusrounded1c/v10/VdGBAYIAV6gnpUpoWwNkYvrugw9RuM0q5psKxeqmzgRK.ttf',
      'MPLUSRounded1c-Light',
    );
    return font.getFont();
  }

  /// M PLUS Rounded 1c regular
  static Future<Font> mPLUSRounded1cRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/mplusrounded1c/v10/VdGEAYIAV6gnpUpoWwNkYvrugw9RuPWGzr8C7vav.ttf',
      'MPLUSRounded1c-Regular',
    );
    return font.getFont();
  }

  /// M PLUS Rounded 1c 500
  static Future<Font> mPLUSRounded1cMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/mplusrounded1c/v10/VdGBAYIAV6gnpUpoWwNkYvrugw9RuM1y55sKxeqmzgRK.ttf',
      'MPLUSRounded1c-Medium',
    );
    return font.getFont();
  }

  /// M PLUS Rounded 1c 700
  static Future<Font> mPLUSRounded1cBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/mplusrounded1c/v10/VdGBAYIAV6gnpUpoWwNkYvrugw9RuM064ZsKxeqmzgRK.ttf',
      'MPLUSRounded1c-Bold',
    );
    return font.getFont();
  }

  /// M PLUS Rounded 1c 800
  static Future<Font> mPLUSRounded1cExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/mplusrounded1c/v10/VdGBAYIAV6gnpUpoWwNkYvrugw9RuM0m4psKxeqmzgRK.ttf',
      'MPLUSRounded1c-ExtraBold',
    );
    return font.getFont();
  }

  /// M PLUS Rounded 1c 900
  static Future<Font> mPLUSRounded1cBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/mplusrounded1c/v10/VdGBAYIAV6gnpUpoWwNkYvrugw9RuM0C45sKxeqmzgRK.ttf',
      'MPLUSRounded1c-Black',
    );
    return font.getFont();
  }

  /// Ma Shan Zheng regular
  static Future<Font> maShanZhengRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/mashanzheng/v5/NaPecZTRCLxvwo41b4gvzkXaRMTsDIRSfr0.ttf',
      'MaShanZheng-Regular',
    );
    return font.getFont();
  }

  /// Macondo regular
  static Future<Font> macondoRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/macondo/v11/RrQQboN9-iB1IXmOS2XO0LBBd4Y.ttf',
      'Macondo-Regular',
    );
    return font.getFont();
  }

  /// Macondo Swash Caps regular
  static Future<Font> macondoSwashCapsRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/macondoswashcaps/v10/6NUL8EaAJgGKZA7lpt941Z9s6ZYgDq6Oekoa_mm5bA.ttf',
      'MacondoSwashCaps-Regular',
    );
    return font.getFont();
  }

  /// Mada 200
  static Future<Font> madaExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/mada/v11/7Au_p_0qnzeSdf3nCCL8zkwMIFg.ttf',
      'Mada-ExtraLight',
    );
    return font.getFont();
  }

  /// Mada 300
  static Future<Font> madaLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/mada/v11/7Au_p_0qnzeSdZnkCCL8zkwMIFg.ttf',
      'Mada-Light',
    );
    return font.getFont();
  }

  /// Mada regular
  static Future<Font> madaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/mada/v11/7Auwp_0qnzeSTTXMLCrX0kU.ttf',
      'Mada-Regular',
    );
    return font.getFont();
  }

  /// Mada 500
  static Future<Font> madaMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/mada/v11/7Au_p_0qnzeSdcHlCCL8zkwMIFg.ttf',
      'Mada-Medium',
    );
    return font.getFont();
  }

  /// Mada 600
  static Future<Font> madaSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/mada/v11/7Au_p_0qnzeSde3iCCL8zkwMIFg.ttf',
      'Mada-SemiBold',
    );
    return font.getFont();
  }

  /// Mada 700
  static Future<Font> madaBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/mada/v11/7Au_p_0qnzeSdYnjCCL8zkwMIFg.ttf',
      'Mada-Bold',
    );
    return font.getFont();
  }

  /// Mada 900
  static Future<Font> madaBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/mada/v11/7Au_p_0qnzeSdbHhCCL8zkwMIFg.ttf',
      'Mada-Black',
    );
    return font.getFont();
  }

  /// Magra regular
  static Future<Font> magraRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/magra/v9/uK_94ruaZus72k5xIDMfO-ed.ttf',
      'Magra-Regular',
    );
    return font.getFont();
  }

  /// Magra 700
  static Future<Font> magraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/magra/v9/uK_w4ruaZus72nbNDxcXEPuUX1ow.ttf',
      'Magra-Bold',
    );
    return font.getFont();
  }

  /// Maiden Orange regular
  static Future<Font> maidenOrangeRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/maidenorange/v13/kJE1BuIX7AUmhi2V4m08kb1XjOZdCZS8FY8.ttf',
      'MaidenOrange-Regular',
    );
    return font.getFont();
  }

  /// Maitree 200
  static Future<Font> maitreeExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/maitree/v5/MjQDmil5tffhpBrklhGNWJGovLdh6OE.ttf',
      'Maitree-ExtraLight',
    );
    return font.getFont();
  }

  /// Maitree 300
  static Future<Font> maitreeLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/maitree/v5/MjQDmil5tffhpBrklnWOWJGovLdh6OE.ttf',
      'Maitree-Light',
    );
    return font.getFont();
  }

  /// Maitree regular
  static Future<Font> maitreeRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/maitree/v5/MjQGmil5tffhpBrkrtmmfJmDoL4.ttf',
      'Maitree-Regular',
    );
    return font.getFont();
  }

  /// Maitree 500
  static Future<Font> maitreeMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/maitree/v5/MjQDmil5tffhpBrkli2PWJGovLdh6OE.ttf',
      'Maitree-Medium',
    );
    return font.getFont();
  }

  /// Maitree 600
  static Future<Font> maitreeSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/maitree/v5/MjQDmil5tffhpBrklgGIWJGovLdh6OE.ttf',
      'Maitree-SemiBold',
    );
    return font.getFont();
  }

  /// Maitree 700
  static Future<Font> maitreeBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/maitree/v5/MjQDmil5tffhpBrklmWJWJGovLdh6OE.ttf',
      'Maitree-Bold',
    );
    return font.getFont();
  }

  /// Major Mono Display regular
  static Future<Font> majorMonoDisplayRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/majormonodisplay/v7/RWmVoLyb5fEqtsfBX9PDZIGr2tFubRhLCn2QIndPww.ttf',
      'MajorMonoDisplay-Regular',
    );
    return font.getFont();
  }

  /// Mako regular
  static Future<Font> makoRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/mako/v14/H4coBX6Mmc_Z0ST09g478Lo.ttf',
      'Mako-Regular',
    );
    return font.getFont();
  }

  /// Mali 200
  static Future<Font> maliExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/mali/v4/N0bV2SRONuN4QOLlKlRaJdbWgdY.ttf',
      'Mali-ExtraLight',
    );
    return font.getFont();
  }

  /// Mali 200italic
  static Future<Font> maliExtraLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/mali/v4/N0bX2SRONuN4SCj8wlVQIfTTkdbJYA.ttf',
      'Mali-ExtraLightItalic',
    );
    return font.getFont();
  }

  /// Mali 300
  static Future<Font> maliLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/mali/v4/N0bV2SRONuN4QIbmKlRaJdbWgdY.ttf',
      'Mali-Light',
    );
    return font.getFont();
  }

  /// Mali 300italic
  static Future<Font> maliLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/mali/v4/N0bX2SRONuN4SCj8plZQIfTTkdbJYA.ttf',
      'Mali-LightItalic',
    );
    return font.getFont();
  }

  /// Mali regular
  static Future<Font> maliRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/mali/v4/N0ba2SRONuN4eCrODlxxOd8.ttf',
      'Mali-Regular',
    );
    return font.getFont();
  }

  /// Mali italic
  static Future<Font> maliItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/mali/v4/N0bU2SRONuN4SCjECn50Kd_PmA.ttf',
      'Mali-Italic',
    );
    return font.getFont();
  }

  /// Mali 500
  static Future<Font> maliMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/mali/v4/N0bV2SRONuN4QN7nKlRaJdbWgdY.ttf',
      'Mali-Medium',
    );
    return font.getFont();
  }

  /// Mali 500italic
  static Future<Font> maliMediumItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/mali/v4/N0bX2SRONuN4SCj8_ldQIfTTkdbJYA.ttf',
      'Mali-MediumItalic',
    );
    return font.getFont();
  }

  /// Mali 600
  static Future<Font> maliSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/mali/v4/N0bV2SRONuN4QPLgKlRaJdbWgdY.ttf',
      'Mali-SemiBold',
    );
    return font.getFont();
  }

  /// Mali 600italic
  static Future<Font> maliSemiBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/mali/v4/N0bX2SRONuN4SCj80lBQIfTTkdbJYA.ttf',
      'Mali-SemiBoldItalic',
    );
    return font.getFont();
  }

  /// Mali 700
  static Future<Font> maliBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/mali/v4/N0bV2SRONuN4QJbhKlRaJdbWgdY.ttf',
      'Mali-Bold',
    );
    return font.getFont();
  }

  /// Mali 700italic
  static Future<Font> maliBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/mali/v4/N0bX2SRONuN4SCj8tlFQIfTTkdbJYA.ttf',
      'Mali-BoldItalic',
    );
    return font.getFont();
  }

  /// Mallanna regular
  static Future<Font> mallannaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/mallanna/v8/hv-Vlzx-KEQb84YaDGwzEzRwVvJ-.ttf',
      'Mallanna-Regular',
    );
    return font.getFont();
  }

  /// Mandali regular
  static Future<Font> mandaliRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/mandali/v9/LhWlMVbYOfASNfNUVFk1ZPdcKtA.ttf',
      'Mandali-Regular',
    );
    return font.getFont();
  }

  /// Manjari 100
  static Future<Font> manjariThin() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/manjari/v4/k3kSo8UPMOBO2w1UdbroK2vFIaOV8A.ttf',
      'Manjari-Thin',
    );
    return font.getFont();
  }

  /// Manjari regular
  static Future<Font> manjariRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/manjari/v4/k3kQo8UPMOBO2w1UTd7iL0nAMaM.ttf',
      'Manjari-Regular',
    );
    return font.getFont();
  }

  /// Manjari 700
  static Future<Font> manjariBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/manjari/v4/k3kVo8UPMOBO2w1UdWLNC0HrLaqM6Q4.ttf',
      'Manjari-Bold',
    );
    return font.getFont();
  }

  /// Manrope 200
  static Future<Font> manropeExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/manrope/v4/xn7_YHE41ni1AdIRqAuZuw1Bx9mbZk59FO_F87jxeN7B.ttf',
      'Manrope-ExtraLight',
    );
    return font.getFont();
  }

  /// Manrope 300
  static Future<Font> manropeLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/manrope/v4/xn7_YHE41ni1AdIRqAuZuw1Bx9mbZk6jFO_F87jxeN7B.ttf',
      'Manrope-Light',
    );
    return font.getFont();
  }

  /// Manrope regular
  static Future<Font> manropeRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/manrope/v4/xn7_YHE41ni1AdIRqAuZuw1Bx9mbZk79FO_F87jxeN7B.ttf',
      'Manrope-Regular',
    );
    return font.getFont();
  }

  /// Manrope 500
  static Future<Font> manropeMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/manrope/v4/xn7_YHE41ni1AdIRqAuZuw1Bx9mbZk7PFO_F87jxeN7B.ttf',
      'Manrope-Medium',
    );
    return font.getFont();
  }

  /// Manrope 600
  static Future<Font> manropeSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/manrope/v4/xn7_YHE41ni1AdIRqAuZuw1Bx9mbZk4jE-_F87jxeN7B.ttf',
      'Manrope-SemiBold',
    );
    return font.getFont();
  }

  /// Manrope 700
  static Future<Font> manropeBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/manrope/v4/xn7_YHE41ni1AdIRqAuZuw1Bx9mbZk4aE-_F87jxeN7B.ttf',
      'Manrope-Bold',
    );
    return font.getFont();
  }

  /// Manrope 800
  static Future<Font> manropeExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/manrope/v4/xn7_YHE41ni1AdIRqAuZuw1Bx9mbZk59E-_F87jxeN7B.ttf',
      'Manrope-ExtraBold',
    );
    return font.getFont();
  }

  /// Mansalva regular
  static Future<Font> mansalvaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/mansalva/v4/aWB4m0aacbtDfvq5NJllI47vdyBg.ttf',
      'Mansalva-Regular',
    );
    return font.getFont();
  }

  /// Manuale regular
  static Future<Font> manualeRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/manuale/v10/f0Xp0eas_8Z-TFZdHv3mMxFaSqASeeHke7wD1TB_JHHY.ttf',
      'Manuale-Regular',
    );
    return font.getFont();
  }

  /// Manuale 500
  static Future<Font> manualeMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/manuale/v10/f0Xp0eas_8Z-TFZdHv3mMxFaSqASeeHWe7wD1TB_JHHY.ttf',
      'Manuale-Medium',
    );
    return font.getFont();
  }

  /// Manuale 600
  static Future<Font> manualeSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/manuale/v10/f0Xp0eas_8Z-TFZdHv3mMxFaSqASeeE6fLwD1TB_JHHY.ttf',
      'Manuale-SemiBold',
    );
    return font.getFont();
  }

  /// Manuale 700
  static Future<Font> manualeBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/manuale/v10/f0Xp0eas_8Z-TFZdHv3mMxFaSqASeeEDfLwD1TB_JHHY.ttf',
      'Manuale-Bold',
    );
    return font.getFont();
  }

  /// Manuale italic
  static Future<Font> manualeItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/manuale/v10/f0Xn0eas_8Z-TFZdNPTUzMkzITq8fvQsOFRA3zRdIWHYr8M.ttf',
      'Manuale-Italic',
    );
    return font.getFont();
  }

  /// Manuale 500italic
  static Future<Font> manualeMediumItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/manuale/v10/f0Xn0eas_8Z-TFZdNPTUzMkzITq8fvQsOGZA3zRdIWHYr8M.ttf',
      'Manuale-MediumItalic',
    );
    return font.getFont();
  }

  /// Manuale 600italic
  static Future<Font> manualeSemiBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/manuale/v10/f0Xn0eas_8Z-TFZdNPTUzMkzITq8fvQsOIpH3zRdIWHYr8M.ttf',
      'Manuale-SemiBoldItalic',
    );
    return font.getFont();
  }

  /// Manuale 700italic
  static Future<Font> manualeBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/manuale/v10/f0Xn0eas_8Z-TFZdNPTUzMkzITq8fvQsOLNH3zRdIWHYr8M.ttf',
      'Manuale-BoldItalic',
    );
    return font.getFont();
  }

  /// Marcellus regular
  static Future<Font> marcellusRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/marcellus/v8/wEO_EBrOk8hQLDvIAF8FUfAL3EsHiA.ttf',
      'Marcellus-Regular',
    );
    return font.getFont();
  }

  /// Marcellus SC regular
  static Future<Font> marcellusSCRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/marcellussc/v8/ke8iOgUHP1dg-Rmi6RWjbLEPgdydGKikhA.ttf',
      'MarcellusSC-Regular',
    );
    return font.getFont();
  }

  /// Marck Script regular
  static Future<Font> marckScriptRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/marckscript/v11/nwpTtK2oNgBA3Or78gapdwuCzyI-aMPF7Q.ttf',
      'MarckScript-Regular',
    );
    return font.getFont();
  }

  /// Margarine regular
  static Future<Font> margarineRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/margarine/v11/qkBXXvoE6trLT9Y7YLye5JRLkAXbMQ.ttf',
      'Margarine-Regular',
    );
    return font.getFont();
  }

  /// Markazi Text regular
  static Future<Font> markaziTextRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/markazitext/v13/sykh-ydym6AtQaiEtX7yhqb_rV1k_81ZVYYZtfSQT4MlBekmJLo.ttf',
      'MarkaziText-Regular',
    );
    return font.getFont();
  }

  /// Markazi Text 500
  static Future<Font> markaziTextMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/markazitext/v13/sykh-ydym6AtQaiEtX7yhqb_rV1k_81ZVYYZtcaQT4MlBekmJLo.ttf',
      'MarkaziText-Medium',
    );
    return font.getFont();
  }

  /// Markazi Text 600
  static Future<Font> markaziTextSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/markazitext/v13/sykh-ydym6AtQaiEtX7yhqb_rV1k_81ZVYYZtSqXT4MlBekmJLo.ttf',
      'MarkaziText-SemiBold',
    );
    return font.getFont();
  }

  /// Markazi Text 700
  static Future<Font> markaziTextBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/markazitext/v13/sykh-ydym6AtQaiEtX7yhqb_rV1k_81ZVYYZtROXT4MlBekmJLo.ttf',
      'MarkaziText-Bold',
    );
    return font.getFont();
  }

  /// Marko One regular
  static Future<Font> markoOneRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/markoone/v12/9Btq3DFG0cnVM5lw1haaKpUfrHPzUw.ttf',
      'MarkoOne-Regular',
    );
    return font.getFont();
  }

  /// Marmelad regular
  static Future<Font> marmeladRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/marmelad/v10/Qw3eZQdSHj_jK2e-8tFLG-YMC0R8.ttf',
      'Marmelad-Regular',
    );
    return font.getFont();
  }

  /// Martel 200
  static Future<Font> martelExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/martel/v5/PN_yRfK9oXHga0XVqekahRbX9vnDzw.ttf',
      'Martel-ExtraLight',
    );
    return font.getFont();
  }

  /// Martel 300
  static Future<Font> martelLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/martel/v5/PN_yRfK9oXHga0XVzeoahRbX9vnDzw.ttf',
      'Martel-Light',
    );
    return font.getFont();
  }

  /// Martel regular
  static Future<Font> martelRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/martel/v5/PN_xRfK9oXHga0XtYcI-jT3L_w.ttf',
      'Martel-Regular',
    );
    return font.getFont();
  }

  /// Martel 600
  static Future<Font> martelSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/martel/v5/PN_yRfK9oXHga0XVuewahRbX9vnDzw.ttf',
      'Martel-SemiBold',
    );
    return font.getFont();
  }

  /// Martel 700
  static Future<Font> martelBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/martel/v5/PN_yRfK9oXHga0XV3e0ahRbX9vnDzw.ttf',
      'Martel-Bold',
    );
    return font.getFont();
  }

  /// Martel 800
  static Future<Font> martelExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/martel/v5/PN_yRfK9oXHga0XVwe4ahRbX9vnDzw.ttf',
      'Martel-ExtraBold',
    );
    return font.getFont();
  }

  /// Martel 900
  static Future<Font> martelBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/martel/v5/PN_yRfK9oXHga0XV5e8ahRbX9vnDzw.ttf',
      'Martel-Black',
    );
    return font.getFont();
  }

  /// Martel Sans 200
  static Future<Font> martelSansExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/martelsans/v7/h0GxssGi7VdzDgKjM-4d8hAX5suHFUknqMxQ.ttf',
      'MartelSans-ExtraLight',
    );
    return font.getFont();
  }

  /// Martel Sans 300
  static Future<Font> martelSansLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/martelsans/v7/h0GxssGi7VdzDgKjM-4d8hBz5cuHFUknqMxQ.ttf',
      'MartelSans-Light',
    );
    return font.getFont();
  }

  /// Martel Sans regular
  static Future<Font> martelSansRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/martelsans/v7/h0GsssGi7VdzDgKjM-4d8ijfze-PPlUu.ttf',
      'MartelSans-Regular',
    );
    return font.getFont();
  }

  /// Martel Sans 600
  static Future<Font> martelSansSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/martelsans/v7/h0GxssGi7VdzDgKjM-4d8hAH48uHFUknqMxQ.ttf',
      'MartelSans-SemiBold',
    );
    return font.getFont();
  }

  /// Martel Sans 700
  static Future<Font> martelSansBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/martelsans/v7/h0GxssGi7VdzDgKjM-4d8hBj4suHFUknqMxQ.ttf',
      'MartelSans-Bold',
    );
    return font.getFont();
  }

  /// Martel Sans 800
  static Future<Font> martelSansExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/martelsans/v7/h0GxssGi7VdzDgKjM-4d8hB_4cuHFUknqMxQ.ttf',
      'MartelSans-ExtraBold',
    );
    return font.getFont();
  }

  /// Martel Sans 900
  static Future<Font> martelSansBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/martelsans/v7/h0GxssGi7VdzDgKjM-4d8hBb4MuHFUknqMxQ.ttf',
      'MartelSans-Black',
    );
    return font.getFont();
  }

  /// Marvel regular
  static Future<Font> marvelRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/marvel/v10/nwpVtKeoNgBV0qaIkV7ED366zg.ttf',
      'Marvel-Regular',
    );
    return font.getFont();
  }

  /// Marvel italic
  static Future<Font> marvelItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/marvel/v10/nwpXtKeoNgBV0qa4k1TALXuqzhA7.ttf',
      'Marvel-Italic',
    );
    return font.getFont();
  }

  /// Marvel 700
  static Future<Font> marvelBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/marvel/v10/nwpWtKeoNgBV0qawLXHgB1WmxwkiYQ.ttf',
      'Marvel-Bold',
    );
    return font.getFont();
  }

  /// Marvel 700italic
  static Future<Font> marvelBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/marvel/v10/nwpQtKeoNgBV0qa4k2x8Al-i5QwyYdrc.ttf',
      'Marvel-BoldItalic',
    );
    return font.getFont();
  }

  /// Mate regular
  static Future<Font> mateRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/mate/v9/m8JdjftRd7WZ2z28WoXSaLU.ttf',
      'Mate-Regular',
    );
    return font.getFont();
  }

  /// Mate italic
  static Future<Font> mateItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/mate/v9/m8JTjftRd7WZ6z-2XqfXeLVdbw.ttf',
      'Mate-Italic',
    );
    return font.getFont();
  }

  /// Mate SC regular
  static Future<Font> mateSCRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/matesc/v11/-nF8OGQ1-uoVr2wKyiXZ95OkJwA.ttf',
      'MateSC-Regular',
    );
    return font.getFont();
  }

  /// Maven Pro regular
  static Future<Font> mavenProRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/mavenpro/v22/7Auup_AqnyWWAxW2Wk3swUz56MS91Eww8SX25nCpozp5GvU.ttf',
      'MavenPro-Regular',
    );
    return font.getFont();
  }

  /// Maven Pro 500
  static Future<Font> mavenProMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/mavenpro/v22/7Auup_AqnyWWAxW2Wk3swUz56MS91Eww8Rf25nCpozp5GvU.ttf',
      'MavenPro-Medium',
    );
    return font.getFont();
  }

  /// Maven Pro 600
  static Future<Font> mavenProSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/mavenpro/v22/7Auup_AqnyWWAxW2Wk3swUz56MS91Eww8fvx5nCpozp5GvU.ttf',
      'MavenPro-SemiBold',
    );
    return font.getFont();
  }

  /// Maven Pro 700
  static Future<Font> mavenProBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/mavenpro/v22/7Auup_AqnyWWAxW2Wk3swUz56MS91Eww8cLx5nCpozp5GvU.ttf',
      'MavenPro-Bold',
    );
    return font.getFont();
  }

  /// Maven Pro 800
  static Future<Font> mavenProExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/mavenpro/v22/7Auup_AqnyWWAxW2Wk3swUz56MS91Eww8aXx5nCpozp5GvU.ttf',
      'MavenPro-ExtraBold',
    );
    return font.getFont();
  }

  /// Maven Pro 900
  static Future<Font> mavenProBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/mavenpro/v22/7Auup_AqnyWWAxW2Wk3swUz56MS91Eww8Yzx5nCpozp5GvU.ttf',
      'MavenPro-Black',
    );
    return font.getFont();
  }

  /// McLaren regular
  static Future<Font> mcLarenRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/mclaren/v8/2EbnL-ZuAXFqZFXISYYf8z2Yt_c.ttf',
      'McLaren-Regular',
    );
    return font.getFont();
  }

  /// Meddon regular
  static Future<Font> meddonRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/meddon/v15/kmK8ZqA2EgDNeHTZhBdB3y_Aow.ttf',
      'Meddon-Regular',
    );
    return font.getFont();
  }

  /// MedievalSharp regular
  static Future<Font> medievalSharpRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/medievalsharp/v14/EvOJzAlL3oU5AQl2mP5KdgptAq96MwvXLDk.ttf',
      'MedievalSharp-Regular',
    );
    return font.getFont();
  }

  /// Medula One regular
  static Future<Font> medulaOneRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/medulaone/v12/YA9Wr0qb5kjJM6l2V0yukiEqs7GtlvY.ttf',
      'MedulaOne-Regular',
    );
    return font.getFont();
  }

  /// Meera Inimai regular
  static Future<Font> meeraInimaiRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/meerainimai/v7/845fNMM5EIqOW5MPuvO3ILep_2jDVevnLQ.ttf',
      'MeeraInimai-Regular',
    );
    return font.getFont();
  }

  /// Megrim regular
  static Future<Font> megrimRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/megrim/v11/46kulbz5WjvLqJZlbWXgd0RY1g.ttf',
      'Megrim-Regular',
    );
    return font.getFont();
  }

  /// Meie Script regular
  static Future<Font> meieScriptRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/meiescript/v10/_LOImzDK7erRjhunIspaMjxn5IXg0WDz.ttf',
      'MeieScript-Regular',
    );
    return font.getFont();
  }

  /// Merienda regular
  static Future<Font> meriendaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/merienda/v9/gNMHW3x8Qoy5_mf8uVMCOou6_dvg.ttf',
      'Merienda-Regular',
    );
    return font.getFont();
  }

  /// Merienda 700
  static Future<Font> meriendaBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/merienda/v9/gNMAW3x8Qoy5_mf8uWu-Fa-y1sfpPES4.ttf',
      'Merienda-Bold',
    );
    return font.getFont();
  }

  /// Merienda One regular
  static Future<Font> meriendaOneRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/meriendaone/v11/H4cgBXaMndbflEq6kyZ1ht6YgoyyYzFzFw.ttf',
      'MeriendaOne-Regular',
    );
    return font.getFont();
  }

  /// Merriweather 300
  static Future<Font> merriweatherLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/merriweather/v22/u-4n0qyriQwlOrhSvowK_l521wRpX837pvjxPA.ttf',
      'Merriweather-Light',
    );
    return font.getFont();
  }

  /// Merriweather 300italic
  static Future<Font> merriweatherLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/merriweather/v22/u-4l0qyriQwlOrhSvowK_l5-eR7lXcf_hP3hPGWH.ttf',
      'Merriweather-LightItalic',
    );
    return font.getFont();
  }

  /// Merriweather regular
  static Future<Font> merriweatherRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/merriweather/v22/u-440qyriQwlOrhSvowK_l5OeyxNV-bnrw.ttf',
      'Merriweather-Regular',
    );
    return font.getFont();
  }

  /// Merriweather italic
  static Future<Font> merriweatherItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/merriweather/v22/u-4m0qyriQwlOrhSvowK_l5-eSZJdeP3r-Ho.ttf',
      'Merriweather-Italic',
    );
    return font.getFont();
  }

  /// Merriweather 700
  static Future<Font> merriweatherBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/merriweather/v22/u-4n0qyriQwlOrhSvowK_l52xwNpX837pvjxPA.ttf',
      'Merriweather-Bold',
    );
    return font.getFont();
  }

  /// Merriweather 700italic
  static Future<Font> merriweatherBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/merriweather/v22/u-4l0qyriQwlOrhSvowK_l5-eR71Wsf_hP3hPGWH.ttf',
      'Merriweather-BoldItalic',
    );
    return font.getFont();
  }

  /// Merriweather 900
  static Future<Font> merriweatherBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/merriweather/v22/u-4n0qyriQwlOrhSvowK_l52_wFpX837pvjxPA.ttf',
      'Merriweather-Black',
    );
    return font.getFont();
  }

  /// Merriweather 900italic
  static Future<Font> merriweatherBlackItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/merriweather/v22/u-4l0qyriQwlOrhSvowK_l5-eR7NWMf_hP3hPGWH.ttf',
      'Merriweather-BlackItalic',
    );
    return font.getFont();
  }

  /// Merriweather Sans 300
  static Future<Font> merriweatherSansLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/merriweathersans/v14/2-cO9IRs1JiJN1FRAMjTN5zd9vgsFF_5asQTb6hZ2JKZ_O4ljuEG7xFHnQ.ttf',
      'MerriweatherSans-Light',
    );
    return font.getFont();
  }

  /// Merriweather Sans regular
  static Future<Font> merriweatherSansRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/merriweathersans/v14/2-cO9IRs1JiJN1FRAMjTN5zd9vgsFF_5asQTb6hZ2JKZou4ljuEG7xFHnQ.ttf',
      'MerriweatherSans-Regular',
    );
    return font.getFont();
  }

  /// Merriweather Sans 500
  static Future<Font> merriweatherSansMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/merriweathersans/v14/2-cO9IRs1JiJN1FRAMjTN5zd9vgsFF_5asQTb6hZ2JKZkO4ljuEG7xFHnQ.ttf',
      'MerriweatherSans-Medium',
    );
    return font.getFont();
  }

  /// Merriweather Sans 600
  static Future<Font> merriweatherSansSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/merriweathersans/v14/2-cO9IRs1JiJN1FRAMjTN5zd9vgsFF_5asQTb6hZ2JKZfOkljuEG7xFHnQ.ttf',
      'MerriweatherSans-SemiBold',
    );
    return font.getFont();
  }

  /// Merriweather Sans 700
  static Future<Font> merriweatherSansBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/merriweathersans/v14/2-cO9IRs1JiJN1FRAMjTN5zd9vgsFF_5asQTb6hZ2JKZRekljuEG7xFHnQ.ttf',
      'MerriweatherSans-Bold',
    );
    return font.getFont();
  }

  /// Merriweather Sans 800
  static Future<Font> merriweatherSansExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/merriweathersans/v14/2-cO9IRs1JiJN1FRAMjTN5zd9vgsFF_5asQTb6hZ2JKZIukljuEG7xFHnQ.ttf',
      'MerriweatherSans-ExtraBold',
    );
    return font.getFont();
  }

  /// Merriweather Sans 300italic
  static Future<Font> merriweatherSansLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/merriweathersans/v14/2-cM9IRs1JiJN1FRAMjTN5zd9vgsFHXwWDvLBsPDdpWMaq2TzesCzRRXnaur.ttf',
      'MerriweatherSans-LightItalic',
    );
    return font.getFont();
  }

  /// Merriweather Sans italic
  static Future<Font> merriweatherSansItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/merriweathersans/v14/2-cM9IRs1JiJN1FRAMjTN5zd9vgsFHXwWDvLBsPDdpWMaq3NzesCzRRXnaur.ttf',
      'MerriweatherSans-Italic',
    );
    return font.getFont();
  }

  /// Merriweather Sans 500italic
  static Future<Font> merriweatherSansMediumItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/merriweathersans/v14/2-cM9IRs1JiJN1FRAMjTN5zd9vgsFHXwWDvLBsPDdpWMaq3_zesCzRRXnaur.ttf',
      'MerriweatherSans-MediumItalic',
    );
    return font.getFont();
  }

  /// Merriweather Sans 600italic
  static Future<Font> merriweatherSansSemiBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/merriweathersans/v14/2-cM9IRs1JiJN1FRAMjTN5zd9vgsFHXwWDvLBsPDdpWMaq0TyusCzRRXnaur.ttf',
      'MerriweatherSans-SemiBoldItalic',
    );
    return font.getFont();
  }

  /// Merriweather Sans 700italic
  static Future<Font> merriweatherSansBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/merriweathersans/v14/2-cM9IRs1JiJN1FRAMjTN5zd9vgsFHXwWDvLBsPDdpWMaq0qyusCzRRXnaur.ttf',
      'MerriweatherSans-BoldItalic',
    );
    return font.getFont();
  }

  /// Merriweather Sans 800italic
  static Future<Font> merriweatherSansExtraBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/merriweathersans/v14/2-cM9IRs1JiJN1FRAMjTN5zd9vgsFHXwWDvLBsPDdpWMaq1NyusCzRRXnaur.ttf',
      'MerriweatherSans-ExtraBoldItalic',
    );
    return font.getFont();
  }

  /// Metal regular
  static Future<Font> metalRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/metal/v15/lW-wwjUJIXTo7i3nnoQAUdN2.ttf',
      'Metal-Regular',
    );
    return font.getFont();
  }

  /// Metal Mania regular
  static Future<Font> metalManiaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/metalmania/v12/RWmMoKWb4e8kqMfBUdPFJeXCg6UKDXlq.ttf',
      'MetalMania-Regular',
    );
    return font.getFont();
  }

  /// Metamorphous regular
  static Future<Font> metamorphousRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/metamorphous/v13/Wnz8HA03aAXcC39ZEX5y1330PCCthTsmaQ.ttf',
      'Metamorphous-Regular',
    );
    return font.getFont();
  }

  /// Metrophobic regular
  static Future<Font> metrophobicRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/metrophobic/v14/sJoA3LZUhMSAPV_u0qwiAT-J737FPEEL.ttf',
      'Metrophobic-Regular',
    );
    return font.getFont();
  }

  /// Michroma regular
  static Future<Font> michromaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/michroma/v11/PN_zRfy9qWD8fEagAMg6rzjb_-Da.ttf',
      'Michroma-Regular',
    );
    return font.getFont();
  }

  /// Milonga regular
  static Future<Font> milongaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/milonga/v10/SZc53FHnIaK9W5kffz3GkUrS8DI.ttf',
      'Milonga-Regular',
    );
    return font.getFont();
  }

  /// Miltonian regular
  static Future<Font> miltonianRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/miltonian/v16/zOL-4pbPn6Ne9JqTg9mr6e5As-FeiQ.ttf',
      'Miltonian-Regular',
    );
    return font.getFont();
  }

  /// Miltonian Tattoo regular
  static Future<Font> miltonianTattooRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/miltoniantattoo/v18/EvOUzBRL0o0kCxF-lcMCQxlpVsA_FwP8MDBku-s.ttf',
      'MiltonianTattoo-Regular',
    );
    return font.getFont();
  }

  /// Mina regular
  static Future<Font> minaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/mina/v6/-nFzOGc18vARrz9j7i3y65o.ttf',
      'Mina-Regular',
    );
    return font.getFont();
  }

  /// Mina 700
  static Future<Font> minaBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/mina/v6/-nF8OGc18vARl4NMyiXZ95OkJwA.ttf',
      'Mina-Bold',
    );
    return font.getFont();
  }

  /// Miniver regular
  static Future<Font> miniverRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/miniver/v11/eLGcP-PxIg-5H0vC770Cy8r8fWA.ttf',
      'Miniver-Regular',
    );
    return font.getFont();
  }

  /// Miriam Libre regular
  static Future<Font> miriamLibreRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/miriamlibre/v7/DdTh798HsHwubBAqfkcBTL_vYJn_Teun9g.ttf',
      'MiriamLibre-Regular',
    );
    return font.getFont();
  }

  /// Miriam Libre 700
  static Future<Font> miriamLibreBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/miriamlibre/v7/DdT-798HsHwubBAqfkcBTL_X3LbbRcC7_-Z7Hg.ttf',
      'MiriamLibre-Bold',
    );
    return font.getFont();
  }

  /// Mirza regular
  static Future<Font> mirzaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/mirza/v10/co3ImWlikiN5EurdKMewsrvI.ttf',
      'Mirza-Regular',
    );
    return font.getFont();
  }

  /// Mirza 500
  static Future<Font> mirzaMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/mirza/v10/co3FmWlikiN5EtIpAeO4mafBomDi.ttf',
      'Mirza-Medium',
    );
    return font.getFont();
  }

  /// Mirza 600
  static Future<Font> mirzaSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/mirza/v10/co3FmWlikiN5EtIFBuO4mafBomDi.ttf',
      'Mirza-SemiBold',
    );
    return font.getFont();
  }

  /// Mirza 700
  static Future<Font> mirzaBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/mirza/v10/co3FmWlikiN5EtJhB-O4mafBomDi.ttf',
      'Mirza-Bold',
    );
    return font.getFont();
  }

  /// Miss Fajardose regular
  static Future<Font> missFajardoseRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/missfajardose/v12/E21-_dn5gvrawDdPFVl-N0Ajb8qvWPaJq4no.ttf',
      'MissFajardose-Regular',
    );
    return font.getFont();
  }

  /// Mitr 200
  static Future<Font> mitrExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/mitr/v6/pxiEypw5ucZF8fMZFJDUc1NECPY.ttf',
      'Mitr-ExtraLight',
    );
    return font.getFont();
  }

  /// Mitr 300
  static Future<Font> mitrLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/mitr/v6/pxiEypw5ucZF8ZcaFJDUc1NECPY.ttf',
      'Mitr-Light',
    );
    return font.getFont();
  }

  /// Mitr regular
  static Future<Font> mitrRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/mitr/v6/pxiLypw5ucZFyTsyMJj_b1o.ttf',
      'Mitr-Regular',
    );
    return font.getFont();
  }

  /// Mitr 500
  static Future<Font> mitrMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/mitr/v6/pxiEypw5ucZF8c8bFJDUc1NECPY.ttf',
      'Mitr-Medium',
    );
    return font.getFont();
  }

  /// Mitr 600
  static Future<Font> mitrSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/mitr/v6/pxiEypw5ucZF8eMcFJDUc1NECPY.ttf',
      'Mitr-SemiBold',
    );
    return font.getFont();
  }

  /// Mitr 700
  static Future<Font> mitrBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/mitr/v6/pxiEypw5ucZF8YcdFJDUc1NECPY.ttf',
      'Mitr-Bold',
    );
    return font.getFont();
  }

  /// Modak regular
  static Future<Font> modakRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/modak/v8/EJRYQgs1XtIEsnMH8BVZ76KU.ttf',
      'Modak-Regular',
    );
    return font.getFont();
  }

  /// Modern Antiqua regular
  static Future<Font> modernAntiquaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/modernantiqua/v12/NGStv5TIAUg6Iq_RLNo_2dp1sI1Ea2u0c3Gi.ttf',
      'ModernAntiqua-Regular',
    );
    return font.getFont();
  }

  /// Mogra regular
  static Future<Font> mograRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/mogra/v9/f0X40eSs8c95TBo4DvLmxtnG.ttf',
      'Mogra-Regular',
    );
    return font.getFont();
  }

  /// Molengo regular
  static Future<Font> molengoRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/molengo/v11/I_uuMpWeuBzZNBtQbbRQkiCvs5Y.ttf',
      'Molengo-Regular',
    );
    return font.getFont();
  }

  /// Molle italic
  static Future<Font> molleItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/molle/v11/E21n_dL5hOXFhWEsXzgmVydREus.ttf',
      'Molle-Italic',
    );
    return font.getFont();
  }

  /// Monda regular
  static Future<Font> mondaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/monda/v11/TK3tWkYFABsmjvpmNBsLvPdG.ttf',
      'Monda-Regular',
    );
    return font.getFont();
  }

  /// Monda 700
  static Future<Font> mondaBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/monda/v11/TK3gWkYFABsmjsLaGz8Dl-tPKo2t.ttf',
      'Monda-Bold',
    );
    return font.getFont();
  }

  /// Monofett regular
  static Future<Font> monofettRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/monofett/v12/mFTyWbofw6zc9NtnW43SuRwr0VJ7.ttf',
      'Monofett-Regular',
    );
    return font.getFont();
  }

  /// Monoton regular
  static Future<Font> monotonRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/monoton/v10/5h1aiZUrOngCibe4fkbBQ2S7FU8.ttf',
      'Monoton-Regular',
    );
    return font.getFont();
  }

  /// Monsieur La Doulaise regular
  static Future<Font> monsieurLaDoulaiseRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/monsieurladoulaise/v9/_Xmz-GY4rjmCbQfc-aPRaa4pqV340p7EZl5ewkEU4HTy.ttf',
      'MonsieurLaDoulaise-Regular',
    );
    return font.getFont();
  }

  /// Montaga regular
  static Future<Font> montagaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/montaga/v8/H4cnBX2Ml8rCkEO_0gYQ7LO5mqc.ttf',
      'Montaga-Regular',
    );
    return font.getFont();
  }

  /// Montez regular
  static Future<Font> montezRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/montez/v11/845ZNMk5GoGIX8lm1LDeSd-R_g.ttf',
      'Montez-Regular',
    );
    return font.getFont();
  }

  /// Montserrat 100
  static Future<Font> montserratThin() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/montserrat/v15/JTUQjIg1_i6t8kCHKm45_QphziTn89dtpQ.ttf',
      'Montserrat-Thin',
    );
    return font.getFont();
  }

  /// Montserrat 100italic
  static Future<Font> montserratThinItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/montserrat/v15/JTUOjIg1_i6t8kCHKm459WxZqi7j0dJ9pTOi.ttf',
      'Montserrat-ThinItalic',
    );
    return font.getFont();
  }

  /// Montserrat 200
  static Future<Font> montserratExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/montserrat/v15/JTURjIg1_i6t8kCHKm45_aZA7g7J_950vCo.ttf',
      'Montserrat-ExtraLight',
    );
    return font.getFont();
  }

  /// Montserrat 200italic
  static Future<Font> montserratExtraLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/montserrat/v15/JTUPjIg1_i6t8kCHKm459WxZBg_D-_xxrCq7qg.ttf',
      'Montserrat-ExtraLightItalic',
    );
    return font.getFont();
  }

  /// Montserrat 300
  static Future<Font> montserratLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/montserrat/v15/JTURjIg1_i6t8kCHKm45_cJD7g7J_950vCo.ttf',
      'Montserrat-Light',
    );
    return font.getFont();
  }

  /// Montserrat 300italic
  static Future<Font> montserratLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/montserrat/v15/JTUPjIg1_i6t8kCHKm459WxZYgzD-_xxrCq7qg.ttf',
      'Montserrat-LightItalic',
    );
    return font.getFont();
  }

  /// Montserrat regular
  static Future<Font> montserratRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/montserrat/v15/JTUSjIg1_i6t8kCHKm45xW5rygbi49c.ttf',
      'Montserrat-Regular',
    );
    return font.getFont();
  }

  /// Montserrat italic
  static Future<Font> montserratItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/montserrat/v15/JTUQjIg1_i6t8kCHKm459WxhziTn89dtpQ.ttf',
      'Montserrat-Italic',
    );
    return font.getFont();
  }

  /// Montserrat 500
  static Future<Font> montserratMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/montserrat/v15/JTURjIg1_i6t8kCHKm45_ZpC7g7J_950vCo.ttf',
      'Montserrat-Medium',
    );
    return font.getFont();
  }

  /// Montserrat 500italic
  static Future<Font> montserratMediumItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/montserrat/v15/JTUPjIg1_i6t8kCHKm459WxZOg3D-_xxrCq7qg.ttf',
      'Montserrat-MediumItalic',
    );
    return font.getFont();
  }

  /// Montserrat 600
  static Future<Font> montserratSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/montserrat/v15/JTURjIg1_i6t8kCHKm45_bZF7g7J_950vCo.ttf',
      'Montserrat-SemiBold',
    );
    return font.getFont();
  }

  /// Montserrat 600italic
  static Future<Font> montserratSemiBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/montserrat/v15/JTUPjIg1_i6t8kCHKm459WxZFgrD-_xxrCq7qg.ttf',
      'Montserrat-SemiBoldItalic',
    );
    return font.getFont();
  }

  /// Montserrat 700
  static Future<Font> montserratBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/montserrat/v15/JTURjIg1_i6t8kCHKm45_dJE7g7J_950vCo.ttf',
      'Montserrat-Bold',
    );
    return font.getFont();
  }

  /// Montserrat 700italic
  static Future<Font> montserratBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/montserrat/v15/JTUPjIg1_i6t8kCHKm459WxZcgvD-_xxrCq7qg.ttf',
      'Montserrat-BoldItalic',
    );
    return font.getFont();
  }

  /// Montserrat 800
  static Future<Font> montserratExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/montserrat/v15/JTURjIg1_i6t8kCHKm45_c5H7g7J_950vCo.ttf',
      'Montserrat-ExtraBold',
    );
    return font.getFont();
  }

  /// Montserrat 800italic
  static Future<Font> montserratExtraBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/montserrat/v15/JTUPjIg1_i6t8kCHKm459WxZbgjD-_xxrCq7qg.ttf',
      'Montserrat-ExtraBoldItalic',
    );
    return font.getFont();
  }

  /// Montserrat 900
  static Future<Font> montserratBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/montserrat/v15/JTURjIg1_i6t8kCHKm45_epG7g7J_950vCo.ttf',
      'Montserrat-Black',
    );
    return font.getFont();
  }

  /// Montserrat 900italic
  static Future<Font> montserratBlackItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/montserrat/v15/JTUPjIg1_i6t8kCHKm459WxZSgnD-_xxrCq7qg.ttf',
      'Montserrat-BlackItalic',
    );
    return font.getFont();
  }

  /// Montserrat Alternates 100
  static Future<Font> montserratAlternatesThin() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/montserratalternates/v12/mFThWacfw6zH4dthXcyms1lPpC8I_b0juU0xiKfVKphL03l4.ttf',
      'MontserratAlternates-Thin',
    );
    return font.getFont();
  }

  /// Montserrat Alternates 100italic
  static Future<Font> montserratAlternatesThinItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/montserratalternates/v12/mFTjWacfw6zH4dthXcyms1lPpC8I_b0juU057p-xIJxp1ml4imo.ttf',
      'MontserratAlternates-ThinItalic',
    );
    return font.getFont();
  }

  /// Montserrat Alternates 200
  static Future<Font> montserratAlternatesExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/montserratalternates/v12/mFTiWacfw6zH4dthXcyms1lPpC8I_b0juU0xJIb1ALZH2mBhkw.ttf',
      'MontserratAlternates-ExtraLight',
    );
    return font.getFont();
  }

  /// Montserrat Alternates 200italic
  static Future<Font> montserratAlternatesExtraLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/montserratalternates/v12/mFTkWacfw6zH4dthXcyms1lPpC8I_b0juU057p8dAbxD-GVxk3Nd.ttf',
      'MontserratAlternates-ExtraLightItalic',
    );
    return font.getFont();
  }

  /// Montserrat Alternates 300
  static Future<Font> montserratAlternatesLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/montserratalternates/v12/mFTiWacfw6zH4dthXcyms1lPpC8I_b0juU0xQIX1ALZH2mBhkw.ttf',
      'MontserratAlternates-Light',
    );
    return font.getFont();
  }

  /// Montserrat Alternates 300italic
  static Future<Font> montserratAlternatesLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/montserratalternates/v12/mFTkWacfw6zH4dthXcyms1lPpC8I_b0juU057p95ArxD-GVxk3Nd.ttf',
      'MontserratAlternates-LightItalic',
    );
    return font.getFont();
  }

  /// Montserrat Alternates regular
  static Future<Font> montserratAlternatesRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/montserratalternates/v12/mFTvWacfw6zH4dthXcyms1lPpC8I_b0juU0J7K3RCJ1b0w.ttf',
      'MontserratAlternates-Regular',
    );
    return font.getFont();
  }

  /// Montserrat Alternates italic
  static Future<Font> montserratAlternatesItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/montserratalternates/v12/mFThWacfw6zH4dthXcyms1lPpC8I_b0juU057qfVKphL03l4.ttf',
      'MontserratAlternates-Italic',
    );
    return font.getFont();
  }

  /// Montserrat Alternates 500
  static Future<Font> montserratAlternatesMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/montserratalternates/v12/mFTiWacfw6zH4dthXcyms1lPpC8I_b0juU0xGIT1ALZH2mBhkw.ttf',
      'MontserratAlternates-Medium',
    );
    return font.getFont();
  }

  /// Montserrat Alternates 500italic
  static Future<Font> montserratAlternatesMediumItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/montserratalternates/v12/mFTkWacfw6zH4dthXcyms1lPpC8I_b0juU057p8hA7xD-GVxk3Nd.ttf',
      'MontserratAlternates-MediumItalic',
    );
    return font.getFont();
  }

  /// Montserrat Alternates 600
  static Future<Font> montserratAlternatesSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/montserratalternates/v12/mFTiWacfw6zH4dthXcyms1lPpC8I_b0juU0xNIP1ALZH2mBhkw.ttf',
      'MontserratAlternates-SemiBold',
    );
    return font.getFont();
  }

  /// Montserrat Alternates 600italic
  static Future<Font> montserratAlternatesSemiBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/montserratalternates/v12/mFTkWacfw6zH4dthXcyms1lPpC8I_b0juU057p8NBLxD-GVxk3Nd.ttf',
      'MontserratAlternates-SemiBoldItalic',
    );
    return font.getFont();
  }

  /// Montserrat Alternates 700
  static Future<Font> montserratAlternatesBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/montserratalternates/v12/mFTiWacfw6zH4dthXcyms1lPpC8I_b0juU0xUIL1ALZH2mBhkw.ttf',
      'MontserratAlternates-Bold',
    );
    return font.getFont();
  }

  /// Montserrat Alternates 700italic
  static Future<Font> montserratAlternatesBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/montserratalternates/v12/mFTkWacfw6zH4dthXcyms1lPpC8I_b0juU057p9pBbxD-GVxk3Nd.ttf',
      'MontserratAlternates-BoldItalic',
    );
    return font.getFont();
  }

  /// Montserrat Alternates 800
  static Future<Font> montserratAlternatesExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/montserratalternates/v12/mFTiWacfw6zH4dthXcyms1lPpC8I_b0juU0xTIH1ALZH2mBhkw.ttf',
      'MontserratAlternates-ExtraBold',
    );
    return font.getFont();
  }

  /// Montserrat Alternates 800italic
  static Future<Font> montserratAlternatesExtraBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/montserratalternates/v12/mFTkWacfw6zH4dthXcyms1lPpC8I_b0juU057p91BrxD-GVxk3Nd.ttf',
      'MontserratAlternates-ExtraBoldItalic',
    );
    return font.getFont();
  }

  /// Montserrat Alternates 900
  static Future<Font> montserratAlternatesBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/montserratalternates/v12/mFTiWacfw6zH4dthXcyms1lPpC8I_b0juU0xaID1ALZH2mBhkw.ttf',
      'MontserratAlternates-Black',
    );
    return font.getFont();
  }

  /// Montserrat Alternates 900italic
  static Future<Font> montserratAlternatesBlackItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/montserratalternates/v12/mFTkWacfw6zH4dthXcyms1lPpC8I_b0juU057p9RB7xD-GVxk3Nd.ttf',
      'MontserratAlternates-BlackItalic',
    );
    return font.getFont();
  }

  /// Montserrat Subrayada regular
  static Future<Font> montserratSubrayadaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/montserratsubrayada/v12/U9MD6c-o9H7PgjlTHThBnNHGVUORwteQQE8LYuceqGT-.ttf',
      'MontserratSubrayada-Regular',
    );
    return font.getFont();
  }

  /// Montserrat Subrayada 700
  static Future<Font> montserratSubrayadaBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/montserratsubrayada/v12/U9MM6c-o9H7PgjlTHThBnNHGVUORwteQQHe3TcMWg3j36Ebz.ttf',
      'MontserratSubrayada-Bold',
    );
    return font.getFont();
  }

  /// Moul regular
  static Future<Font> moulRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/moul/v14/nuF2D__FSo_3E-RYiJCy-00.ttf',
      'Moul-Regular',
    );
    return font.getFont();
  }

  /// Moulpali regular
  static Future<Font> moulpaliRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/moulpali/v15/H4ckBXKMl9HagUWymyY6wr-wg763.ttf',
      'Moulpali-Regular',
    );
    return font.getFont();
  }

  /// Mountains of Christmas regular
  static Future<Font> mountainsofChristmasRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/mountainsofchristmas/v13/3y9w6a4zcCnn5X0FDyrKi2ZRUBIy8uxoUo7ePNamMPNpJpc.ttf',
      'MountainsofChristmas-Regular',
    );
    return font.getFont();
  }

  /// Mountains of Christmas 700
  static Future<Font> mountainsofChristmasBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/mountainsofchristmas/v13/3y9z6a4zcCnn5X0FDyrKi2ZRUBIy8uxoUo7eBGqJFPtCOp6IaEA.ttf',
      'MountainsofChristmas-Bold',
    );
    return font.getFont();
  }

  /// Mouse Memoirs regular
  static Future<Font> mouseMemoirsRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/mousememoirs/v8/t5tmIRoSNJ-PH0WNNgDYxdSb7TnFrpOHYh4.ttf',
      'MouseMemoirs-Regular',
    );
    return font.getFont();
  }

  /// Mr Bedfort regular
  static Future<Font> mrBedfortRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/mrbedfort/v11/MQpR-WCtNZSWAdTMwBicliq0XZe_Iy8.ttf',
      'MrBedfort-Regular',
    );
    return font.getFont();
  }

  /// Mr Dafoe regular
  static Future<Font> mrDafoeRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/mrdafoe/v9/lJwE-pIzkS5NXuMMrGiqg7MCxz_C.ttf',
      'MrDafoe-Regular',
    );
    return font.getFont();
  }

  /// Mr De Haviland regular
  static Future<Font> mrDeHavilandRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/mrdehaviland/v9/OpNVnooIhJj96FdB73296ksbOj3C4ULVNTlB.ttf',
      'MrDeHaviland-Regular',
    );
    return font.getFont();
  }

  /// Mrs Saint Delafield regular
  static Future<Font> mrsSaintDelafieldRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/mrssaintdelafield/v8/v6-IGZDIOVXH9xtmTZfRagunqBw5WC62cK4tLsubB2w.ttf',
      'MrsSaintDelafield-Regular',
    );
    return font.getFont();
  }

  /// Mrs Sheppards regular
  static Future<Font> mrsSheppardsRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/mrssheppards/v11/PN_2Rfm9snC0XUGoEZhb91ig3vjxynMix4Y.ttf',
      'MrsSheppards-Regular',
    );
    return font.getFont();
  }

  /// Mukta 200
  static Future<Font> muktaExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/mukta/v8/iJWHBXyXfDDVXbEOjFma-2HW7ZB_.ttf',
      'Mukta-ExtraLight',
    );
    return font.getFont();
  }

  /// Mukta 300
  static Future<Font> muktaLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/mukta/v8/iJWHBXyXfDDVXbFqj1ma-2HW7ZB_.ttf',
      'Mukta-Light',
    );
    return font.getFont();
  }

  /// Mukta regular
  static Future<Font> muktaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/mukta/v8/iJWKBXyXfDDVXYnGp32S0H3f.ttf',
      'Mukta-Regular',
    );
    return font.getFont();
  }

  /// Mukta 500
  static Future<Font> muktaMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/mukta/v8/iJWHBXyXfDDVXbEyjlma-2HW7ZB_.ttf',
      'Mukta-Medium',
    );
    return font.getFont();
  }

  /// Mukta 600
  static Future<Font> muktaSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/mukta/v8/iJWHBXyXfDDVXbEeiVma-2HW7ZB_.ttf',
      'Mukta-SemiBold',
    );
    return font.getFont();
  }

  /// Mukta 700
  static Future<Font> muktaBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/mukta/v8/iJWHBXyXfDDVXbF6iFma-2HW7ZB_.ttf',
      'Mukta-Bold',
    );
    return font.getFont();
  }

  /// Mukta 800
  static Future<Font> muktaExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/mukta/v8/iJWHBXyXfDDVXbFmi1ma-2HW7ZB_.ttf',
      'Mukta-ExtraBold',
    );
    return font.getFont();
  }

  /// Mukta Mahee 200
  static Future<Font> muktaMaheeExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/muktamahee/v10/XRXN3IOIi0hcP8iVU67hA9MFcBoHJndqZCsW.ttf',
      'MuktaMahee-ExtraLight',
    );
    return font.getFont();
  }

  /// Mukta Mahee 300
  static Future<Font> muktaMaheeLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/muktamahee/v10/XRXN3IOIi0hcP8iVU67hA9NhcxoHJndqZCsW.ttf',
      'MuktaMahee-Light',
    );
    return font.getFont();
  }

  /// Mukta Mahee regular
  static Future<Font> muktaMaheeRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/muktamahee/v10/XRXQ3IOIi0hcP8iVU67hA-vNWz4PDWtj.ttf',
      'MuktaMahee-Regular',
    );
    return font.getFont();
  }

  /// Mukta Mahee 500
  static Future<Font> muktaMaheeMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/muktamahee/v10/XRXN3IOIi0hcP8iVU67hA9M5choHJndqZCsW.ttf',
      'MuktaMahee-Medium',
    );
    return font.getFont();
  }

  /// Mukta Mahee 600
  static Future<Font> muktaMaheeSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/muktamahee/v10/XRXN3IOIi0hcP8iVU67hA9MVdRoHJndqZCsW.ttf',
      'MuktaMahee-SemiBold',
    );
    return font.getFont();
  }

  /// Mukta Mahee 700
  static Future<Font> muktaMaheeBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/muktamahee/v10/XRXN3IOIi0hcP8iVU67hA9NxdBoHJndqZCsW.ttf',
      'MuktaMahee-Bold',
    );
    return font.getFont();
  }

  /// Mukta Mahee 800
  static Future<Font> muktaMaheeExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/muktamahee/v10/XRXN3IOIi0hcP8iVU67hA9NtdxoHJndqZCsW.ttf',
      'MuktaMahee-ExtraBold',
    );
    return font.getFont();
  }

  /// Mukta Malar 200
  static Future<Font> muktaMalarExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/muktamalar/v7/MCoKzAXyz8LOE2FpJMxZqIMwBtAB62ruoAZW.ttf',
      'MuktaMalar-ExtraLight',
    );
    return font.getFont();
  }

  /// Mukta Malar 300
  static Future<Font> muktaMalarLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/muktamalar/v7/MCoKzAXyz8LOE2FpJMxZqINUBdAB62ruoAZW.ttf',
      'MuktaMalar-Light',
    );
    return font.getFont();
  }

  /// Mukta Malar regular
  static Future<Font> muktaMalarRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/muktamalar/v7/MCoXzAXyz8LOE2FpJMxZqLv4LfQJwHbn.ttf',
      'MuktaMalar-Regular',
    );
    return font.getFont();
  }

  /// Mukta Malar 500
  static Future<Font> muktaMalarMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/muktamalar/v7/MCoKzAXyz8LOE2FpJMxZqIMMBNAB62ruoAZW.ttf',
      'MuktaMalar-Medium',
    );
    return font.getFont();
  }

  /// Mukta Malar 600
  static Future<Font> muktaMalarSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/muktamalar/v7/MCoKzAXyz8LOE2FpJMxZqIMgA9AB62ruoAZW.ttf',
      'MuktaMalar-SemiBold',
    );
    return font.getFont();
  }

  /// Mukta Malar 700
  static Future<Font> muktaMalarBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/muktamalar/v7/MCoKzAXyz8LOE2FpJMxZqINEAtAB62ruoAZW.ttf',
      'MuktaMalar-Bold',
    );
    return font.getFont();
  }

  /// Mukta Malar 800
  static Future<Font> muktaMalarExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/muktamalar/v7/MCoKzAXyz8LOE2FpJMxZqINYAdAB62ruoAZW.ttf',
      'MuktaMalar-ExtraBold',
    );
    return font.getFont();
  }

  /// Mukta Vaani 200
  static Future<Font> muktaVaaniExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/muktavaani/v8/3JnkSD_-ynaxmxnEfVHPIGXNV8BD-u97MW1a.ttf',
      'MuktaVaani-ExtraLight',
    );
    return font.getFont();
  }

  /// Mukta Vaani 300
  static Future<Font> muktaVaaniLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/muktavaani/v8/3JnkSD_-ynaxmxnEfVHPIGWpVMBD-u97MW1a.ttf',
      'MuktaVaani-Light',
    );
    return font.getFont();
  }

  /// Mukta Vaani regular
  static Future<Font> muktaVaaniRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/muktavaani/v8/3Jn5SD_-ynaxmxnEfVHPIF0FfORL0fNy.ttf',
      'MuktaVaani-Regular',
    );
    return font.getFont();
  }

  /// Mukta Vaani 500
  static Future<Font> muktaVaaniMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/muktavaani/v8/3JnkSD_-ynaxmxnEfVHPIGXxVcBD-u97MW1a.ttf',
      'MuktaVaani-Medium',
    );
    return font.getFont();
  }

  /// Mukta Vaani 600
  static Future<Font> muktaVaaniSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/muktavaani/v8/3JnkSD_-ynaxmxnEfVHPIGXdUsBD-u97MW1a.ttf',
      'MuktaVaani-SemiBold',
    );
    return font.getFont();
  }

  /// Mukta Vaani 700
  static Future<Font> muktaVaaniBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/muktavaani/v8/3JnkSD_-ynaxmxnEfVHPIGW5U8BD-u97MW1a.ttf',
      'MuktaVaani-Bold',
    );
    return font.getFont();
  }

  /// Mukta Vaani 800
  static Future<Font> muktaVaaniExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/muktavaani/v8/3JnkSD_-ynaxmxnEfVHPIGWlUMBD-u97MW1a.ttf',
      'MuktaVaani-ExtraBold',
    );
    return font.getFont();
  }

  /// Mulish 200
  static Future<Font> mulishExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/mulish/v3/1Ptyg83HX_SGhgqO0yLcmjzUAuWexRNRwaClGrw-PTY.ttf',
      'Mulish-ExtraLight',
    );
    return font.getFont();
  }

  /// Mulish 300
  static Future<Font> mulishLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/mulish/v3/1Ptyg83HX_SGhgqO0yLcmjzUAuWexc1RwaClGrw-PTY.ttf',
      'Mulish-Light',
    );
    return font.getFont();
  }

  /// Mulish regular
  static Future<Font> mulishRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/mulish/v3/1Ptyg83HX_SGhgqO0yLcmjzUAuWexZNRwaClGrw-PTY.ttf',
      'Mulish-Regular',
    );
    return font.getFont();
  }

  /// Mulish 500
  static Future<Font> mulishMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/mulish/v3/1Ptyg83HX_SGhgqO0yLcmjzUAuWexaFRwaClGrw-PTY.ttf',
      'Mulish-Medium',
    );
    return font.getFont();
  }

  /// Mulish 600
  static Future<Font> mulishSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/mulish/v3/1Ptyg83HX_SGhgqO0yLcmjzUAuWexU1WwaClGrw-PTY.ttf',
      'Mulish-SemiBold',
    );
    return font.getFont();
  }

  /// Mulish 700
  static Future<Font> mulishBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/mulish/v3/1Ptyg83HX_SGhgqO0yLcmjzUAuWexXRWwaClGrw-PTY.ttf',
      'Mulish-Bold',
    );
    return font.getFont();
  }

  /// Mulish 800
  static Future<Font> mulishExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/mulish/v3/1Ptyg83HX_SGhgqO0yLcmjzUAuWexRNWwaClGrw-PTY.ttf',
      'Mulish-ExtraBold',
    );
    return font.getFont();
  }

  /// Mulish 900
  static Future<Font> mulishBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/mulish/v3/1Ptyg83HX_SGhgqO0yLcmjzUAuWexTpWwaClGrw-PTY.ttf',
      'Mulish-Black',
    );
    return font.getFont();
  }

  /// Mulish 200italic
  static Future<Font> mulishExtraLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/mulish/v3/1Ptwg83HX_SGhgqk2hAjQlW_mEuZ0FsSqeOvHp47LTZFwA.ttf',
      'Mulish-ExtraLightItalic',
    );
    return font.getFont();
  }

  /// Mulish 300italic
  static Future<Font> mulishLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/mulish/v3/1Ptwg83HX_SGhgqk2hAjQlW_mEuZ0FsSd-OvHp47LTZFwA.ttf',
      'Mulish-LightItalic',
    );
    return font.getFont();
  }

  /// Mulish italic
  static Future<Font> mulishItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/mulish/v3/1Ptwg83HX_SGhgqk2hAjQlW_mEuZ0FsSKeOvHp47LTZFwA.ttf',
      'Mulish-Italic',
    );
    return font.getFont();
  }

  /// Mulish 500italic
  static Future<Font> mulishMediumItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/mulish/v3/1Ptwg83HX_SGhgqk2hAjQlW_mEuZ0FsSG-OvHp47LTZFwA.ttf',
      'Mulish-MediumItalic',
    );
    return font.getFont();
  }

  /// Mulish 600italic
  static Future<Font> mulishSemiBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/mulish/v3/1Ptwg83HX_SGhgqk2hAjQlW_mEuZ0FsS9-SvHp47LTZFwA.ttf',
      'Mulish-SemiBoldItalic',
    );
    return font.getFont();
  }

  /// Mulish 700italic
  static Future<Font> mulishBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/mulish/v3/1Ptwg83HX_SGhgqk2hAjQlW_mEuZ0FsSzuSvHp47LTZFwA.ttf',
      'Mulish-BoldItalic',
    );
    return font.getFont();
  }

  /// Mulish 800italic
  static Future<Font> mulishExtraBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/mulish/v3/1Ptwg83HX_SGhgqk2hAjQlW_mEuZ0FsSqeSvHp47LTZFwA.ttf',
      'Mulish-ExtraBoldItalic',
    );
    return font.getFont();
  }

  /// Mulish 900italic
  static Future<Font> mulishBlackItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/mulish/v3/1Ptwg83HX_SGhgqk2hAjQlW_mEuZ0FsSgOSvHp47LTZFwA.ttf',
      'Mulish-BlackItalic',
    );
    return font.getFont();
  }

  /// MuseoModerno 100
  static Future<Font> museoModernoThin() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/museomoderno/v7/zrf30HnU0_7wWdMrFcWqSEXPVyEaWJ55pTleMlZFuewajeKlCdo.ttf',
      'MuseoModerno-Thin',
    );
    return font.getFont();
  }

  /// MuseoModerno 200
  static Future<Font> museoModernoExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/museomoderno/v7/zrf30HnU0_7wWdMrFcWqSEXPVyEaWJ55pTleMtZEuewajeKlCdo.ttf',
      'MuseoModerno-ExtraLight',
    );
    return font.getFont();
  }

  /// MuseoModerno 300
  static Future<Font> museoModernoLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/museomoderno/v7/zrf30HnU0_7wWdMrFcWqSEXPVyEaWJ55pTleMghEuewajeKlCdo.ttf',
      'MuseoModerno-Light',
    );
    return font.getFont();
  }

  /// MuseoModerno regular
  static Future<Font> museoModernoRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/museomoderno/v7/zrf30HnU0_7wWdMrFcWqSEXPVyEaWJ55pTleMlZEuewajeKlCdo.ttf',
      'MuseoModerno-Regular',
    );
    return font.getFont();
  }

  /// MuseoModerno 500
  static Future<Font> museoModernoMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/museomoderno/v7/zrf30HnU0_7wWdMrFcWqSEXPVyEaWJ55pTleMmREuewajeKlCdo.ttf',
      'MuseoModerno-Medium',
    );
    return font.getFont();
  }

  /// MuseoModerno 600
  static Future<Font> museoModernoSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/museomoderno/v7/zrf30HnU0_7wWdMrFcWqSEXPVyEaWJ55pTleMohDuewajeKlCdo.ttf',
      'MuseoModerno-SemiBold',
    );
    return font.getFont();
  }

  /// MuseoModerno 700
  static Future<Font> museoModernoBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/museomoderno/v7/zrf30HnU0_7wWdMrFcWqSEXPVyEaWJ55pTleMrFDuewajeKlCdo.ttf',
      'MuseoModerno-Bold',
    );
    return font.getFont();
  }

  /// MuseoModerno 800
  static Future<Font> museoModernoExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/museomoderno/v7/zrf30HnU0_7wWdMrFcWqSEXPVyEaWJ55pTleMtZDuewajeKlCdo.ttf',
      'MuseoModerno-ExtraBold',
    );
    return font.getFont();
  }

  /// MuseoModerno 900
  static Future<Font> museoModernoBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/museomoderno/v7/zrf30HnU0_7wWdMrFcWqSEXPVyEaWJ55pTleMv9DuewajeKlCdo.ttf',
      'MuseoModerno-Black',
    );
    return font.getFont();
  }

  /// Mystery Quest regular
  static Future<Font> mysteryQuestRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/mysteryquest/v10/-nF6OG414u0E6k0wynSGlujRHwElD_9Qz9E.ttf',
      'MysteryQuest-Regular',
    );
    return font.getFont();
  }

  /// NTR regular
  static Future<Font> nTRRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ntr/v10/RLpzK5Xy0ZjiGGhs5TA4bg.ttf',
      'NTR-Regular',
    );
    return font.getFont();
  }

  /// Nanum Brush Script regular
  static Future<Font> nanumBrushScriptRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/nanumbrushscript/v17/wXK2E2wfpokopxzthSqPbcR5_gVaxazyjqBr1lO97Q.ttf',
      'NanumBrushScript-Regular',
    );
    return font.getFont();
  }

  /// Nanum Gothic regular
  static Future<Font> nanumGothicRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/nanumgothic/v17/PN_3Rfi-oW3hYwmKDpxS7F_z_tLfxno73g.ttf',
      'NanumGothic-Regular',
    );
    return font.getFont();
  }

  /// Nanum Gothic 700
  static Future<Font> nanumGothicBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/nanumgothic/v17/PN_oRfi-oW3hYwmKDpxS7F_LQv37zlEn14YEUQ.ttf',
      'NanumGothic-Bold',
    );
    return font.getFont();
  }

  /// Nanum Gothic 800
  static Future<Font> nanumGothicExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/nanumgothic/v17/PN_oRfi-oW3hYwmKDpxS7F_LXv77zlEn14YEUQ.ttf',
      'NanumGothic-ExtraBold',
    );
    return font.getFont();
  }

  /// Nanum Gothic Coding regular
  static Future<Font> nanumGothicCodingRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/nanumgothiccoding/v14/8QIVdjzHisX_8vv59_xMxtPFW4IXROwsy6QxVs1X7tc.ttf',
      'NanumGothicCoding-Regular',
    );
    return font.getFont();
  }

  /// Nanum Gothic Coding 700
  static Future<Font> nanumGothicCodingBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/nanumgothiccoding/v14/8QIYdjzHisX_8vv59_xMxtPFW4IXROws8xgecsV88t5V9r4.ttf',
      'NanumGothicCoding-Bold',
    );
    return font.getFont();
  }

  /// Nanum Myeongjo regular
  static Future<Font> nanumMyeongjoRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/nanummyeongjo/v15/9Btx3DZF0dXLMZlywRbVRNhxy1LreHQ8juyl.ttf',
      'NanumMyeongjo-Regular',
    );
    return font.getFont();
  }

  /// Nanum Myeongjo 700
  static Future<Font> nanumMyeongjoBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/nanummyeongjo/v15/9Bty3DZF0dXLMZlywRbVRNhxy2pXV1A0pfCs5Kos.ttf',
      'NanumMyeongjo-Bold',
    );
    return font.getFont();
  }

  /// Nanum Myeongjo 800
  static Future<Font> nanumMyeongjoExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/nanummyeongjo/v15/9Bty3DZF0dXLMZlywRbVRNhxy2pLVFA0pfCs5Kos.ttf',
      'NanumMyeongjo-ExtraBold',
    );
    return font.getFont();
  }

  /// Nanum Pen Script regular
  static Future<Font> nanumPenScriptRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/nanumpenscript/v15/daaDSSYiLGqEal3MvdA_FOL_3FkN2z7-aMFCcTU.ttf',
      'NanumPenScript-Regular',
    );
    return font.getFont();
  }

  /// Nerko One regular
  static Future<Font> nerkoOneRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/nerkoone/v5/m8JQjfZSc7OXlB3ZMOjzcJ5BZmqa3A.ttf',
      'NerkoOne-Regular',
    );
    return font.getFont();
  }

  /// Neucha regular
  static Future<Font> neuchaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/neucha/v12/q5uGsou0JOdh94bvugNsCxVEgA.ttf',
      'Neucha-Regular',
    );
    return font.getFont();
  }

  /// Neuton 200
  static Future<Font> neutonExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/neuton/v13/UMBQrPtMoH62xUZKAKkfegD5Drog6Q.ttf',
      'Neuton-ExtraLight',
    );
    return font.getFont();
  }

  /// Neuton 300
  static Future<Font> neutonLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/neuton/v13/UMBQrPtMoH62xUZKZKofegD5Drog6Q.ttf',
      'Neuton-Light',
    );
    return font.getFont();
  }

  /// Neuton regular
  static Future<Font> neutonRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/neuton/v13/UMBTrPtMoH62xUZyyII7civlBw.ttf',
      'Neuton-Regular',
    );
    return font.getFont();
  }

  /// Neuton italic
  static Future<Font> neutonItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/neuton/v13/UMBRrPtMoH62xUZCyog_UC71B6M5.ttf',
      'Neuton-Italic',
    );
    return font.getFont();
  }

  /// Neuton 700
  static Future<Font> neutonBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/neuton/v13/UMBQrPtMoH62xUZKdK0fegD5Drog6Q.ttf',
      'Neuton-Bold',
    );
    return font.getFont();
  }

  /// Neuton 800
  static Future<Font> neutonExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/neuton/v13/UMBQrPtMoH62xUZKaK4fegD5Drog6Q.ttf',
      'Neuton-ExtraBold',
    );
    return font.getFont();
  }

  /// New Rocker regular
  static Future<Font> newRockerRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/newrocker/v11/MwQzbhjp3-HImzcCU_cJkGMViblPtXs.ttf',
      'NewRocker-Regular',
    );
    return font.getFont();
  }

  /// New Tegomin regular
  static Future<Font> newTegominRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/newtegomin/v5/SLXMc1fV7Gd9USdBAfPlqfN0Q3ptkDMN.ttf',
      'NewTegomin-Regular',
    );
    return font.getFont();
  }

  /// News Cycle regular
  static Future<Font> newsCycleRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/newscycle/v17/CSR64z1Qlv-GDxkbKVQ_TOcATNt_pOU.ttf',
      'NewsCycle-Regular',
    );
    return font.getFont();
  }

  /// News Cycle 700
  static Future<Font> newsCycleBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/newscycle/v17/CSR54z1Qlv-GDxkbKVQ_dFsvaNNUuOwkC2s.ttf',
      'NewsCycle-Bold',
    );
    return font.getFont();
  }

  /// Newsreader 200
  static Future<Font> newsreaderExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/newsreader/v7/cY9qfjOCX1hbuyalUrK49dLac06G1ZGsZBtoBCzBDXXD9JVF438w-I_ADOxEPjCggA.ttf',
      'Newsreader-ExtraLight',
    );
    return font.getFont();
  }

  /// Newsreader 300
  static Future<Font> newsreaderLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/newsreader/v7/cY9qfjOCX1hbuyalUrK49dLac06G1ZGsZBtoBCzBDXXD9JVF438wJo_ADOxEPjCggA.ttf',
      'Newsreader-Light',
    );
    return font.getFont();
  }

  /// Newsreader regular
  static Future<Font> newsreaderRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/newsreader/v7/cY9qfjOCX1hbuyalUrK49dLac06G1ZGsZBtoBCzBDXXD9JVF438weI_ADOxEPjCggA.ttf',
      'Newsreader-Regular',
    );
    return font.getFont();
  }

  /// Newsreader 500
  static Future<Font> newsreaderMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/newsreader/v7/cY9qfjOCX1hbuyalUrK49dLac06G1ZGsZBtoBCzBDXXD9JVF438wSo_ADOxEPjCggA.ttf',
      'Newsreader-Medium',
    );
    return font.getFont();
  }

  /// Newsreader 600
  static Future<Font> newsreaderSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/newsreader/v7/cY9qfjOCX1hbuyalUrK49dLac06G1ZGsZBtoBCzBDXXD9JVF438wpojADOxEPjCggA.ttf',
      'Newsreader-SemiBold',
    );
    return font.getFont();
  }

  /// Newsreader 700
  static Future<Font> newsreaderBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/newsreader/v7/cY9qfjOCX1hbuyalUrK49dLac06G1ZGsZBtoBCzBDXXD9JVF438wn4jADOxEPjCggA.ttf',
      'Newsreader-Bold',
    );
    return font.getFont();
  }

  /// Newsreader 800
  static Future<Font> newsreaderExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/newsreader/v7/cY9qfjOCX1hbuyalUrK49dLac06G1ZGsZBtoBCzBDXXD9JVF438w-IjADOxEPjCggA.ttf',
      'Newsreader-ExtraBold',
    );
    return font.getFont();
  }

  /// Newsreader 200italic
  static Future<Font> newsreaderExtraLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/newsreader/v7/cY9kfjOCX1hbuyalUrK439vogqC9yFZCYg7oRZaLP4obnf7fTXglsMyoT-ZAHDWwgECi.ttf',
      'Newsreader-ExtraLightItalic',
    );
    return font.getFont();
  }

  /// Newsreader 300italic
  static Future<Font> newsreaderLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/newsreader/v7/cY9kfjOCX1hbuyalUrK439vogqC9yFZCYg7oRZaLP4obnf7fTXglsMx2T-ZAHDWwgECi.ttf',
      'Newsreader-LightItalic',
    );
    return font.getFont();
  }

  /// Newsreader italic
  static Future<Font> newsreaderItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/newsreader/v7/cY9kfjOCX1hbuyalUrK439vogqC9yFZCYg7oRZaLP4obnf7fTXglsMwoT-ZAHDWwgECi.ttf',
      'Newsreader-Italic',
    );
    return font.getFont();
  }

  /// Newsreader 500italic
  static Future<Font> newsreaderMediumItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/newsreader/v7/cY9kfjOCX1hbuyalUrK439vogqC9yFZCYg7oRZaLP4obnf7fTXglsMwaT-ZAHDWwgECi.ttf',
      'Newsreader-MediumItalic',
    );
    return font.getFont();
  }

  /// Newsreader 600italic
  static Future<Font> newsreaderSemiBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/newsreader/v7/cY9kfjOCX1hbuyalUrK439vogqC9yFZCYg7oRZaLP4obnf7fTXglsMz2SOZAHDWwgECi.ttf',
      'Newsreader-SemiBoldItalic',
    );
    return font.getFont();
  }

  /// Newsreader 700italic
  static Future<Font> newsreaderBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/newsreader/v7/cY9kfjOCX1hbuyalUrK439vogqC9yFZCYg7oRZaLP4obnf7fTXglsMzPSOZAHDWwgECi.ttf',
      'Newsreader-BoldItalic',
    );
    return font.getFont();
  }

  /// Newsreader 800italic
  static Future<Font> newsreaderExtraBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/newsreader/v7/cY9kfjOCX1hbuyalUrK439vogqC9yFZCYg7oRZaLP4obnf7fTXglsMyoSOZAHDWwgECi.ttf',
      'Newsreader-ExtraBoldItalic',
    );
    return font.getFont();
  }

  /// Niconne regular
  static Future<Font> niconneRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/niconne/v10/w8gaH2QvRug1_rTfrQut2F4OuOo.ttf',
      'Niconne-Regular',
    );
    return font.getFont();
  }

  /// Niramit 200
  static Future<Font> niramitExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/niramit/v5/I_urMpWdvgLdNxVLVXx7tiiEr5_BdZ8.ttf',
      'Niramit-ExtraLight',
    );
    return font.getFont();
  }

  /// Niramit 200italic
  static Future<Font> niramitExtraLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/niramit/v5/I_upMpWdvgLdNxVLXbZiXimOq73EZZ_f6w.ttf',
      'Niramit-ExtraLightItalic',
    );
    return font.getFont();
  }

  /// Niramit 300
  static Future<Font> niramitLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/niramit/v5/I_urMpWdvgLdNxVLVRh4tiiEr5_BdZ8.ttf',
      'Niramit-Light',
    );
    return font.getFont();
  }

  /// Niramit 300italic
  static Future<Font> niramitLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/niramit/v5/I_upMpWdvgLdNxVLXbZiOiqOq73EZZ_f6w.ttf',
      'Niramit-LightItalic',
    );
    return font.getFont();
  }

  /// Niramit regular
  static Future<Font> niramitRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/niramit/v5/I_uuMpWdvgLdNxVLbbRQkiCvs5Y.ttf',
      'Niramit-Regular',
    );
    return font.getFont();
  }

  /// Niramit italic
  static Future<Font> niramitItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/niramit/v5/I_usMpWdvgLdNxVLXbZalgKqo5bYbA.ttf',
      'Niramit-Italic',
    );
    return font.getFont();
  }

  /// Niramit 500
  static Future<Font> niramitMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/niramit/v5/I_urMpWdvgLdNxVLVUB5tiiEr5_BdZ8.ttf',
      'Niramit-Medium',
    );
    return font.getFont();
  }

  /// Niramit 500italic
  static Future<Font> niramitMediumItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/niramit/v5/I_upMpWdvgLdNxVLXbZiYiuOq73EZZ_f6w.ttf',
      'Niramit-MediumItalic',
    );
    return font.getFont();
  }

  /// Niramit 600
  static Future<Font> niramitSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/niramit/v5/I_urMpWdvgLdNxVLVWx-tiiEr5_BdZ8.ttf',
      'Niramit-SemiBold',
    );
    return font.getFont();
  }

  /// Niramit 600italic
  static Future<Font> niramitSemiBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/niramit/v5/I_upMpWdvgLdNxVLXbZiTiyOq73EZZ_f6w.ttf',
      'Niramit-SemiBoldItalic',
    );
    return font.getFont();
  }

  /// Niramit 700
  static Future<Font> niramitBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/niramit/v5/I_urMpWdvgLdNxVLVQh_tiiEr5_BdZ8.ttf',
      'Niramit-Bold',
    );
    return font.getFont();
  }

  /// Niramit 700italic
  static Future<Font> niramitBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/niramit/v5/I_upMpWdvgLdNxVLXbZiKi2Oq73EZZ_f6w.ttf',
      'Niramit-BoldItalic',
    );
    return font.getFont();
  }

  /// Nixie One regular
  static Future<Font> nixieOneRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/nixieone/v11/lW-8wjkKLXjg5y2o2uUoUOFzpS-yLw.ttf',
      'NixieOne-Regular',
    );
    return font.getFont();
  }

  /// Nobile regular
  static Future<Font> nobileRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/nobile/v12/m8JTjflSeaOVl1i2XqfXeLVdbw.ttf',
      'Nobile-Regular',
    );
    return font.getFont();
  }

  /// Nobile italic
  static Future<Font> nobileItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/nobile/v12/m8JRjflSeaOVl1iGXK3TWrBNb3OD.ttf',
      'Nobile-Italic',
    );
    return font.getFont();
  }

  /// Nobile 500
  static Future<Font> nobileMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/nobile/v12/m8JQjflSeaOVl1iOqo7zcJ5BZmqa3A.ttf',
      'Nobile-Medium',
    );
    return font.getFont();
  }

  /// Nobile 500italic
  static Future<Font> nobileMediumItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/nobile/v12/m8JWjflSeaOVl1iGXJUnc5RFRG-K3Mud.ttf',
      'Nobile-MediumItalic',
    );
    return font.getFont();
  }

  /// Nobile 700
  static Future<Font> nobileBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/nobile/v12/m8JQjflSeaOVl1iO4ojzcJ5BZmqa3A.ttf',
      'Nobile-Bold',
    );
    return font.getFont();
  }

  /// Nobile 700italic
  static Future<Font> nobileBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/nobile/v12/m8JWjflSeaOVl1iGXJVvdZRFRG-K3Mud.ttf',
      'Nobile-BoldItalic',
    );
    return font.getFont();
  }

  /// Nokora regular
  static Future<Font> nokoraRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/nokora/v16/hYkIPuwgTubzaWxQOzoPovZg8Q.ttf',
      'Nokora-Regular',
    );
    return font.getFont();
  }

  /// Nokora 700
  static Future<Font> nokoraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/nokora/v16/hYkLPuwgTubzaWxohxUrqt18-B9Uuw.ttf',
      'Nokora-Bold',
    );
    return font.getFont();
  }

  /// Norican regular
  static Future<Font> noricanRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/norican/v9/MwQ2bhXp1eSBqjkPGJJRtGs-lbA.ttf',
      'Norican-Regular',
    );
    return font.getFont();
  }

  /// Nosifer regular
  static Future<Font> nosiferRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/nosifer/v11/ZGjXol5JTp0g5bxZaC1RVDNdGDs.ttf',
      'Nosifer-Regular',
    );
    return font.getFont();
  }

  /// Notable regular
  static Future<Font> notableRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/notable/v9/gNMEW3N_SIqx-WX9-HMoFIez5MI.ttf',
      'Notable-Regular',
    );
    return font.getFont();
  }

  /// Nothing You Could Do regular
  static Future<Font> nothingYouCouldDoRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/nothingyoucoulddo/v10/oY1B8fbBpaP5OX3DtrRYf_Q2BPB1SnfZb0OJl1ol2Ymo.ttf',
      'NothingYouCouldDo-Regular',
    );
    return font.getFont();
  }

  /// Noticia Text regular
  static Future<Font> noticiaTextRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/noticiatext/v10/VuJ2dNDF2Yv9qppOePKYRP1GYTFZt0rNpQ.ttf',
      'NoticiaText-Regular',
    );
    return font.getFont();
  }

  /// Noticia Text italic
  static Future<Font> noticiaTextItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/noticiatext/v10/VuJodNDF2Yv9qppOePKYRP12YztdlU_dpSjt.ttf',
      'NoticiaText-Italic',
    );
    return font.getFont();
  }

  /// Noticia Text 700
  static Future<Font> noticiaTextBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/noticiatext/v10/VuJpdNDF2Yv9qppOePKYRP1-3R59v2HRrDH0eA.ttf',
      'NoticiaText-Bold',
    );
    return font.getFont();
  }

  /// Noticia Text 700italic
  static Future<Font> noticiaTextBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/noticiatext/v10/VuJrdNDF2Yv9qppOePKYRP12YwPhumvVjjTkeMnz.ttf',
      'NoticiaText-BoldItalic',
    );
    return font.getFont();
  }

  /// Noto Sans regular
  static Future<Font> notoSansRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/notosans/v12/o-0IIpQlx3QUlC5A4PNb4j5Ba_2c7A.ttf',
      'NotoSans-Regular',
    );
    return font.getFont();
  }

  /// Noto Sans italic
  static Future<Font> notoSansItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/notosans/v12/o-0OIpQlx3QUlC5A4PNr4DRFSfiM7HBj.ttf',
      'NotoSans-Italic',
    );
    return font.getFont();
  }

  /// Noto Sans 700
  static Future<Font> notoSansBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/notosans/v12/o-0NIpQlx3QUlC5A4PNjXhFlY9aA5Wl6PQ.ttf',
      'NotoSans-Bold',
    );
    return font.getFont();
  }

  /// Noto Sans 700italic
  static Future<Font> notoSansBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/notosans/v12/o-0TIpQlx3QUlC5A4PNr4Az5ZtyEx2xqPaif.ttf',
      'NotoSans-BoldItalic',
    );
    return font.getFont();
  }

  /// Noto Sans HK 100
  static Future<Font> notoSansHKThin() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/notosanshk/v6/nKKO-GM_FYFRJvXzVXaAPe9ZUHp1MOv2ObB7.otf',
      'NotoSansHK-Thin',
    );
    return font.getFont();
  }

  /// Noto Sans HK 300
  static Future<Font> notoSansHKLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/notosanshk/v6/nKKP-GM_FYFRJvXzVXaAPe9ZmFhTHMX6MKliqQ.otf',
      'NotoSansHK-Light',
    );
    return font.getFont();
  }

  /// Noto Sans HK regular
  static Future<Font> notoSansHKRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/notosanshk/v6/nKKQ-GM_FYFRJvXzVXaAPe9hMnB3Eu7mOQ.otf',
      'NotoSansHK-Regular',
    );
    return font.getFont();
  }

  /// Noto Sans HK 500
  static Future<Font> notoSansHKMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/notosanshk/v6/nKKP-GM_FYFRJvXzVXaAPe9ZwFlTHMX6MKliqQ.otf',
      'NotoSansHK-Medium',
    );
    return font.getFont();
  }

  /// Noto Sans HK 700
  static Future<Font> notoSansHKBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/notosanshk/v6/nKKP-GM_FYFRJvXzVXaAPe9ZiF9THMX6MKliqQ.otf',
      'NotoSansHK-Bold',
    );
    return font.getFont();
  }

  /// Noto Sans HK 900
  static Future<Font> notoSansHKBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/notosanshk/v6/nKKP-GM_FYFRJvXzVXaAPe9ZsF1THMX6MKliqQ.otf',
      'NotoSansHK-Black',
    );
    return font.getFont();
  }

  /// Noto Sans JP 100
  static Future<Font> notoSansJPThin() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/notosansjp/v28/-F6ofjtqLzI2JPCgQBnw7HFQoggM-FNthvIU.otf',
      'NotoSansJP-Thin',
    );
    return font.getFont();
  }

  /// Noto Sans JP 300
  static Future<Font> notoSansJPLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/notosansjp/v28/-F6pfjtqLzI2JPCgQBnw7HFQaioq1H1hj-sNFQ.otf',
      'NotoSansJP-Light',
    );
    return font.getFont();
  }

  /// Noto Sans JP regular
  static Future<Font> notoSansJPRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/notosansjp/v28/-F62fjtqLzI2JPCgQBnw7HFowAIO2lZ9hg.otf',
      'NotoSansJP-Regular',
    );
    return font.getFont();
  }

  /// Noto Sans JP 500
  static Future<Font> notoSansJPMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/notosansjp/v28/-F6pfjtqLzI2JPCgQBnw7HFQMisq1H1hj-sNFQ.otf',
      'NotoSansJP-Medium',
    );
    return font.getFont();
  }

  /// Noto Sans JP 700
  static Future<Font> notoSansJPBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/notosansjp/v28/-F6pfjtqLzI2JPCgQBnw7HFQei0q1H1hj-sNFQ.otf',
      'NotoSansJP-Bold',
    );
    return font.getFont();
  }

  /// Noto Sans JP 900
  static Future<Font> notoSansJPBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/notosansjp/v28/-F6pfjtqLzI2JPCgQBnw7HFQQi8q1H1hj-sNFQ.otf',
      'NotoSansJP-Black',
    );
    return font.getFont();
  }

  /// Noto Sans KR 100
  static Future<Font> notoSansKRThin() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/notosanskr/v13/Pby6FmXiEBPT4ITbgNA5CgmOsn7uwpYcuH8y.otf',
      'NotoSansKR-Thin',
    );
    return font.getFont();
  }

  /// Noto Sans KR 300
  static Future<Font> notoSansKRLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/notosanskr/v13/Pby7FmXiEBPT4ITbgNA5CgmOelzI7rgQsWYrzw.otf',
      'NotoSansKR-Light',
    );
    return font.getFont();
  }

  /// Noto Sans KR regular
  static Future<Font> notoSansKRRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/notosanskr/v13/PbykFmXiEBPT4ITbgNA5Cgm20HTs4JMMuA.otf',
      'NotoSansKR-Regular',
    );
    return font.getFont();
  }

  /// Noto Sans KR 500
  static Future<Font> notoSansKRMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/notosanskr/v13/Pby7FmXiEBPT4ITbgNA5CgmOIl3I7rgQsWYrzw.otf',
      'NotoSansKR-Medium',
    );
    return font.getFont();
  }

  /// Noto Sans KR 700
  static Future<Font> notoSansKRBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/notosanskr/v13/Pby7FmXiEBPT4ITbgNA5CgmOalvI7rgQsWYrzw.otf',
      'NotoSansKR-Bold',
    );
    return font.getFont();
  }

  /// Noto Sans KR 900
  static Future<Font> notoSansKRBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/notosanskr/v13/Pby7FmXiEBPT4ITbgNA5CgmOUlnI7rgQsWYrzw.otf',
      'NotoSansKR-Black',
    );
    return font.getFont();
  }

  /// Noto Sans SC 100
  static Future<Font> notoSansSCThin() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/notosanssc/v12/k3kJo84MPvpLmixcA63oeALZTYKL2wv287Sb.otf',
      'NotoSansSC-Thin',
    );
    return font.getFont();
  }

  /// Noto Sans SC 300
  static Future<Font> notoSansSCLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/notosanssc/v12/k3kIo84MPvpLmixcA63oeALZhaCt9yX6-q2CGg.otf',
      'NotoSansSC-Light',
    );
    return font.getFont();
  }

  /// Noto Sans SC regular
  static Future<Font> notoSansSCRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/notosanssc/v12/k3kXo84MPvpLmixcA63oeALhL4iJ-Q7m8w.otf',
      'NotoSansSC-Regular',
    );
    return font.getFont();
  }

  /// Noto Sans SC 500
  static Future<Font> notoSansSCMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/notosanssc/v12/k3kIo84MPvpLmixcA63oeALZ3aGt9yX6-q2CGg.otf',
      'NotoSansSC-Medium',
    );
    return font.getFont();
  }

  /// Noto Sans SC 700
  static Future<Font> notoSansSCBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/notosanssc/v12/k3kIo84MPvpLmixcA63oeALZlaet9yX6-q2CGg.otf',
      'NotoSansSC-Bold',
    );
    return font.getFont();
  }

  /// Noto Sans SC 900
  static Future<Font> notoSansSCBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/notosanssc/v12/k3kIo84MPvpLmixcA63oeALZraWt9yX6-q2CGg.otf',
      'NotoSansSC-Black',
    );
    return font.getFont();
  }

  /// Noto Sans TC 100
  static Future<Font> notoSansTCThin() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/notosanstc/v11/-nFlOG829Oofr2wohFbTp9i9WyEJIfNZ1sjy.otf',
      'NotoSansTC-Thin',
    );
    return font.getFont();
  }

  /// Noto Sans TC 300
  static Future<Font> notoSansTCLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/notosanstc/v11/-nFkOG829Oofr2wohFbTp9i9kwMvDd1V39Hr7g.otf',
      'NotoSansTC-Light',
    );
    return font.getFont();
  }

  /// Noto Sans TC regular
  static Future<Font> notoSansTCRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/notosanstc/v11/-nF7OG829Oofr2wohFbTp9iFOSsLA_ZJ1g.otf',
      'NotoSansTC-Regular',
    );
    return font.getFont();
  }

  /// Noto Sans TC 500
  static Future<Font> notoSansTCMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/notosanstc/v11/-nFkOG829Oofr2wohFbTp9i9ywIvDd1V39Hr7g.otf',
      'NotoSansTC-Medium',
    );
    return font.getFont();
  }

  /// Noto Sans TC 700
  static Future<Font> notoSansTCBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/notosanstc/v11/-nFkOG829Oofr2wohFbTp9i9gwQvDd1V39Hr7g.otf',
      'NotoSansTC-Bold',
    );
    return font.getFont();
  }

  /// Noto Sans TC 900
  static Future<Font> notoSansTCBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/notosanstc/v11/-nFkOG829Oofr2wohFbTp9i9uwYvDd1V39Hr7g.otf',
      'NotoSansTC-Black',
    );
    return font.getFont();
  }

  /// Noto Serif regular
  static Future<Font> notoSerifRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/notoserif/v9/ga6Iaw1J5X9T9RW6j9bNTFAcaRi_bMQ.ttf',
      'NotoSerif-Regular',
    );
    return font.getFont();
  }

  /// Noto Serif italic
  static Future<Font> notoSerifItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/notoserif/v9/ga6Kaw1J5X9T9RW6j9bNfFIWbTq6fMRRMw.ttf',
      'NotoSerif-Italic',
    );
    return font.getFont();
  }

  /// Noto Serif 700
  static Future<Font> notoSerifBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/notoserif/v9/ga6Law1J5X9T9RW6j9bNdOwzTRCUcM1IKoY.ttf',
      'NotoSerif-Bold',
    );
    return font.getFont();
  }

  /// Noto Serif 700italic
  static Future<Font> notoSerifBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/notoserif/v9/ga6Vaw1J5X9T9RW6j9bNfFIu0RWedO9NOoYIDg.ttf',
      'NotoSerif-BoldItalic',
    );
    return font.getFont();
  }

  /// Noto Serif JP 200
  static Future<Font> notoSerifJPExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/notoserifjp/v8/xn77YHs72GKoTvER4Gn3b5eMZBaPRkgfU8fEwb0.otf',
      'NotoSerifJP-ExtraLight',
    );
    return font.getFont();
  }

  /// Noto Serif JP 300
  static Future<Font> notoSerifJPLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/notoserifjp/v8/xn77YHs72GKoTvER4Gn3b5eMZHKMRkgfU8fEwb0.otf',
      'NotoSerifJP-Light',
    );
    return font.getFont();
  }

  /// Noto Serif JP regular
  static Future<Font> notoSerifJPRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/notoserifjp/v8/xn7mYHs72GKoTvER4Gn3b5eMXNikYkY0T84.otf',
      'NotoSerifJP-Regular',
    );
    return font.getFont();
  }

  /// Noto Serif JP 500
  static Future<Font> notoSerifJPMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/notoserifjp/v8/xn77YHs72GKoTvER4Gn3b5eMZCqNRkgfU8fEwb0.otf',
      'NotoSerifJP-Medium',
    );
    return font.getFont();
  }

  /// Noto Serif JP 600
  static Future<Font> notoSerifJPSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/notoserifjp/v8/xn77YHs72GKoTvER4Gn3b5eMZAaKRkgfU8fEwb0.otf',
      'NotoSerifJP-SemiBold',
    );
    return font.getFont();
  }

  /// Noto Serif JP 700
  static Future<Font> notoSerifJPBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/notoserifjp/v8/xn77YHs72GKoTvER4Gn3b5eMZGKLRkgfU8fEwb0.otf',
      'NotoSerifJP-Bold',
    );
    return font.getFont();
  }

  /// Noto Serif JP 900
  static Future<Font> notoSerifJPBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/notoserifjp/v8/xn77YHs72GKoTvER4Gn3b5eMZFqJRkgfU8fEwb0.otf',
      'NotoSerifJP-Black',
    );
    return font.getFont();
  }

  /// Noto Serif KR 200
  static Future<Font> notoSerifKRExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/notoserifkr/v7/3JnmSDn90Gmq2mr3blnHaTZXTihC8O1ZNH1ahck.otf',
      'NotoSerifKR-ExtraLight',
    );
    return font.getFont();
  }

  /// Noto Serif KR 300
  static Future<Font> notoSerifKRLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/notoserifkr/v7/3JnmSDn90Gmq2mr3blnHaTZXTkxB8O1ZNH1ahck.otf',
      'NotoSerifKR-Light',
    );
    return font.getFont();
  }

  /// Noto Serif KR regular
  static Future<Font> notoSerifKRRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/notoserifkr/v7/3Jn7SDn90Gmq2mr3blnHaTZXduZp1ONyKHQ.otf',
      'NotoSerifKR-Regular',
    );
    return font.getFont();
  }

  /// Noto Serif KR 500
  static Future<Font> notoSerifKRMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/notoserifkr/v7/3JnmSDn90Gmq2mr3blnHaTZXThRA8O1ZNH1ahck.otf',
      'NotoSerifKR-Medium',
    );
    return font.getFont();
  }

  /// Noto Serif KR 600
  static Future<Font> notoSerifKRSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/notoserifkr/v7/3JnmSDn90Gmq2mr3blnHaTZXTjhH8O1ZNH1ahck.otf',
      'NotoSerifKR-SemiBold',
    );
    return font.getFont();
  }

  /// Noto Serif KR 700
  static Future<Font> notoSerifKRBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/notoserifkr/v7/3JnmSDn90Gmq2mr3blnHaTZXTlxG8O1ZNH1ahck.otf',
      'NotoSerifKR-Bold',
    );
    return font.getFont();
  }

  /// Noto Serif KR 900
  static Future<Font> notoSerifKRBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/notoserifkr/v7/3JnmSDn90Gmq2mr3blnHaTZXTmRE8O1ZNH1ahck.otf',
      'NotoSerifKR-Black',
    );
    return font.getFont();
  }

  /// Noto Serif SC 200
  static Future<Font> notoSerifSCExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/notoserifsc/v8/H4c8BXePl9DZ0Xe7gG9cyOj7mm63SzZBEtERe7U.otf',
      'NotoSerifSC-ExtraLight',
    );
    return font.getFont();
  }

  /// Noto Serif SC 300
  static Future<Font> notoSerifSCLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/notoserifsc/v8/H4c8BXePl9DZ0Xe7gG9cyOj7mgq0SzZBEtERe7U.otf',
      'NotoSerifSC-Light',
    );
    return font.getFont();
  }

  /// Noto Serif SC regular
  static Future<Font> notoSerifSCRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/notoserifsc/v8/H4chBXePl9DZ0Xe7gG9cyOj7oqCcbzhqDtg.otf',
      'NotoSerifSC-Regular',
    );
    return font.getFont();
  }

  /// Noto Serif SC 500
  static Future<Font> notoSerifSCMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/notoserifsc/v8/H4c8BXePl9DZ0Xe7gG9cyOj7mlK1SzZBEtERe7U.otf',
      'NotoSerifSC-Medium',
    );
    return font.getFont();
  }

  /// Noto Serif SC 600
  static Future<Font> notoSerifSCSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/notoserifsc/v8/H4c8BXePl9DZ0Xe7gG9cyOj7mn6ySzZBEtERe7U.otf',
      'NotoSerifSC-SemiBold',
    );
    return font.getFont();
  }

  /// Noto Serif SC 700
  static Future<Font> notoSerifSCBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/notoserifsc/v8/H4c8BXePl9DZ0Xe7gG9cyOj7mhqzSzZBEtERe7U.otf',
      'NotoSerifSC-Bold',
    );
    return font.getFont();
  }

  /// Noto Serif SC 900
  static Future<Font> notoSerifSCBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/notoserifsc/v8/H4c8BXePl9DZ0Xe7gG9cyOj7miKxSzZBEtERe7U.otf',
      'NotoSerifSC-Black',
    );
    return font.getFont();
  }

  /// Noto Serif TC 200
  static Future<Font> notoSerifTCExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/notoseriftc/v8/XLY9IZb5bJNDGYxLBibeHZ0Bvr8vbX9GTsoOAX4.otf',
      'NotoSerifTC-ExtraLight',
    );
    return font.getFont();
  }

  /// Noto Serif TC 300
  static Future<Font> notoSerifTCLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/notoseriftc/v8/XLY9IZb5bJNDGYxLBibeHZ0BvtssbX9GTsoOAX4.otf',
      'NotoSerifTC-Light',
    );
    return font.getFont();
  }

  /// Noto Serif TC regular
  static Future<Font> notoSerifTCRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/notoseriftc/v8/XLYgIZb5bJNDGYxLBibeHZ0BhnEESXFtUsM.otf',
      'NotoSerifTC-Regular',
    );
    return font.getFont();
  }

  /// Noto Serif TC 500
  static Future<Font> notoSerifTCMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/notoseriftc/v8/XLY9IZb5bJNDGYxLBibeHZ0BvoMtbX9GTsoOAX4.otf',
      'NotoSerifTC-Medium',
    );
    return font.getFont();
  }

  /// Noto Serif TC 600
  static Future<Font> notoSerifTCSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/notoseriftc/v8/XLY9IZb5bJNDGYxLBibeHZ0Bvq8qbX9GTsoOAX4.otf',
      'NotoSerifTC-SemiBold',
    );
    return font.getFont();
  }

  /// Noto Serif TC 700
  static Future<Font> notoSerifTCBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/notoseriftc/v8/XLY9IZb5bJNDGYxLBibeHZ0BvssrbX9GTsoOAX4.otf',
      'NotoSerifTC-Bold',
    );
    return font.getFont();
  }

  /// Noto Serif TC 900
  static Future<Font> notoSerifTCBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/notoseriftc/v8/XLY9IZb5bJNDGYxLBibeHZ0BvvMpbX9GTsoOAX4.otf',
      'NotoSerifTC-Black',
    );
    return font.getFont();
  }

  /// Nova Cut regular
  static Future<Font> novaCutRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/novacut/v14/KFOkCnSYu8mL-39LkWxPKTM1K9nz.ttf',
      'NovaCut-Regular',
    );
    return font.getFont();
  }

  /// Nova Flat regular
  static Future<Font> novaFlatRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/novaflat/v14/QdVUSTc-JgqpytEbVebEuStkm20oJA.ttf',
      'NovaFlat-Regular',
    );
    return font.getFont();
  }

  /// Nova Mono regular
  static Future<Font> novaMonoRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/novamono/v13/Cn-0JtiGWQ5Ajb--MRKfYGxYrdM9Sg.ttf',
      'NovaMono-Regular',
    );
    return font.getFont();
  }

  /// Nova Oval regular
  static Future<Font> novaOvalRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/novaoval/v14/jAnEgHdmANHvPenMaswCMY-h3cWkWg.ttf',
      'NovaOval-Regular',
    );
    return font.getFont();
  }

  /// Nova Round regular
  static Future<Font> novaRoundRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/novaround/v14/flU9Rqquw5UhEnlwTJYTYYfeeetYEBc.ttf',
      'NovaRound-Regular',
    );
    return font.getFont();
  }

  /// Nova Script regular
  static Future<Font> novaScriptRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/novascript/v15/7Au7p_IpkSWSTWaFWkumvmQNEl0O0kEx.ttf',
      'NovaScript-Regular',
    );
    return font.getFont();
  }

  /// Nova Slim regular
  static Future<Font> novaSlimRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/novaslim/v14/Z9XUDmZNQAuem8jyZcn-yMOInrib9Q.ttf',
      'NovaSlim-Regular',
    );
    return font.getFont();
  }

  /// Nova Square regular
  static Future<Font> novaSquareRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/novasquare/v15/RrQUbo9-9DV7b06QHgSWsZhARYMgGtWA.ttf',
      'NovaSquare-Regular',
    );
    return font.getFont();
  }

  /// Numans regular
  static Future<Font> numansRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/numans/v10/SlGRmQmGupYAfH8IYRggiHVqaQ.ttf',
      'Numans-Regular',
    );
    return font.getFont();
  }

  /// Nunito 200
  static Future<Font> nunitoExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/nunito/v16/XRXW3I6Li01BKofA-sekZuHJeTsfDQ.ttf',
      'Nunito-ExtraLight',
    );
    return font.getFont();
  }

  /// Nunito 200italic
  static Future<Font> nunitoExtraLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/nunito/v16/XRXQ3I6Li01BKofIMN5MZ-vNWz4PDWtj.ttf',
      'Nunito-ExtraLightItalic',
    );
    return font.getFont();
  }

  /// Nunito 300
  static Future<Font> nunitoLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/nunito/v16/XRXW3I6Li01BKofAnsSkZuHJeTsfDQ.ttf',
      'Nunito-Light',
    );
    return font.getFont();
  }

  /// Nunito 300italic
  static Future<Font> nunitoLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/nunito/v16/XRXQ3I6Li01BKofIMN4oZOvNWz4PDWtj.ttf',
      'Nunito-LightItalic',
    );
    return font.getFont();
  }

  /// Nunito regular
  static Future<Font> nunitoRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/nunito/v16/XRXV3I6Li01BKof4MuyAbsrVcA.ttf',
      'Nunito-Regular',
    );
    return font.getFont();
  }

  /// Nunito italic
  static Future<Font> nunitoItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/nunito/v16/XRXX3I6Li01BKofIMOaETM_FcCIG.ttf',
      'Nunito-Italic',
    );
    return font.getFont();
  }

  /// Nunito 600
  static Future<Font> nunitoSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/nunito/v16/XRXW3I6Li01BKofA6sKkZuHJeTsfDQ.ttf',
      'Nunito-SemiBold',
    );
    return font.getFont();
  }

  /// Nunito 600italic
  static Future<Font> nunitoSemiBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/nunito/v16/XRXQ3I6Li01BKofIMN5cYuvNWz4PDWtj.ttf',
      'Nunito-SemiBoldItalic',
    );
    return font.getFont();
  }

  /// Nunito 700
  static Future<Font> nunitoBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/nunito/v16/XRXW3I6Li01BKofAjsOkZuHJeTsfDQ.ttf',
      'Nunito-Bold',
    );
    return font.getFont();
  }

  /// Nunito 700italic
  static Future<Font> nunitoBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/nunito/v16/XRXQ3I6Li01BKofIMN44Y-vNWz4PDWtj.ttf',
      'Nunito-BoldItalic',
    );
    return font.getFont();
  }

  /// Nunito 800
  static Future<Font> nunitoExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/nunito/v16/XRXW3I6Li01BKofAksCkZuHJeTsfDQ.ttf',
      'Nunito-ExtraBold',
    );
    return font.getFont();
  }

  /// Nunito 800italic
  static Future<Font> nunitoExtraBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/nunito/v16/XRXQ3I6Li01BKofIMN4kYOvNWz4PDWtj.ttf',
      'Nunito-ExtraBoldItalic',
    );
    return font.getFont();
  }

  /// Nunito 900
  static Future<Font> nunitoBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/nunito/v16/XRXW3I6Li01BKofAtsGkZuHJeTsfDQ.ttf',
      'Nunito-Black',
    );
    return font.getFont();
  }

  /// Nunito 900italic
  static Future<Font> nunitoBlackItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/nunito/v16/XRXQ3I6Li01BKofIMN4AYevNWz4PDWtj.ttf',
      'Nunito-BlackItalic',
    );
    return font.getFont();
  }

  /// Nunito Sans 200
  static Future<Font> nunitoSansExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/nunitosans/v6/pe03MImSLYBIv1o4X1M8cc9yAv5qWVAgVol-.ttf',
      'NunitoSans-ExtraLight',
    );
    return font.getFont();
  }

  /// Nunito Sans 200italic
  static Future<Font> nunitoSansExtraLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/nunitosans/v6/pe01MImSLYBIv1o4X1M8cce4GxZrU1QCU5l-06Y.ttf',
      'NunitoSans-ExtraLightItalic',
    );
    return font.getFont();
  }

  /// Nunito Sans 300
  static Future<Font> nunitoSansLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/nunitosans/v6/pe03MImSLYBIv1o4X1M8cc8WAf5qWVAgVol-.ttf',
      'NunitoSans-Light',
    );
    return font.getFont();
  }

  /// Nunito Sans 300italic
  static Future<Font> nunitoSansLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/nunitosans/v6/pe01MImSLYBIv1o4X1M8cce4G3JoU1QCU5l-06Y.ttf',
      'NunitoSans-LightItalic',
    );
    return font.getFont();
  }

  /// Nunito Sans regular
  static Future<Font> nunitoSansRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/nunitosans/v6/pe0qMImSLYBIv1o4X1M8cfe6Kdpickwp.ttf',
      'NunitoSans-Regular',
    );
    return font.getFont();
  }

  /// Nunito Sans italic
  static Future<Font> nunitoSansItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/nunitosans/v6/pe0oMImSLYBIv1o4X1M8cce4I95Ad1wpT5A.ttf',
      'NunitoSans-Italic',
    );
    return font.getFont();
  }

  /// Nunito Sans 600
  static Future<Font> nunitoSansSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/nunitosans/v6/pe03MImSLYBIv1o4X1M8cc9iB_5qWVAgVol-.ttf',
      'NunitoSans-SemiBold',
    );
    return font.getFont();
  }

  /// Nunito Sans 600italic
  static Future<Font> nunitoSansSemiBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/nunitosans/v6/pe01MImSLYBIv1o4X1M8cce4GwZuU1QCU5l-06Y.ttf',
      'NunitoSans-SemiBoldItalic',
    );
    return font.getFont();
  }

  /// Nunito Sans 700
  static Future<Font> nunitoSansBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/nunitosans/v6/pe03MImSLYBIv1o4X1M8cc8GBv5qWVAgVol-.ttf',
      'NunitoSans-Bold',
    );
    return font.getFont();
  }

  /// Nunito Sans 700italic
  static Future<Font> nunitoSansBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/nunitosans/v6/pe01MImSLYBIv1o4X1M8cce4G2JvU1QCU5l-06Y.ttf',
      'NunitoSans-BoldItalic',
    );
    return font.getFont();
  }

  /// Nunito Sans 800
  static Future<Font> nunitoSansExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/nunitosans/v6/pe03MImSLYBIv1o4X1M8cc8aBf5qWVAgVol-.ttf',
      'NunitoSans-ExtraBold',
    );
    return font.getFont();
  }

  /// Nunito Sans 800italic
  static Future<Font> nunitoSansExtraBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/nunitosans/v6/pe01MImSLYBIv1o4X1M8cce4G35sU1QCU5l-06Y.ttf',
      'NunitoSans-ExtraBoldItalic',
    );
    return font.getFont();
  }

  /// Nunito Sans 900
  static Future<Font> nunitoSansBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/nunitosans/v6/pe03MImSLYBIv1o4X1M8cc8-BP5qWVAgVol-.ttf',
      'NunitoSans-Black',
    );
    return font.getFont();
  }

  /// Nunito Sans 900italic
  static Future<Font> nunitoSansBlackItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/nunitosans/v6/pe01MImSLYBIv1o4X1M8cce4G1ptU1QCU5l-06Y.ttf',
      'NunitoSans-BlackItalic',
    );
    return font.getFont();
  }

  /// Odibee Sans regular
  static Future<Font> odibeeSansRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/odibeesans/v4/neIPzCSooYAho6WvjeToRYkyepH9qGsf.ttf',
      'OdibeeSans-Regular',
    );
    return font.getFont();
  }

  /// Odor Mean Chey regular
  static Future<Font> odorMeanCheyRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/odormeanchey/v14/raxkHiKDttkTe1aOGcJMR1A_4mrY2zqUKafv.ttf',
      'OdorMeanChey-Regular',
    );
    return font.getFont();
  }

  /// Offside regular
  static Future<Font> offsideRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/offside/v10/HI_KiYMWKa9QrAykQ5HiRp-dhpQ.ttf',
      'Offside-Regular',
    );
    return font.getFont();
  }

  /// Oi regular
  static Future<Font> oiRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/oi/v4/w8gXH2EuRqtaut6yjBOG.ttf',
      'Oi-Regular',
    );
    return font.getFont();
  }

  /// Old Standard TT regular
  static Future<Font> oldStandardTTRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/oldstandardtt/v13/MwQubh3o1vLImiwAVvYawgcf2eVurVC5RHdCZg.ttf',
      'OldStandardTT-Regular',
    );
    return font.getFont();
  }

  /// Old Standard TT italic
  static Future<Font> oldStandardTTItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/oldstandardtt/v13/MwQsbh3o1vLImiwAVvYawgcf2eVer1q9ZnJSZtQG.ttf',
      'OldStandardTT-Italic',
    );
    return font.getFont();
  }

  /// Old Standard TT 700
  static Future<Font> oldStandardTTBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/oldstandardtt/v13/MwQrbh3o1vLImiwAVvYawgcf2eVWEX-dTFxeb80flQ.ttf',
      'OldStandardTT-Bold',
    );
    return font.getFont();
  }

  /// Oldenburg regular
  static Future<Font> oldenburgRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/oldenburg/v10/fC1jPY5JYWzbywv7c4V6UU6oXyndrw.ttf',
      'Oldenburg-Regular',
    );
    return font.getFont();
  }

  /// Oleo Script regular
  static Future<Font> oleoScriptRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/oleoscript/v9/rax5HieDvtMOe0iICsUccBhasU7Q8Cad.ttf',
      'OleoScript-Regular',
    );
    return font.getFont();
  }

  /// Oleo Script 700
  static Future<Font> oleoScriptBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/oleoscript/v9/raxkHieDvtMOe0iICsUccCDmnmrY2zqUKafv.ttf',
      'OleoScript-Bold',
    );
    return font.getFont();
  }

  /// Oleo Script Swash Caps regular
  static Future<Font> oleoScriptSwashCapsRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/oleoscriptswashcaps/v8/Noaj6Vb-w5SFbTTAsZP_7JkCS08K-jCzDn_HMXquSY0Hg90.ttf',
      'OleoScriptSwashCaps-Regular',
    );
    return font.getFont();
  }

  /// Oleo Script Swash Caps 700
  static Future<Font> oleoScriptSwashCapsBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/oleoscriptswashcaps/v8/Noag6Vb-w5SFbTTAsZP_7JkCS08K-jCzDn_HCcaBbYUsn9T5dt0.ttf',
      'OleoScriptSwashCaps-Bold',
    );
    return font.getFont();
  }

  /// Open Sans 300
  static Future<Font> openSansLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/opensans/v20/mem5YaGs126MiZpBA-UN_r8-VeJoCqeDjg.ttf',
      'OpenSans-Light',
    );
    return font.getFont();
  }

  /// Open Sans 300italic
  static Future<Font> openSansLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/opensans/v20/memnYaGs126MiZpBA-UFUKWyV-hsKKKTjrPW.ttf',
      'OpenSans-LightItalic',
    );
    return font.getFont();
  }

  /// Open Sans regular
  static Future<Font> openSansRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/opensans/v20/mem8YaGs126MiZpBA-U1UpcaXcl0Aw.ttf',
      'OpenSans-Regular',
    );
    return font.getFont();
  }

  /// Open Sans italic
  static Future<Font> openSansItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/opensans/v20/mem6YaGs126MiZpBA-UFUJ0ef8xkA76a.ttf',
      'OpenSans-Italic',
    );
    return font.getFont();
  }

  /// Open Sans 600
  static Future<Font> openSansSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/opensans/v20/mem5YaGs126MiZpBA-UNirk-VeJoCqeDjg.ttf',
      'OpenSans-SemiBold',
    );
    return font.getFont();
  }

  /// Open Sans 600italic
  static Future<Font> openSansSemiBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/opensans/v20/memnYaGs126MiZpBA-UFUKXGUehsKKKTjrPW.ttf',
      'OpenSans-SemiBoldItalic',
    );
    return font.getFont();
  }

  /// Open Sans 700
  static Future<Font> openSansBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/opensans/v20/mem5YaGs126MiZpBA-UN7rg-VeJoCqeDjg.ttf',
      'OpenSans-Bold',
    );
    return font.getFont();
  }

  /// Open Sans 700italic
  static Future<Font> openSansBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/opensans/v20/memnYaGs126MiZpBA-UFUKWiUOhsKKKTjrPW.ttf',
      'OpenSans-BoldItalic',
    );
    return font.getFont();
  }

  /// Open Sans 800
  static Future<Font> openSansExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/opensans/v20/mem5YaGs126MiZpBA-UN8rs-VeJoCqeDjg.ttf',
      'OpenSans-ExtraBold',
    );
    return font.getFont();
  }

  /// Open Sans 800italic
  static Future<Font> openSansExtraBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/opensans/v20/memnYaGs126MiZpBA-UFUKW-U-hsKKKTjrPW.ttf',
      'OpenSans-ExtraBoldItalic',
    );
    return font.getFont();
  }

  /// Open Sans Condensed 300
  static Future<Font> openSansCondensedLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/opensanscondensed/v15/z7NFdQDnbTkabZAIOl9il_O6KJj73e7Ff1GhPuLGRpWRyAs.ttf',
      'OpenSansCondensed-Light',
    );
    return font.getFont();
  }

  /// Open Sans Condensed 300italic
  static Future<Font> openSansCondensedLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/opensanscondensed/v15/z7NHdQDnbTkabZAIOl9il_O6KJj73e7Fd_-7suDMQreU2AsJSg.ttf',
      'OpenSansCondensed-LightItalic',
    );
    return font.getFont();
  }

  /// Open Sans Condensed 700
  static Future<Font> openSansCondensedBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/opensanscondensed/v15/z7NFdQDnbTkabZAIOl9il_O6KJj73e7Ff0GmPuLGRpWRyAs.ttf',
      'OpenSansCondensed-Bold',
    );
    return font.getFont();
  }

  /// Oranienbaum regular
  static Future<Font> oranienbaumRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/oranienbaum/v9/OZpHg_txtzZKMuXLIVrx-3zn7kz3dpHc.ttf',
      'Oranienbaum-Regular',
    );
    return font.getFont();
  }

  /// Orbitron regular
  static Future<Font> orbitronRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/orbitron/v17/yMJMMIlzdpvBhQQL_SC3X9yhF25-T1nyGy6xpmIyXjU1pg.ttf',
      'Orbitron-Regular',
    );
    return font.getFont();
  }

  /// Orbitron 500
  static Future<Font> orbitronMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/orbitron/v17/yMJMMIlzdpvBhQQL_SC3X9yhF25-T1nyKS6xpmIyXjU1pg.ttf',
      'Orbitron-Medium',
    );
    return font.getFont();
  }

  /// Orbitron 600
  static Future<Font> orbitronSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/orbitron/v17/yMJMMIlzdpvBhQQL_SC3X9yhF25-T1nyxSmxpmIyXjU1pg.ttf',
      'Orbitron-SemiBold',
    );
    return font.getFont();
  }

  /// Orbitron 700
  static Future<Font> orbitronBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/orbitron/v17/yMJMMIlzdpvBhQQL_SC3X9yhF25-T1ny_CmxpmIyXjU1pg.ttf',
      'Orbitron-Bold',
    );
    return font.getFont();
  }

  /// Orbitron 800
  static Future<Font> orbitronExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/orbitron/v17/yMJMMIlzdpvBhQQL_SC3X9yhF25-T1nymymxpmIyXjU1pg.ttf',
      'Orbitron-ExtraBold',
    );
    return font.getFont();
  }

  /// Orbitron 900
  static Future<Font> orbitronBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/orbitron/v17/yMJMMIlzdpvBhQQL_SC3X9yhF25-T1nysimxpmIyXjU1pg.ttf',
      'Orbitron-Black',
    );
    return font.getFont();
  }

  /// Oregano regular
  static Future<Font> oreganoRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/oregano/v8/If2IXTPxciS3H4S2kZffPznO3yM.ttf',
      'Oregano-Regular',
    );
    return font.getFont();
  }

  /// Oregano italic
  static Future<Font> oreganoItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/oregano/v8/If2KXTPxciS3H4S2oZXVOxvLzyP_qw.ttf',
      'Oregano-Italic',
    );
    return font.getFont();
  }

  /// Orelega One regular
  static Future<Font> orelegaOneRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/orelegaone/v1/3qTpojOggD2XtAdFb-QXZGt61EcYaQ7F.ttf',
      'OrelegaOne-Regular',
    );
    return font.getFont();
  }

  /// Orienta regular
  static Future<Font> orientaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/orienta/v8/PlI9FlK4Jrl5Y9zNeyeo9HRFhcU.ttf',
      'Orienta-Regular',
    );
    return font.getFont();
  }

  /// Original Surfer regular
  static Future<Font> originalSurferRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/originalsurfer/v11/RWmQoKGZ9vIirYntXJ3_MbekzNMiDEtvAlaMKw.ttf',
      'OriginalSurfer-Regular',
    );
    return font.getFont();
  }

  /// Oswald 200
  static Future<Font> oswaldExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/oswald/v36/TK3_WkUHHAIjg75cFRf3bXL8LICs13FvgUFoZAaRliE.ttf',
      'Oswald-ExtraLight',
    );
    return font.getFont();
  }

  /// Oswald 300
  static Future<Font> oswaldLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/oswald/v36/TK3_WkUHHAIjg75cFRf3bXL8LICs169vgUFoZAaRliE.ttf',
      'Oswald-Light',
    );
    return font.getFont();
  }

  /// Oswald regular
  static Future<Font> oswaldRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/oswald/v36/TK3_WkUHHAIjg75cFRf3bXL8LICs1_FvgUFoZAaRliE.ttf',
      'Oswald-Regular',
    );
    return font.getFont();
  }

  /// Oswald 500
  static Future<Font> oswaldMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/oswald/v36/TK3_WkUHHAIjg75cFRf3bXL8LICs18NvgUFoZAaRliE.ttf',
      'Oswald-Medium',
    );
    return font.getFont();
  }

  /// Oswald 600
  static Future<Font> oswaldSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/oswald/v36/TK3_WkUHHAIjg75cFRf3bXL8LICs1y9ogUFoZAaRliE.ttf',
      'Oswald-SemiBold',
    );
    return font.getFont();
  }

  /// Oswald 700
  static Future<Font> oswaldBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/oswald/v36/TK3_WkUHHAIjg75cFRf3bXL8LICs1xZogUFoZAaRliE.ttf',
      'Oswald-Bold',
    );
    return font.getFont();
  }

  /// Over the Rainbow regular
  static Future<Font> overtheRainbowRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/overtherainbow/v11/11haGoXG1k_HKhMLUWz7Mc7vvW5upvOm9NA2XG0.ttf',
      'OvertheRainbow-Regular',
    );
    return font.getFont();
  }

  /// Overlock regular
  static Future<Font> overlockRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/overlock/v10/Z9XVDmdMWRiN1_T9Z4Te4u2El6GC.ttf',
      'Overlock-Regular',
    );
    return font.getFont();
  }

  /// Overlock italic
  static Future<Font> overlockItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/overlock/v10/Z9XTDmdMWRiN1_T9Z7Tc6OmmkrGC7Cs.ttf',
      'Overlock-Italic',
    );
    return font.getFont();
  }

  /// Overlock 700
  static Future<Font> overlockBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/overlock/v10/Z9XSDmdMWRiN1_T9Z7xizcmMvL2L9TLT.ttf',
      'Overlock-Bold',
    );
    return font.getFont();
  }

  /// Overlock 700italic
  static Future<Font> overlockBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/overlock/v10/Z9XQDmdMWRiN1_T9Z7Tc0FWJtrmp8CLTlNs.ttf',
      'Overlock-BoldItalic',
    );
    return font.getFont();
  }

  /// Overlock 900
  static Future<Font> overlockBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/overlock/v10/Z9XSDmdMWRiN1_T9Z7xaz8mMvL2L9TLT.ttf',
      'Overlock-Black',
    );
    return font.getFont();
  }

  /// Overlock 900italic
  static Future<Font> overlockBlackItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/overlock/v10/Z9XQDmdMWRiN1_T9Z7Tc0G2Ltrmp8CLTlNs.ttf',
      'Overlock-BlackItalic',
    );
    return font.getFont();
  }

  /// Overlock SC regular
  static Future<Font> overlockSCRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/overlocksc/v11/1cX3aUHKGZrstGAY8nwVzHGAq8Sk1PoH.ttf',
      'OverlockSC-Regular',
    );
    return font.getFont();
  }

  /// Overpass 100
  static Future<Font> overpassThin() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/overpass/v5/qFdB35WCmI96Ajtm81nGU97gxhcJk1s.ttf',
      'Overpass-Thin',
    );
    return font.getFont();
  }

  /// Overpass 100italic
  static Future<Font> overpassThinItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/overpass/v5/qFdD35WCmI96Ajtm81Gga7rqwjUMg1siNQ.ttf',
      'Overpass-ThinItalic',
    );
    return font.getFont();
  }

  /// Overpass 200
  static Future<Font> overpassExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/overpass/v5/qFdA35WCmI96Ajtm81lqcv7K6BsAikI7.ttf',
      'Overpass-ExtraLight',
    );
    return font.getFont();
  }

  /// Overpass 200italic
  static Future<Font> overpassExtraLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/overpass/v5/qFdC35WCmI96Ajtm81GgaxbL4h8ij1I7LLE.ttf',
      'Overpass-ExtraLightItalic',
    );
    return font.getFont();
  }

  /// Overpass 300
  static Future<Font> overpassLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/overpass/v5/qFdA35WCmI96Ajtm81kOcf7K6BsAikI7.ttf',
      'Overpass-Light',
    );
    return font.getFont();
  }

  /// Overpass 300italic
  static Future<Font> overpassLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/overpass/v5/qFdC35WCmI96Ajtm81Gga3LI4h8ij1I7LLE.ttf',
      'Overpass-LightItalic',
    );
    return font.getFont();
  }

  /// Overpass regular
  static Future<Font> overpassRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/overpass/v5/qFdH35WCmI96Ajtm82GiWdrCwwcJ.ttf',
      'Overpass-Regular',
    );
    return font.getFont();
  }

  /// Overpass italic
  static Future<Font> overpassItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/overpass/v5/qFdB35WCmI96Ajtm81GgU97gxhcJk1s.ttf',
      'Overpass-Italic',
    );
    return font.getFont();
  }

  /// Overpass 600
  static Future<Font> overpassSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/overpass/v5/qFdA35WCmI96Ajtm81l6d_7K6BsAikI7.ttf',
      'Overpass-SemiBold',
    );
    return font.getFont();
  }

  /// Overpass 600italic
  static Future<Font> overpassSemiBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/overpass/v5/qFdC35WCmI96Ajtm81GgawbO4h8ij1I7LLE.ttf',
      'Overpass-SemiBoldItalic',
    );
    return font.getFont();
  }

  /// Overpass 700
  static Future<Font> overpassBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/overpass/v5/qFdA35WCmI96Ajtm81kedv7K6BsAikI7.ttf',
      'Overpass-Bold',
    );
    return font.getFont();
  }

  /// Overpass 700italic
  static Future<Font> overpassBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/overpass/v5/qFdC35WCmI96Ajtm81Gga2LP4h8ij1I7LLE.ttf',
      'Overpass-BoldItalic',
    );
    return font.getFont();
  }

  /// Overpass 800
  static Future<Font> overpassExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/overpass/v5/qFdA35WCmI96Ajtm81kCdf7K6BsAikI7.ttf',
      'Overpass-ExtraBold',
    );
    return font.getFont();
  }

  /// Overpass 800italic
  static Future<Font> overpassExtraBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/overpass/v5/qFdC35WCmI96Ajtm81Gga37M4h8ij1I7LLE.ttf',
      'Overpass-ExtraBoldItalic',
    );
    return font.getFont();
  }

  /// Overpass 900
  static Future<Font> overpassBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/overpass/v5/qFdA35WCmI96Ajtm81kmdP7K6BsAikI7.ttf',
      'Overpass-Black',
    );
    return font.getFont();
  }

  /// Overpass 900italic
  static Future<Font> overpassBlackItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/overpass/v5/qFdC35WCmI96Ajtm81Gga1rN4h8ij1I7LLE.ttf',
      'Overpass-BlackItalic',
    );
    return font.getFont();
  }

  /// Overpass Mono 300
  static Future<Font> overpassMonoLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/overpassmono/v6/_Xm3-H86tzKDdAPa-KPQZ-AC3oSWk_edB3Zf8EQ.ttf',
      'OverpassMono-Light',
    );
    return font.getFont();
  }

  /// Overpass Mono regular
  static Future<Font> overpassMonoRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/overpassmono/v6/_Xmq-H86tzKDdAPa-KPQZ-AC5ii-t_-2G38.ttf',
      'OverpassMono-Regular',
    );
    return font.getFont();
  }

  /// Overpass Mono 600
  static Future<Font> overpassMonoSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/overpassmono/v6/_Xm3-H86tzKDdAPa-KPQZ-AC3vCQk_edB3Zf8EQ.ttf',
      'OverpassMono-SemiBold',
    );
    return font.getFont();
  }

  /// Overpass Mono 700
  static Future<Font> overpassMonoBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/overpassmono/v6/_Xm3-H86tzKDdAPa-KPQZ-AC3pSRk_edB3Zf8EQ.ttf',
      'OverpassMono-Bold',
    );
    return font.getFont();
  }

  /// Ovo regular
  static Future<Font> ovoRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ovo/v12/yYLl0h7Wyfzjy4Q5_3WVxA.ttf',
      'Ovo-Regular',
    );
    return font.getFont();
  }

  /// Oxanium 200
  static Future<Font> oxaniumExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/oxanium/v6/RrQPboN_4yJ0JmiMUW7sIGjd1IA9G83JfniMBXQ7d67x.ttf',
      'Oxanium-ExtraLight',
    );
    return font.getFont();
  }

  /// Oxanium 300
  static Future<Font> oxaniumLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/oxanium/v6/RrQPboN_4yJ0JmiMUW7sIGjd1IA9G80XfniMBXQ7d67x.ttf',
      'Oxanium-Light',
    );
    return font.getFont();
  }

  /// Oxanium regular
  static Future<Font> oxaniumRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/oxanium/v6/RrQPboN_4yJ0JmiMUW7sIGjd1IA9G81JfniMBXQ7d67x.ttf',
      'Oxanium-Regular',
    );
    return font.getFont();
  }

  /// Oxanium 500
  static Future<Font> oxaniumMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/oxanium/v6/RrQPboN_4yJ0JmiMUW7sIGjd1IA9G817fniMBXQ7d67x.ttf',
      'Oxanium-Medium',
    );
    return font.getFont();
  }

  /// Oxanium 600
  static Future<Font> oxaniumSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/oxanium/v6/RrQPboN_4yJ0JmiMUW7sIGjd1IA9G82XeXiMBXQ7d67x.ttf',
      'Oxanium-SemiBold',
    );
    return font.getFont();
  }

  /// Oxanium 700
  static Future<Font> oxaniumBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/oxanium/v6/RrQPboN_4yJ0JmiMUW7sIGjd1IA9G82ueXiMBXQ7d67x.ttf',
      'Oxanium-Bold',
    );
    return font.getFont();
  }

  /// Oxanium 800
  static Future<Font> oxaniumExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/oxanium/v6/RrQPboN_4yJ0JmiMUW7sIGjd1IA9G83JeXiMBXQ7d67x.ttf',
      'Oxanium-ExtraBold',
    );
    return font.getFont();
  }

  /// Oxygen 300
  static Future<Font> oxygenLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/oxygen/v10/2sDcZG1Wl4LcnbuCJW8Db2-4C7wFZQ.ttf',
      'Oxygen-Light',
    );
    return font.getFont();
  }

  /// Oxygen regular
  static Future<Font> oxygenRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/oxygen/v10/2sDfZG1Wl4Lcnbu6iUcnZ0SkAg.ttf',
      'Oxygen-Regular',
    );
    return font.getFont();
  }

  /// Oxygen 700
  static Future<Font> oxygenBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/oxygen/v10/2sDcZG1Wl4LcnbuCNWgDb2-4C7wFZQ.ttf',
      'Oxygen-Bold',
    );
    return font.getFont();
  }

  /// Oxygen Mono regular
  static Future<Font> oxygenMonoRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/oxygenmono/v8/h0GsssGg9FxgDgCjLeAd7ijfze-PPlUu.ttf',
      'OxygenMono-Regular',
    );
    return font.getFont();
  }

  /// PT Mono regular
  static Future<Font> pTMonoRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ptmono/v8/9oRONYoBnWILk-9ArCg5MtPyAcg.ttf',
      'PTMono-Regular',
    );
    return font.getFont();
  }

  /// PT Sans regular
  static Future<Font> pTSansRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ptsans/v12/jizaRExUiTo99u79P0WOxOGMMDQ.ttf',
      'PTSans-Regular',
    );
    return font.getFont();
  }

  /// PT Sans italic
  static Future<Font> pTSansItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ptsans/v12/jizYRExUiTo99u79D0eEwMOJIDQA-g.ttf',
      'PTSans-Italic',
    );
    return font.getFont();
  }

  /// PT Sans 700
  static Future<Font> pTSansBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ptsans/v12/jizfRExUiTo99u79B_mh4OmnLD0Z4zM.ttf',
      'PTSans-Bold',
    );
    return font.getFont();
  }

  /// PT Sans 700italic
  static Future<Font> pTSansBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ptsans/v12/jizdRExUiTo99u79D0e8fOytKB8c8zMrig.ttf',
      'PTSans-BoldItalic',
    );
    return font.getFont();
  }

  /// PT Sans Caption regular
  static Future<Font> pTSansCaptionRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ptsanscaption/v13/0FlMVP6Hrxmt7-fsUFhlFXNIlpcqfQXwQy6yxg.ttf',
      'PTSansCaption-Regular',
    );
    return font.getFont();
  }

  /// PT Sans Caption 700
  static Future<Font> pTSansCaptionBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ptsanscaption/v13/0FlJVP6Hrxmt7-fsUFhlFXNIlpcSwSrUSwWuz38Tgg.ttf',
      'PTSansCaption-Bold',
    );
    return font.getFont();
  }

  /// PT Sans Narrow regular
  static Future<Font> pTSansNarrowRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ptsansnarrow/v12/BngRUXNadjH0qYEzV7ab-oWlsYCByxyKeuDp.ttf',
      'PTSansNarrow-Regular',
    );
    return font.getFont();
  }

  /// PT Sans Narrow 700
  static Future<Font> pTSansNarrowBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ptsansnarrow/v12/BngSUXNadjH0qYEzV7ab-oWlsbg95DiCUfzgRd-3.ttf',
      'PTSansNarrow-Bold',
    );
    return font.getFont();
  }

  /// PT Serif regular
  static Future<Font> pTSerifRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ptserif/v12/EJRVQgYoZZY2vCFuvDFRxL6ddjb-.ttf',
      'PTSerif-Regular',
    );
    return font.getFont();
  }

  /// PT Serif italic
  static Future<Font> pTSerifItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ptserif/v12/EJRTQgYoZZY2vCFuvAFTzrq_cyb-vco.ttf',
      'PTSerif-Italic',
    );
    return font.getFont();
  }

  /// PT Serif 700
  static Future<Font> pTSerifBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ptserif/v12/EJRSQgYoZZY2vCFuvAnt65qVXSr3pNNB.ttf',
      'PTSerif-Bold',
    );
    return font.getFont();
  }

  /// PT Serif 700italic
  static Future<Font> pTSerifBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ptserif/v12/EJRQQgYoZZY2vCFuvAFT9gaQVy7VocNB6Iw.ttf',
      'PTSerif-BoldItalic',
    );
    return font.getFont();
  }

  /// PT Serif Caption regular
  static Future<Font> pTSerifCaptionRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ptserifcaption/v12/ieVl2ZhbGCW-JoW6S34pSDpqYKU059WxDCs5cvI.ttf',
      'PTSerifCaption-Regular',
    );
    return font.getFont();
  }

  /// PT Serif Caption italic
  static Future<Font> pTSerifCaptionItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ptserifcaption/v12/ieVj2ZhbGCW-JoW6S34pSDpqYKU019e7CAk8YvJEeg.ttf',
      'PTSerifCaption-Italic',
    );
    return font.getFont();
  }

  /// Pacifico regular
  static Future<Font> pacificoRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/pacifico/v17/FwZY7-Qmy14u9lezJ96A4sijpFu_.ttf',
      'Pacifico-Regular',
    );
    return font.getFont();
  }

  /// Padauk regular
  static Future<Font> padaukRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/padauk/v8/RrQRboJg-id7OnbBa0_g3LlYbg.ttf',
      'Padauk-Regular',
    );
    return font.getFont();
  }

  /// Padauk 700
  static Future<Font> padaukBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/padauk/v8/RrQSboJg-id7Onb512DE1JJEZ4YwGg.ttf',
      'Padauk-Bold',
    );
    return font.getFont();
  }

  /// Palanquin 100
  static Future<Font> palanquinThin() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/palanquin/v6/9XUhlJ90n1fBFg7ceXwUEltI7rWmZzTH.ttf',
      'Palanquin-Thin',
    );
    return font.getFont();
  }

  /// Palanquin 200
  static Future<Font> palanquinExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/palanquin/v6/9XUilJ90n1fBFg7ceXwUvnpoxJuqbi3ezg.ttf',
      'Palanquin-ExtraLight',
    );
    return font.getFont();
  }

  /// Palanquin 300
  static Future<Font> palanquinLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/palanquin/v6/9XUilJ90n1fBFg7ceXwU2nloxJuqbi3ezg.ttf',
      'Palanquin-Light',
    );
    return font.getFont();
  }

  /// Palanquin regular
  static Future<Font> palanquinRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/palanquin/v6/9XUnlJ90n1fBFg7ceXwsdlFMzLC2Zw.ttf',
      'Palanquin-Regular',
    );
    return font.getFont();
  }

  /// Palanquin 500
  static Future<Font> palanquinMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/palanquin/v6/9XUilJ90n1fBFg7ceXwUgnhoxJuqbi3ezg.ttf',
      'Palanquin-Medium',
    );
    return font.getFont();
  }

  /// Palanquin 600
  static Future<Font> palanquinSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/palanquin/v6/9XUilJ90n1fBFg7ceXwUrn9oxJuqbi3ezg.ttf',
      'Palanquin-SemiBold',
    );
    return font.getFont();
  }

  /// Palanquin 700
  static Future<Font> palanquinBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/palanquin/v6/9XUilJ90n1fBFg7ceXwUyn5oxJuqbi3ezg.ttf',
      'Palanquin-Bold',
    );
    return font.getFont();
  }

  /// Palanquin Dark regular
  static Future<Font> palanquinDarkRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/palanquindark/v7/xn75YHgl1nqmANMB-26xC7yuF_6OTEo9VtfE.ttf',
      'PalanquinDark-Regular',
    );
    return font.getFont();
  }

  /// Palanquin Dark 500
  static Future<Font> palanquinDarkMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/palanquindark/v7/xn76YHgl1nqmANMB-26xC7yuF8Z6ZW41fcvN2KT4.ttf',
      'PalanquinDark-Medium',
    );
    return font.getFont();
  }

  /// Palanquin Dark 600
  static Future<Font> palanquinDarkSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/palanquindark/v7/xn76YHgl1nqmANMB-26xC7yuF8ZWYm41fcvN2KT4.ttf',
      'PalanquinDark-SemiBold',
    );
    return font.getFont();
  }

  /// Palanquin Dark 700
  static Future<Font> palanquinDarkBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/palanquindark/v7/xn76YHgl1nqmANMB-26xC7yuF8YyY241fcvN2KT4.ttf',
      'PalanquinDark-Bold',
    );
    return font.getFont();
  }

  /// Pangolin regular
  static Future<Font> pangolinRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/pangolin/v6/cY9GfjGcW0FPpi-tWPfK5d3aiLBG.ttf',
      'Pangolin-Regular',
    );
    return font.getFont();
  }

  /// Paprika regular
  static Future<Font> paprikaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/paprika/v10/8QIJdijZitv49rDfuIgOq7jkAOw.ttf',
      'Paprika-Regular',
    );
    return font.getFont();
  }

  /// Parisienne regular
  static Future<Font> parisienneRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/parisienne/v8/E21i_d3kivvAkxhLEVZpcy96DuKuavM.ttf',
      'Parisienne-Regular',
    );
    return font.getFont();
  }

  /// Passero One regular
  static Future<Font> passeroOneRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/passeroone/v14/JTUTjIko8DOq5FeaeEAjgE5B5Arr-s50.ttf',
      'PasseroOne-Regular',
    );
    return font.getFont();
  }

  /// Passion One regular
  static Future<Font> passionOneRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/passionone/v11/PbynFmL8HhTPqbjUzux3JHuW_Frg6YoV.ttf',
      'PassionOne-Regular',
    );
    return font.getFont();
  }

  /// Passion One 700
  static Future<Font> passionOneBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/passionone/v11/Pby6FmL8HhTPqbjUzux3JEMq037owpYcuH8y.ttf',
      'PassionOne-Bold',
    );
    return font.getFont();
  }

  /// Passion One 900
  static Future<Font> passionOneBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/passionone/v11/Pby6FmL8HhTPqbjUzux3JEMS0X7owpYcuH8y.ttf',
      'PassionOne-Black',
    );
    return font.getFont();
  }

  /// Pathway Gothic One regular
  static Future<Font> pathwayGothicOneRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/pathwaygothicone/v9/MwQrbgD32-KAvjkYGNUUxAtW7pEBwx-dTFxeb80flQ.ttf',
      'PathwayGothicOne-Regular',
    );
    return font.getFont();
  }

  /// Patrick Hand regular
  static Future<Font> patrickHandRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/patrickhand/v14/LDI1apSQOAYtSuYWp8ZhfYeMWcjKm7sp8g.ttf',
      'PatrickHand-Regular',
    );
    return font.getFont();
  }

  /// Patrick Hand SC regular
  static Future<Font> patrickHandSCRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/patrickhandsc/v8/0nkwC9f7MfsBiWcLtY65AWDK873ViSi6JQc7Vg.ttf',
      'PatrickHandSC-Regular',
    );
    return font.getFont();
  }

  /// Pattaya regular
  static Future<Font> pattayaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/pattaya/v6/ea8ZadcqV_zkHY-XNdCn92ZEmVs.ttf',
      'Pattaya-Regular',
    );
    return font.getFont();
  }

  /// Patua One regular
  static Future<Font> patuaOneRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/patuaone/v11/ZXuke1cDvLCKLDcimxBI5PNvNA9LuA.ttf',
      'PatuaOne-Regular',
    );
    return font.getFont();
  }

  /// Pavanam regular
  static Future<Font> pavanamRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/pavanam/v5/BXRrvF_aiezLh0xPDOtQ9Wf0QcE.ttf',
      'Pavanam-Regular',
    );
    return font.getFont();
  }

  /// Paytone One regular
  static Future<Font> paytoneOneRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/paytoneone/v13/0nksC9P7MfYHj2oFtYm2CiTqivr9iBq_.ttf',
      'PaytoneOne-Regular',
    );
    return font.getFont();
  }

  /// Peddana regular
  static Future<Font> peddanaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/peddana/v10/aFTU7PBhaX89UcKWhh2aBYyMcKw.ttf',
      'Peddana-Regular',
    );
    return font.getFont();
  }

  /// Peralta regular
  static Future<Font> peraltaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/peralta/v10/hYkJPu0-RP_9d3kRGxAhrv956B8.ttf',
      'Peralta-Regular',
    );
    return font.getFont();
  }

  /// Permanent Marker regular
  static Future<Font> permanentMarkerRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/permanentmarker/v10/Fh4uPib9Iyv2ucM6pGQMWimMp004HaqIfrT5nlk.ttf',
      'PermanentMarker-Regular',
    );
    return font.getFont();
  }

  /// Petit Formal Script regular
  static Future<Font> petitFormalScriptRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/petitformalscript/v8/B50TF6xQr2TXJBnGOFME6u5OR83oRP5qoHnqP4gZSiE.ttf',
      'PetitFormalScript-Regular',
    );
    return font.getFont();
  }

  /// Petrona 100
  static Future<Font> petronaThin() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/petrona/v16/mtGl4_NXL7bZo9XXq35wRLONYyOjFk6NsARBH452Mvds.ttf',
      'Petrona-Thin',
    );
    return font.getFont();
  }

  /// Petrona 200
  static Future<Font> petronaExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/petrona/v16/mtGl4_NXL7bZo9XXq35wRLONYyOjFk4NsQRBH452Mvds.ttf',
      'Petrona-ExtraLight',
    );
    return font.getFont();
  }

  /// Petrona 300
  static Future<Font> petronaLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/petrona/v16/mtGl4_NXL7bZo9XXq35wRLONYyOjFk7TsQRBH452Mvds.ttf',
      'Petrona-Light',
    );
    return font.getFont();
  }

  /// Petrona regular
  static Future<Font> petronaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/petrona/v16/mtGl4_NXL7bZo9XXq35wRLONYyOjFk6NsQRBH452Mvds.ttf',
      'Petrona-Regular',
    );
    return font.getFont();
  }

  /// Petrona 500
  static Future<Font> petronaMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/petrona/v16/mtGl4_NXL7bZo9XXq35wRLONYyOjFk6_sQRBH452Mvds.ttf',
      'Petrona-Medium',
    );
    return font.getFont();
  }

  /// Petrona 600
  static Future<Font> petronaSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/petrona/v16/mtGl4_NXL7bZo9XXq35wRLONYyOjFk5TtgRBH452Mvds.ttf',
      'Petrona-SemiBold',
    );
    return font.getFont();
  }

  /// Petrona 700
  static Future<Font> petronaBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/petrona/v16/mtGl4_NXL7bZo9XXq35wRLONYyOjFk5qtgRBH452Mvds.ttf',
      'Petrona-Bold',
    );
    return font.getFont();
  }

  /// Petrona 800
  static Future<Font> petronaExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/petrona/v16/mtGl4_NXL7bZo9XXq35wRLONYyOjFk4NtgRBH452Mvds.ttf',
      'Petrona-ExtraBold',
    );
    return font.getFont();
  }

  /// Petrona 900
  static Future<Font> petronaBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/petrona/v16/mtGl4_NXL7bZo9XXq35wRLONYyOjFk4ktgRBH452Mvds.ttf',
      'Petrona-Black',
    );
    return font.getFont();
  }

  /// Petrona 100italic
  static Future<Font> petronaThinItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/petrona/v16/mtGr4_NXL7bZo9XXgXdCu2vkCLkNEVtF8uwDFYpUN-dsIWs.ttf',
      'Petrona-ThinItalic',
    );
    return font.getFont();
  }

  /// Petrona 200italic
  static Future<Font> petronaExtraLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/petrona/v16/mtGr4_NXL7bZo9XXgXdCu2vkCLkNEVtF8mwCFYpUN-dsIWs.ttf',
      'Petrona-ExtraLightItalic',
    );
    return font.getFont();
  }

  /// Petrona 300italic
  static Future<Font> petronaLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/petrona/v16/mtGr4_NXL7bZo9XXgXdCu2vkCLkNEVtF8rICFYpUN-dsIWs.ttf',
      'Petrona-LightItalic',
    );
    return font.getFont();
  }

  /// Petrona italic
  static Future<Font> petronaItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/petrona/v16/mtGr4_NXL7bZo9XXgXdCu2vkCLkNEVtF8uwCFYpUN-dsIWs.ttf',
      'Petrona-Italic',
    );
    return font.getFont();
  }

  /// Petrona 500italic
  static Future<Font> petronaMediumItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/petrona/v16/mtGr4_NXL7bZo9XXgXdCu2vkCLkNEVtF8t4CFYpUN-dsIWs.ttf',
      'Petrona-MediumItalic',
    );
    return font.getFont();
  }

  /// Petrona 600italic
  static Future<Font> petronaSemiBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/petrona/v16/mtGr4_NXL7bZo9XXgXdCu2vkCLkNEVtF8jIFFYpUN-dsIWs.ttf',
      'Petrona-SemiBoldItalic',
    );
    return font.getFont();
  }

  /// Petrona 700italic
  static Future<Font> petronaBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/petrona/v16/mtGr4_NXL7bZo9XXgXdCu2vkCLkNEVtF8gsFFYpUN-dsIWs.ttf',
      'Petrona-BoldItalic',
    );
    return font.getFont();
  }

  /// Petrona 800italic
  static Future<Font> petronaExtraBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/petrona/v16/mtGr4_NXL7bZo9XXgXdCu2vkCLkNEVtF8mwFFYpUN-dsIWs.ttf',
      'Petrona-ExtraBoldItalic',
    );
    return font.getFont();
  }

  /// Petrona 900italic
  static Future<Font> petronaBlackItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/petrona/v16/mtGr4_NXL7bZo9XXgXdCu2vkCLkNEVtF8kUFFYpUN-dsIWs.ttf',
      'Petrona-BlackItalic',
    );
    return font.getFont();
  }

  /// Philosopher regular
  static Future<Font> philosopherRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/philosopher/v14/vEFV2_5QCwIS4_Dhez5jcVBpRUwU08qe.ttf',
      'Philosopher-Regular',
    );
    return font.getFont();
  }

  /// Philosopher italic
  static Future<Font> philosopherItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/philosopher/v14/vEFX2_5QCwIS4_Dhez5jcWBrT0g21tqeR7c.ttf',
      'Philosopher-Italic',
    );
    return font.getFont();
  }

  /// Philosopher 700
  static Future<Font> philosopherBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/philosopher/v14/vEFI2_5QCwIS4_Dhez5jcWjVamgc-NaXXq7H.ttf',
      'Philosopher-Bold',
    );
    return font.getFont();
  }

  /// Philosopher 700italic
  static Future<Font> philosopherBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/philosopher/v14/vEFK2_5QCwIS4_Dhez5jcWBrd_QZ8tK1W77HtMo.ttf',
      'Philosopher-BoldItalic',
    );
    return font.getFont();
  }

  /// Piazzolla 100
  static Future<Font> piazzollaThin() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/piazzolla/v11/N0b52SlTPu5rIkWIZjVKKtYtfxYqZ4RJBFzFfYUjkSDdlqZgy7LYx3Ly1AHfAAy5.ttf',
      'Piazzolla-Thin',
    );
    return font.getFont();
  }

  /// Piazzolla 200
  static Future<Font> piazzollaExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/piazzolla/v11/N0b52SlTPu5rIkWIZjVKKtYtfxYqZ4RJBFzFfYUjkSDdlqZgy7JYxnLy1AHfAAy5.ttf',
      'Piazzolla-ExtraLight',
    );
    return font.getFont();
  }

  /// Piazzolla 300
  static Future<Font> piazzollaLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/piazzolla/v11/N0b52SlTPu5rIkWIZjVKKtYtfxYqZ4RJBFzFfYUjkSDdlqZgy7KGxnLy1AHfAAy5.ttf',
      'Piazzolla-Light',
    );
    return font.getFont();
  }

  /// Piazzolla regular
  static Future<Font> piazzollaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/piazzolla/v11/N0b52SlTPu5rIkWIZjVKKtYtfxYqZ4RJBFzFfYUjkSDdlqZgy7LYxnLy1AHfAAy5.ttf',
      'Piazzolla-Regular',
    );
    return font.getFont();
  }

  /// Piazzolla 500
  static Future<Font> piazzollaMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/piazzolla/v11/N0b52SlTPu5rIkWIZjVKKtYtfxYqZ4RJBFzFfYUjkSDdlqZgy7LqxnLy1AHfAAy5.ttf',
      'Piazzolla-Medium',
    );
    return font.getFont();
  }

  /// Piazzolla 600
  static Future<Font> piazzollaSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/piazzolla/v11/N0b52SlTPu5rIkWIZjVKKtYtfxYqZ4RJBFzFfYUjkSDdlqZgy7IGwXLy1AHfAAy5.ttf',
      'Piazzolla-SemiBold',
    );
    return font.getFont();
  }

  /// Piazzolla 700
  static Future<Font> piazzollaBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/piazzolla/v11/N0b52SlTPu5rIkWIZjVKKtYtfxYqZ4RJBFzFfYUjkSDdlqZgy7I_wXLy1AHfAAy5.ttf',
      'Piazzolla-Bold',
    );
    return font.getFont();
  }

  /// Piazzolla 800
  static Future<Font> piazzollaExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/piazzolla/v11/N0b52SlTPu5rIkWIZjVKKtYtfxYqZ4RJBFzFfYUjkSDdlqZgy7JYwXLy1AHfAAy5.ttf',
      'Piazzolla-ExtraBold',
    );
    return font.getFont();
  }

  /// Piazzolla 900
  static Future<Font> piazzollaBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/piazzolla/v11/N0b52SlTPu5rIkWIZjVKKtYtfxYqZ4RJBFzFfYUjkSDdlqZgy7JxwXLy1AHfAAy5.ttf',
      'Piazzolla-Black',
    );
    return font.getFont();
  }

  /// Piazzolla 100italic
  static Future<Font> piazzollaThinItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/piazzolla/v11/N0b72SlTPu5rIkWIZjVgI-TckS03oGpPETyEJ88Rbvi0_TzOzKcQhZqw3gX9BRy5m5M.ttf',
      'Piazzolla-ThinItalic',
    );
    return font.getFont();
  }

  /// Piazzolla 200italic
  static Future<Font> piazzollaExtraLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/piazzolla/v11/N0b72SlTPu5rIkWIZjVgI-TckS03oGpPETyEJ88Rbvi0_TzOzKcQhRqx3gX9BRy5m5M.ttf',
      'Piazzolla-ExtraLightItalic',
    );
    return font.getFont();
  }

  /// Piazzolla 300italic
  static Future<Font> piazzollaLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/piazzolla/v11/N0b72SlTPu5rIkWIZjVgI-TckS03oGpPETyEJ88Rbvi0_TzOzKcQhcSx3gX9BRy5m5M.ttf',
      'Piazzolla-LightItalic',
    );
    return font.getFont();
  }

  /// Piazzolla italic
  static Future<Font> piazzollaItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/piazzolla/v11/N0b72SlTPu5rIkWIZjVgI-TckS03oGpPETyEJ88Rbvi0_TzOzKcQhZqx3gX9BRy5m5M.ttf',
      'Piazzolla-Italic',
    );
    return font.getFont();
  }

  /// Piazzolla 500italic
  static Future<Font> piazzollaMediumItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/piazzolla/v11/N0b72SlTPu5rIkWIZjVgI-TckS03oGpPETyEJ88Rbvi0_TzOzKcQhaix3gX9BRy5m5M.ttf',
      'Piazzolla-MediumItalic',
    );
    return font.getFont();
  }

  /// Piazzolla 600italic
  static Future<Font> piazzollaSemiBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/piazzolla/v11/N0b72SlTPu5rIkWIZjVgI-TckS03oGpPETyEJ88Rbvi0_TzOzKcQhUS23gX9BRy5m5M.ttf',
      'Piazzolla-SemiBoldItalic',
    );
    return font.getFont();
  }

  /// Piazzolla 700italic
  static Future<Font> piazzollaBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/piazzolla/v11/N0b72SlTPu5rIkWIZjVgI-TckS03oGpPETyEJ88Rbvi0_TzOzKcQhX223gX9BRy5m5M.ttf',
      'Piazzolla-BoldItalic',
    );
    return font.getFont();
  }

  /// Piazzolla 800italic
  static Future<Font> piazzollaExtraBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/piazzolla/v11/N0b72SlTPu5rIkWIZjVgI-TckS03oGpPETyEJ88Rbvi0_TzOzKcQhRq23gX9BRy5m5M.ttf',
      'Piazzolla-ExtraBoldItalic',
    );
    return font.getFont();
  }

  /// Piazzolla 900italic
  static Future<Font> piazzollaBlackItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/piazzolla/v11/N0b72SlTPu5rIkWIZjVgI-TckS03oGpPETyEJ88Rbvi0_TzOzKcQhTO23gX9BRy5m5M.ttf',
      'Piazzolla-BlackItalic',
    );
    return font.getFont();
  }

  /// Piedra regular
  static Future<Font> piedraRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/piedra/v11/ke8kOg8aN0Bn7hTunEyHN_M3gA.ttf',
      'Piedra-Regular',
    );
    return font.getFont();
  }

  /// Pinyon Script regular
  static Future<Font> pinyonScriptRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/pinyonscript/v11/6xKpdSJbL9-e9LuoeQiDRQR8aOLQO4bhiDY.ttf',
      'PinyonScript-Regular',
    );
    return font.getFont();
  }

  /// Pirata One regular
  static Future<Font> pirataOneRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/pirataone/v11/I_urMpiDvgLdLh0fAtoftiiEr5_BdZ8.ttf',
      'PirataOne-Regular',
    );
    return font.getFont();
  }

  /// Plaster regular
  static Future<Font> plasterRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/plaster/v14/DdTm79QatW80eRh4Ei5JOtLOeLI.ttf',
      'Plaster-Regular',
    );
    return font.getFont();
  }

  /// Play regular
  static Future<Font> playRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/play/v12/6aez4K2oVqwIjtI8Hp8Tx3A.ttf',
      'Play-Regular',
    );
    return font.getFont();
  }

  /// Play 700
  static Future<Font> playBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/play/v12/6ae84K2oVqwItm4TOpc423nTJTM.ttf',
      'Play-Bold',
    );
    return font.getFont();
  }

  /// Playball regular
  static Future<Font> playballRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/playball/v10/TK3gWksYAxQ7jbsKcj8Dl-tPKo2t.ttf',
      'Playball-Regular',
    );
    return font.getFont();
  }

  /// Playfair Display regular
  static Future<Font> playfairDisplayRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/playfairdisplay/v22/nuFvD-vYSZviVYUb_rj3ij__anPXJzDwcbmjWBN2PKdFvUDQZNLo_U2r.ttf',
      'PlayfairDisplay-Regular',
    );
    return font.getFont();
  }

  /// Playfair Display 500
  static Future<Font> playfairDisplayMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/playfairdisplay/v22/nuFvD-vYSZviVYUb_rj3ij__anPXJzDwcbmjWBN2PKd3vUDQZNLo_U2r.ttf',
      'PlayfairDisplay-Medium',
    );
    return font.getFont();
  }

  /// Playfair Display 600
  static Future<Font> playfairDisplaySemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/playfairdisplay/v22/nuFvD-vYSZviVYUb_rj3ij__anPXJzDwcbmjWBN2PKebukDQZNLo_U2r.ttf',
      'PlayfairDisplay-SemiBold',
    );
    return font.getFont();
  }

  /// Playfair Display 700
  static Future<Font> playfairDisplayBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/playfairdisplay/v22/nuFvD-vYSZviVYUb_rj3ij__anPXJzDwcbmjWBN2PKeiukDQZNLo_U2r.ttf',
      'PlayfairDisplay-Bold',
    );
    return font.getFont();
  }

  /// Playfair Display 800
  static Future<Font> playfairDisplayExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/playfairdisplay/v22/nuFvD-vYSZviVYUb_rj3ij__anPXJzDwcbmjWBN2PKfFukDQZNLo_U2r.ttf',
      'PlayfairDisplay-ExtraBold',
    );
    return font.getFont();
  }

  /// Playfair Display 900
  static Future<Font> playfairDisplayBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/playfairdisplay/v22/nuFvD-vYSZviVYUb_rj3ij__anPXJzDwcbmjWBN2PKfsukDQZNLo_U2r.ttf',
      'PlayfairDisplay-Black',
    );
    return font.getFont();
  }

  /// Playfair Display italic
  static Future<Font> playfairDisplayItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/playfairdisplay/v22/nuFRD-vYSZviVYUb_rj3ij__anPXDTnCjmHKM4nYO7KN_qiTbtbK-F2rA0s.ttf',
      'PlayfairDisplay-Italic',
    );
    return font.getFont();
  }

  /// Playfair Display 500italic
  static Future<Font> playfairDisplayMediumItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/playfairdisplay/v22/nuFRD-vYSZviVYUb_rj3ij__anPXDTnCjmHKM4nYO7KN_pqTbtbK-F2rA0s.ttf',
      'PlayfairDisplay-MediumItalic',
    );
    return font.getFont();
  }

  /// Playfair Display 600italic
  static Future<Font> playfairDisplaySemiBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/playfairdisplay/v22/nuFRD-vYSZviVYUb_rj3ij__anPXDTnCjmHKM4nYO7KN_naUbtbK-F2rA0s.ttf',
      'PlayfairDisplay-SemiBoldItalic',
    );
    return font.getFont();
  }

  /// Playfair Display 700italic
  static Future<Font> playfairDisplayBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/playfairdisplay/v22/nuFRD-vYSZviVYUb_rj3ij__anPXDTnCjmHKM4nYO7KN_k-UbtbK-F2rA0s.ttf',
      'PlayfairDisplay-BoldItalic',
    );
    return font.getFont();
  }

  /// Playfair Display 800italic
  static Future<Font> playfairDisplayExtraBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/playfairdisplay/v22/nuFRD-vYSZviVYUb_rj3ij__anPXDTnCjmHKM4nYO7KN_iiUbtbK-F2rA0s.ttf',
      'PlayfairDisplay-ExtraBoldItalic',
    );
    return font.getFont();
  }

  /// Playfair Display 900italic
  static Future<Font> playfairDisplayBlackItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/playfairdisplay/v22/nuFRD-vYSZviVYUb_rj3ij__anPXDTnCjmHKM4nYO7KN_gGUbtbK-F2rA0s.ttf',
      'PlayfairDisplay-BlackItalic',
    );
    return font.getFont();
  }

  /// Playfair Display SC regular
  static Future<Font> playfairDisplaySCRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/playfairdisplaysc/v10/ke85OhoaMkR6-hSn7kbHVoFf7ZfgMPr_pb4GEcM2M4s.ttf',
      'PlayfairDisplaySC-Regular',
    );
    return font.getFont();
  }

  /// Playfair Display SC italic
  static Future<Font> playfairDisplaySCItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/playfairdisplaysc/v10/ke87OhoaMkR6-hSn7kbHVoFf7ZfgMPr_lbwMFeEzI4sNKg.ttf',
      'PlayfairDisplaySC-Italic',
    );
    return font.getFont();
  }

  /// Playfair Display SC 700
  static Future<Font> playfairDisplaySCBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/playfairdisplaysc/v10/ke80OhoaMkR6-hSn7kbHVoFf7ZfgMPr_nQIpNcsdL4IUMyE.ttf',
      'PlayfairDisplaySC-Bold',
    );
    return font.getFont();
  }

  /// Playfair Display SC 700italic
  static Future<Font> playfairDisplaySCBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/playfairdisplaysc/v10/ke82OhoaMkR6-hSn7kbHVoFf7ZfgMPr_lbw0qc4XK6ARIyH5IA.ttf',
      'PlayfairDisplaySC-BoldItalic',
    );
    return font.getFont();
  }

  /// Playfair Display SC 900
  static Future<Font> playfairDisplaySCBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/playfairdisplaysc/v10/ke80OhoaMkR6-hSn7kbHVoFf7ZfgMPr_nTorNcsdL4IUMyE.ttf',
      'PlayfairDisplaySC-Black',
    );
    return font.getFont();
  }

  /// Playfair Display SC 900italic
  static Future<Font> playfairDisplaySCBlackItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/playfairdisplaysc/v10/ke82OhoaMkR6-hSn7kbHVoFf7ZfgMPr_lbw0kcwXK6ARIyH5IA.ttf',
      'PlayfairDisplaySC-BlackItalic',
    );
    return font.getFont();
  }

  /// Podkova regular
  static Future<Font> podkovaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/podkova/v18/K2FufZ1EmftJSV9VQpXb1lo9vC3nZWtFzcU4EoporSHH.ttf',
      'Podkova-Regular',
    );
    return font.getFont();
  }

  /// Podkova 500
  static Future<Font> podkovaMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/podkova/v18/K2FufZ1EmftJSV9VQpXb1lo9vC3nZWt3zcU4EoporSHH.ttf',
      'Podkova-Medium',
    );
    return font.getFont();
  }

  /// Podkova 600
  static Future<Font> podkovaSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/podkova/v18/K2FufZ1EmftJSV9VQpXb1lo9vC3nZWubysU4EoporSHH.ttf',
      'Podkova-SemiBold',
    );
    return font.getFont();
  }

  /// Podkova 700
  static Future<Font> podkovaBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/podkova/v18/K2FufZ1EmftJSV9VQpXb1lo9vC3nZWuiysU4EoporSHH.ttf',
      'Podkova-Bold',
    );
    return font.getFont();
  }

  /// Podkova 800
  static Future<Font> podkovaExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/podkova/v18/K2FufZ1EmftJSV9VQpXb1lo9vC3nZWvFysU4EoporSHH.ttf',
      'Podkova-ExtraBold',
    );
    return font.getFont();
  }

  /// Poiret One regular
  static Future<Font> poiretOneRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/poiretone/v9/UqyVK80NJXN4zfRgbdfbk5lWVscxdKE.ttf',
      'PoiretOne-Regular',
    );
    return font.getFont();
  }

  /// Poller One regular
  static Future<Font> pollerOneRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/pollerone/v12/ahccv82n0TN3gia5E4Bud-lbgUS5u0s.ttf',
      'PollerOne-Regular',
    );
    return font.getFont();
  }

  /// Poly regular
  static Future<Font> polyRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/poly/v11/MQpb-W6wKNitRLCAq2Lpris.ttf',
      'Poly-Regular',
    );
    return font.getFont();
  }

  /// Poly italic
  static Future<Font> polyItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/poly/v11/MQpV-W6wKNitdLKKr0DsviuGWA.ttf',
      'Poly-Italic',
    );
    return font.getFont();
  }

  /// Pompiere regular
  static Future<Font> pompiereRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/pompiere/v10/VEMyRoxis5Dwuyeov6Wt5jDtreOL.ttf',
      'Pompiere-Regular',
    );
    return font.getFont();
  }

  /// Pontano Sans regular
  static Future<Font> pontanoSansRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/pontanosans/v8/qFdD35GdgYR8EzR6oBLDHa3qwjUMg1siNQ.ttf',
      'PontanoSans-Regular',
    );
    return font.getFont();
  }

  /// Poor Story regular
  static Future<Font> poorStoryRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/poorstory/v10/jizfREFUsnUct9P6cDfd4OmnLD0Z4zM.ttf',
      'PoorStory-Regular',
    );
    return font.getFont();
  }

  /// Poppins 100
  static Future<Font> poppinsThin() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/poppins/v15/pxiGyp8kv8JHgFVrLPTed3FBGPaTSQ.ttf',
      'Poppins-Thin',
    );
    return font.getFont();
  }

  /// Poppins 100italic
  static Future<Font> poppinsThinItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/poppins/v15/pxiAyp8kv8JHgFVrJJLmE3tFOvODSVFF.ttf',
      'Poppins-ThinItalic',
    );
    return font.getFont();
  }

  /// Poppins 200
  static Future<Font> poppinsExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/poppins/v15/pxiByp8kv8JHgFVrLFj_V1tvFP-KUEg.ttf',
      'Poppins-ExtraLight',
    );
    return font.getFont();
  }

  /// Poppins 200italic
  static Future<Font> poppinsExtraLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/poppins/v15/pxiDyp8kv8JHgFVrJJLmv1plEN2PQEhcqw.ttf',
      'Poppins-ExtraLightItalic',
    );
    return font.getFont();
  }

  /// Poppins 300
  static Future<Font> poppinsLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/poppins/v15/pxiByp8kv8JHgFVrLDz8V1tvFP-KUEg.ttf',
      'Poppins-Light',
    );
    return font.getFont();
  }

  /// Poppins 300italic
  static Future<Font> poppinsLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/poppins/v15/pxiDyp8kv8JHgFVrJJLm21llEN2PQEhcqw.ttf',
      'Poppins-LightItalic',
    );
    return font.getFont();
  }

  /// Poppins regular
  static Future<Font> poppinsRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/poppins/v15/pxiEyp8kv8JHgFVrFJDUc1NECPY.ttf',
      'Poppins-Regular',
    );
    return font.getFont();
  }

  /// Poppins italic
  static Future<Font> poppinsItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/poppins/v15/pxiGyp8kv8JHgFVrJJLed3FBGPaTSQ.ttf',
      'Poppins-Italic',
    );
    return font.getFont();
  }

  /// Poppins 500
  static Future<Font> poppinsMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/poppins/v15/pxiByp8kv8JHgFVrLGT9V1tvFP-KUEg.ttf',
      'Poppins-Medium',
    );
    return font.getFont();
  }

  /// Poppins 500italic
  static Future<Font> poppinsMediumItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/poppins/v15/pxiDyp8kv8JHgFVrJJLmg1hlEN2PQEhcqw.ttf',
      'Poppins-MediumItalic',
    );
    return font.getFont();
  }

  /// Poppins 600
  static Future<Font> poppinsSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/poppins/v15/pxiByp8kv8JHgFVrLEj6V1tvFP-KUEg.ttf',
      'Poppins-SemiBold',
    );
    return font.getFont();
  }

  /// Poppins 600italic
  static Future<Font> poppinsSemiBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/poppins/v15/pxiDyp8kv8JHgFVrJJLmr19lEN2PQEhcqw.ttf',
      'Poppins-SemiBoldItalic',
    );
    return font.getFont();
  }

  /// Poppins 700
  static Future<Font> poppinsBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/poppins/v15/pxiByp8kv8JHgFVrLCz7V1tvFP-KUEg.ttf',
      'Poppins-Bold',
    );
    return font.getFont();
  }

  /// Poppins 700italic
  static Future<Font> poppinsBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/poppins/v15/pxiDyp8kv8JHgFVrJJLmy15lEN2PQEhcqw.ttf',
      'Poppins-BoldItalic',
    );
    return font.getFont();
  }

  /// Poppins 800
  static Future<Font> poppinsExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/poppins/v15/pxiByp8kv8JHgFVrLDD4V1tvFP-KUEg.ttf',
      'Poppins-ExtraBold',
    );
    return font.getFont();
  }

  /// Poppins 800italic
  static Future<Font> poppinsExtraBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/poppins/v15/pxiDyp8kv8JHgFVrJJLm111lEN2PQEhcqw.ttf',
      'Poppins-ExtraBoldItalic',
    );
    return font.getFont();
  }

  /// Poppins 900
  static Future<Font> poppinsBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/poppins/v15/pxiByp8kv8JHgFVrLBT5V1tvFP-KUEg.ttf',
      'Poppins-Black',
    );
    return font.getFont();
  }

  /// Poppins 900italic
  static Future<Font> poppinsBlackItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/poppins/v15/pxiDyp8kv8JHgFVrJJLm81xlEN2PQEhcqw.ttf',
      'Poppins-BlackItalic',
    );
    return font.getFont();
  }

  /// Port Lligat Sans regular
  static Future<Font> portLligatSansRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/portlligatsans/v11/kmKmZrYrGBbdN1aV7Vokow6Lw4s4l7N0Tx4xEcQ.ttf',
      'PortLligatSans-Regular',
    );
    return font.getFont();
  }

  /// Port Lligat Slab regular
  static Future<Font> portLligatSlabRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/portlligatslab/v11/LDIpaoiQNgArA8kR7ulhZ8P_NYOss7ob9yGLmfI.ttf',
      'PortLligatSlab-Regular',
    );
    return font.getFont();
  }

  /// Potta One regular
  static Future<Font> pottaOneRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/pottaone/v6/FeVSS05Bp6cy7xI-YfxQ3Z5nm29Gww.ttf',
      'PottaOne-Regular',
    );
    return font.getFont();
  }

  /// Pragati Narrow regular
  static Future<Font> pragatiNarrowRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/pragatinarrow/v8/vm8vdRf0T0bS1ffgsPB7WZ-mD17_ytN3M48a.ttf',
      'PragatiNarrow-Regular',
    );
    return font.getFont();
  }

  /// Pragati Narrow 700
  static Future<Font> pragatiNarrowBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/pragatinarrow/v8/vm8sdRf0T0bS1ffgsPB7WZ-mD2ZD5fd_GJMTlo_4.ttf',
      'PragatiNarrow-Bold',
    );
    return font.getFont();
  }

  /// Prata regular
  static Future<Font> prataRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/prata/v13/6xKhdSpbNNCT-vWIAG_5LWwJ.ttf',
      'Prata-Regular',
    );
    return font.getFont();
  }

  /// Preahvihear regular
  static Future<Font> preahvihearRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/preahvihear/v14/6NUS8F-dNQeEYhzj7uluxswE49FJf8Wv.ttf',
      'Preahvihear-Regular',
    );
    return font.getFont();
  }

  /// Press Start 2P regular
  static Future<Font> pressStart2PRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/pressstart2p/v9/e3t4euO8T-267oIAQAu6jDQyK0nSgPJE4580.ttf',
      'PressStart2P-Regular',
    );
    return font.getFont();
  }

  /// Pridi 200
  static Future<Font> pridiExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/pridi/v6/2sDdZG5JnZLfkc1SiE0jRUG0AqUc.ttf',
      'Pridi-ExtraLight',
    );
    return font.getFont();
  }

  /// Pridi 300
  static Future<Font> pridiLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/pridi/v6/2sDdZG5JnZLfkc02i00jRUG0AqUc.ttf',
      'Pridi-Light',
    );
    return font.getFont();
  }

  /// Pridi regular
  static Future<Font> pridiRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/pridi/v6/2sDQZG5JnZLfkfWao2krbl29.ttf',
      'Pridi-Regular',
    );
    return font.getFont();
  }

  /// Pridi 500
  static Future<Font> pridiMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/pridi/v6/2sDdZG5JnZLfkc1uik0jRUG0AqUc.ttf',
      'Pridi-Medium',
    );
    return font.getFont();
  }

  /// Pridi 600
  static Future<Font> pridiSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/pridi/v6/2sDdZG5JnZLfkc1CjU0jRUG0AqUc.ttf',
      'Pridi-SemiBold',
    );
    return font.getFont();
  }

  /// Pridi 700
  static Future<Font> pridiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/pridi/v6/2sDdZG5JnZLfkc0mjE0jRUG0AqUc.ttf',
      'Pridi-Bold',
    );
    return font.getFont();
  }

  /// Princess Sofia regular
  static Future<Font> princessSofiaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/princesssofia/v11/qWczB6yguIb8DZ_GXZst16n7GRz7mDUoupoI.ttf',
      'PrincessSofia-Regular',
    );
    return font.getFont();
  }

  /// Prociono regular
  static Future<Font> procionoRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/prociono/v12/r05YGLlR-KxAf9GGO8upyDYtStiJ.ttf',
      'Prociono-Regular',
    );
    return font.getFont();
  }

  /// Prompt 100
  static Future<Font> promptThin() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/prompt/v5/-W_9XJnvUD7dzB2CA9oYREcjeo0k.ttf',
      'Prompt-Thin',
    );
    return font.getFont();
  }

  /// Prompt 100italic
  static Future<Font> promptThinItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/prompt/v5/-W_7XJnvUD7dzB2KZeJ8TkMBf50kbiM.ttf',
      'Prompt-ThinItalic',
    );
    return font.getFont();
  }

  /// Prompt 200
  static Future<Font> promptExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/prompt/v5/-W_8XJnvUD7dzB2Cr_s4bmkvc5Q9dw.ttf',
      'Prompt-ExtraLight',
    );
    return font.getFont();
  }

  /// Prompt 200italic
  static Future<Font> promptExtraLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/prompt/v5/-W_6XJnvUD7dzB2KZeLQb2MrUZEtdzow.ttf',
      'Prompt-ExtraLightItalic',
    );
    return font.getFont();
  }

  /// Prompt 300
  static Future<Font> promptLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/prompt/v5/-W_8XJnvUD7dzB2Cy_g4bmkvc5Q9dw.ttf',
      'Prompt-Light',
    );
    return font.getFont();
  }

  /// Prompt 300italic
  static Future<Font> promptLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/prompt/v5/-W_6XJnvUD7dzB2KZeK0bGMrUZEtdzow.ttf',
      'Prompt-LightItalic',
    );
    return font.getFont();
  }

  /// Prompt regular
  static Future<Font> promptRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/prompt/v5/-W__XJnvUD7dzB26Z9AcZkIzeg.ttf',
      'Prompt-Regular',
    );
    return font.getFont();
  }

  /// Prompt italic
  static Future<Font> promptItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/prompt/v5/-W_9XJnvUD7dzB2KZdoYREcjeo0k.ttf',
      'Prompt-Italic',
    );
    return font.getFont();
  }

  /// Prompt 500
  static Future<Font> promptMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/prompt/v5/-W_8XJnvUD7dzB2Ck_k4bmkvc5Q9dw.ttf',
      'Prompt-Medium',
    );
    return font.getFont();
  }

  /// Prompt 500italic
  static Future<Font> promptMediumItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/prompt/v5/-W_6XJnvUD7dzB2KZeLsbWMrUZEtdzow.ttf',
      'Prompt-MediumItalic',
    );
    return font.getFont();
  }

  /// Prompt 600
  static Future<Font> promptSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/prompt/v5/-W_8XJnvUD7dzB2Cv_44bmkvc5Q9dw.ttf',
      'Prompt-SemiBold',
    );
    return font.getFont();
  }

  /// Prompt 600italic
  static Future<Font> promptSemiBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/prompt/v5/-W_6XJnvUD7dzB2KZeLAamMrUZEtdzow.ttf',
      'Prompt-SemiBoldItalic',
    );
    return font.getFont();
  }

  /// Prompt 700
  static Future<Font> promptBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/prompt/v5/-W_8XJnvUD7dzB2C2_84bmkvc5Q9dw.ttf',
      'Prompt-Bold',
    );
    return font.getFont();
  }

  /// Prompt 700italic
  static Future<Font> promptBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/prompt/v5/-W_6XJnvUD7dzB2KZeKka2MrUZEtdzow.ttf',
      'Prompt-BoldItalic',
    );
    return font.getFont();
  }

  /// Prompt 800
  static Future<Font> promptExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/prompt/v5/-W_8XJnvUD7dzB2Cx_w4bmkvc5Q9dw.ttf',
      'Prompt-ExtraBold',
    );
    return font.getFont();
  }

  /// Prompt 800italic
  static Future<Font> promptExtraBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/prompt/v5/-W_6XJnvUD7dzB2KZeK4aGMrUZEtdzow.ttf',
      'Prompt-ExtraBoldItalic',
    );
    return font.getFont();
  }

  /// Prompt 900
  static Future<Font> promptBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/prompt/v5/-W_8XJnvUD7dzB2C4_04bmkvc5Q9dw.ttf',
      'Prompt-Black',
    );
    return font.getFont();
  }

  /// Prompt 900italic
  static Future<Font> promptBlackItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/prompt/v5/-W_6XJnvUD7dzB2KZeKcaWMrUZEtdzow.ttf',
      'Prompt-BlackItalic',
    );
    return font.getFont();
  }

  /// Prosto One regular
  static Future<Font> prostoOneRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/prostoone/v11/OpNJno4VhNfK-RgpwWWxpipfWhXD00c.ttf',
      'ProstoOne-Regular',
    );
    return font.getFont();
  }

  /// Proza Libre regular
  static Future<Font> prozaLibreRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/prozalibre/v5/LYjGdGHgj0k1DIQRyUEyyHovftvXWYyz.ttf',
      'ProzaLibre-Regular',
    );
    return font.getFont();
  }

  /// Proza Libre italic
  static Future<Font> prozaLibreItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/prozalibre/v5/LYjEdGHgj0k1DIQRyUEyyEotdN_1XJyz7zc.ttf',
      'ProzaLibre-Italic',
    );
    return font.getFont();
  }

  /// Proza Libre 500
  static Future<Font> prozaLibreMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/prozalibre/v5/LYjbdGHgj0k1DIQRyUEyyELbV__fcpC69i6N.ttf',
      'ProzaLibre-Medium',
    );
    return font.getFont();
  }

  /// Proza Libre 500italic
  static Future<Font> prozaLibreMediumItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/prozalibre/v5/LYjZdGHgj0k1DIQRyUEyyEotTCvceJSY8z6Np1k.ttf',
      'ProzaLibre-MediumItalic',
    );
    return font.getFont();
  }

  /// Proza Libre 600
  static Future<Font> prozaLibreSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/prozalibre/v5/LYjbdGHgj0k1DIQRyUEyyEL3UP_fcpC69i6N.ttf',
      'ProzaLibre-SemiBold',
    );
    return font.getFont();
  }

  /// Proza Libre 600italic
  static Future<Font> prozaLibreSemiBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/prozalibre/v5/LYjZdGHgj0k1DIQRyUEyyEotTAfbeJSY8z6Np1k.ttf',
      'ProzaLibre-SemiBoldItalic',
    );
    return font.getFont();
  }

  /// Proza Libre 700
  static Future<Font> prozaLibreBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/prozalibre/v5/LYjbdGHgj0k1DIQRyUEyyEKTUf_fcpC69i6N.ttf',
      'ProzaLibre-Bold',
    );
    return font.getFont();
  }

  /// Proza Libre 700italic
  static Future<Font> prozaLibreBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/prozalibre/v5/LYjZdGHgj0k1DIQRyUEyyEotTGPaeJSY8z6Np1k.ttf',
      'ProzaLibre-BoldItalic',
    );
    return font.getFont();
  }

  /// Proza Libre 800
  static Future<Font> prozaLibreExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/prozalibre/v5/LYjbdGHgj0k1DIQRyUEyyEKPUv_fcpC69i6N.ttf',
      'ProzaLibre-ExtraBold',
    );
    return font.getFont();
  }

  /// Proza Libre 800italic
  static Future<Font> prozaLibreExtraBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/prozalibre/v5/LYjZdGHgj0k1DIQRyUEyyEotTH_ZeJSY8z6Np1k.ttf',
      'ProzaLibre-ExtraBoldItalic',
    );
    return font.getFont();
  }

  /// Public Sans 100
  static Future<Font> publicSansThin() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/publicsans/v5/ijwGs572Xtc6ZYQws9YVwllKVG8qX1oyOymuFpi5ww0pX189fg.ttf',
      'PublicSans-Thin',
    );
    return font.getFont();
  }

  /// Public Sans 200
  static Future<Font> publicSansExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/publicsans/v5/ijwGs572Xtc6ZYQws9YVwllKVG8qX1oyOymulpm5ww0pX189fg.ttf',
      'PublicSans-ExtraLight',
    );
    return font.getFont();
  }

  /// Public Sans 300
  static Future<Font> publicSansLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/publicsans/v5/ijwGs572Xtc6ZYQws9YVwllKVG8qX1oyOymuSJm5ww0pX189fg.ttf',
      'PublicSans-Light',
    );
    return font.getFont();
  }

  /// Public Sans regular
  static Future<Font> publicSansRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/publicsans/v5/ijwGs572Xtc6ZYQws9YVwllKVG8qX1oyOymuFpm5ww0pX189fg.ttf',
      'PublicSans-Regular',
    );
    return font.getFont();
  }

  /// Public Sans 500
  static Future<Font> publicSansMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/publicsans/v5/ijwGs572Xtc6ZYQws9YVwllKVG8qX1oyOymuJJm5ww0pX189fg.ttf',
      'PublicSans-Medium',
    );
    return font.getFont();
  }

  /// Public Sans 600
  static Future<Font> publicSansSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/publicsans/v5/ijwGs572Xtc6ZYQws9YVwllKVG8qX1oyOymuyJ65ww0pX189fg.ttf',
      'PublicSans-SemiBold',
    );
    return font.getFont();
  }

  /// Public Sans 700
  static Future<Font> publicSansBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/publicsans/v5/ijwGs572Xtc6ZYQws9YVwllKVG8qX1oyOymu8Z65ww0pX189fg.ttf',
      'PublicSans-Bold',
    );
    return font.getFont();
  }

  /// Public Sans 800
  static Future<Font> publicSansExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/publicsans/v5/ijwGs572Xtc6ZYQws9YVwllKVG8qX1oyOymulp65ww0pX189fg.ttf',
      'PublicSans-ExtraBold',
    );
    return font.getFont();
  }

  /// Public Sans 900
  static Future<Font> publicSansBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/publicsans/v5/ijwGs572Xtc6ZYQws9YVwllKVG8qX1oyOymuv565ww0pX189fg.ttf',
      'PublicSans-Black',
    );
    return font.getFont();
  }

  /// Public Sans 100italic
  static Future<Font> publicSansThinItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/publicsans/v5/ijwAs572Xtc6ZYQws9YVwnNDZpDyNjGolS673tpRgQctfVotfj7j.ttf',
      'PublicSans-ThinItalic',
    );
    return font.getFont();
  }

  /// Public Sans 200italic
  static Future<Font> publicSansExtraLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/publicsans/v5/ijwAs572Xtc6ZYQws9YVwnNDZpDyNjGolS673trRgActfVotfj7j.ttf',
      'PublicSans-ExtraLightItalic',
    );
    return font.getFont();
  }

  /// Public Sans 300italic
  static Future<Font> publicSansLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/publicsans/v5/ijwAs572Xtc6ZYQws9YVwnNDZpDyNjGolS673toPgActfVotfj7j.ttf',
      'PublicSans-LightItalic',
    );
    return font.getFont();
  }

  /// Public Sans italic
  static Future<Font> publicSansItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/publicsans/v5/ijwAs572Xtc6ZYQws9YVwnNDZpDyNjGolS673tpRgActfVotfj7j.ttf',
      'PublicSans-Italic',
    );
    return font.getFont();
  }

  /// Public Sans 500italic
  static Future<Font> publicSansMediumItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/publicsans/v5/ijwAs572Xtc6ZYQws9YVwnNDZpDyNjGolS673tpjgActfVotfj7j.ttf',
      'PublicSans-MediumItalic',
    );
    return font.getFont();
  }

  /// Public Sans 600italic
  static Future<Font> publicSansSemiBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/publicsans/v5/ijwAs572Xtc6ZYQws9YVwnNDZpDyNjGolS673tqPhwctfVotfj7j.ttf',
      'PublicSans-SemiBoldItalic',
    );
    return font.getFont();
  }

  /// Public Sans 700italic
  static Future<Font> publicSansBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/publicsans/v5/ijwAs572Xtc6ZYQws9YVwnNDZpDyNjGolS673tq2hwctfVotfj7j.ttf',
      'PublicSans-BoldItalic',
    );
    return font.getFont();
  }

  /// Public Sans 800italic
  static Future<Font> publicSansExtraBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/publicsans/v5/ijwAs572Xtc6ZYQws9YVwnNDZpDyNjGolS673trRhwctfVotfj7j.ttf',
      'PublicSans-ExtraBoldItalic',
    );
    return font.getFont();
  }

  /// Public Sans 900italic
  static Future<Font> publicSansBlackItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/publicsans/v5/ijwAs572Xtc6ZYQws9YVwnNDZpDyNjGolS673tr4hwctfVotfj7j.ttf',
      'PublicSans-BlackItalic',
    );
    return font.getFont();
  }

  /// Puritan regular
  static Future<Font> puritanRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/puritan/v14/845YNMgkAJ2VTtIo9JrwRdaI50M.ttf',
      'Puritan-Regular',
    );
    return font.getFont();
  }

  /// Puritan italic
  static Future<Font> puritanItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/puritan/v14/845aNMgkAJ2VTtIoxJj6QfSN90PfXA.ttf',
      'Puritan-Italic',
    );
    return font.getFont();
  }

  /// Puritan 700
  static Future<Font> puritanBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/puritan/v14/845dNMgkAJ2VTtIozCbfYd6j-0rGRes.ttf',
      'Puritan-Bold',
    );
    return font.getFont();
  }

  /// Puritan 700italic
  static Future<Font> puritanBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/puritan/v14/845fNMgkAJ2VTtIoxJjC_dup_2jDVevnLQ.ttf',
      'Puritan-BoldItalic',
    );
    return font.getFont();
  }

  /// Purple Purse regular
  static Future<Font> purplePurseRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/purplepurse/v11/qWctB66gv53iAp-Vfs4My6qyeBb_ujA4ug.ttf',
      'PurplePurse-Regular',
    );
    return font.getFont();
  }

  /// Quando regular
  static Future<Font> quandoRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/quando/v9/xMQVuFNaVa6YuW0pC6WzKX_QmA.ttf',
      'Quando-Regular',
    );
    return font.getFont();
  }

  /// Quantico regular
  static Future<Font> quanticoRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/quantico/v10/rax-HiSdp9cPL3KIF4xsLjxSmlLZ.ttf',
      'Quantico-Regular',
    );
    return font.getFont();
  }

  /// Quantico italic
  static Future<Font> quanticoItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/quantico/v10/rax4HiSdp9cPL3KIF7xuJDhwn0LZ6T8.ttf',
      'Quantico-Italic',
    );
    return font.getFont();
  }

  /// Quantico 700
  static Future<Font> quanticoBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/quantico/v10/rax5HiSdp9cPL3KIF7TQARhasU7Q8Cad.ttf',
      'Quantico-Bold',
    );
    return font.getFont();
  }

  /// Quantico 700italic
  static Future<Font> quanticoBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/quantico/v10/rax7HiSdp9cPL3KIF7xuHIRfu0ry9TadML4.ttf',
      'Quantico-BoldItalic',
    );
    return font.getFont();
  }

  /// Quattrocento regular
  static Future<Font> quattrocentoRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/quattrocento/v12/OZpEg_xvsDZQL_LKIF7q4jPHxGL7f4jFuA.ttf',
      'Quattrocento-Regular',
    );
    return font.getFont();
  }

  /// Quattrocento 700
  static Future<Font> quattrocentoBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/quattrocento/v12/OZpbg_xvsDZQL_LKIF7q4jP_eE3fd6PZsXcM9w.ttf',
      'Quattrocento-Bold',
    );
    return font.getFont();
  }

  /// Quattrocento Sans regular
  static Future<Font> quattrocentoSansRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/quattrocentosans/v13/va9c4lja2NVIDdIAAoMR5MfuElaRB3zOvU7eHGHJ.ttf',
      'QuattrocentoSans-Regular',
    );
    return font.getFont();
  }

  /// Quattrocento Sans italic
  static Future<Font> quattrocentoSansItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/quattrocentosans/v13/va9a4lja2NVIDdIAAoMR5MfuElaRB0zMt0r8GXHJkLI.ttf',
      'QuattrocentoSans-Italic',
    );
    return font.getFont();
  }

  /// Quattrocento Sans 700
  static Future<Font> quattrocentoSansBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/quattrocentosans/v13/va9Z4lja2NVIDdIAAoMR5MfuElaRB0RykmrWN33AiasJ.ttf',
      'QuattrocentoSans-Bold',
    );
    return font.getFont();
  }

  /// Quattrocento Sans 700italic
  static Future<Font> quattrocentoSansBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/quattrocentosans/v13/va9X4lja2NVIDdIAAoMR5MfuElaRB0zMj_bTPXnijLsJV7E.ttf',
      'QuattrocentoSans-BoldItalic',
    );
    return font.getFont();
  }

  /// Questrial regular
  static Future<Font> questrialRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/questrial/v13/QdVUSTchPBm7nuUeVf7EuStkm20oJA.ttf',
      'Questrial-Regular',
    );
    return font.getFont();
  }

  /// Quicksand 300
  static Future<Font> quicksandLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/quicksand/v22/6xK-dSZaM9iE8KbpRA_LJ3z8mH9BOJvgkKEo18G0wx40QDw.ttf',
      'Quicksand-Light',
    );
    return font.getFont();
  }

  /// Quicksand regular
  static Future<Font> quicksandRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/quicksand/v22/6xK-dSZaM9iE8KbpRA_LJ3z8mH9BOJvgkP8o18G0wx40QDw.ttf',
      'Quicksand-Regular',
    );
    return font.getFont();
  }

  /// Quicksand 500
  static Future<Font> quicksandMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/quicksand/v22/6xK-dSZaM9iE8KbpRA_LJ3z8mH9BOJvgkM0o18G0wx40QDw.ttf',
      'Quicksand-Medium',
    );
    return font.getFont();
  }

  /// Quicksand 600
  static Future<Font> quicksandSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/quicksand/v22/6xK-dSZaM9iE8KbpRA_LJ3z8mH9BOJvgkCEv18G0wx40QDw.ttf',
      'Quicksand-SemiBold',
    );
    return font.getFont();
  }

  /// Quicksand 700
  static Future<Font> quicksandBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/quicksand/v22/6xK-dSZaM9iE8KbpRA_LJ3z8mH9BOJvgkBgv18G0wx40QDw.ttf',
      'Quicksand-Bold',
    );
    return font.getFont();
  }

  /// Quintessential regular
  static Future<Font> quintessentialRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/quintessential/v10/fdNn9sOGq31Yjnh3qWU14DdtjY5wS7kmAyxM.ttf',
      'Quintessential-Regular',
    );
    return font.getFont();
  }

  /// Qwigley regular
  static Future<Font> qwigleyRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/qwigley/v10/1cXzaU3UGJb5tGoCuVxsi1mBmcE.ttf',
      'Qwigley-Regular',
    );
    return font.getFont();
  }

  /// Racing Sans One regular
  static Future<Font> racingSansOneRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/racingsansone/v8/sykr-yRtm7EvTrXNxkv5jfKKyDCwL3rmWpIBtA.ttf',
      'RacingSansOne-Regular',
    );
    return font.getFont();
  }

  /// Radley regular
  static Future<Font> radleyRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/radley/v15/LYjDdGzinEIjCN19oAlEpVs3VQ.ttf',
      'Radley-Regular',
    );
    return font.getFont();
  }

  /// Radley italic
  static Future<Font> radleyItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/radley/v15/LYjBdGzinEIjCN1NogNAh14nVcfe.ttf',
      'Radley-Italic',
    );
    return font.getFont();
  }

  /// Rajdhani 300
  static Future<Font> rajdhaniLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/rajdhani/v10/LDI2apCSOBg7S-QT7pasEcOsc-bGkqIw.ttf',
      'Rajdhani-Light',
    );
    return font.getFont();
  }

  /// Rajdhani regular
  static Future<Font> rajdhaniRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/rajdhani/v10/LDIxapCSOBg7S-QT7q4AOeekWPrP.ttf',
      'Rajdhani-Regular',
    );
    return font.getFont();
  }

  /// Rajdhani 500
  static Future<Font> rajdhaniMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/rajdhani/v10/LDI2apCSOBg7S-QT7pb0EMOsc-bGkqIw.ttf',
      'Rajdhani-Medium',
    );
    return font.getFont();
  }

  /// Rajdhani 600
  static Future<Font> rajdhaniSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/rajdhani/v10/LDI2apCSOBg7S-QT7pbYF8Osc-bGkqIw.ttf',
      'Rajdhani-SemiBold',
    );
    return font.getFont();
  }

  /// Rajdhani 700
  static Future<Font> rajdhaniBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/rajdhani/v10/LDI2apCSOBg7S-QT7pa8FsOsc-bGkqIw.ttf',
      'Rajdhani-Bold',
    );
    return font.getFont();
  }

  /// Rakkas regular
  static Future<Font> rakkasRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/rakkas/v12/Qw3cZQlNHiblL3j_lttPOeMcCw.ttf',
      'Rakkas-Regular',
    );
    return font.getFont();
  }

  /// Raleway 100
  static Future<Font> ralewayThin() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/raleway/v19/1Ptxg8zYS_SKggPN4iEgvnHyvveLxVvao4CPNLA3JC9c.ttf',
      'Raleway-Thin',
    );
    return font.getFont();
  }

  /// Raleway 200
  static Future<Font> ralewayExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/raleway/v19/1Ptxg8zYS_SKggPN4iEgvnHyvveLxVtaooCPNLA3JC9c.ttf',
      'Raleway-ExtraLight',
    );
    return font.getFont();
  }

  /// Raleway 300
  static Future<Font> ralewayLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/raleway/v19/1Ptxg8zYS_SKggPN4iEgvnHyvveLxVuEooCPNLA3JC9c.ttf',
      'Raleway-Light',
    );
    return font.getFont();
  }

  /// Raleway regular
  static Future<Font> ralewayRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/raleway/v19/1Ptxg8zYS_SKggPN4iEgvnHyvveLxVvaooCPNLA3JC9c.ttf',
      'Raleway-Regular',
    );
    return font.getFont();
  }

  /// Raleway 500
  static Future<Font> ralewayMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/raleway/v19/1Ptxg8zYS_SKggPN4iEgvnHyvveLxVvoooCPNLA3JC9c.ttf',
      'Raleway-Medium',
    );
    return font.getFont();
  }

  /// Raleway 600
  static Future<Font> ralewaySemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/raleway/v19/1Ptxg8zYS_SKggPN4iEgvnHyvveLxVsEpYCPNLA3JC9c.ttf',
      'Raleway-SemiBold',
    );
    return font.getFont();
  }

  /// Raleway 700
  static Future<Font> ralewayBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/raleway/v19/1Ptxg8zYS_SKggPN4iEgvnHyvveLxVs9pYCPNLA3JC9c.ttf',
      'Raleway-Bold',
    );
    return font.getFont();
  }

  /// Raleway 800
  static Future<Font> ralewayExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/raleway/v19/1Ptxg8zYS_SKggPN4iEgvnHyvveLxVtapYCPNLA3JC9c.ttf',
      'Raleway-ExtraBold',
    );
    return font.getFont();
  }

  /// Raleway 900
  static Future<Font> ralewayBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/raleway/v19/1Ptxg8zYS_SKggPN4iEgvnHyvveLxVtzpYCPNLA3JC9c.ttf',
      'Raleway-Black',
    );
    return font.getFont();
  }

  /// Raleway 100italic
  static Future<Font> ralewayThinItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/raleway/v19/1Pt_g8zYS_SKggPNyCgSQamb1W0lwk4S4WjNPrQVIT9c2c8.ttf',
      'Raleway-ThinItalic',
    );
    return font.getFont();
  }

  /// Raleway 200italic
  static Future<Font> ralewayExtraLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/raleway/v19/1Pt_g8zYS_SKggPNyCgSQamb1W0lwk4S4ejMPrQVIT9c2c8.ttf',
      'Raleway-ExtraLightItalic',
    );
    return font.getFont();
  }

  /// Raleway 300italic
  static Future<Font> ralewayLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/raleway/v19/1Pt_g8zYS_SKggPNyCgSQamb1W0lwk4S4TbMPrQVIT9c2c8.ttf',
      'Raleway-LightItalic',
    );
    return font.getFont();
  }

  /// Raleway italic
  static Future<Font> ralewayItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/raleway/v19/1Pt_g8zYS_SKggPNyCgSQamb1W0lwk4S4WjMPrQVIT9c2c8.ttf',
      'Raleway-Italic',
    );
    return font.getFont();
  }

  /// Raleway 500italic
  static Future<Font> ralewayMediumItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/raleway/v19/1Pt_g8zYS_SKggPNyCgSQamb1W0lwk4S4VrMPrQVIT9c2c8.ttf',
      'Raleway-MediumItalic',
    );
    return font.getFont();
  }

  /// Raleway 600italic
  static Future<Font> ralewaySemiBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/raleway/v19/1Pt_g8zYS_SKggPNyCgSQamb1W0lwk4S4bbLPrQVIT9c2c8.ttf',
      'Raleway-SemiBoldItalic',
    );
    return font.getFont();
  }

  /// Raleway 700italic
  static Future<Font> ralewayBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/raleway/v19/1Pt_g8zYS_SKggPNyCgSQamb1W0lwk4S4Y_LPrQVIT9c2c8.ttf',
      'Raleway-BoldItalic',
    );
    return font.getFont();
  }

  /// Raleway 800italic
  static Future<Font> ralewayExtraBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/raleway/v19/1Pt_g8zYS_SKggPNyCgSQamb1W0lwk4S4ejLPrQVIT9c2c8.ttf',
      'Raleway-ExtraBoldItalic',
    );
    return font.getFont();
  }

  /// Raleway 900italic
  static Future<Font> ralewayBlackItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/raleway/v19/1Pt_g8zYS_SKggPNyCgSQamb1W0lwk4S4cHLPrQVIT9c2c8.ttf',
      'Raleway-BlackItalic',
    );
    return font.getFont();
  }

  /// Raleway Dots regular
  static Future<Font> ralewayDotsRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ralewaydots/v8/6NUR8FifJg6AfQvzpshgwJ8kyf9Fdty2ew.ttf',
      'RalewayDots-Regular',
    );
    return font.getFont();
  }

  /// Ramabhadra regular
  static Future<Font> ramabhadraRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ramabhadra/v10/EYq2maBOwqRW9P1SQ83LehNGX5uWw3o.ttf',
      'Ramabhadra-Regular',
    );
    return font.getFont();
  }

  /// Ramaraja regular
  static Future<Font> ramarajaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ramaraja/v7/SlGTmQearpYAYG1CABIkqnB6aSQU.ttf',
      'Ramaraja-Regular',
    );
    return font.getFont();
  }

  /// Rambla regular
  static Future<Font> ramblaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/rambla/v8/snfrs0ip98hx6mr0I7IONthkwQ.ttf',
      'Rambla-Regular',
    );
    return font.getFont();
  }

  /// Rambla italic
  static Future<Font> ramblaItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/rambla/v8/snfps0ip98hx6mrEIbgKFN10wYKa.ttf',
      'Rambla-Italic',
    );
    return font.getFont();
  }

  /// Rambla 700
  static Future<Font> ramblaBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/rambla/v8/snfos0ip98hx6mrMn50qPvN4yJuDYQ.ttf',
      'Rambla-Bold',
    );
    return font.getFont();
  }

  /// Rambla 700italic
  static Future<Font> ramblaBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/rambla/v8/snfus0ip98hx6mrEIYC2O_l86p6TYS-Y.ttf',
      'Rambla-BoldItalic',
    );
    return font.getFont();
  }

  /// Rammetto One regular
  static Future<Font> rammettoOneRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/rammettoone/v9/LhWiMV3HOfMbMetJG3lQDpp9Mvuciu-_SQ.ttf',
      'RammettoOne-Regular',
    );
    return font.getFont();
  }

  /// Ranchers regular
  static Future<Font> ranchersRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ranchers/v8/zrfm0H3Lx-P2Xvs2AoDYDC79XTHv.ttf',
      'Ranchers-Regular',
    );
    return font.getFont();
  }

  /// Rancho regular
  static Future<Font> ranchoRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/rancho/v11/46kulbzmXjLaqZRlbWXgd0RY1g.ttf',
      'Rancho-Regular',
    );
    return font.getFont();
  }

  /// Ranga regular
  static Future<Font> rangaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ranga/v8/C8ct4cYisGb28p6CLDwZwmGE.ttf',
      'Ranga-Regular',
    );
    return font.getFont();
  }

  /// Ranga 700
  static Future<Font> rangaBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ranga/v8/C8cg4cYisGb28qY-AxgR6X2NZAn2.ttf',
      'Ranga-Bold',
    );
    return font.getFont();
  }

  /// Rasa 300
  static Future<Font> rasaLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/rasa/v6/xn7gYHIn1mWmdg52sgC7S9XdZN8.ttf',
      'Rasa-Light',
    );
    return font.getFont();
  }

  /// Rasa regular
  static Future<Font> rasaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/rasa/v6/xn7vYHIn1mWmTqJelgiQV9w.ttf',
      'Rasa-Regular',
    );
    return font.getFont();
  }

  /// Rasa 500
  static Future<Font> rasaMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/rasa/v6/xn7gYHIn1mWmdlZ3sgC7S9XdZN8.ttf',
      'Rasa-Medium',
    );
    return font.getFont();
  }

  /// Rasa 600
  static Future<Font> rasaSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/rasa/v6/xn7gYHIn1mWmdnpwsgC7S9XdZN8.ttf',
      'Rasa-SemiBold',
    );
    return font.getFont();
  }

  /// Rasa 700
  static Future<Font> rasaBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/rasa/v6/xn7gYHIn1mWmdh5xsgC7S9XdZN8.ttf',
      'Rasa-Bold',
    );
    return font.getFont();
  }

  /// Rationale regular
  static Future<Font> rationaleRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/rationale/v14/9XUnlJ92n0_JFxHIfHcsdlFMzLC2Zw.ttf',
      'Rationale-Regular',
    );
    return font.getFont();
  }

  /// Ravi Prakash regular
  static Future<Font> raviPrakashRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/raviprakash/v9/gokpH6fsDkVrF9Bv9X8SOAKHmNZEq6TTFw.ttf',
      'RaviPrakash-Regular',
    );
    return font.getFont();
  }

  /// Recursive 300
  static Future<Font> recursiveLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/recursive/v23/8vJN7wMr0mhh-RQChyHEH06TlXhq_gukbYrFMk1QuAIcyEwG_X-dpEfaE5YaERmK-CImKsvxvU-MXGX2fSqasNfUvz2xbXfn1uEQadDck018vwxjDJCL.ttf',
      'Recursive-Light',
    );
    return font.getFont();
  }

  /// Recursive regular
  static Future<Font> recursiveRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/recursive/v23/8vJN7wMr0mhh-RQChyHEH06TlXhq_gukbYrFMk1QuAIcyEwG_X-dpEfaE5YaERmK-CImKsvxvU-MXGX2fSqasNfUvz2xbXfn1uEQadCCk018vwxjDJCL.ttf',
      'Recursive-Regular',
    );
    return font.getFont();
  }

  /// Recursive 500
  static Future<Font> recursiveMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/recursive/v23/8vJN7wMr0mhh-RQChyHEH06TlXhq_gukbYrFMk1QuAIcyEwG_X-dpEfaE5YaERmK-CImKsvxvU-MXGX2fSqasNfUvz2xbXfn1uEQadCwk018vwxjDJCL.ttf',
      'Recursive-Medium',
    );
    return font.getFont();
  }

  /// Recursive 600
  static Future<Font> recursiveSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/recursive/v23/8vJN7wMr0mhh-RQChyHEH06TlXhq_gukbYrFMk1QuAIcyEwG_X-dpEfaE5YaERmK-CImKsvxvU-MXGX2fSqasNfUvz2xbXfn1uEQadBclE18vwxjDJCL.ttf',
      'Recursive-SemiBold',
    );
    return font.getFont();
  }

  /// Recursive 700
  static Future<Font> recursiveBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/recursive/v23/8vJN7wMr0mhh-RQChyHEH06TlXhq_gukbYrFMk1QuAIcyEwG_X-dpEfaE5YaERmK-CImKsvxvU-MXGX2fSqasNfUvz2xbXfn1uEQadBllE18vwxjDJCL.ttf',
      'Recursive-Bold',
    );
    return font.getFont();
  }

  /// Recursive 800
  static Future<Font> recursiveExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/recursive/v23/8vJN7wMr0mhh-RQChyHEH06TlXhq_gukbYrFMk1QuAIcyEwG_X-dpEfaE5YaERmK-CImKsvxvU-MXGX2fSqasNfUvz2xbXfn1uEQadAClE18vwxjDJCL.ttf',
      'Recursive-ExtraBold',
    );
    return font.getFont();
  }

  /// Recursive 900
  static Future<Font> recursiveBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/recursive/v23/8vJN7wMr0mhh-RQChyHEH06TlXhq_gukbYrFMk1QuAIcyEwG_X-dpEfaE5YaERmK-CImKsvxvU-MXGX2fSqasNfUvz2xbXfn1uEQadArlE18vwxjDJCL.ttf',
      'Recursive-Black',
    );
    return font.getFont();
  }

  /// Red Hat Display regular
  static Future<Font> redHatDisplayRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/redhatdisplay/v4/8vIQ7wUr0m80wwYf0QCXZzYzUoTQ-jSgZYvdCQ.ttf',
      'RedHatDisplay-Regular',
    );
    return font.getFont();
  }

  /// Red Hat Display italic
  static Future<Font> redHatDisplayItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/redhatdisplay/v4/8vIS7wUr0m80wwYf0QCXZzYzUoTg-D6kR47NCV5Z.ttf',
      'RedHatDisplay-Italic',
    );
    return font.getFont();
  }

  /// Red Hat Display 500
  static Future<Font> redHatDisplayMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/redhatdisplay/v4/8vIV7wUr0m80wwYf0QCXZzYzUoToDh2EbaDBAEdAbw.ttf',
      'RedHatDisplay-Medium',
    );
    return font.getFont();
  }

  /// Red Hat Display 500italic
  static Future<Font> redHatDisplayMediumItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/redhatdisplay/v4/8vIX7wUr0m80wwYf0QCXZzYzUoTg-AZQbqrFIkJQb7zU.ttf',
      'RedHatDisplay-MediumItalic',
    );
    return font.getFont();
  }

  /// Red Hat Display 700
  static Future<Font> redHatDisplayBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/redhatdisplay/v4/8vIV7wUr0m80wwYf0QCXZzYzUoToRhuEbaDBAEdAbw.ttf',
      'RedHatDisplay-Bold',
    );
    return font.getFont();
  }

  /// Red Hat Display 700italic
  static Future<Font> redHatDisplayBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/redhatdisplay/v4/8vIX7wUr0m80wwYf0QCXZzYzUoTg-AYYaKrFIkJQb7zU.ttf',
      'RedHatDisplay-BoldItalic',
    );
    return font.getFont();
  }

  /// Red Hat Display 900
  static Future<Font> redHatDisplayBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/redhatdisplay/v4/8vIV7wUr0m80wwYf0QCXZzYzUoTofhmEbaDBAEdAbw.ttf',
      'RedHatDisplay-Black',
    );
    return font.getFont();
  }

  /// Red Hat Display 900italic
  static Future<Font> redHatDisplayBlackItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/redhatdisplay/v4/8vIX7wUr0m80wwYf0QCXZzYzUoTg-AYgaqrFIkJQb7zU.ttf',
      'RedHatDisplay-BlackItalic',
    );
    return font.getFont();
  }

  /// Red Hat Text regular
  static Future<Font> redHatTextRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/redhattext/v3/RrQXbohi_ic6B3yVSzGBrMxgb60sE8yZPA.ttf',
      'RedHatText-Regular',
    );
    return font.getFont();
  }

  /// Red Hat Text italic
  static Future<Font> redHatTextItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/redhattext/v3/RrQJbohi_ic6B3yVSzGBrMxQbacoMcmJPECN.ttf',
      'RedHatText-Italic',
    );
    return font.getFont();
  }

  /// Red Hat Text 500
  static Future<Font> redHatTextMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/redhattext/v3/RrQIbohi_ic6B3yVSzGBrMxYm4QIG-eFNVmULg.ttf',
      'RedHatText-Medium',
    );
    return font.getFont();
  }

  /// Red Hat Text 500italic
  static Future<Font> redHatTextMediumItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/redhattext/v3/RrQKbohi_ic6B3yVSzGBrMxQbZ_cGO2BF1yELmgy.ttf',
      'RedHatText-MediumItalic',
    );
    return font.getFont();
  }

  /// Red Hat Text 700
  static Future<Font> redHatTextBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/redhattext/v3/RrQIbohi_ic6B3yVSzGBrMxY04IIG-eFNVmULg.ttf',
      'RedHatText-Bold',
    );
    return font.getFont();
  }

  /// Red Hat Text 700italic
  static Future<Font> redHatTextBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/redhattext/v3/RrQKbohi_ic6B3yVSzGBrMxQbZ-UHu2BF1yELmgy.ttf',
      'RedHatText-BoldItalic',
    );
    return font.getFont();
  }

  /// Red Rose 300
  static Future<Font> redRoseLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/redrose/v8/QdVISTYiLBjouPgEUajvsfWwDtc3MH8y8_sDcjSsYUVUjg.ttf',
      'RedRose-Light',
    );
    return font.getFont();
  }

  /// Red Rose regular
  static Future<Font> redRoseRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/redrose/v8/QdVISTYiLBjouPgEUajvsfWwDtc3MH8yrfsDcjSsYUVUjg.ttf',
      'RedRose-Regular',
    );
    return font.getFont();
  }

  /// Red Rose 500
  static Future<Font> redRoseMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/redrose/v8/QdVISTYiLBjouPgEUajvsfWwDtc3MH8yn_sDcjSsYUVUjg.ttf',
      'RedRose-Medium',
    );
    return font.getFont();
  }

  /// Red Rose 600
  static Future<Font> redRoseSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/redrose/v8/QdVISTYiLBjouPgEUajvsfWwDtc3MH8yc_wDcjSsYUVUjg.ttf',
      'RedRose-SemiBold',
    );
    return font.getFont();
  }

  /// Red Rose 700
  static Future<Font> redRoseBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/redrose/v8/QdVISTYiLBjouPgEUajvsfWwDtc3MH8ySvwDcjSsYUVUjg.ttf',
      'RedRose-Bold',
    );
    return font.getFont();
  }

  /// Redressed regular
  static Future<Font> redressedRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/redressed/v13/x3dickHUbrmJ7wMy9MsBfPACvy_1BA.ttf',
      'Redressed-Regular',
    );
    return font.getFont();
  }

  /// Reem Kufi regular
  static Future<Font> reemKufiRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/reemkufi/v10/2sDcZGJLip7W2J7v7wQDb2-4C7wFZQ.ttf',
      'ReemKufi-Regular',
    );
    return font.getFont();
  }

  /// Reenie Beanie regular
  static Future<Font> reenieBeanieRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/reeniebeanie/v11/z7NSdR76eDkaJKZJFkkjuvWxbP2_qoOgf_w.ttf',
      'ReenieBeanie-Regular',
    );
    return font.getFont();
  }

  /// Reggae One regular
  static Future<Font> reggaeOneRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/reggaeone/v3/7r3DqX5msMIkeuwJwOJt_a5L5uH-mts.ttf',
      'ReggaeOne-Regular',
    );
    return font.getFont();
  }

  /// Revalia regular
  static Future<Font> revaliaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/revalia/v9/WwkexPimBE2-4ZPEeVruNIgJSNM.ttf',
      'Revalia-Regular',
    );
    return font.getFont();
  }

  /// Rhodium Libre regular
  static Future<Font> rhodiumLibreRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/rhodiumlibre/v7/1q2AY5adA0tn_ukeHcQHqpx6pETLeo2gm2U.ttf',
      'RhodiumLibre-Regular',
    );
    return font.getFont();
  }

  /// Ribeye regular
  static Future<Font> ribeyeRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ribeye/v11/L0x8DFMxk1MP9R3RvPCmRSlUig.ttf',
      'Ribeye-Regular',
    );
    return font.getFont();
  }

  /// Ribeye Marrow regular
  static Future<Font> ribeyeMarrowRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ribeyemarrow/v12/GFDsWApshnqMRO2JdtRZ2d0vEAwTVWgKdtw.ttf',
      'RibeyeMarrow-Regular',
    );
    return font.getFont();
  }

  /// Righteous regular
  static Future<Font> righteousRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/righteous/v9/1cXxaUPXBpj2rGoU7C9mj3uEicG01A.ttf',
      'Righteous-Regular',
    );
    return font.getFont();
  }

  /// Risque regular
  static Future<Font> risqueRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/risque/v10/VdGfAZUfHosahXxoCUYVBJ-T5g.ttf',
      'Risque-Regular',
    );
    return font.getFont();
  }

  /// Roboto 100
  static Future<Font> robotoThin() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/roboto/v27/KFOkCnqEu92Fr1MmgWxPKTM1K9nz.ttf',
      'Roboto-Thin',
    );
    return font.getFont();
  }

  /// Roboto 100italic
  static Future<Font> robotoThinItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/roboto/v27/KFOiCnqEu92Fr1Mu51QrIzcXLsnzjYk.ttf',
      'Roboto-ThinItalic',
    );
    return font.getFont();
  }

  /// Roboto 300
  static Future<Font> robotoLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/roboto/v27/KFOlCnqEu92Fr1MmSU5vAx05IsDqlA.ttf',
      'Roboto-Light',
    );
    return font.getFont();
  }

  /// Roboto 300italic
  static Future<Font> robotoLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/roboto/v27/KFOjCnqEu92Fr1Mu51TjARc9AMX6lJBP.ttf',
      'Roboto-LightItalic',
    );
    return font.getFont();
  }

  /// Roboto regular
  static Future<Font> robotoRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/roboto/v27/KFOmCnqEu92Fr1Me5WZLCzYlKw.ttf',
      'Roboto-Regular',
    );
    return font.getFont();
  }

  /// Roboto italic
  static Future<Font> robotoItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/roboto/v27/KFOkCnqEu92Fr1Mu52xPKTM1K9nz.ttf',
      'Roboto-Italic',
    );
    return font.getFont();
  }

  /// Roboto 500
  static Future<Font> robotoMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/roboto/v27/KFOlCnqEu92Fr1MmEU9vAx05IsDqlA.ttf',
      'Roboto-Medium',
    );
    return font.getFont();
  }

  /// Roboto 500italic
  static Future<Font> robotoMediumItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/roboto/v27/KFOjCnqEu92Fr1Mu51S7ABc9AMX6lJBP.ttf',
      'Roboto-MediumItalic',
    );
    return font.getFont();
  }

  /// Roboto 700
  static Future<Font> robotoBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/roboto/v27/KFOlCnqEu92Fr1MmWUlvAx05IsDqlA.ttf',
      'Roboto-Bold',
    );
    return font.getFont();
  }

  /// Roboto 700italic
  static Future<Font> robotoBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/roboto/v27/KFOjCnqEu92Fr1Mu51TzBhc9AMX6lJBP.ttf',
      'Roboto-BoldItalic',
    );
    return font.getFont();
  }

  /// Roboto 900
  static Future<Font> robotoBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/roboto/v27/KFOlCnqEu92Fr1MmYUtvAx05IsDqlA.ttf',
      'Roboto-Black',
    );
    return font.getFont();
  }

  /// Roboto 900italic
  static Future<Font> robotoBlackItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/roboto/v27/KFOjCnqEu92Fr1Mu51TLBBc9AMX6lJBP.ttf',
      'Roboto-BlackItalic',
    );
    return font.getFont();
  }

  /// Roboto Condensed 300
  static Future<Font> robotoCondensedLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/robotocondensed/v19/ieVi2ZhZI2eCN5jzbjEETS9weq8-33mZKCMSbvtdYyQ.ttf',
      'RobotoCondensed-Light',
    );
    return font.getFont();
  }

  /// Roboto Condensed 300italic
  static Future<Font> robotoCondensedLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/robotocondensed/v19/ieVg2ZhZI2eCN5jzbjEETS9weq8-19eDpCEYatlYcyRi4A.ttf',
      'RobotoCondensed-LightItalic',
    );
    return font.getFont();
  }

  /// Roboto Condensed regular
  static Future<Font> robotoCondensedRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/robotocondensed/v19/ieVl2ZhZI2eCN5jzbjEETS9weq8-59WxDCs5cvI.ttf',
      'RobotoCondensed-Regular',
    );
    return font.getFont();
  }

  /// Roboto Condensed italic
  static Future<Font> robotoCondensedItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/robotocondensed/v19/ieVj2ZhZI2eCN5jzbjEETS9weq8-19e7CAk8YvJEeg.ttf',
      'RobotoCondensed-Italic',
    );
    return font.getFont();
  }

  /// Roboto Condensed 700
  static Future<Font> robotoCondensedBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/robotocondensed/v19/ieVi2ZhZI2eCN5jzbjEETS9weq8-32meKCMSbvtdYyQ.ttf',
      'RobotoCondensed-Bold',
    );
    return font.getFont();
  }

  /// Roboto Condensed 700italic
  static Future<Font> robotoCondensedBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/robotocondensed/v19/ieVg2ZhZI2eCN5jzbjEETS9weq8-19eDtCYYatlYcyRi4A.ttf',
      'RobotoCondensed-BoldItalic',
    );
    return font.getFont();
  }

  /// Roboto Mono 100
  static Future<Font> robotoMonoThin() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/robotomono/v13/L0xuDF4xlVMF-BfR8bXMIhJHg45mwgGEFl0_3vuPQ--5Ip2sSQ.ttf',
      'RobotoMono-Thin',
    );
    return font.getFont();
  }

  /// Roboto Mono 200
  static Future<Font> robotoMonoExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/robotomono/v13/L0xuDF4xlVMF-BfR8bXMIhJHg45mwgGEFl0_XvqPQ--5Ip2sSQ.ttf',
      'RobotoMono-ExtraLight',
    );
    return font.getFont();
  }

  /// Roboto Mono 300
  static Future<Font> robotoMonoLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/robotomono/v13/L0xuDF4xlVMF-BfR8bXMIhJHg45mwgGEFl0_gPqPQ--5Ip2sSQ.ttf',
      'RobotoMono-Light',
    );
    return font.getFont();
  }

  /// Roboto Mono regular
  static Future<Font> robotoMonoRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/robotomono/v13/L0xuDF4xlVMF-BfR8bXMIhJHg45mwgGEFl0_3vqPQ--5Ip2sSQ.ttf',
      'RobotoMono-Regular',
    );
    return font.getFont();
  }

  /// Roboto Mono 500
  static Future<Font> robotoMonoMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/robotomono/v13/L0xuDF4xlVMF-BfR8bXMIhJHg45mwgGEFl0_7PqPQ--5Ip2sSQ.ttf',
      'RobotoMono-Medium',
    );
    return font.getFont();
  }

  /// Roboto Mono 600
  static Future<Font> robotoMonoSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/robotomono/v13/L0xuDF4xlVMF-BfR8bXMIhJHg45mwgGEFl0_AP2PQ--5Ip2sSQ.ttf',
      'RobotoMono-SemiBold',
    );
    return font.getFont();
  }

  /// Roboto Mono 700
  static Future<Font> robotoMonoBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/robotomono/v13/L0xuDF4xlVMF-BfR8bXMIhJHg45mwgGEFl0_Of2PQ--5Ip2sSQ.ttf',
      'RobotoMono-Bold',
    );
    return font.getFont();
  }

  /// Roboto Mono 100italic
  static Future<Font> robotoMonoThinItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/robotomono/v13/L0xoDF4xlVMF-BfR8bXMIjhOsXG-q2oeuFoqFrlnAeW9AJi8SZwt.ttf',
      'RobotoMono-ThinItalic',
    );
    return font.getFont();
  }

  /// Roboto Mono 200italic
  static Future<Font> robotoMonoExtraLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/robotomono/v13/L0xoDF4xlVMF-BfR8bXMIjhOsXG-q2oeuFoqFrnnAOW9AJi8SZwt.ttf',
      'RobotoMono-ExtraLightItalic',
    );
    return font.getFont();
  }

  /// Roboto Mono 300italic
  static Future<Font> robotoMonoLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/robotomono/v13/L0xoDF4xlVMF-BfR8bXMIjhOsXG-q2oeuFoqFrk5AOW9AJi8SZwt.ttf',
      'RobotoMono-LightItalic',
    );
    return font.getFont();
  }

  /// Roboto Mono italic
  static Future<Font> robotoMonoItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/robotomono/v13/L0xoDF4xlVMF-BfR8bXMIjhOsXG-q2oeuFoqFrlnAOW9AJi8SZwt.ttf',
      'RobotoMono-Italic',
    );
    return font.getFont();
  }

  /// Roboto Mono 500italic
  static Future<Font> robotoMonoMediumItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/robotomono/v13/L0xoDF4xlVMF-BfR8bXMIjhOsXG-q2oeuFoqFrlVAOW9AJi8SZwt.ttf',
      'RobotoMono-MediumItalic',
    );
    return font.getFont();
  }

  /// Roboto Mono 600italic
  static Future<Font> robotoMonoSemiBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/robotomono/v13/L0xoDF4xlVMF-BfR8bXMIjhOsXG-q2oeuFoqFrm5B-W9AJi8SZwt.ttf',
      'RobotoMono-SemiBoldItalic',
    );
    return font.getFont();
  }

  /// Roboto Mono 700italic
  static Future<Font> robotoMonoBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/robotomono/v13/L0xoDF4xlVMF-BfR8bXMIjhOsXG-q2oeuFoqFrmAB-W9AJi8SZwt.ttf',
      'RobotoMono-BoldItalic',
    );
    return font.getFont();
  }

  /// Roboto Slab 100
  static Future<Font> robotoSlabThin() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/robotoslab/v13/BngbUXZYTXPIvIBgJJSb6s3BzlRRfKOFbvjojIWWaG5iddG-1A.ttf',
      'RobotoSlab-Thin',
    );
    return font.getFont();
  }

  /// Roboto Slab 200
  static Future<Font> robotoSlabExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/robotoslab/v13/BngbUXZYTXPIvIBgJJSb6s3BzlRRfKOFbvjoDISWaG5iddG-1A.ttf',
      'RobotoSlab-ExtraLight',
    );
    return font.getFont();
  }

  /// Roboto Slab 300
  static Future<Font> robotoSlabLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/robotoslab/v13/BngbUXZYTXPIvIBgJJSb6s3BzlRRfKOFbvjo0oSWaG5iddG-1A.ttf',
      'RobotoSlab-Light',
    );
    return font.getFont();
  }

  /// Roboto Slab regular
  static Future<Font> robotoSlabRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/robotoslab/v13/BngbUXZYTXPIvIBgJJSb6s3BzlRRfKOFbvjojISWaG5iddG-1A.ttf',
      'RobotoSlab-Regular',
    );
    return font.getFont();
  }

  /// Roboto Slab 500
  static Future<Font> robotoSlabMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/robotoslab/v13/BngbUXZYTXPIvIBgJJSb6s3BzlRRfKOFbvjovoSWaG5iddG-1A.ttf',
      'RobotoSlab-Medium',
    );
    return font.getFont();
  }

  /// Roboto Slab 600
  static Future<Font> robotoSlabSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/robotoslab/v13/BngbUXZYTXPIvIBgJJSb6s3BzlRRfKOFbvjoUoOWaG5iddG-1A.ttf',
      'RobotoSlab-SemiBold',
    );
    return font.getFont();
  }

  /// Roboto Slab 700
  static Future<Font> robotoSlabBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/robotoslab/v13/BngbUXZYTXPIvIBgJJSb6s3BzlRRfKOFbvjoa4OWaG5iddG-1A.ttf',
      'RobotoSlab-Bold',
    );
    return font.getFont();
  }

  /// Roboto Slab 800
  static Future<Font> robotoSlabExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/robotoslab/v13/BngbUXZYTXPIvIBgJJSb6s3BzlRRfKOFbvjoDIOWaG5iddG-1A.ttf',
      'RobotoSlab-ExtraBold',
    );
    return font.getFont();
  }

  /// Roboto Slab 900
  static Future<Font> robotoSlabBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/robotoslab/v13/BngbUXZYTXPIvIBgJJSb6s3BzlRRfKOFbvjoJYOWaG5iddG-1A.ttf',
      'RobotoSlab-Black',
    );
    return font.getFont();
  }

  /// Rochester regular
  static Future<Font> rochesterRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/rochester/v11/6ae-4KCqVa4Zy6Fif-Uy31vWNTMwoQ.ttf',
      'Rochester-Regular',
    );
    return font.getFont();
  }

  /// Rock Salt regular
  static Future<Font> rockSaltRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/rocksalt/v11/MwQ0bhv11fWD6QsAVOZbsEk7hbBWrA.ttf',
      'RockSalt-Regular',
    );
    return font.getFont();
  }

  /// RocknRoll One regular
  static Future<Font> rocknRollOneRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/rocknrollone/v4/kmK7ZqspGAfCeUiW6FFlmEC9guVhs7tfUxc.ttf',
      'RocknRollOne-Regular',
    );
    return font.getFont();
  }

  /// Rokkitt 100
  static Future<Font> rokkittThin() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/rokkitt/v20/qFdb35qfgYFjGy5hukqqhw5XeRgdi1rydpDLE76HvN6n.ttf',
      'Rokkitt-Thin',
    );
    return font.getFont();
  }

  /// Rokkitt 200
  static Future<Font> rokkittExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/rokkitt/v20/qFdb35qfgYFjGy5hukqqhw5XeRgdi1pyd5DLE76HvN6n.ttf',
      'Rokkitt-ExtraLight',
    );
    return font.getFont();
  }

  /// Rokkitt 300
  static Future<Font> rokkittLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/rokkitt/v20/qFdb35qfgYFjGy5hukqqhw5XeRgdi1qsd5DLE76HvN6n.ttf',
      'Rokkitt-Light',
    );
    return font.getFont();
  }

  /// Rokkitt regular
  static Future<Font> rokkittRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/rokkitt/v20/qFdb35qfgYFjGy5hukqqhw5XeRgdi1ryd5DLE76HvN6n.ttf',
      'Rokkitt-Regular',
    );
    return font.getFont();
  }

  /// Rokkitt 500
  static Future<Font> rokkittMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/rokkitt/v20/qFdb35qfgYFjGy5hukqqhw5XeRgdi1rAd5DLE76HvN6n.ttf',
      'Rokkitt-Medium',
    );
    return font.getFont();
  }

  /// Rokkitt 600
  static Future<Font> rokkittSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/rokkitt/v20/qFdb35qfgYFjGy5hukqqhw5XeRgdi1oscJDLE76HvN6n.ttf',
      'Rokkitt-SemiBold',
    );
    return font.getFont();
  }

  /// Rokkitt 700
  static Future<Font> rokkittBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/rokkitt/v20/qFdb35qfgYFjGy5hukqqhw5XeRgdi1oVcJDLE76HvN6n.ttf',
      'Rokkitt-Bold',
    );
    return font.getFont();
  }

  /// Rokkitt 800
  static Future<Font> rokkittExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/rokkitt/v20/qFdb35qfgYFjGy5hukqqhw5XeRgdi1pycJDLE76HvN6n.ttf',
      'Rokkitt-ExtraBold',
    );
    return font.getFont();
  }

  /// Rokkitt 900
  static Future<Font> rokkittBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/rokkitt/v20/qFdb35qfgYFjGy5hukqqhw5XeRgdi1pbcJDLE76HvN6n.ttf',
      'Rokkitt-Black',
    );
    return font.getFont();
  }

  /// Romanesco regular
  static Future<Font> romanescoRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/romanesco/v11/w8gYH2ozQOY7_r_J7mSn3HwLqOqSBg.ttf',
      'Romanesco-Regular',
    );
    return font.getFont();
  }

  /// Ropa Sans regular
  static Future<Font> ropaSansRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ropasans/v10/EYqxmaNOzLlWtsZSScyKWjloU5KP2g.ttf',
      'RopaSans-Regular',
    );
    return font.getFont();
  }

  /// Ropa Sans italic
  static Future<Font> ropaSansItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ropasans/v10/EYq3maNOzLlWtsZSScy6WDNscZef2mNE.ttf',
      'RopaSans-Italic',
    );
    return font.getFont();
  }

  /// Rosario 300
  static Future<Font> rosarioLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/rosario/v19/xfuu0WDhWW_fOEoY8l_VPNZfB7jPM69GCWczd-YnOzUD.ttf',
      'Rosario-Light',
    );
    return font.getFont();
  }

  /// Rosario regular
  static Future<Font> rosarioRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/rosario/v19/xfuu0WDhWW_fOEoY8l_VPNZfB7jPM68YCWczd-YnOzUD.ttf',
      'Rosario-Regular',
    );
    return font.getFont();
  }

  /// Rosario 500
  static Future<Font> rosarioMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/rosario/v19/xfuu0WDhWW_fOEoY8l_VPNZfB7jPM68qCWczd-YnOzUD.ttf',
      'Rosario-Medium',
    );
    return font.getFont();
  }

  /// Rosario 600
  static Future<Font> rosarioSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/rosario/v19/xfuu0WDhWW_fOEoY8l_VPNZfB7jPM6_GDmczd-YnOzUD.ttf',
      'Rosario-SemiBold',
    );
    return font.getFont();
  }

  /// Rosario 700
  static Future<Font> rosarioBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/rosario/v19/xfuu0WDhWW_fOEoY8l_VPNZfB7jPM6__Dmczd-YnOzUD.ttf',
      'Rosario-Bold',
    );
    return font.getFont();
  }

  /// Rosario 300italic
  static Future<Font> rosarioLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/rosario/v19/xfug0WDhWW_fOEoY2Fbnww42bCJhNLrQStFwfeIFPiUDn08.ttf',
      'Rosario-LightItalic',
    );
    return font.getFont();
  }

  /// Rosario italic
  static Future<Font> rosarioItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/rosario/v19/xfug0WDhWW_fOEoY2Fbnww42bCJhNLrQSo9wfeIFPiUDn08.ttf',
      'Rosario-Italic',
    );
    return font.getFont();
  }

  /// Rosario 500italic
  static Future<Font> rosarioMediumItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/rosario/v19/xfug0WDhWW_fOEoY2Fbnww42bCJhNLrQSr1wfeIFPiUDn08.ttf',
      'Rosario-MediumItalic',
    );
    return font.getFont();
  }

  /// Rosario 600italic
  static Future<Font> rosarioSemiBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/rosario/v19/xfug0WDhWW_fOEoY2Fbnww42bCJhNLrQSlF3feIFPiUDn08.ttf',
      'Rosario-SemiBoldItalic',
    );
    return font.getFont();
  }

  /// Rosario 700italic
  static Future<Font> rosarioBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/rosario/v19/xfug0WDhWW_fOEoY2Fbnww42bCJhNLrQSmh3feIFPiUDn08.ttf',
      'Rosario-BoldItalic',
    );
    return font.getFont();
  }

  /// Rosarivo regular
  static Future<Font> rosarivoRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/rosarivo/v10/PlI-Fl2lO6N9f8HaNAeC2nhMnNy5.ttf',
      'Rosarivo-Regular',
    );
    return font.getFont();
  }

  /// Rosarivo italic
  static Future<Font> rosarivoItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/rosarivo/v10/PlI4Fl2lO6N9f8HaNDeA0Hxumcy5ZX8.ttf',
      'Rosarivo-Italic',
    );
    return font.getFont();
  }

  /// Rouge Script regular
  static Future<Font> rougeScriptRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/rougescript/v9/LYjFdGbiklMoCIQOw1Ep3S4PVPXbUJWq9g.ttf',
      'RougeScript-Regular',
    );
    return font.getFont();
  }

  /// Rowdies 300
  static Future<Font> rowdiesLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/rowdies/v5/ptRMTieMYPNBAK219hth5O7yKQNute8.ttf',
      'Rowdies-Light',
    );
    return font.getFont();
  }

  /// Rowdies regular
  static Future<Font> rowdiesRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/rowdies/v5/ptRJTieMYPNBAK21zrdJwObZNQo.ttf',
      'Rowdies-Regular',
    );
    return font.getFont();
  }

  /// Rowdies 700
  static Future<Font> rowdiesBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/rowdies/v5/ptRMTieMYPNBAK219gtm5O7yKQNute8.ttf',
      'Rowdies-Bold',
    );
    return font.getFont();
  }

  /// Rozha One regular
  static Future<Font> rozhaOneRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/rozhaone/v8/AlZy_zVFtYP12Zncg2khdXf4XB0Tow.ttf',
      'RozhaOne-Regular',
    );
    return font.getFont();
  }

  /// Rubik 300
  static Future<Font> rubikLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/rubik/v12/iJWZBXyIfDnIV5PNhY1KTN7Z-Yh-WYi1UE80V4bVkA.ttf',
      'Rubik-Light',
    );
    return font.getFont();
  }

  /// Rubik regular
  static Future<Font> rubikRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/rubik/v12/iJWZBXyIfDnIV5PNhY1KTN7Z-Yh-B4i1UE80V4bVkA.ttf',
      'Rubik-Regular',
    );
    return font.getFont();
  }

  /// Rubik 500
  static Future<Font> rubikMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/rubik/v12/iJWZBXyIfDnIV5PNhY1KTN7Z-Yh-NYi1UE80V4bVkA.ttf',
      'Rubik-Medium',
    );
    return font.getFont();
  }

  /// Rubik 600
  static Future<Font> rubikSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/rubik/v12/iJWZBXyIfDnIV5PNhY1KTN7Z-Yh-2Y-1UE80V4bVkA.ttf',
      'Rubik-SemiBold',
    );
    return font.getFont();
  }

  /// Rubik 700
  static Future<Font> rubikBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/rubik/v12/iJWZBXyIfDnIV5PNhY1KTN7Z-Yh-4I-1UE80V4bVkA.ttf',
      'Rubik-Bold',
    );
    return font.getFont();
  }

  /// Rubik 800
  static Future<Font> rubikExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/rubik/v12/iJWZBXyIfDnIV5PNhY1KTN7Z-Yh-h4-1UE80V4bVkA.ttf',
      'Rubik-ExtraBold',
    );
    return font.getFont();
  }

  /// Rubik 900
  static Future<Font> rubikBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/rubik/v12/iJWZBXyIfDnIV5PNhY1KTN7Z-Yh-ro-1UE80V4bVkA.ttf',
      'Rubik-Black',
    );
    return font.getFont();
  }

  /// Rubik 300italic
  static Future<Font> rubikLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/rubik/v12/iJWbBXyIfDnIV7nEt3KSJbVDV49rz8sDE0UwdYPFkJ1O.ttf',
      'Rubik-LightItalic',
    );
    return font.getFont();
  }

  /// Rubik italic
  static Future<Font> rubikItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/rubik/v12/iJWbBXyIfDnIV7nEt3KSJbVDV49rz8tdE0UwdYPFkJ1O.ttf',
      'Rubik-Italic',
    );
    return font.getFont();
  }

  /// Rubik 500italic
  static Future<Font> rubikMediumItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/rubik/v12/iJWbBXyIfDnIV7nEt3KSJbVDV49rz8tvE0UwdYPFkJ1O.ttf',
      'Rubik-MediumItalic',
    );
    return font.getFont();
  }

  /// Rubik 600italic
  static Future<Font> rubikSemiBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/rubik/v12/iJWbBXyIfDnIV7nEt3KSJbVDV49rz8uDFEUwdYPFkJ1O.ttf',
      'Rubik-SemiBoldItalic',
    );
    return font.getFont();
  }

  /// Rubik 700italic
  static Future<Font> rubikBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/rubik/v12/iJWbBXyIfDnIV7nEt3KSJbVDV49rz8u6FEUwdYPFkJ1O.ttf',
      'Rubik-BoldItalic',
    );
    return font.getFont();
  }

  /// Rubik 800italic
  static Future<Font> rubikExtraBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/rubik/v12/iJWbBXyIfDnIV7nEt3KSJbVDV49rz8vdFEUwdYPFkJ1O.ttf',
      'Rubik-ExtraBoldItalic',
    );
    return font.getFont();
  }

  /// Rubik 900italic
  static Future<Font> rubikBlackItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/rubik/v12/iJWbBXyIfDnIV7nEt3KSJbVDV49rz8v0FEUwdYPFkJ1O.ttf',
      'Rubik-BlackItalic',
    );
    return font.getFont();
  }

  /// Rubik Mono One regular
  static Future<Font> rubikMonoOneRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/rubikmonoone/v9/UqyJK8kPP3hjw6ANTdfRk9YSN-8wRqQrc_j9.ttf',
      'RubikMonoOne-Regular',
    );
    return font.getFont();
  }

  /// Ruda regular
  static Future<Font> rudaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ruda/v14/k3kKo8YQJOpFgHQ1mQ5VkEbUKaJFsi_-2KiSGg-H.ttf',
      'Ruda-Regular',
    );
    return font.getFont();
  }

  /// Ruda 500
  static Future<Font> rudaMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ruda/v14/k3kKo8YQJOpFgHQ1mQ5VkEbUKaJ3si_-2KiSGg-H.ttf',
      'Ruda-Medium',
    );
    return font.getFont();
  }

  /// Ruda 600
  static Future<Font> rudaSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ruda/v14/k3kKo8YQJOpFgHQ1mQ5VkEbUKaKbtS_-2KiSGg-H.ttf',
      'Ruda-SemiBold',
    );
    return font.getFont();
  }

  /// Ruda 700
  static Future<Font> rudaBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ruda/v14/k3kKo8YQJOpFgHQ1mQ5VkEbUKaKitS_-2KiSGg-H.ttf',
      'Ruda-Bold',
    );
    return font.getFont();
  }

  /// Ruda 800
  static Future<Font> rudaExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ruda/v14/k3kKo8YQJOpFgHQ1mQ5VkEbUKaLFtS_-2KiSGg-H.ttf',
      'Ruda-ExtraBold',
    );
    return font.getFont();
  }

  /// Ruda 900
  static Future<Font> rudaBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ruda/v14/k3kKo8YQJOpFgHQ1mQ5VkEbUKaLstS_-2KiSGg-H.ttf',
      'Ruda-Black',
    );
    return font.getFont();
  }

  /// Rufina regular
  static Future<Font> rufinaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/rufina/v8/Yq6V-LyURyLy-aKyoxRktOdClg.ttf',
      'Rufina-Regular',
    );
    return font.getFont();
  }

  /// Rufina 700
  static Future<Font> rufinaBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/rufina/v8/Yq6W-LyURyLy-aKKHztAvMxenxE0SA.ttf',
      'Rufina-Bold',
    );
    return font.getFont();
  }

  /// Ruge Boogie regular
  static Future<Font> rugeBoogieRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/rugeboogie/v13/JIA3UVFwbHRF_GIWSMhKNROiPzUveSxy.ttf',
      'RugeBoogie-Regular',
    );
    return font.getFont();
  }

  /// Ruluko regular
  static Future<Font> rulukoRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ruluko/v10/xMQVuFNZVaODtm0pC6WzKX_QmA.ttf',
      'Ruluko-Regular',
    );
    return font.getFont();
  }

  /// Rum Raisin regular
  static Future<Font> rumRaisinRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/rumraisin/v10/nwpRtKu3Ih8D5avB4h2uJ3-IywA7eMM.ttf',
      'RumRaisin-Regular',
    );
    return font.getFont();
  }

  /// Ruslan Display regular
  static Future<Font> ruslanDisplayRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ruslandisplay/v13/Gw6jwczl81XcIZuckK_e3UpfdzxrldyFvm1n.ttf',
      'RuslanDisplay-Regular',
    );
    return font.getFont();
  }

  /// Russo One regular
  static Future<Font> russoOneRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/russoone/v9/Z9XUDmZRWg6M1LvRYsH-yMOInrib9Q.ttf',
      'RussoOne-Regular',
    );
    return font.getFont();
  }

  /// Ruthie regular
  static Future<Font> ruthieRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ruthie/v13/gokvH63sGkdqXuU9lD53Q2u_mQ.ttf',
      'Ruthie-Regular',
    );
    return font.getFont();
  }

  /// Rye regular
  static Future<Font> ryeRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/rye/v8/r05XGLJT86YDFpTsXOqx4w.ttf',
      'Rye-Regular',
    );
    return font.getFont();
  }

  /// Sacramento regular
  static Future<Font> sacramentoRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sacramento/v8/buEzpo6gcdjy0EiZMBUG0CoV_NxLeiw.ttf',
      'Sacramento-Regular',
    );
    return font.getFont();
  }

  /// Sahitya regular
  static Future<Font> sahityaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sahitya/v7/6qLAKZkOuhnuqlJAaScFPywEDnI.ttf',
      'Sahitya-Regular',
    );
    return font.getFont();
  }

  /// Sahitya 700
  static Future<Font> sahityaBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sahitya/v7/6qLFKZkOuhnuqlJAUZsqGyQvEnvSexI.ttf',
      'Sahitya-Bold',
    );
    return font.getFont();
  }

  /// Sail regular
  static Future<Font> sailRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sail/v11/DPEjYwiBxwYJFBTDADYAbvw.ttf',
      'Sail-Regular',
    );
    return font.getFont();
  }

  /// Saira 100
  static Future<Font> sairaThin() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/saira/v7/memWYa2wxmKQyPMrZX79wwYZQMhsyuShhKMjjbU9uXuA71rDosg7lwYmUVY.ttf',
      'Saira-Thin',
    );
    return font.getFont();
  }

  /// Saira 200
  static Future<Font> sairaExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/saira/v7/memWYa2wxmKQyPMrZX79wwYZQMhsyuShhKMjjbU9uXuA79rCosg7lwYmUVY.ttf',
      'Saira-ExtraLight',
    );
    return font.getFont();
  }

  /// Saira 300
  static Future<Font> sairaLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/saira/v7/memWYa2wxmKQyPMrZX79wwYZQMhsyuShhKMjjbU9uXuA7wTCosg7lwYmUVY.ttf',
      'Saira-Light',
    );
    return font.getFont();
  }

  /// Saira regular
  static Future<Font> sairaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/saira/v7/memWYa2wxmKQyPMrZX79wwYZQMhsyuShhKMjjbU9uXuA71rCosg7lwYmUVY.ttf',
      'Saira-Regular',
    );
    return font.getFont();
  }

  /// Saira 500
  static Future<Font> sairaMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/saira/v7/memWYa2wxmKQyPMrZX79wwYZQMhsyuShhKMjjbU9uXuA72jCosg7lwYmUVY.ttf',
      'Saira-Medium',
    );
    return font.getFont();
  }

  /// Saira 600
  static Future<Font> sairaSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/saira/v7/memWYa2wxmKQyPMrZX79wwYZQMhsyuShhKMjjbU9uXuA74TFosg7lwYmUVY.ttf',
      'Saira-SemiBold',
    );
    return font.getFont();
  }

  /// Saira 700
  static Future<Font> sairaBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/saira/v7/memWYa2wxmKQyPMrZX79wwYZQMhsyuShhKMjjbU9uXuA773Fosg7lwYmUVY.ttf',
      'Saira-Bold',
    );
    return font.getFont();
  }

  /// Saira 800
  static Future<Font> sairaExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/saira/v7/memWYa2wxmKQyPMrZX79wwYZQMhsyuShhKMjjbU9uXuA79rFosg7lwYmUVY.ttf',
      'Saira-ExtraBold',
    );
    return font.getFont();
  }

  /// Saira 900
  static Future<Font> sairaBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/saira/v7/memWYa2wxmKQyPMrZX79wwYZQMhsyuShhKMjjbU9uXuA7_PFosg7lwYmUVY.ttf',
      'Saira-Black',
    );
    return font.getFont();
  }

  /// Saira 100italic
  static Future<Font> sairaThinItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/saira/v7/memUYa2wxmKQyNkiV50dulWP7s95AqZTzZHcVdxWI9WH-pKBSooxkyQjQVYmxA.ttf',
      'Saira-ThinItalic',
    );
    return font.getFont();
  }

  /// Saira 200italic
  static Future<Font> sairaExtraLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/saira/v7/memUYa2wxmKQyNkiV50dulWP7s95AqZTzZHcVdxWI9WH-pKByosxkyQjQVYmxA.ttf',
      'Saira-ExtraLightItalic',
    );
    return font.getFont();
  }

  /// Saira 300italic
  static Future<Font> sairaLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/saira/v7/memUYa2wxmKQyNkiV50dulWP7s95AqZTzZHcVdxWI9WH-pKBFIsxkyQjQVYmxA.ttf',
      'Saira-LightItalic',
    );
    return font.getFont();
  }

  /// Saira italic
  static Future<Font> sairaItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/saira/v7/memUYa2wxmKQyNkiV50dulWP7s95AqZTzZHcVdxWI9WH-pKBSosxkyQjQVYmxA.ttf',
      'Saira-Italic',
    );
    return font.getFont();
  }

  /// Saira 500italic
  static Future<Font> sairaMediumItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/saira/v7/memUYa2wxmKQyNkiV50dulWP7s95AqZTzZHcVdxWI9WH-pKBeIsxkyQjQVYmxA.ttf',
      'Saira-MediumItalic',
    );
    return font.getFont();
  }

  /// Saira 600italic
  static Future<Font> sairaSemiBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/saira/v7/memUYa2wxmKQyNkiV50dulWP7s95AqZTzZHcVdxWI9WH-pKBlIwxkyQjQVYmxA.ttf',
      'Saira-SemiBoldItalic',
    );
    return font.getFont();
  }

  /// Saira 700italic
  static Future<Font> sairaBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/saira/v7/memUYa2wxmKQyNkiV50dulWP7s95AqZTzZHcVdxWI9WH-pKBrYwxkyQjQVYmxA.ttf',
      'Saira-BoldItalic',
    );
    return font.getFont();
  }

  /// Saira 800italic
  static Future<Font> sairaExtraBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/saira/v7/memUYa2wxmKQyNkiV50dulWP7s95AqZTzZHcVdxWI9WH-pKByowxkyQjQVYmxA.ttf',
      'Saira-ExtraBoldItalic',
    );
    return font.getFont();
  }

  /// Saira 900italic
  static Future<Font> sairaBlackItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/saira/v7/memUYa2wxmKQyNkiV50dulWP7s95AqZTzZHcVdxWI9WH-pKB44wxkyQjQVYmxA.ttf',
      'Saira-BlackItalic',
    );
    return font.getFont();
  }

  /// Saira Condensed 100
  static Future<Font> sairaCondensedThin() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sairacondensed/v6/EJRMQgErUN8XuHNEtX81i9TmEkrnwetA2omSrzS8.ttf',
      'SairaCondensed-Thin',
    );
    return font.getFont();
  }

  /// Saira Condensed 200
  static Future<Font> sairaCondensedExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sairacondensed/v6/EJRLQgErUN8XuHNEtX81i9TmEkrnbcpg8Keepi2lHw.ttf',
      'SairaCondensed-ExtraLight',
    );
    return font.getFont();
  }

  /// Saira Condensed 300
  static Future<Font> sairaCondensedLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sairacondensed/v6/EJRLQgErUN8XuHNEtX81i9TmEkrnCclg8Keepi2lHw.ttf',
      'SairaCondensed-Light',
    );
    return font.getFont();
  }

  /// Saira Condensed regular
  static Future<Font> sairaCondensedRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sairacondensed/v6/EJROQgErUN8XuHNEtX81i9TmEkrfpeFE-IyCrw.ttf',
      'SairaCondensed-Regular',
    );
    return font.getFont();
  }

  /// Saira Condensed 500
  static Future<Font> sairaCondensedMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sairacondensed/v6/EJRLQgErUN8XuHNEtX81i9TmEkrnUchg8Keepi2lHw.ttf',
      'SairaCondensed-Medium',
    );
    return font.getFont();
  }

  /// Saira Condensed 600
  static Future<Font> sairaCondensedSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sairacondensed/v6/EJRLQgErUN8XuHNEtX81i9TmEkrnfc9g8Keepi2lHw.ttf',
      'SairaCondensed-SemiBold',
    );
    return font.getFont();
  }

  /// Saira Condensed 700
  static Future<Font> sairaCondensedBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sairacondensed/v6/EJRLQgErUN8XuHNEtX81i9TmEkrnGc5g8Keepi2lHw.ttf',
      'SairaCondensed-Bold',
    );
    return font.getFont();
  }

  /// Saira Condensed 800
  static Future<Font> sairaCondensedExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sairacondensed/v6/EJRLQgErUN8XuHNEtX81i9TmEkrnBc1g8Keepi2lHw.ttf',
      'SairaCondensed-ExtraBold',
    );
    return font.getFont();
  }

  /// Saira Condensed 900
  static Future<Font> sairaCondensedBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sairacondensed/v6/EJRLQgErUN8XuHNEtX81i9TmEkrnIcxg8Keepi2lHw.ttf',
      'SairaCondensed-Black',
    );
    return font.getFont();
  }

  /// Saira Extra Condensed 100
  static Future<Font> sairaExtraCondensedThin() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sairaextracondensed/v6/-nFsOHYr-vcC7h8MklGBkrvmUG9rbpkisrTri0jx9i5ss3a3.ttf',
      'SairaExtraCondensed-Thin',
    );
    return font.getFont();
  }

  /// Saira Extra Condensed 200
  static Future<Font> sairaExtraCondensedExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sairaextracondensed/v6/-nFvOHYr-vcC7h8MklGBkrvmUG9rbpkisrTrJ2nR3ABgum-uoQ.ttf',
      'SairaExtraCondensed-ExtraLight',
    );
    return font.getFont();
  }

  /// Saira Extra Condensed 300
  static Future<Font> sairaExtraCondensedLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sairaextracondensed/v6/-nFvOHYr-vcC7h8MklGBkrvmUG9rbpkisrTrQ2rR3ABgum-uoQ.ttf',
      'SairaExtraCondensed-Light',
    );
    return font.getFont();
  }

  /// Saira Extra Condensed regular
  static Future<Font> sairaExtraCondensedRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sairaextracondensed/v6/-nFiOHYr-vcC7h8MklGBkrvmUG9rbpkisrTT70L11Ct8sw.ttf',
      'SairaExtraCondensed-Regular',
    );
    return font.getFont();
  }

  /// Saira Extra Condensed 500
  static Future<Font> sairaExtraCondensedMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sairaextracondensed/v6/-nFvOHYr-vcC7h8MklGBkrvmUG9rbpkisrTrG2vR3ABgum-uoQ.ttf',
      'SairaExtraCondensed-Medium',
    );
    return font.getFont();
  }

  /// Saira Extra Condensed 600
  static Future<Font> sairaExtraCondensedSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sairaextracondensed/v6/-nFvOHYr-vcC7h8MklGBkrvmUG9rbpkisrTrN2zR3ABgum-uoQ.ttf',
      'SairaExtraCondensed-SemiBold',
    );
    return font.getFont();
  }

  /// Saira Extra Condensed 700
  static Future<Font> sairaExtraCondensedBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sairaextracondensed/v6/-nFvOHYr-vcC7h8MklGBkrvmUG9rbpkisrTrU23R3ABgum-uoQ.ttf',
      'SairaExtraCondensed-Bold',
    );
    return font.getFont();
  }

  /// Saira Extra Condensed 800
  static Future<Font> sairaExtraCondensedExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sairaextracondensed/v6/-nFvOHYr-vcC7h8MklGBkrvmUG9rbpkisrTrT27R3ABgum-uoQ.ttf',
      'SairaExtraCondensed-ExtraBold',
    );
    return font.getFont();
  }

  /// Saira Extra Condensed 900
  static Future<Font> sairaExtraCondensedBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sairaextracondensed/v6/-nFvOHYr-vcC7h8MklGBkrvmUG9rbpkisrTra2_R3ABgum-uoQ.ttf',
      'SairaExtraCondensed-Black',
    );
    return font.getFont();
  }

  /// Saira Semi Condensed 100
  static Future<Font> sairaSemiCondensedThin() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sairasemicondensed/v6/U9MN6c-2-nnJkHxyCjRcnMHcWVWV1cWRRXdvaOM8rXT-8V8.ttf',
      'SairaSemiCondensed-Thin',
    );
    return font.getFont();
  }

  /// Saira Semi Condensed 200
  static Future<Font> sairaSemiCondensedExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sairasemicondensed/v6/U9MM6c-2-nnJkHxyCjRcnMHcWVWV1cWRRXfDScMWg3j36Ebz.ttf',
      'SairaSemiCondensed-ExtraLight',
    );
    return font.getFont();
  }

  /// Saira Semi Condensed 300
  static Future<Font> sairaSemiCondensedLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sairasemicondensed/v6/U9MM6c-2-nnJkHxyCjRcnMHcWVWV1cWRRXenSsMWg3j36Ebz.ttf',
      'SairaSemiCondensed-Light',
    );
    return font.getFont();
  }

  /// Saira Semi Condensed regular
  static Future<Font> sairaSemiCondensedRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sairasemicondensed/v6/U9MD6c-2-nnJkHxyCjRcnMHcWVWV1cWRRU8LYuceqGT-.ttf',
      'SairaSemiCondensed-Regular',
    );
    return font.getFont();
  }

  /// Saira Semi Condensed 500
  static Future<Font> sairaSemiCondensedMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sairasemicondensed/v6/U9MM6c-2-nnJkHxyCjRcnMHcWVWV1cWRRXf_S8MWg3j36Ebz.ttf',
      'SairaSemiCondensed-Medium',
    );
    return font.getFont();
  }

  /// Saira Semi Condensed 600
  static Future<Font> sairaSemiCondensedSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sairasemicondensed/v6/U9MM6c-2-nnJkHxyCjRcnMHcWVWV1cWRRXfTTMMWg3j36Ebz.ttf',
      'SairaSemiCondensed-SemiBold',
    );
    return font.getFont();
  }

  /// Saira Semi Condensed 700
  static Future<Font> sairaSemiCondensedBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sairasemicondensed/v6/U9MM6c-2-nnJkHxyCjRcnMHcWVWV1cWRRXe3TcMWg3j36Ebz.ttf',
      'SairaSemiCondensed-Bold',
    );
    return font.getFont();
  }

  /// Saira Semi Condensed 800
  static Future<Font> sairaSemiCondensedExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sairasemicondensed/v6/U9MM6c-2-nnJkHxyCjRcnMHcWVWV1cWRRXerTsMWg3j36Ebz.ttf',
      'SairaSemiCondensed-ExtraBold',
    );
    return font.getFont();
  }

  /// Saira Semi Condensed 900
  static Future<Font> sairaSemiCondensedBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sairasemicondensed/v6/U9MM6c-2-nnJkHxyCjRcnMHcWVWV1cWRRXePT8MWg3j36Ebz.ttf',
      'SairaSemiCondensed-Black',
    );
    return font.getFont();
  }

  /// Saira Stencil One regular
  static Future<Font> sairaStencilOneRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sairastencilone/v4/SLXSc03I6HkvZGJ1GvvipLoYSTEL9AsMawif2YQ2.ttf',
      'SairaStencilOne-Regular',
    );
    return font.getFont();
  }

  /// Salsa regular
  static Future<Font> salsaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/salsa/v12/gNMKW3FiRpKj-imY8ncKEZez.ttf',
      'Salsa-Regular',
    );
    return font.getFont();
  }

  /// Sanchez regular
  static Future<Font> sanchezRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sanchez/v8/Ycm2sZJORluHnXbITm5b_BwE1l0.ttf',
      'Sanchez-Regular',
    );
    return font.getFont();
  }

  /// Sanchez italic
  static Future<Font> sanchezItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sanchez/v8/Ycm0sZJORluHnXbIfmxR-D4Bxl3gkw.ttf',
      'Sanchez-Italic',
    );
    return font.getFont();
  }

  /// Sancreek regular
  static Future<Font> sancreekRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sancreek/v13/pxiHypAnsdxUm159X7D-XV9NEe-K.ttf',
      'Sancreek-Regular',
    );
    return font.getFont();
  }

  /// Sansita regular
  static Future<Font> sansitaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sansita/v5/QldONTRRphEb_-V7HBm7TXFf3qw.ttf',
      'Sansita-Regular',
    );
    return font.getFont();
  }

  /// Sansita italic
  static Future<Font> sansitaItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sansita/v5/QldMNTRRphEb_-V7LBuxSVNazqx2xg.ttf',
      'Sansita-Italic',
    );
    return font.getFont();
  }

  /// Sansita 700
  static Future<Font> sansitaBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sansita/v5/QldLNTRRphEb_-V7JKWUaXl0wqVv3_g.ttf',
      'Sansita-Bold',
    );
    return font.getFont();
  }

  /// Sansita 700italic
  static Future<Font> sansitaBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sansita/v5/QldJNTRRphEb_-V7LBuJ9Xx-xodqz_joDQ.ttf',
      'Sansita-BoldItalic',
    );
    return font.getFont();
  }

  /// Sansita 800
  static Future<Font> sansitaExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sansita/v5/QldLNTRRphEb_-V7JLmXaXl0wqVv3_g.ttf',
      'Sansita-ExtraBold',
    );
    return font.getFont();
  }

  /// Sansita 800italic
  static Future<Font> sansitaExtraBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sansita/v5/QldJNTRRphEb_-V7LBuJ6X9-xodqz_joDQ.ttf',
      'Sansita-ExtraBoldItalic',
    );
    return font.getFont();
  }

  /// Sansita 900
  static Future<Font> sansitaBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sansita/v5/QldLNTRRphEb_-V7JJ2WaXl0wqVv3_g.ttf',
      'Sansita-Black',
    );
    return font.getFont();
  }

  /// Sansita 900italic
  static Future<Font> sansitaBlackItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sansita/v5/QldJNTRRphEb_-V7LBuJzX5-xodqz_joDQ.ttf',
      'Sansita-BlackItalic',
    );
    return font.getFont();
  }

  /// Sansita Swashed 300
  static Future<Font> sansitaSwashedLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sansitaswashed/v5/BXR8vFfZifTZgFlDDLgNkBydPKTt3pVCeYWqJnZSW-ppbToVehmEa4Q.ttf',
      'SansitaSwashed-Light',
    );
    return font.getFont();
  }

  /// Sansita Swashed regular
  static Future<Font> sansitaSwashedRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sansitaswashed/v5/BXR8vFfZifTZgFlDDLgNkBydPKTt3pVCeYWqJnZSW7RpbToVehmEa4Q.ttf',
      'SansitaSwashed-Regular',
    );
    return font.getFont();
  }

  /// Sansita Swashed 500
  static Future<Font> sansitaSwashedMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sansitaswashed/v5/BXR8vFfZifTZgFlDDLgNkBydPKTt3pVCeYWqJnZSW4ZpbToVehmEa4Q.ttf',
      'SansitaSwashed-Medium',
    );
    return font.getFont();
  }

  /// Sansita Swashed 600
  static Future<Font> sansitaSwashedSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sansitaswashed/v5/BXR8vFfZifTZgFlDDLgNkBydPKTt3pVCeYWqJnZSW2pubToVehmEa4Q.ttf',
      'SansitaSwashed-SemiBold',
    );
    return font.getFont();
  }

  /// Sansita Swashed 700
  static Future<Font> sansitaSwashedBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sansitaswashed/v5/BXR8vFfZifTZgFlDDLgNkBydPKTt3pVCeYWqJnZSW1NubToVehmEa4Q.ttf',
      'SansitaSwashed-Bold',
    );
    return font.getFont();
  }

  /// Sansita Swashed 800
  static Future<Font> sansitaSwashedExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sansitaswashed/v5/BXR8vFfZifTZgFlDDLgNkBydPKTt3pVCeYWqJnZSWzRubToVehmEa4Q.ttf',
      'SansitaSwashed-ExtraBold',
    );
    return font.getFont();
  }

  /// Sansita Swashed 900
  static Future<Font> sansitaSwashedBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sansitaswashed/v5/BXR8vFfZifTZgFlDDLgNkBydPKTt3pVCeYWqJnZSWx1ubToVehmEa4Q.ttf',
      'SansitaSwashed-Black',
    );
    return font.getFont();
  }

  /// Sarabun 100
  static Future<Font> sarabunThin() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sarabun/v8/DtVhJx26TKEr37c9YHZJmnYI5gnOpg.ttf',
      'Sarabun-Thin',
    );
    return font.getFont();
  }

  /// Sarabun 100italic
  static Future<Font> sarabunThinItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sarabun/v8/DtVnJx26TKEr37c9aBBx_nwMxAzephhN.ttf',
      'Sarabun-ThinItalic',
    );
    return font.getFont();
  }

  /// Sarabun 200
  static Future<Font> sarabunExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sarabun/v8/DtVmJx26TKEr37c9YNpoulwm6gDXvwE.ttf',
      'Sarabun-ExtraLight',
    );
    return font.getFont();
  }

  /// Sarabun 200italic
  static Future<Font> sarabunExtraLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sarabun/v8/DtVkJx26TKEr37c9aBBxUl0s7iLSrwFUlw.ttf',
      'Sarabun-ExtraLightItalic',
    );
    return font.getFont();
  }

  /// Sarabun 300
  static Future<Font> sarabunLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sarabun/v8/DtVmJx26TKEr37c9YL5rulwm6gDXvwE.ttf',
      'Sarabun-Light',
    );
    return font.getFont();
  }

  /// Sarabun 300italic
  static Future<Font> sarabunLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sarabun/v8/DtVkJx26TKEr37c9aBBxNl4s7iLSrwFUlw.ttf',
      'Sarabun-LightItalic',
    );
    return font.getFont();
  }

  /// Sarabun regular
  static Future<Font> sarabunRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sarabun/v8/DtVjJx26TKEr37c9WBJDnlQN9gk.ttf',
      'Sarabun-Regular',
    );
    return font.getFont();
  }

  /// Sarabun italic
  static Future<Font> sarabunItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sarabun/v8/DtVhJx26TKEr37c9aBBJmnYI5gnOpg.ttf',
      'Sarabun-Italic',
    );
    return font.getFont();
  }

  /// Sarabun 500
  static Future<Font> sarabunMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sarabun/v8/DtVmJx26TKEr37c9YOZqulwm6gDXvwE.ttf',
      'Sarabun-Medium',
    );
    return font.getFont();
  }

  /// Sarabun 500italic
  static Future<Font> sarabunMediumItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sarabun/v8/DtVkJx26TKEr37c9aBBxbl8s7iLSrwFUlw.ttf',
      'Sarabun-MediumItalic',
    );
    return font.getFont();
  }

  /// Sarabun 600
  static Future<Font> sarabunSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sarabun/v8/DtVmJx26TKEr37c9YMptulwm6gDXvwE.ttf',
      'Sarabun-SemiBold',
    );
    return font.getFont();
  }

  /// Sarabun 600italic
  static Future<Font> sarabunSemiBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sarabun/v8/DtVkJx26TKEr37c9aBBxQlgs7iLSrwFUlw.ttf',
      'Sarabun-SemiBoldItalic',
    );
    return font.getFont();
  }

  /// Sarabun 700
  static Future<Font> sarabunBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sarabun/v8/DtVmJx26TKEr37c9YK5sulwm6gDXvwE.ttf',
      'Sarabun-Bold',
    );
    return font.getFont();
  }

  /// Sarabun 700italic
  static Future<Font> sarabunBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sarabun/v8/DtVkJx26TKEr37c9aBBxJlks7iLSrwFUlw.ttf',
      'Sarabun-BoldItalic',
    );
    return font.getFont();
  }

  /// Sarabun 800
  static Future<Font> sarabunExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sarabun/v8/DtVmJx26TKEr37c9YLJvulwm6gDXvwE.ttf',
      'Sarabun-ExtraBold',
    );
    return font.getFont();
  }

  /// Sarabun 800italic
  static Future<Font> sarabunExtraBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sarabun/v8/DtVkJx26TKEr37c9aBBxOlos7iLSrwFUlw.ttf',
      'Sarabun-ExtraBoldItalic',
    );
    return font.getFont();
  }

  /// Sarala regular
  static Future<Font> saralaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sarala/v5/uK_y4riEZv4o1w9RCh0TMv6EXw.ttf',
      'Sarala-Regular',
    );
    return font.getFont();
  }

  /// Sarala 700
  static Future<Font> saralaBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sarala/v5/uK_x4riEZv4o1w9ptjI3OtWYVkMpXA.ttf',
      'Sarala-Bold',
    );
    return font.getFont();
  }

  /// Sarina regular
  static Future<Font> sarinaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sarina/v11/-F6wfjF3ITQwasLhLkDUriBQxw.ttf',
      'Sarina-Regular',
    );
    return font.getFont();
  }

  /// Sarpanch regular
  static Future<Font> sarpanchRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sarpanch/v6/hESy6Xt4NCpRuk6Pzh2ARIrX_20n.ttf',
      'Sarpanch-Regular',
    );
    return font.getFont();
  }

  /// Sarpanch 500
  static Future<Font> sarpanchMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sarpanch/v6/hES16Xt4NCpRuk6PziV0ba7f1HEuRHkM.ttf',
      'Sarpanch-Medium',
    );
    return font.getFont();
  }

  /// Sarpanch 600
  static Future<Font> sarpanchSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sarpanch/v6/hES16Xt4NCpRuk6PziVYaq7f1HEuRHkM.ttf',
      'Sarpanch-SemiBold',
    );
    return font.getFont();
  }

  /// Sarpanch 700
  static Future<Font> sarpanchBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sarpanch/v6/hES16Xt4NCpRuk6PziU8a67f1HEuRHkM.ttf',
      'Sarpanch-Bold',
    );
    return font.getFont();
  }

  /// Sarpanch 800
  static Future<Font> sarpanchExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sarpanch/v6/hES16Xt4NCpRuk6PziUgaK7f1HEuRHkM.ttf',
      'Sarpanch-ExtraBold',
    );
    return font.getFont();
  }

  /// Sarpanch 900
  static Future<Font> sarpanchBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sarpanch/v6/hES16Xt4NCpRuk6PziUEaa7f1HEuRHkM.ttf',
      'Sarpanch-Black',
    );
    return font.getFont();
  }

  /// Satisfy regular
  static Future<Font> satisfyRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/satisfy/v11/rP2Hp2yn6lkG50LoOZSCHBeHFl0.ttf',
      'Satisfy-Regular',
    );
    return font.getFont();
  }

  /// Sawarabi Gothic regular
  static Future<Font> sawarabiGothicRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sawarabigothic/v8/x3d4ckfVaqqa-BEj-I9mE65u3k3NBSk3E2YljQ.ttf',
      'SawarabiGothic-Regular',
    );
    return font.getFont();
  }

  /// Sawarabi Mincho regular
  static Future<Font> sawarabiMinchoRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sawarabimincho/v10/8QIRdiDaitzr7brc8ahpxt6GcIJTLahP46UDUw.ttf',
      'SawarabiMincho-Regular',
    );
    return font.getFont();
  }

  /// Scada regular
  static Future<Font> scadaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/scada/v9/RLpxK5Pv5qumeWJoxzUobkvv.ttf',
      'Scada-Regular',
    );
    return font.getFont();
  }

  /// Scada italic
  static Future<Font> scadaItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/scada/v9/RLp_K5Pv5qumeVJqzTEKa1vvffg.ttf',
      'Scada-Italic',
    );
    return font.getFont();
  }

  /// Scada 700
  static Future<Font> scadaBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/scada/v9/RLp8K5Pv5qumeVrU6BEgRVfmZOE5.ttf',
      'Scada-Bold',
    );
    return font.getFont();
  }

  /// Scada 700italic
  static Future<Font> scadaBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/scada/v9/RLp6K5Pv5qumeVJq9Y0lT1PEYfE5p6g.ttf',
      'Scada-BoldItalic',
    );
    return font.getFont();
  }

  /// Scheherazade regular
  static Future<Font> scheherazadeRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/scheherazade/v20/YA9Ur0yF4ETZN60keViq1kQgt5OohvbJ9A.ttf',
      'Scheherazade-Regular',
    );
    return font.getFont();
  }

  /// Scheherazade 700
  static Future<Font> scheherazadeBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/scheherazade/v20/YA9Lr0yF4ETZN60keViq1kQYC7yMjt3V_dB0Yw.ttf',
      'Scheherazade-Bold',
    );
    return font.getFont();
  }

  /// Schoolbell regular
  static Future<Font> schoolbellRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/schoolbell/v11/92zQtBZWOrcgoe-fgnJIVxIQ6mRqfiQ.ttf',
      'Schoolbell-Regular',
    );
    return font.getFont();
  }

  /// Scope One regular
  static Future<Font> scopeOneRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/scopeone/v9/WBLnrEXKYFlGHrOKmGD1W0_MJMGxiQ.ttf',
      'ScopeOne-Regular',
    );
    return font.getFont();
  }

  /// Seaweed Script regular
  static Future<Font> seaweedScriptRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/seaweedscript/v8/bx6cNx6Tne2pxOATYE8C_Rsoe0WJ-KcGVbLW.ttf',
      'SeaweedScript-Regular',
    );
    return font.getFont();
  }

  /// Secular One regular
  static Future<Font> secularOneRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/secularone/v5/8QINdiTajsj_87rMuMdKypDlMul7LJpK.ttf',
      'SecularOne-Regular',
    );
    return font.getFont();
  }

  /// Sedgwick Ave regular
  static Future<Font> sedgwickAveRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sedgwickave/v6/uK_04rKEYuguzAcSYRdWTJq8Xmg1Vcf5JA.ttf',
      'SedgwickAve-Regular',
    );
    return font.getFont();
  }

  /// Sedgwick Ave Display regular
  static Future<Font> sedgwickAveDisplayRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sedgwickavedisplay/v8/xfuu0XPgU3jZPUoUo3ScvmPi-NapQ8OxM2czd-YnOzUD.ttf',
      'SedgwickAveDisplay-Regular',
    );
    return font.getFont();
  }

  /// Sen regular
  static Future<Font> senRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sen/v2/6xKjdSxYI9_Hm_-MImrpLQ.ttf',
      'Sen-Regular',
    );
    return font.getFont();
  }

  /// Sen 700
  static Future<Font> senBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sen/v2/6xKudSxYI9__J9CoKkH1JHUQSQ.ttf',
      'Sen-Bold',
    );
    return font.getFont();
  }

  /// Sen 800
  static Future<Font> senExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sen/v2/6xKudSxYI9__O9OoKkH1JHUQSQ.ttf',
      'Sen-ExtraBold',
    );
    return font.getFont();
  }

  /// Sevillana regular
  static Future<Font> sevillanaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sevillana/v11/KFOlCnWFscmDt1Bfiy1vAx05IsDqlA.ttf',
      'Sevillana-Regular',
    );
    return font.getFont();
  }

  /// Seymour One regular
  static Future<Font> seymourOneRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/seymourone/v10/4iCp6Khla9xbjQpoWGGd0myIPYBvgpUI.ttf',
      'SeymourOne-Regular',
    );
    return font.getFont();
  }

  /// Shadows Into Light regular
  static Future<Font> shadowsIntoLightRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/shadowsintolight/v10/UqyNK9UOIntux_czAvDQx_ZcHqZXBNQDcsr4xzSMYA.ttf',
      'ShadowsIntoLight-Regular',
    );
    return font.getFont();
  }

  /// Shadows Into Light Two regular
  static Future<Font> shadowsIntoLightTwoRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/shadowsintolighttwo/v8/4iC86LVlZsRSjQhpWGedwyOoW-0A6_kpsyNmlAvNGLNnIF0.ttf',
      'ShadowsIntoLightTwo-Regular',
    );
    return font.getFont();
  }

  /// Shanti regular
  static Future<Font> shantiRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/shanti/v14/t5thIREMM4uSDgzgU0ezpKfwzA.ttf',
      'Shanti-Regular',
    );
    return font.getFont();
  }

  /// Share regular
  static Future<Font> shareRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/share/v11/i7dEIFliZjKNF5VNHLq2cV5d.ttf',
      'Share-Regular',
    );
    return font.getFont();
  }

  /// Share italic
  static Future<Font> shareItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/share/v11/i7dKIFliZjKNF6VPFr6UdE5dWFM.ttf',
      'Share-Italic',
    );
    return font.getFont();
  }

  /// Share 700
  static Future<Font> shareBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/share/v11/i7dJIFliZjKNF63xM56-WkJUQUq7.ttf',
      'Share-Bold',
    );
    return font.getFont();
  }

  /// Share 700italic
  static Future<Font> shareBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/share/v11/i7dPIFliZjKNF6VPLgK7UEZ2RFq7AwU.ttf',
      'Share-BoldItalic',
    );
    return font.getFont();
  }

  /// Share Tech regular
  static Future<Font> shareTechRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sharetech/v12/7cHtv4Uyi5K0OeZ7bohUwHoDmTcibrA.ttf',
      'ShareTech-Regular',
    );
    return font.getFont();
  }

  /// Share Tech Mono regular
  static Future<Font> shareTechMonoRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sharetechmono/v10/J7aHnp1uDWRBEqV98dVQztYldFc7pAsEIc3Xew.ttf',
      'ShareTechMono-Regular',
    );
    return font.getFont();
  }

  /// Shippori Mincho regular
  static Future<Font> shipporiMinchoRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/shipporimincho/v6/VdGGAZweH5EbgHY6YExcZfDoj0BA2_-C7LoS7g.ttf',
      'ShipporiMincho-Regular',
    );
    return font.getFont();
  }

  /// Shippori Mincho 500
  static Future<Font> shipporiMinchoMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/shipporimincho/v6/VdGDAZweH5EbgHY6YExcZfDoj0B4L9am5JEO5--2zg.ttf',
      'ShipporiMincho-Medium',
    );
    return font.getFont();
  }

  /// Shippori Mincho 600
  static Future<Font> shipporiMinchoSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/shipporimincho/v6/VdGDAZweH5EbgHY6YExcZfDoj0B4A9Gm5JEO5--2zg.ttf',
      'ShipporiMincho-SemiBold',
    );
    return font.getFont();
  }

  /// Shippori Mincho 700
  static Future<Font> shipporiMinchoBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/shipporimincho/v6/VdGDAZweH5EbgHY6YExcZfDoj0B4Z9Cm5JEO5--2zg.ttf',
      'ShipporiMincho-Bold',
    );
    return font.getFont();
  }

  /// Shippori Mincho 800
  static Future<Font> shipporiMinchoExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/shipporimincho/v6/VdGDAZweH5EbgHY6YExcZfDoj0B4e9Om5JEO5--2zg.ttf',
      'ShipporiMincho-ExtraBold',
    );
    return font.getFont();
  }

  /// Shippori Mincho B1 regular
  static Future<Font> shipporiMinchoB1Regular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/shipporiminchob1/v9/wXK2E2wCr44tulPdnn-xbIpJ9RgT9-nyjqBr1lO97Q.ttf',
      'ShipporiMinchoB1-Regular',
    );
    return font.getFont();
  }

  /// Shippori Mincho B1 500
  static Future<Font> shipporiMinchoB1Medium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/shipporiminchob1/v9/wXK1E2wCr44tulPdnn-xbIpJ9RgT9-nKeolP3nih5H4Uug.ttf',
      'ShipporiMinchoB1-Medium',
    );
    return font.getFont();
  }

  /// Shippori Mincho B1 600
  static Future<Font> shipporiMinchoB1SemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/shipporiminchob1/v9/wXK1E2wCr44tulPdnn-xbIpJ9RgT9-nKVo5P3nih5H4Uug.ttf',
      'ShipporiMinchoB1-SemiBold',
    );
    return font.getFont();
  }

  /// Shippori Mincho B1 700
  static Future<Font> shipporiMinchoB1Bold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/shipporiminchob1/v9/wXK1E2wCr44tulPdnn-xbIpJ9RgT9-nKMo9P3nih5H4Uug.ttf',
      'ShipporiMinchoB1-Bold',
    );
    return font.getFont();
  }

  /// Shippori Mincho B1 800
  static Future<Font> shipporiMinchoB1ExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/shipporiminchob1/v9/wXK1E2wCr44tulPdnn-xbIpJ9RgT9-nKLoxP3nih5H4Uug.ttf',
      'ShipporiMinchoB1-ExtraBold',
    );
    return font.getFont();
  }

  /// Shojumaru regular
  static Future<Font> shojumaruRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/shojumaru/v10/rax_HiWfutkLLnaKCtlMBBJek0vA8A.ttf',
      'Shojumaru-Regular',
    );
    return font.getFont();
  }

  /// Short Stack regular
  static Future<Font> shortStackRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/shortstack/v10/bMrzmS2X6p0jZC6EcmPFX-SScX8D0nq6.ttf',
      'ShortStack-Regular',
    );
    return font.getFont();
  }

  /// Shrikhand regular
  static Future<Font> shrikhandRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/shrikhand/v6/a8IbNovtLWfR7T7bMJwbBIiQ0zhMtA.ttf',
      'Shrikhand-Regular',
    );
    return font.getFont();
  }

  /// Siemreap regular
  static Future<Font> siemreapRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/siemreap/v15/Gg82N5oFbgLvHAfNl2YbnA8DLXpe.ttf',
      'Siemreap-Regular',
    );
    return font.getFont();
  }

  /// Sigmar One regular
  static Future<Font> sigmarOneRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sigmarone/v11/co3DmWZ8kjZuErj9Ta3dk6Pjp3Di8U0.ttf',
      'SigmarOne-Regular',
    );
    return font.getFont();
  }

  /// Signika 300
  static Future<Font> signikaLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/signika/v12/vEFO2_JTCgwQ5ejvMV0O96D01E8J0tIJHJbGhs_cfKe1.ttf',
      'Signika-Light',
    );
    return font.getFont();
  }

  /// Signika regular
  static Future<Font> signikaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/signika/v12/vEFO2_JTCgwQ5ejvMV0O96D01E8J0tJXHJbGhs_cfKe1.ttf',
      'Signika-Regular',
    );
    return font.getFont();
  }

  /// Signika 500
  static Future<Font> signikaMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/signika/v12/vEFO2_JTCgwQ5ejvMV0O96D01E8J0tJlHJbGhs_cfKe1.ttf',
      'Signika-Medium',
    );
    return font.getFont();
  }

  /// Signika 600
  static Future<Font> signikaSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/signika/v12/vEFO2_JTCgwQ5ejvMV0O96D01E8J0tKJG5bGhs_cfKe1.ttf',
      'Signika-SemiBold',
    );
    return font.getFont();
  }

  /// Signika 700
  static Future<Font> signikaBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/signika/v12/vEFO2_JTCgwQ5ejvMV0O96D01E8J0tKwG5bGhs_cfKe1.ttf',
      'Signika-Bold',
    );
    return font.getFont();
  }

  /// Signika Negative 300
  static Future<Font> signikaNegativeLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/signikanegative/v11/E217_cfngu7HiRpPX3ZpNE4kY5zKal6DipHD6z_iXAs.ttf',
      'SignikaNegative-Light',
    );
    return font.getFont();
  }

  /// Signika Negative regular
  static Future<Font> signikaNegativeRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/signikanegative/v11/E218_cfngu7HiRpPX3ZpNE4kY5zKUvKrrpno9zY.ttf',
      'SignikaNegative-Regular',
    );
    return font.getFont();
  }

  /// Signika Negative 600
  static Future<Font> signikaNegativeSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/signikanegative/v11/E217_cfngu7HiRpPX3ZpNE4kY5zKaiqFipHD6z_iXAs.ttf',
      'SignikaNegative-SemiBold',
    );
    return font.getFont();
  }

  /// Signika Negative 700
  static Future<Font> signikaNegativeBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/signikanegative/v11/E217_cfngu7HiRpPX3ZpNE4kY5zKak6EipHD6z_iXAs.ttf',
      'SignikaNegative-Bold',
    );
    return font.getFont();
  }

  /// Simonetta regular
  static Future<Font> simonettaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/simonetta/v13/x3dickHVYrCU5BU15c4BfPACvy_1BA.ttf',
      'Simonetta-Regular',
    );
    return font.getFont();
  }

  /// Simonetta italic
  static Future<Font> simonettaItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/simonetta/v13/x3dkckHVYrCU5BU15c4xfvoGnSrlBBsy.ttf',
      'Simonetta-Italic',
    );
    return font.getFont();
  }

  /// Simonetta 900
  static Future<Font> simonettaBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/simonetta/v13/x3dnckHVYrCU5BU15c45-N0mtwTpDQIrGg.ttf',
      'Simonetta-Black',
    );
    return font.getFont();
  }

  /// Simonetta 900italic
  static Future<Font> simonettaBlackItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/simonetta/v13/x3d5ckHVYrCU5BU15c4xfsKCsA7tLwc7Gn88.ttf',
      'Simonetta-BlackItalic',
    );
    return font.getFont();
  }

  /// Single Day regular
  static Future<Font> singleDayRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/singleday/v5/LYjHdGDjlEgoAcF95EI5jVoFUNfeQJU.ttf',
      'SingleDay-Regular',
    );
    return font.getFont();
  }

  /// Sintony regular
  static Future<Font> sintonyRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sintony/v8/XoHm2YDqR7-98cVUITQnu98ojjs.ttf',
      'Sintony-Regular',
    );
    return font.getFont();
  }

  /// Sintony 700
  static Future<Font> sintonyBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sintony/v8/XoHj2YDqR7-98cVUGYgIn9cDkjLp6C8.ttf',
      'Sintony-Bold',
    );
    return font.getFont();
  }

  /// Sirin Stencil regular
  static Future<Font> sirinStencilRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sirinstencil/v11/mem4YaWwznmLx-lzGfN7MdRydchGBq6al6o.ttf',
      'SirinStencil-Regular',
    );
    return font.getFont();
  }

  /// Six Caps regular
  static Future<Font> sixCapsRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sixcaps/v11/6ae_4KGrU7VR7bNmabcS9XXaPCop.ttf',
      'SixCaps-Regular',
    );
    return font.getFont();
  }

  /// Skranji regular
  static Future<Font> skranjiRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/skranji/v8/OZpDg_dtriVFNerMYzuuklTm3Ek.ttf',
      'Skranji-Regular',
    );
    return font.getFont();
  }

  /// Skranji 700
  static Future<Font> skranjiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/skranji/v8/OZpGg_dtriVFNerMW4eBtlzNwED-b4g.ttf',
      'Skranji-Bold',
    );
    return font.getFont();
  }

  /// Slabo 13px regular
  static Future<Font> slabo13pxRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/slabo13px/v8/11hEGp_azEvXZUdSBzzRcKer2wkYnvI.ttf',
      'Slabo13px-Regular',
    );
    return font.getFont();
  }

  /// Slabo 27px regular
  static Future<Font> slabo27pxRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/slabo27px/v7/mFT0WbgBwKPR_Z4hGN2qsxgJ1EJ7i90.ttf',
      'Slabo27px-Regular',
    );
    return font.getFont();
  }

  /// Slackey regular
  static Future<Font> slackeyRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/slackey/v13/N0bV2SdQO-5yM0-dKlRaJdbWgdY.ttf',
      'Slackey-Regular',
    );
    return font.getFont();
  }

  /// Smokum regular
  static Future<Font> smokumRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/smokum/v13/TK3iWkUbAhopmrdGHjUHte5fKg.ttf',
      'Smokum-Regular',
    );
    return font.getFont();
  }

  /// Smythe regular
  static Future<Font> smytheRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/smythe/v13/MwQ3bhT01--coT1BOLh_uGInjA.ttf',
      'Smythe-Regular',
    );
    return font.getFont();
  }

  /// Sniglet regular
  static Future<Font> snigletRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sniglet/v12/cIf9MaFLtkE3UjaJxCmrYGkHgIs.ttf',
      'Sniglet-Regular',
    );
    return font.getFont();
  }

  /// Sniglet 800
  static Future<Font> snigletExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sniglet/v12/cIf4MaFLtkE3UjaJ_ImHRGEsnIJkWL4.ttf',
      'Sniglet-ExtraBold',
    );
    return font.getFont();
  }

  /// Snippet regular
  static Future<Font> snippetRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/snippet/v12/bWt47f7XfQH9Gupu2v_Afcp9QWc.ttf',
      'Snippet-Regular',
    );
    return font.getFont();
  }

  /// Snowburst One regular
  static Future<Font> snowburstOneRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/snowburstone/v10/MQpS-WezKdujBsXY3B7I-UT7eZ-UPyacPbo.ttf',
      'SnowburstOne-Regular',
    );
    return font.getFont();
  }

  /// Sofadi One regular
  static Future<Font> sofadiOneRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sofadione/v11/JIA2UVBxdnVBuElZaMFGcDOIETkmYDU.ttf',
      'SofadiOne-Regular',
    );
    return font.getFont();
  }

  /// Sofia regular
  static Future<Font> sofiaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sofia/v9/8QIHdirahM3j_vu-sowsrqjk.ttf',
      'Sofia-Regular',
    );
    return font.getFont();
  }

  /// Solway 300
  static Future<Font> solwayLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/solway/v5/AMOTz46Cs2uTAOCuLlgZms0QW3mqyg.ttf',
      'Solway-Light',
    );
    return font.getFont();
  }

  /// Solway regular
  static Future<Font> solwayRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/solway/v5/AMOQz46Cs2uTAOCWgnA9kuYMUg.ttf',
      'Solway-Regular',
    );
    return font.getFont();
  }

  /// Solway 500
  static Future<Font> solwayMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/solway/v5/AMOTz46Cs2uTAOCudlkZms0QW3mqyg.ttf',
      'Solway-Medium',
    );
    return font.getFont();
  }

  /// Solway 700
  static Future<Font> solwayBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/solway/v5/AMOTz46Cs2uTAOCuPl8Zms0QW3mqyg.ttf',
      'Solway-Bold',
    );
    return font.getFont();
  }

  /// Solway 800
  static Future<Font> solwayExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/solway/v5/AMOTz46Cs2uTAOCuIlwZms0QW3mqyg.ttf',
      'Solway-ExtraBold',
    );
    return font.getFont();
  }

  /// Song Myung regular
  static Future<Font> songMyungRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/songmyung/v10/1cX2aUDWAJH5-EIC7DIhr1GqhcitzeM.ttf',
      'SongMyung-Regular',
    );
    return font.getFont();
  }

  /// Sonsie One regular
  static Future<Font> sonsieOneRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sonsieone/v11/PbymFmP_EAnPqbKaoc18YVu80lbp8JM.ttf',
      'SonsieOne-Regular',
    );
    return font.getFont();
  }

  /// Sora 100
  static Future<Font> soraThin() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sora/v3/xMQOuFFYT72X5wkB_18qmnndmSdSn3-KIwNhBti0.ttf',
      'Sora-Thin',
    );
    return font.getFont();
  }

  /// Sora 200
  static Future<Font> soraExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sora/v3/xMQOuFFYT72X5wkB_18qmnndmSfSnn-KIwNhBti0.ttf',
      'Sora-ExtraLight',
    );
    return font.getFont();
  }

  /// Sora 300
  static Future<Font> soraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sora/v3/xMQOuFFYT72X5wkB_18qmnndmScMnn-KIwNhBti0.ttf',
      'Sora-Light',
    );
    return font.getFont();
  }

  /// Sora regular
  static Future<Font> soraRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sora/v3/xMQOuFFYT72X5wkB_18qmnndmSdSnn-KIwNhBti0.ttf',
      'Sora-Regular',
    );
    return font.getFont();
  }

  /// Sora 500
  static Future<Font> soraMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sora/v3/xMQOuFFYT72X5wkB_18qmnndmSdgnn-KIwNhBti0.ttf',
      'Sora-Medium',
    );
    return font.getFont();
  }

  /// Sora 600
  static Future<Font> soraSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sora/v3/xMQOuFFYT72X5wkB_18qmnndmSeMmX-KIwNhBti0.ttf',
      'Sora-SemiBold',
    );
    return font.getFont();
  }

  /// Sora 700
  static Future<Font> soraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sora/v3/xMQOuFFYT72X5wkB_18qmnndmSe1mX-KIwNhBti0.ttf',
      'Sora-Bold',
    );
    return font.getFont();
  }

  /// Sora 800
  static Future<Font> soraExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sora/v3/xMQOuFFYT72X5wkB_18qmnndmSfSmX-KIwNhBti0.ttf',
      'Sora-ExtraBold',
    );
    return font.getFont();
  }

  /// Sorts Mill Goudy regular
  static Future<Font> sortsMillGoudyRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sortsmillgoudy/v10/Qw3GZR9MED_6PSuS_50nEaVrfzgEXH0OjpM75PE.ttf',
      'SortsMillGoudy-Regular',
    );
    return font.getFont();
  }

  /// Sorts Mill Goudy italic
  static Future<Font> sortsMillGoudyItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sortsmillgoudy/v10/Qw3AZR9MED_6PSuS_50nEaVrfzgEbH8EirE-9PGLfQ.ttf',
      'SortsMillGoudy-Italic',
    );
    return font.getFont();
  }

  /// Source Code Pro 200
  static Future<Font> sourceCodeProExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sourcecodepro/v14/HI_XiYsKILxRpg3hIP6sJ7fM7Pqt8srztO0rzmmkDQ.ttf',
      'SourceCodePro-ExtraLight',
    );
    return font.getFont();
  }

  /// Source Code Pro 200italic
  static Future<Font> sourceCodeProExtraLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sourcecodepro/v14/HI_ViYsKILxRpg3hIP6sJ7fM7PqlONMbtecv7Gy0DRzS.ttf',
      'SourceCodePro-ExtraLightItalic',
    );
    return font.getFont();
  }

  /// Source Code Pro 300
  static Future<Font> sourceCodeProLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sourcecodepro/v14/HI_XiYsKILxRpg3hIP6sJ7fM7PqtlsnztO0rzmmkDQ.ttf',
      'SourceCodePro-Light',
    );
    return font.getFont();
  }

  /// Source Code Pro 300italic
  static Future<Font> sourceCodeProLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sourcecodepro/v14/HI_ViYsKILxRpg3hIP6sJ7fM7PqlONN_tucv7Gy0DRzS.ttf',
      'SourceCodePro-LightItalic',
    );
    return font.getFont();
  }

  /// Source Code Pro regular
  static Future<Font> sourceCodeProRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sourcecodepro/v14/HI_SiYsKILxRpg3hIP6sJ7fM7PqVOuHXvMY3xw.ttf',
      'SourceCodePro-Regular',
    );
    return font.getFont();
  }

  /// Source Code Pro italic
  static Future<Font> sourceCodeProItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sourcecodepro/v14/HI_QiYsKILxRpg3hIP6sJ7fM7PqlOOvTnsMnx3C9.ttf',
      'SourceCodePro-Italic',
    );
    return font.getFont();
  }

  /// Source Code Pro 500
  static Future<Font> sourceCodeProMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sourcecodepro/v14/HI_XiYsKILxRpg3hIP6sJ7fM7PqtzsjztO0rzmmkDQ.ttf',
      'SourceCodePro-Medium',
    );
    return font.getFont();
  }

  /// Source Code Pro 500italic
  static Future<Font> sourceCodeProMediumItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sourcecodepro/v14/HI_ViYsKILxRpg3hIP6sJ7fM7PqlONMnt-cv7Gy0DRzS.ttf',
      'SourceCodePro-MediumItalic',
    );
    return font.getFont();
  }

  /// Source Code Pro 600
  static Future<Font> sourceCodeProSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sourcecodepro/v14/HI_XiYsKILxRpg3hIP6sJ7fM7Pqt4s_ztO0rzmmkDQ.ttf',
      'SourceCodePro-SemiBold',
    );
    return font.getFont();
  }

  /// Source Code Pro 600italic
  static Future<Font> sourceCodeProSemiBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sourcecodepro/v14/HI_ViYsKILxRpg3hIP6sJ7fM7PqlONMLsOcv7Gy0DRzS.ttf',
      'SourceCodePro-SemiBoldItalic',
    );
    return font.getFont();
  }

  /// Source Code Pro 700
  static Future<Font> sourceCodeProBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sourcecodepro/v14/HI_XiYsKILxRpg3hIP6sJ7fM7Pqths7ztO0rzmmkDQ.ttf',
      'SourceCodePro-Bold',
    );
    return font.getFont();
  }

  /// Source Code Pro 700italic
  static Future<Font> sourceCodeProBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sourcecodepro/v14/HI_ViYsKILxRpg3hIP6sJ7fM7PqlONNvsecv7Gy0DRzS.ttf',
      'SourceCodePro-BoldItalic',
    );
    return font.getFont();
  }

  /// Source Code Pro 900
  static Future<Font> sourceCodeProBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sourcecodepro/v14/HI_XiYsKILxRpg3hIP6sJ7fM7PqtvszztO0rzmmkDQ.ttf',
      'SourceCodePro-Black',
    );
    return font.getFont();
  }

  /// Source Code Pro 900italic
  static Future<Font> sourceCodeProBlackItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sourcecodepro/v14/HI_ViYsKILxRpg3hIP6sJ7fM7PqlONNXs-cv7Gy0DRzS.ttf',
      'SourceCodePro-BlackItalic',
    );
    return font.getFont();
  }

  /// Source Sans Pro 200
  static Future<Font> sourceSansProExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sourcesanspro/v14/6xKydSBYKcSV-LCoeQqfX1RYOo3i94_AkB1v_8CGxg.ttf',
      'SourceSansPro-ExtraLight',
    );
    return font.getFont();
  }

  /// Source Sans Pro 200italic
  static Future<Font> sourceSansProExtraLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sourcesanspro/v14/6xKwdSBYKcSV-LCoeQqfX1RYOo3qPZYokRdr3cWWxg40.ttf',
      'SourceSansPro-ExtraLightItalic',
    );
    return font.getFont();
  }

  /// Source Sans Pro 300
  static Future<Font> sourceSansProLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sourcesanspro/v14/6xKydSBYKcSV-LCoeQqfX1RYOo3ik4zAkB1v_8CGxg.ttf',
      'SourceSansPro-Light',
    );
    return font.getFont();
  }

  /// Source Sans Pro 300italic
  static Future<Font> sourceSansProLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sourcesanspro/v14/6xKwdSBYKcSV-LCoeQqfX1RYOo3qPZZMkhdr3cWWxg40.ttf',
      'SourceSansPro-LightItalic',
    );
    return font.getFont();
  }

  /// Source Sans Pro regular
  static Future<Font> sourceSansProRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sourcesanspro/v14/6xK3dSBYKcSV-LCoeQqfX1RYOo3aP6TkmDZz9g.ttf',
      'SourceSansPro-Regular',
    );
    return font.getFont();
  }

  /// Source Sans Pro italic
  static Future<Font> sourceSansProItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sourcesanspro/v14/6xK1dSBYKcSV-LCoeQqfX1RYOo3qPa7gujNj9tmf.ttf',
      'SourceSansPro-Italic',
    );
    return font.getFont();
  }

  /// Source Sans Pro 600
  static Future<Font> sourceSansProSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sourcesanspro/v14/6xKydSBYKcSV-LCoeQqfX1RYOo3i54rAkB1v_8CGxg.ttf',
      'SourceSansPro-SemiBold',
    );
    return font.getFont();
  }

  /// Source Sans Pro 600italic
  static Future<Font> sourceSansProSemiBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sourcesanspro/v14/6xKwdSBYKcSV-LCoeQqfX1RYOo3qPZY4lBdr3cWWxg40.ttf',
      'SourceSansPro-SemiBoldItalic',
    );
    return font.getFont();
  }

  /// Source Sans Pro 700
  static Future<Font> sourceSansProBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sourcesanspro/v14/6xKydSBYKcSV-LCoeQqfX1RYOo3ig4vAkB1v_8CGxg.ttf',
      'SourceSansPro-Bold',
    );
    return font.getFont();
  }

  /// Source Sans Pro 700italic
  static Future<Font> sourceSansProBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sourcesanspro/v14/6xKwdSBYKcSV-LCoeQqfX1RYOo3qPZZclRdr3cWWxg40.ttf',
      'SourceSansPro-BoldItalic',
    );
    return font.getFont();
  }

  /// Source Sans Pro 900
  static Future<Font> sourceSansProBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sourcesanspro/v14/6xKydSBYKcSV-LCoeQqfX1RYOo3iu4nAkB1v_8CGxg.ttf',
      'SourceSansPro-Black',
    );
    return font.getFont();
  }

  /// Source Sans Pro 900italic
  static Future<Font> sourceSansProBlackItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sourcesanspro/v14/6xKwdSBYKcSV-LCoeQqfX1RYOo3qPZZklxdr3cWWxg40.ttf',
      'SourceSansPro-BlackItalic',
    );
    return font.getFont();
  }

  /// Source Serif Pro 200
  static Future<Font> sourceSerifProExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sourceserifpro/v11/neIXzD-0qpwxpaWvjeD0X88SAOeasbsfhSugxYUvZrI.ttf',
      'SourceSerifPro-ExtraLight',
    );
    return font.getFont();
  }

  /// Source Serif Pro 200italic
  static Future<Font> sourceSerifProExtraLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sourceserifpro/v11/neIVzD-0qpwxpaWvjeD0X88SAOeauXEGbSqqwacqdrKvbQ.ttf',
      'SourceSerifPro-ExtraLightItalic',
    );
    return font.getFont();
  }

  /// Source Serif Pro 300
  static Future<Font> sourceSerifProLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sourceserifpro/v11/neIXzD-0qpwxpaWvjeD0X88SAOeasd8chSugxYUvZrI.ttf',
      'SourceSerifPro-Light',
    );
    return font.getFont();
  }

  /// Source Serif Pro 300italic
  static Future<Font> sourceSerifProLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sourceserifpro/v11/neIVzD-0qpwxpaWvjeD0X88SAOeauXEGCSmqwacqdrKvbQ.ttf',
      'SourceSerifPro-LightItalic',
    );
    return font.getFont();
  }

  /// Source Serif Pro regular
  static Future<Font> sourceSerifProRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sourceserifpro/v11/neIQzD-0qpwxpaWvjeD0X88SAOeaiXM0oSOL2Yw.ttf',
      'SourceSerifPro-Regular',
    );
    return font.getFont();
  }

  /// Source Serif Pro italic
  static Future<Font> sourceSerifProItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sourceserifpro/v11/neIWzD-0qpwxpaWvjeD0X88SAOeauXE-pQGOyYw2fw.ttf',
      'SourceSerifPro-Italic',
    );
    return font.getFont();
  }

  /// Source Serif Pro 600
  static Future<Font> sourceSerifProSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sourceserifpro/v11/neIXzD-0qpwxpaWvjeD0X88SAOeasasahSugxYUvZrI.ttf',
      'SourceSerifPro-SemiBold',
    );
    return font.getFont();
  }

  /// Source Serif Pro 600italic
  static Future<Font> sourceSerifProSemiBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sourceserifpro/v11/neIVzD-0qpwxpaWvjeD0X88SAOeauXEGfS-qwacqdrKvbQ.ttf',
      'SourceSerifPro-SemiBoldItalic',
    );
    return font.getFont();
  }

  /// Source Serif Pro 700
  static Future<Font> sourceSerifProBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sourceserifpro/v11/neIXzD-0qpwxpaWvjeD0X88SAOeasc8bhSugxYUvZrI.ttf',
      'SourceSerifPro-Bold',
    );
    return font.getFont();
  }

  /// Source Serif Pro 700italic
  static Future<Font> sourceSerifProBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sourceserifpro/v11/neIVzD-0qpwxpaWvjeD0X88SAOeauXEGGS6qwacqdrKvbQ.ttf',
      'SourceSerifPro-BoldItalic',
    );
    return font.getFont();
  }

  /// Source Serif Pro 900
  static Future<Font> sourceSerifProBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sourceserifpro/v11/neIXzD-0qpwxpaWvjeD0X88SAOeasfcZhSugxYUvZrI.ttf',
      'SourceSerifPro-Black',
    );
    return font.getFont();
  }

  /// Source Serif Pro 900italic
  static Future<Font> sourceSerifProBlackItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sourceserifpro/v11/neIVzD-0qpwxpaWvjeD0X88SAOeauXEGISyqwacqdrKvbQ.ttf',
      'SourceSerifPro-BlackItalic',
    );
    return font.getFont();
  }

  /// Space Grotesk 300
  static Future<Font> spaceGroteskLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/spacegrotesk/v5/V8mQoQDjQSkFtoMM3T6r8E7mF71Q-gOoraIAEj62UUsjNsFjTDJK.ttf',
      'SpaceGrotesk-Light',
    );
    return font.getFont();
  }

  /// Space Grotesk regular
  static Future<Font> spaceGroteskRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/spacegrotesk/v5/V8mQoQDjQSkFtoMM3T6r8E7mF71Q-gOoraIAEj7oUUsjNsFjTDJK.ttf',
      'SpaceGrotesk-Regular',
    );
    return font.getFont();
  }

  /// Space Grotesk 500
  static Future<Font> spaceGroteskMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/spacegrotesk/v5/V8mQoQDjQSkFtoMM3T6r8E7mF71Q-gOoraIAEj7aUUsjNsFjTDJK.ttf',
      'SpaceGrotesk-Medium',
    );
    return font.getFont();
  }

  /// Space Grotesk 600
  static Future<Font> spaceGroteskSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/spacegrotesk/v5/V8mQoQDjQSkFtoMM3T6r8E7mF71Q-gOoraIAEj42VksjNsFjTDJK.ttf',
      'SpaceGrotesk-SemiBold',
    );
    return font.getFont();
  }

  /// Space Grotesk 700
  static Future<Font> spaceGroteskBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/spacegrotesk/v5/V8mQoQDjQSkFtoMM3T6r8E7mF71Q-gOoraIAEj4PVksjNsFjTDJK.ttf',
      'SpaceGrotesk-Bold',
    );
    return font.getFont();
  }

  /// Space Mono regular
  static Future<Font> spaceMonoRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/spacemono/v6/i7dPIFZifjKcF5UAWdDRUEZ2RFq7AwU.ttf',
      'SpaceMono-Regular',
    );
    return font.getFont();
  }

  /// Space Mono italic
  static Future<Font> spaceMonoItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/spacemono/v6/i7dNIFZifjKcF5UAWdDRYER8QHi-EwWMbg.ttf',
      'SpaceMono-Italic',
    );
    return font.getFont();
  }

  /// Space Mono 700
  static Future<Font> spaceMonoBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/spacemono/v6/i7dMIFZifjKcF5UAWdDRaPpZYFKQHwyVd3U.ttf',
      'SpaceMono-Bold',
    );
    return font.getFont();
  }

  /// Space Mono 700italic
  static Future<Font> spaceMonoBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/spacemono/v6/i7dSIFZifjKcF5UAWdDRYERE_FeaGy6QZ3WfYg.ttf',
      'SpaceMono-BoldItalic',
    );
    return font.getFont();
  }

  /// Spartan 100
  static Future<Font> spartanThin() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/spartan/v3/l7gAbjR61M69yt8Z8w6FZf9WoBxdBrGFuG6OChXtf4qS.ttf',
      'Spartan-Thin',
    );
    return font.getFont();
  }

  /// Spartan 200
  static Future<Font> spartanExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/spartan/v3/l7gAbjR61M69yt8Z8w6FZf9WoBxdBrEFuW6OChXtf4qS.ttf',
      'Spartan-ExtraLight',
    );
    return font.getFont();
  }

  /// Spartan 300
  static Future<Font> spartanLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/spartan/v3/l7gAbjR61M69yt8Z8w6FZf9WoBxdBrHbuW6OChXtf4qS.ttf',
      'Spartan-Light',
    );
    return font.getFont();
  }

  /// Spartan regular
  static Future<Font> spartanRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/spartan/v3/l7gAbjR61M69yt8Z8w6FZf9WoBxdBrGFuW6OChXtf4qS.ttf',
      'Spartan-Regular',
    );
    return font.getFont();
  }

  /// Spartan 500
  static Future<Font> spartanMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/spartan/v3/l7gAbjR61M69yt8Z8w6FZf9WoBxdBrG3uW6OChXtf4qS.ttf',
      'Spartan-Medium',
    );
    return font.getFont();
  }

  /// Spartan 600
  static Future<Font> spartanSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/spartan/v3/l7gAbjR61M69yt8Z8w6FZf9WoBxdBrFbvm6OChXtf4qS.ttf',
      'Spartan-SemiBold',
    );
    return font.getFont();
  }

  /// Spartan 700
  static Future<Font> spartanBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/spartan/v3/l7gAbjR61M69yt8Z8w6FZf9WoBxdBrFivm6OChXtf4qS.ttf',
      'Spartan-Bold',
    );
    return font.getFont();
  }

  /// Spartan 800
  static Future<Font> spartanExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/spartan/v3/l7gAbjR61M69yt8Z8w6FZf9WoBxdBrEFvm6OChXtf4qS.ttf',
      'Spartan-ExtraBold',
    );
    return font.getFont();
  }

  /// Spartan 900
  static Future<Font> spartanBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/spartan/v3/l7gAbjR61M69yt8Z8w6FZf9WoBxdBrEsvm6OChXtf4qS.ttf',
      'Spartan-Black',
    );
    return font.getFont();
  }

  /// Special Elite regular
  static Future<Font> specialEliteRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/specialelite/v11/XLYgIZbkc4JPUL5CVArUVL0nhncESXFtUsM.ttf',
      'SpecialElite-Regular',
    );
    return font.getFont();
  }

  /// Spectral 200
  static Future<Font> spectralExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/spectral/v7/rnCs-xNNww_2s0amA9v2s13GY_etWWIJ.ttf',
      'Spectral-ExtraLight',
    );
    return font.getFont();
  }

  /// Spectral 200italic
  static Future<Font> spectralExtraLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/spectral/v7/rnCu-xNNww_2s0amA9M8qrXHafOPXHIJErY.ttf',
      'Spectral-ExtraLightItalic',
    );
    return font.getFont();
  }

  /// Spectral 300
  static Future<Font> spectralLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/spectral/v7/rnCs-xNNww_2s0amA9uSsF3GY_etWWIJ.ttf',
      'Spectral-Light',
    );
    return font.getFont();
  }

  /// Spectral 300italic
  static Future<Font> spectralLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/spectral/v7/rnCu-xNNww_2s0amA9M8qtHEafOPXHIJErY.ttf',
      'Spectral-LightItalic',
    );
    return font.getFont();
  }

  /// Spectral regular
  static Future<Font> spectralRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/spectral/v7/rnCr-xNNww_2s0amA-M-mHnOSOuk.ttf',
      'Spectral-Regular',
    );
    return font.getFont();
  }

  /// Spectral italic
  static Future<Font> spectralItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/spectral/v7/rnCt-xNNww_2s0amA9M8kn3sTfukQHs.ttf',
      'Spectral-Italic',
    );
    return font.getFont();
  }

  /// Spectral 500
  static Future<Font> spectralMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/spectral/v7/rnCs-xNNww_2s0amA9vKsV3GY_etWWIJ.ttf',
      'Spectral-Medium',
    );
    return font.getFont();
  }

  /// Spectral 500italic
  static Future<Font> spectralMediumItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/spectral/v7/rnCu-xNNww_2s0amA9M8qonFafOPXHIJErY.ttf',
      'Spectral-MediumItalic',
    );
    return font.getFont();
  }

  /// Spectral 600
  static Future<Font> spectralSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/spectral/v7/rnCs-xNNww_2s0amA9vmtl3GY_etWWIJ.ttf',
      'Spectral-SemiBold',
    );
    return font.getFont();
  }

  /// Spectral 600italic
  static Future<Font> spectralSemiBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/spectral/v7/rnCu-xNNww_2s0amA9M8qqXCafOPXHIJErY.ttf',
      'Spectral-SemiBoldItalic',
    );
    return font.getFont();
  }

  /// Spectral 700
  static Future<Font> spectralBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/spectral/v7/rnCs-xNNww_2s0amA9uCt13GY_etWWIJ.ttf',
      'Spectral-Bold',
    );
    return font.getFont();
  }

  /// Spectral 700italic
  static Future<Font> spectralBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/spectral/v7/rnCu-xNNww_2s0amA9M8qsHDafOPXHIJErY.ttf',
      'Spectral-BoldItalic',
    );
    return font.getFont();
  }

  /// Spectral 800
  static Future<Font> spectralExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/spectral/v7/rnCs-xNNww_2s0amA9uetF3GY_etWWIJ.ttf',
      'Spectral-ExtraBold',
    );
    return font.getFont();
  }

  /// Spectral 800italic
  static Future<Font> spectralExtraBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/spectral/v7/rnCu-xNNww_2s0amA9M8qt3AafOPXHIJErY.ttf',
      'Spectral-ExtraBoldItalic',
    );
    return font.getFont();
  }

  /// Spectral SC 200
  static Future<Font> spectralSCExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/spectralsc/v6/Ktk0ALCRZonmalTgyPmRfs1qwkTXPYeVXJZB.ttf',
      'SpectralSC-ExtraLight',
    );
    return font.getFont();
  }

  /// Spectral SC 200italic
  static Future<Font> spectralSCExtraLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/spectralsc/v6/Ktk2ALCRZonmalTgyPmRfsWg26zWN4O3WYZB_sU.ttf',
      'SpectralSC-ExtraLightItalic',
    );
    return font.getFont();
  }

  /// Spectral SC 300
  static Future<Font> spectralSCLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/spectralsc/v6/Ktk0ALCRZonmalTgyPmRfs0OwUTXPYeVXJZB.ttf',
      'SpectralSC-Light',
    );
    return font.getFont();
  }

  /// Spectral SC 300italic
  static Future<Font> spectralSCLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/spectralsc/v6/Ktk2ALCRZonmalTgyPmRfsWg28jVN4O3WYZB_sU.ttf',
      'SpectralSC-LightItalic',
    );
    return font.getFont();
  }

  /// Spectral SC regular
  static Future<Font> spectralSCRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/spectralsc/v6/KtkpALCRZonmalTgyPmRfvWi6WDfFpuc.ttf',
      'SpectralSC-Regular',
    );
    return font.getFont();
  }

  /// Spectral SC italic
  static Future<Font> spectralSCItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/spectralsc/v6/KtkrALCRZonmalTgyPmRfsWg42T9E4ucRY8.ttf',
      'SpectralSC-Italic',
    );
    return font.getFont();
  }

  /// Spectral SC 500
  static Future<Font> spectralSCMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/spectralsc/v6/Ktk0ALCRZonmalTgyPmRfs1WwETXPYeVXJZB.ttf',
      'SpectralSC-Medium',
    );
    return font.getFont();
  }

  /// Spectral SC 500italic
  static Future<Font> spectralSCMediumItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/spectralsc/v6/Ktk2ALCRZonmalTgyPmRfsWg25DUN4O3WYZB_sU.ttf',
      'SpectralSC-MediumItalic',
    );
    return font.getFont();
  }

  /// Spectral SC 600
  static Future<Font> spectralSCSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/spectralsc/v6/Ktk0ALCRZonmalTgyPmRfs16x0TXPYeVXJZB.ttf',
      'SpectralSC-SemiBold',
    );
    return font.getFont();
  }

  /// Spectral SC 600italic
  static Future<Font> spectralSCSemiBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/spectralsc/v6/Ktk2ALCRZonmalTgyPmRfsWg27zTN4O3WYZB_sU.ttf',
      'SpectralSC-SemiBoldItalic',
    );
    return font.getFont();
  }

  /// Spectral SC 700
  static Future<Font> spectralSCBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/spectralsc/v6/Ktk0ALCRZonmalTgyPmRfs0exkTXPYeVXJZB.ttf',
      'SpectralSC-Bold',
    );
    return font.getFont();
  }

  /// Spectral SC 700italic
  static Future<Font> spectralSCBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/spectralsc/v6/Ktk2ALCRZonmalTgyPmRfsWg29jSN4O3WYZB_sU.ttf',
      'SpectralSC-BoldItalic',
    );
    return font.getFont();
  }

  /// Spectral SC 800
  static Future<Font> spectralSCExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/spectralsc/v6/Ktk0ALCRZonmalTgyPmRfs0CxUTXPYeVXJZB.ttf',
      'SpectralSC-ExtraBold',
    );
    return font.getFont();
  }

  /// Spectral SC 800italic
  static Future<Font> spectralSCExtraBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/spectralsc/v6/Ktk2ALCRZonmalTgyPmRfsWg28TRN4O3WYZB_sU.ttf',
      'SpectralSC-ExtraBoldItalic',
    );
    return font.getFont();
  }

  /// Spicy Rice regular
  static Future<Font> spicyRiceRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/spicyrice/v11/uK_24rSEd-Uqwk4jY1RyGv-2WkowRcc.ttf',
      'SpicyRice-Regular',
    );
    return font.getFont();
  }

  /// Spinnaker regular
  static Future<Font> spinnakerRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/spinnaker/v12/w8gYH2oyX-I0_rvR6Hmn3HwLqOqSBg.ttf',
      'Spinnaker-Regular',
    );
    return font.getFont();
  }

  /// Spirax regular
  static Future<Font> spiraxRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/spirax/v11/buE3poKgYNLy0F3cXktt-Csn-Q.ttf',
      'Spirax-Regular',
    );
    return font.getFont();
  }

  /// Squada One regular
  static Future<Font> squadaOneRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/squadaone/v9/BCasqZ8XsOrx4mcOk6MtWaA8WDBkHgs.ttf',
      'SquadaOne-Regular',
    );
    return font.getFont();
  }

  /// Sree Krushnadevaraya regular
  static Future<Font> sreeKrushnadevarayaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sreekrushnadevaraya/v10/R70FjzQeifmPepmyQQjQ9kvwMkWYPfTA_EWb2FhQuXir.ttf',
      'SreeKrushnadevaraya-Regular',
    );
    return font.getFont();
  }

  /// Sriracha regular
  static Future<Font> srirachaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sriracha/v5/0nkrC9D4IuYBgWcI9ObYRQDioeb0.ttf',
      'Sriracha-Regular',
    );
    return font.getFont();
  }

  /// Srisakdi regular
  static Future<Font> srisakdiRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/srisakdi/v6/yMJRMIlvdpDbkB0A-jq8fSx5i814.ttf',
      'Srisakdi-Regular',
    );
    return font.getFont();
  }

  /// Srisakdi 700
  static Future<Font> srisakdiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/srisakdi/v6/yMJWMIlvdpDbkB0A-gIAUghxoNFxW0Hz.ttf',
      'Srisakdi-Bold',
    );
    return font.getFont();
  }

  /// Staatliches regular
  static Future<Font> staatlichesRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/staatliches/v6/HI_OiY8KO6hCsQSoAPmtMbectJG9O9PS.ttf',
      'Staatliches-Regular',
    );
    return font.getFont();
  }

  /// Stalemate regular
  static Future<Font> stalemateRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/stalemate/v10/taiIGmZ_EJq97-UfkZRpuqSs8ZQpaQ.ttf',
      'Stalemate-Regular',
    );
    return font.getFont();
  }

  /// Stalinist One regular
  static Future<Font> stalinistOneRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/stalinistone/v28/MQpS-WezM9W4Dd7D3B7I-UT7eZ-UPyacPbo.ttf',
      'StalinistOne-Regular',
    );
    return font.getFont();
  }

  /// Stardos Stencil regular
  static Future<Font> stardosStencilRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/stardosstencil/v11/X7n94bcuGPC8hrvEOHXOgaKCc2TR71R3tiSx0g.ttf',
      'StardosStencil-Regular',
    );
    return font.getFont();
  }

  /// Stardos Stencil 700
  static Future<Font> stardosStencilBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/stardosstencil/v11/X7n44bcuGPC8hrvEOHXOgaKCc2TpU3tTvg-t29HSHw.ttf',
      'StardosStencil-Bold',
    );
    return font.getFont();
  }

  /// Stick regular
  static Future<Font> stickRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/stick/v4/Qw3TZQpMCyTtJSvfvPVDMPoF.ttf',
      'Stick-Regular',
    );
    return font.getFont();
  }

  /// Stint Ultra Condensed regular
  static Future<Font> stintUltraCondensedRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/stintultracondensed/v11/-W_gXIrsVjjeyEnPC45qD2NoFPtBE0xCh2A-qhUO2cNvdg.ttf',
      'StintUltraCondensed-Regular',
    );
    return font.getFont();
  }

  /// Stint Ultra Expanded regular
  static Future<Font> stintUltraExpandedRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/stintultraexpanded/v10/CSRg4yNNh-GbW3o3JkwoDcdvMKMf0oBAd0qoATQkWwam.ttf',
      'StintUltraExpanded-Regular',
    );
    return font.getFont();
  }

  /// Stoke 300
  static Future<Font> stokeLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/stoke/v12/z7NXdRb7aTMfKNvFVgxC_pjcTeWU.ttf',
      'Stoke-Light',
    );
    return font.getFont();
  }

  /// Stoke regular
  static Future<Font> stokeRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/stoke/v12/z7NadRb7aTMfKONpfihK1YTV.ttf',
      'Stoke-Regular',
    );
    return font.getFont();
  }

  /// Strait regular
  static Future<Font> straitRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/strait/v8/DtViJxy6WaEr1LZzeDhtkl0U7w.ttf',
      'Strait-Regular',
    );
    return font.getFont();
  }

  /// Stylish regular
  static Future<Font> stylishRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/stylish/v10/m8JSjfhPYriQkk7-fo35dLxEdmo.ttf',
      'Stylish-Regular',
    );
    return font.getFont();
  }

  /// Sue Ellen Francisco regular
  static Future<Font> sueEllenFranciscoRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sueellenfrancisco/v11/wXK3E20CsoJ9j1DDkjHcQ5ZL8xRaxru9ropF2lqk9H4.ttf',
      'SueEllenFrancisco-Regular',
    );
    return font.getFont();
  }

  /// Suez One regular
  static Future<Font> suezOneRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/suezone/v5/taiJGmd_EZ6rqscQgNFJkIqg-I0w.ttf',
      'SuezOne-Regular',
    );
    return font.getFont();
  }

  /// Sulphur Point 300
  static Future<Font> sulphurPointLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sulphurpoint/v4/RLpkK5vv8KaycDcazWFPBj2afVU6n6kFUHPIFaU.ttf',
      'SulphurPoint-Light',
    );
    return font.getFont();
  }

  /// Sulphur Point regular
  static Future<Font> sulphurPointRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sulphurpoint/v4/RLp5K5vv8KaycDcazWFPBj2aRfkSu6EuTHo.ttf',
      'SulphurPoint-Regular',
    );
    return font.getFont();
  }

  /// Sulphur Point 700
  static Future<Font> sulphurPointBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sulphurpoint/v4/RLpkK5vv8KaycDcazWFPBj2afUU9n6kFUHPIFaU.ttf',
      'SulphurPoint-Bold',
    );
    return font.getFont();
  }

  /// Sumana regular
  static Future<Font> sumanaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sumana/v5/4UaDrE5TqRBjGj-G8Bji76zR4w.ttf',
      'Sumana-Regular',
    );
    return font.getFont();
  }

  /// Sumana 700
  static Future<Font> sumanaBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sumana/v5/4UaArE5TqRBjGj--TDfG54fN6ppsKg.ttf',
      'Sumana-Bold',
    );
    return font.getFont();
  }

  /// Sunflower 300
  static Future<Font> sunflowerLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sunflower/v9/RWmPoKeF8fUjqIj7Vc-06MfiqYsGBGBzCw.ttf',
      'Sunflower-Light',
    );
    return font.getFont();
  }

  /// Sunflower 500
  static Future<Font> sunflowerMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sunflower/v9/RWmPoKeF8fUjqIj7Vc-0sMbiqYsGBGBzCw.ttf',
      'Sunflower-Medium',
    );
    return font.getFont();
  }

  /// Sunflower 700
  static Future<Font> sunflowerBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sunflower/v9/RWmPoKeF8fUjqIj7Vc-0-MDiqYsGBGBzCw.ttf',
      'Sunflower-Bold',
    );
    return font.getFont();
  }

  /// Sunshiney regular
  static Future<Font> sunshineyRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sunshiney/v13/LDIwapGTLBwsS-wT4vcgE8moUePWkg.ttf',
      'Sunshiney-Regular',
    );
    return font.getFont();
  }

  /// Supermercado One regular
  static Future<Font> supermercadoOneRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/supermercadoone/v12/OpNXnpQWg8jc_xps_Gi14kVVEXOn60b3MClBRTs.ttf',
      'SupermercadoOne-Regular',
    );
    return font.getFont();
  }

  /// Sura regular
  static Future<Font> suraRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sura/v7/SZc23FL5PbyzFf5UWzXtjUM.ttf',
      'Sura-Regular',
    );
    return font.getFont();
  }

  /// Sura 700
  static Future<Font> suraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/sura/v7/SZc53FL5PbyzLUJ7fz3GkUrS8DI.ttf',
      'Sura-Bold',
    );
    return font.getFont();
  }

  /// Suranna regular
  static Future<Font> surannaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/suranna/v8/gokuH6ztGkFjWe58tBRZT2KmgP0.ttf',
      'Suranna-Regular',
    );
    return font.getFont();
  }

  /// Suravaram regular
  static Future<Font> suravaramRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/suravaram/v11/_gP61R_usiY7SCym4xIAi261Qv9roQ.ttf',
      'Suravaram-Regular',
    );
    return font.getFont();
  }

  /// Suwannaphum regular
  static Future<Font> suwannaphumRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/suwannaphum/v16/jAnCgHV7GtDvc8jbe8hXXIWl_8C0Wg2V.ttf',
      'Suwannaphum-Regular',
    );
    return font.getFont();
  }

  /// Swanky and Moo Moo regular
  static Future<Font> swankyandMooMooRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/swankyandmoomoo/v12/flUlRrKz24IuWVI_WJYTYcqbEsMUZ3kUtbPkR64SYQ.ttf',
      'SwankyandMooMoo-Regular',
    );
    return font.getFont();
  }

  /// Syncopate regular
  static Future<Font> syncopateRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/syncopate/v12/pe0sMIuPIYBCpEV5eFdyAv2-C99ycg.ttf',
      'Syncopate-Regular',
    );
    return font.getFont();
  }

  /// Syncopate 700
  static Future<Font> syncopateBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/syncopate/v12/pe0pMIuPIYBCpEV5eFdKvtKaA_Rue1UwVg.ttf',
      'Syncopate-Bold',
    );
    return font.getFont();
  }

  /// Syne regular
  static Future<Font> syneRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/syne/v3/8vIS7w4qzmVxsWxjBZRjr0FKM_04uT6kR47NCV5Z.ttf',
      'Syne-Regular',
    );
    return font.getFont();
  }

  /// Syne 500
  static Future<Font> syneMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/syne/v3/8vIS7w4qzmVxsWxjBZRjr0FKM_0KuT6kR47NCV5Z.ttf',
      'Syne-Medium',
    );
    return font.getFont();
  }

  /// Syne 600
  static Future<Font> syneSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/syne/v3/8vIS7w4qzmVxsWxjBZRjr0FKM_3mvj6kR47NCV5Z.ttf',
      'Syne-SemiBold',
    );
    return font.getFont();
  }

  /// Syne 700
  static Future<Font> syneBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/syne/v3/8vIS7w4qzmVxsWxjBZRjr0FKM_3fvj6kR47NCV5Z.ttf',
      'Syne-Bold',
    );
    return font.getFont();
  }

  /// Syne 800
  static Future<Font> syneExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/syne/v3/8vIS7w4qzmVxsWxjBZRjr0FKM_24vj6kR47NCV5Z.ttf',
      'Syne-ExtraBold',
    );
    return font.getFont();
  }

  /// Syne Mono regular
  static Future<Font> syneMonoRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/synemono/v5/K2FzfZNHj_FHBmRbFvHzIqCkDyvqZA.ttf',
      'SyneMono-Regular',
    );
    return font.getFont();
  }

  /// Syne Tactile regular
  static Future<Font> syneTactileRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/synetactile/v5/11hGGpna2UTQKjMCVzjAPMKh3ysdjvKU8Q.ttf',
      'SyneTactile-Regular',
    );
    return font.getFont();
  }

  /// Tajawal 200
  static Future<Font> tajawalExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/tajawal/v4/Iurf6YBj_oCad4k1l_6gLrZjiLlJ-G0.ttf',
      'Tajawal-ExtraLight',
    );
    return font.getFont();
  }

  /// Tajawal 300
  static Future<Font> tajawalLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/tajawal/v4/Iurf6YBj_oCad4k1l5qjLrZjiLlJ-G0.ttf',
      'Tajawal-Light',
    );
    return font.getFont();
  }

  /// Tajawal regular
  static Future<Font> tajawalRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/tajawal/v4/Iura6YBj_oCad4k1rzaLCr5IlLA.ttf',
      'Tajawal-Regular',
    );
    return font.getFont();
  }

  /// Tajawal 500
  static Future<Font> tajawalMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/tajawal/v4/Iurf6YBj_oCad4k1l8KiLrZjiLlJ-G0.ttf',
      'Tajawal-Medium',
    );
    return font.getFont();
  }

  /// Tajawal 700
  static Future<Font> tajawalBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/tajawal/v4/Iurf6YBj_oCad4k1l4qkLrZjiLlJ-G0.ttf',
      'Tajawal-Bold',
    );
    return font.getFont();
  }

  /// Tajawal 800
  static Future<Font> tajawalExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/tajawal/v4/Iurf6YBj_oCad4k1l5anLrZjiLlJ-G0.ttf',
      'Tajawal-ExtraBold',
    );
    return font.getFont();
  }

  /// Tajawal 900
  static Future<Font> tajawalBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/tajawal/v4/Iurf6YBj_oCad4k1l7KmLrZjiLlJ-G0.ttf',
      'Tajawal-Black',
    );
    return font.getFont();
  }

  /// Tangerine regular
  static Future<Font> tangerineRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/tangerine/v12/IurY6Y5j_oScZZow4VOBDpxNhLBQ4Q.ttf',
      'Tangerine-Regular',
    );
    return font.getFont();
  }

  /// Tangerine 700
  static Future<Font> tangerineBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/tangerine/v12/Iurd6Y5j_oScZZow4VO5srNpjJtM6G0t9w.ttf',
      'Tangerine-Bold',
    );
    return font.getFont();
  }

  /// Taprom regular
  static Future<Font> tapromRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/taprom/v14/UcCn3F82JHycULbFQyk3-0kvHg.ttf',
      'Taprom-Regular',
    );
    return font.getFont();
  }

  /// Tauri regular
  static Future<Font> tauriRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/tauri/v11/TwMA-IISS0AM3IpVWHU_TBqO.ttf',
      'Tauri-Regular',
    );
    return font.getFont();
  }

  /// Taviraj 100
  static Future<Font> tavirajThin() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/taviraj/v6/ahcbv8Cj3ylylTXzRIorV8N1jU2gog.ttf',
      'Taviraj-Thin',
    );
    return font.getFont();
  }

  /// Taviraj 100italic
  static Future<Font> tavirajThinItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/taviraj/v6/ahcdv8Cj3ylylTXzTOwTM8lxr0iwolLl.ttf',
      'Taviraj-ThinItalic',
    );
    return font.getFont();
  }

  /// Taviraj 200
  static Future<Font> tavirajExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/taviraj/v6/ahccv8Cj3ylylTXzRCYKd-lbgUS5u0s.ttf',
      'Taviraj-ExtraLight',
    );
    return font.getFont();
  }

  /// Taviraj 200italic
  static Future<Font> tavirajExtraLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/taviraj/v6/ahcev8Cj3ylylTXzTOwTn-hRhWa8q0v8ag.ttf',
      'Taviraj-ExtraLightItalic',
    );
    return font.getFont();
  }

  /// Taviraj 300
  static Future<Font> tavirajLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/taviraj/v6/ahccv8Cj3ylylTXzREIJd-lbgUS5u0s.ttf',
      'Taviraj-Light',
    );
    return font.getFont();
  }

  /// Taviraj 300italic
  static Future<Font> tavirajLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/taviraj/v6/ahcev8Cj3ylylTXzTOwT--tRhWa8q0v8ag.ttf',
      'Taviraj-LightItalic',
    );
    return font.getFont();
  }

  /// Taviraj regular
  static Future<Font> tavirajRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/taviraj/v6/ahcZv8Cj3ylylTXzfO4hU-FwnU0.ttf',
      'Taviraj-Regular',
    );
    return font.getFont();
  }

  /// Taviraj italic
  static Future<Font> tavirajItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/taviraj/v6/ahcbv8Cj3ylylTXzTOwrV8N1jU2gog.ttf',
      'Taviraj-Italic',
    );
    return font.getFont();
  }

  /// Taviraj 500
  static Future<Font> tavirajMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/taviraj/v6/ahccv8Cj3ylylTXzRBoId-lbgUS5u0s.ttf',
      'Taviraj-Medium',
    );
    return font.getFont();
  }

  /// Taviraj 500italic
  static Future<Font> tavirajMediumItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/taviraj/v6/ahcev8Cj3ylylTXzTOwTo-pRhWa8q0v8ag.ttf',
      'Taviraj-MediumItalic',
    );
    return font.getFont();
  }

  /// Taviraj 600
  static Future<Font> tavirajSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/taviraj/v6/ahccv8Cj3ylylTXzRDYPd-lbgUS5u0s.ttf',
      'Taviraj-SemiBold',
    );
    return font.getFont();
  }

  /// Taviraj 600italic
  static Future<Font> tavirajSemiBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/taviraj/v6/ahcev8Cj3ylylTXzTOwTj-1RhWa8q0v8ag.ttf',
      'Taviraj-SemiBoldItalic',
    );
    return font.getFont();
  }

  /// Taviraj 700
  static Future<Font> tavirajBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/taviraj/v6/ahccv8Cj3ylylTXzRFIOd-lbgUS5u0s.ttf',
      'Taviraj-Bold',
    );
    return font.getFont();
  }

  /// Taviraj 700italic
  static Future<Font> tavirajBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/taviraj/v6/ahcev8Cj3ylylTXzTOwT6-xRhWa8q0v8ag.ttf',
      'Taviraj-BoldItalic',
    );
    return font.getFont();
  }

  /// Taviraj 800
  static Future<Font> tavirajExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/taviraj/v6/ahccv8Cj3ylylTXzRE4Nd-lbgUS5u0s.ttf',
      'Taviraj-ExtraBold',
    );
    return font.getFont();
  }

  /// Taviraj 800italic
  static Future<Font> tavirajExtraBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/taviraj/v6/ahcev8Cj3ylylTXzTOwT9-9RhWa8q0v8ag.ttf',
      'Taviraj-ExtraBoldItalic',
    );
    return font.getFont();
  }

  /// Taviraj 900
  static Future<Font> tavirajBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/taviraj/v6/ahccv8Cj3ylylTXzRGoMd-lbgUS5u0s.ttf',
      'Taviraj-Black',
    );
    return font.getFont();
  }

  /// Taviraj 900italic
  static Future<Font> tavirajBlackItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/taviraj/v6/ahcev8Cj3ylylTXzTOwT0-5RhWa8q0v8ag.ttf',
      'Taviraj-BlackItalic',
    );
    return font.getFont();
  }

  /// Teko 300
  static Future<Font> tekoLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/teko/v10/LYjCdG7kmE0gdQhfgCNqqVIuTN4.ttf',
      'Teko-Light',
    );
    return font.getFont();
  }

  /// Teko regular
  static Future<Font> tekoRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/teko/v10/LYjNdG7kmE0gTaR3pCtBtVs.ttf',
      'Teko-Regular',
    );
    return font.getFont();
  }

  /// Teko 500
  static Future<Font> tekoMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/teko/v10/LYjCdG7kmE0gdVBegCNqqVIuTN4.ttf',
      'Teko-Medium',
    );
    return font.getFont();
  }

  /// Teko 600
  static Future<Font> tekoSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/teko/v10/LYjCdG7kmE0gdXxZgCNqqVIuTN4.ttf',
      'Teko-SemiBold',
    );
    return font.getFont();
  }

  /// Teko 700
  static Future<Font> tekoBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/teko/v10/LYjCdG7kmE0gdRhYgCNqqVIuTN4.ttf',
      'Teko-Bold',
    );
    return font.getFont();
  }

  /// Telex regular
  static Future<Font> telexRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/telex/v9/ieVw2Y1fKWmIO9fTB1piKFIf.ttf',
      'Telex-Regular',
    );
    return font.getFont();
  }

  /// Tenali Ramakrishna regular
  static Future<Font> tenaliRamakrishnaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/tenaliramakrishna/v7/raxgHj6Yt9gAN3LLKs0BZVMo8jmwn1-8KJXqUFFvtA.ttf',
      'TenaliRamakrishna-Regular',
    );
    return font.getFont();
  }

  /// Tenor Sans regular
  static Future<Font> tenorSansRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/tenorsans/v12/bx6ANxqUneKx06UkIXISr3JyC22IyqI.ttf',
      'TenorSans-Regular',
    );
    return font.getFont();
  }

  /// Text Me One regular
  static Future<Font> textMeOneRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/textmeone/v10/i7dOIFdlayuLUvgoFvHQFWZcalayGhyV.ttf',
      'TextMeOne-Regular',
    );
    return font.getFont();
  }

  /// Texturina 100
  static Future<Font> texturinaThin() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/texturina/v9/c4mM1nxpEtL3pXiAulRTkY-HGmNEX1b9NspjMwhAgliHhVrXy2eYG_Ug25riW1OD.ttf',
      'Texturina-Thin',
    );
    return font.getFont();
  }

  /// Texturina 200
  static Future<Font> texturinaExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/texturina/v9/c4mM1nxpEtL3pXiAulRTkY-HGmNEX1b9NspjMwhAgliHhVrXy2cYGvUg25riW1OD.ttf',
      'Texturina-ExtraLight',
    );
    return font.getFont();
  }

  /// Texturina 300
  static Future<Font> texturinaLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/texturina/v9/c4mM1nxpEtL3pXiAulRTkY-HGmNEX1b9NspjMwhAgliHhVrXy2fGGvUg25riW1OD.ttf',
      'Texturina-Light',
    );
    return font.getFont();
  }

  /// Texturina regular
  static Future<Font> texturinaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/texturina/v9/c4mM1nxpEtL3pXiAulRTkY-HGmNEX1b9NspjMwhAgliHhVrXy2eYGvUg25riW1OD.ttf',
      'Texturina-Regular',
    );
    return font.getFont();
  }

  /// Texturina 500
  static Future<Font> texturinaMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/texturina/v9/c4mM1nxpEtL3pXiAulRTkY-HGmNEX1b9NspjMwhAgliHhVrXy2eqGvUg25riW1OD.ttf',
      'Texturina-Medium',
    );
    return font.getFont();
  }

  /// Texturina 600
  static Future<Font> texturinaSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/texturina/v9/c4mM1nxpEtL3pXiAulRTkY-HGmNEX1b9NspjMwhAgliHhVrXy2dGHfUg25riW1OD.ttf',
      'Texturina-SemiBold',
    );
    return font.getFont();
  }

  /// Texturina 700
  static Future<Font> texturinaBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/texturina/v9/c4mM1nxpEtL3pXiAulRTkY-HGmNEX1b9NspjMwhAgliHhVrXy2d_HfUg25riW1OD.ttf',
      'Texturina-Bold',
    );
    return font.getFont();
  }

  /// Texturina 800
  static Future<Font> texturinaExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/texturina/v9/c4mM1nxpEtL3pXiAulRTkY-HGmNEX1b9NspjMwhAgliHhVrXy2cYHfUg25riW1OD.ttf',
      'Texturina-ExtraBold',
    );
    return font.getFont();
  }

  /// Texturina 900
  static Future<Font> texturinaBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/texturina/v9/c4mM1nxpEtL3pXiAulRTkY-HGmNEX1b9NspjMwhAgliHhVrXy2cxHfUg25riW1OD.ttf',
      'Texturina-Black',
    );
    return font.getFont();
  }

  /// Texturina 100italic
  static Future<Font> texturinaThinItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/texturina/v9/c4mO1nxpEtL3pXiAulR5mL129FhZmLj7I4oiSUJyfYDu7sB5zHJQWR1i0Z7AXkODN94.ttf',
      'Texturina-ThinItalic',
    );
    return font.getFont();
  }

  /// Texturina 200italic
  static Future<Font> texturinaExtraLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/texturina/v9/c4mO1nxpEtL3pXiAulR5mL129FhZmLj7I4oiSUJyfYDu7sB5zHJQWZ1j0Z7AXkODN94.ttf',
      'Texturina-ExtraLightItalic',
    );
    return font.getFont();
  }

  /// Texturina 300italic
  static Future<Font> texturinaLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/texturina/v9/c4mO1nxpEtL3pXiAulR5mL129FhZmLj7I4oiSUJyfYDu7sB5zHJQWUNj0Z7AXkODN94.ttf',
      'Texturina-LightItalic',
    );
    return font.getFont();
  }

  /// Texturina italic
  static Future<Font> texturinaItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/texturina/v9/c4mO1nxpEtL3pXiAulR5mL129FhZmLj7I4oiSUJyfYDu7sB5zHJQWR1j0Z7AXkODN94.ttf',
      'Texturina-Italic',
    );
    return font.getFont();
  }

  /// Texturina 500italic
  static Future<Font> texturinaMediumItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/texturina/v9/c4mO1nxpEtL3pXiAulR5mL129FhZmLj7I4oiSUJyfYDu7sB5zHJQWS9j0Z7AXkODN94.ttf',
      'Texturina-MediumItalic',
    );
    return font.getFont();
  }

  /// Texturina 600italic
  static Future<Font> texturinaSemiBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/texturina/v9/c4mO1nxpEtL3pXiAulR5mL129FhZmLj7I4oiSUJyfYDu7sB5zHJQWcNk0Z7AXkODN94.ttf',
      'Texturina-SemiBoldItalic',
    );
    return font.getFont();
  }

  /// Texturina 700italic
  static Future<Font> texturinaBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/texturina/v9/c4mO1nxpEtL3pXiAulR5mL129FhZmLj7I4oiSUJyfYDu7sB5zHJQWfpk0Z7AXkODN94.ttf',
      'Texturina-BoldItalic',
    );
    return font.getFont();
  }

  /// Texturina 800italic
  static Future<Font> texturinaExtraBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/texturina/v9/c4mO1nxpEtL3pXiAulR5mL129FhZmLj7I4oiSUJyfYDu7sB5zHJQWZ1k0Z7AXkODN94.ttf',
      'Texturina-ExtraBoldItalic',
    );
    return font.getFont();
  }

  /// Texturina 900italic
  static Future<Font> texturinaBlackItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/texturina/v9/c4mO1nxpEtL3pXiAulR5mL129FhZmLj7I4oiSUJyfYDu7sB5zHJQWbRk0Z7AXkODN94.ttf',
      'Texturina-BlackItalic',
    );
    return font.getFont();
  }

  /// Thasadith regular
  static Future<Font> thasadithRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/thasadith/v4/mtG44_1TIqPYrd_f5R1YsEkU0CWuFw.ttf',
      'Thasadith-Regular',
    );
    return font.getFont();
  }

  /// Thasadith italic
  static Future<Font> thasadithItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/thasadith/v4/mtG-4_1TIqPYrd_f5R1oskMQ8iC-F1ZE.ttf',
      'Thasadith-Italic',
    );
    return font.getFont();
  }

  /// Thasadith 700
  static Future<Font> thasadithBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/thasadith/v4/mtG94_1TIqPYrd_f5R1gDGYw2A6yHk9d8w.ttf',
      'Thasadith-Bold',
    );
    return font.getFont();
  }

  /// Thasadith 700italic
  static Future<Font> thasadithBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/thasadith/v4/mtGj4_1TIqPYrd_f5R1osnus3QS2PEpN8zxA.ttf',
      'Thasadith-BoldItalic',
    );
    return font.getFont();
  }

  /// The Girl Next Door regular
  static Future<Font> theGirlNextDoorRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/thegirlnextdoor/v13/pe0zMJCIMIsBjFxqYBIcZ6_OI5oFHCYIV7t7w6bE2A.ttf',
      'TheGirlNextDoor-Regular',
    );
    return font.getFont();
  }

  /// Tienne regular
  static Future<Font> tienneRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/tienne/v15/AYCKpX7pe9YCRP0LkEPHSFNyxw.ttf',
      'Tienne-Regular',
    );
    return font.getFont();
  }

  /// Tienne 700
  static Future<Font> tienneBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/tienne/v15/AYCJpX7pe9YCRP0zLGzjQHhuzvef5Q.ttf',
      'Tienne-Bold',
    );
    return font.getFont();
  }

  /// Tienne 900
  static Future<Font> tienneBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/tienne/v15/AYCJpX7pe9YCRP0zFG7jQHhuzvef5Q.ttf',
      'Tienne-Black',
    );
    return font.getFont();
  }

  /// Tillana regular
  static Future<Font> tillanaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/tillana/v6/VuJxdNvf35P4qJ1OeKbXOIFneRo.ttf',
      'Tillana-Regular',
    );
    return font.getFont();
  }

  /// Tillana 500
  static Future<Font> tillanaMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/tillana/v6/VuJ0dNvf35P4qJ1OQFL-HIlMZRNcp0o.ttf',
      'Tillana-Medium',
    );
    return font.getFont();
  }

  /// Tillana 600
  static Future<Font> tillanaSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/tillana/v6/VuJ0dNvf35P4qJ1OQH75HIlMZRNcp0o.ttf',
      'Tillana-SemiBold',
    );
    return font.getFont();
  }

  /// Tillana 700
  static Future<Font> tillanaBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/tillana/v6/VuJ0dNvf35P4qJ1OQBr4HIlMZRNcp0o.ttf',
      'Tillana-Bold',
    );
    return font.getFont();
  }

  /// Tillana 800
  static Future<Font> tillanaExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/tillana/v6/VuJ0dNvf35P4qJ1OQAb7HIlMZRNcp0o.ttf',
      'Tillana-ExtraBold',
    );
    return font.getFont();
  }

  /// Timmana regular
  static Future<Font> timmanaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/timmana/v7/6xKvdShfL9yK-rvpCmvbKHwJUOM.ttf',
      'Timmana-Regular',
    );
    return font.getFont();
  }

  /// Tinos regular
  static Future<Font> tinosRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/tinos/v16/buE4poGnedXvwgX8dGVh8TI-.ttf',
      'Tinos-Regular',
    );
    return font.getFont();
  }

  /// Tinos italic
  static Future<Font> tinosItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/tinos/v16/buE2poGnedXvwjX-fmFD9CI-4NU.ttf',
      'Tinos-Italic',
    );
    return font.getFont();
  }

  /// Tinos 700
  static Future<Font> tinosBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/tinos/v16/buE1poGnedXvwj1AW0Fp2i43-cxL.ttf',
      'Tinos-Bold',
    );
    return font.getFont();
  }

  /// Tinos 700italic
  static Future<Font> tinosBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/tinos/v16/buEzpoGnedXvwjX-Rt1s0CoV_NxLeiw.ttf',
      'Tinos-BoldItalic',
    );
    return font.getFont();
  }

  /// Titan One regular
  static Future<Font> titanOneRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/titanone/v8/mFTzWbsGxbbS_J5cQcjykzIn2Etikg.ttf',
      'TitanOne-Regular',
    );
    return font.getFont();
  }

  /// Titillium Web 200
  static Future<Font> titilliumWebExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/titilliumweb/v9/NaPDcZTIAOhVxoMyOr9n_E7ffAzHKIx5YrSYqWM.ttf',
      'TitilliumWeb-ExtraLight',
    );
    return font.getFont();
  }

  /// Titillium Web 200italic
  static Future<Font> titilliumWebExtraLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/titilliumweb/v9/NaPFcZTIAOhVxoMyOr9n_E7fdMbewI1zZpaduWMmxA.ttf',
      'TitilliumWeb-ExtraLightItalic',
    );
    return font.getFont();
  }

  /// Titillium Web 300
  static Future<Font> titilliumWebLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/titilliumweb/v9/NaPDcZTIAOhVxoMyOr9n_E7ffGjEKIx5YrSYqWM.ttf',
      'TitilliumWeb-Light',
    );
    return font.getFont();
  }

  /// Titillium Web 300italic
  static Future<Font> titilliumWebLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/titilliumweb/v9/NaPFcZTIAOhVxoMyOr9n_E7fdMbepI5zZpaduWMmxA.ttf',
      'TitilliumWeb-LightItalic',
    );
    return font.getFont();
  }

  /// Titillium Web regular
  static Future<Font> titilliumWebRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/titilliumweb/v9/NaPecZTIAOhVxoMyOr9n_E7fRMTsDIRSfr0.ttf',
      'TitilliumWeb-Regular',
    );
    return font.getFont();
  }

  /// Titillium Web italic
  static Future<Font> titilliumWebItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/titilliumweb/v9/NaPAcZTIAOhVxoMyOr9n_E7fdMbmCKZXbr2BsA.ttf',
      'TitilliumWeb-Italic',
    );
    return font.getFont();
  }

  /// Titillium Web 600
  static Future<Font> titilliumWebSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/titilliumweb/v9/NaPDcZTIAOhVxoMyOr9n_E7ffBzCKIx5YrSYqWM.ttf',
      'TitilliumWeb-SemiBold',
    );
    return font.getFont();
  }

  /// Titillium Web 600italic
  static Future<Font> titilliumWebSemiBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/titilliumweb/v9/NaPFcZTIAOhVxoMyOr9n_E7fdMbe0IhzZpaduWMmxA.ttf',
      'TitilliumWeb-SemiBoldItalic',
    );
    return font.getFont();
  }

  /// Titillium Web 700
  static Future<Font> titilliumWebBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/titilliumweb/v9/NaPDcZTIAOhVxoMyOr9n_E7ffHjDKIx5YrSYqWM.ttf',
      'TitilliumWeb-Bold',
    );
    return font.getFont();
  }

  /// Titillium Web 700italic
  static Future<Font> titilliumWebBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/titilliumweb/v9/NaPFcZTIAOhVxoMyOr9n_E7fdMbetIlzZpaduWMmxA.ttf',
      'TitilliumWeb-BoldItalic',
    );
    return font.getFont();
  }

  /// Titillium Web 900
  static Future<Font> titilliumWebBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/titilliumweb/v9/NaPDcZTIAOhVxoMyOr9n_E7ffEDBKIx5YrSYqWM.ttf',
      'TitilliumWeb-Black',
    );
    return font.getFont();
  }

  /// Tomorrow 100
  static Future<Font> tomorrowThin() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/tomorrow/v5/WBLgrETNbFtZCeGqgR2xe2XiKMiokE4.ttf',
      'Tomorrow-Thin',
    );
    return font.getFont();
  }

  /// Tomorrow 100italic
  static Future<Font> tomorrowThinItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/tomorrow/v5/WBLirETNbFtZCeGqgRXXQwHoLOqtgE5h0A.ttf',
      'Tomorrow-ThinItalic',
    );
    return font.getFont();
  }

  /// Tomorrow 200
  static Future<Font> tomorrowExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/tomorrow/v5/WBLhrETNbFtZCeGqgR0dWkXIBsShiVd4.ttf',
      'Tomorrow-ExtraLight',
    );
    return font.getFont();
  }

  /// Tomorrow 200italic
  static Future<Font> tomorrowExtraLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/tomorrow/v5/WBLjrETNbFtZCeGqgRXXQ63JDMCDjEd4yVY.ttf',
      'Tomorrow-ExtraLightItalic',
    );
    return font.getFont();
  }

  /// Tomorrow 300
  static Future<Font> tomorrowLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/tomorrow/v5/WBLhrETNbFtZCeGqgR15WUXIBsShiVd4.ttf',
      'Tomorrow-Light',
    );
    return font.getFont();
  }

  /// Tomorrow 300italic
  static Future<Font> tomorrowLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/tomorrow/v5/WBLjrETNbFtZCeGqgRXXQ8nKDMCDjEd4yVY.ttf',
      'Tomorrow-LightItalic',
    );
    return font.getFont();
  }

  /// Tomorrow regular
  static Future<Font> tomorrowRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/tomorrow/v5/WBLmrETNbFtZCeGqgSXVcWHALdio.ttf',
      'Tomorrow-Regular',
    );
    return font.getFont();
  }

  /// Tomorrow italic
  static Future<Font> tomorrowItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/tomorrow/v5/WBLgrETNbFtZCeGqgRXXe2XiKMiokE4.ttf',
      'Tomorrow-Italic',
    );
    return font.getFont();
  }

  /// Tomorrow 500
  static Future<Font> tomorrowMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/tomorrow/v5/WBLhrETNbFtZCeGqgR0hWEXIBsShiVd4.ttf',
      'Tomorrow-Medium',
    );
    return font.getFont();
  }

  /// Tomorrow 500italic
  static Future<Font> tomorrowMediumItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/tomorrow/v5/WBLjrETNbFtZCeGqgRXXQ5HLDMCDjEd4yVY.ttf',
      'Tomorrow-MediumItalic',
    );
    return font.getFont();
  }

  /// Tomorrow 600
  static Future<Font> tomorrowSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/tomorrow/v5/WBLhrETNbFtZCeGqgR0NX0XIBsShiVd4.ttf',
      'Tomorrow-SemiBold',
    );
    return font.getFont();
  }

  /// Tomorrow 600italic
  static Future<Font> tomorrowSemiBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/tomorrow/v5/WBLjrETNbFtZCeGqgRXXQ73MDMCDjEd4yVY.ttf',
      'Tomorrow-SemiBoldItalic',
    );
    return font.getFont();
  }

  /// Tomorrow 700
  static Future<Font> tomorrowBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/tomorrow/v5/WBLhrETNbFtZCeGqgR1pXkXIBsShiVd4.ttf',
      'Tomorrow-Bold',
    );
    return font.getFont();
  }

  /// Tomorrow 700italic
  static Future<Font> tomorrowBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/tomorrow/v5/WBLjrETNbFtZCeGqgRXXQ9nNDMCDjEd4yVY.ttf',
      'Tomorrow-BoldItalic',
    );
    return font.getFont();
  }

  /// Tomorrow 800
  static Future<Font> tomorrowExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/tomorrow/v5/WBLhrETNbFtZCeGqgR11XUXIBsShiVd4.ttf',
      'Tomorrow-ExtraBold',
    );
    return font.getFont();
  }

  /// Tomorrow 800italic
  static Future<Font> tomorrowExtraBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/tomorrow/v5/WBLjrETNbFtZCeGqgRXXQ8XODMCDjEd4yVY.ttf',
      'Tomorrow-ExtraBoldItalic',
    );
    return font.getFont();
  }

  /// Tomorrow 900
  static Future<Font> tomorrowBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/tomorrow/v5/WBLhrETNbFtZCeGqgR1RXEXIBsShiVd4.ttf',
      'Tomorrow-Black',
    );
    return font.getFont();
  }

  /// Tomorrow 900italic
  static Future<Font> tomorrowBlackItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/tomorrow/v5/WBLjrETNbFtZCeGqgRXXQ-HPDMCDjEd4yVY.ttf',
      'Tomorrow-BlackItalic',
    );
    return font.getFont();
  }

  /// Trade Winds regular
  static Future<Font> tradeWindsRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/tradewinds/v12/AYCPpXPpYNIIT7h8-QenM3Jq7PKP5Z_G.ttf',
      'TradeWinds-Regular',
    );
    return font.getFont();
  }

  /// Train One regular
  static Future<Font> trainOneRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/trainone/v4/gyB-hwkiNtc6KnxUVjWHOqbZRY7JVQ.ttf',
      'TrainOne-Regular',
    );
    return font.getFont();
  }

  /// Trirong 100
  static Future<Font> trirongThin() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/trirong/v6/7r3EqXNgp8wxdOdOl-go3YRl6ujngw.ttf',
      'Trirong-Thin',
    );
    return font.getFont();
  }

  /// Trirong 100italic
  static Future<Font> trirongThinItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/trirong/v6/7r3CqXNgp8wxdOdOn44QuY5hyO33g8IY.ttf',
      'Trirong-ThinItalic',
    );
    return font.getFont();
  }

  /// Trirong 200
  static Future<Font> trirongExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/trirong/v6/7r3DqXNgp8wxdOdOl0QJ_a5L5uH-mts.ttf',
      'Trirong-ExtraLight',
    );
    return font.getFont();
  }

  /// Trirong 200italic
  static Future<Font> trirongExtraLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/trirong/v6/7r3BqXNgp8wxdOdOn44QFa9B4sP7itsB5g.ttf',
      'Trirong-ExtraLightItalic',
    );
    return font.getFont();
  }

  /// Trirong 300
  static Future<Font> trirongLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/trirong/v6/7r3DqXNgp8wxdOdOlyAK_a5L5uH-mts.ttf',
      'Trirong-Light',
    );
    return font.getFont();
  }

  /// Trirong 300italic
  static Future<Font> trirongLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/trirong/v6/7r3BqXNgp8wxdOdOn44QcaxB4sP7itsB5g.ttf',
      'Trirong-LightItalic',
    );
    return font.getFont();
  }

  /// Trirong regular
  static Future<Font> trirongRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/trirong/v6/7r3GqXNgp8wxdOdOr4wi2aZg-ug.ttf',
      'Trirong-Regular',
    );
    return font.getFont();
  }

  /// Trirong italic
  static Future<Font> trirongItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/trirong/v6/7r3EqXNgp8wxdOdOn44o3YRl6ujngw.ttf',
      'Trirong-Italic',
    );
    return font.getFont();
  }

  /// Trirong 500
  static Future<Font> trirongMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/trirong/v6/7r3DqXNgp8wxdOdOl3gL_a5L5uH-mts.ttf',
      'Trirong-Medium',
    );
    return font.getFont();
  }

  /// Trirong 500italic
  static Future<Font> trirongMediumItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/trirong/v6/7r3BqXNgp8wxdOdOn44QKa1B4sP7itsB5g.ttf',
      'Trirong-MediumItalic',
    );
    return font.getFont();
  }

  /// Trirong 600
  static Future<Font> trirongSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/trirong/v6/7r3DqXNgp8wxdOdOl1QM_a5L5uH-mts.ttf',
      'Trirong-SemiBold',
    );
    return font.getFont();
  }

  /// Trirong 600italic
  static Future<Font> trirongSemiBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/trirong/v6/7r3BqXNgp8wxdOdOn44QBapB4sP7itsB5g.ttf',
      'Trirong-SemiBoldItalic',
    );
    return font.getFont();
  }

  /// Trirong 700
  static Future<Font> trirongBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/trirong/v6/7r3DqXNgp8wxdOdOlzAN_a5L5uH-mts.ttf',
      'Trirong-Bold',
    );
    return font.getFont();
  }

  /// Trirong 700italic
  static Future<Font> trirongBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/trirong/v6/7r3BqXNgp8wxdOdOn44QYatB4sP7itsB5g.ttf',
      'Trirong-BoldItalic',
    );
    return font.getFont();
  }

  /// Trirong 800
  static Future<Font> trirongExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/trirong/v6/7r3DqXNgp8wxdOdOlywO_a5L5uH-mts.ttf',
      'Trirong-ExtraBold',
    );
    return font.getFont();
  }

  /// Trirong 800italic
  static Future<Font> trirongExtraBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/trirong/v6/7r3BqXNgp8wxdOdOn44QfahB4sP7itsB5g.ttf',
      'Trirong-ExtraBoldItalic',
    );
    return font.getFont();
  }

  /// Trirong 900
  static Future<Font> trirongBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/trirong/v6/7r3DqXNgp8wxdOdOlwgP_a5L5uH-mts.ttf',
      'Trirong-Black',
    );
    return font.getFont();
  }

  /// Trirong 900italic
  static Future<Font> trirongBlackItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/trirong/v6/7r3BqXNgp8wxdOdOn44QWalB4sP7itsB5g.ttf',
      'Trirong-BlackItalic',
    );
    return font.getFont();
  }

  /// Trispace 100
  static Future<Font> trispaceThin() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/trispace/v6/Yq65-LKSQC3o56LxxgRrtA6yBqsrXL5GI5KI-IUZVGsxWFIlbH9qoQl0zHugpt0.ttf',
      'Trispace-Thin',
    );
    return font.getFont();
  }

  /// Trispace 200
  static Future<Font> trispaceExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/trispace/v6/Yq65-LKSQC3o56LxxgRrtA6yBqsrXL5GI5KI-IUZVGsxWFIlbP9roQl0zHugpt0.ttf',
      'Trispace-ExtraLight',
    );
    return font.getFont();
  }

  /// Trispace 300
  static Future<Font> trispaceLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/trispace/v6/Yq65-LKSQC3o56LxxgRrtA6yBqsrXL5GI5KI-IUZVGsxWFIlbCFroQl0zHugpt0.ttf',
      'Trispace-Light',
    );
    return font.getFont();
  }

  /// Trispace regular
  static Future<Font> trispaceRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/trispace/v6/Yq65-LKSQC3o56LxxgRrtA6yBqsrXL5GI5KI-IUZVGsxWFIlbH9roQl0zHugpt0.ttf',
      'Trispace-Regular',
    );
    return font.getFont();
  }

  /// Trispace 500
  static Future<Font> trispaceMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/trispace/v6/Yq65-LKSQC3o56LxxgRrtA6yBqsrXL5GI5KI-IUZVGsxWFIlbE1roQl0zHugpt0.ttf',
      'Trispace-Medium',
    );
    return font.getFont();
  }

  /// Trispace 600
  static Future<Font> trispaceSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/trispace/v6/Yq65-LKSQC3o56LxxgRrtA6yBqsrXL5GI5KI-IUZVGsxWFIlbKFsoQl0zHugpt0.ttf',
      'Trispace-SemiBold',
    );
    return font.getFont();
  }

  /// Trispace 700
  static Future<Font> trispaceBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/trispace/v6/Yq65-LKSQC3o56LxxgRrtA6yBqsrXL5GI5KI-IUZVGsxWFIlbJhsoQl0zHugpt0.ttf',
      'Trispace-Bold',
    );
    return font.getFont();
  }

  /// Trispace 800
  static Future<Font> trispaceExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/trispace/v6/Yq65-LKSQC3o56LxxgRrtA6yBqsrXL5GI5KI-IUZVGsxWFIlbP9soQl0zHugpt0.ttf',
      'Trispace-ExtraBold',
    );
    return font.getFont();
  }

  /// Trocchi regular
  static Future<Font> trocchiRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/trocchi/v9/qWcqB6WkuIDxDZLcDrtUvMeTYD0.ttf',
      'Trocchi-Regular',
    );
    return font.getFont();
  }

  /// Trochut regular
  static Future<Font> trochutRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/trochut/v10/CHyjV-fDDlP9bDIw5nSIfVIPLns.ttf',
      'Trochut-Regular',
    );
    return font.getFont();
  }

  /// Trochut italic
  static Future<Font> trochutItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/trochut/v10/CHyhV-fDDlP9bDIw1naCeXAKPns8jw.ttf',
      'Trochut-Italic',
    );
    return font.getFont();
  }

  /// Trochut 700
  static Future<Font> trochutBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/trochut/v10/CHymV-fDDlP9bDIw3sinWVokMnIllmA.ttf',
      'Trochut-Bold',
    );
    return font.getFont();
  }

  /// Truculenta 100
  static Future<Font> truculentaThin() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/truculenta/v6/LhWfMVvBKusVIfNYGi1-WvRVyDdZeeiySNppcu32Mb2f06y6Oa21F6XHi0VYDX_PzOupMlAjswcFHnJMMhg.ttf',
      'Truculenta-Thin',
    );
    return font.getFont();
  }

  /// Truculenta 200
  static Future<Font> truculentaExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/truculenta/v6/LhWfMVvBKusVIfNYGi1-WvRVyDdZeeiySNppcu32Mb2f06y6Oa21F6XHi0VYDX_PzOupMtAiswcFHnJMMhg.ttf',
      'Truculenta-ExtraLight',
    );
    return font.getFont();
  }

  /// Truculenta 300
  static Future<Font> truculentaLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/truculenta/v6/LhWfMVvBKusVIfNYGi1-WvRVyDdZeeiySNppcu32Mb2f06y6Oa21F6XHi0VYDX_PzOupMg4iswcFHnJMMhg.ttf',
      'Truculenta-Light',
    );
    return font.getFont();
  }

  /// Truculenta regular
  static Future<Font> truculentaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/truculenta/v6/LhWfMVvBKusVIfNYGi1-WvRVyDdZeeiySNppcu32Mb2f06y6Oa21F6XHi0VYDX_PzOupMlAiswcFHnJMMhg.ttf',
      'Truculenta-Regular',
    );
    return font.getFont();
  }

  /// Truculenta 500
  static Future<Font> truculentaMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/truculenta/v6/LhWfMVvBKusVIfNYGi1-WvRVyDdZeeiySNppcu32Mb2f06y6Oa21F6XHi0VYDX_PzOupMmIiswcFHnJMMhg.ttf',
      'Truculenta-Medium',
    );
    return font.getFont();
  }

  /// Truculenta 600
  static Future<Font> truculentaSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/truculenta/v6/LhWfMVvBKusVIfNYGi1-WvRVyDdZeeiySNppcu32Mb2f06y6Oa21F6XHi0VYDX_PzOupMo4lswcFHnJMMhg.ttf',
      'Truculenta-SemiBold',
    );
    return font.getFont();
  }

  /// Truculenta 700
  static Future<Font> truculentaBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/truculenta/v6/LhWfMVvBKusVIfNYGi1-WvRVyDdZeeiySNppcu32Mb2f06y6Oa21F6XHi0VYDX_PzOupMrclswcFHnJMMhg.ttf',
      'Truculenta-Bold',
    );
    return font.getFont();
  }

  /// Truculenta 800
  static Future<Font> truculentaExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/truculenta/v6/LhWfMVvBKusVIfNYGi1-WvRVyDdZeeiySNppcu32Mb2f06y6Oa21F6XHi0VYDX_PzOupMtAlswcFHnJMMhg.ttf',
      'Truculenta-ExtraBold',
    );
    return font.getFont();
  }

  /// Truculenta 900
  static Future<Font> truculentaBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/truculenta/v6/LhWfMVvBKusVIfNYGi1-WvRVyDdZeeiySNppcu32Mb2f06y6Oa21F6XHi0VYDX_PzOupMvklswcFHnJMMhg.ttf',
      'Truculenta-Black',
    );
    return font.getFont();
  }

  /// Trykker regular
  static Future<Font> trykkerRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/trykker/v11/KtktALyWZJXudUPzhNnoOd2j22U.ttf',
      'Trykker-Regular',
    );
    return font.getFont();
  }

  /// Tulpen One regular
  static Future<Font> tulpenOneRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/tulpenone/v12/dFa6ZfeC474skLgesc0CWj0w_HyIRlE.ttf',
      'TulpenOne-Regular',
    );
    return font.getFont();
  }

  /// Turret Road 200
  static Future<Font> turretRoadExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/turretroad/v2/pxidypMgpcBFjE84Zv-fE0ONEdeLYk1Mq3ap.ttf',
      'TurretRoad-ExtraLight',
    );
    return font.getFont();
  }

  /// Turret Road 300
  static Future<Font> turretRoadLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/turretroad/v2/pxidypMgpcBFjE84Zv-fE0PpEteLYk1Mq3ap.ttf',
      'TurretRoad-Light',
    );
    return font.getFont();
  }

  /// Turret Road regular
  static Future<Font> turretRoadRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/turretroad/v2/pxiAypMgpcBFjE84Zv-fE3tFOvODSVFF.ttf',
      'TurretRoad-Regular',
    );
    return font.getFont();
  }

  /// Turret Road 500
  static Future<Font> turretRoadMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/turretroad/v2/pxidypMgpcBFjE84Zv-fE0OxE9eLYk1Mq3ap.ttf',
      'TurretRoad-Medium',
    );
    return font.getFont();
  }

  /// Turret Road 700
  static Future<Font> turretRoadBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/turretroad/v2/pxidypMgpcBFjE84Zv-fE0P5FdeLYk1Mq3ap.ttf',
      'TurretRoad-Bold',
    );
    return font.getFont();
  }

  /// Turret Road 800
  static Future<Font> turretRoadExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/turretroad/v2/pxidypMgpcBFjE84Zv-fE0PlFteLYk1Mq3ap.ttf',
      'TurretRoad-ExtraBold',
    );
    return font.getFont();
  }

  /// Ubuntu 300
  static Future<Font> ubuntuLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ubuntu/v15/4iCv6KVjbNBYlgoC1CzTt2aMH4V_gg.ttf',
      'Ubuntu-Light',
    );
    return font.getFont();
  }

  /// Ubuntu 300italic
  static Future<Font> ubuntuLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ubuntu/v15/4iCp6KVjbNBYlgoKejZftWyIPYBvgpUI.ttf',
      'Ubuntu-LightItalic',
    );
    return font.getFont();
  }

  /// Ubuntu regular
  static Future<Font> ubuntuRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ubuntu/v15/4iCs6KVjbNBYlgo6eAT3v02QFg.ttf',
      'Ubuntu-Regular',
    );
    return font.getFont();
  }

  /// Ubuntu italic
  static Future<Font> ubuntuItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ubuntu/v15/4iCu6KVjbNBYlgoKeg7znUiAFpxm.ttf',
      'Ubuntu-Italic',
    );
    return font.getFont();
  }

  /// Ubuntu 500
  static Future<Font> ubuntuMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ubuntu/v15/4iCv6KVjbNBYlgoCjC3Tt2aMH4V_gg.ttf',
      'Ubuntu-Medium',
    );
    return font.getFont();
  }

  /// Ubuntu 500italic
  static Future<Font> ubuntuMediumItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ubuntu/v15/4iCp6KVjbNBYlgoKejYHtGyIPYBvgpUI.ttf',
      'Ubuntu-MediumItalic',
    );
    return font.getFont();
  }

  /// Ubuntu 700
  static Future<Font> ubuntuBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ubuntu/v15/4iCv6KVjbNBYlgoCxCvTt2aMH4V_gg.ttf',
      'Ubuntu-Bold',
    );
    return font.getFont();
  }

  /// Ubuntu 700italic
  static Future<Font> ubuntuBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ubuntu/v15/4iCp6KVjbNBYlgoKejZPsmyIPYBvgpUI.ttf',
      'Ubuntu-BoldItalic',
    );
    return font.getFont();
  }

  /// Ubuntu Condensed regular
  static Future<Font> ubuntuCondensedRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ubuntucondensed/v11/u-4k0rCzjgs5J7oXnJcM_0kACGMtf-fVqvHoJXw.ttf',
      'UbuntuCondensed-Regular',
    );
    return font.getFont();
  }

  /// Ubuntu Mono regular
  static Future<Font> ubuntuMonoRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ubuntumono/v10/KFOjCneDtsqEr0keqCMhbBc9AMX6lJBP.ttf',
      'UbuntuMono-Regular',
    );
    return font.getFont();
  }

  /// Ubuntu Mono italic
  static Future<Font> ubuntuMonoItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ubuntumono/v10/KFOhCneDtsqEr0keqCMhbCc_CsHYkYBPY3o.ttf',
      'UbuntuMono-Italic',
    );
    return font.getFont();
  }

  /// Ubuntu Mono 700
  static Future<Font> ubuntuMonoBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ubuntumono/v10/KFO-CneDtsqEr0keqCMhbC-BL-Hyv4xGemO1.ttf',
      'UbuntuMono-Bold',
    );
    return font.getFont();
  }

  /// Ubuntu Mono 700italic
  static Future<Font> ubuntuMonoBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ubuntumono/v10/KFO8CneDtsqEr0keqCMhbCc_Mn33tYhkf3O1GVg.ttf',
      'UbuntuMono-BoldItalic',
    );
    return font.getFont();
  }

  /// Ultra regular
  static Future<Font> ultraRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/ultra/v13/zOLy4prXmrtY-tT6yLOD6NxF.ttf',
      'Ultra-Regular',
    );
    return font.getFont();
  }

  /// Uncial Antiqua regular
  static Future<Font> uncialAntiquaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/uncialantiqua/v10/N0bM2S5WOex4OUbESzoESK-i-PfRS5VBBSSF.ttf',
      'UncialAntiqua-Regular',
    );
    return font.getFont();
  }

  /// Underdog regular
  static Future<Font> underdogRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/underdog/v11/CHygV-jCElj7diMroVSiU14GN2Il.ttf',
      'Underdog-Regular',
    );
    return font.getFont();
  }

  /// Unica One regular
  static Future<Font> unicaOneRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/unicaone/v8/DPEuYwWHyAYGVTSmalshdtffuEY7FA.ttf',
      'UnicaOne-Regular',
    );
    return font.getFont();
  }

  /// UnifrakturCook 700
  static Future<Font> unifrakturCookBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/unifrakturcook/v14/IurA6Yli8YOdcoky-0PTTdkm56n05Uw13ILXs-h6.ttf',
      'UnifrakturCook-Bold',
    );
    return font.getFont();
  }

  /// UnifrakturMaguntia regular
  static Future<Font> unifrakturMaguntiaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/unifrakturmaguntia/v11/WWXPlieVYwiGNomYU-ciRLRvEmK7oaVun2xNNgNa1A.ttf',
      'UnifrakturMaguntia-Regular',
    );
    return font.getFont();
  }

  /// Unkempt regular
  static Future<Font> unkemptRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/unkempt/v12/2EbnL-Z2DFZue0DSSYYf8z2Yt_c.ttf',
      'Unkempt-Regular',
    );
    return font.getFont();
  }

  /// Unkempt 700
  static Future<Font> unkemptBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/unkempt/v12/2EbiL-Z2DFZue0DScTow1zWzq_5uT84.ttf',
      'Unkempt-Bold',
    );
    return font.getFont();
  }

  /// Unlock regular
  static Future<Font> unlockRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/unlock/v12/7Au-p_8ykD-cDl7GKAjSwkUVOQ.ttf',
      'Unlock-Regular',
    );
    return font.getFont();
  }

  /// Unna regular
  static Future<Font> unnaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/unna/v16/AYCEpXzofN0NCpgBlGHCWFM.ttf',
      'Unna-Regular',
    );
    return font.getFont();
  }

  /// Unna italic
  static Future<Font> unnaItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/unna/v16/AYCKpXzofN0NOpoLkEPHSFNyxw.ttf',
      'Unna-Italic',
    );
    return font.getFont();
  }

  /// Unna 700
  static Future<Font> unnaBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/unna/v16/AYCLpXzofN0NMiQusGnpRFpr3vc.ttf',
      'Unna-Bold',
    );
    return font.getFont();
  }

  /// Unna 700italic
  static Future<Font> unnaBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/unna/v16/AYCJpXzofN0NOpozLGzjQHhuzvef5Q.ttf',
      'Unna-BoldItalic',
    );
    return font.getFont();
  }

  /// VT323 regular
  static Future<Font> vT323Regular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/vt323/v12/pxiKyp0ihIEF2hsYHpT2dkNE.ttf',
      'VT323-Regular',
    );
    return font.getFont();
  }

  /// Vampiro One regular
  static Future<Font> vampiroOneRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/vampiroone/v13/gokqH6DoDl5yXvJytFsdLkqnsvhIor3K.ttf',
      'VampiroOne-Regular',
    );
    return font.getFont();
  }

  /// Varela regular
  static Future<Font> varelaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/varela/v11/DPEtYwqExx0AWHXJBBQFfvzDsQ.ttf',
      'Varela-Regular',
    );
    return font.getFont();
  }

  /// Varela Round regular
  static Future<Font> varelaRoundRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/varelaround/v13/w8gdH283Tvk__Lua32TysjIvoMGOD9gxZw.ttf',
      'VarelaRound-Regular',
    );
    return font.getFont();
  }

  /// Varta 300
  static Future<Font> vartaLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/varta/v5/Qw3AZQpJHj_6LzHUngWbrFkDH1x96j4EirE-9PGLfQ.ttf',
      'Varta-Light',
    );
    return font.getFont();
  }

  /// Varta regular
  static Future<Font> vartaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/varta/v5/Qw3AZQpJHj_6LzHUngWbrFkDH1x9tD4EirE-9PGLfQ.ttf',
      'Varta-Regular',
    );
    return font.getFont();
  }

  /// Varta 500
  static Future<Font> vartaMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/varta/v5/Qw3AZQpJHj_6LzHUngWbrFkDH1x9hj4EirE-9PGLfQ.ttf',
      'Varta-Medium',
    );
    return font.getFont();
  }

  /// Varta 600
  static Future<Font> vartaSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/varta/v5/Qw3AZQpJHj_6LzHUngWbrFkDH1x9ajkEirE-9PGLfQ.ttf',
      'Varta-SemiBold',
    );
    return font.getFont();
  }

  /// Varta 700
  static Future<Font> vartaBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/varta/v5/Qw3AZQpJHj_6LzHUngWbrFkDH1x9UzkEirE-9PGLfQ.ttf',
      'Varta-Bold',
    );
    return font.getFont();
  }

  /// Vast Shadow regular
  static Future<Font> vastShadowRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/vastshadow/v10/pe0qMImKOZ1V62ZwbVY9dfe6Kdpickwp.ttf',
      'VastShadow-Regular',
    );
    return font.getFont();
  }

  /// Vesper Libre regular
  static Future<Font> vesperLibreRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/vesperlibre/v14/bx6CNxyWnf-uxPdXDHUD_Rd4D0-N2qIWVQ.ttf',
      'VesperLibre-Regular',
    );
    return font.getFont();
  }

  /// Vesper Libre 500
  static Future<Font> vesperLibreMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/vesperlibre/v14/bx6dNxyWnf-uxPdXDHUD_RdA-2ap0okKXKvPlw.ttf',
      'VesperLibre-Medium',
    );
    return font.getFont();
  }

  /// Vesper Libre 700
  static Future<Font> vesperLibreBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/vesperlibre/v14/bx6dNxyWnf-uxPdXDHUD_RdAs2Cp0okKXKvPlw.ttf',
      'VesperLibre-Bold',
    );
    return font.getFont();
  }

  /// Vesper Libre 900
  static Future<Font> vesperLibreBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/vesperlibre/v14/bx6dNxyWnf-uxPdXDHUD_RdAi2Kp0okKXKvPlw.ttf',
      'VesperLibre-Black',
    );
    return font.getFont();
  }

  /// Viaoda Libre regular
  static Future<Font> viaodaLibreRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/viaodalibre/v5/vEFW2_lWCgoR6OKuRz9kcRVJb2IY2tOHXg.ttf',
      'ViaodaLibre-Regular',
    );
    return font.getFont();
  }

  /// Vibes regular
  static Future<Font> vibesRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/vibes/v4/QdVYSTsmIB6tmbd3HpbsuBlh.ttf',
      'Vibes-Regular',
    );
    return font.getFont();
  }

  /// Vibur regular
  static Future<Font> viburRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/vibur/v13/DPEiYwmEzw0QRjTpLjoJd-Xa.ttf',
      'Vibur-Regular',
    );
    return font.getFont();
  }

  /// Vidaloka regular
  static Future<Font> vidalokaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/vidaloka/v13/7cHrv4c3ipenMKlEass8yn4hnCci.ttf',
      'Vidaloka-Regular',
    );
    return font.getFont();
  }

  /// Viga regular
  static Future<Font> vigaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/viga/v9/xMQbuFFdSaiX_QIjD4e2OX8.ttf',
      'Viga-Regular',
    );
    return font.getFont();
  }

  /// Voces regular
  static Future<Font> vocesRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/voces/v12/-F6_fjJyLyU8d4PBBG7YpzlJ.ttf',
      'Voces-Regular',
    );
    return font.getFont();
  }

  /// Volkhov regular
  static Future<Font> volkhovRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/volkhov/v12/SlGQmQieoJcKemNeQTIOhHxzcD0.ttf',
      'Volkhov-Regular',
    );
    return font.getFont();
  }

  /// Volkhov italic
  static Future<Font> volkhovItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/volkhov/v12/SlGSmQieoJcKemNecTAEgF52YD0NYw.ttf',
      'Volkhov-Italic',
    );
    return font.getFont();
  }

  /// Volkhov 700
  static Future<Font> volkhovBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/volkhov/v12/SlGVmQieoJcKemNeeY4hoHRYbDQUego.ttf',
      'Volkhov-Bold',
    );
    return font.getFont();
  }

  /// Volkhov 700italic
  static Future<Font> volkhovBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/volkhov/v12/SlGXmQieoJcKemNecTA8PHFSaBYRagrQrA.ttf',
      'Volkhov-BoldItalic',
    );
    return font.getFont();
  }

  /// Vollkorn regular
  static Future<Font> vollkornRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/vollkorn/v13/0ybgGDoxxrvAnPhYGzMlQLzuMasz6Df2MHGuGWOdEbD63w.ttf',
      'Vollkorn-Regular',
    );
    return font.getFont();
  }

  /// Vollkorn 500
  static Future<Font> vollkornMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/vollkorn/v13/0ybgGDoxxrvAnPhYGzMlQLzuMasz6Df2AnGuGWOdEbD63w.ttf',
      'Vollkorn-Medium',
    );
    return font.getFont();
  }

  /// Vollkorn 600
  static Future<Font> vollkornSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/vollkorn/v13/0ybgGDoxxrvAnPhYGzMlQLzuMasz6Df27nauGWOdEbD63w.ttf',
      'Vollkorn-SemiBold',
    );
    return font.getFont();
  }

  /// Vollkorn 700
  static Future<Font> vollkornBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/vollkorn/v13/0ybgGDoxxrvAnPhYGzMlQLzuMasz6Df213auGWOdEbD63w.ttf',
      'Vollkorn-Bold',
    );
    return font.getFont();
  }

  /// Vollkorn 800
  static Future<Font> vollkornExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/vollkorn/v13/0ybgGDoxxrvAnPhYGzMlQLzuMasz6Df2sHauGWOdEbD63w.ttf',
      'Vollkorn-ExtraBold',
    );
    return font.getFont();
  }

  /// Vollkorn 900
  static Future<Font> vollkornBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/vollkorn/v13/0ybgGDoxxrvAnPhYGzMlQLzuMasz6Df2mXauGWOdEbD63w.ttf',
      'Vollkorn-Black',
    );
    return font.getFont();
  }

  /// Vollkorn italic
  static Future<Font> vollkornItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/vollkorn/v13/0ybuGDoxxrvAnPhYGxksckM2WMCpRjDj-DJGWmmZM7Xq34g9.ttf',
      'Vollkorn-Italic',
    );
    return font.getFont();
  }

  /// Vollkorn 500italic
  static Future<Font> vollkornMediumItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/vollkorn/v13/0ybuGDoxxrvAnPhYGxksckM2WMCpRjDj-DJ0WmmZM7Xq34g9.ttf',
      'Vollkorn-MediumItalic',
    );
    return font.getFont();
  }

  /// Vollkorn 600italic
  static Future<Font> vollkornSemiBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/vollkorn/v13/0ybuGDoxxrvAnPhYGxksckM2WMCpRjDj-DKYXWmZM7Xq34g9.ttf',
      'Vollkorn-SemiBoldItalic',
    );
    return font.getFont();
  }

  /// Vollkorn 700italic
  static Future<Font> vollkornBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/vollkorn/v13/0ybuGDoxxrvAnPhYGxksckM2WMCpRjDj-DKhXWmZM7Xq34g9.ttf',
      'Vollkorn-BoldItalic',
    );
    return font.getFont();
  }

  /// Vollkorn 800italic
  static Future<Font> vollkornExtraBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/vollkorn/v13/0ybuGDoxxrvAnPhYGxksckM2WMCpRjDj-DLGXWmZM7Xq34g9.ttf',
      'Vollkorn-ExtraBoldItalic',
    );
    return font.getFont();
  }

  /// Vollkorn 900italic
  static Future<Font> vollkornBlackItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/vollkorn/v13/0ybuGDoxxrvAnPhYGxksckM2WMCpRjDj-DLvXWmZM7Xq34g9.ttf',
      'Vollkorn-BlackItalic',
    );
    return font.getFont();
  }

  /// Vollkorn SC regular
  static Future<Font> vollkornSCRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/vollkornsc/v6/j8_v6-zQ3rXpceZj9cqnVhF5NH-iSq_E.ttf',
      'VollkornSC-Regular',
    );
    return font.getFont();
  }

  /// Vollkorn SC 600
  static Future<Font> vollkornSCSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/vollkornsc/v6/j8_y6-zQ3rXpceZj9cqnVimhGluqYbPN5Yjn.ttf',
      'VollkornSC-SemiBold',
    );
    return font.getFont();
  }

  /// Vollkorn SC 700
  static Future<Font> vollkornSCBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/vollkornsc/v6/j8_y6-zQ3rXpceZj9cqnVinFG1uqYbPN5Yjn.ttf',
      'VollkornSC-Bold',
    );
    return font.getFont();
  }

  /// Vollkorn SC 900
  static Future<Font> vollkornSCBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/vollkornsc/v6/j8_y6-zQ3rXpceZj9cqnVin9GVuqYbPN5Yjn.ttf',
      'VollkornSC-Black',
    );
    return font.getFont();
  }

  /// Voltaire regular
  static Future<Font> voltaireRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/voltaire/v10/1Pttg8PcRfSblAvGvQooYKVnBOif.ttf',
      'Voltaire-Regular',
    );
    return font.getFont();
  }

  /// Waiting for the Sunrise regular
  static Future<Font> waitingfortheSunriseRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/waitingforthesunrise/v11/WBL1rFvOYl9CEv2i1mO6KUW8RKWJ2zoXoz5JsYZQ9h_ZYk5J.ttf',
      'WaitingfortheSunrise-Regular',
    );
    return font.getFont();
  }

  /// Wallpoet regular
  static Future<Font> wallpoetRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/wallpoet/v12/f0X10em2_8RnXVVdUNbu7cXP8L8G.ttf',
      'Wallpoet-Regular',
    );
    return font.getFont();
  }

  /// Walter Turncoat regular
  static Future<Font> walterTurncoatRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/walterturncoat/v13/snfys0Gs98ln43n0d-14ULoToe67YB2dQ5ZPqQ.ttf',
      'WalterTurncoat-Regular',
    );
    return font.getFont();
  }

  /// Warnes regular
  static Future<Font> warnesRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/warnes/v12/pONn1hc0GsW6sW5OpiC2o6Lkqg.ttf',
      'Warnes-Regular',
    );
    return font.getFont();
  }

  /// Wellfleet regular
  static Future<Font> wellfleetRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/wellfleet/v10/nuF7D_LfQJb3VYgX6eyT42aLDhO2HA.ttf',
      'Wellfleet-Regular',
    );
    return font.getFont();
  }

  /// Wendy One regular
  static Future<Font> wendyOneRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/wendyone/v9/2sDcZGJOipXfgfXV5wgDb2-4C7wFZQ.ttf',
      'WendyOne-Regular',
    );
    return font.getFont();
  }

  /// Wire One regular
  static Future<Font> wireOneRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/wireone/v13/qFdH35Wah5htUhV75WGiWdrCwwcJ.ttf',
      'WireOne-Regular',
    );
    return font.getFont();
  }

  /// Work Sans 100
  static Future<Font> workSansThin() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/worksans/v9/QGY_z_wNahGAdqQ43RhVcIgYT2Xz5u32K0nWNigDp6_cOyA.ttf',
      'WorkSans-Thin',
    );
    return font.getFont();
  }

  /// Work Sans 200
  static Future<Font> workSansExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/worksans/v9/QGY_z_wNahGAdqQ43RhVcIgYT2Xz5u32K8nXNigDp6_cOyA.ttf',
      'WorkSans-ExtraLight',
    );
    return font.getFont();
  }

  /// Work Sans 300
  static Future<Font> workSansLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/worksans/v9/QGY_z_wNahGAdqQ43RhVcIgYT2Xz5u32KxfXNigDp6_cOyA.ttf',
      'WorkSans-Light',
    );
    return font.getFont();
  }

  /// Work Sans regular
  static Future<Font> workSansRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/worksans/v9/QGY_z_wNahGAdqQ43RhVcIgYT2Xz5u32K0nXNigDp6_cOyA.ttf',
      'WorkSans-Regular',
    );
    return font.getFont();
  }

  /// Work Sans 500
  static Future<Font> workSansMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/worksans/v9/QGY_z_wNahGAdqQ43RhVcIgYT2Xz5u32K3vXNigDp6_cOyA.ttf',
      'WorkSans-Medium',
    );
    return font.getFont();
  }

  /// Work Sans 600
  static Future<Font> workSansSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/worksans/v9/QGY_z_wNahGAdqQ43RhVcIgYT2Xz5u32K5fQNigDp6_cOyA.ttf',
      'WorkSans-SemiBold',
    );
    return font.getFont();
  }

  /// Work Sans 700
  static Future<Font> workSansBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/worksans/v9/QGY_z_wNahGAdqQ43RhVcIgYT2Xz5u32K67QNigDp6_cOyA.ttf',
      'WorkSans-Bold',
    );
    return font.getFont();
  }

  /// Work Sans 800
  static Future<Font> workSansExtraBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/worksans/v9/QGY_z_wNahGAdqQ43RhVcIgYT2Xz5u32K8nQNigDp6_cOyA.ttf',
      'WorkSans-ExtraBold',
    );
    return font.getFont();
  }

  /// Work Sans 900
  static Future<Font> workSansBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/worksans/v9/QGY_z_wNahGAdqQ43RhVcIgYT2Xz5u32K-DQNigDp6_cOyA.ttf',
      'WorkSans-Black',
    );
    return font.getFont();
  }

  /// Work Sans 100italic
  static Future<Font> workSansThinItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/worksans/v9/QGY9z_wNahGAdqQ43Rh_ebrnlwyYfEPxPoGU3moJo43ZKyDSQQ.ttf',
      'WorkSans-ThinItalic',
    );
    return font.getFont();
  }

  /// Work Sans 200italic
  static Future<Font> workSansExtraLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/worksans/v9/QGY9z_wNahGAdqQ43Rh_ebrnlwyYfEPxPoGUXmsJo43ZKyDSQQ.ttf',
      'WorkSans-ExtraLightItalic',
    );
    return font.getFont();
  }

  /// Work Sans 300italic
  static Future<Font> workSansLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/worksans/v9/QGY9z_wNahGAdqQ43Rh_ebrnlwyYfEPxPoGUgGsJo43ZKyDSQQ.ttf',
      'WorkSans-LightItalic',
    );
    return font.getFont();
  }

  /// Work Sans italic
  static Future<Font> workSansItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/worksans/v9/QGY9z_wNahGAdqQ43Rh_ebrnlwyYfEPxPoGU3msJo43ZKyDSQQ.ttf',
      'WorkSans-Italic',
    );
    return font.getFont();
  }

  /// Work Sans 500italic
  static Future<Font> workSansMediumItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/worksans/v9/QGY9z_wNahGAdqQ43Rh_ebrnlwyYfEPxPoGU7GsJo43ZKyDSQQ.ttf',
      'WorkSans-MediumItalic',
    );
    return font.getFont();
  }

  /// Work Sans 600italic
  static Future<Font> workSansSemiBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/worksans/v9/QGY9z_wNahGAdqQ43Rh_ebrnlwyYfEPxPoGUAGwJo43ZKyDSQQ.ttf',
      'WorkSans-SemiBoldItalic',
    );
    return font.getFont();
  }

  /// Work Sans 700italic
  static Future<Font> workSansBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/worksans/v9/QGY9z_wNahGAdqQ43Rh_ebrnlwyYfEPxPoGUOWwJo43ZKyDSQQ.ttf',
      'WorkSans-BoldItalic',
    );
    return font.getFont();
  }

  /// Work Sans 800italic
  static Future<Font> workSansExtraBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/worksans/v9/QGY9z_wNahGAdqQ43Rh_ebrnlwyYfEPxPoGUXmwJo43ZKyDSQQ.ttf',
      'WorkSans-ExtraBoldItalic',
    );
    return font.getFont();
  }

  /// Work Sans 900italic
  static Future<Font> workSansBlackItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/worksans/v9/QGY9z_wNahGAdqQ43Rh_ebrnlwyYfEPxPoGUd2wJo43ZKyDSQQ.ttf',
      'WorkSans-BlackItalic',
    );
    return font.getFont();
  }

  /// Xanh Mono regular
  static Future<Font> xanhMonoRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/xanhmono/v7/R70YjykVmvKCep-vWhSYmACQXzLhTg.ttf',
      'XanhMono-Regular',
    );
    return font.getFont();
  }

  /// Xanh Mono italic
  static Future<Font> xanhMonoItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/xanhmono/v7/R70ejykVmvKCep-vWhSomgqUfTfxTo24.ttf',
      'XanhMono-Italic',
    );
    return font.getFont();
  }

  /// Yanone Kaffeesatz 200
  static Future<Font> yanoneKaffeesatzExtraLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/yanonekaffeesatz/v16/3y9I6aknfjLm_3lMKjiMgmUUYBs04aUXNxt9gW2LIftodtWpcGuLCnXkVA.ttf',
      'YanoneKaffeesatz-ExtraLight',
    );
    return font.getFont();
  }

  /// Yanone Kaffeesatz 300
  static Future<Font> yanoneKaffeesatzLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/yanonekaffeesatz/v16/3y9I6aknfjLm_3lMKjiMgmUUYBs04aUXNxt9gW2LIftoqNWpcGuLCnXkVA.ttf',
      'YanoneKaffeesatz-Light',
    );
    return font.getFont();
  }

  /// Yanone Kaffeesatz regular
  static Future<Font> yanoneKaffeesatzRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/yanonekaffeesatz/v16/3y9I6aknfjLm_3lMKjiMgmUUYBs04aUXNxt9gW2LIfto9tWpcGuLCnXkVA.ttf',
      'YanoneKaffeesatz-Regular',
    );
    return font.getFont();
  }

  /// Yanone Kaffeesatz 500
  static Future<Font> yanoneKaffeesatzMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/yanonekaffeesatz/v16/3y9I6aknfjLm_3lMKjiMgmUUYBs04aUXNxt9gW2LIftoxNWpcGuLCnXkVA.ttf',
      'YanoneKaffeesatz-Medium',
    );
    return font.getFont();
  }

  /// Yanone Kaffeesatz 600
  static Future<Font> yanoneKaffeesatzSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/yanonekaffeesatz/v16/3y9I6aknfjLm_3lMKjiMgmUUYBs04aUXNxt9gW2LIftoKNKpcGuLCnXkVA.ttf',
      'YanoneKaffeesatz-SemiBold',
    );
    return font.getFont();
  }

  /// Yanone Kaffeesatz 700
  static Future<Font> yanoneKaffeesatzBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/yanonekaffeesatz/v16/3y9I6aknfjLm_3lMKjiMgmUUYBs04aUXNxt9gW2LIftoEdKpcGuLCnXkVA.ttf',
      'YanoneKaffeesatz-Bold',
    );
    return font.getFont();
  }

  /// Yantramanav 100
  static Future<Font> yantramanavThin() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/yantramanav/v6/flU-Rqu5zY00QEpyWJYWN5-QXeNzDB41rZg.ttf',
      'Yantramanav-Thin',
    );
    return font.getFont();
  }

  /// Yantramanav 300
  static Future<Font> yantramanavLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/yantramanav/v6/flUhRqu5zY00QEpyWJYWN59Yf8NZIhI8tIHh.ttf',
      'Yantramanav-Light',
    );
    return font.getFont();
  }

  /// Yantramanav regular
  static Future<Font> yantramanavRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/yantramanav/v6/flU8Rqu5zY00QEpyWJYWN6f0V-dRCQ41.ttf',
      'Yantramanav-Regular',
    );
    return font.getFont();
  }

  /// Yantramanav 500
  static Future<Font> yantramanavMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/yantramanav/v6/flUhRqu5zY00QEpyWJYWN58AfsNZIhI8tIHh.ttf',
      'Yantramanav-Medium',
    );
    return font.getFont();
  }

  /// Yantramanav 700
  static Future<Font> yantramanavBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/yantramanav/v6/flUhRqu5zY00QEpyWJYWN59IeMNZIhI8tIHh.ttf',
      'Yantramanav-Bold',
    );
    return font.getFont();
  }

  /// Yantramanav 900
  static Future<Font> yantramanavBlack() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/yantramanav/v6/flUhRqu5zY00QEpyWJYWN59wesNZIhI8tIHh.ttf',
      'Yantramanav-Black',
    );
    return font.getFont();
  }

  /// Yatra One regular
  static Future<Font> yatraOneRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/yatraone/v9/C8ch4copsHzj8p7NaF0xw1OBbRDvXw.ttf',
      'YatraOne-Regular',
    );
    return font.getFont();
  }

  /// Yellowtail regular
  static Future<Font> yellowtailRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/yellowtail/v11/OZpGg_pnoDtINPfRIlLotlzNwED-b4g.ttf',
      'Yellowtail-Regular',
    );
    return font.getFont();
  }

  /// Yeon Sung regular
  static Future<Font> yeonSungRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/yeonsung/v10/QldMNTpbohAGtsJvUn6xSVNazqx2xg.ttf',
      'YeonSung-Regular',
    );
    return font.getFont();
  }

  /// Yeseva One regular
  static Future<Font> yesevaOneRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/yesevaone/v15/OpNJno4ck8vc-xYpwWWxpipfWhXD00c.ttf',
      'YesevaOne-Regular',
    );
    return font.getFont();
  }

  /// Yesteryear regular
  static Future<Font> yesteryearRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/yesteryear/v9/dg4g_p78rroaKl8kRKo1r7wHTwonmyw.ttf',
      'Yesteryear-Regular',
    );
    return font.getFont();
  }

  /// Yrsa 300
  static Future<Font> yrsaLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/yrsa/v6/wlpxgwnQFlxs3af93IQ73W5OcCk.ttf',
      'Yrsa-Light',
    );
    return font.getFont();
  }

  /// Yrsa regular
  static Future<Font> yrsaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/yrsa/v6/wlp-gwnQFlxs5QvV-IwQwWc.ttf',
      'Yrsa-Regular',
    );
    return font.getFont();
  }

  /// Yrsa 500
  static Future<Font> yrsaMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/yrsa/v6/wlpxgwnQFlxs3f_83IQ73W5OcCk.ttf',
      'Yrsa-Medium',
    );
    return font.getFont();
  }

  /// Yrsa 600
  static Future<Font> yrsaSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/yrsa/v6/wlpxgwnQFlxs3dP73IQ73W5OcCk.ttf',
      'Yrsa-SemiBold',
    );
    return font.getFont();
  }

  /// Yrsa 700
  static Future<Font> yrsaBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/yrsa/v6/wlpxgwnQFlxs3bf63IQ73W5OcCk.ttf',
      'Yrsa-Bold',
    );
    return font.getFont();
  }

  /// Yusei Magic regular
  static Future<Font> yuseiMagicRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/yuseimagic/v5/yYLt0hbAyuCmoo5wlhPkpjHR-tdfcIT_.ttf',
      'YuseiMagic-Regular',
    );
    return font.getFont();
  }

  /// ZCOOL KuaiLe regular
  static Future<Font> zCOOLKuaiLeRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/zcoolkuaile/v7/tssqApdaRQokwFjFJjvM6h2WpozzoXhC2g.ttf',
      'ZCOOLKuaiLe-Regular',
    );
    return font.getFont();
  }

  /// ZCOOL QingKe HuangYou regular
  static Future<Font> zCOOLQingKeHuangYouRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/zcoolqingkehuangyou/v5/2Eb5L_R5IXJEWhD3AOhSvFC554MOOahI4mRIi_28c8bHWA.ttf',
      'ZCOOLQingKeHuangYou-Regular',
    );
    return font.getFont();
  }

  /// ZCOOL XiaoWei regular
  static Future<Font> zCOOLXiaoWeiRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/zcoolxiaowei/v5/i7dMIFFrTRywPpUVX9_RJyM1YFKQHwyVd3U.ttf',
      'ZCOOLXiaoWei-Regular',
    );
    return font.getFont();
  }

  /// Zen Dots regular
  static Future<Font> zenDotsRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/zendots/v1/XRXX3ICfm00IGoesQeaETM_FcCIG.ttf',
      'ZenDots-Regular',
    );
    return font.getFont();
  }

  /// Zeyada regular
  static Future<Font> zeyadaRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/zeyada/v10/11hAGpPTxVPUbgZDNGatWKaZ3g.ttf',
      'Zeyada-Regular',
    );
    return font.getFont();
  }

  /// Zhi Mang Xing regular
  static Future<Font> zhiMangXingRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/zhimangxing/v7/f0Xw0ey79sErYFtWQ9a2rq-g0actfektIJ0.ttf',
      'ZhiMangXing-Regular',
    );
    return font.getFont();
  }

  /// Zilla Slab 300
  static Future<Font> zillaSlabLight() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/zillaslab/v6/dFa5ZfeM_74wlPZtksIFYpEY2HSjWlhzbaw.ttf',
      'ZillaSlab-Light',
    );
    return font.getFont();
  }

  /// Zilla Slab 300italic
  static Future<Font> zillaSlabLightItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/zillaslab/v6/dFanZfeM_74wlPZtksIFaj8CVHapXnp2fazkfg.ttf',
      'ZillaSlab-LightItalic',
    );
    return font.getFont();
  }

  /// Zilla Slab regular
  static Future<Font> zillaSlabRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/zillaslab/v6/dFa6ZfeM_74wlPZtksIFWj0w_HyIRlE.ttf',
      'ZillaSlab-Regular',
    );
    return font.getFont();
  }

  /// Zilla Slab italic
  static Future<Font> zillaSlabItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/zillaslab/v6/dFa4ZfeM_74wlPZtksIFaj86-F6NVlFqdA.ttf',
      'ZillaSlab-Italic',
    );
    return font.getFont();
  }

  /// Zilla Slab 500
  static Future<Font> zillaSlabMedium() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/zillaslab/v6/dFa5ZfeM_74wlPZtksIFYskZ2HSjWlhzbaw.ttf',
      'ZillaSlab-Medium',
    );
    return font.getFont();
  }

  /// Zilla Slab 500italic
  static Future<Font> zillaSlabMediumItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/zillaslab/v6/dFanZfeM_74wlPZtksIFaj8CDHepXnp2fazkfg.ttf',
      'ZillaSlab-MediumItalic',
    );
    return font.getFont();
  }

  /// Zilla Slab 600
  static Future<Font> zillaSlabSemiBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/zillaslab/v6/dFa5ZfeM_74wlPZtksIFYuUe2HSjWlhzbaw.ttf',
      'ZillaSlab-SemiBold',
    );
    return font.getFont();
  }

  /// Zilla Slab 600italic
  static Future<Font> zillaSlabSemiBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/zillaslab/v6/dFanZfeM_74wlPZtksIFaj8CIHCpXnp2fazkfg.ttf',
      'ZillaSlab-SemiBoldItalic',
    );
    return font.getFont();
  }

  /// Zilla Slab 700
  static Future<Font> zillaSlabBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/zillaslab/v6/dFa5ZfeM_74wlPZtksIFYoEf2HSjWlhzbaw.ttf',
      'ZillaSlab-Bold',
    );
    return font.getFont();
  }

  /// Zilla Slab 700italic
  static Future<Font> zillaSlabBoldItalic() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/zillaslab/v6/dFanZfeM_74wlPZtksIFaj8CRHGpXnp2fazkfg.ttf',
      'ZillaSlab-BoldItalic',
    );
    return font.getFont();
  }

  /// Zilla Slab Highlight regular
  static Future<Font> zillaSlabHighlightRegular() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/zillaslabhighlight/v10/gNMbW2BrTpK8-inLtBJgMMfbm6uNVDvRxhtIY2DwSXlM.ttf',
      'ZillaSlabHighlight-Regular',
    );
    return font.getFont();
  }

  /// Zilla Slab Highlight 700
  static Future<Font> zillaSlabHighlightBold() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/zillaslabhighlight/v10/gNMUW2BrTpK8-inLtBJgMMfbm6uNVDvRxiP0TET4YmVF0Mb6.ttf',
      'ZillaSlabHighlight-Bold',
    );
    return font.getFont();
  }

  /// MaterialIcons
  static Future<Font> materialIcons() {
    const font = PdfGoogleFonts._(
      'https://fonts.gstatic.com/s/materialicons/v90/flUhRq6tzZclQEJ-Vdg-IuiaDsNZ.ttf',
      'MaterialIcons',
    );
    return font.getFont();
  }
}
